function arrow(z,mh);
% ARROW(z,mh);
%    Plot an arrow from z(1) to z(2) (complex coordinates)
%    If mh is present, it represents a relative 
%            magnification of the head of the arrow

%  Mario Storti, 10/6/93

axis('square')
b=axis;

if nargin==1
  mh=1;
end

za = unsplitc([0 1 1 1 1; 0 0  0 0 0]');
zh = mh*0.25*(b(2)-b(1))*unsplitc([0 0 -.2 -.2 0;0 0 .02 -.02 0]');

xini=real(z(:,1));
yini=imag(z(:,1));
xend=real(z(:,2));
yend=imag(z(:,2));

wini=unsplitc([xini yini]);
wend=unsplitc([xend yend]);

for k=1:length(wini)
  dz=wend(k)-wini(k);
  zz=wini(k)+(za*abs(dz)+zh)*sign(dz);
  rz=real(zz);
  iz=imag(zz);
  polyline(rz,iz,'-w')
end
axis('normal')
