function [ar] = aspratio(xnod,icone)
% function that compute the aspect ratio of a given mesh
%
%   [ar] = aspratio(xnod,icone)
%

ar=[];
[numel,nen]=size(icone);
[nnod,ndm]=size(xnod);
if nen ~= 4 & nen ~= 8, error(' nen .ne. 4 .and. nen .ne. 8 ');end
if nen==4,
  for k=1:numel,
    in=icone(k,1:nen);
    v1=xnod(in(2),:)-xnod(in(1),:);
    v2=xnod(in(3),:)-xnod(in(2),:);
    v3=xnod(in(4),:)-xnod(in(3),:);
    v4=xnod(in(1),:)-xnod(in(4),:);
    l1=sqrt(v1(1)^2+v1(2)^2); 
    l2=sqrt(v2(1)^2+v2(2)^2); 
    l3=sqrt(v3(1)^2+v3(2)^2); 
    l4=sqrt(v4(1)^2+v4(2)^2); 
    lmax = max([l1;l2;l3;l4]);
    lmin = min([l1;l2;l3;l4]);
  
    if lmin==0 , disp(' element # '),k,disp(' with lmin==0 ');end
    ar = [ar; lmax/lmin];
  end
else
  for k=1:numel,
    in=icone(k,1:nen);
    v1=xnod(in(2),:)-xnod(in(1),:);
    v2=xnod(in(3),:)-xnod(in(2),:);
    v3=xnod(in(4),:)-xnod(in(3),:);
    v4=xnod(in(1),:)-xnod(in(4),:);
    v5=xnod(in(6),:)-xnod(in(5),:);
    v6=xnod(in(7),:)-xnod(in(6),:);
    v7=xnod(in(8),:)-xnod(in(7),:);
    v8=xnod(in(5),:)-xnod(in(8),:);
    v9=xnod(in(6),:)-xnod(in(2),:);
    v10=xnod(in(7),:)-xnod(in(3),:);
    v11=xnod(in(8),:)-xnod(in(4),:);
    v12=xnod(in(5),:)-xnod(in(1),:);
    l1=sqrt(v1(1)^2+v1(2)^2+v1(3)^2);
    l2=sqrt(v2(1)^2+v2(2)^2+v2(3)^2);
    l3=sqrt(v3(1)^2+v3(2)^2+v3(3)^2);
    l4=sqrt(v4(1)^2+v4(2)^2+v4(3)^2);
    l5=sqrt(v5(1)^2+v5(2)^2+v5(3)^2);
    l6=sqrt(v6(1)^2+v6(2)^2+v6(3)^2);
    l7=sqrt(v7(1)^2+v7(2)^2+v7(3)^2);
    l8=sqrt(v8(1)^2+v8(2)^2+v8(3)^2);
    l9=sqrt(v9(1)^2+v9(2)^2+v9(3)^2);
    l10=sqrt(v10(1)^2+v10(2)^2+v10(3)^2);
    l11=sqrt(v11(1)^2+v11(2)^2+v11(3)^2);
    l12=sqrt(v12(1)^2+v12(2)^2+v12(3)^2);
    lmax = max([lmax;l5;l6;l7;l8;l9;l10;l11;l12]);
    lmin = min([lmin;l5;l6;l7;l8;l9;l10;l11;l12]);
    if lmin==0 , disp(' element # '),k,disp(' with lmin==0 ');end
    ar = [ar; lmax/lmin];
   end
  end