function [x_box,hele,Nx,Ny,xelemin,xelemax,yelemin,yelemax] = ...
bou_box(xnod,icone)
%
% [x_box,hele,Nx,Ny,xelemin,xelemax,yelemin,yelemax] = bou_box(xnod,icone)
%  compute the bounded box for a set
%  of elements and nodes subset of a
%  whole mesh
%


[numel,nen]=size(icone);
% determination of the bounded box
%-----------------------------------
% limits of the box
xmax = max(xnod);
xmin = min(xnod);
if xmax(1,1) >0, xmax(1,1)=1.1*xmax(1,1); else xmax(1,1)=0.9*xmax(1,1); 
end
if xmax(1,2) >0, xmax(1,2)=1.1*xmax(1,2); else xmax(1,2)=0.9*xmax(1,2); 
end
if xmin(1,1) >0, xmin(1,1)=0.9*xmin(1,1); else xmin(1,1)=1.1*xmin(1,1); 
end
if xmin(1,2) >0, xmin(1,2)=0.9*xmin(1,2); else xmin(1,2)=1.1*xmin(1,2); 
end
Lx = xmax(1,1)-xmin(1,1);
Ly = xmax(1,2)-xmin(1,2);
% minimum element size
%------------------------
if nen==4,
xele = [ ...
xnod(icone(:,1),1)'; xnod(icone(:,2),1)'; xnod(icone(:,3),1)' ; ...
xnod(icone(:,4),1)'];
else
xele = [ ...
xnod(icone(:,1),1)'; xnod(icone(:,2),1)'; xnod(icone(:,3),1)' ];
end
xelemin = min(xele); xelemin  = xelemin';
xelemax = max(xele); xelemax  = xelemax';
if nen==4,
yele = [ ...
xnod(icone(:,1),2)'; xnod(icone(:,2),2)'; xnod(icone(:,3),2)' ; ...
xnod(icone(:,4),2)' ];
else
yele = [ ...
xnod(icone(:,1),2)'; xnod(icone(:,2),2)'; xnod(icone(:,3),2)' ]; 
end
yelemin = min(yele); yelemin = yelemin';
yelemax = max(yele); yelemax = yelemax';
dxele = xelemax-xelemin;
dyele = yelemax-yelemin;
scale = 0.5;
hele = scale*min([dxele;dyele]);
Nx = fix(Lx/hele);
Ny = fix(Ly/hele);
Lx = hele*Nx;
Ly = hele*Ny;
x_box = [ xmin ; [Lx+xmin(1,1) xmin(1,2)] ; [xmin(1,1) Ly+xmin(1,2)]; ... 
[Lx+xmin(1,1) Ly+xmin(1,2)] ];

