function [P]=circle3D(V,r);
%
%    [P] - circle3D(V,r);
%
% function that returns a circle in 3D oriented
% with the extrussion vector V with radius r.
%

Vn = norm(V);
Vx=V(1)/Vn;
Vy=V(2)/Vn;
Vz=V(3)/Vn;
alfa = (0:pi/72:2*pi);

theta = atan2(Vy,Vx); 
p0_x = r*(cos(alfa)*Vz*cos(theta)-sin(alfa)*sin(theta));
p0_y = r*(cos(alfa)*Vz*sin(theta)+sin(alfa)*cos(theta));
p0_z = -r*cos(alfa)*(Vx*cos(theta)+Vy*sin(theta));

P = [p0_x' p0_y' p0_z'];
plot3(P(:,1),P(:,2),P(:,3)),grid,pause
