function [x_cut,u_cut]=cut_sol(xh,yh,uh,idir,cp)
%
% routine to make a cut using as input the
% fine mesh generated by routine view_sol.m
%
%  [x_cut,u_cut]=cut_sol(xh,yh,uh,idir,cp)  
%
% Inputs :
%--------------------------
%
%       xh
%       yh 
%       uh
%     idir : 1 or 2 , plane orientation
%            1 plane parallel x-axis
%            2                y-axis
%
%       cp : cut point (scalar value)
%          = x_cut if idir = 2
%          = y_cut if idir = 1 
%-------------------------------------------------  

[Nx,Ny]=size(xh);
if idir ~=1 & idir ~= 2, idir = 1;
display('We assume the cut plane parallel to x-axis ')
end


xmin = [min(xh(:,1)) min(yh(1,:))];
xmax = [max(xh(:,1)) max(yh(1,:))];

hele = (xmax(1,1)-xmin(1,1))/(Nx-1);

if idir == 1,
i1=fix((cp-xmin(1,2))/hele)+1;i2=i1+1;
else
i1=fix((cp-xmin(1,1))/hele)+1;i2=i1+1;
end

if idir == 1 , 
   y1 = yh(1,i1);
   y2 = yh(1,i2);
   x_cut = xh(1:Nx,1);
   u1 = uh(1:Nx,i1); 
   u2 = uh(1:Nx,i2); 
   alfa = (cp-y1) / (y2-y1);
   u_cut = alfa * u2 + (1-alfa) * u1 ;
else
   x1 = xh(i1,1);
   x2 = xh(i2,1);
   x_cut = yh(1,1:Ny);
   u1 = uh(i1,1:Ny); 
   u2 = uh(i2,1:Ny); 
   alfa = (cp-x1) / (x2-x1);
   u_cut = alfa * u2 + (1-alfa) * u1 ;
end

plot(x_cut,u_cut),pause