%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>
%   Estos son los parametros de la malla a definir por el usuario:
%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>
nx=81;        % Numero de nodos sobre el perfil
next=40;      % Numero de nodos en la direccion radial
ndown=40;     % Numero de nodos en la continuacion sobre la estela
wext=3;       % Controla la extension de la malla en la direccion radial
wdown=3;      % Controla la extension de la malla en la direccion aguas abajo
              %                 (mas alla de la estela)
refext=10;    % Refinamiento en la direccion exterior 
              %    refext=(espesor de la capa de elementos mas externa 
              %       en la direccion radial) / (espesor de la capa mas cercana
              %                                             al perfil)
refdown=10;   % Refinamiento en la direccion de la estela
              %    refext=(espesor de la ultima capa de elementos en 
              %       la direccion de la estela) / (espesor de la primera capa 
              %          de la estela, inmediatamente despues del borde de fuga)
nx=75;
next=31;
ndown=20;
wext =1.5;
wdown=1.0;
refext=100;
refdown=10;
nprol=0;
xf=16.4;


% free stream variable
angle = 8*pi/180;
rho = 1;
ux  = 2*cos(angle);
uy  = 2*sin(angle);
uz  = 0;
temp= 180;
pres= 72;


%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>%%%%%%<*>

if round(nx/2)*2==nx 
   error('Eye (Ojo)!!!! nx is required to be odd!!!')
end
nx2=(nx-1)/2;
zprof=naca4ds(0012,nx2); % Aca se puede introducir cualquier conjunto de nodos
                         % sobre el perfil que se desea mallar. Tiene que
                         % empezar por el borde de fuga y recorrer el contorno
                         % del perfil en sentido antihorario. Se supone que el
                         % LE esta en (x,y)=(0,0) y el TE en (0,1).
                         % La secuencia de numeracion es TE, extrados, LE,
                         % intrados. Ojo! El ultimo nodo es el anterior al TE y
                         % no el TE.
zprof=[zprof;zprof(1)];
zprof=zprof(nx:-1:1);
zskl=[0.01 0.5 0.9999];
wprof=itjk3cnt(zprof,zskl);
wTE=wprof(1);
[bid,jLE]=max(abs(wprof-wTE)); clear bid;
wLE=wprof(jLE);
w1=-1+2*(wprof-wLE)/(wTE-wLE);
w1=0.5*(w1+ 1 ./w1);
w1=(w1+1)/2;
w2=[sqrt(w1(1:jLE)); -sqrt(w1(jLE+1:nx))];

xdown=1+wdown*onedstr([1 0 refdown],ndown);
xdown(1)=[];
w2=[xdown(ndown-1:-1:1); w2; -xdown];
xext=onedstr([1 0 refext],next);

W2=zeros(length(w2),next);
for k=1:next
  W2(:,k)=(1-xext(k))*w2+xext(k)*(real(w2)+i*wext);
end

% Ahora recorrer el camino inverso
W1=W2.^2;
W1=2*W1-1;
W1=W1(:,next:-1:1);
W1=W1.';
det=sqrtcnt(W1.^2-1);
W1=(W1+det).'; % OJO!!!! En esta linea en algunos casos puede ser necesario
               %         poner "W1-det". Tiene que ver con que la
               %         transformacion de inversa de Joukowski no es 
               %         simplemente valuada y no se bien que "rama" (branch)
               %         tomar.
Wprof=(W1+1)/2*(wTE-wLE)+wLE;
Zprof=0.5*(Wprof+1 ./Wprof);

return

% armado arreglo de nodos y conectividades
xnod=[]; icone=[];x3d=[];
for k=1:next,
xnod = [xnod;[real(Zprof(:,k)) imag(Zprof(:,k))]];end
[nnod,ndm]=size(xnod);
[nn,mm]=size(Zprof);
if nprol~=0,
n_ou = [(1:nn:nn*(mm-1)+1)';(nn*mm:-nn:nn)'];
nnou=length(n_ou);
xl = [ones(nnou,1)*xf xnod(n_ou,2)];
dx = xl-xnod(n_ou,:);
dx = dx/nprol;
for k=1:next,
  for l=1:nprol;
    ynod = [ynod;[xl(k,:)-(l-1)*dx(k,:)]];
  end
  ynod=[ynod;[real(Zprof(:,k)) imag(Zprof(:,k))]];
  for l=nprol:-1:1;
    ynod = [ynod;[xl(2*next+1-k,:)-(l-1)*dx(2*next+1-k,:)]];
  end
end
xnod=ynod;
[nnod,ndm]=size(xnod);
nn=nn+2*nprol;
end

x3d = [xnod zeros(nnod,1)]; x3d=[x3d;[xnod ones(nnod,1)]];

for k=1:mm-2,
ip=(k-1)*nn;
icone =[ icone; ip+[(1:nn-1)' (2:nn)' nn+(2:nn)' nn+(1:nn-1)']];
end

ndown = ndown+nprol;
icone = [icone; nn*(mm-2)+[(1:nx+ndown-3)' (2:nx+ndown-2)' ... 
				  nn+(2:nx+ndown-2)' nn+(1:nx+ndown-3)' ]];
icone = [icone ; nn*(mm-2)+[ nx+ndown-2 nx+ndown-1 nn+ndown+0 nn+nx+ndown-2 ] ];

for k=1:ndown-1,
icone =[icone; nn*(mm-2)+[ nx+ndown+k-2 nx+ndown+k-1 ... 
				   nn+ndown-[ k k-1 ] ] ] ;
end

ico3d=[icone icone+nnod];

ch=input(' Do you want to compute Boundary conditions (y/n) ? ','s')

if ch == 'y',

% boundary conditions
%--------------------------

[n2d,mm]=size(xnod);
[nele,nen]=size(icone);
nodes_profile = (nx-2+2*ndown)*(next-1)+(ndown:ndown+nx-1)';
nodes_profile = [nodes_profile ; nodes_profile+n2d];

nodes_peri = (nx-2+2*ndown)*(next-1)+ ... 
	 [(2*ndown+nx-2:-1:ndown+nx-1)' (1:ndown)' ];
nodes_peri = [ nodes_peri  ; nodes_peri+n2d];
[nn,mm]=size(nodes_peri);
nodes_peri = [ nodes_peri zeros(nn,1) ];

nn = 2*ndown+nx-2;
nodes_inflow = (1:nn)';
nodes_inflow = [nodes_inflow ; n2d+nodes_inflow];
nodes_outflow = (nn+1:nn:n2d)';
nodes_outflow = [ nodes_outflow ; (2*nn:nn:n2d)'];
nodes_outflow = [ nodes_outflow ; nodes_outflow+n2d ];

ele_inflow = [(1:nn-1)' ];
ele_inflow = [ ele_inflow 2*ones(length(ele_inflow),1) ];
ele_outflow = [(nn:nn-1:nele)'];
ele_outflow = [ ele_outflow 5*ones(length(ele_outflow),1) ];
ele_outflow = [ ele_outflow ; ... 
		   [ (2*(nn-1):nn-1:nele)' 3*ones(length(ele_outflow),1)  ] ] ;

ele_slip = (nn-1)*(next-2)+(ndown+1:ndown+nx-2)' ;
mm=length(ele_slip);
ele_slip = [ ele_slip 4*ones(mm,1) ];
ele_flux = (nn-1)*(next-2)+(ndown:ndown+nx-1)';
ele_flux = [ele_flux 4*ones(mm+2,1) zeros(mm+2,4) ones(mm+2,1)];

nn=length(nodes_profile);
id = [nodes_profile zeros(nn,1) ones(nn,3) zeros(nn,2)];
nn=length(nodes_inflow);
id = [id ; [nodes_inflow ones(nn,4) zeros(nn,1) ones(nn,1) ]];
nn=length(nodes_outflow);
id = [id ; [nodes_outflow ones(nn,4) zeros(nn,1) ones(nn,1)]];

peri = nodes_peri;

nn=length(nodes_inflow);
force = [ nodes_inflow  ones(nn,1) ones(nn,1)*[ux uy uz] zeros(nn,1) ...
temp*ones(nn,1) ];
nn=length(nodes_outflow);
force = [ force ; ...
	 [ nodes_outflow ones(nn,1) ones(nn,1)*[ux uy uz] zeros(nn,1) ...
	 temp*ones(nn,1) ] ];

inou= [ele_inflow;ele_outflow];

my_fprintf('COOR','%5i     %17.9e%17.9e%17.9e \n',[(1:2*n2d)' x3d])
my_fprintf('ELEM','%5i%5i%5i%5i%5i%5i%5i%5i%5i%5i \n',[(1:nele)' ...
ones(nele,1) ico3d]);
my_fprintf('BOUN','%5i     %5i%5i%5i%5i%5i%5i \n',id)
my_fprintf('FORC','%5i     %10.5f%10.5f%10.5f%10.5f%10.5f%10.5f \n',force)
my_fprintf('INOU','%5i     %5i \n',inou);
my_fprintf('PERI','%5i%5i%10.5f \n',peri);
my_fprintf('FLUX','%5i     %5i%5i%5i%5i%5i%5i \n',ele_flux);
my_fprintf('SLIP','%5i     %5i \n',ele_slip);

end
