function [map] = rmdbnode(xnod,tol)
%
%  found duplicate nodes and create a map to remove them
%
%    [map] = rmdbnode(xnod,tol)
%
%  to remove           to leave
%   map(:,1)     --->  map(:,2)
%

if nargin<2, tol=1e-10; end
[numnp,ndm] = size(xnod);
nnod=numnp;

nchunk = fix(numnp/50)+1;

xmin=min(xnod);
xmax=max(xnod);
dxs = (xmax-xmin)/nchunk;
xs=[];
for k=1:ndm
   xs(:,k)  = (xmin(k):dxs(k):xmax(k))';
end

ijk = fix((xnod-ones(nnod,1)*xmin)./(ones(nnod,1)*dxs));

if max(max(ijk))>nchunk, error('rmdbnode ERROR [000] '); end

map = zeros(numnp,1);
for i=1:nchunk+1,
   for j=1:nchunk+1,
      for k=1:nchunk+1
         mask = (ijk(:,1)==i-1)&(ijk(:,2)==j-1)&(ijk(:,3)==k-1);
         nn=find(mask==1);
         map(nn,1)=((k-1)*(nchunk+1)^2+(j-1)*(nchunk+1)+i)*ones(length(nn),1); 
      end
   end
end

imin=1;
imax=max(map);

map2 = [];

for k=imin:imax,
   nn=find(map==k);
   if length(nn)>1,
      xc1 = min(xnod(nn,:));
      xc2 = max(xnod(nn,:));
      d1 = xnod(nn,:)-ones(length(xnod(nn,1)),1)*xc1;         
      d2 = xnod(nn,:)-ones(length(xnod(nn,1)),1)*xc2;               
      r = sqrt(sum(d1'.^2))'+sqrt(sum(d2'.^2))';
      [bas,ibas]=sort(r);
      xnew  = xnod(nn(ibas),:);
      mm    = find(diff(r(ibas))<tol);
      map2   = [map2 ; [nn(ibas(mm+1)) , nn(ibas(mm))] ];
   end   
end

keyboard;pause

return


d1 = xnod-ones(length(xnod(:,1)),1)*xmin;
d2 = xnod-ones(length(xnod(:,1)),1)*xmax;
if ndm==2,   
   d3 = xnod-ones(length(xnod(:,1)),1)*[xmin(1),xmax(2)];   
   d4 = xnod-ones(length(xnod(:,1)),1)*[xmax(1),xmin(2)];
else
   d3 = xnod-ones(length(xnod(:,1)),1)*[xmin(1),xmax(2),xmin(3)];
   d4 = xnod-ones(length(xnod(:,1)),1)*[xmax(1),xmin(2),xmax(3)];
end

d1 = sqrt(sum(d1'.^2))';
d2 = sqrt(sum(d2'.^2))';
d3 = sqrt(sum(d3'.^2))';
d4 = sqrt(sum(d4'.^2))';
ds = [d1,d2,d3,d4]*rand(4,1);
[bas,ibas] = sort(ds);
xnew  = xnod(ibas,:);

nn    = find(diff(ds(ibas))<tol);
map   = [ibas(nn+1) , ibas(nn)];

follow=1;
while follow,
   found = 0;
for k=1:length(nn),
   nn = find(map(:,1)==map(k,2));
   if length(nn)==1,
      map(k,2)=map(nn,2);
      found = found+1;
   end
end
   follow=found>0;
end

return
