function pltmsh4(IN,XX,IELM,CONEC)
% function pltmsh4(IN,XX,IELM,CONEC)
%
%   Dibuja una malla de elementos finitos triangulares
%
%   IN:    Numeros de nodos
%   XX:    Tabla de coordenadas nodales
%   IELM:  Numeros de elementos
%   CONEC: Tabla de conectividades
%
    clg
    axis('square')
    setaxr(XX);
    hold on

    nel = length (IELM);
    [numel,nen]=size(CONEC);    

    inn        = zeros(max(IN),1);
    inn(IN(:)) = 1:length(IN);

    if nen==3,
    ind = [1,2,3,1,2,3];
    else
    ind = [1,2,3,4,1,2,3,4];
    end

    for i=1:nen
        in1 = (i-1)*nel;
        ii(in1+1:in1+nel) = inn(CONEC(:,ind(i  )));
        jj(in1+1:in1+nel) = inn(CONEC(:,ind(i+1)));
    end

    X1(:,1:2)  = XX(inn(:),1:2);

    n = max(max(ii),max(jj));
    A = sparse(ii,jj,-1,n,n);
    A = A + A';
    d = abs(sum(A)) + 1;
    A = A + diag (sparse(d));
    gplot(A,X1,'r-');

    axis;
    hold off
