function [xc,rc]=draw_circle(x,y)
%
%   [xc,rc]=draw_circle(x,y)
%

[nnod,nen]=size(x);

if nen==3,

v1   = [x(:,2)-x(:,1) , y(:,2)-y(:,1)];
v2   = [x(:,3)-x(:,2) , y(:,3)-y(:,2)];

w1   = pvec([v1,0],ones(nnod,1)*[0,0,1]);
w2   = pvec([v2,0],ones(nnod,1)*[0,0,1]);
w1n  = sqrt(sum(w1'.^2))';
w2n  = sqrt(sum(w2'.^2))';
w1   = w1(:,1:2)./(w1n*[1,1]);
w2   = w2(:,1:2)./(w2n*[1,1]);

P1   = 0.5*[x(:,2)+x(:,1) , y(:,2)+y(:,1)];
P2   = 0.5*[x(:,3)+x(:,2) , y(:,3)+y(:,2)];

rhs  = m2v(P2-P1)';
K    = [w1(:,1),-w2(:,1),w1(:,2),-w2(:,2)];
detK = K(:,1).*K(:,4)-K(:,2).*K(:,3);
z(:,1) = (K(:,4).*rhs(:,1)-K(:,2).*rhs(:,2))./detK;
z(:,2) = (-K(:,3).*rhs(:,1)+K(:,1).*rhs(:,2))./detK;

xc   = P1 + z(1:nnod,:).*w1;
dx = [x(:,1)-xc(:,1),y(:,1)-xc(:,2)];
rc = sqrt(sum(dx'.^2))';
x0   = [xc,rc];

% postprocessing
figure(1);clf;
plot(xc(:,1),xc(:,2),'ro');hold on
NN = 50;
theta=(0:NN)'/NN*2*pi;
ct=cos(theta); st=sin(theta);
for k=1:nnod,
   xx=xc(k,1)*ones(NN+1,1)+rc(k)*ct;
   yy=xc(k,2)*ones(NN+1,1)+rc(k)*st;
   plot(xx,yy);
end
plot(x,y,'b*')

disp('draw_circle');keyboard;pause

else
   error(' nen SHOULD be 3 ')
end

return
x    = fsolve('eq_circle',x0);

xc=x(:,1:2);
r =x(:,3); 
