function [map] = rmdbnode(xnod,tol)
%
%  found duplicate nodes and create a map to remove them
%
%    [map] = rmdbnode(xnod,tol) 
%
%  to remove           to leave
%   map(:,1)     --->  map(:,2)
%

if nargin<2, tol=1e-10; end
[nnod,ndm] = size(xnod);

xmin=min(xnod);
xmax=max(xnod);

X1 = xmin;
X2 = xmax;
d1 = xnod-ones(length(xnod(:,1)),1)*X1;
d2 = xnod-ones(length(xnod(:,1)),1)*X2;
if ndm==2,   
   X3 = [xmin(1),xmax(2)];
   X4 = [xmax(1),xmin(2)];
   d3 = xnod-ones(length(xnod(:,1)),1)*X3;   
   d4 = xnod-ones(length(xnod(:,1)),1)*X4;
else
   d3 = xnod-ones(length(xnod(:,1)),1)*[xmin(1),xmax(2),xmin(3)];
   d4 = xnod-ones(length(xnod(:,1)),1)*[xmax(1),xmin(2),xmax(3)];
end

d1 = sqrt(sum(d1'.^2))';
d2 = sqrt(sum(d2'.^2))';
d3 = sqrt(sum(d3'.^2))';
d4 = sqrt(sum(d4'.^2))';
%ds = [d1,d2,d3,d4]*rand(4,1);
ds = [d1,d2,d3,d4]*ones(4,1);
[bas,ibas] = sort(ds);
xnew  = xnod(ibas,:);

nn    = find(diff(ds(ibas))<tol);

map   = [ibas(nn+1) , ibas(nn)];

follow=1;
while follow,
   found = 0;
for k=1:length(nn),
   nn = find(map(:,1)==map(k,2));
   if length(nn)==1,
      map(k,2)=map(nn,2);
      found = found+1;
   end
end
   follow=found>0;
end

return
