function [vort,divu] = vortex(xnod,icone,veloc)
%
%      [vort,divu] = vortex(xnod,icone,veloc)
%

[nnod,ndm]=size(xnod);
[nele,nen]=size(icone);
ndof = 5;

if ndm==2,
   icone=[icone,icone+nnod];
   xnod(:,3)=0;
   xnod=[xnod;[xnod(:,1:2),ones(nnod,1)]];
   veloc(:,3)=0*veloc(:,1);
   veloc = [veloc;veloc];
   if nen==4,nen=8; else nen=4; end
end

[nnod,bas]=size(xnod);
[nele,nen]=size(icone);
Rele = zeros(nele,ndof*nen);
Rg   = zeros(nnod,ndof);

npg = 2;
% set coordinates and weights of Gauss points for numerical integration  
  pgauss_3d;  
  
  ceros = zeros(nele,nen);
  velex = ceros;
  veley = ceros;
  velez = ceros;
    
  for inod=1:nen,
            nodes = icone(:,inod);
    velex(:,inod) = veloc(nodes,1);
    veley(:,inod) = veloc(nodes,2);
    velez(:,inod) = veloc(nodes,3);    
 end
  
% Loop sobre los puntos de Gauss
%------------------------------------------------------------------
for ipg=1:npg
     
  [X2S,S2X,Jaco] = xyz2rst(xnod,icone,psipg(ipg),etapg(ipg),zetapg(ipg));  
  [dNdx,dNdy,dNdz,N] = shape3d(X2S,psipg(ipg),etapg(ipg),zetapg(ipg),nen);
  
  xsj =  wpg(ipg) .* Jaco;
  
  dudx    = zeros(nele,3);   dvdx    = zeros(nele,3);   dwdx    = zeros(nele,3);
   
  for inod=1:nen,
    dudx(:,1) = dudx(:,1) + dNdx(:,inod).* velex(:,inod);
    dudx(:,2) = dudx(:,2) + dNdy(:,inod).* velex(:,inod);
    dudx(:,3) = dudx(:,3) + dNdz(:,inod).* velex(:,inod);
    
    dvdx(:,1) = dvdx(:,1) + dNdx(:,inod).* veley(:,inod);
    dvdx(:,2) = dvdx(:,2) + dNdy(:,inod).* veley(:,inod);
    dvdx(:,3) = dvdx(:,3) + dNdz(:,inod).* veley(:,inod);
    
    dwdx(:,1) = dwdx(:,1) + dNdx(:,inod).* velez(:,inod);
    dwdx(:,2) = dwdx(:,2) + dNdy(:,inod).* velez(:,inod);
    dwdx(:,3) = dwdx(:,3) + dNdz(:,inod).* velez(:,inod);
    
  end
 
  wx = dwdx(:,2)-dvdx(:,3);
  wy = dudx(:,3)-dwdx(:,1);
  wz = dvdx(:,1)-dudx(:,2);
  
  div_u = dudx(:,1)+dvdx(:,2)+dwdx(:,3);
  
  for inod=1:nen,
% RESIDUO    
% termino temporal
	Rele(:,(inod-1)*ndof+1) =  Rele(:,(inod-1)*ndof+1) + N(inod) .* ones(nele,1) .*xsj;
	Rele(:,(inod-1)*ndof+2) =  Rele(:,(inod-1)*ndof+2) + N(inod) .* wx .* xsj;    
	Rele(:,(inod-1)*ndof+3) =  Rele(:,(inod-1)*ndof+3) + N(inod) .* wy .* xsj;
   Rele(:,(inod-1)*ndof+4) =  Rele(:,(inod-1)*ndof+4) + N(inod) .* wz .* xsj;         
	Rele(:,(inod-1)*ndof+5) =  Rele(:,(inod-1)*ndof+5) + N(inod) .* div_u .* xsj;            
  end % inod
    
end  % for ipg

for k=1:nen,
   nodos=icone(:,k);
   for idf=1:ndof,
      Rg(nodos,idf) = Rg(nodos,idf)+Rele(:,(k-1)*ndof+idf);
   end   
end

%keyboard;pause

vort(:,1)=Rg(:,2)./Rg(:,1);
vort(:,2)=Rg(:,3)./Rg(:,1);
vort(:,3)=Rg(:,4)./Rg(:,1);
divu = Rg(:,5)./Rg(:,1);

if ndm==2,
     nnod = nnod/2;   
     vort = vort(1:nnod,:);     
     divu = divu(1:nnod);
end
  