function drawaxis(s)
% function drawaxis(s)
axis('square')
hold on
[x,y,b]=ginput(2);
if b(2)~=32, return, end
xc=[x y zeros(2,1)]*inv(s');
dx=xc(1,:)-xc(2,:);
l=sqrt(dx*dx');
xc(2,:)=[];
a = [[-1 1 .8  .8  1 .8 .8 1]+1;
      0 0 .04 -.04 0  0  0  0;
      0 0   0   0  0  .04 -.04 0]';

%
rot=[0 1 0;0 0 1;1 0 0];

% Draw arrow along x axis
arrow=(l*a/2+ones(8,3)*diag(xc))*s';
plot(arrow(:,1),arrow(:,2))
text(arrow(5,1),arrow(5,2),'x')

% Draw arrow along y axis
a=a*rot;
arrow=(l*a/2+ones(8,3)*diag(xc))*s';
plot(arrow(:,1),arrow(:,2))
text(arrow(5,1),arrow(5,2),'y')

% Draw arrow along z axis
a=a*rot;
arrow=(l*a/2+ones(8,3)*diag(xc))*s';
plot(arrow(:,1),arrow(:,2))
text(arrow(5,1),arrow(5,2),'z')

axis('normal')
hold off
