function set_tet = face_htot(set_hexa,mapface_0,mapface_1,itypo)
%
% function that assign
% a set of tetrahedral faces (set_tet) 
% to a given 
% set of hexahedral ones (set_hex) 
%
%         set_tet = face_htot(set_hexa,mapface_0,mapface_1,itypo)
%
%     mapface_0,mapface_1 and itypo are arrays generateb by hextotet.m file
%     set_hexa  = [ element    face ];
%

%    tetrahedral faces :
%  
%      faces           nodes  
%        1             1 2 4
%        2             2 3 4 
%        3             1 4 3
%        4             1 3 2
%
 
set_tet = [];
[nele,nen]=size(set_hexa);
for k=1:nele
  iele       = set_hexa(k,1);
  local_face = set_hexa(k,2); 
  if itypo(k)==0,
    jele(1:2) = mapface_0(local_face,[1 3]);
    jface(1:2) = mapface_0(local_face,[2 4]);
  else
    jele(1:2) = mapface_1(local_face,[1 3]);
    jface(1:2) = mapface_1(local_face,[2 4]);
  end
  set_tet = [set_tet ; [(iele-1)*5+jele(1:2)' jface(1:2)']]; 
end
