function vol = checkhexa(xnod,icone)
%
%   vol = checkhexa(xnod,icone)
%

  columns(icone) == 8 || ...
      error('Connectivity should have 8 columns (hexas)\n');

  xi=  [+1,+1,-1,-1,+1,+1,-1,-1];
  eta= [-1,+1,+1,-1,-1,+1,+1,-1];
  zeta=[-1,-1,-1,-1,+1,+1,+1,+1];

  nnod=rows(xnod);
  nele=rows(icone);

  vol=zeros(nele,1);
  for ipg=1:8
    xipg=xi(ipg)/sqrt(3);
    etapg=eta(ipg)/sqrt(3);
    zetapg=zeta(ipg)/sqrt(3);
    
    dxdxi=zeros(nele,9);
    for node=1:8
      shape=[(1+xipg*xi(node)) (1+etapg*eta(node)) (1+zetapg*zeta(node))]/2;
      shapexi(:,1)=  xi(node)*shape(:,2).*shape(:,3)/2;
      shapexi(:,2)= eta(node)*shape(:,1).*shape(:,3)/2;
      shapexi(:,3)=zeta(node)*shape(:,1).*shape(:,2)/2;
      
      xnode=xnod(icone(:,node),:);
      dxdxi=dxdxi+[shapexi(1)*xnode shapexi(2)*xnode shapexi(3)*xnode];
    end
    
    clear xnode
    det=rowdet3(dxdxi);
    
    neg=sum(det<=0);
    if neg>0
    disp(['Negative or null jacobian found at ' num2str(neg)  ' Gauss points '])
    disp('Elements: ');
      find(det<=0)
    end
    
    vol=vol+det;
  end

  disp(['min vol ' num2str(min(vol)) ', max vol ' num2str(max(vol)) ', ratio ' num2str(max(vol)/min(vol)) ]);
       disp(['total volume ' num2str(sum(vol)) ]);

  clear det shape dxdxi 
  % Checking number of nodes connected to elements
  flag=zeros(nnod,1);
  for k=1:nele
    flag(icone(k,:))=flag(icone(k,:))+ones(8,1);
  end

  for kk=min(flag):max(flag)
    disp([ num2str(sum(flag==kk)) ' nodes with ' num2str(kk) ' connected elements']);
  end

end
