function [xx,yy,zz] = mesh3d (x,y,z)
%
%       [xx,yy,zz] = mesh3d (x,y,z)
%

   xmax = max(x);
   xmin = min(x);
   ymax = max(y);
   ymin = min(y);
   n    = sqrt(length(x));
   dx   = (xmax-xmin)/n;
   dy   = (ymax-ymin)/n;
   [xx,yy] = meshgrid(xmin:dx:xmax,ymin:dy:ymax);
   zz = griddata(x,y,z,xx,yy);
   mesh(xx,yy,zz);