function [xn2d,ic2d,arlist,coe]=pf3dcut(xnod,icone,x0,s)
%function [xn2d,ic2d,arlist,coe]=pf3dcut(xnod,icone,x0,s)
%  calcular la malla de fem 2d resultado dele corte de una malla 3d
%  por un plano definido por (x-x0).normal=0
[nele,n]=size(icone);
[nnod,ibid]=size(xnod);
normal=s(3,:)';
sx=s(1,:)';
sy=s(2,:)';
x0n=x0'*normal;

coorn=xnod*normal-x0n;
cnmax=max(coorn);
cnmin=min(coorn);
cnmina=min(abs(coorn));

if cnmax*cnmin>0
  disp(' *** pf3dcut ** No hay corte')
  return
end

% Si el plano pasa por un nodo lo corre un poquito
if cnmina==0
  coorn=coorn-1e-8*(cnmax-cnmin)*sign(cnmax+cnmin);
end

% genera numeracion de nodos en 2d
ln2d(nele*12,1)=0;
fele=zeros(1:nele)';
% elementos ladrillo
iari=[1 2;2 3;3 4;4 1;5 6;6 7;7 8;8 5;1 5;2 6;3 7;4 8];
% elemento prismatico de base triangular
iari=[iari;1 2;2 3;3 1;4 5;5 6;6 4;1 4;2 5;3 6];
kn2d=0;
for iel=1:nele
  icloc=[];
  for j=1:n
   icj=icone(iel,j);
   if icj>0
      icloc(j)=icj;
   else
      break
   end
  end
  coornl=coorn(icloc);
  if max(coornl)>0 & min(coornl)<0
    fele(iel)=1;
    nel=length(icloc);
    if nel==8
      iar1=1;
      iar2=12;
    elseif nel==6
      iar1=13;
      iar2=21;
    end
    for ia=iar1:iar2
      nl1=iari(ia,1);
      nl2=iari(ia,2);
      c1=coornl(nl1);
      c2=coornl(nl2);
      if (c1>0 & c2<0) | (c2>0 & c1<0)
         n1=icone(iel,nl1);
         n2=icone(iel,nl2);
         nod2d=min([n1 n2])*nnod+max([n1 n2]);
         kn2d=kn2d+1;
         ln2d(kn2d)=nod2d;
      end
    end
  end
end
ln2d(kn2d+1:12*nele)=[];
% ordena la lista
ln2d=sort(ln2d);
% compacta la lista
ind=1; ln2dc(1)=ln2d(1); lold=ln2d(1);
for j=2:length(ln2d)
  lnew=ln2d(j);
  if lnew~=lold
    ind=ind+1;
    ln2dc(ind)=lnew;
    lold=lnew;
  end
end
ln2dc=ln2dc';
% genera coordenadas de nodos 2d, nodos de la arista madre y coeficientes
nnod2d=ind;
arlist(nnod2d,2)=0;
coe(nnod2d)=0;
xn2d(nnod2d,2)=0;
for k=1:nnod2d
  lnod=ln2dc(k);
  n1=floor((lnod-1)/nnod);
  n2=lnod-n1*nnod;
  arlist(k,1)=n1;
  arlist(k,2)=n2;
  c1=coorn(n1);
  c2=coorn(n2);
  ck=c1/(c1-c2);
  coe(k)=ck;
  xx=(1-ck)*xnod(n1,:)+ck*xnod(n2,:);
  xn2d(k,1)=xx*sx;
  xn2d(k,2)=xx*sy;
end
% genera conectividades
ic2d=[];
%for iel=1:nele
for iel=1:nele
 if fele(iel)==1
  for nel=n:-1:1
   if icone(iel,nel)>0
      break
   end
  end
  if nel==8
    iar1=1;
    iar2=12;
  elseif nel==6
    iar1=13;
    iar2=21;
  end
  kl=0;
  beta=[];
  kv=[];
  for ia=iar1:iar2
    nl1=iari(ia,1);
    nl2=iari(ia,2);
    n1=icone(iel,nl1);
    n2=icone(iel,nl2);
    lnod=min([n1 n2])*nnod+max([n1 n2]);
    k=findl(ln2dc,lnod);
    if k>0
      kl=kl+1;
      if kl==1
        x1=xn2d(k,:);
        kv1=k;
      elseif kl==2
        x2=xn2d(k,:);
        x12=x2-x1;
        beta=[0];
        kv=[k];
      else
        b=xn2d(k,:)-x1;
        pe=b*x12';
        pv=x12(1)*b(2)-x12(2)*b(1);
        beta=[beta;atanx(pv,pe)];
        kv=[kv;k];
      end
    end
  end
  [bsor,ind]=sort(beta);
  kv=kv(ind);
  ntri=kl-2;
  for itri=1:ntri
   ic2d=[ic2d;kv1 kv(itri) kv(itri+1)];
  end
 end
end
