function vhg=pfhgrid(xnod,icone,nps,v);
% function vhg=pfhgrid(xnod,icone,nps,v);

% Coeficiente de seguridad (numero loco!!)
cseg=1.05+pi*1e-4;

% eleccion del numero de puntos de la malla homogenea

%xmax=max(xnod); ymax=xmax(2); xmax(2)=[];
%xmin=min(xnod); ymin=xmin(2); xmin(2)=[];
%dl=(xmax-xmin)*(cseg-1)/2; xmax=xmax+dl; xmin=xmin-dl;
%dl=(ymax-ymin)*(cseg-1)/2; ymax=ymax+dl; ymin=ymin-dl;
%ra=(ymax-ymin)/(xmax-xmin);
%nx=floor(sqrt(nps/ra));
%ny=nx*ra;
%h=max([(xmax-xmin)/(nx-1) (ymax-ymin)/(ny-1)]);


xmax=max(xnod); ymax=xmax(2); xmax(2)=[];
xmin=min(xnod); ymin=xmin(2); xmin(2)=[];
l=max([xmax-xmin ymax-ymin])*cseg;
xc=(xmax+xmin)/2;
xmax=xc+l/2;
xmin=xc-l/2;
yc=(ymax+ymin)/2;
ymax=yc+l/2;
ymin=yc-l/2;
nx=floor(sqrt(nps));
ny=nx;
h=(xmax-xmin)/(nx-1);

% Construccion del vector de arista -> elemento vecino
[nele,nen]=size(icone);
if nen==3
  icone=[icone zeros(nele,1)];
end
[nnod,bid]=size(xnod);
iae=zeros(4*nele,2);
ia=0;
for ie=1:nele
   ic=icone(ie,:);
   istri=(ic(4)==0); 
   nal=4-istri;
   n2=ic(1);
   for ial=2:nal 
     n1=n2;
     n2=ic(ial);
     ia=ia+1;
     if n2>n1
       nn2=n2; nn1=n1;
     else
       nn2=n1; nn1=n2;
     end
     iae(ia,:)=[nn1*nnod+nn2 ie];
   end
   n1=n2;
   n2=ic(1);
   ia=ia+1;
   if n2>n1
     nn2=n2; nn1=n1;
   else
     nn2=n1; nn1=n2;
   end
   iae(ia,:)=[nn1*nnod+nn2 ie];
   ia=ia+istri;
end

% Ordena
inga=iae(:,1); iae(:,1)=[];
[inga,iper]=sort(inga);

% Tablero de elementos conectados por aristas
for ip=1:4*nele
  if inga(ip)>0, break, end
end
inga=[inga;0];
for ia=1:4*nele
  if ip>4*nele, break, end
  if inga(ip)==inga(ip+1)
    iag1=iper(ip);
    iag2=iper(ip+1);
    iee=iae(iag1);
    iae(iag1)=iae(iag2);
    iae(iag2)=iee;
    ip=ip+2;
  else
    iag=iper(ip);
    iae(iag)=0;
    ip=ip+1;
  end
end

% construye efectivamente el tablero
iarel=zeros(nele,4);
for ke=1:nele
  iarel(ke,:)=iae((ke-1)*4+(1:4))';
end

% Interpolacion de los valores sobre la grilla homogenea
ieguess=1;
[bid,nddl]=size(v);
vhg=zeros(nddl*ny,nx);
ishift=ny*(0:nddl-1);
pvecv=zeros(4,1);
sens=-1;
j=0;
for i=1:ny
yy=ymax-(i-1)*h;
sens=-sens;
for jj=1:nx
j=j+sens;
xx=xmin+(j-1)*h;
  isinmesh=1;
  for ie=1:nele
    xp=[xx yy];
    ic=icone(ieguess,:);
    nal=4; istri=(ic(4)==0); nal=nal-istri;
    ic(nal+1)=ic(1);
    n2=ic(1);
    xp=xp-xnod(n2,:);
    belongs=1;
    for ial=1:nal
       n1=n2;
       n2=ic(ial+1);
       var=xnod(n2,:)-xnod(n1,:);
       pvec=var(1)*xp(2)-var(2)*xp(1);
       pvecv(ial)=pvec;
       if pvec<0, belongs=0; break, end
       xp=xp-var;
    end
    if belongs, break, end
% No pertenece al elemento
    iegnew=iarel(ieguess,ial);
    if iegnew==0
      isinmesh=0;
      break
    else
      ieguess=iegnew;
    end
  end %sobre los elementos
  if isinmesh, 
% Interpolar la funcion
     if istri
       vl=v(ic(1:3),:);
       vv=(vl(1,:)*pvecv(2)+vl(2,:)*pvecv(3)+vl(3,:)*pvecv(1))/ ...
                                  (pvecv(1)+pvecv(2)+pvecv(3));
     else
       vl=v(ic(1:4),:);
       sump=pvecv(1)+pvecv(2)+pvecv(3)+pvecv(4);
       xi=2*(pvecv(4)-pvecv(2))/sump;
       eta=2*(pvecv(1)-pvecv(3))/sump;
       vc=(vl(1,:)+vl(2,:)+vl(3,:)+vl(4,:))/4;
       dvdxi=(vl(2,:)+vl(3,:)-vl(1,:)-vl(4,:))/4;
       dvdeta=(vl(3,:)+vl(4,:)-vl(1,:)-vl(2,:))/4;
       d2v=(vl(3,:)+vl(1,:)-vl(2,:)-vl(4,:))/4;
       vv=vc+dvdxi*xi+dvdeta*eta+d2v*xi*eta;
     end
     for kk=1:nddl
       vhg(i+ishift(kk),j)=vv(kk);
     end
  else
     for kk=1:nddl
       vhg(i+ishift(kk),j)=0;
     end
  end
end % sobre jj
j=j+sens;
end % sobre i
