function [xnew,icnew,unew,ibnew]=pftwprf(xnod,icone,u,nprof,ibou,nspan);
%function [xnew,icnew,unew,ibnew]=pftwprf(xnod,icone,u,nprof,ibou,nspan);
%   Construct equivalent structure for periodic problems

[nnod,bid]=size(xnod);

% Intialize coordinates and topology of new structure
xnew=[];
icnew=[];
ibnew=[];
unew=[];

% Rotation angle and matrix
nnt=0;
for jspan=[-nspan+1:nspan]
     teta=jspan*2*pi/nprof;
     R=[cos(teta) -sin(teta);
        sin(teta)  cos(teta)];
     
     % Composed nodes
     xnew=[xnew;xnod*R'];
     
     % Composed connectivities
     icnew=[icnew;icone+nnt];
     
     % Composed boundary
     ibnew=[ibnew;ibou+nnt];
     
     % Composed results
     unew=[unew;
           u(:,1) u(:,2:3)*R' u(:,4)];
     % Actualize number of nodes of composed structure
     nnt=nnt+nnod;
end
