function splot(s,q,lab)
% SPLOT   Uso: splot(s,q) s=vector de abscisas (nx1)
%                          q=matriz de ordenadas (nxm)
%    Ploteo simultaneo de varias cantidades con escala automatica
[lv,n]=size(q);
scale=max(abs(q)); scale=log10(scale); 
iscal=round(scale); scale=exp(log(10)*iscal);
%clg
for i=1:n, 
  q(:,i)=q(:,i)/scale(i);
end
plot(s,q), grid

for i=1:n
  if nargin==3
   t=lab(i,:);
  else
   t=[' '];
  end
  is=-iscal(i);
  if is~=0
    t=['10**' num2str(is) 'x' t];
  end

% Find x-coordinate with maximum separation between curves
  qq=q;
  qq(:,i)=[];
  dq=abs(qq-q(:,i)*ones(1,n-1))';
  if n>2
    dq=min(dq);
  end
  [dev,kt]=max(dq);

% Plot curve label and scale
  text(s(kt),q(kt,i),t)
end
