function C = addcol(A,B,jA)
%
%        C = addcol(A,B,jA)
%
% Add a set of values in a vector B placed at different columns 
% in a matrix "A" 
%               C(1:N,jA(1:N)) = A(1:N,jA(1:N))+B(1:N)
%  
%

C = A;

jA1 = min(jA); jA2=max(jA);

for j=jA1:jA2,
  nA = find(jA==j);
  if isempty(nA)==0, C(nA,j) = C(nA,j)+B(nA) ; end
end
