function [area] = area_mesh(xnod,icone)
%
%   [area] = area_mesh(xnod,icone)
%

[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);

if ndm ~=2, 
    if nen==3,
        % triangulos en una superficie 3D
        a = xnod(icone(:,2),:)-xnod(icone(:,1),:);
        b = xnod(icone(:,nen),:)-xnod(icone(:,1),:);
        nor = pvec(a,b);
        nor = sqrt(sum(nor'.^2))';
        area = nor/2;
    else
        error(' Only for 2D or TRI in 3D '); 
    end
    
else

if nen==3,
    a = xnod(icone(:,2),:)-xnod(icone(:,1),:);
    b = xnod(icone(:,nen),:)-xnod(icone(:,1),:);
    a = [a,0*a(:,1)];
    b = [b,0*b(:,1)];
    nor = pvec(a,b);
    area = abs(nor(:,3))/2;
elseif nen==4,
    a = xnod(icone(:,2),:)-xnod(icone(:,1),:);
    b = xnod(icone(:,4),:)-xnod(icone(:,1),:);
    a = [a,0*a(:,1)];
    b = [b,0*b(:,1)];
    nor = pvec(a,b);
    area = abs(nor(:,3)/2);
    a = xnod(icone(:,3),:)-xnod(icone(:,2),:);
    b = xnod(icone(:,4),:)-xnod(icone(:,2),:);
    a = [a,0*a(:,1)];
    b = [b,0*b(:,1)];
    nor = pvec(a,b);    
    area = area+abs(nor(:,3)/2);    
else
    error('Bad element type')
end

end