%
% script que genera datos para nuestros programas a partir de una malla de
% CFX
%

filename = 'malla.msh';
fid = fopen(filename,'r');

% find an specific string 
[nlines,bas] = find_string(fid,'Version number');
% get next line and convert to an array
tline  = fgets(fid);
vnod   = str2num(tline);
numnp = vnod(1);
numel = vnod(2);
ndm   = vnod(7);  % ??? creo que es la dimension
for k=1:numnp
    tline  = fgets(fid);
    xnod(k,:)   = str2num(tline);    
end
for k=1:numel
    tline  = fgets(fid);
    icone(k,:)   = str2num(tline);    
end

[nlines,tline] = find_string(fid,'PARED');
tline = strtok(tline);
vnod = str2num(tline);    
nele_wall = vnod(1);

[v_array,tline] = read_line_if_no_string(fid,'SALIDA');

if (length(v_array)~=2*nele_wall), error(' problems reading PARED values ') ; end
ele_wall = reshape(v_array,2,nele_wall)';

tline = strtok(tline);
vnod = str2num(tline);    
nele_out = vnod(1);

[v_array,tline] = read_line_if_no_string(fid,'ENTRADA');

if (length(v_array)~=2*nele_out), error(' problems reading SALIDA values ') ; end
ele_out = reshape(v_array,2,nele_out)';

tline = strtok(tline);
vnod = str2num(tline);    
nele_in = vnod(1);

[v_array,tline] = read_line_if_no_string(fid,'XXXXX');

if (length(v_array)~=2*nele_in), error(' problems reading ENTRADA values ') ; end
ele_in = reshape(v_array,2,nele_in)';

fclose(fid)

% numeracion seguida por CFX (nodos locales por cada cara)
inoca = [1,2,3;1,2,4;2,3,4;1,3,4];
face_con = [];

for k=1:4,
    nn = find(ele_wall(:,2)==k);
    eles = ele_wall(nn,1);
    nodes = icone(eles,:);
    nodes_l = inoca(k,:);
    nodes_p = nodes(:,nodes_l);
    face_con =  [face_con; nodes_p];
end
face_con_wall = face_con;
face_con = [];

for k=1:4,
    nn = find(ele_out(:,2)==k);
    eles = ele_out(nn,1);
    nodes = icone(eles,:);
    nodes_l = inoca(k,:);
    nodes_p = nodes(:,nodes_l);
    face_con =  [face_con; nodes_p];
end
face_con_out = face_con;
face_con = [];

for k=1:4,
    nn = find(ele_in(:,2)==k);
    eles = ele_in(nn,1);
    nodes = icone(eles,:);
    nodes_l = inoca(k,:);
    nodes_p = nodes(:,nodes_l);
    face_con =  [face_con; nodes_p];
end
face_con_in = face_con;
face_con = [];