%
%  generate surface meshes
%
%  surface meshes should be written in [ element , local face ] format
%

% mapeo para tetraedros solamente

% elementos sobre la superficie de entrada
file = 'sinter_bound_in.con';
bou  = load([mydir file]);
[vaux] = get_ifaceb_from_surfmesh(bou,xnod,icone);
ifaceb = vaux(:,4:5);
ifaceb_cfx_in = convert_ifaceb_pf_to_cfx(ifaceb,nen);
nele_in = size(ifaceb_cfx_in,1);

% elementos sobre la superficie de salida
file = 'sinter_bound_outlet.con';
bou  = load([mydir file]);
[vaux] = get_ifaceb_from_surfmesh(bou,xnod,icone);
ifaceb = vaux(:,4:5);
ifaceb_cfx_out = convert_ifaceb_pf_to_cfx(ifaceb,nen);
nele_out = size(ifaceb_cfx_out,1);

% elementos sobre la pared
file = 'sinter_bound_wall.con';
bou  = load([mydir file]);
[vaux] = get_ifaceb_from_surfmesh(bou,xnod,icone);
ifaceb = vaux(:,4:5);
ifaceb_cfx_wall = convert_ifaceb_pf_to_cfx(ifaceb,nen);
nele_wall = size(ifaceb_cfx_wall,1);

% elementos sobre el 1er deflector
file = 'sinter_bound_df1.con';
bou  = load([mydir file]);
[vaux] = get_ifaceb_from_surfmesh(bou,xnod,icone);
ifaceb = vaux(:,4:5);
ifaceb_cfx_df1 = convert_ifaceb_pf_to_cfx(ifaceb,nen);
nele_df1 = size(ifaceb_cfx_df1,1);

% elementos sobre el 2do deflector
file = 'sinter_bound_df2.con';
bou  = load([mydir file]);
[vaux] = get_ifaceb_from_surfmesh(bou,xnod,icone);
ifaceb = vaux(:,4:5);
ifaceb_cfx_df2 = convert_ifaceb_pf_to_cfx(ifaceb,nen);
nele_df2 = size(ifaceb_cfx_df2,1);

% array de superficies
array_surface.name  = strvcat('ENTRADA','SALIDA','PARED','DEFLECTOR-1','DEFLECTOR-2');
array_surface.nval = [nele_in;nele_out;nele_wall;nele_df1;nele_df2];
array_surface.value = [ifaceb_cfx_in;ifaceb_cfx_out;ifaceb_cfx_wall;ifaceb_cfx_df1;ifaceb_cfx_df2];

return

[ifaceb,face_con] = pfbou3d(xnod,icone,1);

%keyboard;pause

% mapeo para tetraedros solamente
if nen==4,
    map_inoca_pf_to_cfx = [2,3,4,1];
elseif nen==8,
%    map_inoca_pf_to_cfx = [3,1,4,2,6,5];
%    map_inoca_pf_to_cfx = [5,1,2,4,3,6];
    map_inoca_pf_to_cfx = [5,3,2,4,1,6];
else
    error(' *** Map between local nodes PF to CFX was not already done **** ')
end

nfaces = length(map_inoca_pf_to_cfx);

% elementos sobre la pared
radius = sqrt(sum(xnod(:,[1,3])'.^2))';
tol = 1e-4;
radius_max = max(radius);
nodes_wall = find(abs(radius-radius_max)<tol);
ip_ele_wall = get_eles_by_nodes(nodes_wall,face_con,1);
ele_wall_pf = ifaceb(ip_ele_wall,:);
ele_wall_cfx = ele_wall_pf;
for k=1:nfaces,
    nn = find(ele_wall_pf(:,2)==k);
    ele_wall_cfx(nn,2) = map_inoca_pf_to_cfx(k);
end
ele_wall = ele_wall_cfx;

% elementos sobre la superficie de salida
tol = 1e-4;
y_min = min(xnod(:,2));
nodes_out = find(abs(xnod(:,2)-y_min)<tol);
ip_ele_out = get_eles_by_nodes(nodes_out,face_con,1);
ele_out_pf = ifaceb(ip_ele_out,:);
ele_out_cfx = ele_out_pf;
for k=1:nfaces,
    nn = find(ele_out_pf(:,2)==k);
    ele_out_cfx(nn,2) = map_inoca_pf_to_cfx(k);
end
ele_out = ele_out_cfx;

% elementos sobre la superficie de entrada
tol = 1e-4;
y_max = max(xnod(:,2));
nodes_in = find(abs(xnod(:,2)-y_max)<tol);
ip_ele_in = get_eles_by_nodes(nodes_in,face_con,1);
ele_in_pf = ifaceb(ip_ele_in,:);
ele_in_cfx = ele_in_pf;
for k=1:nfaces,
    nn = find(ele_in_pf(:,2)==k);
    ele_in_cfx(nn,2) = map_inoca_pf_to_cfx(k);
end
ele_in = ele_in_cfx;