function surf_mesh_out = get_ele_by_surfmesh(surf_mesh,xnod,icone)
%
%  surf_mesh_out = get_ele_by_surfmesh(surf_mesh,xnod,icone)
%
%  surf_mesh_out returns [surf_mesh , ifaceb ]
%

[numnp,ndm] = size(xnod);
[numel,nen] = size(icone);    

[inoca]=get_inoca(ndm,nen);
nfaces = size(inoca,1);

surf_mesh_out = surf_mesh;

surf_mesh_sorted = sort(surf_mesh')';

mask = zeros(size(surf_mesh,1),1);

for k=1:nfaces
    vaux = sort(icone(:,inoca(k,:))')';
    [C,C1,C2] = intersect(vaux,surf_mesh_sorted,'rows');
    surf_mesh_out(C2,4) = C1;
    surf_mesh_out(C2,5) = ones(size(C,1),1)*k;
    mask(C2,1) = mask(C2,1) + 1 ;
%    keyboard;pause
end

if((min(mask)~=1)|(max(mask)~=1)), 
    error(' one surf_mesh element is connected to more than one element '); 
end
    