function [ifaceb] = get_only_ifaceb_from_surfmesh(bou,xnod,icone,flag)
%
%  [ifaceb] = get_only_ifaceb_from_surfmesh(bou,xnod,icone,flag)
%  
%  for routine with an output array like [bou , ifaceb] 
%  use get_ifaceb_from_surfmesh
%
%  This routine does not support volume meshes with element having
%  all their nodes lying on surf meshes 
%

if nargin<4, flag=0; end

[numnp,ndm] = size(xnod);
[numel,nen] = size(icone);    
if nen~=4, error('ONLY FOR TETRAHEDRAL MESH'); end

nodes=rmdblist(m2v(bou));
eles = get_eles_by_nodes(nodes,icone,0);
vaux=zeros(numnp,1);
vaux(nodes)=1;
mask=zeros(numel,nen);
for k=1:nen
    mask(eles,k) = vaux(icone(eles,k));
end
vele=sum(mask')';
eles = find(vele==3);

[inoca]=get_inoca(ndm,nen);
nfaces = size(inoca,1);

ifaceb = [];
for k=1:nfaces
    mask2 = zeros(size(mask,1),1);    
    nodes = inoca(k,:);
    for kk=1:length(nodes)
        mask2(eles) = mask2(eles)+mask(eles,nodes(kk));
    end
    nn = find(mask2==length(nodes));
    ifaceb = [ifaceb;[nn , k*ones(length(nn),1)]];
end

if length(eles)~=size(bou,1),

    error(' There is some tetrahedrals with all their nodes lying on the surface - Use routine get_ifaceb_from_surfmesh ')
    
end