%
% script que genera datos para nuestros programas a partir de una malla de
% CFX
%

% datos necesarios
filename = 'malla_bis_2.msh';
filename = 'malla_fcc_A.msh';

if 0
    numnp = 115;
    numel = 415;
    ndm   = 3;
    
    nele_wall = 103;
    nele_out = 24;
    nele_in = 23;
    
    if 0
        nele_wall = 4;
        nele_out  = 3;
        ele_wall = [100,1;200,2;300,3;400,4];
        ele_out  = [101,1;201,2;301,3;401,4];
        ele_in   = [102,1;202,2;302,3;402,4];
    end
else 
    gen_mesh
    xnod = x3d;
    icone = icone3d;    
    [numnp,ndm] = size(xnod);
    [numel,nen] = size(icone);    
end

% default
numel_tetras = 0;
numel_prism  = 0;
numel_hexas  = 0;
numel_pyram  = 0; 
num_material = 1;
num_surfaces = 0;

if nen==4, 
    type_elem = 'tetras';
    numel_tetras = numel;    
elseif nen==8
    type_elem = 'hexas';        
    numel_hexas  = numel;
elseif nen==6
    type_elem = 'prism';
    numel_prism  = numel;
elseif nen==5
    type_elem = 'pyram';
    numel_pyram  = numel;
else
    error(' **** Bad type of element *** ')
end

gen_surface

if 1
    icone = icone(:,[1,2,4,3,5,6,8,7]);
end

if 1
    nele_wall = size(ele_wall,1);
    nele_out = size(ele_out,1);
    nele_in = size(ele_in,1);
    
    % array de superficies
    array_surface.name  = strvcat('PARED','SALIDA','ENTRADA');
    array_surface.nval = [nele_wall;nele_out;nele_in];
    array_surface.value = [ele_wall;ele_out;ele_in];
end

% fin de datos
fid = fopen(filename,'w');
% agregar el header del archivo
fprintf(fid,'%s \n','1128683573');
fprintf(fid,'%s \n','Version number: 5.6S');

num_surfaces = length(array_surface.nval);

fprintf(fid,'%d %d %d %d %d %d %d \n',numnp,numel_tetras,numel_prism,numel_hexas,numel_pyram,num_material,num_surfaces);
for k=1:numnp
    fprintf(fid,'%f %f %f \n',xnod(k,:));
end

fmt = [];
for k=1:nen
    fmt = [fmt , '%d '];
end
fmt = [fmt , ' \n'];

for k=1:numel
    fprintf(fid,fmt,icone(k,:));
end

fprintf(fid,'%d CREATED_MATERIAL_11 \n',numel);
for k=1:numel
    if rem(k,10)==0,
        fprintf(fid,' %d \n',k);
        new_line = 1;
    else
        fprintf(fid,' %d ',k);
        new_line=0;
    end
end
if new_line==0, 
    fprintf(fid,' \n');
end

for m=1:num_surfaces
    name  = array_surface.name(m,:);
    nval = array_surface.nval(m,1);
    if m>1,
        ip1 = sum(array_surface.nval(1:m-1))+1;
    else
        ip1 = 1;
    end    
    ip2 = sum(array_surface.nval(1:m));
    
    fprintf(fid,'%d  %s \n',nval,name);
    
    ele_p = array_surface.value(ip1:ip2,1:2);
    for k=1:nval
        if rem(k,5)==0,
            fprintf(fid,'%d %d \n',ele_p(k,:));
            new_line = 1;
        else
            fprintf(fid,'%d %d ',ele_p(k,:));        
            new_line=0;
        end
    end
    if new_line==0, 
        fprintf(fid,' \n');
    end
    
end

fclose(fid)

return

%===========================================================================================

fprintf(fid,'%d PARED \n',nele_wall);
for k=1:nele_wall
    if rem(k,5)==0,
        fprintf(fid,'%d %d \n',ele_wall(k,:));
        new_line = 1;
    else
        fprintf(fid,'%d %d ',ele_wall(k,:));        
        new_line=0;
    end
end
if new_line==0, 
    fprintf(fid,' \n');
end


fprintf(fid,'%d SALIDA \n',nele_out);
for k=1:nele_out
    if rem(k,5)==0,
        fprintf(fid,'%d %d \n',ele_out(k,:));
        new_line = 1;
    else
        fprintf(fid,'%d %d ',ele_out(k,:));        
        new_line=0;
    end
end
if new_line==0, 
    fprintf(fid,' \n');
end

fprintf(fid,'%d ENTRADA \n',nele_in);
for k=1:nele_in
    if rem(k,5)==0,
        fprintf(fid,'%d %d \n',ele_in(k,:));
        new_line = 1;
    else
        fprintf(fid,'%d %d ',ele_in(k,:));        
        new_line=0;
    end
end
if new_line==0, 
    fprintf(fid,' \n');
end

fclose(fid)

return
%==========================================================================

filename = 'malla.msh';
fid = fopen(filename,'r');

% find an specific string 
[nlines,bas] = find_string(fid,'Version number');
% get next line and convert to an array
tline  = fgets(fid);
vnod   = str2num(tline);
numnp = vnod(1);
numel = vnod(2);
ndm   = vnod(7);  % ??? creo que es la dimension
for k=1:numnp
    tline  = fgets(fid);
    xnod(k,:)   = str2num(tline);    
end
for k=1:numel
    tline  = fgets(fid);
    icone(k,:)   = str2num(tline);    
end

[nlines,tline] = find_string(fid,'PARED');
tline = strtok(tline);
vnod = str2num(tline);    
nele_wall = vnod(1);

[v_array,tline] = read_line_if_no_string(fid,'SALIDA');

if (length(v_array)~=2*nele_wall), error(' problems reading PARED values ') ; end
ele_wall = reshape(v_array,2,nele_wall)';

tline = strtok(tline);
vnod = str2num(tline);    
nele_out = vnod(1);

[v_array,tline] = read_line_if_no_string(fid,'ENTRADA');

if (length(v_array)~=2*nele_out), error(' problems reading SALIDA values ') ; end
ele_out = reshape(v_array,2,nele_out)';

tline = strtok(tline);
vnod = str2num(tline);    
nele_in = vnod(1);

[v_array,tline] = read_line_if_no_string(fid,'XXXXX');

if (length(v_array)~=2*nele_in), error(' problems reading ENTRADA values ') ; end
ele_in = reshape(v_array,2,nele_in)';

fclose(fid)

% numeracion seguida por CFX (nodos locales por cada cara)
if nen==4
    inoca = [1,2,3;1,2,4;2,3,4;1,3,4];
elseif nen==8,
    inoca = [1,2,6,5;3,4,8,7;1,4,3,2;2,3,7,6;5,6,7,8;1,5,8,4];
elseif nen==6,
    inoca = [];
elseif nen==5,
    inoca = [];
else
end
    
for k=1:4,
    nn = find(ele_wall(:,2)==k);
    eles = ele_wall(nn,1);
    nodes = icone(eles,:);
    nodes_l = inoca(k,:);
    nodes_p = nodes(:,nodes_l);
    face_con =  [face_con; nodes_p];
end
face_con_wall = face_con;
face_con = [];

for k=1:4,
    nn = find(ele_out(:,2)==k);
    eles = ele_out(nn,1);
    nodes = icone(eles,:);
    nodes_l = inoca(k,:);
    nodes_p = nodes(:,nodes_l);
    face_con =  [face_con; nodes_p];
end
face_con_out = face_con;
face_con = [];

for k=1:4,
    nn = find(ele_in(:,2)==k);
    eles = ele_in(nn,1);
    nodes = icone(eles,:);
    nodes_l = inoca(k,:);
    nodes_p = nodes(:,nodes_l);
    face_con =  [face_con; nodes_p];
end
face_con_in = face_con;
face_con = [];