%fileout = 'auto_31';

[numnp,ndim] = size(xnod);
[numel,nen]  = size(icone);
ndf         = ndim+1;

if ndim==2,
   if nen==4,
      my_fprintf([fileout '.nod'],'%10.5f %10.5f \n',[xnod]);
      my_fprintf([fileout '.con'],'%5i %5i %5i %5i \n',[icone]);
   elseif nen==3,
      my_fprintf([fileout '.nod'],'%10.5f %10.5f \n',[xnod]);
      my_fprintf([fileout '.con'],'%5i %5i %5i \n',[icone]);      
   else
      error(' NOT valid kind of element in 2D ')
   end
else
   if nen==4,
      my_fprintf([fileout '.nod'],'%10.5f %10.5f %10.5f \n',[xnod]);
      my_fprintf([fileout '.con'],'%6i %6i %6i %6i \n',[icone]);
   elseif nen==8,
      my_fprintf([fileout '.nod'],'%10.5f %10.5f %10.5f \n',[xnod]);
      my_fprintf([fileout '.con'],'%6i %6i %6i %6i %6i %6i %6i %6i \n',[icone]);      
   else
      error(' NOT valid kind of element in 3D ')
   end
end

% BOUNDARY CONDITIONS
  % entrada (nodes_in)
  % salida  (nodes_out)
  % borde superior (nodes_top)
  % suelo (nodes_bot)
  % borde derecho (nodes_rig)
  % borde izquierdo (nodes_lef)  
  % piel del auto (nodes_over_car)

% entrada
vaux=[];
vaux = [vaux ; [nodes_in 1*ones(length(nodes_in),1) u_infty*ones(length(nodes_in),1) ]];
vaux = [vaux ; [nodes_in 2*ones(length(nodes_in),1) v_infty*ones(length(nodes_in),1) ]];
vaux = [vaux ; [nodes_in 3*ones(length(nodes_in),1) w_infty*ones(length(nodes_in),1) ]];
my_fprintf([fileout '.fixa_in'],'%7i %3i %10.5f \n',[vaux]);

% salida
vaux=[];
vaux = [vaux ; [nodes_out 1*ones(length(nodes_out),1) u_infty*ones(length(nodes_out),1) ]];
vaux = [vaux ; [nodes_out 3*ones(length(nodes_out),1) w_infty*ones(length(nodes_out),1) ]];
my_fprintf([fileout '.fixa_out_vel'],'%7i %3i %10.5f \n',[vaux]);
vaux=[];
vaux = [vaux ; [nodes_out ndf*ones(length(nodes_out),1) p_infty*ones(length(nodes_out),1) ]];
my_fprintf([fileout '.fixa_out_p'],'%7i %3i %10.5f \n',[vaux]);

% borde superior 
nodes_laterales = nodes_top;
vaux=[];
vaux = [vaux ; [nodes_laterales 3*ones(length(nodes_laterales),1) w_infty*ones(length(nodes_laterales),1) ]];
my_fprintf([fileout '.fixa_top'],'%7i %3i %10.5f \n',[vaux]);

% borde suelo
nodes_laterales = nodes_bot;
vaux=[];
vaux = [vaux ; [nodes_laterales 1*ones(length(nodes_laterales),1) 0*ones(length(nodes_laterales),1) ]];
vaux = [vaux ; [nodes_laterales 2*ones(length(nodes_laterales),1) v_infty*ones(length(nodes_laterales),1) ]];
vaux = [vaux ; [nodes_laterales 3*ones(length(nodes_laterales),1) 0*ones(length(nodes_laterales),1) ]];
my_fprintf([fileout '.fixa_bot'],'%7i %3i %10.5f \n',[vaux]);

% borde derecho
nodes_laterales = nodes_rig;
vaux=[];
vaux = [vaux ; [nodes_laterales 1*ones(length(nodes_laterales),1) u_infty*ones(length(nodes_laterales),1) ]];
my_fprintf([fileout '.fixa_rig'],'%7i %3i %10.5f \n',[vaux]);

% borde izquierdo
nodes_laterales = nodes_lef;
vaux=[];
vaux = [vaux ; [nodes_laterales 1*ones(length(nodes_laterales),1) u_infty*ones(length(nodes_laterales),1) ]];
my_fprintf([fileout '.fixa_lef'],'%7i %3i %10.5f \n',[vaux]);

% piel del auto (nodes_over_car)
nodes = nodes_over_car;
vaux=[];
vaux = [vaux ; [nodes 1*ones(length(nodes),1) 0*ones(length(nodes),1) ]];
vaux = [vaux ; [nodes 2*ones(length(nodes),1) 0*ones(length(nodes),1) ]];
vaux = [vaux ; [nodes 3*ones(length(nodes),1) 0*ones(length(nodes),1) ]];
my_fprintf([fileout '.fixa_car'],'%7i %3i %10.5f \n',[vaux]);

% Coordenadas de los nodos sobre el auto
list_nod = eles;
my_fprintf([fileout '.list_nod'],'%6i \n',[list_nod]);

X = xnod(list_nod,:);
my_fprintf([fileout '.nod_car'],'%10.5f %10.5f %10.5f \n',[X]);

% conectividades de los elementos sobre el auto
tt =icone_bou(eles,:);
my_fprintf([fileout '.con_car'],'%6i %6i %6i \n',[tt]);

% algunos nodos para imprimir resultados
if exist('nodes_some')==1,
vaux=nodes_some;
my_fprintf([fileout '.nodes_some'],'%7i \n',[vaux]);
end

if ndim==2,
   u0 = [0.1*u_infty,v_infty, 0];
   my_fprintf([fileout '.ini'],'%10.5f %10.5f %10.5f \n', ...
      ones(numnp,1)*u0);
else
   u0 = [u_infty,v_infty,w_infty, 0];
   my_fprintf([fileout '.ini'],'%10.5f %10.5f %10.5f %10.5f \n', ...
      ones(numnp,1)*u0);
end

