%
% genera una base de datos para la corrida del auto de Matija y Diego
% a partir de una malla generada por GID. Version 3D
%

%fileout = 'auto_31';  % coarse grid
%fileout = 'auto_32';   % fine grid
%fileout = 'auto_33_6';
fileout = 'auto_nestor';

if (exist('xnod')==0 | exist('icone')==0), 
eval(['load ' fileout '.nod']);
eval(['xnod=' fileout ';']);
eval(['load ' fileout '.con']);
eval(['icone=' fileout ';']);

[numnp,ndm]=size(xnod);
%xnod=xnod(:,2:ndm);
[numel,nen]=size(icone);
%icone=icone(:,2:nen);
%xnod = xnod/1000;

end

% coordenada z entre el piso del auto y el piso del tunel
zfloor = 0;  

tol  = 1e-6;
[numel,nen]=size(icone);
[numnp,ndm]=size(xnod);

% El auto esta orientado de forma que:
%  Eje x : transversal a lo ancho
%  Eje y : longitudinal
%  Eje z : transversal a lo alto

% caja que envuelve al auto para poder determinar los nodos de la piel del vehiculo
% El auto va a estar dentro del paralelepipedo exterior siendo lo unico incierto la
% medida del despeje del suelo. Eso es a ojo viendo la distribucion de puntos.
% Para la malla zephyr_coarse es aprox 50 mm.
xmin = min(xnod); xmax=max(xnod);

xmin_box = xmin + 0.01*(xmax-xmin);
xmax_box = xmin + 0.99*(xmax-xmin);
xmin_box(3) = zfloor; 

% estado del flujo al infinito
u_infty = 0;
v_infty = 1;
w_infty = 0;
p_infty = 0;

nodes_lef = find(abs(xnod(:,1)-xmin(1))<tol);
nodes_rig = find(abs(xnod(:,1)-xmax(1))<tol);
nodes_in  = find(abs(xnod(:,2)-xmin(2))<tol);
nodes_out = find(abs(xnod(:,2)-xmax(2))<tol);
nodes_bot = find(abs(xnod(:,3)-xmin(3))<tol);
nodes_top = find(abs(xnod(:,3)-xmax(3))<tol);

%[ifaceb,nodes_bou] = pfbou3d3(xnod,icone);
[ifaceb,nodes_bou] = pfbou3d2(xnod,icone);

% nodos del borde interior sobre el auto
[nodes_over_car] = in_box(xnod(nodes_bou,:),xmin_box,xmax_box);
nodes_over_car = nodes_bou(nodes_over_car);

% malla sobre la superficie de todo el contorno
[icone_bou]=surf_mesh_connectivity(icone,ifaceb);

% elementos sobre la piel del auto
[eles] = eles_in_box(xnod,icone_bou,xmin_box,xmax_box);
[eles_over_car] = ifaceb(eles,1:2);

% algo para ver si la malla esta OK
figure(1);clf
nodes_nn=nodes_over_car;
plot3(xnod(nodes_nn,2),xnod(nodes_nn,1),xnod(nodes_nn,3),'b.')
hold on
nodes_nn=nodes_top;
plot3(xnod(nodes_nn,2),xnod(nodes_nn,1),xnod(nodes_nn,3),'y.')
nodes_nn=nodes_bot;
plot3(xnod(nodes_nn,2),xnod(nodes_nn,1),xnod(nodes_nn,3),'y.')
nodes_nn=nodes_lef;
plot3(xnod(nodes_nn,2),xnod(nodes_nn,1),xnod(nodes_nn,3),'g.')
nodes_nn=nodes_rig;
plot3(xnod(nodes_nn,2),xnod(nodes_nn,1),xnod(nodes_nn,3),'g.')
nodes_nn=nodes_in;
plot3(xnod(nodes_nn,2),xnod(nodes_nn,1),xnod(nodes_nn,3),'m.')
nodes_nn=nodes_out;
plot3(xnod(nodes_nn,2),xnod(nodes_nn,1),xnod(nodes_nn,3),'m.')

figure(2);clf;
pltmsh(xnod,icone_bou(eles,:),1);
hold on;
nodes_some = m2v(icone(eles_over_car,:));
nodes_some = rmdblist(nodes_some);
nodes_nn=nodes_some;
plot3(xnod(nodes_nn,1),xnod(nodes_nn,2),xnod(nodes_nn,3),'b.')

% escritura de datos
boundary_conditions_3d;

% nodos debajo del auto para ver como resuelve el despeje
xmin_box2 = [-1 , 1 , 0.0];
xmax_box2 = [ 1 , 4 , 0.3];
[nodes_under_car] = in_box(xnod,xmin_box2,xmax_box2);

eval(['save ' fileout '_mesh']);

return
