function [xnew,iconew] = refh1(xnod,N,gradx,grady)
%
% rutina para dividir un elemento en N_x * N_y partes
% mediante una interpolacion lineal
% Usamos un grading para el macroelemento de la pared
%
%  Por ej.  gradx = -1 ---> grading hacia la izquierda 
%           gradx = +1 ---> grading hacia la derecha 
%           grady = -1 ---> grading hacia abajo
%           grady = +1 ---> grading hacia arriba
%           grady =  0 ---> homogeneo
%           gradx =  2 ---> grading hacia ambos extremos


N_x = N(1);
N_y = N(2);

%N_x = N(2);
%N_y = N(1);

[psi,eta] = meshgrid((-1:2:1),(-1:2:1));

psi1 =  (0:N_x-1)'/(N_x-1);
eta1 =  (0:N_y-1)'/(N_y-1);

psic  = psi1*2-1; 
psipn = sin(pi/2*(psi1*2-1));
psi1  = rot90(rot90(psi1));
psip  = 2*cos(psi1*pi/2)-1;
psin  = cos(pi/2+psi1*pi/2)*2+1;


etac  = eta1*2-1;
etapn = sin(pi/2*(eta1*2-1));
eta1  = rot90(rot90(eta1));
etap  = 2*cos(eta1*pi/2)-1;
etan  = cos(pi/2+eta1*pi/2)*2+1;

wx = zeros(4,1);
wy = zeros(4,1);
if gradx==-1, wx(1)=1; end
if gradx==+1, wx(3)=1; end
if gradx== 0, wx(2)=1; end
if gradx== 2, wx(4)=1; end
if grady==-1, wy(1)=1; end
if grady==+1, wy(3)=1; end
if grady== 0, wy(2)=1; end
if grady== 2, wy(4)=1; end

psi1  = wx(1)*psin+wx(2)*psic+wx(3)*psip+wx(4)*psipn;
eta1  = wy(1)*etan+wy(2)*etac+wy(3)*etap+wy(4)*etapn;

[psi1,eta1] = meshgrid(psi1,eta1);

xxx = xnod([1 2 4 3],:);
xx  = [ xxx(1,1) xxx(2,1) ; 
        xxx(3,1) xxx(4,1) ] ;
x1=interp2(psi,eta,xx,psi1,eta1,'linear');
xx  = [ xxx(1,2) xxx(2,2) ; 
        xxx(3,2) xxx(4,2) ] ;
x2=interp2(psi,eta,xx,psi1,eta1,'linear');

x1 = x1(1,:)';
x2 = x2(:,1);

xnew = [];

%if N_y > N_x,
 for k=1:N_y,
   xnew = [xnew ; [ x1 ones(N_x,1)*x2(k)] ];
 end
%else
% for k=1:N_x,
%   xnew = [xnew ; [ x1(k)*ones(N_y,1) x2] ];
% end
%end

iconew = [];
ico0   = [ (1:N_x-1)' (2:N_x)' ];
ico0   = [ ico0  ico0(:,[2 1])+N_x ];
for k=1:N_y-1,
  ip = (k-1)*N_x ;  
  iconew = [iconew ; ip+ico0  ] ;
end