function [xnod,icone] = refhtri(x,N)
%
% Refinamiento homogeneo en N partes de un triangulo 
% de coordenadas x
% 
% Para su uso con mblock
%


%   (psi;eta)  Coordenadas elemento master
psi = (0:N)'/N ; 
eta = psi      ; 

xnod = [] ;
for l=1:N+1,
  for k=1:N+2-l,
    xnod = [xnod ; [psi(k) eta(l)]];
  end
end

icone = [];
ip    = (1:N+1)';
ip = cumsum(rot90(rot90(ip)));ip = [0;ip];ip = ip+1;
for l=1:N-1,
  for k=1:N-l,
    ico1 = [ ip(l)-1+[k k+1] ip(l+1)-1+k];  
    ico2 = [ ip(l)-1+k+1 ip(l+1)-1+[k+1 k] ];
    icone = [icone ; [ico1;ico2]];  
  end
  k = N-l+1;
    ico1 = [ ip(l)-1+[k k+1] ip(l+1)-1+k];  
    icone = [icone ; ico1 ];  
end
l = N;
k = 1;
ico1 = [ ip(l)-1+[k k+1] ip(l+1)-1+k];  
icone = [icone ; ico1 ];  

N1 = 1 - xnod(:,1) - xnod(:,2);
N2 = xnod(:,1);
N3 = xnod(:,2);

xnod(:,1) = x(1,1)*N1+x(2,1)*N2+x(3,1)*N3;
xnod(:,2) = x(1,2)*N1+x(2,2)*N2+x(3,2)*N3;