% una malla estructurada para el continuous casting
%-----------------------------------------------------------

% radio del molde
r_mou = 0.115/2;
% radio de la tobera
r_noz = 0.03/2;
% longitud del molde
l_mou = 3 ;

xnod = [];
Nx = 30;
Nx_noz = 10;
px = 1;

psi=(0:Nx_noz)'/Nx_noz;
%x_noz = (psi-1).^px+1 ;
x_noz = sin(psi*pi/2).^2; 
psi=(1:Nx-Nx_noz)'/(Nx-Nx_noz);
%x_mou = psi.^px ;
x_mou = (cos(psi*pi-pi)+1)/2;

psi=(0:Nx)';
psimax = max(psi);
psi  = psi / psimax;
x_hom = psi;

x_noz = x_noz*r_noz;
x_mou = x_mou*(r_mou-r_noz)+r_noz;
x_hom = x_hom*r_mou;
x_inn = [x_noz;x_mou];
x_hom = x_hom/r_mou;
x_inn = x_inn/r_mou;

Ny  = 50;
etah = (0:Ny)/Ny;
for eta=etah,
% x = (1-eta).^2*((x_inn-x_inn(Nx_noz)).^1  +x_inn(Nx_noz)^1)+eta.^2*x_hom;
 x = ((x_inn-x_inn(Nx_noz)).^1  +x_inn(Nx_noz)^1);
xmax = max(x);
x = x/xmax;
x = x*r_mou;
xnod = [xnod ; [ x l_mou*ones(Nx+1,1)*eta.^(3/2)] ];
end

ico0  = [(1:Nx)' (2:Nx+1)' Nx+1+[(2:Nx+1)' (1:Nx)'] ];
icone = [];

for j=1:Ny,
  icone = [icone ; ico0+(j-1)*(Nx+1) ];
end

[nnod,ndm]=size(xnod);
[numel,nen]=size(icone);
my_fprintf('XNOD','%5i     %17.9e%17.9e \n',[(1:nnod)' xnod]);
my_fprintf('ICON','%5i%5i%5i%5i%5i%5i \n',[(1:numel)' ones(numel,1) icone]);
