%function [x,y,z]=view3d_3(xnod,icone,sol)
% function that generate a 3D view of an unstructured 2D solution.
% [xnod,icone] : contain the coordinates and connectivities 
% [sol]        :         the solution

[numnp,ndm]=size(xnod);
%if ndm ~= 3 , disp('** ERROR ** ndm ~= 3 '); break;end
[numel,nen]=size(icone);
%if nen ~= 8 , disp('** ERROR ** nen ~= 8 '); break;end


cara1 = [1 2 3 4];
cara2 = [2 1 5 6];
cara3 = [1 4 8 5];
cara4 = [8 7 3 4];
cara5 = [2 3 7 6];
cara6 = [5 6 7 8];

ico1 = icone(:,cara1)';
ico2 = icone(:,cara2)';
ico3 = icone(:,cara3)';
ico4 = icone(:,cara4)';
ico5 = icone(:,cara5)';
ico6 = icone(:,cara6)';

ico = [ico1 ico2 ico3 ico4 ico5 ico6];
% sort each face of each element 
%------------------------------------
icos = sort(ico);
% sort all the faces
%----------------------
icosm = m_sort(icos);
% delete those faces that are duplicated , not belonging to the boundaries.
%---------------------------------------------------------------------------
[m,n]=size(icosm);
flag = zeros(n,1); % flag = 1  caras duplicadas
for k=2:n,
  tmp = icosm(:,[k-1 k]);
  flag(k) = prod(tmp(:,1) == tmp(:,2)) ;
end
iface=[]; 
for k=1:n,
  if flag(k) ~= 0, iface = [iface ico(:,k)]; end
end

[m,n]=size(iface);

x = zeros(4,1);
y = x;
z = x;
for k=1:n,
  x(:,k) = xnod(iface(:,k),1);
  y(:,k) = xnod(iface(:,k),2);
  z(:,k) = xnod(iface(:,k),3);
  u(:,k) =  sol(iface(:,k));
end

fill3(x,y,z,u);pause
