%function [xh,icoh] = mblock()
%---------------------------------------------------------------
%
%                GENERACION MULTIBLOCK
%
%---------------------------------------------------------------

out = 'y',
toler = 1e-8;

%--------------------------------------------------------
%      Datos 
%--------------------------------------------------------

%--------------------------------------------------------
% Numero de nodos segun x e y por bloque
%--------------------------------------------------------

 N = [  40      10
        20      10
        40      10 ];

 N = [  40      50
        40      25
        40      50 ];



  [nblock,m]=size(N);

%--------------------------------------------------------
% Coordenadas de los vertices de los bloques
%--------------------------------------------------------

x1 = [  0     0       ] ;
x2 = [  36    0       ] ;
x3 = [  0     1       ] ;
x4 = [  36    1       ] ;
x5 = [ -4     1       ] ;
x6 = [ -4     2       ] ;
x7 = [  0     2       ] ;
x8 = [  36    2       ] ;


%--------------------------------------------------------
% Coordenadas nodales de los bloques
%--------------------------------------------------------

xnod  = [x1;x2;x3;x4;x5;x6;x7;x8];

%--------------------------------------------------------
% Conectividades de los bloques
%--------------------------------------------------------

icone = [ ... 
          1    2   4   3   ;
          5    3   7   6   ;
          3    4   8   7  ];


% dividimos cada uno de los macroelementos

nnod = 0;
xh   = [];
icoh = [];
bouh = [];
nmacroele = length(icone(:,1));
 
for k=1:nmacroele,
  N1 = N(k,1);
  N2 = N(k,2);
  x = xnod(icone(k,:),:) ;

%  if k==3 | k==4 | k==7 | k==10 | k==13 ,
%    [x,ico] = refh1(x,[N1 N2]);
%  else
    [x,ico] = refh(x,[N1 N2]);
%  end

  nodo_bou = [(1:N1)';N1*(N2-1)+(1:N1)';(1:N1:N1*(N2-1)+1)';(N1:N1:N1*N2)'];
  bouh     = [bouh ; nodo_bou+nnod ] ;
  xh = [xh ; x];
  icoh = [icoh ; ico+nnod];
  nnod = nnod + length(x(:,1));
end



bouh=sort(bouh);
bouh=[bouh(1);bouh];
nodo_x = find(diff(bouh)==0);
bouh(nodo_x)=[];

nnod = length(xh(:,1));
ipunt = (1:nnod)';
nbou = length(bouh);

for k=nbou:-1:2,
  for l=1:k-1,
    distan = norm(xh(bouh(k),:)-xh(bouh(l),:),2);
    if distan < toler ,  ipunt(bouh(k)) = bouh(l); break ; end 
  end
end

icone = [];
for k=1:4,
  icone = [icone ipunt(icoh(:,k)) ];
end

nodes_ficticios = find(ipunt~=(1:nnod)') ;
ipunt = cumsum(ipunt==(1:nnod)');
ipunt(nodes_ficticios) = (nnod+1)*ones(length(nodes_ficticios),1);
xh(nodes_ficticios,:)=[];

icoh = [];
for k=1:4,
  icoh = [icoh ipunt(icone(:,k)) ];
end

nnod = length(xh(:,1));
[nele,nen] = size(icoh);

clg
pltmsh4((1:nnod),xh,(1:nele),icoh);

if out=='y', 


% CONDICIONES DE CONTORNO
%-------------------------------------------------

% Esta zona del programa se debe modificar ad-hoc para cada caso
%-------------------------------------------------------------------

% Back step flow
%------------------

% Entrada - Poiseuille desarrollado a la entrada
%------------------------------------------------
xmin = min(xh(:,1));
nodes_in = find(abs(xh(:,1)-xmin)<toler);
y0       = abs(x6(1,2)-x5(1,2))/2;
ym       = (x5(1,2)+x6(1,2))/2;
y        = xh(nodes_in,2);
id_in    = [ones(length(nodes_in),2) zeros(length(nodes_in),1) ...
                 ones(length(nodes_in),2)];
U_in     = [3/2*(1-((y-ym)/y0).^2) zeros(length(nodes_in),2) ... 
           2000*ones(length(nodes_in),1) zeros(length(nodes_in),1)];

% Salida - presion nula
%-----------------------------------
xmax = max(xh(:,1));

nodes_out = find(abs(xh(:,1)-xmax)<toler);
id_out    = [zeros(length(nodes_out),2) ones(length(nodes_out),1) ...
                 ones(length(nodes_out),2)];
U_out     = [zeros(length(nodes_out),3) ...
           2000*ones(length(nodes_out),1) zeros(length(nodes_out),1)]; 

% Pared inferior
%------------------------------------
mask1 = (abs(xh(:,2)-x3(1,2))<toler)&(xh(:,1)>x5(1,1))&(xh(:,1)<=x3(1,1));
mask2 = (abs(xh(:,1)-x3(1,1))<toler)&(xh(:,2)>=x1(1,2))&(xh(:,2)<x3(1,2));
mask3 = (abs(xh(:,2)-x1(1,2))<toler);
mask  = mask1+mask2+mask3;
wall_inf = find(mask~=0);
id_wall_inf  = [ones(length(wall_inf),2) zeros(length(wall_inf),1) ...
                 ones(length(wall_inf),2)];

U_wall_inf = [zeros(length(wall_inf),3) ...
           2000*ones(length(wall_inf),1) zeros(length(wall_inf),1)]; 

% Pared superior
%------------------------------------
mask = (abs(xh(:,2)-x7(1,2))<toler);
wall_sup = find(mask~=0);

id_wall_sup  = [ones(length(wall_sup),2) zeros(length(wall_sup),1) ...
                 ones(length(wall_sup),2)];

U_wall_sup = [zeros(length(wall_sup),3) ...
           2000*ones(length(wall_sup),1) zeros(length(wall_sup),1)]; 


vaux = [nodes_in;nodes_out;wall_inf;wall_sup];
vaux = [ vaux [id_in;id_out;id_wall_inf;id_wall_sup] ];
my_fprint('BOUN','%5i     %5i%5i%5i%5i%5i \n',vaux);

vaux = [nodes_in;nodes_out;wall_inf;wall_sup];
vaux = [vaux [U_in;U_out;U_wall_inf;U_wall_sup]];
my_fprint('FORC','%5i     %10.4f%10.4f%10.4f%10.4f%10.4f \n',vaux);

my_fprint('COOR','%5i     %10.4f%10.4f \n',[(1:nnod)' xh]);

nele = length(icoh(:,1));
my_fprint('ELEM','%5i%5i%5i%5i%5i%5i \n',...
           [(1:nele)' ones(nele,1) icoh(:,[1 4 3 2])  ]);

return

% POR LAS DUDAS SE NECESITE MAS ADELANTE
%------------------------------------------

my_fprint('TECO','%5i     %5i%5i \n',[ele_TECO ones(size(ele_TECO))*[2 Tamb]]);

my_fprintf('STRG', ... 
  '%5i%5i%10.5f%10.5f%10.5f%10.5f%10.4e%10.4e \n %9.4f%10.4f \n',vaux);

end