
% --------------------- datos del usuario ---------------------
% Datos de la seccion circular 2D
%ri = 0; re = 1; Nr = 8; Nc = 12;
ri = 0.1; re = 0.6; Nr = 10; Nc = 20;
%ri = 0.2; re = 1; Nr = 8; Nc = 12;

% Datos de la generatriz en la tercera dimension

% Posicion del centro de cada uno de los planos que se generan
% respecto al origen inicial en [0,0,0]
% y 
% Angulo de giro respecto a cada uno de los 3 ejes locales
% Este angulo es respecto a una terna fija de referencia

type_tubo = 0;    % recto [0] , curvo [1]

if type_tubo==0,
% tubo recto
%---------------------------------
gtriz = [  0 ,    0 , 0  ;
           0 ,    0 , 1  ; 
           0 ,    0 , 2  ;
	   0 ,    0 , 3  ; 
	   0 ,    0 , 4  ;
	   0 ,    0 , 5  ;
	   0 ,    0 , 6  ]/6*1.5;

theta_gtriz = zeros(size(gtriz));

else

% tubo curvo
%---------------------------------
Radio   = 4;
Radio_i = 0.1; Radio_f = 0.6;
Ntheta  = 10;
DTheta  = pi/4;

theta = ((0:Ntheta)'/Ntheta*DTheta);
%Radio = Radio*ones(Ntheta+1,1);
Radio = Radio_i+((0:Ntheta)'/Ntheta)*(Radio_f-Radio_i);
gtriz = [0*theta , Radio-Radio.*cos(theta) , Radio.*sin(theta) ] ;
theta_gtriz = [theta  ,      0*theta ,        0*theta  ];

end

% -------------------- fin datos usuario ----------------------

% generamos una seccion cilindrica
[x2d,ico2d]=cc2d(ri,re,Nr,Nc);

% tomo un sector circular
xmin_box = [-1e-6 , -1e-6];
xmax_box = 1.1*[re , re];
[nodes_in] = in_box(x2d,xmin_box,xmax_box);

nnn=length(nodes_in);
[nele2d,nen2d] = size(ico2d);

mask = zeros(nele2d,1);
for j=1:nen2d,
 for k=1:nnn,
  nn = find(ico2d(:,j)==nodes_in(k));
  mask(nn) = mask(nn)+1;
 end
end

eles = find(mask~=4);
[x2d,ico2d] = rmele(x2d,ico2d,eles);

% generamos la malla 3D
  xnod   = [];
  icone  = [];

  ngtriz = length(gtriz(:,1));
  n2d    = length(x2d(:,1));
  indx   = [ 2 3 ; 3 1 ; 1 2];

% Posiciono el primer plano (traslacion + rotacion)
  x3d = [ x2d , zeros(n2d,1)];
  for k=1:3,
    theta_k = theta_gtriz(1,k);
	Rota = eye(3);
	Rota(indx(k,1),indx(k,1)) =  cos(theta_k);
	Rota(indx(k,1),indx(k,2)) =  sin(theta_k);
	Rota(indx(k,2),indx(k,1)) = -sin(theta_k);
	Rota(indx(k,2),indx(k,2)) =  cos(theta_k);
    xold  = (Rota*x3d')';
  end
  xold   = ... 
    [xold(:,1)+gtriz(1,1),xold(:,2)+gtriz(1,2) xold(:,3)+gtriz(1,3)]; 

  xnod   = xold;

for k=1:ngtriz-1,
  xold = x3d;
%  xold = x3d*(1+1.0*k/(ngtriz-1));
  for k1=1:3,
    theta_k = theta_gtriz(k+1,k1);
	Rota = eye(3);
	Rota(indx(k1,1),indx(k1,1)) =  cos(theta_k);
	Rota(indx(k1,1),indx(k1,2)) =  sin(theta_k);
	Rota(indx(k1,2),indx(k1,1)) = -sin(theta_k);
	Rota(indx(k1,2),indx(k1,2)) =  cos(theta_k);
    xold  = (Rota*xold')';
  end

    dx = gtriz(k+1,1);
    dy = gtriz(k+1,2);
    dz = gtriz(k+1,3);
    xnew   = [xold(:,1)+dx,xold(:,2)+dy xold(:,3)+dz]; 

  xnod   = [xnod ; xnew];
  xold   = xnew;


  icone = [icone ; (k-1)*n2d+[ico2d n2d+ico2d ]];
end
