function [eles] = eles_in_box(xnod,icone,xmin_box,xmax_box)
%
%   Dado un conjunto de nodos "xnod", determinar aquellos
%   que se hallan dentro de una caja cubica con vertices
%   en xmin_box y xmax_box
%
%    [eles] = eles_in_box(xnod,icone,xmin_box,xmax_box) 
%

[numel,nen]=size(icone);
[numnp,ndm]=size(xnod);

xc = zeros(numel,ndm);

factor=1/nen;
for k=1:nen,
  xc = xc + factor*xnod(icone(:,k),:);
end

mask = ones(numel,1);

for k=1:ndm,
  mask = mask & (xc(:,k)<xmax_box(k)) ;
  mask = mask & (xc(:,k)>xmin_box(k)) ;
end

eles = find(mask==1);