function [ef_bou] = find_bou(icone,nodes_bou,nn)
%
%   Dado un conjunto de elementos "icone" 
%   y un conjunto de nodos "nodes_bou"
%   determina las caras de aquellos elementos que tienen
%   "nn" nodos dentro de la lista de nodos "nodes_bou"
%
%       [ef_bou] = find_bou(icone,nodes_bou,nn)
%
%    nodes_bou : conjunto de nodos del borde
%           nn : numero de nodos por cara de elemento
%                3 tetras - 4 hexas - 3 o 4 prismas
%       ef_bou : [ elemento cara ] del borde

%

nz = length(nodes_bou);
[numel,nen] = size(icone);

mask = zeros(numel,1);

for k=1:nz,
 for m=1:nen, 
  mask = mask + (icone(:,m)==nodes_bou(k));
 end
end

set_ele = find(mask==nn);
ne = length(set_ele);
jcone = icone(set_ele,:);

mask = zeros(ne,1);
for k=1:nz,
 for m=1:nen,
  mask = mask + (jcone(:,m)==nodes_bou(k))*m;
 end
end


ef_bou=[];

if nen==4,
  for k=1:ne,
    iface =  mask(k)-5;
	iele  =  set_ele(k);
	ef_bou = [ef_bou ; [iele iface]];
  end
elseif nen==6,
  error(' *** FIND_BOU.M  ERROR *** , falta implementar para prismas ')
else
  for k=1:ne,
	iele  =  set_ele(k);
    if(mask(k)==10),iface =  1;end
    if(mask(k)==14),iface =  2;end
    if(mask(k)==22),iface =  4;end
    if(mask(k)==26),iface =  6;end
    if(mask(k)==18),iface =  3;end
    nmin = min(icone(iele,:));
	if(iface==3)&(nmin==1), iface=5;end
	ef_bou = [ef_bou ; [iele iface]];
  end
end