function [faces,ele2face]=get_face_elem(xnod,icone)
%
%     [faces,ele2face]=get_face_elem(xnod,icone)
%
%  Given a set of 3D elements (hexas or tetras)
%  the corresponding faces are found
%
%     faces : nodes (global numbering) for each face
%  ele2face : mapping between elements and faces
%

[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);

if ndm==3,
   istetra=nen==4;
   if istetra
      nodes_face= [1,3,2; 1,4,3; 2,3,4; 1,2,4];
      nfaces = 4;
      mfaces = 3;
   else
      nodes_face= [1,2,3,4; 1,2,5,6; 2,3,7,6; 3,4,8,7; 1,5,8,4; 5,6,7,8];      
      nfaces = 6;
      mfaces = 4;
   end 
   for k=1:nfaces,
      ip            = (k-1)*numel+(1:numel)';      
      for l=1:mfaces,
         iface         = nodes_face(k,l);
         faces(ip,l)   = getcol(icone,ones(numel,1)*iface);
      end      
      ele2face(:,k) = ip;      
   end      
else
   error(' ONLY FOR 3D MESHES')
end

