function [iconew]=get_mesh_by_plane(xnod,icone,idm_plane,xc_plane)
%
% generate a mesh passing through a plane formed by a set of element faces
%
%    [iconew]=get_mesh_by_plane(xnod,icone,idm_plane,xc_plane)
%

table=[2,3;3,1;1,2];
i1=idm_plane;
i2=table(i1,1);
i3=table(i1,2);

[du,jmin]=min(abs(xnod(:,idm_plane)-xc_plane));
xc_plane = xnod(jmin,idm_plane);

% find all the faces for each element
[faces,ele2face]=get_face_elem(xnod,icone);
clear ele2face;
%keyboard;pause
% get the baricenter of each face
xc     = get_elem_center(xnod,faces);
nn     = find(abs(xc(:,idm_plane)-xc_plane)<1e-6);
iconew = faces(nn,:);

xx=xnod(:,i2);
yy=xnod(:,i3);

indx   = get_elem_number_order([xx,yy],iconew);
nn     = find(indx>0);
iconew = iconew(nn,:);
