function [xpri,icopri] = hex2pris(xnod,icone,set_ele,local_face_0)
%
%     [xpri,icopri] = hex2pris(xnod,icone,set_ele,local_face_0)
%
%  Genera una malla de prismas partiendo de una malla de hexaedros
%  set_ele : conjunto de elementos a tratar [Default:todos]
%  local_face_0 : cara local del primer elemento a tratar a ser partida
%


tol = 1e-10;
inoca = [1 4 3 2 ; 
         1 2 6 5 ;
         6 2 3 7 ;
         4 8 7 3 ;
         4 1 5 8 ;
         7 8 5 6 ];

iface_op = [6,4,5,2,3,1];

table = [1,3,1,6,6,3,7,4,5,4,5,7  ; 
         2,4,2,5,2,7,8,3,1,8,8,6  ];

% de acuerdo a las aristas comunes de la tabla_1
% te dice cuales son las caras a partir en tabla_2

%             aristas
tabla_1=[ 1,2,3,4 ; 2,3,1,4 ; 
          1,2,5,6 ; 1,5,2,6 ;
		  2,3,6,7 ; 2,6,3,7 ;
		  4,8,3,7 ; 3,4,7,8 ;
		  1,4,5,8 ; 1,5,4,8 ;
		  5,6,7,8 ; 6,7,5,8 ];
%			    cara a partir
tabla_2 = [ 2;3;1;3;1;2;3;1;1;2;2;3];

xpri = xnod;
[nnod,ndm] = size(xnod);
[nele,nen] = size(icone);

icopri = [];
inofa  = [];
ifael  = [];

% Armo arreglos de caras por elemento "ifael" y nodos por cara "inofa"
% En principio armo 6 caras por cada elemento (hay redundancia)
for k=1:6,
  i1 = icone(:,inoca(k,1));
  i2 = icone(:,inoca(k,2));
  i3 = icone(:,inoca(k,3));
  i4 = icone(:,inoca(k,4));

  faces = (1:6:nele*6)'+k-1;
  ifael(1:nele,k) = faces;
  inofa(faces,1:4) = [i1 i2 i3 i4];
end

% Remuevo caras duplicadas
% Ordeno nodos por cara por orden decreciente 
  [jnofa,is0] = sort(inofa');
   jnofa      = jnofa';
   is0        =   is0';

% ordeno por multiples llaves
  [knofa,is1] = mksort(jnofa);

% calculo operador inverso de ordenamiento
  ism1(is1,1) = (1:length(is1))'; 

% Reordeno el arreglo de caras por elemento
  for k=1:6,
   ifael(:,k)= ism1(ifael(:,k));
  end

% Calculo aquellas caras duplicadas
  mask = (sum(abs((diff(knofa))'))'~=0);
  mask = [1;mask];
  nn   = cumsum(mask);
  ifaces = find(mask~=0);

% Remuevo las caras duplicadas 
  inofa = inofa(is1(ifaces),:);

  for k=1:6,
   ifael(:,k)= nn(ifael(:,k));
  end

% numero de caras sin duplicar
  nfaces = length(ifaces);

ico1 = [... 
    1  2  3  5  6  7  ; 
	1  6  2  4  7  3  ; 
	2  6  3  1  5  4  ; 
	1  5  6  4  8  7  ;
	3  6  7  4  5  8  ;
	1  3  4  5  7  8  ;
	];

ico2 = [...
    1  2  4  5  6  8  ;
	1  5  2  4  8  3  ; 
    2  7  3  1  8  4  ; 
	2  5  6  3  8  7  ;
	2  6  7  1  5  8  ;
	2  3  4  6  7  8  ;
	 ];

ipolfa = zeros(nfaces,1);
ipolel = zeros(nele,1);


% Calculo lista de elementos perteneciente a cada region del dominio
% completo. La idea es tomar la caja que cubre todo el dominio y partirla
% en 2x2x2 pedazos y calcular a que region pertenece c/u de los elementos

% calculo de las cajas
xmax = max(xnod);
xmin = min(xnod);
dx   = xmax-xmin;
xbox = [xmin' , xmin'+0.45*dx', xmin'+0.55*dx' , xmax'];

% calculo del centroide de los elementos
%xc = zeros(nele,3);
%for k=1:nen,
%  xc= xc+ xnod(icone(:,k),:)/nen;
%end

xyz =(xnod(icone,:));
xxx = v2m(xyz(:,1),nele);
yyy = v2m(xyz(:,2),nele);
zzz = v2m(xyz(:,3),nele);
xe1 = min(xxx)';
xe2 = max(xxx)';
ye1 = min(yyy)';
ye2 = max(yyy)';
ze1 = min(zzz)';
ze2 = max(zzz)';

ele_box = zeros(nele,2^3);
for i1=1:2,
 mask_x = (xe1<=xbox(1,i1+2))&(xe2>=xbox(1,i1));
 for i2=1:2,
  mask_y = (ye1<=xbox(2,i2+2))&(ye2>=xbox(2,i2));
  for i3=1:2,
    ibox = (i1-1)*4+(i2-1)*2+i3;
    mask_z = (ze1<=xbox(3,i3+2))&(ze2>=xbox(3,i3));
	mask = (mask_x)&(mask_y)&(mask_z) ;
	ieles = find(mask==1);
	ele_box(ieles,ibox) = ibox*ones(size(ieles));
  end
 end
end

%keyboard;pause

if (sum(size(find((sum(ele_box'~=0)')==0)))~=0),
  error(' [ 0-0-0 ] ')
end


if nargin < 3, set_ele = (1:nele)'; end
if nargin < 4, local_face_0 = 1; end
nset_ele = length(set_ele); 

iset = (1:nele)';
iset(set_ele) = zeros(nset_ele,1);
nn = find(iset~=0);
nnen = 6;
if length(nn)>0, 
  icopri = icone(nn,:); 
  nnen   = 8;
end

for kset=1:nset_ele,

k = set_ele(kset);

  global_faces = ifael(k,1:6)';

  if kset==1, 

   local_face =local_face_0;
   local_face_op = iface_op(local_face);
   icouno = [];
   ipolfa(global_faces,1)=+9*ones(6,1);

   for iface=[local_face,local_face_op],

% nodos locales del elemento por la cara iface
     nodes_local = inoca(iface,[1,3]);
% nodos globales del elemento por la cara iface 
     nodes_global_elem = icone(k,nodes_local);
% nodos globales por la cara
	 nodes_global_face = inofa(global_faces(iface),:);
% vemos cual arista de la cara coincide con la del elemento tomada

     nn=find(nodes_global_face==nodes_global_elem(1));
	 if length(nn)==0, error(' HEX2PRIS [000]');end
	 if nn==1 | nn==3,
	   ipolfa(global_faces(iface),1)=+1;
	 else
	   ipolfa(global_faces(iface),1)=-1;
	 end

     icouno = [icouno ; icone(k,ico1(iface,:))];
				   
   end

  else

   sign_faces = ipolfa(global_faces,1);
   local_face = find(sign_faces~=0);
   if sum(size(local_face))==0, 
     error(' hex2pris [001] ');
   end

   mask = (abs(sign_faces(local_face))==1);
   nn   = find(mask~=0);

   if length(nn)>2, 
% mas de dos caras partidas
     error(' hex2pris [002] '); 
   end

%%%%%%%%%%%%%%%%%%%% if k==60 | k==61, keyboard;pause;end

   if length(nn)>0, 
% al menos una cara partida
     local_face = local_face(nn(1)); 
     get_pris;      

   else
% ninguna cara partida (al menos una debe ser 9)

     mask = (sign_faces==9);
     nnn  = find(mask==1);
     if length(nnn)==0 | length(nnn)>4, 
% ninguna cara es 9 (no puede ser) o existen mas de 4 caras 9
	   error(' hex2pris [002] '); 
	 end

     if length(nnn)==4,
% 4 caras tipo 9, las dos restantes son partidas
       local_face = find(sign_faces==0); local_face=local_face(1);
       get_pris
	 end

     if length(nnn)==3,
% 3 caras tipo 9, la que es opuesta a alguna de estas 3 y es tipo 0
% se convierte en 9 y las dos restante son partidas
	   nn_op = iface_op(nnn);
	   sign_faces(nn_op) = 9*ones(3,1);
       mask = (sign_faces==0);
       mmm  = find(mask==1);
	   local_face = mmm(1);
	   get_pris
	 end

     if length(nnn)<=2,
% 1 o 2 caras tipo 9, las que son opuesta a alguna de estas y son tipo 0
% se convierte en 9 y segun cuantas queden podemos 
%   (a) hacer que las dos restante sean partidas
%   (b) tener que elegir entre los 2 pares de caras restantes cual es partida

	   nn_op = iface_op(nnn);
	   sign_faces(nn_op) = 9*ones(size(nn_op));
       mask = (sign_faces==0);
       mmm  = find(mask==1);

       if length(mmm)==2,
% caso (a)
	     local_face = mmm(1);
	     get_pris
	   else
% caso (b)

         jnofa = inofa(global_faces(nnn(1)),:);
%		 nboxes = find(ele_box(k,:)~=0);
%		 list_ele = [];
%		 for ibox=1:nboxes,
%		   ieles = find(ele_box(:,ibox)~=0);
%		   list_ele = [list_ele;ieles];
%		 end
%         [list_ele] = rmdblist(list_ele);

         set_nod = icone(k,:);
         [list_ele,ele_int]=nod2ele(icone,set_nod);
		 list_ele = m2v(list_ele);
		 n1=find(list_ele~=0);
		 list_ele=list_ele(n1);
         [list_ele] = rmdblist(list_ele);

%keyboard;pause

		 [jele] = neig_ele(icone,list_ele,k,jnofa);

         global_faces_neig = ifael(jele,:);
         sign_faces_neig = ipolfa(global_faces_neig,1);
		 lll = find(abs(sign_faces_neig)==1);
		 if length(lll)~=2, 
% ninguna cara partida en el elemento vecino
           disp(' ERROR [005] ')
           keyboard;pause
		   error(' HEX2PRIS [005]');
		 end
% las dos caras partidas del vecino
         global_faces_neig=global_faces_neig(lll);
         nodes_global_face_neig = inofa(global_faces_neig,:);
		 nodes_global_elem = icone(k,:);
		 lt=[];
		 for l0=1:2,
		  for l1=1:4,
		   l2=find(nodes_global_elem==nodes_global_face_neig(l0,l1));
		   if length(l2)>0, lt=[lt;l2];end
		  end		  
		 end
		 if length(lt)~=4, 
%           disp(' ERROR [006] ')
%           keyboard;pause
		   error(' HEX2PRIS [006] ');
		 end

         local_face = local_face(1);
		 tabla = tabla_1(2*(local_face-1)+(1:2),:);
		 tabla = tabla';
		 s1=sum(tabla(1:2,:));
		 s2=sum(tabla(3:4,:));
		 s3=[s1;s2];
         slt1 = sum(lt(1:2));
         slt2 = sum(lt(3:4));
		 slt3=[slt1;slt2];
		 if min(slt3)==min(s3(:,1)) & max(slt3)==max(s3(:,1)),
		   local_face = tabla_2(2*(local_face-1)+1);
		 elseif min(slt3)==min(s3(:,2)) & max(slt3)==max(s3(:,2)),
		   local_face = tabla_2(2*(local_face-1)+2);
		 else
		   error(' HEX2PRIS [007] ');
		 end

%%%%%%%%%%%%%%%if k==37 | k==60 | k==61, keyboard;pause;end
		 get_pris;
%%%%%%%%%%%%%%%if k==37 | k==60 | k==61, keyboard;pause;end

	   end
	 end
    end  
   end

  if nnen==8, icouno = [icouno , zeros(2,2)]; end

  icopri=[icopri;icouno];



end
