function [xtet,icotet] = hex2tet2(xnod,icone)
%
%    [xtet,icotet] = hex2tet2(xnod,icone)
%
%   24 tetras por cada hexa y agrega nodos adicionales
%

tol = 1e-10;
inoca = [1 4 3 2 ; 
         5 1 2 6 ;
         6 2 3 7 ;
         8 7 3 4 ;
         5 8 4 1 ;
         5 6 7 8 ];

xtet = xnod;
[nnod,ndm] = size(xnod);
[nele,nen] = size(icone);

% agrego nodos en los centroides de cada elemento
xcc = zeros(nele,3);
for k=1:8,
  xcc= xcc+ xnod(icone(:,k),:)/8;
end
xtet = [xtet;xcc];

icotet = [];
inofa  = [];
ifael  = [];

% Armo arreglos de caras por elemento "ifael" y nodos por cara "inofa"
% En principio armo 6 caras por cada elemento (hay redundancia)
for k=1:6,
  i1 = icone(:,inoca(k,1));
  i2 = icone(:,inoca(k,2));
  i3 = icone(:,inoca(k,3));
  i4 = icone(:,inoca(k,4));

  faces = (1:6:nele*6)'+k-1;
  ifael(1:nele,k) = faces;
  inofa(faces,1:4) = [i1 i2 i3 i4];
end

% Remuevo caras duplicadas
% Ordeno nodos por cara por orden decreciente 
  [jnofa,is0] = sort(inofa');
   jnofa      = jnofa';
   is0        =   is0';

% ordeno por multiples llaves
  [knofa,is1] = mksort(jnofa);

% calculo operador inverso de ordenamiento
  ism1(is1,1) = (1:length(is1))'; 

% Reordeno el arreglo de caras por elemento
  for k=1:6,
   ifael(:,k)= ism1(ifael(:,k));
  end

% Calculo aquellas caras duplicadas
  mask = (sum(abs((diff(knofa))'))'~=0);
  mask = [1;mask];
  nn   = cumsum(mask);
  ifaces = find(mask~=0);

% Remuevo las caras duplicadas 
  inofa = inofa(is1(ifaces),:);

  for k=1:6,
   ifael(:,k)= nn(ifael(:,k));
  end

% Calculo nodo en los centroides de las caras remanentes
  xcf = (xnod(inofa(:,1),:)+xnod(inofa(:,2),:)+xnod(inofa(:,3),:)+...
		 xnod(inofa(:,4),:))/4;

  nlast = length(xtet(:,1));
  xtet=[xtet;xcf];

% armo los elementos con 
%  los nodos originales + 
%      nodos centroides elementos +
%      nodos centroides caras

for k=1:6,
  i1 = icone(:,inoca(k,1));
  i2 = icone(:,inoca(k,2));
  i3 = icone(:,inoca(k,3));
  i4 = icone(:,inoca(k,4));
  ic = nnod+(1:nele)';
  icotet=[icotet;[i2 i1 nlast+ifael(:,k) ic]];
  icotet=[icotet;[i3 i2 nlast+ifael(:,k) ic]];
  icotet=[icotet;[i4 i3 nlast+ifael(:,k) ic]];
  icotet=[icotet;[i1 i4 nlast+ifael(:,k) ic]];
end
