function [xtet,icotet] = hex2tet3(xnod,icone,set_ele,isgn_0)
%
%    [xtet,icotet] = hex2tet3(xnod,icone,set_ele,isgn_0)
%
%          Utilizo 5 tetraedros por cada hexahedro
%          sin agregar nodos adicionales
%


tol = 1e-10;
inoca = [1 4 3 2 ; 
         1 2 6 5 ;
         6 2 3 7 ;
         8 7 3 4 ;
         1 5 8 4 ;
         8 5 6 7 ];

xtet = xnod;
[nnod,ndm] = size(xnod);
[nele,nen] = size(icone);

icotet = [];
inofa  = [];
ifael  = [];

% Armo arreglos de caras por elemento "ifael" y nodos por cara "inofa"
% En principio armo 6 caras por cada elemento (hay redundancia)
for k=1:6,
  i1 = icone(:,inoca(k,1));
  i2 = icone(:,inoca(k,2));
  i3 = icone(:,inoca(k,3));
  i4 = icone(:,inoca(k,4));

  faces = (1:6:nele*6)'+k-1;
  ifael(1:nele,k) = faces;
  inofa(faces,1:4) = [i1 i2 i3 i4];
end

% Remuevo caras duplicadas
% Ordeno nodos por cara por orden decreciente 
  [jnofa,is0] = sort(inofa');
   jnofa      = jnofa';
   is0        =   is0';

% ordeno por multiples llaves
  [knofa,is1] = mksort(jnofa);

% calculo operador inverso de ordenamiento
  ism1(is1,1) = (1:length(is1))'; 

% Reordeno el arreglo de caras por elemento
  for k=1:6,
   ifael(:,k)= ism1(ifael(:,k));
  end

% Calculo aquellas caras duplicadas
  mask = (sum(abs((diff(knofa))'))'~=0);
  mask = [1;mask];
  nn   = cumsum(mask);
  ifaces = find(mask~=0);

% Remuevo las caras duplicadas 
  inofa = inofa(is1(ifaces),:);

  for k=1:6,
   ifael(:,k)= nn(ifael(:,k));
  end

% numero de caras sin duplicar
  nfaces = length(ifaces);

ico1 = [... 
    1  2  3  6  ;
   	1  3  4  8  ;
	6  8  7  3  ;
	5  8  6  1  ;
	1  3  8  6  ];
ico2 = [...
    1  2  4  5  ;
   	2  3  4  7  ;
	5  7  6  2  ;
	5  8  7  4  ;
	5  7  2  4  ];

ipolfa = zeros(nfaces,1);
ipolel = zeros(nele,1);

table = [1,3,1,6,6,3,8,3,1,8,8,6 ; 
         2,4,2,5,2,7,7,4,5,4,5,7 ];


if nargin < 3, set_ele = (1:nele)'; end
if nargin < 4, isgn_0 = 1; end
nset_ele = length(set_ele); 

iset = (1:nele)';
iset(set_ele) = zeros(nset_ele,1);
nn = find(iset~=0);
nnen = 4;
if length(nn)>0, 
  icotet = icone(nn,:); 
  nnen   = 8;
end

for kset=1:nset_ele,

k = set_ele(kset);

% caras que conforman el elemento
  global_faces = ifael(k,1:6)';

  if kset==1, 

   if isgn_0 >0,
    nodes_arista_local = table(1,:);
    ico                = ico1;
   else
    nodes_arista_local = table(2,:);
    ico                = ico2;
   end

   nodes_arista_global = icone(k,nodes_arista_local);

   for iface=1:6,

     nn = find(inofa(global_faces(iface),[1,3])==nodes_arista_global(2*(iface-1)+1));

	 if sum(size(nn))>0, 
	   ipolfa(global_faces(iface),1)=+1;
	 else
	   ipolfa(global_faces(iface),1)=-1;
	 end
   end

  else
   sign_faces = ipolfa(global_faces,1);
   local_face = find(sign_faces~=0);
   if sum(size(local_face))==0, 
     error(' hex2tet3 [000] ');
   end

% cara comun entre elemento vecinos
%-------------------------------------------------
   local_face = local_face(1);
   jface = global_faces(local_face);

% nodos pertenecientes a la cara comun
%-------------------------------------------------
   nodes_global = inofa(jface,:);

   if sign_faces(local_face)>0,
    nodes_arista = nodes_global([1,3]);
   else
    nodes_arista = nodes_global([2,4]);
   end

   nodes_local     = inoca(local_face,:);
   nodes_face_elem = icone(k,nodes_local);

   nodes_arista_local(1) = find(nodes_face_elem==nodes_arista(1));
   nodes_arista_local(2) = find(nodes_face_elem==nodes_arista(2));

   nodes_arista_local(1) = inoca(local_face,nodes_arista_local(1));
   nodes_arista_local(2) = inoca(local_face,nodes_arista_local(2));

   if (nodes_arista_local(1)==table(1,2*(local_face-1)+1)) | ...
	  (nodes_arista_local(1)==table(1,2*(local_face-1)+2)) ,
     nodes_arista_local = table(1,:);
	 ico                = ico1;
   else
     nodes_arista_local = table(2,:);
	 ico                = ico2;
   end

   nodes_arista_global = icone(k,nodes_arista_local);

   for iface=1:6,
     nn = find(inofa(global_faces(iface),[1,3])==nodes_arista_global(2*(iface-1)+1));
	 if sum(size(nn))>0, 
       vaux(iface,1)=+1;
	 else
       vaux(iface,1)=-1;
	 end
   end

   nn = find(ipolfa(global_faces,1)~=0);
   mm = sum(vaux(nn,1)==ipolfa(global_faces(nn),1));
   if length(nn)~=mm, error(' HEX2TET3 Error ');end
   ipolfa(global_faces,1) = vaux;


  end

  icouno = [...
             icone(k,ico(1,:));
             icone(k,ico(2,:));
             icone(k,ico(3,:));
             icone(k,ico(4,:));
             icone(k,ico(5,:))];

  if nnen==8, icouno = [icouno , zeros(5,4)]; end

  icotet=[icotet;icouno];

end
