function [xnew,iconew,nodes] = mesh_in_box(xnod,icone,xmin_box,xmax_box)
%
%  to generate a mesh from the original taking only those elements contained within a box
%
%   [xnew,iconew,nodes] = mesh_in_box(xnod,icone,xmin_box,xmax_box)
%

[nele,nen] = size(icone);
[nnod,ndm]=size(xnod);

% compute nodes within the box
[nodes_in] = in_box(xnod,xmin_box,xmax_box);
% mark those elements having their baricenter within the box
xc = get_elem_center(xnod,icone);

for idm=1:ndm,
   mask(:,idm) = (xc(:,idm)>=xmin_box(:,idm))&(xc(:,idm)<=xmax_box(:,idm));
end
set_ele=find(sum(mask')==ndm);

% calculamos los nodos que quedan en la nueva malla
nodes=[];
for k=1:nen,
  nodes = [nodes;icone(set_ele,k)];
end
nodes = sort(nodes);
nodes = rmdblist(nodes);

nnod = max2(icone);
set_nod = (1:nnod)';
set_nod(nodes) = (1:length(nodes))';

xnew = xnod(nodes,:);
for k=1:nen,
  iconew(:,k) = set_nod(icone(set_ele,k));
end

