function [ifaceb] = pltbou3d(xnod,icone,color_surface,ifaceb)
%
%    [ifaceb] = pltbou3d(xnod,icone,color_surface,ifaceb)
%

tol = 1e-10;

if nargin < 4,
  ifaceb = pfbou3d2(xnod,icone);
end

if nargin < 3, return ; end
  
[nnod,ndm] = size(xnod);
[nele,nen] = size(icone);

if nen==8,
inoca = [1 4 3 2 ; 
         1 2 6 5 ;
         6 2 3 7 ;
         8 7 3 4 ;
         1 5 8 4 ;
         8 5 6 7 ];
elseif nen==4,
inoca = [1 2 4 ; 
         2 3 4 ;
         1 4 3 ;
         1 3 2 ];
else
inoca = [1 3 2 1 ; 
         1 2 5 4 ;
         2 3 6 5 ;
         1 4 6 3 ;
         4 5 6 4 ];
end

[nface,mface]=size(inoca);
nfaces = length(ifaceb(:,1));

nodes_local = inoca(ifaceb(:,2),1:mface);

nodes_global = zeros(nfaces,mface+1);


for k=1:nfaces
% mm = mface;
% if (nen==6)&(k==1 | k==5), mm=3;end
 for m=1:mface,
  nodes_global(k,m) = icone(ifaceb(k,1),nodes_local(k,m));
 end
 nodes_global(k,mface+1) =  icone(ifaceb(k,1),nodes_local(k,1));
end

xx =[];yy=[];zz=[];
for k=1:nfaces,
 xx= [xx ; [xnod(nodes_global(k,:),1)] ];
 yy= [yy ; [xnod(nodes_global(k,:),2)] ];
 zz= [zz ; [xnod(nodes_global(k,:),3)] ];
end

xx = v2m(xx,mface+1)';
yy = v2m(yy,mface+1)';
zz = v2m(zz,mface+1)';

%fill3(xx,yy,zz,color_surface);
patch(xx,yy,zz,color_surface);
