function [icone_t,map] = prismas2tetras(icone)
%
%  [icone_t,map] = prismas2tetras(icone)
%
%  split prismatic mesh in tetrahedral mesh 
%
%  each tetra at each corner of the prism
%
%  prism nodes number 
%  [1,2,3] for the bottom triangle
%  [4,5,6] for the upper triangle
%
%  map : me dice a que prisma pertenece cada tetra y 
%        cual es el tetra de la particion
%  map(i,1) = es el prisma que dio origen i-esimo tetras 
%  map(i,2) = me dice a cual de las 6 particiones pertenece
%

tetras = [ 1,2,3,4;
    2,3,1,5;
    3,1,2,6;
    4,6,5,1;
    5,4,6,2;
    6,5,4,3];

numel=size(icone,1);

icone_t = [];
map = [];
for k=1:size(tetras,1)
    nodes = tetras(k,:);
    icone_t = [icone_t;icone(:,nodes)];
    map = [map;[(1:numel)',k*ones(numel,1)]];
end

