function [xnew,iconew] = refq3xN(xnod,icone,N)
%
%        [xf,icof] = refq3xN(xnod,icone)
%
%       Refina un hexa (3D) en NxNxN hexas
%

[nnod,ndm]=size(xnod);
[nele,nen]=size(icone);

if nen~=8, error(' ONLY FOR HEXAS ');end

% Calculo de las funciones de forma del elemento master
 psi = (-1:2/N:1); 

 x1 = [psi' , zeros(N+1,2)];
 x2 = [zeros(N+1,1) , psi', zeros(N+1,1)];
 x3 = [zeros(N+1,2), psi' ];

 xnew=[];
 iconew=[];

for k=1:nele,
  
  nodes = icone(k,:);

% genero un hexa master de NxNxN
  [xq,icoq] = qq3d(x1,x2,x3);

% transformacion inversa al quad original

  Nj(:,1)  = 0.125*(1-xq(:,1)).*(1-xq(:,2)).*(1-xq(:,3));
  Nj(:,2)  = 0.125*(1+xq(:,1)).*(1-xq(:,2)).*(1-xq(:,3));
  Nj(:,3)  = 0.125*(1+xq(:,1)).*(1+xq(:,2)).*(1-xq(:,3));
  Nj(:,4)  = 0.125*(1-xq(:,1)).*(1+xq(:,2)).*(1-xq(:,3));
  Nj(:,5)  = 0.125*(1-xq(:,1)).*(1-xq(:,2)).*(1+xq(:,3));
  Nj(:,6)  = 0.125*(1+xq(:,1)).*(1-xq(:,2)).*(1+xq(:,3));
  Nj(:,7)  = 0.125*(1+xq(:,1)).*(1+xq(:,2)).*(1+xq(:,3));
  Nj(:,8)  = 0.125*(1-xq(:,1)).*(1+xq(:,2)).*(1+xq(:,3));

  xx=0;yy=0;zz=0;
  for j=1:nen,
    xx = xx + Nj(:,j)*xnod(nodes(j),1);
    yy = yy + Nj(:,j)*xnod(nodes(j),2);
    zz = zz + Nj(:,j)*xnod(nodes(j),3);
  end

  [nnew,ndm]=size(xnew);
  xnew   = [ xnew ; [ xx , yy , zz] ];
  iconew = [iconew ; nnew+[icoq] ];

  if 0,
  [xnew,irenum]=rmdbnode(xnew);
  for j=1:nen,
   iconew(:,j) = irenum(iconew(:,j));
  end
  end

end

[xnew,iconew] = check_mesh(xnew,iconew,1);