function [xnew,iconew] = reft2xN(xnod,icone,N)
%
%        [xf,icof] = reft2xN(xnod,icone,N)
%
%       Refina varios triangulos (2D) en NxN triangulos c/u
%

[nnod,ndm]=size(xnod);
[nele,nen]=size(icone);

if nen~=3, error(' ONLY FOR TRIANGLES ');end

for k=1:nele,

% armo por cada triangulo un quad refinado
  nodes = icone(k,:);
  xe    = xnod(nodes,:);
  xplus = xe(2,:)+(xe(3,:)-xe(1,:));
  xe    = [xe ; xplus];
  icoe  = [1,2,4,3];



  [xfe,icofe] = refq2xN(xe,icoe,N);



% triangularizo el quad anterior
  icofe = [icofe(:,[1,2,4]);icofe(:,[2,3,4])];

% remuevo del quad anterior la parte que no corresponde
  xc   = zeros(2*N^2,2);
  for j=1:3,
    xc = [xc + [xfe(icofe(:,j),1) xfe(icofe(:,j),2)]];
  end
  xc = xc/3;

  xc1 = [xc-ones(2*N^2,1)*xnod(nodes(1),:), zeros(2*N^2,1)];
  xc2 = [xc-ones(2*N^2,1)*xnod(nodes(2),:), zeros(2*N^2,1)];
  xc3 = [xc-ones(2*N^2,1)*xnod(nodes(3),:), zeros(2*N^2,1)];

  vaux = cross(xc2',xc3')'  ;
  eles = find(vaux(:,3)<=0) ;
  [xfe,icofe] = rmele(xfe,icofe,eles);

  [nnew,ndm]=size(xnew);
  xnew   = [ xnew ; xfe ];

  iconew = [iconew ; nnew+[icofe] ];
  

  [xnew,irenum]=rmdbnode(xnew);
  
  for j=1:3,
   iconew(:,j) = irenum(iconew(:,j));
  end

end
