function [Rele] = ... 
    r_boun(xnod,Te,Ce,props,velx,vely,dxdT,dydT,dxdC,dydC,Cse,mushy_e,...
	       dNdx0,dNdy0,Jaco0)
%
%
%      Contribucion del contorno debido a la regla de Leibnitz
%
%   xnod : coordenadas del conjunto de elementos triangulares 
%          producto de la particion
%

       nen  = 3;
       ndf  = 2;
[numel,bas] = size(Te);

icone          = v2m((1:numel*3)',3);

Tm       = props(1);
slopel   = props(2);
kp       = props(3);
Ks       = props(5);
Kl       = props(6); 
Lh       = props(9);
U0       = props(10);
Cp       = props(8);
rho      = props(7);
Dm_s     = props(12);
Dm_l     = props(13);
dt       = props(14);

nn = [ 1 2 3 ; 
       2 3 1  ];

npg_boun = 2;
xpg = sqrt(3)/3;
xpg = [-xpg xpg];
wpg = [1 1];

Rele = zeros(numel,(3*ndf)^2);

fse  = frsol2(m2v(Te),m2v(Ce),Tm,slopel,kp);
fse  = v2m(fse,3);

% Loop sobre las aristas
for iar=1:3,

 ig = nn(:,iar);
 n1 = icone(:,ig(1));n2 = icone(:,ig(2));

 dx = xnod(n2,1)-xnod(n1,1);
 dy = xnod(n2,2)-xnod(n1,2);
 dl = sqrt(dx.^2+dy.^2);
 nor= [dy./dl -dx./dl];

 Rar = zeros(numel,(3*ndf)^2);

% Loop sobre los puntos de Gauss
 for ipg=1:npg_boun,

  Nb(1)  = 0.5*(1-xpg(ipg));
  Nb(2)  = 0.5*(1+xpg(ipg));
  xp(:,1) = xnod(n1,1)*Nb(1)+xnod(n2,1)*Nb(2);
  xp(:,2) = xnod(n1,2)*Nb(1)+xnod(n2,2)*Nb(2);
  [psi] = x2psi(xnod,icone,xp);

  [X2S,S2X,Jaco] = xy2st(xnod,icone,psi(:,1),psi(:,2));
  [dNdx,dNdy,N] = shape(X2S,psi(:,1),psi(:,2),3); 

  Jaco    = dl/2;

  Tpg     = zeros(numel,1);
  Cpg     = zeros(numel,1);
  fspg    = zeros(numel,1);
  dTpg    = zeros(numel,2);
  dCpg    = zeros(numel,2);
 dCspg    = zeros(numel,2);
 dfspg    = zeros(numel,2);
 velpg    = zeros(numel,2);

  for inod=1:3,
      Tpg       =     Tpg      +    N(:,inod) .*  Te(:,inod);
      Cpg       =     Cpg      +    N(:,inod) .*  Ce(:,inod);
     fspg       =    fspg      +    N(:,inod) .* fse(:,inod);
     dTpg(:,1)  =    dTpg(:,1) + dNdx(:,inod) .*  Te(:,inod);
     dTpg(:,2)  =    dTpg(:,2) + dNdy(:,inod) .*  Te(:,inod);
     dCpg(:,1)  =    dCpg(:,1) + dNdx(:,inod) .*  Ce(:,inod);
     dCpg(:,2)  =    dCpg(:,2) + dNdy(:,inod) .*  Ce(:,inod);
    dCspg(:,1)  =   dCspg(:,1) + dNdx(:,inod) .* Cse(:,inod);
    dCspg(:,2)  =   dCspg(:,2) + dNdy(:,inod) .* Cse(:,inod);
    dfspg(:,1)  =   dfspg(:,1) + dNdx(:,inod) .* fse(:,inod);
    dfspg(:,2)  =   dfspg(:,2) + dNdy(:,inod) .* fse(:,inod);
	velpg(:,1)  =   velpg(:,1) +    N(:,inod) .* velx(:,inod);
	velpg(:,2)  =   velpg(:,2) +    N(:,inod) .* vely(:,inod);
  end


  kappa =   Ks*fspg +   Kl*(1-fspg);
  Dm    =   Dm_l/kp+ (Dm_s-Dm_l/kp)*fspg;

% Vector Residuo
%------------------------------------------------------------------

 dGdT  = zeros(numel,3);
 dGdC  = zeros(numel,3);

 for inod=1:2,
  for k=1:3,
   dGdT(:,k) = dGdT(:,k) + Nb(:,inod).* ...
	(dxdT(:,(ig(inod)-1)*3+k).*nor(:,1)+dydT(:,(ig(inod)-1)*3+k).*nor(:,2));
   dGdC(:,k) = dGdC(:,k) + Nb(:,inod).* ...
	(dxdC(:,(ig(inod)-1)*3+k).*nor(:,1)+dydC(:,(ig(inod)-1)*3+k).*nor(:,2));
   end
 end

% for inod=1:3,
%    R_T(:,inod) = ... 
%	  N(:,inod).*Tpg/dt + ...
%	  N(:,inod).*(velpg(:,1).*dTpg(:,1)+velpg(:,2).*dTpg(:,2)) + ...
%	  (kappa/rho/Cp).*(dNdx(:,inod).*dTpg(:,1)+dNdy(:,inod).*dTpg(:,2)) - ... 
%	  mushy_e .* (N(:,inod).*(Lh/Cp*(U0.*dfspg(:,2) + fspg/dt))) ; 
% end

% for inod=1:3,
%    R_C(:,inod) = ... 
%	  N(:,inod).*Cpg/dt + ...
%	  N(:,inod).*(velpg(:,1).*dCpg(:,1)+velpg(:,2).*dCpg(:,2)) + ...
%	      Dm.*(dNdx(:,inod).*dCspg(:,1)+dNdy(:,inod).*dCspg(:,2)) + ... 
%      mushy_e .* (N(:,inod).*((dCspg(:,1)/kp-dCpg(:,1)).* velpg(:,1) + ...
%                 (dCspg(:,2)/kp-dCpg(:,2)).*(velpg(:,2)-U0) ) ) ;
% end

ijob=1;
bas = 0*(Tpg*ones(1,nen));
Relet = zeros(numel,nen*ndf);

[bas,Relet] = ... 
 KyR003(bas,Relet,Tpg,Cpg,dTpg,dCpg,dCspg,dfspg,bas,bas,bas,velpg,dt,fspg,...
          N,dNdx,dNdy,ones(numel,1),ones(1,npg_boun),dNdx0,dNdy0,Jaco0,mushy_e,props,...
			 [1,1,1,1,1],ndf,nen,ijob,ipg);


R_T = -Relet(:,1:ndf:ndf*nen);
R_C = -Relet(:,2:ndf:ndf*nen);

 for k=1:3,
  for inod=1:3,
    ip = (inod-1)*3*ndf^2+(k-1)*ndf^2;
    Rar(:,ip+1)=Rar(:,ip+1)-R_T(:,inod).*dGdT(:,k).*(wpg(ipg).*Jaco);
    Rar(:,ip+4)=Rar(:,ip+4)-R_C(:,inod).*dGdC(:,k).*(wpg(ipg).*Jaco);	              
    Rar(:,ip+2)=Rar(:,ip+2)-R_T(:,inod).*dGdC(:,k).*(wpg(ipg).*Jaco);
    Rar(:,ip+3)=Rar(:,ip+3)-R_C(:,inod).*dGdT(:,k).*(wpg(ipg).*Jaco);	              

  end
 end

% disp(' r_boun [1] ');keyboard;pause

end      % fin Loop puntos de Gauss

Rele = Rele + Rar;

end      % fin loop aristas

