function [vsec] = pf_coef(xnod,icone,U,faces)
%------------------------------------------------------------------
%
%  Lift coefficient computation
%
%------------------------------------------------------------------

% Datos dependiente de la aplicacion
idf_pressure = 3;
idf_u        = 1;
idf_v        = 2; 
ndof         = 2; % cantidad de grados de libertad de variables secundarias

p_infty   = 1;
rho_infty = 1;
vel_infty = 1;

  [numel,nen]   = size(icone);
  [numnp,ndf]   = size(U);
  [numnp,ndim]   = size(xnod);
  
  if ndim~=2, error(' Available only for NDIM = 2 ');end  
  
  if nen==3, npg=3; end
  if nen==4, npg=4; end

%  [vaux] = get_normal(xnod,icone,ele_face);
%  nodes  = vaux(:,1);
%  normal = vaux(:,2:3);
%  nx     = normal(:,1);
%  ny     = normal(:,2);
  
  n1 = get_col(icone,faces);
  n2 = n1+1;
  n2 = n2.*(n2<=nen)+(n2>nen);
  dd = xnod(n2,:)-xnod(n1,:);
  dd = dd./((sqrt(sum(dd'.^2)))*[1,1]);
  nx = -dd(:,2); ny = dd(:,1);
  
  ceros    = zeros(numel,nen*ndf);
  
  Rg   = zeros(numnp,2);
  Mg   = zeros(numnp,1);

  Rele = zeros(numel,2*nen);
  Mele = zeros(numel,1*nen);
    
% Localizacion
%------------------------------------------------------------------

       Ue = ceros;

  for inod=1:nen,
     for idf=1:ndf,
       nodes = icone(eles,inod);
       Ue(:,(inod-1)*ndf+idf) = U(nodes,idf);
     end 
  end

 for ipg=1:npg

  [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
  [dNdx,dNdy,N] = shape(X2S,psipg(ipg),etapg(ipg),nen); 

  Upg    = zeros(length(eles),ndf);
  dUdxpg = zeros(length(eles),ndf);
  dUdypg = zeros(length(eles),ndf);
  
  for inod=1:nen,
   for idf=1:ndf,
      Upg(:,idf) = Upg(:,idf) + N(inod).* Ue(:,(inod-1)*ndf+idf);
      dUdxpg(:,idf) = dUdxpg(:,idf) + dNdx.* Ue(:,(inod-1)*ndf+idf);
      dUdypg(:,idf) = dUdypg(:,idf) + dNdy.* Ue(:,(inod-1)*ndf+idf);      
   end   
  end
     
  for inod=1:nen,        
     Mele(eles,inod) = Mele(eles,inod) + N(inod).*xsj;
  end % inod
  
  for inod=1:nen,        
   if(ijob==1),     
     Rele(eles,inod) = Rele(eles,inod) + ...
        (Upg(:,idf_pressure)-p_infty)/(0.5*rho_infty*vel_infty^2).*xsj;							      
  else
     % pressure forces
     Fpx = Upg(:,idf_pressure)*nx;
     Fpy = Upg(:,idf_pressure)*ny;
     % viscous forces
     Fvx = visco*(dUdxpg(:,idf_u)*nx+dUdypg(:,idf_u)*ny);
     Fvx = visco*(dUdxpg(:,idf_v)*nx+dUdypg(:,idf_v)*ny);     
     Rele(eles,(inod-1)*ndof+1) = Rele(eles,(inod-1)*ndof+1) + (Fpx+Fvx).*xsj;
     Rele(eles,(inod-1)*ndof+2) = Rele(eles,(inod-1)*ndof+2) + (Fpy+Fvy).*xsj;     
  end
  end % inod

 end % ipg

  for iele=1:numel,
  for inod=1:nen,
   for idf=1:ndof,
    Rg(icone(iele,inod),idf) = ... 
         Rg(icone(iele,inod),idf) + Rele(iele,(inod-1)*ndof+idf);      
   end
   Mg(icone(iele,inod),1) = Mg(icone(iele,inod),1) + Mele(iele,inod);          
  end
  end
  
  for idof=1:ndof,
    vsec(:,idof) = Rg(:,idof) ./ Mg;
  end