function [ar,emax,emin,diangle] = ar3d(xnod,icone,ijob)
%
%   [ar,emax,emin,diangle] = ar3d(xnod,icone,ijob)
%
%   ar : aspect ratio
%   emin : minimal edge length element by element
%   emax : maximal edge length element by element
%
%   diangle : dihedral angle distribution (if ijob==1)
%

big_amount = 5e5;

if size(icone,1)>big_amount
    nchunks = round(size(icone,1)/big_amount);
else
    nchunks = 1;
end

nele_chunk = round(size(icone,1)/nchunks);

emin = [];
emax = [];

for ich=1:nchunks
    eles_1 = (ich-1)*nele_chunk+1;
    eles_2 = min([(ich)*nele_chunk,size(icone,1)]);   

    eles = (eles_1:eles_2);
    disp([ num2str(ich) '/' num2str(nchunks)])
    
    [ar_p,emax_p,emin_p,diangle_p] = ar3d_chunk(xnod,icone(eles,:),ijob);
    
    ar(eles,1) = ar_p;
    emin(eles,1) = emin_p;    
    emax(eles,1) = emax_p;        
    diangle(eles,1) = diangle_p;    

end
