function [Fa,Ax,Ay] = Flux_function(Up,prop,veloc)
%
%            [Fa,Ax,Ay] = Flux_function(Up,prop,veloc)
%
%       Computes advective fluxes F_a
%                   2D    
%	 Dimension of Fa array = numnp x ndm*ndf 
%             

ndm         = 2;
[N,ndf]     = size(Up);
if ndf~=2, error(' CHECK FLUX FUNCTION BECAUSE IT IS ONLY VALID FOR NDF=2'); end

eig_dcmp_function;

vx = rowprod(Lax,S1,ndf,ndf,ndf);
vx = rowprod(S,vx,ndf,ndf,ndf);
vy = rowprod(Lay,S1,ndf,ndf,ndf);
vy = rowprod(S,vy,ndf,ndf,ndf);

% advective jacobians
A   = zeros(N,ndm,ndf,ndf);
for j=1:ndf,
   for k=1:ndf,
      A(:,1,j,k)    = vx(:,j,k);
      A(:,2,j,k)    = vy(:,j,k);
   end
end

Ax         = reshape(A(:,1,:,:),N,ndf,ndf);
Ay         = reshape(A(:,2,:,:),N,ndf,ndf);      

% advective fluxes
Fa     = zeros(N,ndf,2);
Fa(:,:,1)   = rowprod(reshape(A(:,1,:,:),N,ndf,ndf),Up,ndf,ndf,1);
Fa(:,:,2)   = rowprod(reshape(A(:,2,:,:),N,ndf,ndf),Up,ndf,ndf,1);

