%
%   Ejemplo Generacion de malla a partir de un Laplaciano
%  

Nx  = 41;
Ny  = 41;
Lx  = 1;  
Ly  = 1; 

psi      = (0:Nx-1)'/(Nx-1);
x0       = 0;
x        = psi*Lx+x0; 
eta      = (0:Ny-1)'/(Ny-1)*1; 
y0       = 0;
y        = eta*Ly+y0;

%-------- coordenadas (XNOD)
xnod     =[];
for k=1:Ny,
  xnod=[xnod;[x ones(Nx,1)*y(k)]];
end

%-------- conectividades (ICONE)
icone    =[];
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
ico2= [ (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' (1:Nx-1)'];
for k=1:Ny-1,
    icone=[icone; (k-1)*Nx+ico ];
end

% convertimos cuadrangulos en triangulos
quad2tri=0;

if quad2tri,
[numel,nen]=size(icone);

iconew=[];
for k=1:numel,
  vvv  = icone(k,:);
  ico  = Q2T(xnod(vvv,:));
  iconew = [iconew;vvv(ico(1,:));vvv(ico(2,:))];
end
icone=iconew;
end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;
nodes_bot  = (1:Nx);
nodes_top  = Nx*(Ny-1)+(1:Nx);
nodes_lef  = 1:Nx:Nx*Ny;
nodes_rig  = Nx:Nx:Nx*Ny;

fixa= zeros(numnp,ndf);
fixa(nodes_lef,1)=ones(length(nodes_lef),1);
fixa(nodes_rig,1)=ones(length(nodes_rig),1);
fixa(nodes_top,1)=ones(length(nodes_top),1);
fixa(nodes_bot,1)=ones(length(nodes_bot),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc = zeros(numnp,ndf);

r_i = 0.5;
r_e = 1.5;
theta = pi/4;
if 0,
% coordenada x
forc(nodes_top,1) = (r_i+(r_e-r_i)*xnod(nodes_top,1))*cos(theta);
forc(nodes_bot,1) = (r_i+(r_e-r_i)*xnod(nodes_top,1))*cos(0);
forc(nodes_lef,1) = r_i*cos(xnod(nodes_lef,2)*theta); 
forc(nodes_rig,1) = r_e*cos(xnod(nodes_rig,2)*theta); 

mask = (xnod(nodes_bot,1)>0.3)&(xnod(nodes_bot,1)<=0.7);
nn   = find(mask==1);
z    = naca4ds(0012,length(nn));
xprf = rot90(rot90(real(z(1:length(nn)))));
forc(nodes_bot(nn),1) = r_i+(0.3+xprf*(0.7-0.3))*(r_e-r_i);
[dmin,imin] = min(abs(xnod(nodes_bot,1)-0.3));
forc(nodes_bot(imin),1) = r_i+0.3*(r_e-r_i);

else
% coordenada y
forc(nodes_top,1) = (r_i+(r_e-r_i)*xnod(nodes_top,1))*sin(theta);
forc(nodes_bot,1) = (r_i+(r_e-r_i)*xnod(nodes_top,1))*sin(0);
forc(nodes_lef,1) = r_i*sin(xnod(nodes_lef,2)*theta); 
forc(nodes_rig,1) = r_e*sin(xnod(nodes_rig,2)*theta); 

mask = (xnod(nodes_bot,1)>0.3)&(xnod(nodes_bot,1)<=0.7);
nn   = find(mask==1);
z    = naca4ds(0012,length(nn));
yprf = rot90(rot90(imag(z(1:length(nn)))));
forc(nodes_bot(nn),1) = yprf;
[dmin,imin] = min(abs(xnod(nodes_bot,1)-0.3));
forc(nodes_bot(imin),1) = 0;

end

%-------- Fuentes de volumen (por elemento)
source =zeros(numel,1);

%--------- Termino reactivo -----------------------------
reac = zeros(numel,1);

%--------- Campo de Velocidad -----------------------------
veloc = zeros(numnp,2);
%-------- Propiedades del material

 rho     = 1    ;
 Cp      = 1    ;
 kappa   = 1    ;
 npg     =  2   ;
 prop(1) =rho   ;
 prop(2) =Cp    ;
 prop(3) =kappa ;
 prop(4) =npg   ;

 upwind  =    0 ;
 shocap  =    0 ;
 axisim  =    0 ;
% [1] SUPG
% [2] (SU+C)PG
 type_upw =    1;   
 lumped   =   0 ;

 prop(6)  = upwind ;
 prop(7)  = shocap ;
 prop(8)  = axisim ;
 prop(9)  = type_upw;
 prop(11) = lumped ;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas
peri = [];

%-------- Solucion inicial (PHI)
bini = zeros(numnp,ndf);

for k=1:ndf,
 nofree        = find(fixa(:,k)~=0);
 bini(nofree,k)   = forc(nofree,k);
end
