% Calculos del elemento propiamente dichos
%------------------------------------------------------------------

  beta_supg = 1.0;      % consistent SUPG mass matrix parameter
 						      % [0] consistent Galerkin ; [1] consistent SUPG
  implicit_factor = 1;  % [1] full implicit ; 
                        % [0] only mass matrix is implicit ;
                        
  ne    = length(eles);
  
  weak_form = 1;
  
  difu_phys = kappa /rho/Cp; 
  Kappa_pg = difu_phys*eye(2);
  
  % DEBUG fixme after the test  
  % r = [-1;5]; r=r/norm(r);
  % s = [0;5]; s =s/norm(s);
  % Kappa_pg = difu_phys*(r*r'-(r'*s)^2*(s*s'));  
  % END DEBUG

% Localizacion
%------------------------------------------------------------------

    ceros = zeros(length(eles),nen);
       Te = ceros;
      T0e = ceros;
     vele = zeros(length(eles),nen,ndm);
	 radio = ceros;
   
  for inod=1:nen,
               nodes = icone(eles,inod);
       Te(:,inod) = T(nodes);
      T0e(:,inod) = Told(nodes);
     vele(:,inod,1:ndm) = veloc(nodes,1:ndm);
    radio(:,inod) = xnod(nodes,1);
  end
  
  if 0,
     
% Calculo del tamao del elemento en el centroide del elemento
%------------------------------------------------------------------
if nen==4,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),0,0);
  [dshapex0,N0] = shape2d(X2S,0,0,nen); 
elseif nen==3,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),1/3,1/3);
  [dshapex0,N0] = shape2d(X2S,1/3,1/3,nen); 
else
  error(' Bad type of element , nen ~=3, nen ~=4 ')
end

  velpg  = zeros(ne,2);
  Tpg    = zeros(ne,1);
  dTpg    = zeros(ne,2);

  for inod=1:nen,
     Tpg(:,1)  =  Tpg(:,1) + N0(inod).*    Te(:,inod);     
     for idm=1:ndm,
        velpg(:,idm)  = velpg(:,idm) +  N0(inod).* vele(:,inod,idm);
        dTpg(:,idm)  = dTpg(:,idm) + dshapex0(:,inod,idm).* Te(:,inod);
     end      
  end    
  
  hele = comp_hele(velpg,dshapex0,Jaco0,nen);
  [P1_pg,tau,difu_anis]=supg_advdif_2d(velpg,difu_phys,dshapex0,hele,Tpg,dTpg,reac, ... 
                                       source,nen,shocap,tau_fac)                                      
  end
  
% Loop sobre los puntos de Gauss
%------------------------------------------------------------------

 for ipg=1:npg

  [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
  [dshapex,N] = shape2d(X2S,psipg(ipg),etapg(ipg),nen); 
  
% Interpolacion en punto de Gauss
%------------------------------------------------------------------
     Tpg    = zeros(ne,1);
    T0pg    = zeros(ne,1);
    dTpg    = zeros(ne,2);
   dT0pg    = zeros(ne,2);    
   velpg    = zeros(ne,2);
   radpg    = zeros(ne,1);

  for inod=1:nen,
      Tpg(:,1)  =     Tpg(:,1) +      N(inod).*    Te(:,inod);
     T0pg(:,1)  =    T0pg(:,1) +      N(inod).*   T0e(:,inod);
     dTpg(:,1)  =    dTpg(:,1) + dshapex(:,inod,1).*    Te(:,inod);
     dTpg(:,2)  =    dTpg(:,2) + dshapex(:,inod,2).*    Te(:,inod);
    dT0pg(:,1)  =   dT0pg(:,1) + dshapex(:,inod,1).*    T0e(:,inod);
    dT0pg(:,2)  =   dT0pg(:,2) + dshapex(:,inod,2).*    T0e(:,inod);     
    velpg(:,1)  =   velpg(:,1) +      N(inod).* vele(:,inod,1);
    velpg(:,2)  =   velpg(:,2) +      N(inod).* vele(:,inod,2);
    radpg(:,1)  =   radpg(:,1) +      N(inod).* radio(:,inod);
  end
  
  % asumimos que la difusion fisica es cte
%  kappa_pg = difu_phys;
  
  hele = comp_hele(velpg,dshapex,Jaco,nen);
  [P1_pg,tau,difu_anis]=supg_advdif_2d(velpg,difu_phys,dshapex,hele,Tpg,dTpg,reac(eles), ... 
                                         source(eles),nen,shocap,tau_fac);

% Correccion axisimetrica del jacobiano de la transformacion al elemento master
%------------------------------------------------------------------
  xsj =  wpg(ipg) .* Jaco;
  if axisim,
     xsj = xsj.*radpg;
  end

% Calculo matriz tangente y residuo
%--------------------------------------------------------------------
  for inod=1:nen,
   if ijob==0,

    for jnod=1:nen,
%     ip=((inod-1)*nen+(jnod-1))*ndf^2;

	 if lumped,
       if inod==jnod, ter1 = (N(inod))/dt   ;else ter1=0; end
     else
       ter1 = (N(inod)+beta_supg*P1_pg(:,inod))*N(jnod)/dt   ;
    end
    ter20 = (velpg(:,1).*dshapex(:,jnod,1) + velpg(:,2).*dshapex(:,jnod,2));             
    if weak_form,
       ter2 = -(dshapex(:,inod,1).*velpg(:,1)+dshapex(:,inod,2).*velpg(:,2)).*N(jnod);
       ter2 = ter2 + P1_pg(:,inod).* ter20 ;              
    else
      ter2 = (N(inod)+P1_pg(:,inod)).* ter20;
    end
    
%    ter3 = (dshapex(:,inod,1).*dshapex(:,jnod,1) + ...
%            dshapex(:,inod,2).*dshapex(:,jnod,2)).* kappa_pg ;             
         
    ter3 = dshapex(:,inod,1).* ... 
	    (Kappa_pg(1,1).*dshapex(:,jnod,1)+Kappa_pg(1,2).*dshapex(:,jnod,2)) + ...
		    dshapex(:,inod,2).* ...
	    (Kappa_pg(2,1).*dshapex(:,jnod,1)+Kappa_pg(2,2).*dshapex(:,jnod,2)) ;
         
    ter4 = dshapex(:,inod,1).* ... 
	    (difu_anis(:,1).*dshapex(:,jnod,1)+difu_anis(:,2).*dshapex(:,jnod,2)) + ...
		    dshapex(:,inod,2).* ...
	    (difu_anis(:,3).*dshapex(:,jnod,1)+difu_anis(:,4).*dshapex(:,jnod,2)) ;
    
    
    ter5 = (N(inod)+P1_pg(:,inod))*N(jnod).*reac(eles)   ;
    
    Kele(eles,inod,1,jnod,1) = Kele(eles,inod,1,jnod,1) + ( ... 
              ter1+implicit_factor*(ter2+ter3+ter4+ter5)  ) .* xsj;
                           
    end  % jnod

   end % if ijob

    if lumped,
     ter1 = (N(inod)).*(Te(:,inod)-T0e(:,inod))/dt ;
	else
     ter1 = (N(inod)+beta_supg*P1_pg(:,inod)).*(Tpg-T0pg)/dt ;
  end
  ter20 = (velpg(:,1).*dTpg(:,1) + velpg(:,2).*dTpg(:,2));
   if weak_form,
      ter2 = -(dshapex(:,inod,1).*velpg(:,1)+dshapex(:,inod,2).*velpg(:,2)).*Tpg;
      ter2 = ter2 + P1_pg(:,inod).*ter20;
   else
     ter2 = (N(inod)+P1_pg(:,inod)).*ter20;                 
   end
%    ter3 = (dshapex(:,inod,1).*dTpg(:,1)+dshapex(:,inod,2).*dTpg(:,2)).*kappa_pg ;
    ter3 = (dshapex(:,inod,1).* ... 
	        (Kappa_pg(1,1).*dTpg(:,1)+Kappa_pg(1,2).*dTpg(:,2)) + ...
	         dshapex(:,inod,2).* ... 
	        (Kappa_pg(2,1).*dTpg(:,1)+Kappa_pg(2,2).*dTpg(:,2)) );
        
    ter4 = (dshapex(:,inod,1).* ... 
	        (difu_anis(:,1).*dTpg(:,1)+difu_anis(:,2).*dTpg(:,2)) + ...
	         dshapex(:,inod,2).* ... 
	        (difu_anis(:,3).*dTpg(:,1)+difu_anis(:,4).*dTpg(:,2)) );
        
        
    ter5 = (N(inod)+P1_pg(:,inod)).*source(eles) ;
	 ter6 = (N(inod)+P1_pg(:,inod)).*reac(eles).*Tpg ;
    Rele(eles,inod,1) = Rele(eles,inod,1) - (ter1+ter2+ter3+ter4+ter5+ter6) .* xsj;
	            							 
  end % inod

 end % ipg
  
