function [visco_dcdd] = comp_tau_rgn_bis(velpg,dshapex,grad_phi)
%
%   [visco_dcdd] = comp_tau_rgn(velpg,dshapex,grad_phi)
%
  
  limit = 1e-10;
  tol2  = 1e-2;
  [numel,nen,ndm] = size(dshapex);
  [bas,ndf,bas] = size(grad_phi);
  N = numel;
  veloc = velpg;
  
  eig_dcmp_function;
  
  for idm=1:ndm
     grad_phi_2(:,:,idm) = rowprod(S1,grad_phi(:,:,idm),ndf,ndf,1);
  end
  
  visco_dcdd = zeros(N,ndf,ndm,ndf,ndm);
  
  for idf=1:ndf,
     
  grad_phi = reshape(grad_phi_2(:,idf,:),N,ndm);     
     
  % "r" direction
  grad_phi_norm = sqrt(sum(grad_phi'.^2))';  
  mask          = grad_phi_norm<limit;
  grad_phi_norm = grad_phi_norm+limit*mask;  
  
  r = grad_phi ./ (grad_phi_norm*ones(1,ndm));
  
  h_rgn_star = zeros(numel,1);
  for inod=1:nen,
    h_rgn_star  = h_rgn_star + abs(r(:,1).*dshapex(:,inod,1)+r(:,2).*dshapex(:,inod,2));
  end
  
  h_rgn_star  = max([h_rgn_star';ones(1,numel)*limit])';
  h_rgn       = 2 ./ h_rgn_star;
  
  % "s" direction
  velmodpg = sqrt(sum(velpg'.^2))';
  mask     = velmodpg<limit;
  velmodpg = velmodpg+limit*mask;  
  s = velpg ./ (velmodpg*ones(1,ndm));
  
  r_dot_s = sum((r.*s)')';
  r_dot_s_square = r_dot_s.^2;
  r_dot_u = sum((r.*velpg)')';
  
  nu_dcdd = abs(r_dot_u).*h_rgn/2;
  
  grad_phi_norm_max = max(grad_phi_norm);
  
  mask = ((grad_phi_norm ./ grad_phi_norm_max)< tol2);  
  nn = find(mask==1);
  nu_dcdd(nn,:)= 0*nu_dcdd(nn,:);
  h_rgn(nn,:)  = 0*h_rgn(nn,:);  
  
  for idm=1:ndm,
     for jdm=1:ndm
            visco_dcdd(:,idf,idm,idf,jdm) = ...
                 nu_dcdd.*((r(:,idm).*r(:,jdm))-r_dot_s_square.*(s(:,idm).*s(:,jdm)));
     end
  end
  
end

for idm=1:ndm
   for jdm=1:ndm
      vaux = rowprod(S,reshape(visco_dcdd(:,:,idm,:,jdm),N,ndf,ndf),ndf,ndf,ndf);
      vaux = rowprod(vaux,S1,ndf,ndf,ndf);
      visco_dcdd(:,:,idm,:,jdm) = reshape(vaux,N,ndf,1,ndf,1);
   end
end
