%
% ------ Malla cuasi 1D ---------
% difusion no estacionaria
%

Nx       = 101;Lx=1;  
Ny       = 2;Ly=1/100;  
psi      = (0:Nx-1)'/(Nx-1);
x        = psi*Lx;
eta      = (0:Ny-1)'/(Ny-1)*1; 
y        = eta*Ly;

%-------- coordenadas (XNOD)
xnod     =[];
for k=1:Ny,
  xnod=[xnod;[x ones(Nx,1)*y(k)]];
end

%-------- conectividades (ICONE)
icone    =[];
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
ico2= [ (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' (1:Nx-1)'];
for k=1:Ny-1,
    icone=[icone; (k-1)*Nx+ico ];
end

% convertimos cuadrangulos en triangulos
quad2tri=0;

if quad2tri,
[numel,nen]=size(icone);

iconew=[];
for k=1:numel,
  vvv  = icone(k,:);
  ico  = Q2T(xnod(vvv,:));
  iconew = [iconew;vvv(ico(1,:));vvv(ico(2,:))];
end
icone=iconew;
end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;
nodes_bot  = (1:Nx);
nodes_top  = Nx*(Ny-1)+(1:Nx);
nodes_lef  = 1:Nx:Nx*Ny;
nodes_rig  = Nx:Nx:Nx*Ny;

fixa= zeros(numnp,ndf);
fixa(nodes_lef,1)=ones(length(nodes_lef),1);
%fixa(nodes_rig,1)=ones(length(nodes_rig),1);
%fixa(nodes_top,1)=ones(length(nodes_top),1);
%fixa(nodes_bot,1)=ones(length(nodes_bot),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc = zeros(numnp,ndf);
forc(nodes_lef,1)=ones(length(nodes_lef),1);

%-------- Fuentes de volumen (por elemento)
 xc=0;yc=0;
 factor = 1/nen;
 for kk=1:nen,
  xc = xc+factor*xnod(icone(:,kk),1);
  yc = yc+factor*xnod(icone(:,kk),2);
 end
 mask=(yc>0.1)&(yc<0.3);
 source = 0*mask;

%--------- Termino reactivo -----------------------------
reac = 0*ones(numel,1);

%--------- Campo de Velocidad -----------------------------
veloc  =  0*[ones(numnp,1) 0*sin(75*pi/180)*ones(numnp,1)];

%-------- Propiedades del material

 rho     = 1    ;
 Cp      = 1    ;
 kappa   = 1e+0 ;
 npg     =  2   ;
 prop(1) =rho   ;
 prop(2) =Cp    ;
 prop(3) =kappa ;
 prop(4) =npg   ;

 upwind  =    0 ;
 shocap  =    0 ;
 axisim  =    0 ;
% [1] SUPG
% [2] (SU+C)PG
 type_upw =   1 ;   
 lumped   =   0 ;

 prop(6)  = upwind ;
 prop(7)  = shocap ;
 prop(8)  = axisim ;
 prop(9)  = type_upw;
 prop(11) = lumped ;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)

eles    = (2*(Nx-1):Nx-1:(Nx-1)*(Ny-1))';
[numel,nen]=size(icone);
face    = 2*ones(size(eles));
val1    = 800*ones(size(eles));
val2    = 40*ones(size(eles));
%teco    = [eles face val1/rho/Cp val2 ];
teco     = [];

%-------- Condiciones periodicas
peri = [nodes_bot' nodes_top'];
peri = [];

%-------- Solucion inicial (PHI)
bini = zeros(numnp,ndf);

for k=1:ndf,
 nofree        = find(fixa(:,k)~=0);
 bini(nofree,k)   = forc(nofree,k);
end
