function [tau,delta] = supg_advdif_system(Upg,grad_phi,velmod,hele,shocap,type_upwind)
%
%  [tau,delta] = supg_advdif_system(Upg,grad_phi,velmod,hele,shocap,type_upwind)
%

tol = 1e-08;
tau_factor = 1.0;

[N,ndf]     = size(Upg);

if type_upwind==0,
   velmod  = max([velmod';tol*ones(1,N)])';  
   tau   = 0.5* hele ./ velmod;
   delta = 1.0*velmod.*hele/2;
elseif type_upwind==1,
   
   % luego poner algo diferente
   velmod  = max([velmod';tol*ones(1,N)])';  
   vaux   = 0.5* hele ./ velmod;
   for k=1:ndf
      tau(:,k,k)  = vaux;
   end
   delta = 1.0*velmod.*hele/2;

else
   error(' Bad type of upwind has been chosen')
end

