%
%   Ejemplo Cavidad cuadrada
%   Lee malla y campo de velocidad de un archivo
%


load sqcv1000;
Nx = 41; Ny = 41;
xmax = max(xnod(:,1));
ymax = max(xnod(:,2));
xmin = min(xnod(:,1));
ymin = min(xnod(:,2));
Lx = xmax-xmin;
Ly = ymax-ymin;


% convertimos cuadrangulos en triangulos
if quad2tri, quad_to_tri; end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;
nodes_bot  = (1:Nx);
nodes_top  = Nx*(Ny-1)+(1:Nx);
nodes_lef  = 1:Nx:Nx*Ny;
nodes_rig  = Nx:Nx:Nx*Ny;

fixa= zeros(numnp,ndf);
%fixa(nodes_lef,1)=ones(length(nodes_lef),1);
%fixa(nodes_rig,1)=ones(length(nodes_rig),1);
%fixa(nodes_top,1)=ones(length(nodes_top),1);
%fixa(nodes_bot,1)=ones(length(nodes_bot),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc = zeros(numnp,ndf);
%forc(nodes_top,1) = 50*ones(length(nodes_top),1);
%forc(nodes_lef,1) = 50*ones(length(nodes_lef),1);


%-------- Fuentes de volumen (por elemento)
 xc=0;yc=0;
 factor = 1/nen;
 for kk=1:nen,
  xc = xc+factor*xnod(icone(:,kk),1);
  yc = yc+factor*xnod(icone(:,kk),2);
 end
 mask=(yc>0.1)&(yc<0.3);
 source = 0*mask;

%--------- Termino reactivo -----------------------------
reac = 0*ones(numel,1);

%--------- Campo de Velocidad -----------------------------
 veloc = sqcv(:,1:2);
 clear sqcv;

%-------- Propiedades del material

 rho     = 1    ;
 Cp      = 1    ;
 kappa   = 1e-03; kappa = 1e-01;
 npg     =  2   ;
 prop(1) =rho   ;
 prop(2) =Cp    ;
 prop(3) =kappa ;
 prop(4) =npg   ;

 upwind  =    1 ;
 shocap  =    0 ;
 axisim  =    0 ;
% [1] SUPG
% [2] (SU+C)PG
 type_upw =    1;   
 lumped   =   0 ;

 prop(6)  = upwind ;
 prop(7)  = shocap ;
 prop(8)  = axisim ;
 prop(9)  = type_upw;
 prop(11) = lumped ;

%-------- Cargas repartidas (STRG)

strg  = [ ...
   42.0000   63.0000   -0.5108   -0.4625
   63.0000   84.0000   -0.4625   -0.4254
  420.0000  441.0000   -0.1187   -0.1055 ];

strg    = [];

%-------- Condiciones de contorno mixtas (TECO)

%eles    = (2*(Nx-1):Nx-1:(Nx-1)*(Ny-1))';
eles    = (4*(Nx-1):Nx-1:(Nx-1)*(Ny-1))';
eles = [ ...
        1523           3;
        1524           3;
        1527           3;
        1528           3;
        1531           3;
        1532           3;
        1535           3;
        1536           3;
        1539           3;
        1540           3;
        1543           3;
        1544           3;
        1547           3;
        1548           3;
        1551           3;
        1552           3;
        1555           3;
        1556           3;
        1559           3;
        1560           3;
        1563           3;
        1564           3;
        1567           3;
        1568           3;
        1571           3;
        1572           3;
        1575           3;
        1576           3;
        1579           3;
        1580           3;
        1583           3;
        1584           3;
        1587           3;
        1588           3;
        1591           3;
        1592           3;
        1595           3;
        1596           3;
        1599           3;
        1600           3];

[numel,nen]=size(icone);
val1    = 100*ones(size(eles,1),1);
val2    = 40*ones(size(eles,1),1);
teco     = [];
teco    = [eles val1/rho/Cp val2 ];

%-------- Condiciones periodicas
peri = [nodes_bot' nodes_top'];
peri = [];

%-------- Solucion inicial (PHI)
bini = 100*ones(numnp,ndf);

%mask = (xnod(:,1)>0.3)&(xnod(:,1)<0.5)&(xnod(:,2)>-0.5)&(xnod(:,2)<0);
%nn   = find(mask==1);
%bini(nn) = ones(length(nn),1);
for k=1:ndf,
 nofree        = find(fixa(:,k)~=0);
 bini(nofree,k)   = forc(nofree,k);
end
