%
%   Ejemplo uso de condicion de contorno convectiva
%

Nx       = 21;Lx=1;  
Ny       = 21;Ly=1; 
psi      = (0:Nx-1)'/(Nx-1);
x        = psi*Lx;
eta      = (0:Ny-1)'/(Ny-1)*1; 
y0       = 0;
y        = eta*Ly+y0;

%-------- coordenadas (XNOD)
xnod     =[];
for k=1:Ny,
  xnod=[xnod;[x ones(Nx,1)*y(k)]];
end

%-------- conectividades (ICONE)
icone    =[];
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
ico2= [ (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' (1:Nx-1)'];
for k=1:Ny-1,
    icone=[icone; (k-1)*Nx+ico ];
end

% convertimos cuadrangulos en triangulos
quad2tri=1;
if quad2tri, quad_to_tri; end

xmin = min(xnod); xmax=max(xnod);

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;
nodes_bot  = (1:Nx);
nodes_top  = Nx*(Ny-1)+(1:Nx);
nodes_lef  = 1:Nx:Nx*Ny;
nodes_rig  = Nx:Nx:Nx*Ny;

mask = xnod(nodes_rig,2)>(xmin(2)+0.25*(xmax(2)-xmin(2)));
nnn  = find(mask==1);
[ifaceb,icone_bou] = pfbou2d(xnod,icone,1);
nn = get_eles_by_nodes(nodes_rig(nnn),icone_bou,1);
eles_rig = ifaceb(nn,1);

fixa= zeros(numnp,ndf);
%fixa(nodes_rig,1)=ones(length(nodes_rig),1);
mask = xnod(nodes_bot,1)>(xmin(1)+0.25*(xmax(1)-xmin(1)));
nn   = find(mask==1);
fixa(nodes_bot(nn),1)=ones(length(nodes_bot(nn)),1);
fixa(nodes_bot,1)=ones(length(nodes_bot),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc = zeros(numnp,ndf);
%forc(nodes_rig,1) = 0.5*ones(length(nodes_rig),1);
forc(nodes_bot,1) = 100*ones(length(nodes_bot),1);
%forc(nodes_bot(nn),1) = ones(length(nodes_bot(nn)),1);

%-------- Fuentes de volumen (por elemento)
 xc=0;yc=0;
 factor = 1/nen;
 for kk=1:nen,
  xc = xc+factor*xnod(icone(:,kk),1);
  yc = yc+factor*xnod(icone(:,kk),2);
 end
 mask=(yc>0.1)&(yc<0.3);
 source = 0*mask;

%--------- Termino reactivo -----------------------------
reac = 0*ones(numel,1);

%--------- Campo de Velocidad -----------------------------
% veloc  =  [cos(75*pi/180)*ones(numnp,1) sin(75*pi/180)*ones(numnp,1)];
% veloc  =  [ 1-(xnod(:,2)/Ly).^2 , 0*xnod(:,2) ];
 veloc  =  [0.*ones(numnp,1) 10*ones(numnp,1)];

%-------- Propiedades del material

 rho     = 1    ;
 Cp      = 1    ;
 kappa   = 1e-02;
 npg     =  2   ;
 prop(1) =rho   ;
 prop(2) =Cp    ;
 prop(3) =kappa ;
 prop(4) =npg   ;

 tau_fac =    1 ;
 shocap  =    0 ;
 axisim  =    0 ;
% [1] SUPG
% [2] (SU+C)PG
 type_upw =    1;   
 lumped   =   0 ;

 prop(6)  = tau_fac ;
 prop(7)  = shocap ;
 prop(8)  = axisim ;
 prop(9)  = type_upw;
 prop(11) = lumped ;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
eles    = eles_rig;
face    = 2*ones(size(eles));
val1    = 1*ones(size(eles));
val2    = 40*ones(size(eles));
teco    = [eles face val1/rho/Cp val2 ];

% Restricciones lineales ----> Condiciones periodicas
lin_con = [];

%-------- Solucion inicial (PHI)
bini = zeros(numnp,ndf);

for k=1:ndf,
 nofree        = find(fixa(:,k)~=0);
 bini(nofree,k)   = forc(nofree,k);
end
