function [Lv]=valve_0_lift_valve(theta,props)
%
%      Lv = valve_0_lift_valve(theta,[theta_VO,theta_VC,Lvmax])
%
%   Valve lift with theta in radians
%   

theta_VO = props(1);
theta_VC = props(2);
Lvmax = props(3);

theta = rem(theta,4*pi);

if 0,
angle = (theta-theta_VO)/(theta_VC-theta_VO);
Lv = Lvmax*sin(pi*angle).^2;
mask = (theta>theta_VO)&(theta<theta_VC);
Lv = Lv.*mask;
else
    if theta_VO <0, 
        theta_VO=theta_VO+4*pi; 
        is_open = ((theta>theta_VC)&(theta<theta_VO))==0; 
    else
        if theta_VC > theta_VO,
            is_open = (theta>theta_VO)&(theta<theta_VC);        
        else
            is_open = ((theta>theta_VC)&(theta<theta_VO))==0; 
        end        
    end    
    dangle = theta_VC-theta_VO;
    angle  = theta-theta_VO;
    if angle < 0 , angle = 4*pi+theta-theta_VO;end
    if dangle < 0 , dangle = 4*pi+theta_VC-theta_VO ; end 
    alfa  = angle/dangle*pi;
    Lv    = is_open*Lvmax*sin(alfa)^2; 
end
