function [Kxx,Kxy,Kyx,Kyy] = Djac_2D(Up,prop)
%
%  [Kxx,Kxy,Kyx,Kyy] = Djac_2D(UP,prop)
%

alpha_g_ctf = 1e-5;

[N,ndf]     = size(Up);    

rho_g       = prop(1);
visco_g     = prop(2);

alpha_g     = Up(:,1);
vel_g       = Up(:,2:3);

alpha_g     = max([alpha_g_ctf*ones(1,N);alpha_g'])';

vaux        = (1-alpha_g)*visco_g;
%vaux        = alpha_g*visco_g;
  
delta       = eye(2);
uno_1       = [1;0];
uno_2       = [0;1];
Kxx         = zeros(N,ndf,ndf);
Kxy         = zeros(N,ndf,ndf);
Kyx         = zeros(N,ndf,ndf);
Kyy         = zeros(N,ndf,ndf);

tmp_xx = (delta(1,1)*eye(2)+uno_1*uno_1');
tmp_xy = (delta(1,2)*eye(2)+uno_2*uno_1');
tmp_yx = (delta(2,1)*eye(2)+uno_1*uno_2');
tmp_yy = (delta(2,2)*eye(2)+uno_2*uno_2');

for j=1:2
   for k=1:2,
      Kxx(:,j+1,k+1)  = vaux*tmp_xx(j,k);
      Kxy(:,j+1,k+1)  = vaux*tmp_xy(j,k);
      Kyx(:,j+1,k+1)  = vaux*tmp_yx(j,k);
      Kyy(:,j+1,k+1)  = vaux*tmp_yy(j,k);      
   end
end

