function [Fa,Ax,Ay] = Flux_function(Up,prop)
%
%            [Fa,Ax,Ay] = Flux_function(Up,prop)
%
%       Computes advective fluxes F_a
%                   2D    
%	 Dimension of Fa array = numnp x ndm*ndf 
%             

ndm         = 2;
rho_g       = prop(1);
visco_g     = prop(2);
[N,ndf]     = size(Up);
alpha_g     = Up(:,1);
vel_g       = Up(:,2:3);

% advective fluxes
Fa            = zeros(N,ndf,2);
Fa(:,1,1:2)   = rho_g*(alpha_g*[1,1]).*vel_g;
Fa(:,2,1)     = rho_g*alpha_g.*vel_g(:,1).*vel_g(:,1);
Fa(:,3,1)     = rho_g*alpha_g.*vel_g(:,1).*vel_g(:,2);
Fa(:,2,2)     = rho_g*alpha_g.*vel_g(:,2).*vel_g(:,1);
Fa(:,3,2)     = rho_g*alpha_g.*vel_g(:,2).*vel_g(:,2);

A             = zeros(N,ndm,ndf,ndf);
A(:,1:2,1,1)  = rho_g*vel_g;
A(:,1,1,2)    = rho_g*alpha_g;
A(:,2,1,3)    = rho_g*alpha_g;
A(:,1,2,1)    = rho_g*vel_g(:,1).*vel_g(:,1);
A(:,1,3,1)    = rho_g*vel_g(:,2).*vel_g(:,1);
A(:,2,2,1)    = rho_g*vel_g(:,1).*vel_g(:,2);
A(:,2,3,1)    = rho_g*vel_g(:,2).*vel_g(:,2);

A(:,1,2,2)    = rho_g*alpha_g.*(vel_g(:,1)+vel_g(:,1));
A(:,1,3,2)    = rho_g*alpha_g.* vel_g(:,2);
A(:,1,3,3)    = rho_g*alpha_g.* vel_g(:,1);

A(:,2,2,2)    = rho_g*alpha_g.* vel_g(:,2);
A(:,2,2,3)    = rho_g*alpha_g.* vel_g(:,1);
A(:,2,3,3)    = rho_g*alpha_g.*(vel_g(:,2)+vel_g(:,2));

Ax         = reshape(A(:,1,:,:),N,ndf,ndf);
Ay         = reshape(A(:,2,:,:),N,ndf,ndf);      
