function [Kg,Rg] = bubbly_2D(xnod,icone,fixa,forc,teco,lin_con,extra_nodal_fields,prop,...
                       ifaceb,Up,Upold,ijob)                       
%------------------------------------------------------------------
%
%  TWO PHASE FLOW APPLICATIONS
%
%  only for the gas phase, the liquid is fixed to a prescribed pressure and
%  velocity field
%
%  state vector = [alpha_g ; vel_g ]
%
%------------------------------------------------------------------

global row col

%%%%%%%%%%%%%% PROPIEDADES DEL MATERIAL 
  rho_g    = prop(1) ;
  visco_g  = prop(2) ;
  gravity  = prop(3) ;
  npg      = prop(4) ;
  shocap   = prop(7) ;
  axisim   = prop(8) ;
  tol      = prop(12);
  dt       = prop(13);
  weak_form= prop(5) ;
  tol_upw  = prop(10);
  Cou      = prop(6);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  U    = Up;
  Uold = Upold;

  [numel,nen]   = size(icone);
  [numnp,ndf]   = size(U);
  if ndf~=3, error(' NDF debe ser 3 (gas phase bubbly in 2D) ');end
  ndm = 2;

  if ndm==1,
     pgauss1d;
  elseif ndm==2, 
     pgauss2d; 
  elseif ndm==3,
     pgauss3d; 
  end

  Rele = zeros(numel,nen,ndf);
  Mele = zeros(numel,nen,ndf,nen,ndf);
  
  Rg    = 0*forc;
  eles  = (1:numel)';
  ceros = zeros(length(eles),nen);
      
  if length(eles)>0,    
    bubbly_2d_ele;
  end

% Gather contributions from eles to nodes
%------------------------------------------------------------------
  [Rg,Kg] = gather(Rele,Mele,icone,nen,ndf);
  
% Linear restrictions
%------------------------------------------------------------------
  if isempty(lin_con)==0,[Rg,Kg] = linear_constraint(Rg,Kg,lin_con,ndf);end
