function [H,Cp] = enthalpy_function(Up,prop)
%
%      [H,Cp] = enthalpy_function(Up,prop)
%
%       Computes enthalpy function to handle primitive variables
%       in 2D 
%

[N,ndf]     = size(Up);
rho_g       = prop(1);
alpha_g     = Up(:,1);
vel_g       = Up(:,2:3);

H            = [alpha_g,(alpha_g*[1,1]).*vel_g];
Cp           = zeros(N,ndf,ndf);
Cp(:,1,1)    = rho_g*ones(N,1);
Cp(:,2:3,1)  = rho_g*vel_g;
Cp(:,2,2)    = rho_g*alpha_g;
Cp(:,3,3)    = rho_g*alpha_g;

