function [V,D,V1]=get_eig_dcmp(Upg,ijob,tol)
%
%  [V,D,V1]=get_eig_dcmp(Upg,ijob,tol)
%

[N,ndf] = size(Upg);
alpha_g = Upg(:,1);
vel_g   = Upg(:,2:3);
beta_0  = alpha_g;
beta_p  = (alpha_g+1/2+1/2*sqrt(4*alpha_g.^2+1));
beta_m  = (alpha_g+1/2-1/2*sqrt(4*alpha_g.^2+1));    
deno = sqrt(4*alpha_g.^2+1);
vaux_x = 2*alpha_g-1+deno;   
vaux_y = 2*alpha_g-1-deno;    

if ijob==1,
   % eigenvalues of Ax
   Dx = zeros(N,ndf,ndf);
   Dx(:,1,1) = beta_p.*vel_g(:,1);
   Dx(:,2,2) = beta_m.*vel_g(:,1);
   Dx(:,3,3) = beta_0.*vel_g(:,1);    
   % eigenvectors of Ax
   Vx = zeros(N,ndf,ndf);    
   Vx(:,1,1) = (beta_p-2*alpha_g)./vel_g(:,1);
   Vx(:,1,2) = (beta_m-2*alpha_g)./vel_g(:,1);
   Vx(:,2,1) = ones(N,1);
   Vx(:,2,2) = ones(N,1);
   Vx(:,3,3) = ones(N,1);    
   Vx(:,3,1) = vel_g(:,2)./vel_g(:,1); 
   Vx(:,3,2) = vel_g(:,2)./vel_g(:,1);    
   % inverse of eigenvectors of Ax
   Vx1 = zeros(N,ndf,ndf);    
   Vx1(:,1,1) = vel_g(:,1)./deno;
   Vx1(:,2,1) = -vel_g(:,1)./deno;
   Vx1(:,1,2) = 0.5*vaux_x./deno;
   Vx1(:,2,2) = -0.5*vaux_y./deno;      
   Vx1(:,3,2) = -vel_g(:,2)./vel_g(:,1);
   Vx1(:,3,3) = ones(N,1);   
   V  = Vx;
   D  = Dx;
   V1 = Vx1;
end
if ijob==2,
   % eigenvalues of Ay
   Dy = zeros(N,ndf,ndf);       
   % eigenvectors of Ay and the inverse
   Vy = zeros(N,ndf,ndf);
   Vy1 = zeros(N,ndf,ndf);    
   
   nn = find(abs(vel_g(:,1))>=tol);
   if isempty(nn)==0,   
   Dy(nn,1,1) = beta_p(nn).*vel_g(nn,2);
   Dy(nn,2,2) = beta_m(nn).*vel_g(nn,2);
   Dy(nn,3,3) = beta_0(nn).*vel_g(nn,2);           
   Vy(nn,1,1) = (beta_p(nn)-2*alpha_g(nn))./vel_g(nn,1);
   Vy(nn,1,2) = (beta_m(nn)-2*alpha_g(nn))./vel_g(nn,1);
   Vy(nn,2,1) = ones(length(nn),1);
   Vy(nn,2,2) = ones(length(nn),1);
   Vy(nn,2,3) = ones(length(nn),1);
   Vy(nn,3,1) = vel_g(nn,2)./vel_g(nn,1); 
   Vy(nn,3,2) = vel_g(nn,2)./vel_g(nn,1);    
   Vy1(nn,1,1) = vel_g(nn,1)./deno(nn);
   Vy1(nn,2,1) = -vel_g(nn,1)./deno(nn);  
   Vy1(nn,3,2) = ones(length(nn),1);   
   Vy1(nn,1,3) = 0.5*vaux_x(nn)./deno(nn).*vel_g(nn,1)./vel_g(nn,2);
   Vy1(nn,2,3) = -0.5*vaux_y(nn)./deno(nn).*vel_g(nn,1)./vel_g(nn,2);   
   Vy1(nn,3,3) = -vel_g(nn,1)./vel_g(nn,2);   
   end

   nn = find(abs(vel_g(:,1))<tol);
   if isempty(nn)==0,
   Dy(nn,1,1) = beta_0(nn).*vel_g(nn,2);
   Dy(nn,2,2) = beta_p(nn).*vel_g(nn,2);
   Dy(nn,3,3) = beta_m(nn).*vel_g(nn,2);                  
   Vy(nn,2,1) = ones(length(nn),1);
   Vy(nn,3,2) = ones(length(nn),1);
   Vy(nn,3,3) = ones(length(nn),1);
   Vy(nn,1,2) = -0.5*vaux_y(nn)./vel_g(nn,2);
   Vy(nn,1,3) = -0.5*vaux_x(nn)./vel_g(nn,2);   
   
   Vy1(nn,1,2) =  ones(length(nn),1);
   Vy1(nn,2,1) =  vel_g(nn,2)./deno(nn);
   Vy1(nn,3,1) = -vel_g(nn,2)./deno(nn);
   Vy1(nn,2,3) =  0.5*vaux_x(nn)./deno(nn);
   Vy1(nn,3,3) = -0.5*vaux_y(nn)./deno(nn);   
   end

   V  = Vy;
   D  = Dy;
   V1 = Vy1;
   
end   