syms alfa rho_l rho_g u_l v_l w_l u_g v_g w_g p kappa epsilon
syms tau_1 tau_2 tau_3
syms p_xx alfa_xx u_l_xx v_l_xx u_g_xx v_g_xx
syms p_xy alfa_xy u_l_xy v_l_xy u_g_xy v_g_xy
syms p_yx alfa_yx u_l_yx v_l_yx u_g_yx v_g_yx
syms p_yy alfa_yy u_l_yy v_l_yy u_g_yy v_g_yy
syms b_x b_y b_z
syms n_x n_y n_z
syms U_1 U_2 U_3
syms C_drag

rho_g = subs(rho_g,1);
%u_g = subs(u_g,0);


ndim =2;

if ndim==3,
vel_l=[u_l;v_l;w_l];
vel_g=[u_g;v_g;w_g];
body_f = [b_x;b_y;b_z];
no = [n_x;n_y;n_z];
vel_l_T=reshape(vel_l,1,3);
vel_g_T=reshape(vel_g,1,3);
else
vel_l=[u_l;v_l];
vel_g=[u_g;v_g];
body_f = [b_x;b_y];
no = [n_x;n_y];
vel_l_T=reshape(vel_l,1,2);
vel_g_T=reshape(vel_g,1,2);
end

% alfa es la fraccion de gas
U = [alfa;vel_g];
%U = [U_1;U_2;U_3];

Fa = [    alfa *rho_g*vel_g_T ;
          alfa *rho_g*vel_g*vel_g_T];

%Fa = [    U_2 , U_3 ;
%    U_2*U_2/U_1 , U_2*U_3/U_1 ; 
%    U_3*U_2/U_1 , U_3*U_3/U_1 ];

A_1 = jacobian(Fa(:,1),U);
A_2 = jacobian(Fa(:,2),U);
A_n = A_1*n_x+A_2*n_y;
if ndim==3,
    A_3 = jacobian(Fa(:,3),U);
    A_n = A_n+A_3*n_z;
end

%A_n=simple(subs(subs(subs(A_n,U_1,rho_g*alfa),U_2,rho_g*alfa*u_g),U_3,rho_g*alfa*v_g));

G = [ 0; alfa*body_f];
dGdU = jacobian(G,U);

H = [ alfa*rho_g ,alfa*rho_g*vel_g_T];       
dHdU = jacobian(H,U);

F_drag = [0;C_drag*alfa*(vel_l-vel_g)];
dF_dragdU = jacobian(F_drag,U);

[Vn,Dn]=eig(A_n);

[V1,D1]=eig(A_1);
A_1_u0=subs(A_1,u_g,0);
A_1_v0=subs(A_1,v_g,0);
A_1_alfa0=subs(A_1,alfa,0);
[V1_u0,D1_u0]=eig(A_1_u0);
[V1_v0,D1_v0]=eig(A_1_v0);
[V1_alfa0,D1_alfa0]=eig(A_1_alfa0);

[V2,D2]=eig(A_2);
A_2_u0=subs(A_2,u_g,0);
A_2_v0=subs(A_2,v_g,0);
A_2_alfa0=subs(A_2,alfa,0);
[V2_u0,D2_u0]=eig(A_2_u0);
[V2_v0,D2_v0]=eig(A_2_v0);
[V2_alfa0,D2_alfa0]=eig(A_2_alfa0);


return