function [Rg,Kg] = linear_constraint(Rg,Kg,lin_con,ndf)
%
%  [Rg,Kg] = linear_constraint(Rg,Kg,lin_con,ndf)
%

lin_con=sort_lin_con(lin_con);

[nr,nc]=size(lin_con);

if rem(nc,3)~=0, error(' lin_con array is corrupted [00] '); end
nnod  = nc/3;
if nnod<2,  error(' lin_con array is corrupted [01]'); end

coef1 = lin_con(:,1);
node1 = lin_con(:,2);
dof1  = lin_con(:,3);

row=(node1-1)*ndf+dof1;
col=row;
coe=ones(nr,1);

for k=2:nnod
   coef = lin_con(:,1+3*(k-1));
   node = lin_con(:,2+3*(k-1));
   dof  = lin_con(:,3+3*(k-1));
   row=[row;(node1-1)*ndf+dof1];
   col=[col;(node-1)*ndf+dof];
   coe=[coe;coef./coef1];
end

nr = length(row);
[row0,col0,coe0]=find(Kg);

for ir=1:nr
   nn=find(row0==row(ir));
   coe0(nn)=0;   
   Rg(row(ir),1)=0;
end

Kg = sparse([row0;row],[col0;col],[coe0;coe]);
%Rg    = [Rg;zeros(nr,1)];

