function [fsol,dfsdT] = frsol1(T,C,Tm,slope_l,kp)
%
%  calcula la fraccion solida
%

slope_s = slope_l/kp ; 
Tsol    =   Tm+slope_s*C;
Tliq    =   Tm+slope_l*C;

leverrule = 1;

if leverrule, 

% Regla de la palanca
%-------------------------------------------
mask = abs(T-Tm) < 1e-10 ;
deno = 1e-10*(mask==1)+(T-Tm).*(mask==0);

fsol    = 1/(1-kp)*(1-slope_l*C ./ deno); 
mask    = (fsol<1 & fsol >0);
dfsdT   = mask .* (slope_l * C ./ deno.^2 / (1-kp));

else

% Relacion lineal
%-------------------------------------------
fsol    = (T-Tliq)./(Tsol-Tliq);   
mask    = (fsol<1 & fsol >0);
dfsol   = mask ./  (Tsol-Tliq); 

end

fsol    = fsol .* (fsol<1 & fsol >0) ;
fsol    = fsol  + (T<=Tsol) ;



