%
%            KyR_ele
%
%  Calcula constribuciones elementales a la matriz K y al vector R
%

  lumping = 0;
  P1_pg=[]; P2_pg=[];

  kappa_pg      = (kappa_s * fspg + kappa_l *(1-fspg))/rho/Cp; 
%  Dm_l_c        = Dm_l + Dm_l_turb*(fspg<1e-6);
  Dm_l_c        = Dm_l + Dm_l_turb*fspg.^2;
  Dm_pg         = Dm_l_c/kp + (Dm_s-Dm_l_c/kp) .* fspg ;

  vel_supg      = velpg - 0*DeltaH/Cp*dfsdTpg*U0*[0 1];
  [hele]        = h_supg(vel_supg,dNdx0,dNdy0);
  velmod        = sqrt(sum(vel_supg'.^2))';
  mask          = (velmod<1e-10);
  if nen0==4, hele = mask.*(sqrt(4.0*Jaco0/pi))+(1-mask).*hele;end
  if nen0==3, hele = mask.*(sqrt(0.5*Jaco0/pi))+(1-mask).*hele;end
  [tau1_pg]     = upwind*supg2(vel_supg,hele,kappa_pg);

  vel_supg      = velpg + 1*(mushy*ones(1,2)) .* ( ... 
           (velpg-ones(length(velpg(:,1)),1)*[ 0 U0]).*((dCsdCpg-1)*ones(1,2)) );
  [hele]        = h_supg(vel_supg,dNdx0,dNdy0);
  velmod        = sqrt(sum(vel_supg'.^2))';
  mask          = (velmod<1e-10);
  if nen0==4, hele = mask.*(sqrt(4.0*Jaco0/pi))+(1-mask).*hele;end
  if nen0==3, hele = mask.*(sqrt(0.5*Jaco0/pi))+(1-mask).*hele;end
  [tau2_pg]     = upwind*supg2(vel_supg,hele,Dm_pg.*dCsdCpg);

  
  for inod=1:nen,
   vel_supg      = velpg - 0*DeltaH/Cp*dfsdTpg*U0*[0 1];
   P1_pg(:,inod) = tau1_pg .* ... 
    ( vel_supg(:,1) .*dNdx(:,inod) + vel_supg(:,2) .*dNdy(:,inod) );

   vel_supg      = velpg + 1*(mushy*ones(1,2)) .* ( ... 
           (velpg-ones(length(velpg(:,1)),1)*[ 0 U0]).*((dCsdCpg-1)*ones(1,2)) );
   P2_pg(:,inod) = tau2_pg .* ... 
    ( vel_supg(:,1) .*dNdx(:,inod) + vel_supg(:,2) .*dNdy(:,inod) );

   if shocap==1,

    if lmushy==1, error(' Shock capturing + lmushy Not implemented yet ');end

% estrategia # 1
    deno = (dCpg(:,1).^2+dCpg(:,2).^2);
    mask = (sqrt(deno)>1e-10);
    deno = deno + (1-mask)*1e-10;
    vel_sc =  mask .* RgCpg ./  deno ;
    vel_sc =  [dCpg(:,1).*vel_sc dCpg(:,2).*vel_sc ];
% estrategia # 2
%    vel_sc = - Dm_l/(1-kp) ./(Tpg-Tm); 
%    vel_sc = [vel_sc vel_sc];
%    vel_sc = vel_sc .*dTpg;
    
    [tau3_pg]     = upwind*supg2(vel_sc,hele,zeros(size(Dm_pg)));
%    [tau3_pg]      = upwind*supg2(vel_sc,hele,Dm_pg.*dCsdCpg);
     
    P3_pg(:,inod) = mushy.*tau3_pg .* ...
     ( vel_sc(:,1) .*dNdx(:,inod) + vel_sc(:,2) .*dNdy(:,inod) );

    P2_pg(:,inod) = P2_pg(:,inod)+P3_pg(:,inod) ; 
   end
  end 

%disp(' en KyR ')
%keyboard;
%pause

% armado matriz tangente elemental y vector residuo
%------------------------------------------------------------------
  for inod=1:nen,
   if ijob==0,

% Matriz tangente para el balance de energia
%--------------------------------------------------------------------

   if lumping,
     ip=((inod-1)*nen+(inod-1))*ndf^2;
     Kelet(:,ip+1) = Kelet(:,ip+1) + ( ... 
     (N(inod)+P1_pg(:,inod))*1/dt - ... 
     (N(inod)+P1_pg(:,inod)).*(DeltaH/Cp*dfsdTe(:,inod)).*(1/dt) ...
                               ) * wpg(ipg) .* Jaco;
   end

    for jnod=1:nen,
     ip=((inod-1)*nen+(jnod-1))*ndf^2;
     Kelet(:,ip+1) = Kelet(:,ip+1) + ( ... 
     (N(inod)+P1_pg(:,inod))*(1-lumping)*N(jnod)/dt    + ...
     (N(inod)+P1_pg(:,inod)).*velpg(:,1).*dNdx(:,jnod) + ...
     (N(inod)+P1_pg(:,inod)).*velpg(:,2).*dNdy(:,jnod) + ...
     (dNdx(:,inod).*dNdx(:,jnod) + ... 
         dNdy(:,inod).*dNdy(:,jnod)).* kappa_pg + ... 
     (dNdx(:,inod).*dTpg(:,1)+dNdy(:,inod).*dTpg(:,2)).* ...
          ((kappa_s-kappa_l)/rho/Cp*dfsdTe(:,jnod))*N(jnod) - ... 
     (N(inod)+0*P1_pg(:,inod)).*(DeltaH/Cp*dfsdTe(:,jnod)) .* ... 
       (U0*dNdy(:,jnod)+(1-lumping)*N(jnod)/dt) ...
                               ) * wpg(ipg) .* Jaco;
    end  % jnod

% Matriz tangente para el balance de soluto
%--------------------------------------------------------------------

   for jnod=1:nen,
     Difu = Dm_pg .* dCsdCe(:,jnod);
     ip=((inod-1)*nen+(jnod-1))*ndf^2;
     Kelet(:,ip+4) = Kelet(:,ip+4) + ( ... 
     (N(inod)+P2_pg(:,inod))*N(jnod)/dt    + ...
     (N(inod)+P2_pg(:,inod)).*velpg(:,1).*dNdx(:,jnod) + ...
     (N(inod)+P2_pg(:,inod)).*velpg(:,2).*dNdy(:,jnod) + ...
     (dNdx(:,inod).*dNdx(:,jnod) + ... 
             dNdy(:,inod).*dNdy(:,jnod)).* Difu + ... 
     (dNdx(:,inod).*dCspg(:,1) + dNdy(:,inod).*dCspg(:,2))  ... 
       .* (Dm_s-Dm_l/kp)*N(jnod) .* dfsdCe(:,jnod) + ... 
      (N(inod)+P2_pg(:,inod)).*(dCsdCe(:,jnod)/kp-1) .* ...
    mushy.* (velpg(:,1).*dNdx(:,jnod)+(velpg(:,2)-U0).*dNdy(:,jnod)) ...
                                         ) * wpg(ipg) .* Jaco;
    end % jnod

% Matriz tangente para el acoplamiento soluto-energia
%--------------------------------------------------------------------

   for jnod=1:nen,
     ip=((inod-1)*nen+(jnod-1))*ndf^2;
     Kelet(:,ip+2) = Kelet(:,ip+2) + ( ... 
     (dNdx(:,inod).*dTpg(:,1) + dNdy(:,inod).*dTpg(:,2))  ... 
       .* (kappa_s-kappa_l)/rho/Cp .* dfsdCe(:,jnod) *N(jnod) - ... 
    (N(inod)+P1_pg(:,inod)).*(DeltaH/Cp*dfsdCe(:,jnod)).* ... 
       (U0*dNdy(:,jnod)+N(jnod)/dt)  ...
                                         ) * wpg(ipg) .* Jaco;
     Kelet(:,ip+3) = Kelet(:,ip+3) + ( ... 
     (dNdx(:,inod).*dCspg(:,1) + dNdy(:,inod).*dCspg(:,2))  ... 
       .* (Dm_s-Dm_l/kp)*N(jnod) .* dfsdTe(:,jnod) + ... 
     (dNdx(:,inod).*dNdx(:,jnod) + dNdy(:,inod).*dNdy(:,jnod)) ... 
             .* Dm_pg .* dCsdTe(:,jnod) - ... 
     (N(inod)+P2_pg(:,inod)).*(dCsdTe(:,jnod)/kp) .* ...
     (velpg(:,1).*dNdx(:,jnod)+(velpg(:,2)-U0).*dNdy(:,jnod)) ...
                                         ) * wpg(ipg) .* Jaco;
    end % jnod

   end % if ijob

% residuo del balance de energia
%-----------------------------------------------------------

   Relet(:,(inod-1)*ndf+1) = Relet(:,(inod-1)*ndf+1) - ( ...
      (N(inod)+P1_pg(:,inod)).*(1-lumping).*(Tpg-Toldpg)/dt          + ...
      (N(inod)+P1_pg(:,inod)).*lumping.*(Te(:,inod)-Tolde(:,inod))/dt          + ...
      (N(inod)+P1_pg(:,inod)).*velpg(:,1).*dTpg(:,1)    + ...
      (N(inod)+P1_pg(:,inod)).*velpg(:,2).*dTpg(:,2)    + ...
  (dNdx(:,inod).*dTpg(:,1)+dNdy(:,inod).*dTpg(:,2)).*kappa_pg - ...
      (N(inod)+0*P1_pg(:,inod)).*(DeltaH/Cp*(U0.*dfspg(:,2))) - ...
      (N(inod)+P1_pg(:,inod)).* ((1-lumping)*DeltaH/Cp*(fspg-fsoldpg)/dt) - ...
 (N(inod)+P1_pg(:,inod)).* (lumping*DeltaH/Cp*(fsole(:,inod)-fsololde(:,inod))/dt)  ...
                   ) * wpg(ipg) .* Jaco ;
                                 

% residuo del balance de soluto
%-----------------------------------------------------------

   Relet(:,(inod-1)*ndf+2) = Relet(:,(inod-1)*ndf+2) - ( ...
      (N(inod)+P2_pg(:,inod)).*(Cpg-Coldpg)/dt          + ...
      (N(inod)+P2_pg(:,inod)).*velpg(:,1).*dCpg(:,1)    + ...
      (N(inod)+P2_pg(:,inod)).*velpg(:,2).*dCpg(:,2)    + ...
     (dNdx(:,inod).*dCspg(:,1)+dNdy(:,inod).*dCspg(:,2)).*Dm_pg +  ...
     (N(inod)+P2_pg(:,inod)) .* mushy.* ( ...
       (dCspg(:,1)/kp-dCpg(:,1)).*velpg(:,1) + ...
       (dCspg(:,2)/kp-dCpg(:,2)).*(velpg(:,2)-U0) ) ...
                                  ) * wpg(ipg) .* Jaco ;

  end % inod

