function iconew = P2T(x)
%
%  Funcion que convierte un pentagono en tres triangulos
%  considerando como criterio de eleccion la maximizacion
%  de la relacion entre la minima y maxima longitud de arista
%

% las 5 particiones posibles (Pt)
Pt = [ 1 2 3 5 ; 3 4 5 0 ;
       2 3 4 5 ; 1 2 5 0 ;
       3 4 5 1 ; 1 2 3 0 ;
       4 5 1 2 ; 2 3 4 0 ;
       1 2 3 4 ; 4 5 1 0  ];

rlsmax = -1e10;

for k=1:5,
  icoq   = Pt((k-1)*2+1,:);
  ico    = Q2T(x(icoq,:));
  rls(k) = +1e10;
  for l=1:2,
    xt     = x(icoq(ico(l,:)),:);
    ls(1)  = sqrt((xt(2,1)-xt(1,1))^2+(xt(2,2)-xt(1,2))^2);
    ls(2)  = sqrt((xt(3,1)-xt(2,1))^2+(xt(3,2)-xt(2,2))^2);
    ls(3)  = sqrt((xt(1,1)-xt(3,1))^2+(xt(1,2)-xt(3,2))^2);
    lmax   = -1e6;
    lmin   = +1e6;
    lmax   = max([lmax ;max(ls)]);
    lmin   = min([lmin ;min(ls)]);
    rls(k) = min([rls(k);lmin/lmax]);
  end

  icot   = Pt((k-1)*2+2,:);
  xt     = x(icot(1:3),:);
  ls(1)  = sqrt((xt(2,1)-xt(1,1))^2+(xt(2,2)-xt(1,2))^2);
  ls(2)  = sqrt((xt(3,1)-xt(2,1))^2+(xt(3,2)-xt(2,2))^2);
  ls(3)  = sqrt((xt(1,1)-xt(3,1))^2+(xt(1,2)-xt(3,2))^2);
  lmax   = -1e6;
  lmin   = +1e6;
  lmax   = max([lmax ;max(ls)]);
  lmin   = min([lmin ;min(ls)]);
  rls(k) = min([rls(k);lmin/lmax]);

  if rls(k)>rlsmax, 
     imax   = k ; 
     rlsmax = rls(k);
  end

end

 icoq   = Pt((imax-1)*2+1,:);
 icot   = Pt((imax-1)*2+2,:);
 ico    = Q2T(x(icoq,:));
 iconew = [icoq(ico(1,:));icoq(ico(2,:))];
 iconew = [iconew;[icot(1,1:3)]];
