function [Dudx,Dudy] = dphidx(xnod,icone,phi,npg,axisim)
%------------------------------------------------------------------
%
%      [Dudx,Dudy] = dphidx(xnod,icone,phi,npg,axisim)
%
%    Calcula las derivadas de una funcion escalar respecto de las
%               direcciones "x" e "y"
%
%------------------------------------------------------------------

  [numnp,ndm]   = size(xnod);
  [numel,nen]   = size(icone);
  if sum(icone(:,nen))==0, icone(:,nen)=[]; end
  [numel,nen]   = size(icone);

  tol           = 1e-6;

  if axisim==1, error(' Axisimetrico aun no implementado'); end

  if nen==3,
    if npg>=2,npg=3;end
  elseif nen==4,
	if npg>=3, npg=9; end
    if npg==2, npg=4; end
  else
    error(' Bad choice of Gauss point number ')
  end

  T = phi(:,1);

  Mg   	=zeros(numnp,1);
  Dxg   =zeros(numnp,1);
  Dyg   =zeros(numnp,1);
  Mele  =zeros(numel,nen);
  Delex =zeros(numel,nen);
  Deley =zeros(numel,nen);

  eles     = (1:numel)';
  ceros    = zeros(length(eles),nen);

  if length(eles)>0,    

  ne     = length(eles);
  Melet  = zeros(ne,nen);
  Delext = zeros(ne,nen);
  Deleyt = zeros(ne,nen);

% Puntos de Gauss para elementos cuadrangulares

  if nen==4,
   if npg==4,
    xpg  = sqrt(3)/3;
    psipg = [ -xpg xpg xpg -xpg ];
    etapg = [ -xpg -xpg xpg xpg ];
    wpg   = [    1   1   1    1 ];
   elseif npg==1,
    xpg  = 0;
    psipg = [ xpg ];
    etapg = [ xpg ];
    wpg   = [   4 ];
   end
  else
   if npg==3,
    psipg = [ 1/6  2/3  1/6 ];
    etapg = [ 1/6  1/6  2/3 ];
    wpg   = [ 1/6  1/6  1/6 ];
   elseif npg==1,
    psipg = [ 1/3 ];
    etapg = [ 1/3 ];
    wpg   = [ 1/2 ];
   end
  end

% Localizacion
    ceros = zeros(length(eles),nen);
       Te = ceros;

  for inod=1:nen,
               nodes = icone(eles,inod);
       Te(:,inod) = T(nodes);
  end

 for ipg=1:npg

  [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));

  [dNdx,dNdy,N] = shape(X2S,psipg(ipg),etapg(ipg),nen); 

% Interpolacion en punto de Gauss

     Tpg    = zeros(ne,1);
    dTpg    = zeros(ne,2);

  for inod=1:nen,
      Tpg(:,1)  =     Tpg(:,1) +      N(inod).*    Te(:,inod);
     dTpg(:,1)  =    dTpg(:,1) + dNdx(:,inod).*    Te(:,inod);
     dTpg(:,2)  =    dTpg(:,2) + dNdy(:,inod).*    Te(:,inod);
  end

  xsj =  wpg(ipg) .* Jaco;
  if axisim,
     xsj = xsj.*radpg;
  end

  for inod=1:nen,

    Melet(:,(inod-1)+1)  = Melet(:,(inod-1)+1) + N(inod) .* xsj	;
    Delext(:,(inod-1)+1) = Delext(:,(inod-1)+1) + ... 
	                           N(inod) .* dTpg(:,1) .* xsj ; 
    Deleyt(:,(inod-1)+1) = Deleyt(:,(inod-1)+1) + ... 
	                           N(inod) .* dTpg(:,2) .* xsj ; 							 
  end % inod

 end % ipg

  for itri=1:ne,
    Mele(eles(itri),:) =  Mele(eles(itri),:) +  Melet(itri,:);
    Delex(eles(itri),:)=  Delex(eles(itri),:)+ Delext(itri,:);
    Deley(eles(itri),:)=  Deley(eles(itri),:)+ Deleyt(itri,:);
  end

  end

  for iele=1:numel,
  for inod=1:nen,
    Mg((icone(iele,inod)-1)+1,1) = ... 
         Mg((icone(iele,inod)-1)+1,1) + Mele(iele,(inod-1)+1);
    Dxg((icone(iele,inod)-1)+1,1) = ... 
         Dxg((icone(iele,inod)-1)+1,1) + Delex(iele,(inod-1)+1);
    Dyg((icone(iele,inod)-1)+1,1) = ... 
         Dyg((icone(iele,inod)-1)+1,1) + Deley(iele,(inod-1)+1);
  end
  end

  Dudx = Dxg ./ Mg;
  Dudy = Dyg ./ Mg;
