function [x,ico,ntri] = drvmushy(xnod,T,C,Tm,slopel,kp)
%----------------------------------------------------------------------
%
%  Dado un triangulo que se halla en la zona muchy
%  lo divide en varios triangulos de forma de que 
%  cada uno de ellos solo tenga en su interior una
%  sola fase.
%
%        [x,ico,ntri] = drv(xnod,T,C,Tm,slopel,kp)
%
%----------------------------------------------------------------------

Tsol   = Tm+slopel/kp*C;
Tliq   = Tm+slopel*C;
fs     = frsol2(T,C,Tm,slopel,kp);

% Estima la fase en que se halla cada nodo
limit=1e-6;
%phase =   (fs > (1-limit))+(-1)*(fs<limit);
phase =   (T > (Tliq+limit))+(-1)*(T < (Tsol-limit));

% Calcula la cantidad de interfases por arista
%  edge    = mushy_1(phase(icone(k,:)));
  edge    = mushy_1(phase);
% Identifica el caso
  caso    = mushy_2(edge);
% Calcula la subparticion en triangulos segun el caso
%  [x,ico,ntri] = ... 
%      mushy_3(caso,edge,xnod(icone(k,:),:),Tliq,Tsol,T(icone(k,:)));
  [x,ico,ntri] = mushy_3(caso,edge,xnod,T,C,Tm,slopel,kp);
