function xi = fs2x(xnod,T,C,Tm,slopel,kp)
%
%  Dadas las coordenadas de 2 puntos y sus temperaturas
%  Calcular la posicion de todas las interfases posibles
%  entre los dos puntos. Puede haber 1 o 2.
%

tol    = 1e-6;
xi     = [];

% Calculo punto de interseccion recta liquidus y solidus con 
% la recta sobre el diagrama de equilibrio obtenida
% por interpolacion del par (T,C) en cada nodo de la arista

% interseccion con linea liquidus
alfa_l = (Tm+slopel*C(1)-T(1))/((T(2)-T(1))-slopel*(C(2)-C(1)));

% interseccion con linea solidus
alfa_s = (Tm+slopel/kp*C(1)-T(1))/((T(2)-T(1))-slopel/kp*(C(2)-C(1)));

% ordena las intersecciones
if alfa_s<alfa_l, alfa(1)=alfa_s; alfa(2)=alfa_l;end
if alfa_s>=alfa_l, alfa(1)=alfa_l; alfa(2)=alfa_s;end


% Si la distancia entre ellas es menor que una tolerancia veces
% la longitud de la arista, debe redefinirse como esa tolerancia.
if (alfa(1)>0)&(alfa(1)<1)&(alfa(2)>0)&(alfa(2)<1),
  if (alfa(2)-alfa(1)) < tol,
    alfa_m   = (alfa(1)+alfa(2))/2 ;
    alfa_max = alfa_m+tol/2;
    alfa_min = alfa_m-tol/2;
    if alfa_max >= 1, alfa_max = alfa(2); end
    if alfa_min <= 0, alfa_min = alfa(1); end
    alfa(1)  = alfa_min;
    alfa(2)  = alfa_max; 
  end
end

for k=1:2,
  if (alfa(k)>0)&(alfa(k)<1),
    x = (xnod(2,1)-xnod(1,1))*alfa(k)+xnod(1,1);
    y = (xnod(2,2)-xnod(1,2))*alfa(k)+xnod(1,2);
    xi    = [xi ; [x y]];
  end
end
