function [T2] = intT2T(x1,T1,x2)
%
% Rutina para interpolar valores nodales (T1) desde 1 triangulo
% a un subtriangulo incluido en el anterior (T2)
%
%           [T2] = intT2T(x1,T1,x2)
%

% Calculo de las coordenadas naturales del punto x

%x2 = x2';
%A = [ x1(2,1)-x1(1,1) x1(3,1)-x1(1,1) ; 
%      x1(2,2)-x1(1,2) x1(3,2)-x1(1,2) ]; 
%b = [ x2(1,:)-x1(1,1); x2(2,:)-x1(1,2) ];
%psi = A\b;
%T2 = (1-psi(1,:)-psi(2,:)).*T1(1)+psi(1,:)*T1(2)+psi(2,:)*T1(3);
%T2 = v2m(T2',3);

 z1 = x1;
 x1 = v2m(z1(:,1),3)';
 y1 = v2m(z1(:,2),3)';
 z2 = x2;
 x2 = v2m(z2(:,1),3)';
 y2 = v2m(z2(:,2),3)';

 T1 = v2m(T1,3)';

 A = [ x1(2,:)-x1(1,:); x1(3,:)-x1(1,:)   ; 
       y1(2,:)-y1(1,:); y1(3,:)-y1(1,:) ]; 

 detA = A(1,:).*A(4,:)-A(2,:).*A(3,:);

 T2 = [];
 for k=1:3,
     b = [ x2(k,:)-x1(1,:); y2(k,:)-y1(1,:)  ];
   psi = ([1;1]*(1 ./ detA)) .* ... 
           [ [A(4,:).*b(1,:)-A(2,:).*b(2,:)]  ; 
           [-A(3,:).*b(1,:)+A(1,:).*b(2,:)] ];

    T2 = [T2 ; 
     (1-psi(1,:)-psi(2,:)).*T1(1,:)+psi(1,:).*T1(2,:)+psi(2,:).*T1(3,:) ];
 end 
 T2 = T2'; 
