%
%  Generacion de datos programa fem001
%

xnod=[];
icone=[];
Nx = 20;
Ny = 20;
x = (0:Nx-1)'/(Nx-1)*0.106;
y = (0:Ny-1)'/(Ny-1)*1.4;

zmould  = 0.6;
radio   = 0.106;

%-------- coordenadas (XNOD)
for k=1:Ny,
  xnod=[xnod;[x ones(Nx,1)*y(k)]];
end

%-------- conectividades (ICONE)
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
for k=1:Ny-1,
  icone=[icone; (k-1)*Nx+ico ];
end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 2;
fixa= zeros(numnp,ndf);
fixa(1:Nx-1,2)=ones(Nx-1,1);
fixa(:,1)=ones(numnp,1);

%fixa(Nx*(Ny-1)+(1:Nx),1)=ones(Nx,1);
%fixa(1:Nx:Nx*Ny,1)=ones(Ny,1);
%fixa(Nx:Nx:Nx*Ny,1)=ones(Ny,1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc= zeros(numnp,ndf);
%forc(Nx*(Ny-1)+(2:Nx-1),1)=0.1*ones(Nx-2,1);
%forc(Nx*(Ny-1)+1,1)=0.1/2;
%forc(Nx*(Ny-1)+Nx,1)=0.1/2;
%forc(Nx*(Ny-1)+(2:Nx-1),1)=0.1*ones(Nx-2,1);
%forc(2*Nx:Nx:Nx*Ny,1) = -1000000*ones(Ny-1,1);

%-------- Propiedades del material

 veloc =  zeros(numnp,2);
 veloc(:,2) = 0.0267*ones(numnp,1);

 Tm      = 1537    ; 
 prop(1) = Tm      ;
 slopel  = -90     ; 
 prop(2) = slopel  ;
 kp      = 0.439   ;
 prop(3) = kp      ;
 C       = 0.1     ;
 prop(4) = C       ;
 kappa_s = 30      ;
 prop(5) = kappa_s ;
 kappa_l = 50      ;
 prop(6) = kappa_l ;
 rho     = 7200    ;
 prop(7) = rho     ;
 Cp      = 680     ;
 prop(8) = Cp      ;
 DeltaH  = 272000  ;
 prop(9) = DeltaH  ;
 U0      = 0.0267  ;
 prop(10)= U0      ;
 alfa_min= 0.1     ;
 prop(11)= alfa_min;
 Dm_s    = 1.6e-11 ;
 prop(12)= Dm_s    ;
 Dm_l    = 1e-08   ;
 prop(13)= Dm_l    ;
 Fou     = 1       ;
 prop(14)= Fou     ;


%-------- Cargas repartidas (STRG)
mask    = (abs(xnod(:,1)-radio)<1e-4)&(xnod(:,2)<zmould);
nodos_1 = find(mask==1);
%nodos_1 = (2*Nx:Nx:Nx*(Ny-1))'; 
%value_1 = -1e6*ones(size(nodos_1));
nodos_2 = nodos_1+Nx;
%value_2 = -1e6*ones(size(nodos_2));

alfa = 1.1469;
z_1 = xnod(nodos_1,2);
z_2 = xnod(nodos_2,2);
value_1 = -4186*alfa*(640-75.3*sqrt(z_1/U0));  % en Watt/m^2
value_2 = -4186*alfa*(640-75.3*sqrt(z_2/U0));  % en Watt/m^2

strg    = [];
%strg    = [nodos_1 nodos_2 value_1 value_2];


%-------- Condiciones de contorno mixtas (TECO)

ele     = find(icone(:,3)==max(nodos_2));
%eles    = (2*(Nx-1):Nx-1:(Nx-1)*(Ny-1))';
[numel,nen]=size(icone);
eles    = (ele+Nx-1:Nx-1:numel)';
face    = 2*ones(size(eles));
val1    = 500*ones(size(eles));
val2    = 40*ones(size(eles));

%teco    = [eles face val1/rho/Cp val2 ];
teco     = [];

%-------- Solucion inicial (PHI)

T   = 1530-xnod(:,1)/0.106*50;
phi = [T 0.1*ones(numnp,1)];
phiold = phi;

%phi(1:fix(Nx/2),1)      = 1550*ones(fix(Nx/2),1);
%phi(Nx*(Ny-1)+(1:Nx),1) = 1450*ones(Nx,1);
%phi(Nx:Nx:Nx*Ny,1)       = 1450*ones(Ny,1);
%phi(1:Nx:Nx*Ny,1)=1550*ones(Ny,1);

%-------- Conversion de STRG --> FORC

if size(strg)~= 0, 

  strg(:,3)  = strg(:,3)/rho/Cp;
  strg(:,4)  = strg(:,4)/rho/Cp;

  nodos_1 = strg(:,1);
  nodos_2 = strg(:,2);
  value_1 = strg(:,3);
  value_2 = strg(:,4);

  hele    = sqrt((xnod(nodos_2,1)-xnod(nodos_1,1)).^2 + ... 
                 (xnod(nodos_2,2)-xnod(nodos_1,2)).^2 );

  forc(nodos_1) = forc(nodos_1) + ...
      ((value_1+value_2)/2 - (value_2-value_1)/6).*hele/2 ; 
  forc(nodos_2) = forc(nodos_2) + ...
      ((value_1+value_2)/2 + (value_2-value_1)/6).*hele/2 ; 

end