function [Kele,Rele] = ...
      mapt2t(xfather,xson,Kelet,Relet,ico2t,ntri,ndf,nen)
%
%    [Kele,Rele] = ... 
%          mapt2t(xnod,x,Kelet,Relet,ico2t,ntri,ndf,nen)
%
%
%     xfather(1:3*ntri,1:2)   
%     xson(1:3*ntri,1:2)   
%      ntri = nro de triangulos que surgen de la particion de la zona mushy
%      NOTA : Para xnod, por cada triangulo nacido existe su padre
%             1 mismo padre puede tener varios hijos pero en el arreglo
%             xnod debemos repetir al padre como si fuera distinto.
%

  Kele = zeros(ntri,(nen*ndf)^2);
  Rele = zeros(ntri,(nen*ndf));

% Armado matriz A (global)
%---------------------------

  A = ones(3,ntri);
  A = [ A ; v2m(xfather(:,1),3)' ; v2m(xfather(:,2),3)' ];

% Armado matriz Ai (interior)
%---------------------------

  Ast = ones(3,ntri);
  Ast = [ Ast ; v2m(xson(:,1),3)' ; v2m(xson(:,2),3)' ];
 
  for itri=1:ntri,

  Ar      = v2m(A(:,itri),3);
  Astr    = v2m(Ast(:,itri),3);
  A1Astr  = Ar\Astr;

  A1Astv  = (m2v(A1Astr))';
  A1Astvt  = (m2v(A1Astr'))';

  Kt  = Kelet(itri,1:ndf^2:(ndf^2)*(3^2));
  Kt  = mamav3(A1Astv,Kt);
  Kt1 = mamav3(Kt,A1Astvt);

  Kt  = Kelet(itri,2:ndf^2:(ndf^2)*(3^2));
  Kt  = mamav3(A1Astv,Kt);
  Kt2 = mamav3(Kt,A1Astvt);

  Kt  = Kelet(itri,3:ndf^2:(ndf^2)*(3^2));
  Kt  = mamav3(A1Astv,Kt);
  Kt3 = mamav3(Kt,A1Astvt);

  Kt  = Kelet(itri,4:ndf^2:(ndf^2)*(3^2));
  Kt  = mamav3(A1Astv,Kt);
  Kt4 = mamav3(Kt,A1Astvt);

  Rt1 = mavev3(A1Astv,Relet(itri,1:ndf:ndf*3));
  Rt2 = mavev3(A1Astv,Relet(itri,2:ndf:ndf*3));

  for k1=1:3,
   inod=ico2t(itri,k1);
   for k2=1:3,
     jnod=ico2t(itri,k2);
     ip=((inod-1)*nen+(jnod-1))*ndf^2;
     Kele(itri,ip+1)=Kele(itri,ip+1)+Kt1((k1-1)*3+k2);
     Kele(itri,ip+2)=Kele(itri,ip+2)+Kt2((k1-1)*3+k2);
     Kele(itri,ip+3)=Kele(itri,ip+3)+Kt3((k1-1)*3+k2);
     Kele(itri,ip+4)=Kele(itri,ip+4)+Kt4((k1-1)*3+k2);
   end
   Rele(itri,(inod-1)*ndf+1)=Rele(itri,(inod-1)*ndf+1)+Rt1(k1);
   Rele(itri,(inod-1)*ndf+2)=Rele(itri,(inod-1)*ndf+2)+Rt2(k1);
  end

%disp(' dentro de mapt2t ')
%disp([' despues de cargar el elemento ' num2str(itri) ])
%keyboard
%pause

 end