function  [dphin,nsd,isd] = sdomain(xnod,nsdv,fixa,Kg,Rg)
%
%    [dphin,nsd,isd] = sdomain(xnod,nsdv,fixa,Kg,Rg)
%------------------------------------------------------------------
%   Armar un precondicionador diagonal por bloques de ecuaciones
%------------------------------------------------------------------
%              particion del dominio en subdominios
%

disp('Fase 1')
tic

xmin = min(xnod(:,1));
xmax = max(xnod(:,1));
ymin = min(xnod(:,2));
ymax = max(xnod(:,2));
dx   = (xmax-xmin)/nsdv(1);
dy   = (ymax-ymin)/nsdv(2);

xc_0 = xmin;
yc_0 = ymin;

for k=1:nsdv(1),
 eval(['xc_' num2str(k) '= xmin + k*dx ;'])
end
for k=1:nsdv(2),
 eval(['yc_' num2str(k) '= ymin + k*dy ;'])
end


for k1=1:nsdv(2),
  for k2=1:nsdv(1),
    kk = (k1-1)*nsdv(1)+k2;
    eval(['mask' num2str(kk) '= (xnod(:,1)>=xc_' num2str(k2-1) ...
    ')&(xnod(:,1)<xc_' num2str(k2) ')&(xnod(:,2)>=yc_' num2str(k1-1) ...
    ')&(xnod(:,2)<yc_' num2str(k1) ');']);
    if k2==nsdv(1),
    eval(['mask' num2str(kk) '= (xnod(:,1)>=xc_' num2str(k2-1) ...
    ')&(xnod(:,1)<=xc_' num2str(k2) ')&(xnod(:,2)>=yc_' num2str(k1-1) ...
    ')&(xnod(:,2)<yc_' num2str(k1) ');']);
    end
    if k1==nsdv(2),
    eval(['mask' num2str(kk) '= (xnod(:,1)>=xc_' num2str(k2-1) ...
    ')&(xnod(:,1)<xc_' num2str(k2) ')&(xnod(:,2)>=yc_' num2str(k1-1) ...
    ')&(xnod(:,2)<=yc_' num2str(k1) ');']);
    end
    if (k1==nsdv(2))&(k2==nsdv(1)),
    eval(['mask' num2str(kk) '= (xnod(:,1)>=xc_' num2str(k2-1) ...
    ')&(xnod(:,1)<=xc_' num2str(k2) ')&(xnod(:,2)>=yc_' num2str(k1-1) ...
    ')&(xnod(:,2)<=yc_' num2str(k1) ');']);
    end
  end
end

nsd = nsdv(1)*nsdv(2);

for k=1:nsd,
 eval(['if sum(mask' num2str(k) ... 
      ') == 0 ,error('' Bad domain decomposicion ''),end '])
end

for k=1:nsd,
 eval(['ieqs' num2str(k) ' = find(mask' num2str(k) '==1);']);
end

[numnp,ndm]=size(xnod);
isd = zeros(numnp,1);
for k=1:nsd,
 eval(['isd(ieqs' num2str(k) ') = ' num2str(k) ... 
            '*ones(length(ieqs' num2str(k) '),1);']);
end

for k=1:nsd,
 eval(['free' num2str(k) '= find(fixa(ieqs' num2str(k) ',1)==0);']);
 eval(['free' num2str(k) '= ieqs' num2str(k) '(free' num2str(k) ');']);
 eval(['Kg_' num2str(k) '= Kg(free' num2str(k) ',free' num2str(k) ');']);
 eval(['Rg_' num2str(k) '= Rg(free' num2str(k) ');']);
end


for k=1:nsd,
 eval([' [n' num2str(k) ',m' num2str(k) '] = size(Kg_' num2str(k) ');'])
end


ip=[0];
for k=1:nsd-1,
 eval(['nn = n' num2str(k) ';']); 
 ip = [ip;nn];
end
eval(['ip = [ip; n' num2str(nsd) ']; ']); 
ip = cumsum(ip);
ip = ip+1;

toc
disp('Fase 2')
tic

ipn=[];

for k=1:nsd,
  iu = (ip(k):ip(k+1)-1)';  
  eval(['dphi(iu,1) = Kg_' num2str(k) '\ Rg_' num2str(k) ';']);
  eval(['ipn(ip(k):ip(k+1)-1,1) = free' num2str(k) ';']);
end

dphin = zeros(numnp,1);
dphin(ipn) = dphi;
toc