function [tau_pg] = supg2(velpg,h_supg,difu)
%
% calculo de tau (stabilizacion numerica)
%
%        [tau_pg,h_supg] = supg(velpg,dNdx,dNdy,difu)
%

  limit = 1e-20;
  [numel,nnn] = size(velpg);

  velmodpg = sqrt(sum(velpg'.^2))';
  mask_d   = (difu>limit);
  difu     = difu+limit*(1-mask_d);
  Pe_pg    = velmodpg .* h_supg / 2 ./ difu ;
  psi_pg   = (abs(Pe_pg)>3) + (abs(Pe_pg)<=3).*abs(Pe_pg/3);

  mask_v   = (velmodpg>limit);
  velmodpg = velmodpg+limit*(1-mask_v);

  tau_pg   = ( h_supg / 2  ./ abs(velmodpg) ) .* psi_pg;
