function [HRpg,dHRdTpg,dHRdHpg] = Hrel(Tpg,Hpg);

% H = equilibrium moisture content
% T = Temperature
% HR = Relative humidity
%
% 						   
T=[30 50 70 90 110 130 150 170 190 210]';
H = [0 1 3 5 7 9 11 13 15 17 19]';

% ----> Temperaturas
% !
% ! Humedades
% v 
HR=[ 9 6 6 6 3   3  3  3  3  3; % Guarda que esta linea es trucha!!!!
     3 4 6 8 11 13 14 17 21 15;
     12 15 18 24 29 35 41 53 62 74;
     20 26 30 39 47 56 70 84 93 100;
     31 37 44 53 61 71 84 98 100 100;
     44 48 56 64 74 80 92 100 100 100;
     55 59 66 73 80 87 98 100 100 100;
     65 68 74 80 86 93 100 100 100 100;
     71 74 80 86 90 97 100 100 100 100;
     77 79 85 90 94 100 100 100 100 100;
     82 84 89 94 98 100 100 100 100 100];

T=T+273.15;
H=H/100;
HR=HR/100;

hrcoef=zeros(9,3);
for k=1:9
  II=find(HR(:,k)<100);
  hrcoef(k,:)=polyfit(H(II),HR(II,k),2);
  % plot(H,[HR(:,k) polyval(polyfit(H(II),HR(II,k),2),H)])
end

hrcoef(:,3)=0*hrcoef(:,3);

iT=[1 5];
c2=polyfit(T(iT),hrcoef(iT,1),1);
c1=polyfit(T(iT),hrcoef(iT,2),1);
c0=polyfit(T(iT),hrcoef(iT,3),1);

% cnm * H^n * T^m

c00=c0(2); c01=c0(1);
c10=c1(2); c11=c1(1);
c20=c2(2); c21=c2(1);

fHRpg=(c00+c01*Tpg)+(c10+c11*Tpg).*Hpg+(c20+c21*Tpg).*Hpg.^2;
fdHRdTpg=c01+c11*Hpg+c21*Hpg.^2;
fdHRdHpg=(c10+c11*Tpg)+2*(c20+c21*Tpg).*Hpg;

%HRpg=fHRpg;
%dHRdTpg=fdHRdTpg;
%dHRdHpg=fdHRdHpg;
%if max(max(HRpg))>1, error(' HR > 1 ');end
%return

fmax=.98;
FMAX=3;

if max(fHRpg)>FMAX,
   error('HR: Te pasaste de FMAX')
end

mask=fHRpg>fmax;
HRpg=fHRpg.*(1-mask)+(fmax+(1-fmax)/(FMAX-fmax)*(fHRpg-fmax)).*mask;
dfdotdf=(1-mask)+mask*(1-fmax)/(FMAX-fmax);
dHRdTpg=fdHRdTpg.*dfdotdf;
dHRdHpg=fdHRdHpg.*dfdotdf;

% Regularizacion demasiado bruta
%HRpg=fHRpg./(1+fHRpg);
%dHRdTpg=fdHRdTpg./(1+fHRpg).^2;
%dHRdHpg=fdHRdHpg./(1+fHRpg).^2;

if max(fHRpg)>1,
 disp([' max fHRpg = ' num2str(max(fHRpg)) ])
 disp([' max HRpg = ' num2str(max(HRpg)) ])
end

%mask    = HRpg>1;
%HRpg    = HRpg.*(1-mask)+mask;
%dHRdTpg = dHRdTpg.*(1-mask);
%dHRdHpg = dHRdHpg.*(1-mask);

return

HRr=zeros(10);
HRri=HRr;

C=zeros(1,3);
for it=1:10
   TT=T(it);
   C(1)=polyval(c2,TT);
   C(2)=polyval(c1,TT);
   C(3)=polyval(c0,TT);
   HRr(:,it)=polyval(C,H);
%   HRri(:,it) = interp2(H,T,HR,H,T(it)*ones(10,1),'bilinear');
end

