function [Relet] = ... 
       KyR005(Relet,Tpg,Cpg,dTpg,dCpg,dCspg,dfspg,velpg,dt,fspg,  ...
              N,dNdx,dNdy,Jaco,wpg,dNdx0,dNdy0,Jaco0,mushy_e,prop,...
			  coe,ndf,nen,ijob)
%
%   ARMADO DEL RESIDUO (LA MATRIZ TANGENTE SE OBTIENE PERTURBANDO 
%                       EL RESIDUO)
%   ijob = 0 ---> INTEGRAL EN EL INTERIOR DEL DOMINIO
%   ijob = 1 ---> INTEGRAL EN EL CONTORNO DEL DOMINIO
%


  ne    = length(Tpg);

  Tm       = prop(1) ; 
  slopel   = prop(2) ;
  kp       = prop(3) ;
  kappa_s  = prop(5) ;
  kappa_l  = prop(6) ;
  rho      = prop(7) ;
  Cp       = prop(8) ;
  DeltaH   = prop(9) ;
  U0       = prop(10);
  alfa_min = prop(11);
  Dm_s     = prop(14);
  Dm_l     = prop(16);
  dt       = prop(13);
  lmushy   = prop(15);
  upwind   = prop(19);
  Dm_l_turb= prop(17);
  shocap   = prop(18);
  tol      = prop(12);

  if ijob==0,
  P1_pg=[]; P2_pg=[]; P3_pg=[]; P4_pg=[];

  kappa_pg      = (kappa_s * fspg + kappa_l *(1-fspg))/rho/Cp; 
  Dm_pg         = Dm_l/kp + (Dm_s-Dm_l/kp) .* fspg ;

  vel_supg      = velpg ;
  [hele]        = h_supg(vel_supg,dNdx0,dNdy0);
  velmod        = sqrt(sum(vel_supg'.^2))';
  mask          = (velmod<1e-16);
  vel_supg      = vel_supg+(mask*[1e-16 1e-16]);
  if nen==4, hele = mask.*(sqrt(4.0*Jaco0/pi))+(1-mask).*hele;end
  if nen==3, hele = mask.*(sqrt(0.5*Jaco0/pi))+(1-mask).*hele;end
  [tau1_pg]     = upwind*supg1(dt,vel_supg,hele,kappa_pg);

  vel_supg      = velpg;
  [hele]        = h_supg(vel_supg,dNdx0,dNdy0);
  velmod        = sqrt(sum(vel_supg'.^2))';
  mask          = (velmod<1e-16);
  vel_supg      = vel_supg+(mask*[1e-16 1e-16]);
  if nen==4, hele = mask.*(sqrt(4.0*Jaco0/pi))+(1-mask).*hele;end
  if nen==3, hele = mask.*(sqrt(0.5*Jaco0/pi))+(1-mask).*hele;end
  [tau2_pg]     = upwind*supg1(dt,vel_supg,hele,Dm_pg);

  for inod=1:nen,
   vel_supg = velpg ; 
   P1_pg(:,inod) = tau1_pg .* ... 
    ( vel_supg(:,1) .*dNdx(:,inod) + vel_supg(:,2) .*dNdy(:,inod) );
   vel_supg = velpg ;
   P2_pg(:,inod) = tau2_pg .* ... 
    ( vel_supg(:,1) .*dNdx(:,inod) + vel_supg(:,2) .*dNdy(:,inod) );

   if shocap==1,
% Para la energia
    deno = (dTpg(:,1).^2+dTpg(:,2).^2);
    mask = (sqrt(deno)>1e-10);
    deno = deno + (1-mask)*1e-10;
    vel_sc =  mask .* RgTpg ./  deno ;
    vel_sc =  [dTpg(:,1).*vel_sc dTpg(:,2).*vel_sc ];
    [tau3_pg]      = upwind*supg2(vel_sc,hele,kappa_pg);

    P3_pg(:,inod) = mushy_e.*tau3_pg .* ...
     ( vel_sc(:,1) .*dNdx(:,inod) + vel_sc(:,2) .*dNdy(:,inod) );
    P1_pg(:,inod) = P1_pg(:,inod)+P3_pg(:,inod) ; 

% Para el soluto
% estrategia # 1
    deno = (dCpg(:,1).^2+dCpg(:,2).^2);
    mask = (sqrt(deno)>1e-10);
    deno = deno + (1-mask)*1e-10;
    vel_sc =  mask .* RgCpg ./  deno ;
    vel_sc =  [dCpg(:,1).*vel_sc dCpg(:,2).*vel_sc ];
% estrategia # 2
    [tau4_pg]      = upwind*supg2(vel_sc,hele,Dm_pg.*dCsdCpg);
    P4_pg(:,inod) = mushy_e.*tau4_pg .* ...
     ( vel_sc(:,1) .*dNdx(:,inod) + vel_sc(:,2) .*dNdy(:,inod) );
    P2_pg(:,inod) = P2_pg(:,inod)+P4_pg(:,inod) ; 
   end
  end 

  for inod=1:nen,

% residuo del balance de energia
%-----------------------------------------------------------
    ter1 = (N(:,inod)+P1_pg(:,inod)).*Tpg/dt ;
% sin debilitar termino advectivo
%    ter2 = (N(:,inod)+P1_pg(:,inod)).*velpg(:,1).*dTpg(:,1) + ...
%           (N(:,inod)+P1_pg(:,inod)).*velpg(:,2).*dTpg(:,2) ;
% debilitando el termino advectivo (hay agregado termino de contorno)
    ter2 = P1_pg(:,inod).* (velpg(:,1).*dTpg(:,1)+velpg(:,2).*dTpg(:,2));
    ter2 = ter2 - (dNdx(:,inod).*velpg(:,1)+dNdy(:,inod).*velpg(:,2)).*Tpg;

    ter3 = (dNdx(:,inod).*dTpg(:,1)+dNdy(:,inod).*dTpg(:,2)).*kappa_pg ;
    ter4 = -(N(:,inod)+P1_pg(:,inod)).*(DeltaH/Cp*fspg/dt) ;
    ter5 = -(N(:,inod)+P1_pg(:,inod)).*(DeltaH/Cp*(U0.*dfspg(:,2)));

   Relet(:,(inod-1)*ndf+1) = Relet(:,(inod-1)*ndf+1) - ( ...
	     ter1*coe(1)+ter2*coe(2)+ter3*coe(3)+ter4*coe(4)+ter5*coe(5) ...
                   ) * wpg .* Jaco ;

% residuo del balance de soluto
%-----------------------------------------------------------

    ter1 = (N(:,inod)+P2_pg(:,inod)).*(Cpg)/dt ;
% sin debilitar el termino advectivo
%    ter2 = (N(:,inod)+P2_pg(:,inod)).* ... 
%	   (velpg(:,1).*dCpg(:,1)+velpg(:,2).*dCpg(:,2));
% debilitando termino advectivo
    ter2 = P2_pg(:,inod).* (velpg(:,1).*dCpg(:,1)+velpg(:,2).*dCpg(:,2));
	ter2 = ter2 - (dNdx(:,inod).*velpg(:,1)+dNdy(:,inod).*velpg(:,2)).*Cpg;

    ter3 = (dNdx(:,inod).*dCspg(:,1)+dNdy(:,inod).*dCspg(:,2)).*Dm_pg ;
    ter5 = (N(:,inod)+P2_pg(:,inod)) .* mushy_e.* ( ...
       (dCspg(:,1)/kp-dCpg(:,1)).*velpg(:,1) + ...
       (dCspg(:,2)/kp-dCpg(:,2)).*(velpg(:,2)-U0) ) ;

   Relet(:,(inod-1)*ndf+2) = Relet(:,(inod-1)*ndf+2) - ( ...
	     ter1*coe(1)+ter2*coe(2)+ter3*coe(3)+ter5*coe(5) ...
                                  ) * wpg .* Jaco ;

  end % inod

  else

ldebug=1;

 if ldebug,
% INTEGRAL DE CONTORNO 


  for inod=1:2,

% residuo del balance de energia
%-----------------------------------------------------------
    ter1 = 0;
    ter2 = N(inod).*velpg(:,1).*Tpg(:,1) ;
	ter3 = 0;
    ter4 = 0;
	ter5 = 0;

   Relet(:,(inod-1)*ndf+1) = Relet(:,(inod-1)*ndf+1) - ( ...
	     ter1*coe(1)+ter2*coe(2)+ter3*coe(3)+ter4*coe(4)+ter5*coe(5) ...
                   ) * wpg .* Jaco ;

% residuo del balance de soluto
%-----------------------------------------------------------

    ter1 = 0;
    ter2 = N(inod).* velpg(:,1).*Cpg(:,1);	   
    ter3 = 0;
	ter4 = 0;
    ter5 = 0;

   Relet(:,(inod-1)*ndf+2) = Relet(:,(inod-1)*ndf+2) - ( ...
	     ter1*coe(1)+ter2*coe(2)+ter3*coe(3)+ter5*coe(5) ...
                                  ) * wpg .* Jaco ;

  end % inod

  end % if ijob

  end % if ldebug
