function [Relet] = ... 
        KyR007(Relet,Tpg,Hpg,rhoapg,dTpg,dHpg,drhoapg,velpg,dt,...
               N,dNdx,dNdy,Jaco,wpg,dNdx0,dNdy0,Jaco0,prop,...
	       radpg,coe,ndf,nen,Tpgold,Hpgold,rhoapgold);

% modelo_cc = 1 ---> CARVALHO-COSTA model
modelo_cc=0;


%
%   ARMADO DEL RESIDUO (LA MATRIZ TANGENTE SE OBTIENE PERTURBANDO 
%                       EL RESIDUO)
%

  ne    = length(Tpg);

  npg      = prop(1);
  Lx       = prop(2);
  dt       = prop(13);
  upwind   = prop(19);
  shocap   = prop(18);
  tol      = prop(12);
  fuga_lat = prop(17);
  axisim   = prop(16);

%t = cputime;

% [0] Llamada a la rutina con calculo de las props variables del material
[rho_s,Cp_s,Cp_s0,Kgz,Kgx,mu_g,Psat,dPsatdT,kappa_z,kappa_x,Cp_g, ...  
                DeltaH,epsilon,Ra,Rv,Patm,MMv,MMa]=coefmat(Tpg,Hpg);

  Psatold = 10.^(10.745-2141.0./Tpgold);


% Calculo de la humedad relativa (isotermas de sorcion)
% y calculo de la presion parcial de vapor
  [HR,dHRdT,dHRdH] = Hrel(Tpg,Hpg);
  Pvpg    = HR.*Psat;
  [HRold,dHRdTold,dHRdHold] = Hrel(Tpgold,Hpgold);
  Pvpgold = HRold.*Psatold;

  dPvpg = ((dHRdT*[1 1]).*dTpg+(dHRdH*[1 1]).*dHpg).*(Psat*[1 1]) + ... 
          ((HR.*dPsatdT)*[1 1]).*dTpg;

  Papg  = rhoapg.*(Ra*Tpg);
  dPapg = drhoapg.*(Ra*Tpg*[1 1])+(rhoapg*Ra*[1 1]).*dTpg;

% Calculo de la presion total
  Ppg  = Pvpg+0*Papg;
  dPpg = dPvpg+0*dPapg;

% Difusividad del aire
  Da = 2.20e-5*(101325 ./Ppg).*(Tpg/273.15).^(1.75);

% Difusividad del vapor
  Da_upw = Da;
  Dvx_upw = Da_upw;
  Dvz_upw = 0.1*Da_upw;
  Da  = MMv/MMa*Da.*rhoapg;
  Dvx = Da;
  Dvz = 0.1*Da;

% Fracciones molares
  dXvpg = dPvpg ./ (Ppg*[1 1]) - (Pvpg./(Ppg.^2)*[1 1]).*dPpg ;

% [1] Calculo de la velocidad del gas (Ley de Darcy)
  velpg = -(1 ./ mu_g * [Kgx,Kgz]).*dPpg/epsilon;
% DEBUG
%  velpg = [zeros(ne,1) -ones(ne,1)];

% [2] Calculo del gradiente de la densidad de vapor
  rhovpg  = Pvpg./(Rv*Tpg);
  rhovpgold  = Pvpgold./(Rv*Tpgold);
  drhovpg = dPvpg./(Rv*Tpg*[1 1])- ((rhovpg./Tpg)*[1 1]).*dTpg ;

% [3] Calculo de la velocidad transversal (OJO que no es strictly una veloc)
  velxpg = 0;
  if fuga_lat ~=0, velxpg=1; end
  velxpg = velxpg*8/Lx^2*(Kgx./mu_g).*(Ppg-Patm)/epsilon;  

%disp(' KyR007');keyboard;pause

  rhogpg = rhoapg+rhovpg;

% Calculo del upwind para cada una de las tres ecuaciones
  P1_pg=zeros(ne,nen); P2_pg=P1_pg; P3_pg=P1_pg; 

% Ecuacion de energia
  fac1 = epsilon*rhogpg*Cp_g;

  if upwind,
  kappa_pg      = sqrt(kappa_x.*kappa_z) ./(rho_s*Cp_s0); 
  vel_supg      = (fac1*[1 1]).*velpg ./(rho_s*Cp_s0);
  [hele]        = h_supg(vel_supg,dNdx0,dNdy0);
  velmod        = sqrt(sum(vel_supg'.^2))';
  mask          = (velmod<1e-16);
  vel_supg      = vel_supg+(mask*[1e-16 1e-16]);
  if nen==4, hele = mask.*(sqrt(4.0*Jaco0/pi))+(1-mask).*hele;end
  if nen==3, hele = mask.*(sqrt(0.5*Jaco0/pi))+(1-mask).*hele;end
  [tau1_pg,Pe1]     = supg1(Cp_s0 ./Cp_s*dt,vel_supg,hele,kappa_pg);

% Ecuacion de masa de vapor
  kappa_pg      = sqrt(Dvx_upw.*Dvz_upw);%/(rho_s/epsilon);
  vel_supg      = velpg; %/(rho_s/epsilon);
  [hele]        = h_supg(vel_supg,dNdx0,dNdy0);
  velmod        = sqrt(sum(vel_supg'.^2))';
  mask          = (velmod<1e-16);
  vel_supg      = vel_supg+(mask*[1e-16 1e-16]);
  if nen==4, hele = mask.*(sqrt(4.0*Jaco0/pi))+(1-mask).*hele;end
  if nen==3, hele = mask.*(sqrt(0.5*Jaco0/pi))+(1-mask).*hele;end
  [tau2_pg,Pe2]     = supg1(epsilon/rho_s*dt,vel_supg,hele,kappa_pg);

% Ecuacion de masa de aire
  kappa_pg      = sqrt(Dvx_upw.*Dvz_upw);
  vel_supg      = velpg;
  [hele]        = h_supg(vel_supg,dNdx0,dNdy0);
  velmod        = sqrt(sum(vel_supg'.^2))';
  mask          = (velmod<1e-16);
  vel_supg      = vel_supg+(mask*[1e-16 1e-16]);
  if nen==4, hele = mask.*(sqrt(4.0*Jaco0/pi))+(1-mask).*hele;end
  if nen==3, hele = mask.*(sqrt(0.5*Jaco0/pi))+(1-mask).*hele;end
  [tau3_pg,Pe3]     = supg1(1e+10*dt,vel_supg,hele,kappa_pg);

 Pemax = max([Pe1;Pe2;Pe3]);
 if Pemax > 1,
   disp(' max Peclet = '),Pemax
 end

%keyboard;pause

%
% DEBUG  Tiene un 20 para exagerar el upwind !!!!!!!!!!!!!!!!!!!!!!!!
%

  for inod=1:nen,
   vel_supg = velpg ; 
   vel_supg_T = (fac1*[1 1]) .*velpg ./ (rho_s*Cp_s0);
   P1_pg(:,inod) = 1*tau1_pg .* ... 
    ( vel_supg_T(:,1) .*dNdx(:,inod) + vel_supg_T(:,2) .*dNdy(:,inod) );
   P2_pg(:,inod) = 1*tau2_pg .* ... 
    ( vel_supg(:,1) .*dNdx(:,inod) + vel_supg(:,2) .*dNdy(:,inod) );
   P3_pg(:,inod) = 1*tau3_pg .* ... 
    ( vel_supg(:,1) .*dNdx(:,inod) + vel_supg(:,2) .*dNdy(:,inod) );
  end 

  end % if upwind

%t_A = cputime-t;
%t   = cputime;


if modelo_cc,
% CARVALHO-COSTA
  fac2 = Psat/rho_s.*dHRdH;
  else
% NUESTRO
  fac2 = 1;
  end

% Correccion axisimetrica del jacobiano de la transformacion al elemento master
%------------------------------------------------------------------
  xsj =  wpg .* Jaco;
  if axisim,
     xsj = xsj.*radpg;
  end



  for inod=1:nen,

% residuo del balance de energia
%-----------------------------------------------------------

    ter1 = (N(:,inod)+1*P1_pg(:,inod)).*(Cp_s/Cp_s0.*(Tpg-Tpgold))/dt ;
    ter2 = P1_pg(:,inod).* fac1./(rho_s*Cp_s0).* ... 
	           (velpg(:,1).*dTpg(:,1) + velpg(:,2).*dTpg(:,2));

    
    ter2 = ter2 - fac1./(rho_s*Cp_s0) .* ...
	     (dNdx(:,inod).*velpg(:,1)+dNdy(:,inod).*velpg(:,2)).*Tpg;

    ter3 = (1 ./ (rho_s*Cp_s0)) .* (kappa_x.*dNdx(:,inod).*dTpg(:,1) + ...
	                       kappa_z.*dNdy(:,inod).*dTpg(:,2));
    if modelo_cc,
% CARVALHO-COSTA
    ter4 = (N(:,inod)+1*P1_pg(:,inod)).*(DeltaH ./ (rho_s*Cp_s0)) .* ... 
	                  (-1 ./ fac2 .* (Pvpg-Pvpgold)/dt) ;
    else
% NUESTRO
    ter4 = (N(:,inod)+1*P1_pg(:,inod)).*(DeltaH ./ (rho_s*Cp_s0)) .* ... 
	       (epsilon*(rhovpg-rhovpgold)-rho_s*(Hpg-Hpgold))/dt ;
	end
    ter5 = (N(:,inod)+1*P1_pg(:,inod)).*fac1./(rho_s*Cp_s0).*velxpg.*Tpg ;
% termino convectivo del cambio de fase
    ter6 = P1_pg(:,inod).* (epsilon*DeltaH./(rho_s*Cp_s0).* ... 
	           (velpg(:,1).*drhovpg(:,1) + velpg(:,2).*drhovpg(:,2)));

    ter6 = ter6 - epsilon*DeltaH./(rho_s*Cp_s0) .* ...
	     (dNdx(:,inod).*velpg(:,1)+dNdy(:,inod).*velpg(:,2)).*rhovpg;

% DEBUG
%   Qbody = 0*1e7;   
%   ter7 = (N(:,inod)+1*P1_pg(:,inod)).*(-Qbody ./ (rho_s*Cp_s0)) ;

   Relet(:,(inod-1)*ndf+1) = Relet(:,(inod-1)*ndf+1) - ( ...
   ter1*coe(1)+ter2*coe(2)+ter3*coe(3)+ter4*coe(4)+ter5*coe(5)+ter6 ...
                   ) .* xsj ;
					   

% residuo del balance de masa de vapor
%-----------------------------------------------------------
    if modelo_cc,
% CARVALHO-COSTA
    ter1 = (N(:,inod)+1*P2_pg(:,inod)).*(Pvpg-Pvpgold)/dt ;
    else
% NUESTRO
    ter1 = (N(:,inod)+1*P2_pg(:,inod)).*(rho_s/epsilon*(Hpg-Hpgold))/dt ;
	end

    ter2 = P2_pg(:,inod).* ... 
	   (velpg(:,1).*drhovpg(:,1)+velpg(:,2).*drhovpg(:,2));
	ter2 = ter2 - ...
	   (dNdx(:,inod).*velpg(:,1)+dNdy(:,inod).*velpg(:,2)).*rhovpg;
	ter2 = ter2.*fac2;
    ter3 =  (dNdx(:,inod).*dXvpg(:,1).*Dvx + ... 
	        dNdy(:,inod).*dXvpg(:,2).*Dvz).*fac2 ;
	ter5 = (N(:,inod)+1*P2_pg(:,inod)).*(velxpg.*rhovpg).*fac2 ;

   Relet(:,(inod-1)*ndf+2) = Relet(:,(inod-1)*ndf+2) - ( ...
	         ter1*coe(1)+ter2*coe(2)+ter3*coe(3)+ter5*coe(5) ...
                                  ) .* xsj ;
  %disp('KYR007 [2] ');keyboard;pause

% residuo del balance de masa de aire
%-----------------------------------------------------------

    ter1 = (N(:,inod)+1*P3_pg(:,inod)).*(rhoapg-rhoapgold)/dt ;
    ter2 = P3_pg(:,inod).* ... 
	   (velpg(:,1).*drhoapg(:,1)+velpg(:,2).*drhoapg(:,2));
    ter2 = ter2 - ...
	   (dNdx(:,inod).*velpg(:,1)+dNdy(:,inod).*velpg(:,2)).*rhoapg;
    ter3 =  dNdx(:,inod).*(-dXvpg(:,1)).*Dvx + ... 
	        dNdy(:,inod).*(-dXvpg(:,2)).*Dvz ;
    ter5 = (N(:,inod)+1*P3_pg(:,inod)).*(velxpg.*rhoapg) ;
    
   Relet(:,(inod-1)*ndf+3) = Relet(:,(inod-1)*ndf+3) - ( ...
	                  ter1*coe(1)+ter2*coe(2)+ter3*coe(3)+ter5*coe(5) ...
                                  ) .* xsj ;

  end % inod

%disp('KYR007 [1] ');keyboard;pause
%t_B = cputime-t;

%disp([' t_A = ' num2str(t_A)  ])
%disp([' t_B = ' num2str(t_B)  ])
%pause(0.1)
