function [Rele] = ...
    Res005(Rele,eles,xnod,icone,iface,Te0,Ce0,veloc,prop,nen,ndf,coe)
%------------------------------------------------------------------
%                        fmushy2.m
%
%        Tratamiento de los elementos en la zona mushy 
%
%  El ingreso de T y C es por elemento con el fin de poder perturbar
%  a cada elemento en particular para calcular la matriz de rigidez. 
% 
%------------------------------------------------------------------

  [nnod,ndm] = size(xnod);
  [numel,nen]= size(icone);

  Tm       = prop(1) ; 
  slopel   = prop(2) ;
  kp       = prop(3) ;
  kappa_s  = prop(5) ;
  kappa_l  = prop(6) ;
  rho      = prop(7) ;
  Cp       = prop(8) ;
  DeltaH   = prop(9) ;
  U0       = prop(10);
  alfa_min = prop(11);
  Dm_s     = prop(14);
  Dm_l     = prop(16);
  dt       = prop(13);
  lmushy   = prop(15);
  upwind   = prop(19);
  Dm_l_turb= prop(17);
  shocap   = prop(18);
  tol      = prop(12);


% Puntos de Gauss para elementos triangulares

  psipg = [ 1/6  2/3  1/6 ];
  etapg = [ 1/6  1/6  2/3 ];
  wpg   = [ 1/6  1/6  1/6 ];
  npg   = 3;

t=cputime;
%[xt,icot,ico2tt,xfather,Te,Ce,velex,veley,eles_father] = ...          
%      mushint2(xnod,icone,Te0,Ce0,veloc,Tm,slopel,kp,eles) ;

  ceros = zeros(length(eles),nen);
  xe = ceros;
  ve = ceros;  
  for inod=1:nen,
   nodes = icone(eles,inod);
   xe(:,inod)   = xnod(nodes,1);
   xe(:,inod+3) = xnod(nodes,2);
   ve(:,inod)   = veloc(nodes,1);
   ve(:,inod+3) = veloc(nodes,2);
  end
 
  N  = 4;
  n0 = nnod;

  [fsole] = frsol2(m2v(Te0),m2v(Ce0),Tm,slopel,kp);
  fsole = v2m(fsole,3);
  itri_mushy = (max(fsole')>tol)&(min(fsole')<(1-tol));
  eles_m = find(itri_mushy==1);

  
  xt = xnod;icot = icone;Te=Te0;Ce=Ce0;
  velex=ve(:,1:nen);veley=ve(:,nen+1:2*nen);
  eles_father=eles;
  if isempty(eles_m)==0, 
  [xt,icot,velt,Te,Ce,eles_father] = ... 
     Intvar(xe(eles_m,:),Te0(eles_m,:),Ce0(eles_m,:),ve(eles_m,:),eles_m,N,n0);

  xt   = [xnod;xt];
  Te0(eles_m,:)  =[];
  Ce0(eles_m,:)  =[];
  ve(eles_m,:)   =[];
  velx = [veloc(:,1);velt(:,1)];
  vely = [veloc(:,2);velt(:,2)];

  for inod=1:nen,
   nodes = icot(:,inod)-n0;
   Te1(:,inod) = Te(nodes,1);
   Ce1(:,inod) = Ce(nodes,1);
   vxele1(:,inod) = velx(nodes,1);
   vyele1(:,inod) = vely(nodes,1);
  end

  Te = [Te0;Te1];
  Ce = [Ce0;Ce1];
  velex = [ve(:,1:3); vxele1];
  veley = [ve(:,4:6); vyele1];

  icot0 = icone;
  icot0(eles_m,:)=[];
  icot = [icot0;icot];

  eles_father = [eles;eles_father];
  eles_father(eles_m) = [];

  clear Te1 Ce1 vxele1 vyele1 icot0

  end

t_A = cputime-t;
t=cputime;

   ntri = length(icot(:,1));
   eles = (1:ntri)';

   Kelet = zeros(ntri,9*ndf^2);
   Relet = zeros(ntri,3*ndf);

   Tev = m2v(Te);
   Cev = m2v(Ce);

   [fsole,dfsdTe,dfsdCe,Cse,dCsdTe,dCsdCe] = ... 
         frsol2(Tev,Cev,Tm,slopel,kp);

%   [fsole] = frsol2(Tev,Cev,Tm,slopel,kp);
   fsole = v2m(fsole,3);

   itri_mushy = (max(fsole')>tol)&(min(fsole')<(1-tol));
   itri_mushy = [itri_mushy ; itri_mushy ; itri_mushy ]';

%   [fsole,dfsdTe,dfsdCe,Cse,dCsdTe,dCsdCe] = ... 
%         frsol2(Tev,Cev,Tm,slopel,kp,m2v(itri_mushy));


%         fsole = v2m(fsole,3);
%        dfsdTe = v2m(dfsdTe,3);
%        dfsdCe = v2m(dfsdCe,3);
         Cse = v2m(Cse,3);
%        dCsdTe = v2m(dCsdTe,3);
%        dCsdCe = v2m(dCsdCe,3);
%        RgTe   = zeros(size(Te));
%        RgCe   = zeros(size(Te));

if nen==4,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles_father,:),0,0);
  [dNdx0,dNdy0,N] = shape(X2S,0,0,nen); 
elseif nen==3,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles_father,:),1/3,1/3);
  [dNdx0,dNdy0,N] = shape(X2S,1/3,1/3,nen); 
else
  error(' Bad type of element , nen ~=3, nen ~=4 ')
end

t_B = cputime-t;
t=cputime;

% Lazo sobre puntos de Gauss del interior

  for ipg=1:npg
    [X2S,S2X,Jaco] = xy2st(xt,icot(eles,:),psipg(ipg),etapg(ipg));
    [dNdx,dNdy,N]  = shape(X2S,psipg(ipg),etapg(ipg),3); 
    ne         = ntri;

%  Interpolacion en el punto de Gauss

     Tpg    = zeros(ne,1);
    dTpg    = zeros(ne,2);
     Cpg    = zeros(ne,1);
    dCpg    = zeros(ne,2);
   dCspg    = zeros(ne,2);
   velpg    = zeros(ne,2);
    fspg    = zeros(ne,1);
   dfspg    = zeros(ne,2);

  for inod=1:nen,
      Tpg(:,1)  =     Tpg(:,1) +      N(inod).*    Te(:,inod);
     dTpg(:,1)  =    dTpg(:,1) + dNdx(:,inod).*    Te(:,inod);
     dTpg(:,2)  =    dTpg(:,2) + dNdy(:,inod).*    Te(:,inod);
      Cpg(:,1)  =     Cpg(:,1) +      N(inod).*    Ce(:,inod);
     dCpg(:,1)  =    dCpg(:,1) + dNdx(:,inod).*    Ce(:,inod);
     dCpg(:,2)  =    dCpg(:,2) + dNdy(:,inod).*    Ce(:,inod);
    dCspg(:,1)  =   dCspg(:,1) + dNdx(:,inod).*   Cse(:,inod);
    dCspg(:,2)  =   dCspg(:,2) + dNdy(:,inod).*   Cse(:,inod);
    velpg(:,1)  =   velpg(:,1) +      N(inod).* velex(:,inod);
    velpg(:,2)  =   velpg(:,2) +      N(inod).* veley(:,inod);
     fspg(:,1)  =    fspg(:,1) +      N(inod).* fsole(:,inod);
    dfspg(:,1)  =   dfspg(:,1) + dNdx(:,inod).* fsole(:,inod);
    dfspg(:,2)  =   dfspg(:,2) + dNdy(:,inod).* fsole(:,inod);
  end

    mushy_e    = itri_mushy(:,1);

	[Relet]= KyR005(Relet,Tpg,Cpg,dTpg,dCpg,dCspg,dfspg,velpg,dt,fspg,...
             N,dNdx,dNdy,Jaco,wpg(ipg),dNdx0,dNdy0,Jaco0,mushy_e,prop,...
		     coe,ndf,nen,0);
  end % for ipg        

% Lazo sobre puntos de Gauss del contorno

  npg_bou = 2;
  xpg  = 1/sqrt(3);
  psipg = [ - xpg  xpg ];
  wpg   = [     1    1 ];
  nface = nen;
  nodes = [(1:nen)' [(2:nen)';1]];

  for ifa=1:nface,

  nn = find(iface(:,2)==ifa);
  eles_bou = eles(iface(nn,1));
  n1 = icone(eles_bou,nodes(ifa,1));
  n2 = icone(eles_bou,nodes(ifa,2));
  dx = (xnod(n2,1)-xnod(n1,1));
  dy = (xnod(n2,2)-xnod(n1,2));
  hele = sqrt(dx.^2+dy.^2);
  nx = dy./hele;
  ny = -dx./hele;

  Relebou = zeros(length(eles_bou),2*ndf);

  for ipg=1:npg_bou,

%  [X2S,S2X,Jaco]  = xy2st(xnod,icone(eles_bou,nodes(ifa,:)),psipg(ipg));
%  [dNdx,N]        = shape1d(X2S,psipg(ipg),2); 

  N    = [0.5*(1-psipg(ipg)) , 0.5*(1+psipg(ipg))];
  Jaco = 0.5*hele;

  ne = length(eles_bou);

%  Interpolacion en el punto de Gauss
     Tpg    = zeros(ne,1);
     Cpg    = zeros(ne,1);
   velpg    = zeros(ne,2);
    fspg    = zeros(ne,1);

  for inod=1:2,
    Tpg(:,1)  =   Tpg(:,1) +   N(inod).*  Te(eles_bou,nodes(ifa,inod));
    Cpg(:,1)  =   Cpg(:,1) +   N(inod).*  Ce(eles_bou,nodes(ifa,inod));
    velpg(:,1)=   velpg(:,1) +   N(inod).* ...
(velex(eles_bou,nodes(ifa,inod)).*nx + veley(eles_bou,nodes(ifa,inod)).*ny);		  
    fspg(:,1) =   fspg(:,1) +  N(inod).* fsole(eles_bou,nodes(ifa,inod));
  end

	[Relebou]= KyR005(Relebou,Tpg,Cpg,dTpg,dCpg,dCspg,dfspg,velpg,dt,fspg,...
             N,dNdx,dNdy,Jaco,wpg(ipg),dNdx0,dNdy0,Jaco0,mushy_e,prop,...
		     coe,ndf,nen,1);


  end  % for ipg

  n1 = nodes(ifa,1);
  n2 = nodes(ifa,2);
  for idf=1:ndf,
  Relet(eles_bou,(n1-1)*ndf+idf)= Relet(eles_bou,(n1-1)*ndf+idf) + ... 
                                  Relebou(:,idf);
  Relet(eles_bou,(n2-1)*ndf+idf)= Relet(eles_bou,(n2-1)*ndf+idf) + ... 
                                  Relebou(:,ndf+idf);
  end % for idf

%disp(' RES005 ');keyboard;pause
  end  % for ifa



t_C = cputime-t;
t=cputime;

% Transformacion entre elementos triangulares

xh=[]; yh=[];
for inod=1:nen,
  xh = [xh , xnod(icone(eles_father,inod),1)];
  yh = [yh , xnod(icone(eles_father,inod),2)];
end
xfather = [m2v(xh),m2v(yh)];

xson    = xt(m2v(icot),:);
ico2tt  = ones(ntri,1)*[1 2 3];

[Kele1,Rele1] = mapT2T(xfather,xson,Kelet,Relet,ico2tt,ntri,ndf,nen,-1);

eles    = eles_father;
for itri=1:ntri,
  Rele(eles(itri),:)=  Rele(eles(itri),:)+Rele1(itri,:);
end

t_D = cputime-t;

disp([' t_A = ' num2str(t_A)  ])
disp([' t_B = ' num2str(t_B)  ])
disp([' t_C = ' num2str(t_C)  ])
disp([' t_D = ' num2str(t_D)  ]);pause(0.1)
