function [Rele] = ...
    Res007(Rele,eles,xnod,icone,iface,Te,He,rhoae,Teold,Heold,rhoaeold,... 
	       veloc,prop,nen,ndf,coe,teco,bccv,ijob)
%------------------------------------------------------------------

%global Test Hest rhoaest

  [nnod,ndm] = size(xnod);
  [numel,nen]= size(icone);

  re = zeros(length(eles),nen);
  for inod=1:nen,
   nodes = icone(eles,inod);
   re(:,inod)      = xnod(nodes,1);
  end

  npg      = prop(1);
  dt       = prop(13);
  upwind   = prop(19);
  shocap   = prop(18);
  axisim   = prop(16);
  tol      = prop(12);

  if nen==4,
   if npg==4,
    xpg  = sqrt(3)/3;
    psipg = [ -xpg xpg xpg -xpg ];
    etapg = [ -xpg -xpg xpg xpg ];
    wpg   = [    1   1   1    1 ];
   elseif npg==1,
    xpg  = 0;
    psipg = [ xpg ];
    etapg = [ xpg ];
    wpg   = [   4 ];
   end
  else
   if npg==3,
    psipg = [ 1/6  2/3  1/6 ];
    etapg = [ 1/6  1/6  2/3 ];
    wpg   = [ 1/6  1/6  1/6 ];
   elseif npg==1,
    psipg = [ 1/3 ];
    etapg = [ 1/3 ];
    wpg   = [ 1/2 ];
   end
  end

%t=cputime;

   Relet = zeros(numel,nen*ndf);

if nen==4,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),0,0);
  [dNdx0,dNdy0,N] = shape(X2S,0,0,nen); 
elseif nen==3,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),1/3,1/3);
  [dNdx0,dNdy0,N] = shape(X2S,1/3,1/3,nen); 
else
  error(' Bad type of element , nen ~=3, nen ~=4 ')
end

  ceros = zeros(length(eles),nen);
  velex = ceros;
  veley = ceros;
  for inod=1:nen,
   nodes = icone(eles,inod);
   velex(:,inod) = veloc(nodes,1);
   veley(:,inod) = veloc(nodes,2);
  end

%t_B = cputime-t;
%t=cputime;

  for ipg=1:npg
    [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
    [dNdx,dNdy,N]  = shape(X2S,psipg(ipg),etapg(ipg),nen); 

%  Interpolacion en el punto de Gauss
     ne     = numel;
     Tpg    = zeros(ne,1);
    dTpg    = zeros(ne,2);
     Hpg    = zeros(ne,1);
    dHpg    = zeros(ne,2);
  rhoapg    = zeros(ne,1);
 drhoapg    = zeros(ne,2);
   velpg    = zeros(ne,2);
   radpg    = zeros(ne,1);

     Tpgold    = zeros(ne,1);
     Hpgold    = zeros(ne,1);
     rhoapgold = zeros(ne,1);

  for inod=1:nen,
    radpg(:,1)  =   radpg(:,1) +      N(inod).*    re(:,inod);
      Tpg(:,1)  =     Tpg(:,1) +      N(inod).*    Te(:,inod);
     dTpg(:,1)  =    dTpg(:,1) + dNdx(:,inod).*    Te(:,inod);
     dTpg(:,2)  =    dTpg(:,2) + dNdy(:,inod).*    Te(:,inod);
      Hpg(:,1)  =     Hpg(:,1) +      N(inod).*    He(:,inod);
     dHpg(:,1)  =    dHpg(:,1) + dNdx(:,inod).*    He(:,inod);
     dHpg(:,2)  =    dHpg(:,2) + dNdy(:,inod).*    He(:,inod);
   rhoapg(:,1)  =     rhoapg(:,1) +      N(inod).*    rhoae(:,inod);
  drhoapg(:,1)  =    drhoapg(:,1) + dNdx(:,inod).*    rhoae(:,inod);
  drhoapg(:,2)  =    drhoapg(:,2) + dNdy(:,inod).*    rhoae(:,inod);
    velpg(:,1)  =   velpg(:,1) +      N(inod).* velex(:,inod);
    velpg(:,2)  =   velpg(:,2) +      N(inod).* veley(:,inod);

      Tpgold(:,1)  =  Tpgold(:,1)    + N(inod).*  Teold(:,inod);
      Hpgold(:,1)  =  Hpgold(:,1)    + N(inod).*  Heold(:,inod);
   rhoapgold(:,1)  =  rhoapgold(:,1) + N(inod).*  rhoaeold(:,inod);


  end

	[Relet]= KyR007(Relet,Tpg,Hpg,rhoapg,dTpg,dHpg,drhoapg,velpg,dt,...
             N,dNdx,dNdy,Jaco,wpg(ipg),dNdx0,dNdy0,Jaco0,prop,...
		 radpg,coe,ndf,nen,Tpgold,Hpgold,rhoapgold);
  end % for ipg        

Rele = Rele + Relet;

% Integrales de contorno

% Condicion de contorno mixta (enfriamiento Newtoniano)
if ~isempty(teco), 
  ijob    = 1;
  [nn,mm] = size(teco);
  if mm~=5, error(' Falta 5 columna arreglo TECO - ecuacion a aplicar ');end
  nn = find(teco(:,5)==1);
  teco_T = teco(nn,1:4);
  [bas,Rele] = bc_teco2(xnod,icone,Te,teco_T,[],Rele,ijob,1,ndf);
  nn = find(teco(:,5)==2);
  teco_H = teco(nn,1:4);
  [bas,Rele] = bc_teco2(xnod,icone,He,teco_H,[],Rele,ijob,2,ndf);
end

% Condicion de contorno termino advectivo debilitado
 if ijob==0,
   [Rele] = bc_conv(xnod,icone,Te,He,rhoae,bccv,Rele,ndf,axisim);
 end

%disp(' RES007 ');keyboard;pause
