function [row,col,coe] = assemble(Kele,icone,ndf,ijob)
%
%    [row,col,coe] = assemble(Kele,icone,ndf,ijob)
%
%  Esta nueva version permite montar tanto matrices como vectores 
%  y de esta forma se evita problemas relacionado con la operacion 
%  de gather de chunks de elementos que apuntan al mismo nodo.
%                                                     Abril 2000

if nargin==2, ndf=1;end
if nargin<4, ijob=0; end

[numel,nen]=size(icone);

row = []; col = []; coe = [];

if ijob==0,
% monta una matriz
for inod=1:nen,
 for jnod=1:nen,
  for idf=1:ndf,
   for jdf=1:ndf,
    %in = (((1:numel)-1)*nen^2+(inod-1)*nen+(jnod-1))*ndf^2+(idf-1)*ndf+jdf;
    row = [row;(icone(:,inod)-1)*ndf+idf];
    col = [col;(icone(:,jnod)-1)*ndf+jdf];
    coe = [coe;Kele(:,((inod-1)*nen+jnod-1)*ndf^2+(idf-1)*ndf+jdf)];
   end
  end
 end
end

else
% monta un vector

for inod=1:nen,
  for idf=1:ndf,
    %in = ((1:numel)-1)*nen*ndf + (inod-1)*ndf + idf ;
    row = [row;(icone(:,inod)-1)*ndf+idf];
    col = [col;(icone(:,inod)-1)*ndf+idf];
    coe = [coe;Kele(:,(inod-1)*ndf+idf)];
  end
end

end