function [Rele,Kele] = bc_conv_addi(xnod,icone,vel,U,bou_data,Rele,Kele,axisim)
%
%      [Rele,Kele] = bc_conv_addi(xnod,icone,vel,U,bou_data,Rele,Kele,axisim)
%

ndf=1;
ndm=2;
[numel,nen] = size(icone);
[nbou,bas] = size(bou_data);

if nbou>0,

  xpg    = sqrt(3)/3;
  psipg  = [ -xpg xpg ];
  wpg    = [   1   1  ];

  eles_bou = bou_data(:,1);
  face_bou = bou_data(:,2);

  mask = zeros(nbou,1);
  
  nodo_1 = face_bou;
  nodo_2 = (nodo_1+1).*(nodo_1<nen)+(nodo_1==nen);
  nodos  = [nodo_1,nodo_2];
  nodog1 = getcol(icone(eles_bou,:),nodo_1);
  nodog2 = getcol(icone(eles_bou,:),nodo_2);
  nodog  = [nodog1 , nodog2];
  dxbc   = xnod(nodog2,1) - xnod(nodog1,1);
  dybc   = xnod(nodog2,2) - xnod(nodog1,2);
  lbou   = sqrt(dxbc.^2+dybc.^2);
  norbc  = [dybc./lbou, -dxbc./lbou];

  re = v2m(xnod(icone(eles_bou,:)',1),nen);
  re = [getcol(re,nodo_1), getcol(re,nodo_2) ];

  Ue = zeros(nbou,ndf*2);
  vele = zeros(nbou,2*ndm);
  for idf=1:ndf
    Ue(:,idf)     = getcol(U(eles_bou,:),(nodo_1-1)*ndf+idf);
    Ue(:,ndf+idf) = getcol(U(eles_bou,:),(nodo_2-1)*ndf+idf);
  end
    
  for idm=1:ndm,
    vele(:,1+(idm-1)*2) = getcol(vel(eles_bou,:),nodo_1+(idm-1)*nen);    
    vele(:,2+(idm-1)*2) = getcol(vel(eles_bou,:),nodo_2+(idm-1)*nen);     
  end  
 
  for ipg=1:2,

   N = ones(nbou,1)*[(1-psipg(ipg))/2 , (1+psipg(ipg))/2 ];
   
   Upg      = zeros(nbou,ndf);
   radpg    = zeros(nbou,1);
   velpg    = zeros(nbou,ndm);
   for inod=1:2,    
    radpg   = radpg +  N(:,inod).*re(:,inod);
    Upg    = Upg    + (N(:,inod)*ones(1,ndf)).*Ue(:,(inod-1)*ndf+(1:ndf));
    velpg  = velpg  + (N(:,inod)*ones(1,ndm)).*vele(:,inod+[0,2]);    
   end 
   
   vn     =  sum((velpg.*norbc)')';
   Fan    =  Upg.*vn;
               
   xsj = wpg(ipg)*lbou/2;
   if axisim,
     xsj = xsj.*radpg;
   end

   for iface=1:nen,
     eles = find(face_bou==iface);      
     for inod=1:2,
       jnod = iface-1+inod;
       if(jnod>nen),jnod=1; end 
       ip=(jnod-1)*ndf+(1:ndf);
       vaux  =  (N(eles,inod).*xsj(eles)*ones(1,ndf)).*Fan(eles,1:ndf);
	    Rele(eles_bou(eles),ip) = Rele(eles_bou(eles),ip) - vaux;          
       for iinod=1:2, 
         jjnod = iface-1+iinod;
         if(jjnod>nen),jjnod=1; end           
         ip=((jnod-1)*nen+(jjnod-1))*ndf^2;         
         vaux  =  (N(eles,inod).*xsj(eles)).*vn(eles,1).*N(eles,iinod);         
         Kele(eles_bou(eles),ip+1) = Kele(eles_bou(eles),ip+1) + vaux;         
       end % for iinod
     end  % for inod
    end % for iface
   end % puntos de Gauss del contorno

end % if bou

% disp(' BC_CONV_EULER ');keyboard;pause
