function [Rg,Kg] = bc_peri(Rg,Kg,peri,ndf,ijob);  
%
%   [Rg,Kg] = bc_peri(Rg,Kg,peri,ndf,ijob);  
%
%------------------------------------------------------------------
%       Aplicamos condiciones de periodicidad
%
%    arreglo PERI    i (col 1 ) ----> j (col 2)
%------------------------------------------------------------------
%
%  ijob = 0 ---> apply periodical bc to both Rg & Kg
%  ijob = 1 ---> apply periodical bc only to Rg
%  ijob = 2 ---> apply periodical bc to Rg and other array similar to Rg
%

 if nargin<5, ijob=0; end
 if ijob<0 | ijob>2, error(' BC_PERI - ijob out of range '); end

 if isempty(peri)==0,
   n1 = peri(:,1); 
   n2 = peri(:,2);

   if ijob==0,

   for idf=1:ndf,
    Kg((n2-1)*ndf+idf,:) = Kg((n2-1)*ndf+idf,:)+Kg((n1-1)*ndf+idf,:);
    Kg((n1-1)*ndf+idf,:) = 0*Kg((n1-1)*ndf+idf,:);
    Kg((n1-1)*ndf+idf,(n1-1)*ndf+idf)= eye(size(n1),size(n1));
    Kg((n1-1)*ndf+idf,(n2-1)*ndf+idf)=-eye(size(n1),size(n2));
    Rg((n2-1)*ndf+idf,1) = Rg((n2-1)*ndf+idf,1)+Rg((n1-1)*ndf+idf,1);
    Rg((n1-1)*ndf+idf,1) = 0*Rg((n1-1)*ndf+idf,1);
   end

   elseif ijob==2, 

   for idf=1:ndf,
    Kg((n2-1)*ndf+idf,1) = Kg((n2-1)*ndf+idf,1)+Kg((n1-1)*ndf+idf,1);
    Kg((n1-1)*ndf+idf,1) = Kg((n2-1)*ndf+idf,1);
    Rg((n2-1)*ndf+idf,1) = Rg((n2-1)*ndf+idf,1)+Rg((n1-1)*ndf+idf,1);
    Rg((n1-1)*ndf+idf,1) = Rg((n2-1)*ndf+idf,1);
   end

   else

   for idf=1:ndf,
    Rg((n2-1)*ndf+idf,1) = Rg((n2-1)*ndf+idf,1)+Rg((n1-1)*ndf+idf,1);
    Rg((n1-1)*ndf+idf,1) = 0*Rg((n1-1)*ndf+idf,1);
   end

   end  

 end

%disp(' BC_PERI ');keyboard;pause