function [Rg,Kg] = bc_pvap(phi,Rg,Kg,bcpv,pvatm);  
%
%
%

if isempty(bcpv), 
  return; 
end

T          = phi(bcpv,1);
H          = phi(bcpv,2);
rhoa       = phi(bcpv,3);

scaling    = 1;

indx = (bcpv-1)*3;

% RESIDUO

Rg(indx+2) = 0*Rg(indx+2);

[rho_s,Cp_s,Cp_s0,Kgz,Kgx,mu_g,Psat,dPsatdT,kappa_z,kappa_x,Cp_g, ...  
                DeltaH,epsilon,Ra,Rv,Patm,MMv,MMa]=coefmat(T,H);

[HR,dHRdT,dHRdH] = Hrel(T,H);

Rg(indx+2) = scaling*(Psat.*HR-pvatm);

% JACOBIANO

ndof = size(Kg,1);
Kg(indx+2,:) = 0*Kg(indx+2,:);
coef  = scaling*(dPsatdT.*HR+Psat.*dHRdT);
Kgadd = sparse(indx+2,indx+1,-coef,ndof,ndof);
Kg = Kg+Kgadd;
coef  = scaling*Psat.*dHRdH;
Kgadd = sparse(indx+2,indx+2,-coef,ndof,ndof);
Kg = Kg+Kgadd;

%disp('bc_pvap');keyboard;pause
