function [slip_data] = get_normal(xnod,icone,slip)
%
% Calculo de la normal a cada nodo perteneciente al borde SLIP
%
%        [slip_data] = get_normal(xnod,icone,slip)
%-----------------------------------------------------------------

[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);

 nslip = length(slip(:,1));
 if ndm==2,
   if nen==4, node_face = [1;2;3;4;1];end
   if nen==3, node_face = [1;2;3;1]  ;end
   eles= slip(:,1);
   face= slip(:,2);
   nod1= getcol(icone(eles,:),node_face(face));
   nod2= getcol(icone(eles,:),node_face(face+1));
   L_ele  = [xnod(nod2,1)-xnod(nod1,1) , xnod(nod2,2)-xnod(nod1,2)];
   tg_ele = L_ele;
   L_ele  = sqrt(sum(L_ele'.^2))';

   tg_ele = tg_ele ./ (L_ele*ones(1,2));
   no_ele = [-tg_ele(:,2) tg_ele(:,1)];
   normal = zeros(numnp,ndm);
   L_nod  = zeros(numnp,1);

   for k=1:nslip,
     normal(nod1(k),:) = normal(nod1(k),:)+L_ele(k)*no_ele(k,:);
     normal(nod2(k),:) = normal(nod2(k),:)+L_ele(k)*no_ele(k,:);
     L_nod(nod1(k)) = L_nod(nod1(k))+L_ele(k);
	 L_nod(nod2(k)) = L_nod(nod2(k))+L_ele(k);
   end

   nn = find(L_nod>0);
   nodes_slip = nn;
   normal(nn,:) = normal(nn,:)./(L_nod(nn)*ones(1,ndm));
   normal = normal(nn,:);
   vaux = sqrt(sum(normal'.^2))';
   normal = normal./(vaux*[1,1]);
   slip_data = [nodes_slip , normal ] ;
   
 else
   error(' IMPLEMENTACION 3D NO DISPONIBLE AUN ')
 end

