% Calculos del elemento propiamente dichos
%------------------------------------------------------------------

  beta_supg = 1.0;      % consistent SUPG mass matrix parameter
 						      % [0] consistent Galerkin ; [1] consistent SUPG
  implicit_factor = 1;  % [1] full implicit ; 
                        % [0] only mass matrix is implicit ;
  
  ne    = length(eles);
  
  weak_form = 1;
  
% Localizacion
%------------------------------------------------------------------

    ceros = zeros(length(eles),nen);
       Te = ceros;
      T0e = ceros;
    velex = ceros;
    veley = ceros;
	radio = ceros;

  for inod=1:nen,
               nodes = icone(eles,inod);
       Te(:,inod) = T(nodes);
      T0e(:,inod) = Told(nodes);
    velex(:,inod) = veloc(nodes,1);
    veley(:,inod) = veloc(nodes,2);
    radio(:,inod) = xnod(nodes,1);
  end




% Calculo del tamao del elemento en el centroide del elemento
%------------------------------------------------------------------

if nen0==4,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),0,0);
  [dNdx0,dNdy0,N0] = shape(X2S,0,0,nen0); 
elseif nen0==3,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),1/3,1/3);
  [dNdx0,dNdy0,N0] = shape(X2S,1/3,1/3,nen0); 
else
  error(' Bad type of element , nen ~=3, nen ~=4 ')
end

  vele_0  = zeros(ne,2);
  kappa_0 = kappa/rho/Cp; 
  for inod=1:nen0,
    vele_0(:,1)  =   vele_0(:,1) +  N0(inod).* velex(:,inod);
    vele_0(:,2)  =   vele_0(:,2) +  N0(inod).* veley(:,inod);
  end
  hele_0          = h_supg(vele_0,dNdx0,dNdy0);


if 0,
% SUPG standard
%------------------------------------------------------------------
  velmod          = sqrt(sum(vele_0'.^2))';
  mask            = (velmod<1e-10);
  if nen0==4, hele_0 = mask.*(sqrt(4.0*Jaco0/pi))+(1-mask).*hele_0;end
  if nen0==3, hele_0 = mask.*(sqrt(0.5*Jaco0/pi))+(1-mask).*hele_0;end
  tau_0           = upwind*supg2(vele_0,hele_0,kappa_0);

  difu_anis = zeros(ne,4);             
  if shocap,
    difu_supg = tau_0.*sum(vele_0'.^2)';
    difu_anis = ... 
	   shocap2d(vele_0,gT_0,T_0,reac,source,kappa_0,difu_supg,hele_0);
  end
end

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------

 for ipg=1:npg

  [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
  [dNdx,dNdy,N] = shape(X2S,psipg(ipg),etapg(ipg),nen); 

% Interpolacion en punto de Gauss
%------------------------------------------------------------------

     Tpg    = zeros(ne,1);
    T0pg    = zeros(ne,1);
    dTpg    = zeros(ne,2);
   velpg    = zeros(ne,2);
   radpg    = zeros(ne,1);

  for inod=1:nen,
      Tpg(:,1)  =     Tpg(:,1) +      N(inod).*    Te(:,inod);
     T0pg(:,1)  =    T0pg(:,1) +      N(inod).*   T0e(:,inod);
     dTpg(:,1)  =    dTpg(:,1) + dNdx(:,inod).*    Te(:,inod);
     dTpg(:,2)  =    dTpg(:,2) + dNdy(:,inod).*    Te(:,inod);
    velpg(:,1)  =   velpg(:,1) +      N(inod).* velex(:,inod);
    velpg(:,2)  =   velpg(:,2) +      N(inod).* veley(:,inod);
	radpg(:,1)  =   radpg(:,1) +      N(inod).* radio(:,inod);
  end
  
  velmod          = sqrt(sum(velpg'.^2))';
  mask            = (velmod<1e-10);
  if nen0==4, hele_0 = mask.*(sqrt(4.0*Jaco0/pi))+(1-mask).*hele_0;end
  if nen0==3, hele_0 = mask.*(sqrt(0.5*Jaco0/pi))+(1-mask).*hele_0;end
  tau             = upwind*supg2(velpg,hele_0,kappa_0);

  difu_anis = zeros(ne,4);             
  if shocap,
    difu_supg = tau.*sum(velpg'.^2)';
    difu_anis = ... 
	   1*shocap2d(velpg,dTpg,Tpg,reac,source,kappa_0,difu_supg,hele_0);
  end
  
%disp('FEM0001');keyboard;pause

% Calculo de funciones de peso perturbadas (Petrov-Galerkin)
%------------------------------------------------------------------
  kappa_pg      = kappa /rho/Cp; 
  for inod=1:nen,
   P1_pg(:,inod) = tau .* ... 
    ( velpg(:,1) .*dNdx(:,inod) + velpg(:,2) .*dNdy(:,inod) );
  end 

% Correccion axisimetrica del jacobiano de la transformacion al elemento master
%------------------------------------------------------------------
  xsj =  wpg(ipg) .* Jaco;
  if axisim,
     xsj = xsj.*radpg;
  end

% Calculo matriz tangente y residuo
%--------------------------------------------------------------------

  for inod=1:nen,
   if ijob==0,

    for jnod=1:nen,
     ip=((inod-1)*nen+(jnod-1))*ndf^2;

	 if lumped,
       if inod==jnod, ter1 = (N(inod))/dt   ;else ter1=0; end
     else
       ter1 = (N(inod)+beta_supg*P1_pg(:,inod))*N(jnod)/dt   ;
	 end
    if weak_form,
       ter2 = -(dNdx(:,inod).*velpg(:,1)+dNdy(:,inod).*velpg(:,2)).*N(jnod);
       ter2 = ter2 + P1_pg(:,inod).*velpg(:,1).*dNdx(:,jnod) + ...
                     P1_pg(:,inod).*velpg(:,2).*dNdy(:,jnod) ;              
    else
      ter2 = (N(inod)+P1_pg(:,inod)).*velpg(:,1).*dNdx(:,jnod) + ...
             (N(inod)+P1_pg(:,inod)).*velpg(:,2).*dNdy(:,jnod) ;                  
    end
     ter3 = (dNdx(:,inod).*dNdx(:,jnod) + ... 
             dNdy(:,inod).*dNdy(:,jnod)).* kappa_pg ;
     ter4 = dNdx(:,inod).* ... 
	    (difu_anis(:,1).*dNdx(:,jnod)+difu_anis(:,2).*dNdy(:,jnod)) + ...
		    dNdy(:,inod).* ...
	    (difu_anis(:,3).*dNdx(:,jnod)+difu_anis(:,4).*dNdy(:,jnod)) ;
     ter5 = (N(inod)+P1_pg(:,inod))*N(jnod).*reac   ;
     Kele(:,ip+1) = Kele(:,ip+1) + ( ... 
              ter1+implicit_factor*(ter2+ter3+ter4+ter5)  ) .* xsj;
                           
    end  % jnod

   end % if ijob

    if lumped,
     ter1 = (N(inod)).*(Te(:,inod)-T0e(:,inod))/dt ;
	else
     ter1 = (N(inod)+beta_supg*P1_pg(:,inod)).*(Tpg-T0pg)/dt ;
	end
   if weak_form,
      ter2 = -(dNdx(:,inod).*velpg(:,1)+dNdy(:,inod).*velpg(:,2)).*Tpg;
      ter2 = ter2 + P1_pg(:,inod).*velpg(:,1).*dTpg(:,1) + ...
                    P1_pg(:,inod).*velpg(:,2).*dTpg(:,2) ;            
   else
     ter2 = (N(inod)+P1_pg(:,inod)).*velpg(:,1).*dTpg(:,1) + ...
            (N(inod)+P1_pg(:,inod)).*velpg(:,2).*dTpg(:,2) ;
                 
   end
    ter3 = (dNdx(:,inod).*dTpg(:,1)+dNdy(:,inod).*dTpg(:,2)).*kappa_pg ;
    ter4 = (dNdx(:,inod).* ... 
	        (difu_anis(:,1).*dTpg(:,1)+difu_anis(:,2).*dTpg(:,2)) + ...
	        dNdy(:,inod).* ... 
	        (difu_anis(:,3).*dTpg(:,1)+difu_anis(:,4).*dTpg(:,2)) );
    ter5 = (N(inod)+P1_pg(:,inod)).*source ;
	 ter6 = (N(inod)+P1_pg(:,inod)).*reac.*Tpg ;
    Rele(:,(inod-1)*ndf+1) = Rele(:,(inod-1)*ndf+1) - ( ...
	            ter1+ter2+ter3+ter4+ter5+ter6 ) .* xsj ;							 
  end % inod

 end % ipg

  
% ------ Terminos de contorno

%disp(' TRACE # 1 ')

if weak_form,
   [Rele,Kele] = bc_conv_addi(xnod,icone,[velex,veley],Te,ifaceb,Rele,Kele,axisim);
end
  