
% Calculos del elemento propiamente dichos
%------------------------------------------------------------------
   ne = numel;

% Puntos de Gauss para elementos unidimensionales
%------------------------------------------------------------------

   if npg==1,
    psipg = [ 0 ];
    wpg   = [  2 ];
   elseif npg==2,
    xpg  = 1/sqrt(3);
    psipg = [ - xpg  xpg ];
    wpg   = [     1    1 ];
   elseif npg==3,
    psipg = [-sqrt(3/5) 0 sqrt(3.5) ];
    wpg   = [ 5/9   8/9   5/9 ];    
   elseif npg==4,
    psipg = [ -0.8611363116  -0.3399810436 +0.3399810436 +0.8611363116 ];
	wpg   = [  0.3478548451 0.6521451549 0.6521451549 0.3478548451 ];
   elseif npg==5,
    psipg = [ -0.9061798459 -0.5384693101 0 +0.5384693101 +0.9061798459	];
	wpg   = [  0.2369268850  0.4786286705 0.5688888889 0.4786286705 0.2369268850];
   else
     error(' MALA SELECCION DE LA CANTIDAD DE PUNTOS DE GAUSS ')
   end

   nolineal = prop(10);
   if nolineal ~=0,
% Lee archivo FNOLIN (si existe) para actualizar coeficientes que pudieran 
% ser no funcion de la solucion
  if exist('FNOLIN.M')==2,
    FNOLIN;
  end
  end

% Fuerza masa lumped si la resolucion es explicita
 if ijob<0, lumped=1; end

% Localizacion ( valores globales en valores por elemento )
%------------------------------------------------------------------
    ceros = zeros(length(eles),nen);
       Te = ceros;
      T0e = ceros;
    velex = ceros;

  for inod=1:nen,
            nodes = icone(eles,inod);
       Te(:,inod) = T(nodes);
      T0e(:,inod) = Told(nodes);
    velex(:,inod) = veloc(nodes,1);
  end

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------
 for ipg=1:npg

% Calculo de transformacion isoparametrica y funciones de forma
%------------------------------------------------------------------
  [X2S,S2X,Jaco]  = xy2st(xnod,icone(eles,:),psipg(ipg));
  [dNdx,N]        = shape1d(X2S,psipg(ipg),nen); 

% Interpolacion en punto de Gauss
%------------------------------------------------------------------
     Tpg    = zeros(ne,1);
    T0pg    = zeros(ne,1);
    dTpg    = zeros(ne,1);
   velpg    = zeros(ne,1);

  for inod=1:nen,
      Tpg(:,1)  =     Tpg(:,1) +      N(inod).*    Te(:,inod);
     T0pg(:,1)  =    T0pg(:,1) +      N(inod).*   T0e(:,inod);
     dTpg(:,1)  =    dTpg(:,1) + dNdx(:,inod).*    Te(:,inod);
    velpg(:,1)  =   velpg(:,1) +      N(inod).* velex(:,inod);
  end

% Calculo de funciones de peso perturbadas (Petrov-Galerkin)
%------------------------------------------------------------------
  kappa_pg = kappa; 
  vel_supg = zeros(ne,1);
  for inod=1:nen,
    vel_supg(:,1)  =   vel_supg(:,1) +  N(inod).* velex(:,inod);
  end
  hele     = 2*Jaco;
  tau      = upwind*supg1d(vel_supg,hele,kappa_pg);
  for inod=1:nen,
   P1_pg(:,inod) = tau.*(vel_supg(:,1).*dNdx(:,inod));
  end 

  xsj =  wpg(ipg) .* Jaco;

%disp('FEM0000 [1] ');keyboard;pause

% Calculo matriz tangente y residuo
%--------------------------------------------------------------------

  for inod=1:nen,

   if ijob==0,
    for jnod=1:nen,
     ip=((inod-1)*nen+(jnod-1))*ndf^2;

	 if lumped,
       if inod==jnod, ter1 = (N(inod))/dt   ;else ter1=0; end
     else
       ter1 = (N(inod)+P1_pg(:,inod))*N(jnod)/dt  ;
	 end
	 if ijob==0,
       ter2 = (N(inod)+P1_pg(:,inod)).*velpg(:,1).*dNdx(:,jnod);
       ter3 = dNdx(:,inod).*dNdx(:,jnod).* kappa_pg  ;
       ter4 = (N(inod)+P1_pg(:,inod))*N(jnod).*reac ;
	 end
     Kele(:,ip+1) = Kele(:,ip+1) + ( ... 
	                    ter1+ter2+ter3+ter4) .* xsj;
    end  % jnod

   end % if ijob

   if ijob<0,
% Caso explicito
     ter1 = (N(inod))/dt ;
     Kele(:,(inod-1)*ndf+1) = Kele(:,(inod-1)*ndf+1) + ter1 .* xsj;
   end % if ijob

    if lumped,
     ter1 = (N(inod)).*(Te(:,inod)-T0e(:,inod))/dt ;
	else
     ter1 = (N(inod)+P1_pg(:,inod)).*(Tpg-T0pg)/dt ;
	end
    ter2 = (N(inod)+P1_pg(:,inod)).*velpg(:,1).*dTpg(:,1) ;    
    ter3 = (dNdx(:,inod).*dTpg(:,1)).*kappa_pg ;
	ter4 = (N(inod)+P1_pg(:,inod)).*reac.*Tpg ;
    ter5 = -(N(inod)+P1_pg(:,inod)).*source ;

    Rele(:,(inod-1)*ndf+1) = Rele(:,(inod-1)*ndf+1) - ( ...
	            ter1+ter2+ter3+ter4+ter5) .* xsj ;
							 
  end % inod

 end % ipg
%disp('FEM0000 [2] ');keyboard;pause