function [Mg,Rg] = fem002(xnod,icone,fixa,forc,teco,peri,prop,...
                          U,Uold,ijob)
%------------------------------------------------------------------
%
%     [Mg,Rg] = fem002(xnod,icone,fixa,forc,teco,peri,prop,
%                      U,Uold,ijob)
%
%       Caracteristicas del elemento:
%
%        #.- ecuaciones de Euler 
%        #.- elemento cuadrangular y triangular
%        #.- 2D, plano y axisimetrico
%        #.- no estacionario y explicito (masa diagonal)
%
%        ijob = 1 ---> matriz masa diagonal y residuo
%        ijob = 0 ---> solo residuo
%
%------------------------------------------------------------------

disp('FEM_002');keyboard;pause

  [numel,nen]   = size(icone);
  [numnp,ndf]   = size(U);
  if ndf~=4, error(' NDF debe ser 4 (Euler 2D) ');end
  ndm = 2;

%%%%%%%%%%%%%% PROPIEDADES DEL MATERIAL 
  gamma    = prop(1) ;
  Cou      = prop(2) ;
  kappa    = prop(3) ;
  npg      = prop(4);
  upwind   = prop(6);
  shocap   = prop(7);
  axisim   = prop(8);
  type_upw = prop(9);
  Cv       = prop(10);
  lumped   = prop(11);

  tol      = prop(12);
  dt       = prop(13);

  visco    = prop(14)  ;
  sigma    = prop(15)  ;
  Pran     = prop(16)  ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  if nen==3,
	if npg==3,npg=7;end
    if npg==2,npg=3;end
  elseif nen==4,
    if npg==2, npg=4; end
	if npg==3, npg=9; end
  else
    error(' Bad choice of Gauss point number ')
  end

  Rg   =0*forc;
  Mg   =zeros(size(Rg));

  Mele =zeros(numel,nen*ndf);
  Rele =zeros(numel,nen*ndf);

  eles     = (1:numel)';
  ceros    = zeros(length(eles),nen);

%t0=cputime;
  if length(eles)>0,    
% Elemento E27T21
%    fem0021;
% Elemento TET_1
    fem0022;
% Elemento PRECO_CHOI
%    fem0023;
% Elemento NO PRECO + SUPG HUGHES
%    fem0024;

  end


%------------------------------------------------------------------
%        Montaje
%------------------------------------------------------------------

%t0=cputime;

%  [row,col,coe] = assemble(Kele,icone,ndf);
%  Kg = sparse(row,col,coe);

%  for iele=1:numel,
  for inod=1:nen,
   for idf=1:ndf,
    ip=(inod-1)*ndf+idf;
	jp=(icone(:,inod)-1)*ndf+idf;
%    ip=(inod-1)*ndf+(1:ndf);
%	jp=(icone(iele,inod)-1)*ndf+(1:ndf);

    Mg(jp,1) = Mg(jp,1) + Mele(:,ip);
    Rg(jp,1) = Rg(jp,1) + Rele(:,ip);         
   end
  end
%  end

ldupli=0;
if ldupli,
% duplicamos masa nodos frontera para un problema en particular
[ifaceb] =pfbou2d(xnod,icone);
iaux = [(1:nen),1];
nodes=[];
for k=1:length(ifaceb(:,1)),
 iele  = ifaceb(k,1);
 face  = ifaceb(k,2);
 node  = [iaux(face);iaux(face+1)];
 nodes = [nodes;icone(iele,node)'];
end
nodes=rmdblist(nodes);
for k=1:length(nodes),
  Mg((nodes(k)-1)*ndf+(1:ndf),1)=2*Mg((nodes(k)-1)*ndf+(1:ndf),1);
end
end

% condiciones periodicas
  [Rg,Kg] = bc_peri(Rg,Kg,peri,ndf);  

