%------------------------------------------------------------------
% Continua de fem002
%------------------------------------------------------------------

  ne    = length(eles);
  taucte=0;

% Puntos de Gauss para elementos cuadrangulares y triangulares
%------------------------------------------------------------------

  if nen==4,
   if npg==4,
    xpg  = sqrt(3)/3;
    psipg = [ -xpg xpg xpg -xpg ];
    etapg = [ -xpg -xpg xpg xpg ];
    wpg   = [    1   1   1    1 ];
   elseif npg==1,
    xpg  = 0;
    psipg = [ xpg ];
    etapg = [ xpg ];
    wpg   = [   4 ];
   end
  else
   if npg==3,
    psipg = [ 1/6  2/3  1/6 ];
    etapg = [ 1/6  1/6  2/3 ];
    wpg   = [ 1/6  1/6  1/6 ];
   elseif npg==1,
    psipg = [ 1/3 ];
    etapg = [ 1/3 ];
    wpg   = [ 1/2 ];
   end
  end

% Localizacion
%------------------------------------------------------------------

    ceros = zeros(length(eles),nen*ndf);
       Ue = ceros;
      U0e = ceros;
	radio = ceros;

  for inod=1:nen,
            nodes = icone(eles,inod);
	         jnod = (inod-1)*ndf+(1:ndf);
       Ue(:,jnod) = U(nodes,1:ndf);
      U0e(:,jnod) = Uold(nodes,1:ndf);
    radio(:,inod) = xnod(nodes,1);
  end

 if taucte,

% Calculo de transformacion isoparametrica y funciones de forma
%------------------------------------------------------------------

if nen==4,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),0,0);
  [dNdx0,dNdy0,N0] = shape(X2S,0,0,nen); 
elseif nen==3,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),1/3,1/3);
  [dNdx0,dNdy0,N0] = shape(X2S,1/3,1/3,nen); 
else
  error(' Bad type of element , nen ~=3, nen ~=4 ')
end

%------------------------------------------------------------------
%                      SUPG version HUGHES
%------------------------------------------------------------------

  UC_0    = zeros(ne,ndf);
  gU_0    = zeros(ne,2*ndf);

  for inod=1:nen,
    jnod = (inod-1)*ndf+(1:ndf);
    UC_0(:,(1:ndf))  = UC_0(:,(1:ndf)) + N0(inod).* Ue(:,jnod);
	gU_0(:,(1:ndf))  = gU_0(:,(1:ndf)) + ...
	          (dNdx0(:,inod)*ones(1,ndf)).* Ue(:,jnod);
	gU_0(:,(1:ndf)+ndf) = gU_0(:,(1:ndf)+ndf)+ ...
	          (dNdy0(:,inod)*ones(1,ndf)).* Ue(:,jnod);
  end

  UP_0           = cv2pv(UC_0,gamma,+1);
  vele_0         = UP_0(:,2:ndf-1);
  hele_0         = h_supg(vele_0,dNdx0,dNdy0);
  velmod         = sqrt(sum(vele_0'.^2))';
  velmod         = velmod+(velmod<1e-16)*1e-16;

% segun la linea de corriente
%   kv = vele_0 ./ (velmod*ones(1,ndf-2));
%  [tau_0,dt] = Tau_Hug1(UC_0,UP_0,kv,hele_0,Cou,gamma);
% segun matriz jacobiana al elemento master
   kv = X2S;
  [tau_0,dt] = Tau_Hug2(UC_0,UP_0,kv,hele_0,Cou,gamma);

%  if shocap,
%    tau_shc = Shc_Hug(UC_0,UP_0,gU_0,hele_0, ... )	
%  end

  Ax_0   =  Ajac(UC_0,UP_0,gamma,1);
  Ay_0   =  Ajac(UC_0,UP_0,gamma,2);

% disp(' FEM_0002');keyboard;pause

 end  % taucte

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------

 for ipg=1:npg

  [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
  [dNdx,dNdy,N] = shape(X2S,psipg(ipg),etapg(ipg),nen); 

% Interpolacion en punto de Gauss
%------------------------------------------------------------------

     Upg    = zeros(ne,ndf);
    U0pg    = zeros(ne,ndf);
    dUpg    = zeros(ne,ndm*ndf);
   radpg    = zeros(ne,1);

  for inod=1:nen,
     jnod = (inod-1)*ndf+(1:ndf);
      Upg(:,(1:ndf))  =  Upg(:,(1:ndf)) + N(inod).*  Ue(:,jnod);
     U0pg(:,(1:ndf))  = U0pg(:,(1:ndf)) + N(inod).* U0e(:,jnod);
	 dUpg(:,(1:ndf))  = dUpg(:,(1:ndf)) + ...
	          (dNdx(:,inod)*ones(1,ndf)).* Ue(:,jnod);
	 dUpg(:,(1:ndf)+ndf) = dUpg(:,(1:ndf)+ndf)+ ...
	          (dNdy(:,inod)*ones(1,ndf)).* Ue(:,jnod);
	radpg(:,1)  =   radpg(:,1) +      N(inod).* radio(:,inod);
  end

%------------------------------------------------------------------
%                          KYRELE
%
%  Calcula constribuciones elementales a 
%  la matriz de masa diagonal M y al vector R
%
%------------------------------------------------------------------

  UPpg = cv2pv(Upg,gamma,+1);

  if ~taucte,

%t0  = cputime;

% segun matriz jacobiana al elemento master
   kv = X2S;
   vele_pg         = UPpg(:,2:ndf-1);
   hele_pg         = h_supg(vele_pg,dNdx,dNdy);

  [tau,dt] = Tau_Hug2(Upg,UPpg,kv,hele_pg,Cou,gamma);

%t = cputime-t0; disp([' Tau_Hug2 ' num2str(t) ])


  end

%t0 = cputime;

% jacobianos segun variable de estado en el pto de Gauss actual
  Ax   =  Ajac(Upg,UPpg,gamma,1);
  Ay   =  Ajac(Upg,UPpg,gamma,2);

% Calculo de los flujos advectivos, necesario si debilitamos el fluujo
% advectivo
%  [Fa] = fluxa(Upg,UPpg);

disp(' FEM_0002');keyboard;pause

% Correccion axisimetrica del jacobiano de la transformacion al elemento master
%------------------------------------------------------------------
  xsj =  wpg(ipg) .* Jaco;
  if axisim,
     xsj = xsj.*radpg;
  end

% Calculo matriz masa diagonal y residuo
%--------------------------------------------------------------------

%disp(' INGRESE TAU 1er elemento');keyboard;pause

    Fax = rowprod(Ax,dUpg(:,1:ndf),ndf,ndf,1);
    Fay = rowprod(Ay,dUpg(:,ndf+(1:ndf)),ndf,ndf,1);

    if taucte,
    Ataux = rowprod(Ax_0,tau_0,ndf,ndf,ndf);
    Atauy = rowprod(Ay_0,tau_0,ndf,ndf,ndf);
	else
    Ataux = rowprod(Ax,tau,ndf,ndf,ndf);
    Atauy = rowprod(Ay,tau,ndf,ndf,ndf);
	end

    AtauAdx = rowprod(Ataux,(Fax+Fay),ndf,ndf,1);
	AtauAdy = rowprod(Atauy,(Fax+Fay),ndf,ndf,1);

%disp(' FEM_0002 ');keyboard;pause

  for inod=1:nen,
    ip=(inod-1)*ndf+(1:ndf);

%------ Masa diagonal
      ter1 = N(inod)/dt ;
	  Mele(:,ip) = Mele(:,ip) + (ter1*xsj)*ones(1,ndf);

%------ Residuo

%    ter1 = N(inod)*(Upg(:,(1:ndf))-U0pg(:,(1:ndf)))/dt ;
%    ter2 = (N(inod)+P1_pg(:,ip)).*rowprod(Ax,dUpg(:,1:ndf),ndf,ndf,1)+ ...
%           (N(inod)+P1_pg(:,ip)).*rowprod(Ay,dUpg(:,ndf+(1:ndf)),ndf,ndf,1);

     ter1 = N(inod)*(Fax+Fay);
	 ter2 = rowprod(dNdx(:,inod)*m2v(eye(ndf))',AtauAdx,ndf,ndf,1)+...
            rowprod(dNdy(:,inod)*m2v(eye(ndf))',AtauAdy,ndf,ndf,1);

    Rele(:,ip) = Rele(:,ip) - ( ter1+ter2 ) .* (xsj*ones(1,ndf)) ;

% Esto se usaria si debilitamos el flujo advectivo
%    ter2 =  rowprod(Fa(:,1:ndf),dNdx(:,inod)*ones(1,ndf),ndf,ndf,1)+ ...
%            rowprod(Fa(:,ndf+(1:ndf)),dNdy(:,inod)*ones(1,ndf),ndf,ndf,1);
%    ter2 = ter2 + (P1_pg(:,ip)).*rowprod(Ax,dUpg(:,1:ndf),ndf,ndf,1)+ ...
%           (P1_pg(:,ip)).*rowprod(Ay,dUpg(:,ndf+(1:ndf)),ndf,ndf,1);
            

	            							 
  end % inod

%t = cputime-t0; disp([' Resto ' num2str(t) ])

 end % ipg

% ------ Terminos de contorno

% si debilitamos aparece un termino de contorno aqui del tipo
%   calculo normal a cada (elemento-cara) del borde
%   [eleb,faceb] = find_bou(????);
%   normal = ???
%   [Fa_n] = fluxan(Fa(eleb,:),normal);
% 	ver rutina bc_teco para armar algo similar


if sum(size(teco))~=0, error(' EULER con TECO '); end

