%------------------------------------------------------------------
% from FEM002 - version TET (Tayfun Tezduyar)
%------------------------------------------------------------------

  ne    = length(eles);
  taucte = 0;

% Puntos de Gauss para elementos cuadrangulares y triangulares
%------------------------------------------------------------------

  if nen==4,
   if npg==4,
    xpg  = sqrt(3)/3;
    psipg = [ -xpg xpg xpg -xpg ];
    etapg = [ -xpg -xpg xpg xpg ];
    wpg   = [    1   1   1    1 ];
   elseif npg==1,
    xpg  = 0;
    psipg = [ xpg ];
    etapg = [ xpg ];
    wpg   = [   4 ];
   end
  else
   if npg==3,
    psipg = [ 1/6  2/3  1/6 ];
    etapg = [ 1/6  1/6  2/3 ];
    wpg   = [ 1/6  1/6  1/6 ];
   elseif npg==1,
    psipg = [ 1/3 ];
    etapg = [ 1/3 ];
    wpg   = [ 1/2 ];
   end
  end

% Localizacion
%------------------------------------------------------------------

    ceros = zeros(length(eles),nen*ndf);
       Ue = ceros;
      U0e = ceros;
	radio = ceros;

  for inod=1:nen,
            nodes = icone(eles,inod);
	         jnod = (inod-1)*ndf+(1:ndf);
       Ue(:,jnod) = U(nodes,1:ndf);
      U0e(:,jnod) = Uold(nodes,1:ndf);
    radio(:,inod) = xnod(nodes,1);
% Calculo de la norma de la variable de estado en cada nodo de c/elemento
% Usada por upwind TET1
      UC2(:,inod) = sum(Ue(:,jnod)'.^2)'; 
  end



if taucte,
% Calculo de transformacion isoparametrica y funciones de forma
%------------------------------------------------------------------

if nen==4,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),0,0);
  [dNdx0,dNdy0,N0] = shape(X2S,0,0,nen); 
elseif nen==3,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),1/3,1/3);
  [dNdx0,dNdy0,N0] = shape(X2S,1/3,1/3,nen); 
else
  error(' Bad type of element , nen ~=3, nen ~=4 ')
end

%------------------------------------------------------------------
%                      SUPG version TET
%------------------------------------------------------------------

  UC_0    = zeros(ne,ndf);
  gU_0    = zeros(ne,2*ndf);
  gUC2_0   = zeros(ne,2);

  for inod=1:nen,
    jnod = (inod-1)*ndf+(1:ndf);
    UC_0(:,(1:ndf))  = UC_0(:,(1:ndf)) + N0(inod).* Ue(:,jnod);
	gU_0(:,(1:ndf))  = gU_0(:,(1:ndf)) + ...
	          (dNdx0(:,inod)*ones(1,ndf)).* Ue(:,jnod);
	gU_0(:,(1:ndf)+ndf) = gU_0(:,(1:ndf)+ndf)+ ...
	          (dNdy0(:,inod)*ones(1,ndf)).* Ue(:,jnod);
	gUC2_0(:,1) = gUC2_0(:,1) + dNdx0(:,inod).* UC2(:,inod);
	gUC2_0(:,2) = gUC2_0(:,2) + dNdy0(:,inod).* UC2(:,inod);
  end

  UP_0           = cv2pv(UC_0,gamma,+1);

% Calculo del vector beta
    abs_gUC2 = sqrt(sum(gUC2_0'.^2))';
    abs_gUC2 = max([abs_gUC2'; tol*ones(1,ne)])';
    beta     = gUC2_0 ./ (abs_gUC2*[1 1]);
    hele_0   = h_supg(beta,dNdx0,dNdy0);

% Calculo del tau
  [tau_0,delta,dt] = Tau_TET1(UC_0,UP_0,beta,hele_0,Cou,gamma,shocap);

  Ax_0   =  Ajac(UC_0,UP_0,gamma,1);
  Ay_0   =  Ajac(UC_0,UP_0,gamma,2);

end  % taucte

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------

 for ipg=1:npg

  [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
  [dNdx,dNdy,N] = shape(X2S,psipg(ipg),etapg(ipg),nen); 

% Interpolacion en punto de Gauss
%------------------------------------------------------------------

     Upg    = zeros(ne,ndf);
    U0pg    = zeros(ne,ndf);
    dUpg    = zeros(ne,ndm*ndf);
   radpg    = zeros(ne,1);
    gUC2    = zeros(ne,2);

  for inod=1:nen,
     jnod = (inod-1)*ndf+(1:ndf);
      Upg(:,(1:ndf))  =  Upg(:,(1:ndf)) + N(inod).*  Ue(:,jnod);
     U0pg(:,(1:ndf))  = U0pg(:,(1:ndf)) + N(inod).* U0e(:,jnod);
	 dUpg(:,(1:ndf))  = dUpg(:,(1:ndf)) + ...
	          (dNdx(:,inod)*ones(1,ndf)).* Ue(:,jnod);
	 dUpg(:,(1:ndf)+ndf) = dUpg(:,(1:ndf)+ndf)+ ...
	          (dNdy(:,inod)*ones(1,ndf)).* Ue(:,jnod);
	       gUC2(:,1)  = gUC2(:,1) + dNdx(:,inod).* UC2(:,inod);
	       gUC2(:,2)  = gUC2(:,2) + dNdy(:,inod).* UC2(:,inod);
	radpg(:,1)  =   radpg(:,1) +      N(inod).* radio(:,inod);
  end

%------------------------------------------------------------------
%                          KYRELE
%
%  Calcula constribuciones elementales a 
%  la matriz de masa diagonal M y al vector R
%
%------------------------------------------------------------------

  UPpg = cv2pv(Upg,gamma,+1);

if ~taucte,
% Calculo del vector beta
    abs_gUC2 = sqrt(sum(gUC2'.^2))';
    abs_gUC2 = max([abs_gUC2'; tol*ones(1,ne)])';
    beta     = gUC2 ./ (abs_gUC2*[1 1]);
    hele     = h_supg(beta,dNdx,dNdy);

% Calculo del tau
  [tau,delta,dt] = Tau_TET1(Upg,UPpg,beta,hele,Cou,gamma,shocap);
end

% jacobianos segun variable de estado en el pto de Gauss actual
  Ax   =  Ajac(Upg,UPpg,gamma,1);
  Ay   =  Ajac(Upg,UPpg,gamma,2);

% Calculo de los flujos advectivos, necesario si debilitamos el fluujo
% advectivo
%  [Fa] = fluxa(Upg,UPpg);

% Correccion axisimetrica del jacobiano de la transformacion al elemento master
%------------------------------------------------------------------
  xsj =  wpg(ipg) .* Jaco;
  if axisim,
     xsj = xsj.*radpg;
  end

% Calculo matriz masa diagonal y residuo
%--------------------------------------------------------------------

%disp(' INGRESE TAU 1er elemento');keyboard;pause

    Fax = rowprod(Ax,dUpg(:,1:ndf),ndf,ndf,1);
    Fay = rowprod(Ay,dUpg(:,ndf+(1:ndf)),ndf,ndf,1);
    if taucte,
      Ataux = rowprod(Ax_0,tau_0,ndf,ndf,ndf);
      Atauy = rowprod(Ay_0,tau_0,ndf,ndf,ndf);
	else
      Ataux = rowprod(Ax,tau,ndf,ndf,ndf);
      Atauy = rowprod(Ay,tau,ndf,ndf,ndf);
	end
    AtauAdx = rowprod(Ataux,(Fax+Fay),ndf,ndf,1);
	AtauAdy = rowprod(Atauy,(Fax+Fay),ndf,ndf,1);

%disp(' FEM_0002 ');keyboard;pause

  for inod=1:nen,
    ip=(inod-1)*ndf+(1:ndf);

%------ Masa diagonal
      ter1 = N(inod)/dt ;
	  Mele(:,ip) = Mele(:,ip) + (ter1*xsj)*ones(1,ndf);

%------ Residuo
     ter1 = N(inod)*(Fax+Fay);
	 ter2 = rowprod(dNdx(:,inod)*m2v(eye(ndf))',AtauAdx,ndf,ndf,1)+...
            rowprod(dNdy(:,inod)*m2v(eye(ndf))',AtauAdy,ndf,ndf,1);

    Rele(:,ip) = Rele(:,ip) - ( ter1+ter2 ) .* (xsj*ones(1,ndf)) ;

% Esto se usaria si debilitamos el flujo advectivo
%    ter2 =  rowprod(Fa(:,1:ndf),dNdx(:,inod)*ones(1,ndf),ndf,ndf,1)+ ...
%            rowprod(Fa(:,ndf+(1:ndf)),dNdy(:,inod)*ones(1,ndf),ndf,ndf,1);
%    ter2 = ter2 + (P1_pg(:,ip)).*rowprod(Ax,dUpg(:,1:ndf),ndf,ndf,1)+ ...
%           (P1_pg(:,ip)).*rowprod(Ay,dUpg(:,ndf+(1:ndf)),ndf,ndf,1);
            

	            							 
  end % inod

 end % ipg

% ------ Terminos de contorno

% si debilitamos aparece un termino de contorno aqui del tipo
%   calculo normal a cada (elemento-cara) del borde
%   [eleb,faceb] = find_bou(????);
%   normal = ???
%   [Fa_n] = fluxan(Fa(eleb,:),normal);
% 	ver rutina bc_teco para armar algo similar


if sum(size(teco))~=0, error(' EULER con TECO '); end

