function [he] = helem(velpg,dNdx,dNdy,Area)
%
%  [he] = helem(velpg,dNdx,dNdy,Area)
%

  limit       = 1e-10;
  [numel,nen] = size(dNdx);
  velmod      = sqrt(sum(velpg'.^2))';
  mask        = velmod>limit;
  he          = zeros(numel,1);
  vels        = velpg ./ ((mask.*velmod+(1-mask).*limit)*[1,1]);

  for inod=1:nen,
    he  = he + abs(vels(:,1).*dNdx(:,inod)+vels(:,2).*dNdy(:,inod));
  end

  he = mask.*he + (1-mask) .*(2 ./ sqrt(4*Area/pi));
  he = 2 ./ he;
