function [Kele,Rele] = ...
      mapt2t(xfather,xson,Kelet,Relet,ico2t,ntri,ndf,nen,ijob)
%
%     xfather(1:3*ntri,1:2)   
%     xson(1:3*ntri,1:2)   
%      ntri = nro de triangulos que surgen de la particion de la zona mushy
%      NOTA : Para xnod, por cada triangulo nacido existe su padre
%             1 mismo padre puede tener varios hijos pero en el arreglo
%             xnod debemos repetir al padre como si fuera distinto.
%	   ijob == 0 , pre y pos Kele y pre Rele
%      ijob > 0 , solo pre Kele
%      ijob < 0 , solo pre Rele

  if nargin <9, ijob = 0; end

%disp(' ******* VERSION NUEVA DE MAPT2T ********* ')

  Kele = zeros(ntri,(nen*ndf)^2);
  Rele = zeros(ntri,(nen*ndf));

%t = cputime;

% Armado matriz A (global)
%---------------------------

  A = ones(3,ntri);
  A = [ A ; v2m(xfather(:,1),3)' ; v2m(xfather(:,2),3)' ];
  A = A';
  A = A(:,[1,4,7,2,5,8,3,6,9]);

% Armado matriz Ai (interior)
%---------------------------

  Ast = ones(3,ntri);
  Ast = [ Ast ; v2m(xson(:,1),3)' ; v2m(xson(:,2),3)' ];
  Ast = Ast';
  Ast = Ast(:,[1,4,7,2,5,8,3,6,9]);

%t_A = cputime -t;
%t = cputime;

  A1       = rowsolve(A,(ones(ntri,1)*m2v(eye(3))'),3,3);
  A1Astr   = rowprod(A1,Ast,3,3,3);
  A1Astv   = A1Astr;
  A1Astvt  = A1Astv(:,[1,4,7,2,5,8,3,6,9]);

%t_B = cputime -t;

  if ijob >=0,
  Kt  = Kelet(:,1:ndf^2:(ndf^2)*(3^2));
  Kt  = Kt(:,[1,4,7,2,5,8,3,6,9]);
  Kt1 = rowprod(A1Astv,Kt,3,3,3);
  if ijob==0, 
    Kt1 = rowprod(Kt1,A1Astvt,3,3,3); 
  end
  Kt1 = Kt1(:,[1,4,7,2,5,8,3,6,9]);

  Kt  = Kelet(:,2:ndf^2:(ndf^2)*(3^2));
  Kt  = Kt(:,[1,4,7,2,5,8,3,6,9]);
  Kt2 = rowprod(A1Astv,Kt,3,3,3);
  if ijob==0, 
    Kt2 = rowprod(Kt2,A1Astvt,3,3,3);
  end
  Kt2 = Kt2(:,[1,4,7,2,5,8,3,6,9]);

  Kt  = Kelet(:,3:ndf^2:(ndf^2)*(3^2));
  Kt  = Kt(:,[1,4,7,2,5,8,3,6,9]);
  Kt3 = rowprod(A1Astv,Kt,3,3,3);
  if ijob==0,
    Kt3 = rowprod(Kt3,A1Astvt,3,3,3);
  end
  Kt3 = Kt3(:,[1,4,7,2,5,8,3,6,9]);

  Kt  = Kelet(:,4:ndf^2:(ndf^2)*(3^2));
  Kt  = Kt(:,[1,4,7,2,5,8,3,6,9]);
  Kt4 = rowprod(A1Astv,Kt,3,3,3);
  if ijob==0, 
    Kt4 = rowprod(Kt4,A1Astvt,3,3,3);
  end
  Kt4 = Kt4(:,[1,4,7,2,5,8,3,6,9]);

  Rt1 = rowprod(A1Astv,Relet(:,1:ndf:ndf*3),3,3,1);
  Rt2 = rowprod(A1Astv,Relet(:,2:ndf:ndf*3),3,3,1);

 for itri=1:ntri,
  for k1=1:3,
   inod=ico2t(itri,k1);
   for k2=1:3,
     jnod=ico2t(itri,k2);
     ip=((inod-1)*nen+(jnod-1))*ndf^2;
     Kele(itri,ip+1)=Kele(itri,ip+1)+Kt1(itri,(k1-1)*3+k2);
     Kele(itri,ip+2)=Kele(itri,ip+2)+Kt2(itri,(k1-1)*3+k2);
     Kele(itri,ip+3)=Kele(itri,ip+3)+Kt3(itri,(k1-1)*3+k2);
     Kele(itri,ip+4)=Kele(itri,ip+4)+Kt4(itri,(k1-1)*3+k2);
   end
   Rele(itri,(inod-1)*ndf+1)=Rele(itri,(inod-1)*ndf+1)+Rt1(itri,k1);
   Rele(itri,(inod-1)*ndf+2)=Rele(itri,(inod-1)*ndf+2)+Rt2(itri,k1);
  end
 end

  else

  Rt1 = rowprod(A1Astv,Relet(:,1:ndf:ndf*3),3,3,1);
  Rt2 = rowprod(A1Astv,Relet(:,2:ndf:ndf*3),3,3,1);

%disp(' MAPT2T '); keyboard;pause

%  for itri=1:ntri,
%   for k1=1:3,
%%    inod=ico2t(itri,k1);
%   Rele(itri,(inod-1)*ndf+1)=Rele(itri,(inod-1)*ndf+1)+Rt1(itri,k1);
%    Rele(itri,(inod-1)*ndf+2)=Rele(itri,(inod-1)*ndf+2)+Rt2(itri,k1);
%   end
%  end

%  for itri=1:ntri,
   for k1=1:3,
%    inod=ico2t(:,k1);
    Rele(:,(k1-1)*ndf+1)=Rt1(:,k1);
    Rele(:,(k1-1)*ndf+2)=Rt2(:,k1);
   end
%  end

  end


%disp([' t_A = ' num2str(t_A)  ])
%disp([' t_B = ' num2str(t_B)  ]),pause(0.1)


