function [xc,icoc,uc]=pfint_st(xnod,u,Nx,Ny,x1,x2)
%
%       [xc,icoc,uc]=pfint_st(xnod,u,Nx,Ny,x1,x2)
%
% Interpolamos solucion de una malla en otra interior 
% Solo para mallas estructuradas y regulares de [Nx x Ny] nodos.
% La malla interior se obtiene dando un conjunto de nodos 
% segun x e y.
%

if rem(Nx,2)==0, error(' Nx debe ser impar ');end
if rem(Ny,2)==0, error(' Ny debe ser impar ');end

[xc,icoc]=qq3d([x1,0*x1],[0*x2,x2]);
x  = xnod(1:Nx,1);
y  = xnod(1:Nx:Nx*Ny,2);
z  = v2m(u,Nx);
uc = interp2(x,y,z,xc(:,1),xc(:,2));
