function [tau_pg,Pe_max] = supg1(dt,velpg,h_supg,difu)
%
% calculo de tau (stabilizacion numerica)
%
%        [tau_pg,Pe_max] = supg1(velpg,dNdx,dNdy,difu)
%

  limit = 1e-20;
  [numel,nnn] = size(velpg);

  velmodpg = sqrt(sum(velpg'.^2))';
  mask_d   = (difu>limit);
  difu     = difu+limit*(1-mask_d);

  Pe_pg    = velmodpg .* h_supg / 2 ./ difu ;
  psi_pg   = (abs(Pe_pg)>3) + (abs(Pe_pg)<=3).*abs(Pe_pg/3);
  mask_v   = (velmodpg>limit);
  velmodpg = velmodpg+limit*(1-mask_v);
  tau_pg   = ( h_supg / 2  ./ abs(velmodpg) ) .* psi_pg;
  tau_pg   = (2.0d0 ./ dt).^2 + (1.0d0 ./ tau_pg).^2 ; 
  tau_pg   = 1 ./ sqrt(tau_pg);		 
  Pe_max   = max(Pe_pg);
