function [X2S,S2X,Jaco] = xyz2rst(xnod,icone,psipg,etapg,zetapg);
%-------------------------------------------------------------------
%          --- FEMCODE routine --- 
%
%   [X2S,S2X,Jaco] = xyz2rst(xnod,icone,psipg,etapg,zetapg);
%
%  (1) Calculo del jacobiano y tensor metrico transformacion
%      al elemento master en 3D
%-------------------------------------------------------------------

[nnod,ndm]=size(xnod);
[nele,nen]=size(icone);

dxdpsi  = zeros(nele,1);
dxdeta  = zeros(nele,1); 
dxdzeta = zeros(nele,1);
      
dydpsi =  zeros(nele,1);
dydeta =  zeros(nele,1);
dydzeta = zeros(nele,1);
      
dzdpsi =  zeros(nele,1);
dzdeta =  zeros(nele,1);
dzdzeta =  zeros(nele,1);

if nen==8,
   
psi  = [-0.5,0.5,0.5,-0.5,-0.5,0.5,0.5,-0.5];
eta  = [-0.5,-0.5,0.5,0.5,-0.5,-0.5,0.5,0.5];
zeta = [-0.5,-0.5,-0.5,-0.5,0.5,0.5,0.5,0.5];

% hexahedro
   for i=1:8
         N(i) =  (0.5+psi(i)*psipg)*(0.5+eta(i)*etapg)*(0.5+zeta(i)*zetapg);
      dNd1(i) =    psi(i)*(0.5+zeta(i)*zetapg)* (0.5+eta(i)*etapg);
      dNd2(i) =    eta(i)*(0.5+zeta(i)*zetapg)* (0.5+psi(i)*psipg);
      dNd3(i) =   zeta(i)*(0.5+ eta(i)* etapg)* (0.5+psi(i)*psipg);      
   end
      
   xs = v2m(xnod(icone,1),nele);   
   ys = v2m(xnod(icone,2),nele);
   zs = v2m(xnod(icone,3),nele);   
   
   for i=1:8,
      x(:,i) = xs(i,:)';   
      y(:,i) = ys(i,:)';
      z(:,i) = zs(i,:)';      
   end
   
  
elseif nen==4,

      N(1) = 1-psipg-etapg-zetapg;
      N(2) = psipg;  
      N(3) = etapg; 
      N(4) = zetapg; 
      dNd1(1) = -1.0;
      dNd1(2) =  1.0;
      dNd1(3) =  0.0;
      dNd1(4) =  0.0;
      
      dNd2(1) = -1.0;
      dNd2(2) =  0.0;
      dNd2(3) =  1.0;
      dNd2(4) =  0.0;
      
      dNd3(1) = -1.0;
      dNd3(2) =  0.0;
      dNd3(3) =  0.0;
      dNd3(4) =  1.0;
      
   xs = v2m(xnod(icone,1),nele);   
   ys = v2m(xnod(icone,2),nele);
   zs = v2m(xnod(icone,3),nele);   
   
   for i=1:4,
      x(:,i) = xs(i,:)';   
      y(:,i) = ys(i,:)';
      z(:,i) = zs(i,:)';      
   end

else
   
  error(' ** ERROR ** , Routine XYZ2RST , Bad type of element')
   
end

   for i=1:nen,
       dxdpsi =  dxdpsi+x(:,i)*dNd1(i);
       dxdeta =  dxdeta+x(:,i)*dNd2(i);
      dxdzeta = dxdzeta+x(:,i)*dNd3(i);
      
       dydpsi =  dydpsi+y(:,i)*dNd1(i);
       dydeta =  dydeta+y(:,i)*dNd2(i);
      dydzeta = dydzeta+y(:,i)*dNd3(i);
      
       dzdpsi =  dzdpsi+z(:,i)*dNd1(i);
       dzdeta =  dzdeta+z(:,i)*dNd2(i);
      dzdzeta = dzdzeta+z(:,i)*dNd3(i);      
   end
   
   Jaco =  dxdpsi.*(dydeta.*dzdzeta-dzdeta.*dydzeta) + ...
           dxdeta.*(-dydpsi.*dzdzeta+dzdpsi.*dydzeta) + ...
          dxdzeta.*(dydpsi.*dzdeta-dzdpsi.*dydeta);
   
   S2X = [dxdpsi dxdeta dxdzeta dydpsi dydeta dydzeta dzdpsi dzdeta dzdzeta];
   
   X2S = [  dydeta.*dzdzeta-dydzeta.*dzdeta, -dxdeta.*dzdzeta+dxdzeta.*dzdeta,  dxdeta.*dydzeta-dxdzeta.*dydeta , ...
        -dydpsi.*dzdzeta+dydzeta.*dzdpsi,  dxdpsi.*dzdzeta-dxdzeta.*dzdpsi, -dxdpsi.*dydzeta+dxdzeta.*dydpsi , ...
        dydpsi.*dzdeta-dydeta.*dzdpsi,   -dxdpsi.*dzdeta+dxdeta.*dzdpsi,    dxdpsi.*dydeta-dxdeta.*dydpsi];
  
  X2S = X2S./(Jaco*ones(1,9));
  