function A = Ajac_euler_1D(U,Up,gamma)

% funcion que calcula el jacobiano advectivo de Euler en 1D

     [nnod,ibid]=size(U);

     rho    =  Up(:,1);
     Ucell  =  Up(:,2);
     ucell  =  U(:,3)./rho;
     cc     =  sqrt(gamma*Up(:,3)./rho);
     uno    =  ones(nnod,1);
     cero   =  zeros(nnod,1);
     g1     =  gamma-1;
     
     if 0,     
      A = [cero  .5*(gamma-3)*Ucell.^2  (g1*Ucell.^2-gamma*ucell).*Ucell  ...
          uno   -(gamma-3)*Ucell       gamma*ucell-1.5*g1*Ucell.^2       ... 
          cero  g1*uno                 gamma*Ucell];
     else
        A(:,1,1) = cero;
        A(:,2,1) = 0.5*(gamma-3)*Ucell.^2;
        A(:,3,1) = (g1*Ucell.^2-gamma*ucell).*Ucell;
        A(:,1,2) = uno;
        A(:,2,2) = -(gamma-3)*Ucell;
        A(:,3,2) = gamma*ucell-1.5*g1*Ucell.^2;
        A(:,1,3) = cero;
        A(:,2,3) = g1*uno;
        A(:,3,3) = gamma*Ucell;          
     end
       