function [P,P1,Lambda] = Jaco_cv2chv(U,ga);
%
%    Matrix transformation between conservative and characteristics variables 
%
%               [P,P1] = Jaco_cv2chv(U)
%
     [nnod,ibid]=size(U);
     Up     =  cv2pv(U,ga);
     
     rho    =  Up(:,1);
     vel    =  Up(:,2);
     cc     =  sqrt(ga*Up(:,3)./rho);
     uno    =  ones(nnod,1);
     g1     =  ga-1;
     
   % characteristic -----> conservative
   P  = [ ...
      uno , vel , 0.5*vel.^2, ...         
      rho./(2*cc), rho.*(vel+cc)./(2*cc), rho.*(0.5*vel.^2+vel.*cc+cc.^2/g1)./(2*cc), ...         
     -rho./(2*cc), -rho.*(vel-cc)./(2*cc), -rho.*(0.5*vel.^2-vel.*cc+cc.^2/g1)./(2*cc)];
     
   %   conservative -----> characteristic   
   P1 = [ ...
       uno-g1/2*vel.^2./cc.^2 , ...
         (g1/2*vel.^2-vel.*cc)./(rho.*cc), ...
        -(g1/2*vel.^2+vel.*cc)./(rho.*cc), ...
              g1/2*vel./cc.^2 , ...
         (cc-g1*vel)./(rho.*cc), ...
         (cc+g1*vel)./(rho.*cc), ...
         -g1./cc.^2, ...
         g1./(rho.*cc), ...
         -g1./(rho.*cc)  ];
   
   Lambda  = [ vel , vel+cc , vel-cc ];
