function Wout = cv2chv(U,Win,ga,idim);
%
%    conservative to characteristics variables (idim +)
%    characteristics variables to conservative (idim -)
%

     [nnod,ibid]=size(U);
     Up     =  cv2pv(U,ga);
     
     rho    =  Up(:,1);
     vel    =  Up(:,2);
     cc     =  sqrt(ga*Up(:,3)./rho);
     uno    =  ones(nnod,1);
     g1     =  ga-1;
     
   % characteristic -----> conservative
   P  = [ ...
      uno , vel , 0.5*vel.^2, ...         
      rho./(2*cc), rho.*(vel+cc)./(2*cc), rho.*(0.5*vel.^2+vel.*cc+cc.^2/g1)./(2*cc), ...         
     -rho./(2*cc), -rho.*(vel-cc)./(2*cc), -rho.*(0.5*vel.^2-vel.*cc+cc.^2/g1)./(2*cc)];
     
   %   conservative -----> characteristic   
   P1 = [ ...
       uno-g1/2*vel.^2./cc.^2 , ...
         (g1/2*vel.^2-vel.*cc)./(rho.*cc), ...
        -(g1/2*vel.^2+vel.*cc)./(rho.*cc), ...
              g1/2*vel./cc.^2 , ...
         (cc-g1*vel)./(rho.*cc), ...
         (cc+g1*vel)./(rho.*cc), ...
         -g1./cc.^2, ...
         g1./(rho.*cc), ...
         -g1./(rho.*cc)  ];
   
   %disp(' CV2CHV routine ')
   %keyboard,pause
   
if idim<0,
   
if(abs(idim)==1),
   Wout  = rowprod(P,Win,3,3,1);
else
   Wout  = rowprod(P,Win,3,3,3);   
   Wout  = rowprod(Wout,P1,3,3,3);   
end

else
   if(abs(idim)==1),   
      Wout  = rowprod(P1,Win,3,3,1);
   else
      Wout  = rowprod(P1,Win,3,3,3);   
      Wout  = rowprod(Wout,P,3,3,3);         
   end   
end
