%------------------------------------------------------------------
%       Programa   " D R V F E M " 
%------------------------------------------------------------------

if(exist('inicia')==0),
  disp('Ingrese la variable inicia ')
  disp(' inicia == 0 ---> si continua una corrida previa ')
  disp(' inicia ~= 0 ---> si comienza una corrida nueva ')
  inicia = input(' Inicia = ')
end

%------ Ingreso de datos -------------------------------------------

if inicia,
  read_data;
  bfh=[];          % Guarda la solucion
  hc_res=[];       % Guarda la historia de la convergencia en residuo
  hc_du=[];        % Guarda la historia de la convergencia en dphi
  bfh_nc = [];     % Guarda los pasos de tiempo en que no hubo convergencia
  bfh_u=[];        % Guarda la solucion cada nstep pasos de tiempo
  posdat;
  ttime = 0;
end

%------ fin ingreso de datos --------------------------------------

limit = prop(12);

% Loop temporal o pseudotemporal
%------------------------------------------------------------------

for itime=1:ntime,
  ttime = ttime+dt;
  
  phiold = phi;

% Actualiza las condiciones de contorno si fueran funcion del tiempo
% La funcionalidad se lee del archivo "bc_time"
    if exist('bc_time_flag')==1,
	  if (bc_time_flag==1)&(exist('bc_time')~=2), 
	  disp('Debe tener en el directorio de trabajo un archivo de nombre bc_time.m ');
	    error(' bc_time_flag==1 y bc_time file no existe '); 
      end
	  if bc_time_flag==1, bc_time; end
	end
    
  nu    = 0;
  iterflag = 1;
  [numnp,ndf] = size(phi);

while iterflag

  nu= nu+1;
  
  phi_nu = phi;
%------------------------------------------------------------------
%        Montaje sistema y solucion del problema
%------------------------------------------------------------------

    ijob = 0;
    if type_solver ==2, ijob=-1; end

% Armado matriz jacobiana y vector residuo del sistema
%------------------------------------------------------------------
[Kg,Rg] = elem_Euler_1D(xnod,icone,fixa,forc,teco,lin_con,prop,ifaceb, ...
                        phi,phiold,ijob);

% Resolucion del sistema algebraico lineal de ecuaciones
%------------------------------------------------------------------
%solver;
[phi,Rg]=solver(phi,Rg,Kg,fixa,prop,prop_solver,ndf);

dphi = phi-phi_nu;

% Analisis de la convergencia
%------------------------------------------------------------------
  iterflag = (norm(Rg)>limit) & (nu< nu_max); % & (norm(dphi)>limit);

  disp(['time ' num2str(itime) ... 
          ' Iter ' num2str(nu)  ' || R || -----> ' num2str(norm(Rg)) ... 
          ' || Delta phi || -----> ' num2str(norm(dphi))  ])

  hc_res  = [hc_res ; norm(Rg)];
  hc_du   = [hc_du ; norm(dphi)];
  
%t3=cputime;
%disp([' dt pos solver   = ' num2str(t3-t2)])

end  % end while

% Salida grafica de resultados (provista por cada aplicacion)
%------------------------------------------------------------------

plot_fem

%  bfh = [bfh phi(:,1)];


if norm(Rg)>limit ,
%  error(' NO CONVERGENCE ');
 bfh_nc = [bfh_nc ; itime];
end

if exist('nsave')==0; nsave=ntime;end

if exist('filesave')==0; filesave='tempo'; end

if rem(itime,nsave)==0, 
  eval(['save ' filesave ';']);
end

if rem(itime,nstep)==0,
  bfh_u = [bfh_u , phi];
end

%disp('DRVFEM');keyboard;pause

end % itime loop

