function [Kg,Rg] = elem_Euler_1D(xnod,icone,fixa,forc,teco,lin_con,prop,ifaceb,U,Uold,ijob)
%------------------------------------------------------------------
%
%     [Mg,Rg] = elem_Euler_1D(xnod,icone,fixa,forc,teco,peri,prop,U,Uold,ijob)
%
%       Caracteristicas del elemento:
%
%        #.- EULER 1D
%


  [numel,nen]   = size(icone);
  [numnp,ndf]   = size(U);
  [numnp,ndm]   = size(xnod);

  gamma    = prop(1);
  Cou      = prop(2);
  npg      = prop(3);
  upwind   = prop(4);
  shocap   = prop(5);
  lumped   = prop(6);
  type_var = prop(7);
  if prop(8)==0, matrix_type='diag'; else matrix_type='full'; end
  if matrix_type=='diag',
     if ijob>=0, 
        error(' Diagonal matrix needs ijob < 0 - check type solver and matrix type');
     end
  end
  
  tau_TET  = prop(9);    
  weak_form = prop(10);
  
  tol      = prop(12);
  dt       = prop(13);
  
% tipo de variables usadas
if type_var ==0,
   type_var = 'cons';
else   
   type_var = 'char';
end

  if ndm==1,
     pgauss1d;
  elseif ndm==2, 
     pgauss2d; 
  elseif ndm==3,
     pgauss3d; 
  end

%  Rg       = forc;
  Rele     = zeros(numel,nen,ndf);
if matrix_type=='diag',
   Mele = zeros(numel,nen,ndf);
else
   Mele = zeros(numel,nen,ndf,nen,ndf);
end
  
  eles     = (1:numel)';
  
  if type_var=='cons',     
     elem_Euler_1D_2;
  elseif type_var=='char',
    Ucons = U;
        U = cv2chv(Ucons,U,gamma,1);
     Uold = cv2chv(Uold,Uold,gamma,1);
     elem_Euler_1D_2_char;
  else
     error(' Bad choice of variable set ')
  end

% Gather contributions from eles to nodes
%------------------------------------------------------------------
[Rg,Kg] = gather(Rele,Mele,icone,nen,ndf);

% Linear restrictions
%------------------------------------------------------------------
if isempty(lin_con)==0,[Rg,Kg] = linear_constraint(Rg,Kg,lin_con,ndf);end

