%
% trabaja en variables caracteristicas
% pp. 160 Hirsch
%

iii = v2m((1:ndf^2)',ndf);
iii = m2v(iii');

        ne = length(eles);
 
 hele     = xnod(icone(:,2),1)-xnod(icone(:,1),1); 
 
% Localizacion de las variables
%------------------------------------------------------------------

  for inod=1:nen,
            nodes = icone(eles,inod);
	          jnod = (inod-1)*ndf+(1:ndf);
       Ue(:,jnod) = U(nodes,1:ndf);		 
       U0e(:,jnod) = Uold(nodes,1:ndf);
       Uce(:,jnod) = Ucons(nodes,1:ndf);
  end

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------

 for ipg=1:npg
    
% Calculo de transformacion isoparametrica y funciones de forma
%------------------------------------------------------------------
  [X2S,S2X,Jaco]  = xy2st(xnod,icone(eles,:),psipg(ipg));
  [dNdx,N]        = shape1d(X2S,psipg(ipg),nen); 
  xsj             =  wpg(ipg) .* Jaco;
    
% Interpolacion en punto de Gauss
%------------------------------------------------------------------

     Upg    = zeros(ne,ndf);
    Ucpg    = zeros(ne,ndf);
    U0pg    = zeros(ne,ndf);
    dUpg    = zeros(ne,ndf);

  for inod=1:nen,
     jnod = (inod-1)*ndf+(1:ndf);
      Upg(:,(1:ndf))  =  Upg(:,(1:ndf)) + N(inod).*  Ue(:,jnod);
     Ucpg(:,(1:ndf))  = Ucpg(:,(1:ndf)) + N(inod).* Uce(:,jnod);     
     U0pg(:,(1:ndf))  = U0pg(:,(1:ndf)) + N(inod).* U0e(:,jnod);
     dUpg(:,(1:ndf))  = dUpg(:,(1:ndf)) + (dNdx(:,inod)*ones(1,ndf)).* Ue(:,jnod);	          
  end

  UPpg = cv2pv(Ucpg,gamma);  % pasaje de variables conservativas a primitivas
  
% calculo del upwind en cada punto de Gauss  
  cc         = sqrt(gamma*UPpg(:,3)./UPpg(:,1));
  lambda_1   = UPpg(:,2);
  lambda_2   = UPpg(:,2)+cc;
  lambda_3   = UPpg(:,2)-cc;  
  lambda     = [lambda_1,lambda_2,lambda_3];
  tau        = 0.5*(hele*ones(1,3)) ./ abs(lambda);
  dt         = min(hele)*Cou ./ max(max([abs(lambda')]));
  dt         = dt* ones(numel,1);
  
             
%------ Matriz de masa 
  if matrix_type=='full',
     
  jp=[1,ndf+2,2*ndf+3];
  for idf=1;ndf    
  for inod=1:nen,
     P_supg = (tau(:,idf).*dNdx(:,inod)).*lambda(:,idf) ;
   for jnod=1:nen,
     ip=((inod-1)*nen+(jnod-1))*ndf^2;      
     ter1 = N(inod)*N(jnod) ./ dt ;
     ter2 = +(dNdx(:,jnod)*N(inod)).*lambda(:,idf);      
     % stabilization SUPG terms     
     AgN  = lambda(:,idf).*dNdx(:,jnod);      
     ter3 = P_supg.*AgN;          
     Mele(:,ip+jp(idf)) = Mele(:,ip+jp(idf)) + (ter1+ter2+ter3).*xsj;
   end
  end
  end
else
   for inod=1:nen,
     ip=(inod-1)*ndf+(1:ndf);
     ter1 = N(inod) ./ dt ;
     Mele(:,ip) = Mele(:,ip) + (ter1.*xsj)*ones(1,ndf);
   end
  end

%------ Residuo
  for idf=1:ndf,
  for inod=1:nen,
   ip=(inod-1)*ndf;
   ter1 = N(inod)* ((Upg(:,idf)-U0pg(:,idf)) ./ dt);
   AgU = lambda(:,idf).*dUpg(:,idf);   
   ter2 = N(inod)* AgU;
   % stabilization SUPG terms
   P_supg = (tau(:,idf).*dNdx(:,inod)).*lambda(:,idf) ;
   ter3 = P_supg.*AgU;     
   Rele(:,ip+idf) = Rele(:,ip+idf) - (0*ter1+ter2+ter3).*xsj ;
  end % inod
  end % idf

 end % ipg
