%
%   Ejemplo BUMP_1 : Euler Mach = 0.3
%


xnod     =[];
icone    =[];

load bump_1.nod
xnod = bump_1;
Nx = 48;
Ny = 13;

load bump_1.con
icone = bump_1;

clear bump_1

% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 4;

xmin = min(xnod);
xmax = max(xnod);

nodes_bot  = find(xnod(:,2)<0.1);
nodes_top  = find(abs(xnod(:,2)-xmax(2))<1e-6);
nodes_lef  = find(abs(xnod(:,1)-xmin(1))<1e-6);
nodes_rig  = find(abs(xnod(:,1)-xmax(1))<1e-6);

fixa= zeros(numnp,ndf);
fixa(nodes_lef,[1,2,3])=ones(length(nodes_lef),3);
fixa(nodes_rig,[4])=ones(length(nodes_rig),1);
fixa(nodes_top,1:4)=ones(length(nodes_top),4);
%fixa(nodes_bot,1:4)=ones(length(nodes_bot),4);

%-------- Cargas/Desplazamientos nodales(FORC)

forc= zeros(numnp,ndf);
forc(nodes_lef,1)= 1*ones(length(nodes_lef),1);
forc(nodes_lef,2)= 5*ones(length(nodes_lef),1);
forc(nodes_rig,4)=72*ones(length(nodes_rig),1);
forc(nodes_top,1)= 1*ones(length(nodes_top),1);
forc(nodes_top,2)= 5*ones(length(nodes_top),1);
forc(nodes_top,4)=72*ones(length(nodes_top),1);

%-------- Fuentes de volumen (por elemento)
 xc=0;yc=0;
 factor = 1/nen;
 for kk=1:nen,
  xc = xc+factor*xnod(icone(:,kk),1);
  yc = yc+factor*xnod(icone(:,kk),2);
 end
 mask=(yc>0.1)&(yc<0.3);
 source = 0*mask;
 source = [];

%--------- Termino reactivo -----------------------------
reac = zeros(numel,1);
reac = [];

%--------- Campo de Velocidad -----------------------------
veloc =  zeros(numnp,2);
veloc = [];

%-------- Propiedades del material
 gamma   = 1.4    ;
 Cou     = 20    ;
 kappa   = 1      ;
 npg     =  4     ;

 prop(1) =gamma   ;
 prop(2) =Cou    ;
 prop(3) =kappa ;
 prop(4) =npg   ;

 shocap   =      0 ;
 axisim   =      0 ;
 type_upw =      1 ;   
 lumped   =      0 ;
 weak_form=      1 ;
 
 prop(5)  = weak_form;
 prop(6)  = type_upw; 
 prop(7)  = shocap ;
 prop(8)  = axisim ;
 prop(11) = lumped ;
 
 matrix_type = 'full';  % arma el jacobiano lo mejor posible
% matrix_type = 'diag';  % solo la matriz de masa y lumped 
if exist('matrix_type'),
   if matrix_type=='diag', prop(9) = 0; else prop(9) = 1; end 
end
 
%-------- Cargas repartidas (STRG)
strg  = [ ...
   42.0000   63.0000   -0.5108   -0.4625
  420.0000  441.0000   -0.1187   -0.1055 ];
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas
peri = [nodes_bot' nodes_top'];
peri = [];

%-------- Condiciones SLIP
slip = [];
slip = [ (2:10)'  ones(9,1)  ;
        (12:36)' ones(25,1)  ;
		(38:46)'  ones(9,1)   ];

slip = [ (1:47)'  ones(47,1)  ];

[no] = get_normal(xnod,icone,slip,0);
nno  = length(no(:,1));
lin_con = [no(:,2),no(:,1),2*ones(nno,1),no(:,3),no(:,1),3*ones(nno,1)];
%lin_con = [];

%-------- Solucion inicial (PHI)

U   =  ones(numnp,1)*[1,5,0,72];

% bump_1 tiene la solucion Feap del bump con Mach=0.3
% bump_2 tiene la solucion Feap del bump con Mach=0.5
%load bump_2.u
%U = bump_2;
%clear bump_2;

% condicion inicial en primitivas
%-----------------------------------------------
bini   = U;
for k=1:ndf,
 nofree        = find(fixa(:,k)~=0);
 bini(nofree,k)   = forc(nofree,k);
end
%bini    =  pv2cv(bini,gamma);
