function [Q,Q1] = cv2pv_Jaco(Up,gamma);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  Matrices jacobianas de transformacion entre
%  variables primitivas y conservativas en 2D
%
%        [Q,Q1] = cv2pv_Jaco(Up,gamma)
%
%            Up : primitive variables
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

     [nnod,ndf]=size(Up);

     rho    =  Up(:,1);
     Ucell  = sqrt(sum(Up(:,2:ndf-1)'.^2))';
     uno    =  ones(nnod,1);
     cero   =  zeros(nnod,1);
     g1     =  gamma-1;
     
%[               1,               0,               0,               0]
%[               u,             rho,               0,               0]
%[               v,               0,             rho,               0]
%[ 1/2*u^2+1/2*v^2,           rho*u,           rho*v,        1/(ga-1)]

%[                    1,                    0,                    0,                    0]
%[               -u/rho,                1/rho,                    0,                    0]
%[               -v/rho,                    0,                1/rho,                    0]
%[ 1/2*(u^2+v^2)*(ga-1),            -u*(ga-1),            -v*(ga-1),                 ga-1]

% esta escrito column-wise

Q=  [  uno   Up(:,2)  Up(:,3) (0.5*Ucell.^2)  ... 
            cero    rho     cero          Up(:,1).*Up(:,2)  ...
            cero    cero    rho           Up(:,1).*Up(:,3)  ...
            cero    cero    cero             (1/g1)*uno       ];

Q1=  [ uno (-Up(:,2)./Up(:,1)) (-Up(:,3)./Up(:,1)) (0.5*g1*Ucell.^2) ... 
	      cero   1 ./Up(:,1)            cero   -g1*Up(:,2)       ... 			
          cero          cero     1 ./Up(:,1)   -g1*Up(:,3)       ... 
          cero          cero            cero         g1*uno        ];
