%   
%   dominio cuadrado con una perturbacion en un flujo uniforme
%


xnod     =[];
icone    =[];
Nx       =  10;   Lx =  1.0;
Ny       =  10;   Ly =  1.0;
psi      = (0:Nx-1)'/(Nx-1);
x        = psi*Lx;
eta      = (0:Ny-1)'/(Ny-1)*1; 
y        = eta*Ly;

%-------- coordenadas (XNOD)
for k=1:Ny,
  xnod=[xnod;[x y(k)*ones(Nx,1)]];
end

%-------- conectividades (ICONE)
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
ico2= [ (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' (1:Nx-1)'];
for k=1:Ny-1,
    icone=[icone; (k-1)*Nx+ico ];
end

% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 4;
nodes_bot  = (1:Nx);
nodes_top  = Nx*(Ny-1)+(1:Nx);
nodes_lef  = 1:Nx:Nx*Ny;
nodes_rig  = Nx:Nx:Nx*Ny;

fixa= zeros(numnp,ndf);
fixa(nodes_lef,[1,2,3])=ones(length(nodes_lef),3);
fixa(nodes_rig,[4])=ones(length(nodes_rig),1);
%fixa(nodes_bot,[1,2,3,4])=ones(length(nodes_bot),4);
%fixa(nodes_top,[1,2,3,4])=ones(length(nodes_top),4);

%-------- Cargas/Desplazamientos nodales(FORC)
forc= zeros(numnp,ndf);
forc(nodes_lef,1:3)= ones(length(nodes_lef),1)*[1,1,0];
forc(nodes_rig,4)= ones(length(nodes_rig),1)*[72];
%forc(nodes_bot,1:4)= ones(length(nodes_bot),1)*[1,1,0,180.5];
%forc(nodes_top,1:4)= ones(length(nodes_top),1)*[1,1,0,180.5];

%-------- Fuentes de volumen (por elemento)
 xc=0;yc=0;
 factor = 1/nen;
 for kk=1:nen,
  xc = xc+factor*xnod(icone(:,kk),1);
  yc = yc+factor*xnod(icone(:,kk),2);
 end
 mask=(yc>0.1)&(yc<0.3);
 source = 0*mask;

%--------- Termino reactivo -----------------------------
reac = zeros(numel,1);
reac = [];

%--------- Campo de Velocidad -----------------------------
veloc =  zeros(numnp,2);
veloc = [];

%-------- Propiedades del material
 gamma   = 1.4    ;
 Cou     = 20    ;
 kappa   = 1      ;
 npg     =  4     ;

 prop(1) =gamma   ;
 prop(2) =Cou    ;
 prop(3) =kappa ;
 prop(4) =npg   ;

 shocap   =      0 ;
 axisim   =      0 ;
 type_upw =      1 ;   
 lumped   =      0 ;
 weak_form=      1 ;
 
 prop(5)  = weak_form;
 prop(6)  = type_upw; 
 prop(7)  = shocap ;
 prop(8)  = axisim ;
 prop(11) = lumped ;
 
 matrix_type = 'full';  % arma el jacobiano lo mejor posible
% matrix_type = 'diag';  % solo la matriz de masa y lumped 
if exist('matrix_type'),
   if matrix_type=='diag', prop(9) = 0; else prop(9) = 1; end 
end
 

%-------- Cargas repartidas (STRG)
strg  = [ ...
   42.0000   63.0000   -0.5108   -0.4625
   63.0000   84.0000   -0.4625   -0.4254
  420.0000  441.0000   -0.1187   -0.1055 ];
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
%teco    = [eles face val1/rho/Cp val2 ];
teco     = [];

%-------- Condiciones periodicas
peri = [nodes_rig' nodes_lef' pi/2*ones(length(nodes_lef),1)];
peri = [];

%-------- Condiciones de deslizamiento
% slip = [ elemento - cara ];
slip = [    (1:20)'   ones(20,1) ; 
        380+(1:20)' 3*ones(20,1) ];
slip = [(1:20)' , ones(20,1) ; 380+(1:20)' , 3*ones(20,1)];
slip = [];

lin_con = [];

%-------- Solucion inicial (PHI)
U      =  ones(numnp,1)*[1,1,0,72];
DP     = 1;
sigma  = 0.05;
xc     = (max(xnod)+min(xnod))/2;
r      = sqrt(sum((xnod-ones(numnp,1)*xc)'.^2))';
U(:,4) = U(:,4)+DP*exp(-r.^2/sigma);
%U(4,4) = 72.1;      

% condicion inicial en primitivas
%-----------------------------------------------
bini   = U;

for k=1:ndf,
 nofree        = find(fixa(:,k)~=0);
 bini(nofree,k)   = forc(nofree,k);
end

