function [Fa,A] = Flux_function(Up,prop)
%
%            [Fa] = Flux_function(Up,prop)
%
%       Computes advective fluxes F_a
%                   2D    
%	 Dimension of Fa array = numnp x ndm*ndf 
%             

gamma       = prop(1);
[numnp,ndf] = size(Up);
Uc          = cv2pv(Up,gamma,-1);  

% advective fluxes
Fa            = zeros(numnp,ndf,ndf-2);
Fa(:,1,1)     = Uc(:,2);
Fa(:,2,1)     = Uc(:,2).*Up(:,2) + Up(:,ndf);
Fa(:,3,1)     = Uc(:,3).*Up(:,2);
Fa(:,4,1)     = (Uc(:,ndf)+Up(:,ndf)).* Up(:,2);
Fa(:,1,2)     = Uc(:,3);
Fa(:,2,2)     = Uc(:,2).*Up(:,3);
Fa(:,3,2)     = Uc(:,3).*Up(:,3) + Up(:,ndf);
Fa(:,4,2)     = (Uc(:,ndf)+Up(:,ndf)).* Up(:,3);

axisim        = prop(8) ;

A = zeros(numnp,2,ndf,ndf);
if 1,
   A(:,1,1,1)= Up(:,2);
   A(:,1,1,2)= Up(:,1);
   A(:,1,2,1)= Up(:,2).^2;
   A(:,1,2,2)= 2*Up(:,1).*Up(:,2);
   A(:,1,2,4)= 1;   
   A(:,1,3,1)= Up(:,2).*Up(:,3);
   A(:,1,3,2)= Up(:,1).*Up(:,3);
   A(:,1,3,3)= Up(:,1).*Up(:,2); 
   
%   A(:,1,4,1)= Up(:,2).*Uc(:,4)./Uc(:,1);
%   A(:,1,4,2)= Up(:,4)+Uc(:,4);   
%   A(:,1,4,4)= Up(:,2);   
     
   A(:,1,4,1)= 0.5*Up(:,2).*(Up(:,2).^2+Up(:,3).^2);
   A(:,1,4,2)= -0.5*Up(:,1).*(Up(:,2).^2+Up(:,3).^2)*(gamma-1) + ...
                gamma * Uc(:,4) + Up(:,1).*Up(:,2).^2;   
   A(:,1,4,3)= Up(:,1).*Up(:,2).*Up(:,3);   
   A(:,1,4,4)= gamma*Up(:,2)/(gamma-1);   
   
   
 
   A(:,2,1,1)= Up(:,3);
   A(:,2,1,3)= Up(:,1);   
   A(:,2,2,1)= Up(:,2).*Up(:,3);
   A(:,2,2,2)= Up(:,1).*Up(:,3);
   A(:,2,2,3)= Up(:,1).*Up(:,2); 
   A(:,2,3,1)= Up(:,3).^2;
   A(:,2,3,3)= 2*Up(:,1).*Up(:,3);
   A(:,2,3,4)= 1;   
   
%   A(:,2,4,1)= Up(:,3).*Uc(:,4)./Uc(:,1);
%   A(:,2,4,3)= Up(:,4)+Uc(:,4);   
%   A(:,2,4,4)= Up(:,3);   
   
   A(:,2,4,1)= 0.5*Up(:,3).*(Up(:,2).^2+Up(:,3).^2);
   A(:,2,4,2)= Up(:,4)+Uc(:,4)+Up(:,1).*Up(:,3).^2;   
   A(:,2,4,2)= Up(:,1).*Up(:,2).*Up(:,3);   
   A(:,2,4,4)= Up(:,3)/(gamma-1);   
  
   A(:,2,4,1)= 0.5*Up(:,3).*(Up(:,2).^2+Up(:,3).^2);
   A(:,2,4,3)= -0.5*Up(:,1).*(Up(:,2).^2+Up(:,3).^2)*(gamma-1) + ...
                gamma * Uc(:,4) + Up(:,1).*Up(:,3).^2;   
   A(:,2,4,2)= Up(:,1).*Up(:,2).*Up(:,3);   
   A(:,2,4,4)= gamma*Up(:,3)/(gamma-1);   
   
 else
   % advective jacobian in conservative basis
   [A(:,1,:,:),A(:,2,:,:)] = Ajac_2D(Uc,Up,gamma,axisim);
end