function [H,Cp,Cp_i] = enthalpy_function(Up,prop)
%
%      [H,Cp,Cp_i] = enthalpy_function(Up,prop)
%
%       Computes enthalpy function to handle primitive variables
%                   2D    
%             

gamma       = prop(1);
[numnp,ndf] = size(Up);
H           = cv2pv(Up,gamma,-1);  
[Q,Q1]      = cv2pv_Jaco(Up,gamma);
Cp          = reshape(Q,numnp,ndf,ndf);
Cp_i        = reshape(Q1,numnp,ndf,ndf);

