function [Fd] = Dflux(Up,dv,dT,vis,k);
%----------------------------------------------------------
%        Function [Fd] = Dflux(Up,dv,dT,vis,k,ndm);
%           donde:  Up = var. primitivas  
%                   dv = (du dv dw)/dx  (du dv dw)/dy
%                   dT = dTx dTy
%                  vis = viscosidad
%                   k  = conductividad
%----------------------------------------------------------

[num,ndf] = size(dU);    
Fd  = zeros(num,ndf*(ndf-2));

if ndf == 4,
   T   = zeros(num,4);    % T = [11 12 21 22]
   
   T(:,1)= vis/3*(4*dv(:,1) - 2*dv(:,4));
   T(:,2)= vis*(dv(:,3) + dv(:,2));
   T(:,3)= T(2);
   T(:,4)= vis/3*(4*dv(:,4) - 2*dv(:,1));
   
   for i=1:2,
      Fd(:,ndf*(i-1)+2)= T(:,i);
      Fd(:,ndf*(i-1)+3)= T(:,i+2);
      Fd(:,ndf*(i-1)+4)= T(:,2*i-1).*Up(:,2) + T(:,2*i).*Up(:,3) - k*dT(:,i);
   end
elseif ndf == 5,
   T   = zeros(num,9);    % T = [11 12 13 21 22 23 31 32 33]
   
   T(:,1)= vis/3*(4*dv(:,1) - 2*(dv(:,5) - dv(:,9)));
   T(:,2)= vis*(dv(:,4) + dv(:,2));
   T(:,3)= vis*(dv(:,7) + dv(:,3));
   T(:,4)= T(2);
   T(:,5)= vis/3*(4*dv(:,5) - 2*(dv(:,1) - dv(:,9)));
   T(:,6)= vis*(dv(:,8) - dv(:,6));
   T(:,7)= T(3);
   T(:,8)= T(6);
   T(:,9)= vis/3*(4*dv(:,9) - 2*(dv(:,1) - dv(:,5)));
    
   for i=1:3,
      Fd(:,ndf*(i-1)+2)= T(:,i);
      Fd(:,ndf*(i-1)+3)= T(:,i+3);
      Fd(:,ndf*(i-1)+4)= T(:,i+6);
      Fd(:,ndf*(i-1)+5)= T(:,3*i-2).*Up(:,2) + T(:,3*i-1).*Up(:,3) + T(:,3*i).*Up(:,4)...
                         - k*dT(:,i);
   end
   
else
   error('Error en el nmero de grados de libertad')
   
end   
   