function [tau,delta,dt] = Tau_TET2(UC,UP,dUpg,hnod,Cou,gamma,shocap)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  [tau,delta,dt] = Tau_TET2(UC,UP,dUpg,hnod,Cou,gamma,shocap)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

     limit = 1e-12;
     [nnod,ndf]=size(UC);

     uno    =  ones(nnod,1);
     cero   =  zeros(nnod,1);
     g1     =  gamma-1;

     rho    =  UP(:,1);
	 Ucell = zeros(nnod,1);
	 for k=2:ndf-1,
       Ucell  =  Ucell + UP(:,k).^2;
	 end
	 Ucell  = sqrt(Ucell);
     cc    = sqrt(gamma*UP(:,ndf)./UP(:,1));

% Calculo de beta
    beta(:,1) = sum((2.0d0*UC(:,(1:ndf)).*dUpg(:,(1:ndf)))')';
    beta(:,2) = sum((2.0d0*UC(:,(1:ndf)).*dUpg(:,ndf+(1:ndf)))')';

    UC_nor    = sqrt(sum(UC'.^2))';
    beta_nor  = sqrt(sum(beta'.^2))';

    mask = (beta_nor ./ UC_nor)>limit;
    beta_nor = mask.*beta_nor + (1-mask)*limit;
    beta = beta./(beta_nor*[1,1]);
    beta = (mask*[1,1]).*beta;


    vaux = cc+abs(sum((UP(:,2:3).*beta)')');

% Calculo del tau_a
    tau_a =  hnod ./ ( 2 * vaux ) ;
	           
% Calculo del delta (shock capturing)
     delta = zeros(nnod,1);
	 if shocap,
% Calculo de la inversa del tensor metrico Riemanniano A01
%      A01 = [ ??? ]
%       delta =   ????
	 end
% Calculo del tau_delta
     tau_delta = delta ./ (vaux.^2) ;

% Calculo del tau
     tau = max([(tau_a-tau_delta)'; zeros(1,nnod)])';
     tau = tau * ones(1,4);

% Calculo del paso de tiempo critico con time local stepping
     max_c = max(Ucell+cc);
     max_c = abs(Ucell)+cc;
     hmin  = min(hnod)*ones(size(max_c));
     hmin = hnod;

     dt    = Cou*hmin ./ max_c;
