function [a01] = A01(uc,ga);
%
%          [a01] = A01(uc,ga)
%
%  Matriz Jacobiana de Riemann inversa para transformacion de
%  variables conservativas a variables de entropia
%  ( de uso para el shock capturing que usa TET )
%

      [nn,ndf] = size(uc);
      ndm = ndf-2;
      u = [uc(:,1:3) zeros(nn,1) uc(:,ndf) ];
	  if ndm==3, u(:,4) = uc(:,4);end

	  roe     =  u(:,5) - 0.5 *sum(u(:,2:4)'.^2)' ./u(:,1);

      s1      =  (ga-1.0)*roe ./ (u(:,1).^ga);
      s1      =  log(s1);
      vl(:,1) =  (-u(:,5)+roe.*(ga+1.0-s1)) ./roe ;
      vl(:,2) =  u(:,2)./roe;
      vl(:,3) =  u(:,3)./roe;
      vl(:,4) =  u(:,4)./roe;
      vl(:,5) = -u(:,1)./roe;

      ak1 = 0.5* sum(vl(:,2:4)'.^2)' ./ vl(:,5);

      d1  = -vl(:,2).*vl(:,3);
      d2  = -vl(:,2).*vl(:,4);
      d3  = -vl(:,4).*vl(:,3);
      e1  = vl(:,2).*vl(:,5);
      e2  = vl(:,3).*vl(:,5);
      e3  = vl(:,4).*vl(:,5);
      s   = ga - vl(:,1) + ak1;
      s1  = - s ./ (ga-1.0);
      roe = ( (ga-1.0) ./ (-vl(:,5) ).^ga ).^(1/(ga-1.0)) .* exp(s1);

      cte2 = -1 ./ roe ./ vl(:,5);
	  
  	  a01 = zeros(nn,25);
      a01(:,1) = cte2 .* (   ak1.^2 + ga );
      a01(:,2) = cte2 .* (   ak1.*vl(:,2));
      a01(:,3) = cte2 .* (   ak1.*vl(:,3));
      a01(:,4) = cte2 .* (   ak1.*vl(:,4));
      a01(:,5) = cte2 .* (   (ak1+1).*vl(:,5) );
      a01(:,5+2) = cte2 .* (   vl(:,2).^2-vl(:,5));
      a01(:,5+3) = cte2 .* (   -d1);
      a01(:,5+4) = cte2 .* (   -d2);
      a01(:,5+5) = cte2 .* (    e1);
      a01(:,10+3) = cte2 .* (    vl(:,3).^2-vl(:,5) );
      a01(:,10+4) = cte2 .* (   -d3);
      a01(:,10+5) = cte2 .* (    e2);
      a01(:,15+4) = cte2 .* (    vl(:,4).^2-vl(:,5) );
      a01(:,15+5) = cte2 .* (    e3);
      a01(:,20+5) = cte2 .* (    vl(5).^2 );

% simetrizacion de la matriz
%      for i=1:ndf,
%	   for j=1:ndf,
%	    if j<i,
%		  a01(:,(i-1)*5+j) = a01(:,(j-1)*5+i);
%		end
%	   end
%	  end
     
      for i=1:5,
	   for j=1:5,
	    if j<i,
		  a01(:,(i-1)*5+j) = a01(:,(j-1)*5+i);
		end
	   end
	  end

% conversion de la matriz a 2D si ndm==2
      icoef_remv = [4,9,14,(16:20),24];
      if ndm==2,
	    a01(:,icoef_remv) = [];
	  end

