%
%   Ejemplo BUMP_1 : Euler Mach = 0.3
%
%  using new set of primitive variables 
%       U = [ p , u , v T ]
%

% ====================================================================
% Reference infinity state of variables
rho_infty  = 1.15;
p_infty    = 1e5;
Mach_infty = 0.3;
Re_infty   = 100;
ga         = 1.4;
Rgas       = 287;
cc_infty   = sqrt(ga*p_infty/rho_infty);
u_infty    = Mach_infty*cc_infty;
% ====================================================================

xnod     =[];
icone    =[];

%load bump_gid.nod
load bump_gid_tri.nod
xnod = bump_gid_tri;
[numnp,ndm]=size(xnod);
if ndm==3, 
    xnod(:,3)=[];
    ndm = 2;
end

L_char     = max(xnod(:,2))-min(xnod(:,2));

%load bump_gid.con
load bump_gid_tri.con
icone = bump_gid_tri;
[numel,nen]=size(icone);

clear bump_gid

% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 4;

xmin = min(xnod);
xmax = max(xnod);

nodes_top  = find(abs(xnod(:,2)-xmax(2))<1e-6);
nodes_lef  = find(abs(xnod(:,1)-xmin(1))<1e-6);
nodes_rig  = find(abs(xnod(:,1)-xmax(1))<1e-6);

[ifaceb,nodes_bou] = pfbou2d(xnod,icone,1);
[nodes_bou] = rmdblist(m2v(nodes_bou));
mask = zeros(numnp,1);
mask(nodes_bou)=ones(length(nodes_bou),1);
mask(nodes_top)=zeros(length(nodes_top),1);
mask(nodes_lef)=zeros(length(nodes_lef),1);
mask(nodes_rig)=zeros(length(nodes_rig),1);
nodes_bot = find(mask==1);
%ip = find(abs(xnod(nodes_rig,2)-xmin(2))<tol);
[bas,ip]=min(xnod(nodes_rig,2));
nodes_bot_rig = nodes_rig(ip);

fixa= zeros(numnp,ndf);
fixa(nodes_lef,[1,2,3])= ones(length(nodes_lef),3);
fixa(nodes_rig,[4])    = ones(length(nodes_rig),1);
fixa(nodes_top,1:4)    = ones(length(nodes_top),4);
fixa(nodes_bot,2:3)    = ones(length(nodes_bot),2);
fixa(nodes_bot_rig,2:3) = ones(length(nodes_bot_rig),2);

%-------- Cargas/Desplazamientos nodales(FORC)
forc= zeros(numnp,ndf);
forc(nodes_lef,1) = rho_infty*ones(length(nodes_lef),1);
forc(nodes_lef,2) =   u_infty*ones(length(nodes_lef),1);
forc(nodes_rig,4) =   p_infty*ones(length(nodes_rig),1);
forc(nodes_top,1) = rho_infty*ones(length(nodes_top),1);
forc(nodes_top,2) =   u_infty*ones(length(nodes_top),1);
forc(nodes_top,4) =   p_infty*ones(length(nodes_top),1);

%-------- Fuentes de volumen (por elemento)
source = [];

%--------- Termino reactivo -----------------------------
reac = [];

%--------- Campo de Velocidad -----------------------------
veloc = [];

%-------- Propiedades del material
%-------- Propiedades del material
% ga   = 1.4    ; ver arriba
 Cou     = 10    ;
 % Rgas     =     287; ver arriba
% visco    =  1e-5; % laminar
 visco    =  u_infty*L_char/Re_infty;
 Pr       = 0.72;
 C_v      = Rgas/(ga-1);
 C_p      = ga*C_v;
 kappa    = C_p*visco/Pr;
 
 npg     =  2  ;

 shocap   =      0 ;
 axisim   =      0 ;
 type_upw =      1 ;   
 weak_form=      1 ;
 
 
 matrix_type = 'full';  % arma el jacobiano lo mejor posible
% matrix_type = 'diag';  % solo la matriz de masa y lumped 

ijob = 'set';  % to be used by handle_prop_elem to set element properties
handle_prop_elem;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas
peri = [];

%-------- Condiciones SLIP
slip = [];
slip = [ (2:10)'  ones(9,1)  ;
        (12:36)' ones(25,1)  ;
		(38:46)'  ones(9,1)   ];

slip = [ (1:47)'  ones(47,1)  ];

[no] = get_normal(xnod,icone,slip,0);
nno  = length(no(:,1));
lin_con = [no(:,2),no(:,1),2*ones(nno,1),no(:,3),no(:,1),3*ones(nno,1)];
lin_con = [];

%-------- Solucion inicial (PHI)
rhoini = rho_infty;
pini   = p_infty;
uini   = u_infty;
U      =  ones(numnp,1)*[rhoini,uini,0,pini];

% condicion inicial en primitivas
%-----------------------------------------------
bini   = U;
for k=1:ndf,
 nofree        = find(fixa(:,k)~=0);
 bini(nofree,k)   = forc(nofree,k);
end
