function [tau,delta,dt] = supg_nsc_2d(Upg,UPpg,dUpg,grad_Unorm,hele,prop)
%
%   supg_nsc_2d(Upg,UPpg,dUpg,hele,prop)
%
%  calculo de tau (estabilizacion numerica) para Euler 1D
%

ijob = 'get';
handle_prop_elem;

ne = length(Upg(:,1));

limit = 1e-12;
[nnod,ndf]=size(Upg);

uno    =  ones(nnod,1);
cero   =  zeros(nnod,1);
g1     =  ga-1;

rho    =  UPpg(:,1);
Ucell  = sqrt(sum(UPpg(:,2:3)'.^2))';
cc     = sqrt(ga*UPpg(:,ndf)./UPpg(:,1));

% Calculo de beta
    beta      = grad_Unorm;
    UC_nor    = sqrt(sum(Upg'.^2))';
    beta_nor  = sqrt(sum(beta'.^2))';
    mask = (beta_nor ./ UC_nor)>limit;
    beta_nor = mask.*beta_nor + (1-mask)*limit;
    beta = beta./(beta_nor*[1,1]);
    beta = (mask*[1,1]).*beta;

    vaux = cc+abs(sum((UPpg(:,2:3).*beta)')');

% Calculo del tau_a
    tau_a =  (hele ./ ( 2 * vaux )) * ones(1,ndf);

% Calculo del tau_d
    K_11_d = zeros(ne,ndf);
    K_22_d = zeros(ne,ndf);
    K_11_d(:,2) = 4/3*visco;
    K_11_d(:,3) = visco;
    K_11_d(:,4) = kappa/C_v;
    K_22_d(:,3) = 4/3*visco;
    K_22_d(:,2) = visco;
    K_22_d(:,4) = kappa/C_v;
    for idf=1:ndf,
        tau_d(:,idf) = beta(:,1).^2.*K_11_d(:,idf)+beta(:,2).^2.*K_22_d(:,idf);
        tau_d(:,idf) = tau_d(:,idf)./vaux.^2;
    end    

% Calculo del delta (shock capturing)
     delta = zeros(nnod,1);
	 if shocap,
% Calculo de la inversa del tensor metrico Riemanniano A01
     [A0_inv]   = A01(Upg,ga);
     [bas,A]    = Flux_function(Upg,prop);   
     [bas,Cp]   = enthalpy_function(Upg,prop);     
     Ax         = reshape(A(:,1,:,:),ne,ndf,ndf);
     Ay         = reshape(A(:,2,:,:),ne,ndf,ndf);
     Ax         = rowprod(Ax,Cp,ndf,ndf,ndf);
     Ay         = rowprod(Ay,Cp,ndf,ndf,ndf);
     AgU        = rowprod(Ax,dUpg(:,1:ndf,1),ndf,ndf,1) + ... 
                  rowprod(Ay,dUpg(:,1:ndf,2),ndf,ndf,1);
     vaux1      = rowprod(reshape(A0_inv,ne,ndf,ndf),AgU,ndf,ndf,1);
     delta      = sum(AgU'.*vaux1')';
	 end
% Calculo del tau_delta
     tau_delta = (delta ./ (vaux.^2))* ones(1,ndf);

% Calculo del tau
     for idf=1:ndf
         tau(:,idf) = max([(tau_a(:,idf)-tau_d(:,idf)-tau_delta(:,idf))'; zeros(1,nnod)])';
     end

% Calculo del paso de tiempo critico con time local stepping
     max_c = max(Ucell+cc);
     max_c = abs(Ucell)+cc;
     hmin  = min(hele)*ones(size(max_c));
     hmin  = hele;
     dt    = Cou*hmin ./ max_c;
