syms mu rho u v w p R K 
syms drho du dv dw dp 
syms rho_x rho_y rho_z u_x v_x w_x u_y v_y w_y u_z v_z w_z p_x p_y p_z

vel=[u;v;w];
vel_T=reshape(vel,1,3);

U = [rho;vel;p];
dU = [drho;du;dv;dw;dp];

U1 = [rho_x;u_x ;v_x ;w_x;p_x];
U2 = [rho_y;u_y ;v_y ;w_y;p_y];
U3 = [rho_z;u_z ;v_z ;w_z;p_z];

grad_rho = [rho_x;rho_y;rho_z];
grad_u   = [u_x;u_y;u_z];
grad_v   = [v_x;v_y;v_z];
grad_w   = [w_x;w_y;w_z];
grad_p   = [p_x;p_y;p_z];
grad_T   = (grad_p/rho-p/rho^2*grad_rho)/R;

grad_u_T=reshape(grad_u,1,3);

defo(1,1) = grad_u(1)+grad_u(1);
defo(1,2) = grad_u(2)+grad_v(1);
defo(1,3) = grad_u(3)+grad_w(1);

defo(2,1) = grad_v(1)+grad_u(2);
defo(2,2) = grad_v(2)+grad_v(2);
defo(2,3) = grad_v(3)+grad_w(2);

defo(3,1) = grad_w(1)+grad_u(3);
defo(3,2) = grad_w(2)+grad_v(3);
defo(3,3) = grad_w(3)+grad_w(3);

defo = defo/2;

divu = grad_u(1)+grad_v(2)+grad_w(3);

tau = 2*mu*defo-2/3*mu*divu*eye(3);

qT = -K*reshape(grad_T,1,3);

Fd = [ 0 , 0 , 0 ; tau ; reshape(tau*vel,1,3) - qT ]
   
Uc = [rho, rho*u , rho*v , rho*w , rho*ene];
Uc = simple(subs(Uc,ene,'Cv*(p/rho/R)+0.5*(u^2+v^2+w^2)'));
Cp = jacobian(reshape(Uc,5,1),U);

K_11 = jacobian(Fd(:,1),U1);  % en primitivas
Kc_11 = simple((Cp)*K_11*inv(Cp));

K_12 = jacobian(Fd(:,1),U2);  % en primitivas
Kc_12 = simple(Cp*K_12*inv(Cp));

return
   
Fd=subs(Fd,mu_l,mu_l+C_mu*rho_l*k^2/e);


K_11 = jacobian(Fd(:,1),U1);
K_12 = jacobian(Fd(:,1),U2);
K_13 = jacobian(Fd(:,1),U3);

K_21 = jacobian(Fd(:,2),U1);
K_22 = jacobian(Fd(:,2),U2);
K_23 = jacobian(Fd(:,2),U3);

K_31 = jacobian(Fd(:,3),U1);
K_32 = jacobian(Fd(:,3),U2);
K_33 = jacobian(Fd(:,3),U3);

diary D_jac
for k=1:3,
    for l=1:3
        disp(['K_' num2str(k) num2str(l) ])
        eval(['pretty(K_' num2str(k) num2str(l) ')'])
    end
end
diary off