syms U1 U2 U3 U4 U5 p ga rho u v w e T Cv R

g1 = ga-1;

Fa_x = [U2 ; U2*U2/U1+p ;U3*U2/U1    ;U4*U2/U1;    (U5+p)*(U2/U1)];
Fa_y = [U3;  U2*U3/U1   ;U3*U3/U1+p  ;U4*U3/U1;    (U5+p)*(U3/U1)];
Fa_z = [U4;  U2*U4/U1   ;U3*U4/U1    ;U4*U4/U1+p;  (U5+p)*(U4/U1)];

Fa_x = subs(Fa_x,p,'(ga-1)*(U5-0.5*(U2^2+U3^2+U4^2)/U1)');
Fa_y = subs(Fa_y,p,'(ga-1)*(U5-0.5*(U2^2+U3^2+U4^2)/U1)');
Fa_z = subs(Fa_z,p,'(ga-1)*(U5-0.5*(U2^2+U3^2+U4^2)/U1)');

Uc = [U1,U2,U3,U4,U5];

Ax=jacobian(Fa_x,Uc);
Ay=jacobian(Fa_y,Uc);
Az=jacobian(Fa_z,Uc);

Ax = simple((subs(subs(subs(subs(subs(Ax,U1,'rho'),U2,'rho*u'),U3,'rho*v'),U4,'rho*w'),U5,'rho*e')));
Ay = simple((subs(subs(subs(subs(subs(Ay,U1,'rho'),U2,'rho*u'),U3,'rho*v'),U4,'rho*w'),U5,'rho*e')));
Az = simple((subs(subs(subs(subs(subs(Az,U1,'rho'),U2,'rho*u'),U3,'rho*v'),U4,'rho*w'),U5,'rho*e')));

Cp(5,5) = 1/(ga-1);
Cp(1,1) = 1;
Cp(2,1) = u;
Cp(3,1) = v;
Cp(4,1) = w;
Cp(2,2) = rho;
Cp(3,3) = rho;
Cp(4,4) = rho;
Cp(5,1) = 0.5*(u^2+v^2+w^2);
Cp(5,2) = u*rho;
Cp(5,3) = v*rho;
Cp(5,4) = w*rho;

Axp = simple(Ax*Cp);
Ayp = simple(Ay*Cp);
Azp = simple(Az*Cp);

Bxp(1,1) = u;
Byp(1,1) = v;
Bzp(1,1) = w;

Bxp(1,2) = rho;
Byp(1,3) = rho;
Bzp(1,4) = rho;

Bxp(5,1) = 0.5*(u^2+v^2+w^2)*u;
Byp(5,1) = 0.5*(u^2+v^2+w^2)*v;
Bzp(5,1) = 0.5*(u^2+v^2+w^2)*w;

Bxp(5,5) = ga/(ga-1)*u;
Byp(5,5) = ga/(ga-1)*v;
Bzp(5,5) = ga/(ga-1)*w;

Bxp(5,2) = rho*u*u + 1*(ga/(ga-1)*p+0.5*rho*(u^2+v^2+w^2));
Bxp(5,3) = rho*u*v + 0*(ga/(ga-1)*p+0.5*rho*(u^2+v^2+w^2));
Bxp(5,4) = rho*u*w + 0*(ga/(ga-1)*p+0.5*rho*(u^2+v^2+w^2));

Byp(5,2) = rho*v*u + 0*(ga/(ga-1)*p+0.5*rho*(u^2+v^2+w^2));
Byp(5,3) = rho*v*v + 1*(ga/(ga-1)*p+0.5*rho*(u^2+v^2+w^2));
Byp(5,4) = rho*v*w + 0*(ga/(ga-1)*p+0.5*rho*(u^2+v^2+w^2));

Bzp(5,2) = rho*w*u + 0*(ga/(ga-1)*p+0.5*rho*(u^2+v^2+w^2));
Bzp(5,3) = rho*w*v + 0*(ga/(ga-1)*p+0.5*rho*(u^2+v^2+w^2));
Bzp(5,4) = rho*w*w + 1*(ga/(ga-1)*p+0.5*rho*(u^2+v^2+w^2));

Bxp(2:4,2:4) = rho*u*eye(3)+rho*[u;v;w]*[1,0,0];
Byp(2:4,2:4) = rho*v*eye(3)+rho*[u;v;w]*[0,1,0];
Bzp(2:4,2:4) = rho*w*eye(3)+rho*[u;v;w]*[0,0,1];

Bxp(2:4,1) = u*[u;v;w];
Byp(2:4,1) = v*[u;v;w];
Bzp(2:4,1) = w*[u;v;w];

Bxp(2:4,5) = [1;0;0];
Byp(2:4,5) = [0;1;0];
Bzp(2:4,5) = [0;0;1];

Bxp = subs(Bxp,p,'(ga-1)*(U5-0.5*(U2^2+U3^2+U4^2)/U1)');
Byp = subs(Byp,p,'(ga-1)*(U5-0.5*(U2^2+U3^2+U4^2)/U1)');
Bzp = subs(Bzp,p,'(ga-1)*(U5-0.5*(U2^2+U3^2+U4^2)/U1)');

Bxp = simple((subs(subs(subs(subs(subs(Bxp,U1,'rho'),U2,'rho*u'),U3,'rho*v'),U4,'rho*w'),U5,'rho*e')));
Byp = simple((subs(subs(subs(subs(subs(Byp,U1,'rho'),U2,'rho*u'),U3,'rho*v'),U4,'rho*w'),U5,'rho*e')));
Bzp = simple((subs(subs(subs(subs(subs(Bzp,U1,'rho'),U2,'rho*u'),U3,'rho*v'),U4,'rho*w'),U5,'rho*e')));
