function [c] = vector_cross(a,b)
%
%			[c] = vector_cross(a,b)
%
%       a,b :  2 sym vectors
%         c :  symbolic cross vector between them
%


a = sym(a); b = sym(b);

e = epsilon_definition;


c = 0*a;
for k=1:3,
   for j=1:3,
      for i=1:3,
         c(i)=c(i)+e(i,j,k)*a(j)*b(k);
      end; 
   end ; 
end

return

% una forma sencilla
ex = [1,0,0];
ey = [0,1,0];
ez = [0,0,1];

A = [ex;a;b];
c(1) = det(A);
A = [ey;a;b];
c(2) = det(A);
A = [ez;a;b];
c(3) = det(A);

