function [Fd] = Dflux(Up,dUp,grad_T,prop);
%--------------------------------------------------------------------
%
%  [Fd] = Dflux(Up,dUp,grad_T,prop);
%
%  Diffusive fluxes for Navier-Stokes equations
%
%--------------------------------------------------------------------

gamma    = prop(1);
visco    = prop(20);
kappa    = prop(3);
Rgas     = prop(11);

[numnp,ndf] = size(Up);    

Fd  = zeros(numnp,ndf,ndf-2);

grad_u = reshape(dUp(:,2,1:2),numnp,2);
grad_v = reshape(dUp(:,3,1:2),numnp,2);

defo(:,1,1) = grad_u(:,1)+grad_u(:,1);
defo(:,1,2) = grad_u(:,2)+grad_v(:,1);
defo(:,2,1) = grad_v(:,1)+grad_u(:,2);
defo(:,2,2) = grad_v(:,2)+grad_v(:,2);
defo = defo/2;
divu = grad_u(:,1)+grad_v(:,2);
tau = 2*visco*defo;
tau(:,1,1) = tau(:,1,1)-2/3*visco*divu;
tau(:,2,2) = tau(:,2,2)-2/3*visco*divu;

Fd(:,2:3,1:2) = tau;
Fd(:,4,1) = tau(:,1,1).*Up(:,2)+tau(:,1,2).*Up(:,3)+kappa*grad_T(:,1);
Fd(:,4,2) = tau(:,2,1).*Up(:,2)+tau(:,2,2).*Up(:,3)+kappa*grad_T(:,2);
