%
%   Ejemplo 03 - Conveccion-Difusion - estacionaria
%

Nx       = 11;  
Lx       = 1;
psi      = (0:Nx-1)'/(Nx-1);
x        = psi*Lx;

%-------- coordenadas (XNOD)
xnod= [x];

%-------- conectividades (ICONE)
icone = [ (1:Nx-1)' (2:Nx)' ]; 

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;
nodes_lef  = 1;
nodes_rig  = Nx;
fixa= zeros(numnp,ndf);
fixa(nodes_lef,1)=ones(length(nodes_lef),1);
fixa(nodes_rig,1)=ones(length(nodes_rig),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc= zeros(numnp,ndf);
forc(nodes_lef,1)=0*ones(length(nodes_lef),1);
forc(nodes_rig,1)=1*ones(length(nodes_rig),1);

%-------- Fuentes de volumen (por elemento)
source = zeros(numel,1);

%--------- Termino reactivo -----------------------------
reac   = zeros(numel,1);

%--------- Campo de Velocidad -----------------------------
veloc  =  ones(numnp,1);

%-------- Propiedades del material
% kappa   =  1e+3 ; 
% kappa   =     1 ;  
 kappa   =  1e-3 ;
 npg     =  2    ;
 prop(1) = kappa ;
 prop(2) = npg   ;
 upwind   =      1 ;
 lumped   =      1 ;
 prop(4)  = upwind   ;
 prop(11) = lumped   ;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
% del tipo  -k du/dn + h(u-u_0) = 0
% elementos con estas condiciones
%eles    = [1;numel];
% valor del coeficiente h
%val1    = ones(size(eles));
%val2    = 0.1*ones(size(eles));
%teco    = [eles face val1/rho/Cp val2 ];
teco     = [];

%-------- Condiciones periodicas
peri = [];

%-------- Solucion inicial (PHI)
bini = 10*(xnod(:,1)*ones(1,ndf));
for k=1:ndf,
 nofree      = find(fixa(:,k)~=0);
 bini(nofree,k)= forc(nofree,k);
end
