%
%   Ejemplo 05 - Burgers 1D - Problema de Riemann
%

Nx       = 81;  
Lx       = 10;
psi      = (0:Nx-1)'/(Nx-1);
x        = psi*Lx-5;

%-------- coordenadas (XNOD)
xnod= [x];

%-------- conectividades (ICONE)
icone = [ (1:Nx-1)' (2:Nx)' ]; 

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;
nodes_lef  = 1;
nodes_rig  = Nx;
fixa= zeros(numnp,ndf);
fixa(nodes_lef,1)=ones(length(nodes_lef),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc= zeros(numnp,ndf);
forc(nodes_lef,1)=1*ones(length(nodes_lef),1);

%-------- Fuentes de volumen (por elemento)
source = zeros(numel,1);

%--------- Termino reactivo -----------------------------
reac   = zeros(numel,1);

%--------- Campo de Velocidad -----------------------------
veloc  =  zeros(numnp,1);

%-------- Propiedades del material
% kappa   =  1e+3 ; 
% kappa   =     1 ;  
 kappa   =  1e-15 ;
 npg     =  2    ;
 prop(1) = kappa ;
 prop(2) = npg   ;
 upwind   =      1 ;
 lumped   =      0 ;
 prop(4)  = upwind   ;
 prop(11) = lumped   ;

 nolineal = 1;
 prop(10) = nolineal;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
% del tipo  -k du/dn + h(u-u_0) = 0
% elementos con estas condiciones
%eles    = [1;numel];
% valor del coeficiente h
%val1    = ones(size(eles));
%val2    = 0.1*ones(size(eles));
%teco    = [eles face val1/rho/Cp val2 ];
teco     = [];

%-------- Condiciones periodicas
peri = [];

%-------- Solucion inicial (PHI)
bini = ones(numnp,ndf);
mask = (xnod>0);
% Caso con shock estacionario
%bini = bini-2*mask;
% Caso con shock no estacionario
bini = bini-1*mask;
for k=1:ndf,
 nofree      = find(fixa(:,k)~=0);
 bini(nofree,k)= forc(nofree,k);
end

