function [u_ex]=phi_ex(ejemplo,x,vel,c,kappa)
%
%   [u_ex]=phi_ex(ejemplo,x,vel,c,kappa)
%    
%    Solucion exacta a algunos ejemplos incluidos en las
%    aplicaciones Cap 9 notas curso NQN
%

L = max(x)-min(x);
if ejemplo==1
  if c<0, error(' c NO PUEDE SER NEGATIVO ');end
  lambda = sqrt(c/kappa);
  A = 1 / (exp(-lambda*L)-exp(lambda*L) );
  B = -A;
  u_ex = A*exp(-lambda*x)+B*exp(+lambda*x);
elseif ejemplo==3,
  lambda = vel/kappa;
  if abs(lambda)>200, lambda = 200*sign(lambda); end
  u_ex = (exp(lambda*x)-1)/(exp(lambda)-1);
elseif ejemplo==4,
% la onda esta inicialmente en el intervalo (x1,x2)
% y se traslada durante un tiempo t a velocidad u
% la solucion exacta a un problema de conveccion pura 
% no estacionaria es:
  u_ex = 0*x(:,1);
  x1 = 0.2; x2=0.3; t=0.2; x1=x1+t*vel; x2=x2+t*vel;
  mask = (x>x1)&(x<x2);
  u_ex = mask.*sin(pi*(x-x1)/(x2-x1));
else
  error(' NO SE DISPONE DE LA SOLUCION EXACTA A ESTE EJEMPLO ')
end