%
%   Ejemplo 01 : Resolucion ec de Poisson 
%                equivale a resolver el flujo Poiseuille con un grad presion fijo
%

Nx       = 21;Lx=1;  
Ny       = 21;Ly=1;  
psi      = (0:Nx-1)'/(Nx-1);
x        = psi*Lx;
eta      = (0:Ny-1)'/(Ny-1)*1; 
y0       = -1;
y        = eta*Ly+y0;

%-------- coordenadas (XNOD)
xnod     =[];
for k=1:Ny,
  xnod=[xnod;[x ones(Nx,1)*y(k)]];
end

%-------- conectividades (ICONE)
icone    =[];
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
ico2= [ (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' (1:Nx-1)'];
for k=1:Ny-1,
    icone=[icone; (k-1)*Nx+ico ];
end

% convertimos cuadrangulos en triangulos
quad2tri=0;

if quad2tri, quad_to_tri; end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;
nodes_bot  = (1:Nx);
nodes_top  = Nx*(Ny-1)+(1:Nx);
nodes_lef  = 1:Nx:Nx*Ny;
nodes_rig  = Nx:Nx:Nx*Ny;

fixa= zeros(numnp,ndf);
%fixa(nodes_lef,1)=ones(length(nodes_lef),1);
%fixa(nodes_rig,1)=ones(length(nodes_rig),1);
fixa(nodes_top,1)=ones(length(nodes_top),1);
fixa(nodes_bot,1)=ones(length(nodes_bot),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc = zeros(numnp,ndf);

%-------- Fuentes de volumen (por elemento)
visco = 1;
grad_p = 1;
source = grad_p/visco*ones(numel,1);

%--------- Termino reactivo -----------------------------
reac = 0*ones(numel,1);

%--------- Campo de Velocidad -----------------------------
veloc  =  0*[cos(pi/3)*ones(numnp,1) sin(pi/3)*ones(numnp,1)];
%-------- Propiedades del material

rho     = 1    ;
Cp      = 1    ;
kappa   = 1    ;
npg     =  2   ;
prop(1) =rho   ;
prop(2) =Cp    ;
prop(3) =kappa ;
prop(4) =npg   ;

upwind  =    0 ;
shocap  =    0 ;
axisim  =    0 ;
type_upw =   1 ;   
lumped   =   0 ;

 prop(6)  = upwind ;
 prop(7)  = shocap ;
 prop(8)  = axisim ;
 prop(9)  = type_upw;
 prop(11) = lumped ;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas
lin_con = [];

%-------- Solucion inicial (PHI)
phi0 =  0;
for k=1:ndf,
 bini(:,k)   = forc(:,k);
 free        = find(fixa(:,k)==0);
 bini(free,k)= phi0(1,k)*ones(size(free));
end
