%
%   Ejemplo vertedero con sobresaturacion gaseosa
%


[xnod,icone] = read_mesh('cota78');
xnod = xnod(:,2:3);
icone = icone(:,2:end-1);

if 0,
% cargamos la malla del contorno
load cota78.con_bou;
icone_bou = cota78;
end

% cargamos el campo de velocidades
load cota78.vel
state_tdyn=cota78';
state_tdyn(:,3)=[];
indx_vel = (1:2);
indx_pre = 3;

phi_in = 8.5;  % concentracion a la entrada de aire en gr/m3
source_guess = 1;

% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;

xmax = max(xnod);
xmin = min(xnod);
tol = 1e-6;

% condiciones de contorno
fixa= zeros(numnp,ndf);
forc = zeros(numnp,ndf);

nodes_in = find(abs(xnod(:,1)-xmin(1))<tol);
fixa(nodes_in,1)=1;
forc(nodes_in,1)=phi_in;


%-------- Fuentes de volumen (por elemento)
if 0,
xc = xc_ele(xnod,icone);
mask=(xc(:,1)>4)&(xc(:,1)<14);
source = -source_guess*mask;
else
xmin_box = [3.5 61 ]; xmax_box=[15 67];
[eles] = eles_in_box(xnod,icone,xmin_box,xmax_box) 
source = zeros(numel,1);
source(eles) = -source_guess;
end

%--------- Termino reactivo -----------------------------
reac = 0*ones(numel,1);

%--------- Campo de Velocidad -----------------------------
veloc  =  state_tdyn(:,indx_vel);

%-------- Propiedades del material
rho     = 1 ;
Cp      = 1 ;
kappa   = 1 ;
npg     =  2   ;
prop(1) =rho   ;
prop(2) =Cp    ;
prop(3) =kappa ;
prop(4) =npg   ;

upwind  =    1 ;
shocap  =    0 ;
axisim  =    0 ;
% [1] SUPG
% [2] (SU+C)PG
type_upw =    1;   
lumped   =    0 ;
weak_form =   0;

prop(6)  = upwind ;
prop(7)  = shocap ;
prop(8)  = axisim ;
prop(9)  = type_upw;
prop(11) = lumped ;
prop(16) = weak_form;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas
peri = [];

% restricciones lineales
lin_con = [];

%-------- Solucion inicial (PHI)
bini = zeros(numnp,ndf);

for k=1:ndf,
    nofree        = find(fixa(:,k)~=0);
    bini(nofree,k)   = forc(nofree,k);
end
