%
%   Ejemplo advdif system
%           ver paper Hwang , J. Comp. Physics. vol 192 (2003) pp. 643-
%
%   ejemplo usado para ver como tratar el upwind de sistemas acoplados cuando se los resuelve en forma desacoplada
%

from_left_to_right = 1;

Nx       = 21;Lx=1;  
Ny       = 2;Ly=1; 
psi      = (0:Nx-1)'/(Nx-1);
x        = psi*Lx;
eta      = (0:Ny-1)'/(Ny-1)*1; 
y0       = 0;
y        = eta*Ly+y0;

%-------- coordenadas (XNOD)
xnod     =[];
for k=1:Ny,
  xnod=[xnod;[x ones(Nx,1)*y(k)]];
end

%-------- conectividades (ICONE)
icone    =[];
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
ico2= [ (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' (1:Nx-1)'];
for k=1:Ny-1,
    icone=[icone; (k-1)*Nx+ico ];
end

% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end

xmin = min(xnod); xmax=max(xnod);

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;
nodes_bot  = (1:Nx)';
nodes_top  = Nx*(Ny-1)+(1:Nx)';
nodes_lef  = (1:Nx:Nx*Ny)';
nodes_rig  = (Nx:Nx:Nx*Ny)';

fixa= zeros(numnp,ndf);
fixa(nodes_lef,1)=ones(length(nodes_lef),1);
fixa(nodes_rig,1)=ones(length(nodes_rig),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc = zeros(numnp,ndf);
if from_left_to_right,
    forc(nodes_lef,1) = zeros(length(nodes_lef),1);
    forc(nodes_rig,1) = ones(length(nodes_rig),1);
else
    forc(nodes_lef,1) = ones(length(nodes_lef),1);
    forc(nodes_rig,1) = zeros(length(nodes_rig),1);
end    
%mask = xnod(nodes_lef,2)>(xmin(2)+0.25*(xmax(2)-xmin(2)));
%nn   = find(mask==1);
%forc(nodes_lef(nn),1)=1*ones(length(nodes_lef(nn)),1);

%-------- Propiedades del material ( 1 set por cada campo )
idf      = 1;
rho      = 1;
C_p      = 1;
kappa    = 1;
npg      = 2;
tau_fac  = 1;
shocap   = 0;
axisim   = 0;
weak_form = 0;
lumped   = 0;
Cou      = 1;
tol_upw  = 1e-6;

type_upwind = 1;         % [0] : standard ; [1] : advdif+reac (Codina)
entalphy_ff_flag = 0;    % [0] : do not use entalphy function , [1] use entalphy function
flux_ff_flag     = 0;    % [0] : do not use flux functions , [1] use flux functions

ijob = 'set';  % to be used by handle_prop_elem to set element properties
handle_prop_elem;

%--------- Campo de Velocidad -----------------------------
vel  =  [cos(0*pi/180)*ones(numnp,1) sin(0*pi/180)*ones(numnp,1)];
veloc(:,1,1:2) = vel;

%--------- Termino reactivo -----------------------------
reac(:,1) = zeros(numel,ndf);

%-------- Fuentes de volumen (por elemento)
source = zeros(numel,ndf);

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

% Restricciones lineales ----> Condiciones periodicas
lin_con = [];
for icompo=[1]
   lin_con = [lin_con ; ... 
      [ ones(length(nodes_lef),1) nodes_lef icompo*ones(length(nodes_lef),1) ...
       -ones(length(nodes_rig),1) nodes_rig icompo*ones(length(nodes_rig),1)]];
end

%-------- Solucion inicial (PHI)
bini = ones(numnp,ndf);

for k=1:ndf,
 nofree        = find(fixa(:,k)~=0);
 bini(nofree,k)   = forc(nofree,k);
end
