function [tau,delta] = compute_tau_advdif(Upg,dUpg,velmod,hele,reac,prop,type_upwind);
%
%  [tau,delta] = compute_tau_advdif(Upg,dUpg,velmod,hele,reac,prop,type_upwind);
%

ijob = 'get';
handle_prop_elem;

tau_factor = 1.0;
[N,ndf]     = size(Upg);

if type_upwind==0,
    Pe = 0.5/kappa*velmod.*hele ;
    psi = min([ones(1,N);Pe'/3])';
    velmod  = max([velmod';tol_upw*ones(1,N)])';  
    tau   = 0.5* hele ./ velmod.*psi;
    delta = 1.0*velmod.*hele/2;
elseif type_upwind==1,
   % advective-diffusive-reactive equations (Codina)
%    disp(' using Codina scheme for advdif + reac ')
    tau_k = 4*kappa ./ (hele.^2);
    tau_a = 2*velmod ./ hele;
    tau_c = abs(reac);
    tau   = tau_factor ./ (tau_k + tau_a + tau_c);
    delta = 0.0*velmod.*hele/2;
else
   error(' Bad type of upwind has been chosen')
end

