%------------------------------------------------------------------
%       Programa   " D R V F E M " 
%------------------------------------------------------------------

if(exist('inicia')==0),
  disp('Ingrese la variable inicia ')
  disp(' inicia == 0 ---> si continua una corrida previa ')
  disp(' inicia ~= 0 ---> si comienza una corrida nueva ')
  inicia = input(' Inicia = ')
end

%------ Ingreso de datos -------------------------------------------

if inicia,
  read_data;
  bfh=[];          % Guarda la solucion
  hc_res=[];       % Guarda la historia de la convergencia en residuo
  hc_du=[];        % Guarda la historia de la convergencia en dphi
  bfh_nc = [];     % Guarda los pasos de tiempo en que no hubo convergencia
  bfh_u=[];        % Guarda la solucion cada nstep pasos de tiempo
  posdat;
  ttime = 0;
end

%------ fin ingreso de datos --------------------------------------

limit = prop(12);

% Loop temporal o pseudotemporal
%------------------------------------------------------------------

[numnp,ndf] = size(phi);

% check for some arrays that should have some features for uncoupled treatment of advdif system
 posdat_advdif_system;
 
for itime=1:ntime,
  ttime = ttime+dt;
  
  phiold = phi;

% Actualiza las condiciones de contorno si fueran funcion del tiempo
% La funcionalidad se lee del archivo "bc_time"
    if exist('bc_time_flag')==1,
	  if (bc_time_flag==1)&(exist('bc_time')~=2), 
	  disp('Debe tener en el directorio de trabajo un archivo de nombre bc_time.m ');
	    error(' bc_time_flag==1 y bc_time file no existe '); 
      end
	  if bc_time_flag==1, bc_time; end
	end
    
  nu    = 0;
  iterflag = 1;
  
  if analysis,
     
while iterflag

  nu= nu+1;
  
  phi_nu = phi;
  
%------------------------------------------------------------------
%        Montaje sistema y solucion del problema
%------------------------------------------------------------------

    ijob = 0;
%    if type_solver ==2, ijob=-1; end

Rg_dofs = [];

for idf=1:ndf,
% Armado matriz jacobiana y vector residuo del sistema
%------------------------------------------------------------------
fixa_idf = v2m(fixa,ndf);
fixa_idf = fixa_idf(:,idf);
forc_idf = v2m(forc,ndf);
forc_idf = forc_idf(:,idf);
veloc_idf = veloc(:,idf,:);
reac_idf = reac(:,idf);
source_idf = source(:,idf);
prop_idf = prop(:,idf);

if isempty(teco)==0,
    [nrow,ncol]=size(teco);
    if ncol<5, error(' For ADVDIF systems Teco should have a 5th column with the dof associated '); end
    nn=find(teco(:,5)==idf);
    teco_idf = teco(nn,1:4);
else
    teco_idf = [];
end

if isempty(lin_con)==0,
    nn=find(lin_con(:,3)==idf);
    lin_con_idf=lin_con(nn,:);
else
    lin_con_idf = [];
end

[Kg,Rg(:,idf)] = ...
    advdif_system(xnod,icone,fixa_idf,forc_idf,teco_idf,lin_con_idf,veloc_idf,reac_idf,source_idf, ...
                       prop_idf,ifaceb,phi,phiold,ijob);

% Resolucion del sistema algebraico lineal de ecuaciones
%------------------------------------------------------------------
[phi_idf,Rg_idf]=solver(phi(:,idf),Rg(:,idf),Kg,fixa_idf,prop_idf,prop_solver,1);

phi(:,idf) = phi_idf;
Rg_dofs = [Rg_dofs;norm(Rg_idf)];

end
% Analisis de la convergencia
%------------------------------------------------------------------
Rg_norm = norm(Rg_dofs);
phi = m2v(phi);
iterflag = (Rg_norm>limit) & (nu< nu_max); % & (norm(dphi)>limit);
  
  dphi = phi-phi_nu;
  
  disp(['time ' num2str(itime) ... 
          ' Iter ' num2str(nu)  ' || R || -----> ' num2str(Rg_norm) ... 
          ' || Delta phi || -----> ' num2str(norm(dphi))  ])

  hc_res  = [hc_res ; Rg_norm];
  hc_du   = [hc_du ; norm(dphi)];
  
end  % end while

% Salida grafica de resultados (provista por cada aplicacion)
%------------------------------------------------------------------

plot_fem

if Rg_norm>limit ,
%  error(' NO CONVERGENCE ');
 bfh_nc = [bfh_nc ; itime];
end

if exist('nsave')==0; nsave=ntime;end

if exist('filesave')==0; filesave='tempo'; end

if rem(itime,nsave)==0, 
  eval(['save ' filesave ';']);
end

if rem(itime,nstep)==0,
  bfh_u = [bfh_u , phi];
end

end % if analysis

end % itime loop

%disp('DRVFEM');keyboard;pause 