%----------------------------------------------------------------------
%
%          Fichero de datos
%
%----------------------------------------------------------------------

  caso     = 3 ;

  if caso==1,
    Ej2d_01      % conveccion difusion de 1 campo
  elseif caso==2,
    Ej2d_02      % conveccion difusion y reaccion de 1 campo 
                 % ver paper G. Hauke CMAME Vol 191 (2002) pp. 2925-2947    
  elseif caso==3,
    Ej2d_03      % conveccion y reaccion de 1 campo                  
  else
    error(' MALA ELECCION DEL CASO A TRATAR')
  end

  limit    =   1e-06;

% Type_solver ------>  [ 0 ]  standard - directo con relajacion (relax)
%                      [ 1 ]  line-search
%                      [ 2 ]  explicito
%                      [ 3 ]  GMRES

  dt          = 1e+15 ;
  type_solver = 0;
  relax       = 1;     % parametro de relajacion fijo para type_solver=0
  nu_max      = 2;	  % numero maximo de iteraciones por paso de tiempo
  alfa_min    = 0.01;  % para linesearch
  alpha       = 1;     % grado de implicitud (1/2 Cranck-Nicholson)
  ntime       = 2;  % pasos de tiempo
  nstep       = 1;     % guarda solucion cada nstep pasos de tiempo
  scaling     = 1;     % scaling equations at solver for better conditioning of the system
  nplot       = 1;     % plot cada "nplot" pasos de tiempo
  
if caso==1,
   nu_max      = 5;
   ntime       = 3;
   nstep       = 10; % no interesa guardar la solucion en el tiempo
elseif caso==2,
   nu_max      = 3;
   ntime       = 3;
   nstep       = 10; % no interesa guardar la solucion en el tiempo
elseif caso==3,
   nu_max      = 3;
   ntime       = 3;
   nstep       = 10; % no interesa guardar la solucion en el tiempo   
end
  
prop(12) = limit    ;
prop(13)  = dt    ; % paso de tiempo
prop(14)  = alpha ; % grado de implicitud  

prop_solver = [type_solver,relax,nu_max,alfa_min,alpha,ntime,nstep,scaling];