%
%   Ejemplo 03 : Conveccion-difusion no estacionaria bc TECO y axisim
%

Nx       = 41;Lx=1;  
Ny       = 41;Ly=1;  
psi      = (0:Nx-1)'/(Nx-1);
x        = sin(psi*pi/2).^2*Lx;
eta      = (0:Ny-1)'/(Ny-1)*1; 
y0       = -1;
y        = sin(eta*pi/2).^2*Ly+y0;

%-------- coordenadas (XNOD)
xnod     =[];
for k=1:Ny,
  xnod=[xnod;[x ones(Nx,1)*y(k)]];
end

%-------- conectividades (ICONE)
icone    =[];
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
ico2= [ (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' (1:Nx-1)'];
for k=1:Ny-1,
    icone=[icone; (k-1)*Nx+ico ];
end

% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;
nodes_bot  = (1:Nx);
nodes_top  = Nx*(Ny-1)+(1:Nx);
nodes_lef  = 1:Nx:Nx*Ny;
nodes_rig  = Nx:Nx:Nx*Ny;

fixa= zeros(numnp,ndf);
%fixa(nodes_lef,1)=ones(length(nodes_lef),1);
%fixa(nodes_rig,1)=ones(length(nodes_rig),1);
fixa(nodes_top,1)=ones(length(nodes_top),1);
fixa(nodes_bot,1)=ones(length(nodes_bot),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc = zeros(numnp,ndf);
forc(nodes_bot,1) = 200*ones(length(nodes_bot),1);
forc(nodes_top,1) = 100*ones(length(nodes_top),1);

%-------- Fuentes de volumen (por elemento)
 xc=0;yc=0;
 factor = 1/nen;
 for kk=1:nen,
  xc = xc+factor*xnod(icone(:,kk),1);
  yc = yc+factor*xnod(icone(:,kk),2);
 end
 mask=(yc>0.1)&(yc<0.3);
 source = 0*mask;
%--------- Termino reactivo -----------------------------
reac = 0*ones(numel,1);

%--------- Campo de Velocidad -----------------------------
 veloc  =  [cos(75*pi/180)*ones(numnp,1) sin(75*pi/180)*ones(numnp,1)];
 veloc  =  0*[zeros(numnp,1) ones(numnp,1)];

%-------- Propiedades del material

 rho     = 1    ;
 Cp      = 1    ;
 kappa   = 1e+1 ;
 npg     =  2   ;
 prop(1) =rho   ;
 prop(2) =Cp    ;
 prop(3) =kappa ;
 prop(4) =npg   ;

 upwind  =    0 ;
 shocap  =    0 ;
 axisim  =    1 ;
% [1] SUPG
% [2] (SU+C)PG
 type_upw =    1;   
 lumped   =   0 ;

 prop(6)  = upwind ;
 prop(7)  = shocap ;
 prop(8)  = axisim ;
 prop(9)  = type_upw;
 prop(11) = lumped ;

%-------- Cargas repartidas (STRG)

strg  = [ ...
   42.0000   63.0000   -0.5108   -0.4625
   63.0000   84.0000   -0.4625   -0.4254
  420.0000  441.0000   -0.1187   -0.1055 ];

strg    = [];

%-------- Condiciones de contorno mixtas (TECO)

%eles    = (2*(Nx-1):Nx-1:(Nx-1)*(Ny-1))';
eles    = (4*(Nx-1):Nx-1:(Nx-1)*(Ny-1))';
[numel,nen]=size(icone);
face    = 2*ones(size(eles));
val1    = 100*ones(size(eles));
val2    = 40*ones(size(eles));

teco     = [];
teco    = [eles face val1/rho/Cp val2 ];

%-------- Condiciones periodicas
peri = [nodes_bot' nodes_top'];
peri = [];

%-------- Solucion inicial (PHI)
bini = 200*ones(numnp,ndf);

%mask = (xnod(:,1)>0.3)&(xnod(:,1)<0.5)&(xnod(:,2)>-0.5)&(xnod(:,2)<0);
%nn   = find(mask==1);
%bini(nn) = ones(length(nn),1);
for k=1:ndf,
 nofree        = find(fixa(:,k)~=0);
 bini(nofree,k)   = forc(nofree,k);
end
