%
%   Ejemplo Nestor y Facundo
%

cd Nestor
if 0,
% malla de xyz
load calvo.nod
xnod=calvo;
% conectividades
load calvo.con
icone=calvo;
else
% malla de xyz
load borar.xyz
xnod=borar;
% conectividades
load borar.con
icone=borar;    
end

cd ..

% guardo la z para las BC
z    = xnod(:,3);
xnod = xnod(:,1:2);

[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;
xmax = max(xnod);
xmin = min(xnod);
tol = 1e-6;

%-------- fijaciones (FIXA)
[ifaceb,nodes_bou]=pfbou2d(xnod,icone,1);

fixa = zeros(numnp,ndf);
forc = zeros(numnp,ndf);
if 0,
    load calvo.bou
    vaux = calvo;
    nodes = vaux(:,1);
    value = vaux(:,2);
else
    nodes = rmdblist(m2v(nodes_bou));
    value = z(nodes);
end

fixa(nodes,1) = 1;
forc(nodes,1) = value;

%-------- Fuentes de volumen (por elemento)
source = zeros(numel,1);
%--------- Termino reactivo -----------------------------
reac   = zeros(numel,1);

%--------- Campo de Velocidad -----------------------------
veloc  =  0*[zeros(numnp,1) ones(numnp,1)];

%-------- Propiedades del material
rho     = 1  ;
Cp      = 1  ;
kappa   = 1  ;
npg     =  2   ;
prop(1) =rho   ;
prop(2) =Cp    ;
prop(3) =kappa ;
prop(4) =npg   ;

upwind  =    0 ;
shocap  =    0 ;
axisim  =    0 ;
% [1] SUPG
% [2] (SU+C)PG
type_upw =    1;   
lumped   =   0 ;
weak_form =  0 ;

prop(6)  = upwind ;
prop(7)  = shocap ;
prop(8)  = axisim ;
prop(9)  = type_upw;
prop(11) = lumped ;
prop(16) = weak_form;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas
peri = [];

%-------- Solucion inicial (PHI)
bini = zeros(numnp,ndf);

for k=1:ndf,
    nofree        = find(fixa(:,k)~=0);
    bini(nofree,k)   = forc(nofree,k);
end
