%
%   Ejemplo trafo 2D
%

[xnod,icone] = read_mesh('trafo_2d');

% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end
%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;

xmax = max(xnod);
xmin = min(xnod);
tol = 1e-6;
nodes_bot  = find(abs(xnod(:,2)-xmin(2))<tol);
nodes_top  = find(abs(xnod(:,2)-xmax(2))<tol);

fixa= zeros(numnp,ndf);
fixa(nodes_top,1)=ones(length(nodes_top),1);
fixa(nodes_bot,1)=ones(length(nodes_bot),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc = zeros(numnp,ndf);
forc(nodes_bot,1) = 200*ones(length(nodes_bot),1);
forc(nodes_top,1) = 100*ones(length(nodes_top),1);

%-------- Fuentes de volumen (por elemento)
 xc=0;yc=0;
 factor = 1/nen;
 for kk=1:nen,
  xc = xc+factor*xnod(icone(:,kk),1);
  yc = yc+factor*xnod(icone(:,kk),2);
 end
 mask=(yc>0.1)&(yc<0.3);
 source = 0*mask;
%--------- Termino reactivo -----------------------------
reac = 0*ones(numel,1);

%--------- Campo de Velocidad -----------------------------
 veloc  =  [cos(75*pi/180)*ones(numnp,1) sin(75*pi/180)*ones(numnp,1)];
 veloc  =  0*[zeros(numnp,1) ones(numnp,1)];

%-------- Propiedades del material
 rho     = 1    ;
 Cp      = 1    ;
 kappa   = 1e+1 ;
 npg     =  2   ;
 prop(1) =rho   ;
 prop(2) =Cp    ;
 prop(3) =kappa ;
 prop(4) =npg   ;

 upwind  =    0 ;
 shocap  =    0 ;
 axisim  =    0 ;
% [1] SUPG
% [2] (SU+C)PG
 type_upw =    1;   
 lumped   =   0 ;
 weak_form = 1;
 
 prop(6)  = upwind ;
 prop(7)  = shocap ;
 prop(8)  = axisim ;
 prop(9)  = type_upw;
 prop(11) = lumped ;
 prop(16) = weak_form;
 
%-------- Cargas repartidas (STRG)

strg  = [ ...
   42.0000   63.0000   -0.5108   -0.4625
   63.0000   84.0000   -0.4625   -0.4254
  420.0000  441.0000   -0.1187   -0.1055 ];

strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas
peri = [nodes_bot' nodes_top'];
peri = [];

%-------- Solucion inicial (PHI)
bini = 200*ones(numnp,ndf);

%mask = (xnod(:,1)>0.3)&(xnod(:,1)<0.5)&(xnod(:,2)>-0.5)&(xnod(:,2)<0);
%nn   = find(mask==1);
%bini(nn) = ones(length(nn),1);
for k=1:ndf,
 nofree        = find(fixa(:,k)~=0);
 bini(nofree,k)   = forc(nofree,k);
end
