%
%   Ejemplo trafo 2D
%

cd tempo
if 1,
    %    [xnod,icone] = read_mesh('trafo_2d');
    load trafo_axi_3
    N=72212;
    xnod = xnod(1:N/2,1:2);    
    icone=[icone_cpr_at_psm;icone_cpr_bt_psm;icone_irn_psm;icone_oil_psm];
    icone=icone(:,4:6);    
    icone=icone(:,[1,2,3,3]);
    icone=[icone;icone_oil_hxd(:,5:8)];
else
    [xnod,icone] = read_mesh('trafo_solded');    
    xnod=xnod(:,2:3);
    icone=icone(:,2:4);
    icone=icone+1;    
end
cd ..

% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;

xmax = max(xnod);
xmin = min(xnod);
tol = 1e-6;

fixa= zeros(numnp,ndf);
forc = zeros(numnp,ndf);

% marcamos los nodos que no se usan para fijarlos
mask=ones(numnp,1);
nodes=m2v(icone);
mask(nodes)=0;
nn=find(mask==1);
fixa(nn,1)=1;

if 0,
    load tempo/trafo_2d.fixa;
    nodes = tempo_trafo_2d(:,1);
    fixa(nodes,1)=ones(length(nodes),1);
    
    value = tempo_trafo_2d(:,2);
    forc(nodes,1) = value;
else
    nodes = m2v(icone);
    xxmin = min(xnod(nodes,:));
    xxmax = max(xnod(nodes,:));    
    nodes_axis=find(abs(xnod(nodes,1)-xxmin(1))<tol);
    nodes_axis=nodes(nodes_axis);
    nodes_ext =find(abs(xnod(nodes,1)-xxmax(1))<tol);
    nodes_ext=nodes(nodes_ext);    
    nodes_top =find(abs(xnod(nodes,2)-xxmax(2))<tol);    
    nodes_top=nodes(nodes_top);    
    fixa(nodes_axis)=1;
    fixa(nodes_ext)=1; 
    fixa(nodes_top)=1;    
    forc(nodes_ext)=1;        
    forc(nodes_top)=0.5;            
end

%-------- Fuentes de volumen (por elemento)
xc=0;yc=0;
factor = 1/nen;
for kk=1:nen,
    xc = xc+factor*xnod(icone(:,kk),1);
    yc = yc+factor*xnod(icone(:,kk),2);
end
mask=(yc>0.1)&(yc<0.3);
source = 0*mask;
%--------- Termino reactivo -----------------------------
reac = 0*ones(numel,1);

%--------- Campo de Velocidad -----------------------------
veloc  =  [cos(75*pi/180)*ones(numnp,1) sin(75*pi/180)*ones(numnp,1)];
veloc  =  0*[zeros(numnp,1) ones(numnp,1)];

%-------- Propiedades del material
rho     = 1    ;
Cp      = 1    ;
kappa   = 1e+1 ;
npg     =  2   ;
prop(1) =rho   ;
prop(2) =Cp    ;
prop(3) =kappa ;
prop(4) =npg   ;

upwind  =    0 ;
shocap  =    0 ;
axisim  =    0 ;
% [1] SUPG
% [2] (SU+C)PG
type_upw =    1;   
lumped   =   0 ;
weak_form = 1;

prop(6)  = upwind ;
prop(7)  = shocap ;
prop(8)  = axisim ;
prop(9)  = type_upw;
prop(11) = lumped ;
prop(16) = weak_form;

%-------- Cargas repartidas (STRG)

strg  = [ ...
        42.0000   63.0000   -0.5108   -0.4625
    63.0000   84.0000   -0.4625   -0.4254
    420.0000  441.0000   -0.1187   -0.1055 ];

strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas
peri = [];

%-------- Solucion inicial (PHI)
bini = zeros(numnp,ndf);
bini = rand(numnp,ndf);

for k=1:ndf,
    nofree        = find(fixa(:,k)~=0);
    bini(nofree,k)   = forc(nofree,k);
end
