function [G_dif] = Dflux_correction(Up,dUp,prop);
%--------------------------------------------------------------------
%
%              correccion termino difusivo
%
%             2*visco*strain_rate*grad(alpha)
%
%              [G_dif] = Dflux_correction(Up,dUp,prop)
%
%--------------------------------------------------------------------

tol         = 1e-2;
rho_g       = prop(1);
visco_g     = prop(2);
[N,ndf]     = size(Up);
alpha_g     = Up(:,1);
vel_g       = Up(:,2:3);
ndm         = 2;

grad_u      = reshape(dUp(:,2,1:2),N,2);
grad_v      = reshape(dUp(:,3,1:2),N,2);
grad_alpha  = reshape(dUp(:,1,1:2),N,2);

defo(:,1,1) = grad_u(:,1)+grad_u(:,1);
defo(:,1,2) = grad_u(:,2)+grad_v(:,1);
defo(:,2,1) = grad_v(:,1)+grad_u(:,2);
defo(:,2,2) = grad_v(:,2)+grad_v(:,2);
defo        = defo/2;

alpha_max   = max([alpha_g';ones(1,N)*tol])';

G_dif       = zeros(N,ndf);
for j=1:ndm
   for k=1:ndm
      G_dif(:,j+1) = G_dif(:,j+1) + 2*visco_g*defo(:,j,k).*grad_alpha(:,k)./alpha_max;
   end
end   
