%----------------------------------------------------------------------
%
%          Fichero de datos
%
%----------------------------------------------------------------------

caso  = 1 ;

if caso==0,
   % gas pipe flow with alpha_g fixed at input
   bubbly_00;   
elseif caso==1,
   % gas pipe flow with alpha_g fixed at input, axisymmetric case
   % bubbly_01;      
   % caso 1D
%   bubbly_01_1D_vel_fixed;  % fixed velocity
%   bubbly_01_1D_alpha_fixed;  % fixed void fraction  
   bubbly_01_1D;  % no field fixed
elseif caso==2,
   % gas pipe flow with alpha_g fixed at input, horizontal velocity
   bubbly_02;         
elseif caso==3,
   % laddle 2D with gas inlet
   bubbly_03;         
else
   error(' MALA ELECCION DEL CASO A TRATAR')
end

% Type_solver ------>  [ 0 ]  standard - directo con relajacion (relax)
%                      [ 1 ]  line-search
%                      [ 2 ]  explicito
%                      [ 3 ]  GMRES

  limit    =   1e-06;
  dt          = 0.0001 ;
  type_solver = 0;
  relax       = 1;     % parametro de relajacion fijo para type_solver=0
  nu_max      = 1;	  % numero maximo de iteraciones por paso de tiempo
  alfa_min    = 0.01;  % para linesearch
  alpha       = 1;     % grado de implicitud (1/2 Cranck-Nicholson)
  ntime       = 2;     % numero de pasos de tiempo
  nstep       = 1;     % guarda solucion cada nstep pasos de tiempo
  scaling     = 1;     % scaling equations at solver for better conditioning of the system

if caso==0,
   alpha       = 1;
   dt          = 1e-03 ;
   type_solver = 0;
   relax       = 1;     
   nu_max      = 4;  
   alfa_min    = 0.01;  
   ntime       = 1;   
   nstep       = 10;     
   nsave       = 10;   
   dtmin       = 1e-3;
   dtmax       = 1e-3;   
elseif caso==1 | caso==3,
   alpha       = 1;
   dt          = 1e+15 ;
   type_solver = 0;
   relax       = 1;     
   nu_max      = 6;  
   alfa_min    = 0.01;  
   ntime       = 1;   
   nstep       = 10;     
   nsave       = 10;
   nplot       = 2;
   dtmin       = 1e-5;
   dtmax       = 1e-5;
   limit       = 1e-8;
elseif caso==2,
   alpha       = 1;
   dt          = 1e-02 ;
   type_solver = 0;
   relax       = 1;     
   nu_max      = 5;  
   alfa_min    = 0.01;  
   ntime       = 100;   
   nstep       = 1;     
   nsave       = 10;      
end
   
  
prop(12) = limit    ;
prop(13)  = dt    ; % paso de tiempo
prop(14)  = alpha ; % grado de implicitud  

prop_solver = [type_solver,relax,nu_max,alfa_min,alpha,ntime,nstep,scaling];