%
%   incluye (SU+C)PG
%

tol = 1e-06;

if nen~=4, error(' SOLO PARA QUADS ???? '); end

type_upwind = 2; % [0] simple  [1] based on eigenvalues
type_shocap = 0; % [0] isotropico [1] anisotropico
lumping_drag_forces = 0;  % [0] not lumped drag forces [1] lumped drag forces
conservative_version = 0;

time_factor=0;  % lumping sobre el termino temporal
if type_upwind==2, time_factor=1; end % no lumping sobre el termino temporal

if weak_form ==1 & conservative_version==0, 
   error(' This version should be used without weak form '); 
end

ne  = length(eles);
[bas,ndf_fields] = size(extra_nodal_fields);

% Localizacion de las variables
%------------------------------------------------------------------

    ceros = zeros(ne,nen*ndf);
       Ue = ceros;
      U0e = ceros;
	    re = zeros(ne,nen);
     Uf_e = zeros(ne,nen*ndf_fields);
   Uenorm = zeros(ne,nen);
for inod=1:nen,
            nodes  = icone(eles,inod);
            jnod  = (inod-1)*ndf+(1:ndf);
            knod  = (inod-1)*ndf_fields+(1:ndf_fields);            
       Ue(:,jnod)  = U(nodes,1:ndf);		 
       U0e(:,jnod) = Uold(nodes,1:ndf);   
       re(:,inod)  = xnod(nodes,1);		        
       Uf_e(:,knod)  = extra_nodal_fields(nodes,1:ndf_fields);       
       Uenorm(:,inod) = sqrt(sum(Uold(nodes,1:ndf)'.^2)');
end

% UPWIND EN EL CENTROIDE 
%------------------------------------------------------------------
if nen==4,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),0,0);
  [dshapex0,N0] = shape2d(X2S,0,0,nen); 
elseif nen==3,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),1/3,1/3);
  [dshapex0,N0] = shape2d(X2S,1/3,1/3,nen); 
else
  error(' Bad type of element , nen ~=3, nen ~=4 ')
end
Upg        = zeros(ne,ndf);
dUpg       = zeros(ne,ndf,ndm);
dUpg_new   = zeros(ne,ndf,ndm);
grad_Unorm = zeros(ne,ndm);
grad_p     = zeros(ne,ndm);
vel_l      = zeros(ne,ndm);

for inod=1:nen,
   jnod = (inod-1)*ndf+(1:ndf);
   Upg(:,(1:ndf))    =  Upg(:,(1:ndf)) + N0(inod).*  U0e(:,jnod);
   dUpg(:,(1:ndf),1) = dUpg(:,(1:ndf),1) + ...
	          (dshapex0(:,inod,1)*ones(1,ndf)).* U0e(:,jnod);          
   dUpg(:,(1:ndf),2) = dUpg(:,(1:ndf),2)+ ...
             (dshapex0(:,inod,2)*ones(1,ndf)).* U0e(:,jnod);             
   dUpg_new(:,(1:ndf),1) = dUpg_new(:,(1:ndf),1) + ...
	          (dshapex0(:,inod,1)*ones(1,ndf)).* Ue(:,jnod);          
   dUpg_new(:,(1:ndf),2) = dUpg_new(:,(1:ndf),2)+ ...
             (dshapex0(:,inod,2)*ones(1,ndf)).* Ue(:,jnod);             
      
   grad_Unorm(:,1) = grad_Unorm(:,1) + dshapex0(:,inod,1).* Uenorm(:,inod);
   grad_Unorm(:,2) = grad_Unorm(:,2) + dshapex0(:,inod,2).* Uenorm(:,inod);   
   
      grad_p(:,1)  = grad_p(:,1) + dshapex0(:,inod,1).* Uf_e(:,(inod-1)*ndf_fields+1);
      grad_p(:,2)  = grad_p(:,2) + dshapex0(:,inod,2).* Uf_e(:,(inod-1)*ndf_fields+1);          
      vel_l(:,1)   = vel_l (:,1) + N0(inod).* Uf_e(:,(inod-1)*ndf_fields+2);
      vel_l(:,2)   = vel_l (:,2) + N0(inod).* Uf_e(:,(inod-1)*ndf_fields+3);      

end    

%[H,bas] = enthalpy_function(Upg,prop);

velpg   = Upg(:,2:3);
hele    = comp_hele(velpg,dshapex0,Jaco0,nen);
if type_upwind~=2,
[tau,delta,bas] = supg_bubbly_2d(Upg,dUpg,Cou,hele,shocap,type_upwind);
else
velmod      = sqrt(sum(velpg'.^2))';
[bas,Cp]    = enthalpy_function(Upg,prop);
div_vg_0    = dUpg(:,2,1)+dUpg(:,3,2);
[bas,Cr]    = Cflux_nc(Upg,grad_p,vel_l,div_vg_0,prop,0);
reac        = [Cr(:,1,1)+Cp(:,1,1)./dt , Cr(:,2,2)+Cp(:,2,2)./dt , Cr(:,3,3)+Cp(:,3,3)./dt];
[bas,delta,bas] = supg_bubbly_2d(Upg,dUpg,Cou,hele,shocap,0);

%[tau,delta] = compute_tau_adv_dif_reac(Upg,dUpg,velmod,hele,reac,prop,1);
% upwind del tipo funcion burbuja (SU+C)PG
%------------------------------------------------------------------
for idf=1:ndf
   source     = 0*reac(:,idf);
   if idf==1, kappa=tol; else kappa      = max([visco_g;tol]); end
   [beta,gamma(:,idf)] = sucpg(velpg,hele,kappa,abs(reac(:,idf)),source);
   tau(:,idf)   = beta.*hele.^2/2/kappa; 
%   delta      = 0*tau(:,idf);
end

%disp('bubbly_2d_ele_with_sucpg');keyboard;pause

end

% Flux_function_nc :=> non-conservative Flux_function version
  if conservative_version,
     [bas,Ax0,Ay0]     =  Flux_function(Upg,prop);        
  else
     [bas,Ax0,Ay0]     =  Flux_function_nc(Upg,prop);   
  end

div_vg_0 = dUpg_new(:,2,1)+dUpg_new(:,3,2);

Vol = zeros(ne,nen);

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------
 for ipg=1:npg
  
  [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
  [dshapex,N] = shape2d(X2S,psipg(ipg),etapg(ipg),nen); 

% Interpolacion en punto de Gauss
%------------------------------------------------------------------

     Upg    = zeros(ne,ndf);
    U0pg    = zeros(ne,ndf);
    dUpg    = zeros(ne,ndf,ndm);
   radpg    = zeros(ne,1);
   grad_p   = zeros(ne,ndm);
   vel_l    = zeros(ne,ndm);
   
  for inod=1:nen,
     jnod = (inod-1)*ndf+(1:ndf);
      Upg(:,(1:ndf))  =  Upg(:,(1:ndf)) + N(inod).*  Ue(:,jnod);
      U0pg(:,(1:ndf)) = U0pg(:,(1:ndf)) + N(inod).* U0e(:,jnod);
      radpg(:,1)      =      radpg(:,1) + N(inod).* re(:,inod);
      
      dUpg(:,(1:ndf),1)   = dUpg(:,(1:ndf),1) + ...
	          (dshapex(:,inod,1)*ones(1,ndf)).* Ue(:,jnod);
          
      dUpg(:,(1:ndf),2) = dUpg(:,(1:ndf),2)+ ...
	          (dshapex(:,inod,2)*ones(1,ndf)).* Ue(:,jnod);          
      grad_p(:,1)  = grad_p(:,1) + dshapex(:,inod,1).* Uf_e(:,(inod-1)*ndf_fields+1);
      grad_p(:,2)  = grad_p(:,2) + dshapex(:,inod,2).* Uf_e(:,(inod-1)*ndf_fields+1);          
      vel_l(:,1)   = vel_l (:,1) + N(inod).* Uf_e(:,(inod-1)*ndf_fields+2);
      vel_l(:,2)   = vel_l (:,2) + N(inod).* Uf_e(:,(inod-1)*ndf_fields+3);      
  end
  
  
  [H,Cp]     =  enthalpy_function(Upg,prop);
  [H0,bas]   =  enthalpy_function(U0pg,prop);
  
  % advective flux function  
  if conservative_version,
     [Fa,Ax,Ay]     =  Flux_function(Upg,prop);        
  else
     [Fa,Ax,Ay]     =  Flux_function_nc(Upg,prop);   
  end
    
  % reactive and source terms due to:
  % .- pressure gradient 
  % .- bouyancy forces
  % .- phase interactions drag  
    
  %disp('Bubbly_2d_ele');keyboard;pause

  if lumping_drag_forces,
  job         = 1; % [0] en Cflux todas las 3 fuerzas (pressure, buoyancy y pressure)
                   % [1] en Cflux solo las 3 fuerzas de pressure y buoyancy
                   % [2] en Cflux solo la fuerza de drag
  else
     job = 0;
  end
  
  if conservative_version,
     [Fc_1,C_1] = Cflux(Upg,grad_p,vel_l,prop,job);
  else
     % Cflux_nc :=> non-conservative Cflux version
     div_vg = dUpg(:,2,1)+dUpg(:,3,2);
     [Fc_1,C_1] = Cflux_nc(Upg,grad_p,vel_l,div_vg,prop,job);
  end
  
  % Upg y dUpg deben tener como 2da y 3ra componentes a la velocidad   
   [Fd,Kxx,Kxy,Kyx,Kyy]  = Dflux(Upg,dUpg,prop);  
%  [Kxx,Kxy,Kyx,Kyy] = Djac_2D(Upg,prop);
  
  % Correccion axisimetrica del jacobiano de la transformacion al elemento master
  %------------------------------------------------------------------
  xsj =  wpg(ipg) .* Jaco;
  if axisim,
     xsj = xsj.*radpg;
  end

  AgU = rowprod(Ax,dUpg(:,1:ndf,1),ndf,ndf,1) + ... 
        rowprod(Ay,dUpg(:,1:ndf,2),ndf,ndf,1);
    
  % P_i Petrov-Galerkin perturbation weight function
  for inod=1:nen,   

     P_supg = zeros(ne,ndf,ndf);       
     
     % Element Volume
     Vol(:,inod)=Vol(:,inod)+N(inod)*xsj;
     
     % W_i = N_i + P_i
     if type_upwind==-1,
        tmpx = tau.*dshapex(:,inod,1);
        tmpy = tau.*dshapex(:,inod,2);
        for idf=1:ndf,
           for jdf=1:ndf,
              P_supg(:,idf,jdf) = tmpx.*Ax0(:,idf,jdf) + tmpy.*Ay0(:,idf,jdf) ;
           end 
        end
     elseif type_upwind==0,
        tmp = tau.*(velpg(:,1).*dshapex(:,inod,1)+velpg(:,2).*dshapex(:,inod,2));
        for idf=1:ndf,
           P_supg(:,idf,idf) = tmp;
        end
               
        div_vel = dUpg(:,2,1)+dUpg(:,3,2);
        
        P_supg(:,1,1) = P_supg(:,1,1) - (0)* div_vel*N(inod);

     elseif type_upwind==1,
        tmpx = rowprod(tau,Ax0,ndf,ndf,ndf);
        tmpy = rowprod(tau,Ay0,ndf,ndf,ndf);
%        tmpx = rowprod(Ax0,tau,ndf,ndf,ndf);
%        tmpy = rowprod(Ay0,tau,ndf,ndf,ndf);
        for idf=1:ndf,
           for jdf=1:ndf,
              P_supg(:,idf,jdf) = tmpx(:,idf,jdf).*dshapex(:,inod,1) + ... 
                 tmpy(:,idf,jdf).*dshapex(:,inod,2);
           end 
        end           

     elseif type_upwind==2, % (GLS)

     for idf=1:ndf,
        P_supg(:,idf,idf)  = tau(:,idf).*(velpg(:,1).*dshapex(:,inod,1)+velpg(:,2).*dshapex(:,inod,2));         
        P_supg_reac = gamma(:,idf) .* ( (-1/4)* (1-psipg(ipg)^2)*(1-etapg(ipg)^2) );
        P_supg(:,idf,idf) = P_supg(:,idf,idf)+ P_supg_reac;             
     end
     
     else
        error('Bad type of upwind has been chosen ')
     end
  
    W_supg = P_supg;
  
     for idf=1:ndf,
        W_supg(:,idf,idf)=W_supg(:,idf,idf)+N(inod);
     end
     
     % W_i N_j term
                
        for jnod=1:nen,        
        % A_gN     
        tmpx = dshapex(:,jnod,1);
        tmpy = dshapex(:,jnod,2);
        for idf=1:ndf,
           for jdf=1:ndf,
              A_gN(:,idf,jdf,jnod) = tmpx.*Ax(:,idf,jdf) + tmpy.*Ay(:,idf,jdf) ;
           end 
        end    
        end
        
        for jnod=1:nen,
           
        % temporal terms
        W_Cp_N = rowprod(W_supg,Cp,ndf,ndf,ndf)*N(jnod) ;        
        
        % N_A_gN or gN_A_N according to weak form
        if weak_form,
                 N_A_gN = -A_gN(:,:,:,inod)*N(jnod);                 
        else          
                 N_A_gN =  A_gN(:,:,:,jnod)*N(inod);              
        end
        
        P_A_gN = rowprod(P_supg,A_gN(:,:,:,jnod),ndf,ndf,ndf);
        
        % shock capturing term
        gN_D_gN = zeros(numel,ndf,ndf);        
        if (shocap > 0)        
           for idf=1:ndf,
              for idm=1:ndm
                 gN_D_gN(:,idf,idf) = gN_D_gN(:,idf,idf) + ...
                    dshapex(:,inod,idm).*delta.*dshapex(:,jnod,idm);
              end
           end
        end
        
        gN_K_gN = zeros(numel,ndf,ndf);        
        for idf=1:ndf,
           for jdf=1:ndf,
              gN_K_gN(:,idf,jdf) = ...
                 -( (dshapex(:,inod,1).*Kxx(:,idf,jdf).*dshapex(:,jnod,1))+ ...
                    (dshapex(:,inod,1).*Kxy(:,idf,jdf).*dshapex(:,jnod,2))+ ...
                    (dshapex(:,inod,2).*Kyx(:,idf,jdf).*dshapex(:,jnod,1))+ ...
                    (dshapex(:,inod,2).*Kyy(:,idf,jdf).*dshapex(:,jnod,2)) );
           end             
        end
        
        % reactive terms
        W_C_N = rowprod(W_supg,C_1,ndf,ndf,ndf)*N(jnod) ;        
        
        % assembling
        vaux =  N_A_gN + P_A_gN + gN_D_gN - gN_K_gN + W_C_N;
        

        for idf=1:ndf,
           for jdf=1:ndf,              
              Mele(:,inod,idf,jnod,jdf) = Mele(:,inod,idf,jnod,jdf) + ... 
              xsj.*( time_factor*W_Cp_N(:,idf,jdf) ./ dt + vaux(:,idf,jdf) );           
           end
        end
                
        end % jnod
        
        % temporal term
        W_dUdt   = rowprod(W_supg,(H-H0),ndf,ndf,1);
        
        % advective fluxes
        if weak_form,
           
           gN_Fa = -(dshapex(:,inod,1)*ones(1,ndf)).*Fa(:,1:ndf,1) ... 
                   -(dshapex(:,inod,2)*ones(1,ndf)).*Fa(:,1:ndf,2);
        else
           gN_Fa = (N(inod)*ones(numel,ndf)).* AgU(:,1:ndf);
        end
        
        % diffusive fluxes
        gN_Fd = -(dshapex(:,inod,1)*ones(1,ndf)).*Fd(:,1:ndf,1) ... 
                -(dshapex(:,inod,2)*ones(1,ndf)).*Fd(:,1:ndf,2);
                          
        % stabilization SUPG terms        
        P_A_gU   = rowprod(P_supg,AgU,ndf,ndf,1);
        
        gN_D_gU = zeros(ne,ndf);
        
        if(shocap>0)                
           for idf=1:ndf,
              for idm=1:ndm              
                 gN_D_gU(:,idf) = gN_D_gU(:,idf) + ...
                    dshapex(:,inod,idm).*delta.*dUpg(:,idf,idm);
              end
           end
        end

        % reactive and source terms        
        W_Fc_1   = rowprod(W_supg,Fc_1,ndf,ndf,1) ;

        vaux =  gN_Fa + P_A_gU + gN_D_gU - gN_Fd + W_Fc_1;  
    
        for idf=1:ndf,
           Rele(:,inod,idf) = Rele(:,inod,idf) - ... 
                              (vaux(:,idf) +time_factor*W_dUdt(:,idf) ./ dt ).* xsj ;
        end

  end % inod
    
end % ipg


if lumping_drag_forces,

for inod=1:nen,
   % reactive and source terms        
   job         = 2; % [0] en Cflux todas las 3 fuerzas (pressure, buoyancy y pressure)
                    % [1] en Cflux solo las 3 fuerzas de pressure y buoyancy
                    % [2] en Cflux solo la fuerza de drag

   jnod           = (inod-1)*ndf+(1:ndf);
   Upg(:,(1:ndf)) = Ue(:,jnod);
   U0pg(:,(1:ndf)) = U0e(:,jnod);   
   vel_l(:,1)     = Uf_e(:,(inod-1)*ndf_fields+2);
   vel_l(:,2)     = Uf_e(:,(inod-1)*ndf_fields+3);      
   
   [H,Cp]     =  enthalpy_function(Upg,prop);
   [H0,bas]   =  enthalpy_function(U0pg,prop);
   
  if conservative_version,
     [Fc_2,C_2] = Cflux(Upg,grad_p,vel_l,prop,job);
  else
     [Fc_2,C_2] = Cflux_nc(Upg,0*grad_p,vel_l,div_vg_0,prop,job);     
  end
  
  if 0,
  figure(1);clf;plot(div_vg_0,'b-*');
  figure(2);subplot(211);plot(hele.*div_vg_0/abs(Upg(:,3)));title('c h / abs(vel) ')
  figure(2);subplot(212);plot(hele.^2.*div_vg_0/visco_g);title('c h^2/kappa')
  keyboard;pause  
  end

   if 1,
   for idf=1:ndf,
       for jdf=1:ndf,              
          Mele(:,inod,idf,inod,jdf)=Mele(:,inod,idf,inod,jdf)+Vol(:,inod).*C_2(:,idf,jdf);               
          Mele(:,inod,idf,inod,jdf)=Mele(:,inod,idf,inod,jdf)+(1-time_factor)*Vol(:,inod).*Cp(:,idf,jdf)./dt;           
       end
    end
   end

   for idf=1:ndf,
      Rele(:,inod,idf) = Rele(:,inod,idf) - Vol(:,inod).*Fc_2(:,idf);
      Rele(:,inod,idf) = Rele(:,inod,idf) - (1-time_factor)*Vol(:,inod).*(H(:,idf)-H0(:,idf))./dt;      
   end

end
end

% ------ Terminos de contorno

if weak_form,
   [Mele,Rele] = bc_conv_bubbly_2d(xnod,icone,Ue,ifaceb,Rele,Mele,prop);   
end

