function [Fd,Kxx,Kxy,Kyx,Kyy] = Dflux(grad_Up,alpha,prop,visco_t);
%--------------------------------------------------------------------
%
%       [Fd,Kxx,Kxy,Kyx,Kyy] = Dflux(Up,dUp,alpha_g,prop);
%
%  Diffusive fluxes and jacobians 
%
%--------------------------------------------------------------------


[N,nphases] = size(alpha);
[N,ndf,ndm] = size(grad_Up);

Fd     = zeros(N,ndf,2);
Kxx    = zeros(N,ndf,ndf);
Kxy    = zeros(N,ndf,ndf);
Kyx    = zeros(N,ndf,ndf);
Kyy    = zeros(N,ndf,ndf);

% epsilon (vel)
grad_vel_k  = grad_Up(:,2:3,:);
grad_vel    = grad_vel_k(:,1:2,:);
grad_u      = reshape(grad_vel(:,1,1:2),N,2);
grad_v      = reshape(grad_vel(:,2,1:2),N,2);
defo(:,1,1) = grad_u(:,1)+grad_u(:,1);
defo(:,1,2) = grad_u(:,2)+grad_v(:,1);
defo(:,2,1) = grad_v(:,1)+grad_u(:,2);
defo(:,2,2) = grad_v(:,2)+grad_v(:,2);
defo        = defo/2;
tau         = 2*defo;
[rho_m,visco_m] = get_mixture_props(alpha,prop,visco_t,0);
for k=1:2,
    for m=1:2,
        Fd(:,k+1,m) = visco_m.*tau(:,k,m);       
    end
end

if 0,
    for iif=1:nphases
        ipt = (iif-1)*2+(1:2);       
        grad_vel = grad_vel_k(:,ipt+2,:);
        grad_u      = reshape(grad_vel(:,1,1:2),N,2);
        grad_v      = reshape(grad_vel(:,2,1:2),N,2);
        defo(:,1,1) = grad_u(:,1)+grad_u(:,1);
        defo(:,1,2) = grad_u(:,2)+grad_v(:,1);
        defo(:,2,1) = grad_v(:,1)+grad_u(:,2);
        defo(:,2,2) = grad_v(:,2)+grad_v(:,2);
        defo        = defo/2;
        tau         = 2*defo;    
        [rho_k,visco_k] = get_mixture_props(alpha,prop,visco_t,iif);       
        for k=1:2,
            for m=1:2,
                Fd(:,k+1,m) = Fd(:,k+1,m) + alpha(:,iif).*visco_k.*tau(:,k,m);       
            end
        end    
    end
end

vaux        = visco_m;
delta       = eye(2);
uno_1       = [1;0];
uno_2       = [0;1];

tmp_xx = (delta(1,1)*eye(2)+uno_1*uno_1');
tmp_xy = (delta(1,2)*eye(2)+uno_2*uno_1');
tmp_yx = (delta(2,1)*eye(2)+uno_1*uno_2');
tmp_yy = (delta(2,2)*eye(2)+uno_2*uno_2');

for j=1:2
    for k=1:2,
        Kxx(:,j+1,k+1)  = vaux.*tmp_xx(j,k);
        Kxy(:,j+1,k+1)  = vaux.*tmp_xy(j,k);
        Kyx(:,j+1,k+1)  = vaux.*tmp_yx(j,k);
        Kyy(:,j+1,k+1)  = vaux.*tmp_yy(j,k);      
    end
end
