function [Fa,Ax,Ay] = Flux_function(Up,rho_m)
%
%        [Fa,Ax,Ay] = Flux_function(Up,rho_m)
%
%       Computes advective fluxes F_a
%                   2D    
%	 Dimension of Fa array = numnp x ndm*ndf 
%             

ndm         = 2;
[N,ndf]     = size(Up);

pre   = Up(:,1);
vel   = Up(:,2:3);

% advective fluxes
Fa            = zeros(N,ndf,2);
A             = zeros(N,ndm,ndf,ndf);

Fa(:,1,1:2)   = (rho_m*[1,1]).*vel;

Fa(:,2,1)     = (rho_m.*vel(:,1).*vel(:,1));
Fa(:,3,1)     = (rho_m.*vel(:,1).*vel(:,2));
Fa(:,2,2)     = (rho_m.*vel(:,2).*vel(:,1));
Fa(:,3,2)     = (rho_m.*vel(:,2).*vel(:,2));

Fa(:,2,1)     = Fa(:,2,1) + pre;
Fa(:,3,2)     = Fa(:,3,2) + pre;

A(:,1,1,2)    = rho_m;
A(:,2,1,3)    = rho_m;
A(:,1,2,1)    = 1;
A(:,2,3,1)    = 1;

A(:,1,2,2)    = 2*rho_m.*vel(:,1);
A(:,1,3,2)    =   rho_m.*vel(:,2);
A(:,1,3,3)    =   rho_m.*vel(:,1);

A(:,2,2,2)    =   rho_m.*vel(:,2);
A(:,2,2,3)    =   rho_m.*vel(:,1);
A(:,2,3,3)    = 2*rho_m.*vel(:,2);

Ax         = reshape(A(:,1,:,:),N,ndf,ndf);
Ay         = reshape(A(:,2,:,:),N,ndf,ndf);      
