function [Rele,Kele] = bcconv_advdif_2d(xnod,icone,vel,U,bou_data,Rele,Kele,axisim)
%
%    [Rele,Kele] = bcconv_advdif_2d(xnod,icone,vel,U,bou_data,Rele,Kele,axisim)
%
%  Inputs:   
%              U = [    U(idf_1,idf_2, ... idf_N)_node_1 , U(idf_1,idf_2, ... idf_N)_node_2 , ... U(idf_1,idf_2, ... idf_N)_node_N]
%            vel = [vel_x(node_1,node_2, ... node_N) , vel_y(node_1,node_2, ... node_N)]
%

ndf = 1;
ndm = 2;
npg = 2;

[numel,nen] = size(icone);
[nbou,bas] = size(bou_data);

if nbou>0,

  pgauss1d;
  
  eles_bou = bou_data(:,1);
  face_bou = bou_data(:,2);

  mask = zeros(nbou,1);
  
  nodo_1 = face_bou;
  nodo_2 = (nodo_1+1).*(nodo_1<nen)+(nodo_1==nen);
  
  nodos  = [nodo_1,nodo_2];
  nodog1 = getcol(icone(eles_bou,:),nodo_1);
  nodog2 = getcol(icone(eles_bou,:),nodo_2);
  nodog  = [nodog1 , nodog2];
  
% calculo de la normal  
  dxbc   = xnod(nodog2,1) - xnod(nodog1,1);
  dybc   = xnod(nodog2,2) - xnod(nodog1,2);
  lbou   = sqrt(dxbc.^2+dybc.^2);
  norbc  = [dybc./lbou, -dxbc./lbou];
% det Jacobiano transformacion al master
  Jaco   = lbou/2;
  
  re = v2m(xnod(icone(eles_bou,:)',1),nen);
  re = [getcol(re,nodo_1), getcol(re,nodo_2) ];

  Ue = zeros(nbou,ndf*2);
  vele = zeros(nbou,2*ndm);
  for idf=1:ndf
    Ue(:,idf)     = getcol(U(eles_bou,:),(nodo_1-1)*ndf+idf);
    Ue(:,ndf+idf) = getcol(U(eles_bou,:),(nodo_2-1)*ndf+idf);
  end
    
  for idm=1:ndm,
    vele(:,1+(idm-1)*2) = getcol(vel(eles_bou,:),nodo_1+(idm-1)*nen);    
    vele(:,2+(idm-1)*2) = getcol(vel(eles_bou,:),nodo_2+(idm-1)*nen);     
  end
 
  for ipg=1:2,
          
   N = ones(nbou,1)*[(1-psipg(ipg))/2 , (1+psipg(ipg))/2 ];
   
% Localizacion , scatter   
   Upg      = zeros(nbou,ndf);
   radpg    = zeros(nbou,1);
   velpg    = zeros(nbou,ndm);
   
   for inod=1:2,    
    radpg   = radpg +  N(:,inod).*re(:,inod);
    Upg    = Upg    + (N(:,inod)*ones(1,ndf)).*Ue(:,(inod-1)*ndf+(1:ndf));
    velpg  = velpg  + (N(:,inod)*ones(1,ndm)).*vele(:,inod+[0,2]);    
   end 
   
   vn     =  sum((velpg.*norbc)')';
   Fan    =  Upg.*vn;
               
   xsj = wpg(ipg)*Jaco;
   if axisim,
     xsj = xsj.*radpg;
   end

   for iface=1:nen,
     eles = find(face_bou==iface);      
     for inod=1:2,
       jnod = iface-1+inod;
       if(jnod>nen),jnod=1; end 
       vaux  =  (N(eles,inod).*xsj(eles)*ones(1,ndf)).*Fan(eles,1:ndf);
	    Rele(eles_bou(eles),jnod,1) = Rele(eles_bou(eles),jnod,1) - vaux;          
       for iinod=1:2, 
         jjnod = iface-1+iinod;
         if(jjnod>nen),jjnod=1; end           
         vaux  =  (N(eles,inod).*xsj(eles)).*vn(eles,1).*N(eles,iinod);         
         Kele(eles_bou(eles),jnod,1,jjnod,1) = Kele(eles_bou(eles),jnod,1,jjnod,1)+ vaux;           
       end % for iinod
     end  % for inod
    end % for iface
   end % puntos de Gauss del contorno

end % if bou

%disp(' BC_CONV_EULER ');keyboard;pause
