function [rho_m,visco_m] = get_mixture_props(alpha,prop,visco_t,Id)
% 
%   [rho_m,visco_m] = get_mixture_props(alpha,prop,visco_t,Id)
%
%   Id = 0 : para obtener props de la mezcla
%   Id = 1,2,... para obtener las difusiones de las ecuaciones de transporte
%

if nargin<4, Id=0; end


ijob = 'get';
handle_prop_elem;

[N,ndf_fields]=size(alpha);
rho_k = [rho_g,rho_s,rho_l];
    
if Id==0,

    visco_k = [visco_g,visco_s,visco_l];
    
    % rho_k = vector de densidades [rho_1,rho_2, ... rho_ndf_fields , rho_c] , rho_c: densidad fase continua
    alpha_c = ones(N,1);
    rho_m = zeros(N,1);
    for iif=1:ndf_fields,
        rho_m = rho_m + rho_k(iif)*alpha(:,iif);
        alpha_c = alpha_c - alpha(:,iif);
    end
    rho_m = rho_m + alpha_c.*rho_k(ndf_fields+1);
    
    % visco_k = vector de viscosidades [mu_1,mu_2, ... mu_ndf_fields , mu_c] , mu_c: viscosidad fase continua
    visco_m = zeros(N,1);
    for iif=1:ndf_fields,
        visco_m = visco_m + visco_k(iif)*alpha(:,iif);
    end
    visco_m = visco_m + alpha_c.*(visco_k(ndf_fields+1)+rho_k(ndf_fields+1)*visco_t);  % solo tratamos como turbulenta la fase continua !!!
else
    Sct = 1;
    visco_k = rho_k(Id)*(visco_l/rho_l+visco_t)/Sct;    
    rho_m   = rho_k(Id)*ones(N,1);
    visco_m = visco_k;   
end

