function visco_t = get_turbulent_visco(grad_vel,hele);
%
%  Smagorisnky LES turbulence model
%

C_smag = 0.18;
[N,bas,bas] = size(grad_vel);

grad_u      = reshape(grad_vel(:,1,1:2),N,2);
grad_v      = reshape(grad_vel(:,2,1:2),N,2);

defo(:,1,1) = grad_u(:,1)+grad_u(:,1);
defo(:,1,2) = grad_u(:,2)+grad_v(:,1);
defo(:,2,1) = grad_v(:,1)+grad_u(:,2);
defo(:,2,2) = grad_v(:,2)+grad_v(:,2);
defo        = defo/2;

visco_t = zeros(N,1);
for idm=1:2, 
    for jdm=1:2,
        visco_t = visco_t + defo(:,idm,jdm).^2;
    end
end
visco_t = C_smag*hele.^2.*sqrt(visco_t);