function vel_m = get_vel_mix(vel_l,vslip,alpha,prop)
%
%   vel_m = get_vel_mix(vel_l,vslip,alpha,prop)
%

[N,nphases]=size(alpha);

alpha_c = ones(N,1);
rho_m   = zeros(N,1);
vel_m   = 0*vel_l;

for iif=1:nphases,
   [rho_k,bas] = get_mixture_props(alpha,prop,0,iif);     
   rho_m = rho_m + rho_k.*alpha(:,iif);
   alpha_c = alpha_c - alpha(:,iif);   
   vel_m = vel_m + ((rho_k.*alpha(:,iif))*ones(1,2)).*vslip(:,(iif-1)*2+(1:2));
end
[rho_k,bas] = get_mixture_props(alpha,prop,0,nphases+1);
rho_m = rho_m + alpha_c.*rho_k;
vel_m = vel_m + ((rho_k.*alpha_c)*ones(1,2)).*vel_l;
vel_m = vel_m ./ (rho_m*ones(1,2));
return
