function [Fd,Kxx,Kxy,Kyx,Kyy] = Dflux(Up,dUp,visco_m);
%--------------------------------------------------------------------
%
%       [Fd,Kxx,Kxy,Kyx,Kyy] = Dflux(Up,dUp,alpha_g,prop);
%
%  Diffusive fluxes and jacobians 
%
%--------------------------------------------------------------------

%ijob = 'get';
%handle_prop_elem;

[N,ndf] = size(Up);
pre     = Up(:,1);
vel     = Up(:,2:3);

Fd     = zeros(N,ndf,2);
Kxx    = zeros(N,ndf,ndf);
Kxy    = zeros(N,ndf,ndf);
Kyx    = zeros(N,ndf,ndf);
Kyy    = zeros(N,ndf,ndf);

grad_u      = reshape(dUp(:,2,1:2),N,2);
grad_v      = reshape(dUp(:,3,1:2),N,2);

defo(:,1,1) = grad_u(:,1)+grad_u(:,1);
defo(:,1,2) = grad_u(:,2)+grad_v(:,1);
defo(:,2,1) = grad_v(:,1)+grad_u(:,2);
defo(:,2,2) = grad_v(:,2)+grad_v(:,2);
defo        = defo/2;
tau         = 2*defo;

for k=1:2,
   for m=1:2,
      Fd(:,k+1,m) = visco_m.*tau(:,k,m);       
   end
end

vaux        = visco_m;
delta       = eye(2);
uno_1       = [1;0];
uno_2       = [0;1];

tmp_xx = (delta(1,1)*eye(2)+uno_1*uno_1');
tmp_xy = (delta(1,2)*eye(2)+uno_2*uno_1');
tmp_yx = (delta(2,1)*eye(2)+uno_1*uno_2');
tmp_yy = (delta(2,2)*eye(2)+uno_2*uno_2');

for j=1:2
   for k=1:2,
      Kxx(:,j+1,k+1)  = vaux.*tmp_xx(j,k);
      Kxy(:,j+1,k+1)  = vaux.*tmp_xy(j,k);
      Kyx(:,j+1,k+1)  = vaux.*tmp_yx(j,k);
      Kyy(:,j+1,k+1)  = vaux.*tmp_yy(j,k);      
   end
end
