function [Mele,Rele] = bc_conv_bubbly_2d_liq(xnod,icone,U,bou_data,Rele,Mele,prop,Uf)
%                                     
% [Mele,Rele] = bc_conv_bubbly_2d_liq(xnod,icone,U,bou_data,Rele,Mele,prop,Uf)
%

ijob = 'get';
handle_prop_elem;

[numnp,ndm] = size(xnod);  
[numel,nen] = size(icone);
[nbou,bas]  = size(bou_data);
[bas,ndf]   = size(U);
ndf        = ndf/nen;

[bas,ndf_fields] = size(Uf);
ndf_fields = ndf_fields/nen;

[bas,ncol]  = size(Mele);

if nbou>0,

  xpg    = sqrt(3)/3;
  psipg  = [ -xpg xpg ];
  wpg    = [   1   1  ];

  eles_bou = bou_data(:,1);
  face_bou = bou_data(:,2);

  nodo_1 = face_bou;
  nodo_2 = (nodo_1+1).*(nodo_1<nen)+(nodo_1==nen);
  nodos  = [nodo_1,nodo_2];
  nodog1 = getcol(icone(eles_bou,:),nodo_1);
  nodog2 = getcol(icone(eles_bou,:),nodo_2);
  nodog  = [nodog1 , nodog2];
  dxbc   = xnod(nodog2,1) - xnod(nodog1,1);
  dybc   = xnod(nodog2,2) - xnod(nodog1,2);
  lbou   = sqrt(dxbc.^2+dybc.^2);
  norbc  = [dybc./lbou, -dxbc./lbou];

  re = v2m(xnod(icone(eles_bou,:)',1),nen);
  re = [getcol(re,nodo_1), getcol(re,nodo_2) ];
  
  Ue = zeros(nbou,ndf*2);  
  for idf=1:ndf
     Ue(:,idf)     = getcol(U(eles_bou,:),(nodo_1-1)*ndf+idf);
     Ue(:,ndf+idf) = getcol(U(eles_bou,:),(nodo_2-1)*ndf+idf);    
  end
  
  Uf_e = zeros(nbou,ndf*2);  
  for idf=1:ndf_fields     
     Uf_e(:,idf)     = getcol(Uf(eles_bou,:),(nodo_1-1)*ndf_fields+idf);
     Uf_e(:,ndf+idf) = getcol(Uf(eles_bou,:),(nodo_2-1)*ndf_fields+idf);
  end
  
  for ipg=1:2,

   N = ones(nbou,1)*[(1-psipg(ipg))/2 , (1+psipg(ipg))/2 ];
   
   Upg     = zeros(nbou,ndf);
   radpg   = zeros(nbou,1);
   alpha   = zeros(nbou,ndf_fields);

   for inod=1:2,    
    radpg = radpg + N(:,inod).*re(:,inod);
    Upg  = Upg + (N(:,inod)*ones(1,ndf)).*Ue(:,(inod-1)*ndf+(1:ndf));    
      if ndf_fields>0,         
         for iif=1:ndf_fields,
            alpha(:,iif) =  alpha(:,iif) + N(inod).* Uf_e(:,(inod-1)*ndf_fields+iif);
         end      
      end      
   end 
   
   [rho_m,visco_m] = get_mixture_props(alpha,prop);
   
   [H,Cp]     = enthalpy_function(Upg,rho_m);   
   [Fa,Ax,Ay] = Flux_function(Upg,rho_m);
       
   Fan      =  Fa(:,1:ndf,1).*(norbc(:,1)*ones(1,ndf)) + Fa(:,1:ndf,2).*(norbc(:,2)*ones(1,ndf));

   for idf=1:ndf,
      for jdf=1:ndf,      
         An(:,idf,jdf) =  Ax(:,idf,jdf).*norbc(:,1)+ Ay(:,idf,jdf).*norbc(:,2);
      end
   end
   
   xsj = wpg(ipg)*lbou/2;
   if axisim,
     xsj = xsj.*radpg;
   end

%      disp(' BC_CONV_BUBBLY ');keyboard;pause     
      
   for iface=1:nen,
     for inod=1:2,
      eles = find(face_bou==iface);
      jnod = iface-1+inod;
      if(jnod>nen),jnod=1; end 
      vaux  =  (N(eles,inod).*xsj(eles)*ones(1,ndf)).*Fan(eles,1:ndf);
      Rele(eles_bou(eles),jnod,1:ndf) = Rele(eles_bou(eles),jnod,1:ndf) - ...
         reshape(vaux,length(eles),1,ndf);
      
      for iinod=1:2, 
         jjnod = iface-1+iinod;
         if(jjnod>nen),jjnod=1; end           
         ip=((jnod-1)*nen+(jjnod-1))*ndf^2;         
         for idf=1:ndf
            for jdf=1:ndf,
               vaux  =  (N(eles,inod).*xsj(eles).*N(eles,iinod)).*An(eles,idf,jdf);                  
               Mele(eles_bou(eles),jnod,idf,jjnod,jdf) = ...
                  Mele(eles_bou(eles),jnod,idf,jjnod,jdf) + vaux;          
            end
         end
      end % for iinod
     end  % for inod
   end % for iface

  end % puntos de Gauss del contorno

end % if bou

