function [Kg,Rg] = nsi_tet(xnod,icone,fixa,forc,teco,lin_con,extra_nodal_fields,...
   extra_nodal_fields_old,prop,ifaceb,Up,Upold) 
%------------------------------------------------------------------
%
%  NSI_TET solver
%
%  state vector = [p ; vel ]
%
%------------------------------------------------------------------

global row col

ijob = 'get';
handle_prop_elem;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

U    = Up;
Uold = Upold;

[numel,nen]   = size(icone);
[numnp,ndf]   = size(U);
if ndf~=3, error(' NDF debe ser 3 (NSI_TET) ');end
ndm = 2;

if ndm==1,
   pgauss1d;
elseif ndm==2, 
   pgauss2d; 
elseif ndm==3,
   pgauss3d; 
end

Rele = zeros(numel,nen,ndf);
Mele = zeros(numel,nen,ndf,nen,ndf);

Rg    = 0*forc;
eles  = (1:numel)';
ceros = zeros(length(eles),nen);

if length(eles)>0,    
   nsi_tet_ele;
end

% Gather contributions from eles to nodes
%------------------------------------------------------------------
%disp(' at BUBBLY_2d ')
%keyboard;pause
[Rg,Kg] = gather(Rele,Mele,icone,nen,ndf);

%disp('bubbly_2d antes');keyboard;pause
% Linear restrictions
%------------------------------------------------------------------
if isempty(lin_con)==0,
    [Rg,Kg] = linear_constraint(Rg,Kg,lin_con,ndf);
%disp('bubbly_2d despues');keyboard;pause
end

