function [tau,delta] = supg_nsi_tet(Upg,hele,rho_l,visco_l)
%
%  [tau,delta] = supg_nsi_tet(Upg,hele,rho_l,visco_l)
%

%ijob = 'get';
%handle_prop_elem;

tol_upw = 1e-08;
type_upwind = 1;

[N,ndf]  = size(Upg);
pre      = Upg(:,1);
vel      = Upg(:,2:3);
velmod   = sqrt(sum(vel'.^2))';
velmod   = max([velmod';tol_upw*ones(1,N)])';  

Pe       = 0.5 ./ (visco_l ./ rho_l).*velmod.*hele ;
psi      = min([ones(1,N);Pe'/3])';

if type_upwind==0,
    tau   = 0.5* hele ./ velmod.*psi;
    delta = velmod.*hele/2.*psi;   
elseif type_upwind==1,
    tau   =  (2*velmod./hele).^2 + 9*(4*(visco_l ./ rho_l) ./(hele).^2).^2;
    tau   =   1 ./ sqrt(tau);
    delta = velmod.*hele/2.*psi;   
else   
    error(' Bad type of upwind has been chosen')
end

