function [H,Cp] = enthalpy_function(Up,prop,flag_predictor)
%
%      [H,Cp] = enthalpy_function(Up,pro,flag_predictorp)
%
%       Computes enthalpy function to handle primitive variables
%       in 2D 
%

if nargin < 3, flag_predictor=0; end

[N,ndf]     = size(Up);
rho_g       = prop(1);
alpha_g     = Up(:,1);
vel_g       = Up(:,2:3);

if flag_predictor,
   
H            = [alpha_g,vel_g];
Cp           = zeros(N,ndf,ndf);

for idf=1:ndf,
    Cp(:,idf,idf)    = ones(N,1);
end
   
else
   
H            = [alpha_g,(alpha_g*[1,1]).*vel_g];
Cp           = zeros(N,ndf,ndf);
if 0,
% DEBUG and fixme
file = 'enthalpy_function';
line = '22';
lp_debug(file,line)
end
if 0,
for idf=1:ndf,
    Cp(:,idf,idf)    = ones(N,1);
end
else
Cp(:,1,1)    = rho_g*ones(N,1);
Cp(:,2:3,1)  = rho_g*vel_g;
Cp(:,2,2)    = rho_g*alpha_g;
Cp(:,3,3)    = rho_g*alpha_g;
end
end