function [tau,delta] = compute_tau_adv_dif_reac(Upg,dUpg,velmod,hele,reac,prop,type_upwind);
%
%  [tau,delta] = compute_tau_adv_dif_reac(Upg,dUpg,velmod,hele,reac,prop,type_upwind);
%

tol_upw = 1e-08;
tau_factor = 1;

ijob = 'get';
handle_prop_elem;

[N,ndf]     = size(Upg);

if type_upwind==0,
    Pe = 0.5/visco_g*velmod.*hele ;
    psi = min([ones(1,N);Pe'/3])';
    velmod  = max([velmod';tol_upw*ones(1,N)])';  
    tau   = tau_factor*0.5* hele ./ velmod.*psi;
    delta = tau_factor*velmod.*hele/2;
elseif type_upwind==1,
   % advective-diffusive-reactive equations (Codina)
%    disp(' using Codina scheme for advdif + reac ')
    tau_k = 4*visco_g ./ (hele.^2);
    tau_a = 2*velmod ./ hele;
    tau_c = max(abs(reac'))';
%    tau_c = abs(reac);
    tau   = tau_factor ./ (tau_k + tau_a + tau_c);
    delta = tau_factor*velmod.*hele/2;
else
   error(' Bad type of upwind has been chosen')
end

