function [tau,delta,dt] = supg_bubbly_2d(Upg,grad_phi,Cou,hele,shocap,type_upwind)
%
%  [tau,delta,dt] = supg_bubbly_2d(Upg,grad_phi,dUpg,gamma,Cou,hele,shocap,type_upwind)
%

tol = 1e-08;
tau_factor = 1.;

if 0,
file = 'supg_bubbly_2d';
line = '7';
lp_debug(file,line)
end

[N,ndf]     = size(Upg);
alpha_g     = Upg(:,1);
vel_g       = Upg(:,2:3);

velmod  = sqrt(sum(Upg(:,2:3)'.^2))';

if type_upwind==0,
   velmod  = max([velmod';tol*ones(1,N)])';  
   tau   = tau_factor*0.5* hele ./ velmod;
   velmod_eff = 1*(alpha_g+1/2+1/2*sqrt(4*alpha_g.^2+1)).*velmod;
   velmod_eff = velmod;
   delta = 2*velmod_eff.*hele/2;
%   delta = 5*ones(N,1);
dt    =  Cou*hele ./ velmod;   
elseif type_upwind==1,
   
   tau     = zeros(N,ndf,ndf);    
   delta   = zeros(N,1);
   dt      = zeros(N,1);
   
%   nn      = find(velmod>tol);   
%   N       = length(nn);
%   alpha_g = alpha_g(nn);
%   vel_g   = vel_g(nn,:);

% usando una descomposicion en autovalores
   alpha_g  = max([alpha_g';tol*ones(1,N)])';  
   
   m1      = find(abs(vel_g(:,1))>tol);  
   if isempty(m1)==0,
   [Vx,Dx,Vx1]=get_eig_dcmp(Upg(m1,:),1,tol);
   vaux = rowprod(abs(Dx),Vx1,ndf,ndf,ndf);
   vaux_1 = rowprod(Vx,vaux,ndf,ndf,ndf);    
   tau(m1,:,:) = tau(m1,:,:)+vaux_1;      
   % DEBUG
 %     disp(' Eig dcmp X ');keyboard;pause   
   end 
   m2      = find(abs(vel_g(:,2))>tol);      
   if isempty(m2)==0,
   [Vy,Dy,Vy1]=get_eig_dcmp(Upg(m2,:),2,tol);
   vaux = rowprod(abs(Dy),Vy1,ndf,ndf,ndf);
   vaux_2 = rowprod(Vy,vaux,ndf,ndf,ndf);       
   tau(m2,:,:) = tau(m2,:,:)+vaux_2;         
   % DEBUG
   %   [bas,Ax,Ay]=flux_function(Upg(m2,:),[1,1]);
%      disp(' Eig dcmp Y ');keyboard;pause   
   end
   mm = [m1;m2];
   if isempty(mm)==0, mm = rmdblist(mm); tau(mm,:,:) = row_inv(tau(mm,:,:)); end
   
%   disp(' supg_bubbly_2d ');keyboard;pause   
   for k=1:3,
      for m=1:3,
         tau(:,k,m) = tau_factor*tau(:,k,m).*hele/2;         
      end      
   end
   
   if 1,
   if 0,
   % agregamos difusion isotropica solo si el gradiente de la solucion es alto
   limit         = tol;
   limit2        = 1e-2;
   grad_phi_norm = sqrt(sum(grad_phi'.^2))';
   mask          = grad_phi_norm<limit;
   grad_phi_norm = grad_phi_norm+limit*mask;  
   grad_phi_norm_max = max(grad_phi_norm);
   mask          = ((grad_phi_norm ./ grad_phi_norm_max)< limit2);  
   nn            = find(mask==0);   
   if isempty(nn)==0, delta(nn)     = 1.0*velmod(nn).*hele(nn)/2; end
   %keyboard;pause
   else
         delta = 1.0*velmod.*hele/2;
   end
   end

else   
   error(' Bad type of upwind has been chosen')
end

