%------------------------------------------------------------------
%     APLICATION  :  TWO PHASE FLOW
%------------------------------------------------------------------

if(exist('inicia')==0),
   disp('Ingrese la variable inicia ')
   disp(' inicia == 0 ---> si continua una corrida previa ')
   disp(' inicia ~= 0 ---> si comienza una corrida nueva ')
   inicia = input(' Inicia = ')
end

%------ Ingreso de datos -------------------------------------------

if inicia,
   read_data;
   bfh=[];          % Guarda la solucion
   hc_res=[];       % Guarda la historia de la convergencia en residuo
   hc_du=[];        % Guarda la historia de la convergencia en dphi
   bfh_nc = [];     % Guarda los pasos de tiempo en que no hubo convergencia
   bfh_u=[];        % Guarda la solucion cada nstep pasos de tiempo
   posdat;
   ttime = 0;
end

%------ fin ingreso de datos --------------------------------------

limit = prop(12);

% Loop temporal o pseudotemporal
%------------------------------------------------------------------

for itime=1:ntime,
   
   if exist('dtmin')&exist('dtmax'),
      dt = dtmin+(dtmax-dtmin)*itime/ntime;
      prop(13)=dt;
      disp(['dt = ' num2str(dt)])
   end   
   ttime = ttime+dt;
   
   phiold = phi;
   
   % Actualiza las condiciones de contorno si fueran funcion del tiempo
   % La funcionalidad se lee del archivo "bc_time"
   if exist('bc_time_flag')==1,
      if (bc_time_flag==1)&(exist('bc_time')~=2), 
         disp('Debe tener en el directorio de trabajo un archivo de nombre bc_time.m ');
         error(' bc_time_flag==1 y bc_time file no existe '); 
      end
      if bc_time_flag==1, bc_time; end
   end
   
   nu    = 0;
   iterflag = 1;
   [numnp,ndf] = size(phi);
   
   while iterflag
      
      nu= nu+1;
      
      phi_nu = phi;
      %------------------------------------------------------------------
      %        Montaje sistema y solucion del problema
      %------------------------------------------------------------------
      
      ijob = 0;
      if type_solver ==2, ijob=-1; end
      
      % Liquid phase        
      external_fields = phi(:,indx_gas);
      fixa_p = v2m(fixa,ndf);
      fixa_p = m2v(fixa_p(:,indx_liq));
      forc_p = v2m(forc,ndf);
      forc_p = m2v(forc_p(:,indx_liq));
      lin_con_p = [];      
      if isempty(lin_con)==0,
         for idf=indx_liq,
            nn = find(lin_con(:,3)==idf);
            lin_con_p =[lin_con_p;lin_con(nn,:)];
         end
      end
      [Kg,Rg_liq] = bubbly_2D(xnod,icone,fixa_p,forc_p,teco,lin_con_p,external_fields,prop,...
         ifaceb,phi(:,indx_liq),phiold(:,indx_liq),'liq');                      
      [phi_p,Rg_liq]=solver(phi(:,indx_liq),Rg_liq,Kg,fixa_p,prop,prop_solver,ndf_liq);   
      phi(:,indx_liq) = phi_p;
      
      % Gas phase
      if 1,
         external_fields = phi(:,indx_liq);        
         fixa_p = v2m(fixa,ndf);
         fixa_p = m2v(fixa_p(:,indx_gas));
         forc_p = v2m(forc,ndf);
         forc_p = m2v(forc_p(:,indx_gas));         
         lin_con_p = [];
         if isempty(lin_con)==0,            
            for idf=indx_gas,
               nn = find(lin_con(:,3)==idf);
               lin_con_p =[lin_con_p;lin_con(nn,:)];
            end
         end
         [Kg,Rg_gas] = bubbly_2D(xnod,icone,fixa,forc,teco,lin_con,external_fields,prop,...
            ifaceb,phi(:,indx_gas),phiold(:,indx_gas),'gas');
         [phi_p,Rg_gas]=solver(phi(:,indx_gas),Rg_gas,Kg,fixa_p,prop,prop_solver,ndf_gas);   
         phi(:,indx_gas) = phi_p;
      else
         Rg_gas = 0*Rg_liq;
      end
      
      % Analisis de la convergencia
      %------------------------------------------------------------------
      
      Rg = [Rg_liq;Rg_gas];
      dphi = phi-phi_nu;
      
      iterflag = (norm(Rg)>limit) & (nu< nu_max); % & (norm(dphi)>limit);
      
      disp(['time ' num2str(itime) ... 
            ' Iter ' num2str(nu)  ' || R || -----> ' num2str(norm(Rg)) ... 
            ' || Delta phi || -----> ' num2str(norm(dphi))  ])
      
      hc_res  = [hc_res ; norm(Rg)];
      hc_du   = [hc_du ; norm(dphi)];
      
   end  % end while
   
   % Salida grafica de resultados (provista por cada aplicacion)
   %------------------------------------------------------------------
   
   plot_fem
   
   if norm(Rg)>limit ,
      %  error(' NO CONVERGENCE ');
      bfh_nc = [bfh_nc ; itime];
   end
   
   if exist('nsave')==0; nsave=ntime;end
   
   if exist('filesave')==0; filesave='tempo'; end
   
   if rem(itime,nsave)==0, 
      eval(['save ' filesave ';']);
   end
   
   if rem(itime,nstep)==0,
      bfh_u = [bfh_u , phi];
   end
   
end % itime loop

