function [H,Cp,Cpi] = enthalpy_function_gas(Up,prop,ijob)
%
%      [H,Cp,Cpi] = enthalpy_function(Up,prop,ijob)
%
%       Computes enthalpy function to handle primitive variables in 2D 
%

if nargin <3, ijob=0; end

ijob = 'get';
handle_prop_elem;

alpha_g_ctf  = 1e-3; 

[N,ndf]     = size(Up);

alpha_g     = Up(:,1);
vel_g       = Up(:,2:3);

alpha_g      = max([alpha_g_ctf*ones(1,N);alpha_g'])';
alpha_g      = min([(1-alpha_g_ctf)*ones(1,N);alpha_g'])';

if virtual_mass,
   rho_g_eff = rho_g + C_vm*rho_l;
else
   rho_g_eff = rho_g;
end

H            = [rho_g*alpha_g,rho_g_eff*(alpha_g*[1,1]).*vel_g];
Cp           = zeros(N,ndf,ndf);

Cp(:,1,1)    = rho_g*ones(N,1);
%Cp(:,2:3,1)  = rho_g*vel_g;
Cp(:,2,2)    = rho_g_eff*alpha_g;
Cp(:,3,3)    = rho_g_eff*alpha_g;

if ijob>0,
    Cpi           = zeros(N,ndf,ndf);
    Cpi(:,1,1)    = 1/rho_g;
    Cpi(:,2,2)    = 1 ./ (rho_g_eff*alpha_g);
    Cpi(:,3,3)    = 1 ./ (rho_g_eff*alpha_g);
end
