function [Fd,Kxx,Kxy,Kyx,Kyy] = Dflux_liq(Up,dUp,alpha_g,prop);
%--------------------------------------------------------------------
%
%         [Fd,Kxx,Kxy,Kyx,Kyy] = Dflux(Up,dUp,alpha_g,prop);
%
%  Diffusive fluxes and jacobians for the gas phase in the two phase flow eqs 
%
%--------------------------------------------------------------------

ijob = 'get';
handle_prop_elem;

alpha_g_ctf = 0;
[N,ndf]  = size(Up);
pre      = Up(:,1);
vel_l    = Up(:,2:3);


% NIGRO
% GERONIMO
% ANA
% SILVIA
%
%  hecho por GERONIMO
%

Fd     = zeros(N,ndf,2);
Kxx    = zeros(N,ndf,ndf);
Kxy    = zeros(N,ndf,ndf);
Kyx    = zeros(N,ndf,ndf);
Kyy    = zeros(N,ndf,ndf);

grad_u      = reshape(dUp(:,2,1:2),N,2);
grad_v      = reshape(dUp(:,3,1:2),N,2);

defo(:,1,1) = grad_u(:,1)+grad_u(:,1);
defo(:,1,2) = grad_u(:,2)+grad_v(:,1);
defo(:,2,1) = grad_v(:,1)+grad_u(:,2);
defo(:,2,2) = grad_v(:,2)+grad_v(:,2);
defo        = defo/2;

tau         = 2*defo;

alpha_g     = max([alpha_g_ctf*ones(1,N);alpha_g'])';
alpha_g     = min([(1-alpha_g_ctf)*ones(1,N);alpha_g'])';
alpha_l     = 1-alpha_g;

if model_visco_std==1,
    visco_mix   = alpha_l*visco_l;   
    %visco_mix   = visco_l;   
elseif model_visco_std==2,
    alpha_avg   = 0.5*(max(alpha_l)+min(alpha_l));
    visco_mix   = alpha_avg*visco_l;
elseif model_visco_std==0,
    visco_mix   = visco_l;    
else
    error(' Bad model_visco_std choice')
end


for k=1:2,
   for m=1:2,
      Fd(:,k+1,m) = visco_mix.*tau(:,k,m);       
   end
end

vaux        = visco_mix;
delta       = eye(2);
uno_1       = [1;0];
uno_2       = [0;1];

tmp_xx = (delta(1,1)*eye(2)+uno_1*uno_1');
tmp_xy = (delta(1,2)*eye(2)+uno_2*uno_1');
tmp_yx = (delta(2,1)*eye(2)+uno_1*uno_2');
tmp_yy = (delta(2,2)*eye(2)+uno_2*uno_2');

for j=1:2
   for k=1:2,
      Kxx(:,j+1,k+1)  = vaux*tmp_xx(j,k);
      Kxy(:,j+1,k+1)  = vaux*tmp_xy(j,k);
      Kyx(:,j+1,k+1)  = vaux*tmp_yx(j,k);
      Kyy(:,j+1,k+1)  = vaux*tmp_yy(j,k);      
   end
end

