function [Kg,Rg] = bubbly_2D(xnod,icone,fixa,forc,teco,lin_con,extra_nodal_fields,prop,...
    ifaceb,Up,Upold,Id_phase) 
%------------------------------------------------------------------
%
%  TWO PHASE FLOW APPLICATIONS
%
%  only for the gas phase, the liquid is fixed to a prescribed pressure and
%  velocity field
%
%  state vector = [alpha_g ; vel_g ]
%
%------------------------------------------------------------------

global row col

if nargin < 12, error('phase Id is not input '); end

ijob = 'get';
handle_prop_elem;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

U    = Up;
Uold = Upold;

[numel,nen]   = size(icone);
[numnp,ndf]   = size(U);
if ndf~=3, error(' NDF debe ser 3 (gas phase bubbly in 2D) ');end
ndm = 2;

if ndm==1,
    pgauss1d;
elseif ndm==2, 
    pgauss2d; 
elseif ndm==3,
    pgauss3d; 
end

Rele = zeros(numel,nen,ndf);
Mele = zeros(numel,nen,ndf,nen,ndf);

Rg    = 0*forc;
eles  = (1:numel)';
ceros = zeros(length(eles),nen);

if length(eles)>0,    
    if strcmp(Id_phase,'liq')==1
        bubbly_2d_ele_liq;
    elseif strcmp(Id_phase,'gas')==1,
        bubbly_2d_ele_gas;
    else
        error(' Bad phase')
    end   
end

% Gather contributions from eles to nodes
%------------------------------------------------------------------
[Rg,Kg] = gather(Rele,Mele,icone,nen,ndf);

%disp('bubbly_2d antes');keyboard;pause
% Linear restrictions
%------------------------------------------------------------------
if isempty(lin_con)==0,[Rg,Kg] = linear_constraint(Rg,Kg,lin_con,ndf);end
%disp('bubbly_2d despues');keyboard;pause

