%----------------------------------------------------------------------
%
%          Fichero de datos
%
%----------------------------------------------------------------------

caso  = 1;

if caso==0,
   % square cavity for one phase (alpha_g=0)
   %bubbly_sqcav;
   % Poiseuille flow
   bubbly_poise
elseif caso==1,
   % ejemplo Anagbo
   bubbly_laddle_2d;
elseif caso==2,
   % ejemplo Anagbo pero hecho 1D axial (periodico radial)
   bubbly_laddle_1d;
else
   error(' MALA ELECCION DEL CASO A TRATAR')
end

% Type_solver ------>  [ 0 ]  standard - directo con relajacion (relax)
%                      [ 1 ]  line-search
%                      [ 2 ]  explicito
%                      [ 3 ]  GMRES

limit    =   1e-06;
dt          = 0.0001 ;
type_solver = 0;
relax       = 1;     % parametro de relajacion fijo para type_solver=0
nu_max      = 1;	  % numero maximo de iteraciones por paso de tiempo
alfa_min    = 0.01;  % para linesearch
alpha       = 1;     % grado de implicitud (1/2 Cranck-Nicholson)
ntime       = 2;     % numero de pasos de tiempo
nstep       = 1;     % guarda solucion cada nstep pasos de tiempo
scaling     = 1;     % scaling equations at solver for better conditioning of the system

if caso==0 | caso==1 | caso==2,
   alpha       = 1;
   dt          = 1e-03 ;
   type_solver = 0;
   relax       = 1;     
   nu_max      = 4;  
   alfa_min    = 0.01;  
   ntime       = 1;   
   nstep       = 1;     
   nsave       = 10;   
   dtmin       = 1e-4;
   dtmax       = 1e-4;   
end


prop(12) = limit    ;
prop(13)  = dt    ; % paso de tiempo
prop(14)  = alpha ; % grado de implicitud  

prop_solver = [type_solver,relax,nu_max,alfa_min,alpha,ntime,nstep,scaling];