% ====================================================================
%
%                           Back step example (finlandes)
%
% ====================================================================

read_from_file = 0;
filestate = 'bstep_39';

filename = 'bwstep_petsc';

% bc files
bc_file_list = strvcat('bwstep_petsc.fixa_wall.tmp','bwstep_petsc.fixa_in.tmp', ...
     'bwstep_petsc.fixa_out_p.tmp','bwstep_petsc.fixa_out_v.tmp');

nnwt_liq = 4;
nnwt_gas = 4;
nnwt_outer = 2;

shocap                = 1;
weak_form             = 1; 

Cou   =  1;
npg   =  4;
ndf   =  6;
ndf_liq = 3;
ndf_gas = 3;
tol   = 1e-6;

indx_gas = [2,5,6];
indx_liq = [1,3,4];

% PHYSICAL DATA
gravity  = 0*(-9.8);
beta = 0.5;                                    % Relacin de densidades
rho_l= 1.0;                                    % Densidad fase continua
rho_g   =  rho_l/ beta ;                       % Densidad fase dispersa
d_bubble = 0.005;                              % Diametro de burbuja 
Rel=100;                                       % Reynolds fase continua
Reg=200;                                       % Reynolds fase dispersa
visco_l =  3.8e-6;                             % liquid phase viscosity
visco_g = ( Rel/ Reg)* visco_l/ beta;          % gas phase viscosity
comp_interphase_terms = 1;
axisim                = 0;
drag_factor           = 1.0;
virtual_mass          = 0;
C_vm                  = 1/2;
model_visco_std       = 1;   % std --> alpha_k * visco_k  sino avg(alpha_k) * visco_k
qpot_drag_model       = 0;   % F_drag propto alpha_l ^ qpot
fRe_drag_model        = 1;   % [0] Laminar model [1] Cd=0.44

% ESCALEO
if 0,
   visco_l=visco_l/sqrt(rho_l);
   visco_g=visco_g/sqrt(rho_l);
   rho_g=rho_g/sqrt(rho_l);
   p_bot=p_bot/sqrt(rho_l);    
   p_ini=p_ini/sqrt(rho_l);    
   p_ref=p_ref/sqrt(rho_l);    
   rho_l=rho_l/sqrt(rho_l);
end

lumping_drag_forces   = 1;
lumping_time_terms    = 1;
tau_factor            = 1;

% lee malla de archivos
ijob = 0;  % ijob=1 lee malla de la superficie tambien
%[xnod,icone] = read_mesh(filename,ijob);
[xnod,icone] = read_mesh(filename);
% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end
[numnp,ndm] = size(xnod);
[numel,nen] = size(icone);

xmin = min(xnod);
xmax = max(xnod);

%-------- Solucion inicial (PHI)
if read_from_file==1,
    eval(['load ' filestate]);
    uini = phi;
else
    [uini] = read_file([filename '.ini.tmp']);
    uini = uini(:,1:ndf);
end

%-------- fijaciones (FIXA)
fixa = zeros(numnp,ndf);
forc = zeros(numnp,ndf);

if exist('bc_file_list','var')==0, error(' BC files does not exist'); end
[nfiles,bas] = size(bc_file_list);
for k=1:nfiles
    bc_file = bc_file_list(k,:);
    [fixa_pf]  = read_file(bc_file );
    [fixa,forc] = conv_fixa_pfem(fixa_pf,fixa,forc);    
end

%-------- Propiedades del material
ijob = 'set';
handle_prop_elem;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas y deslizamiento AHORA como linear constraints
lin_con = [];
tol = 1e-6;
nodes_out = find(abs(xnod(:,1)-xmax(1))<tol);
% busco aquellos nodos que son vecinos a los de salida para imponer restriccion de igual valor 
% valido solo para mallas estructuradas, sino habria que agregar una capa de nodos al final paralela
% al contorno donde se desea imponer esta restriccion
mask = ones(numnp,1);
mask(nodes_out) = 0;
nn=find(mask==1);
[bas,ipt] = min(abs(xnod(nn,1)-xnod(nodes_out(1),1)));
xx = xnod(ipt,1);
nodes_out_m1 = find(abs(xnod(:,1)-xx)<tol);
for icompo=[2,3,5]    
    lin_con = [lin_con ; ... 
            [ones(length(nodes_out),1) nodes_out icompo*ones(length(nodes_out),1) ...
                -ones(length(nodes_out),1) nodes_out_m1 icompo*ones(length(nodes_out),1)]];
end

% condicion inicial en primitivas
%-----------------------------------------------
if 1,
   bini   = uini;
   for k=1:ndf,
      nofree        = find(fixa(:,k)~=0);
      bini(nofree,k)   = forc(nofree,k);
   end   
end

bc_time_flag = 0;
bc_time_t_end = 1;