%------------------------------------------------------------------
%     APLICATION  :  TWO PHASE FLOW
%------------------------------------------------------------------

if(exist('inicia')==0),
   disp('Ingrese la variable inicia ')
   disp(' inicia == 0 ---> si continua una corrida previa ')
   disp(' inicia ~= 0 ---> si comienza una corrida nueva ')
   inicia = input(' Inicia = ')
end

%------ Ingreso de datos -------------------------------------------

if inicia,
   read_data;
   bfh=[];          % Guarda la solucion
   hc_res=[];       % Guarda la historia de la convergencia en residuo
   hc_du=[];        % Guarda la historia de la convergencia en dphi
   hc_res_outer = [];
   bfh_nc = [];     % Guarda los pasos de tiempo en que no hubo convergencia
   bfh_u=[];        % Guarda la solucion cada nstep pasos de tiempo
   posdat;
   ttime = 0;
   restart_time = 0;
end

if exist('nnwt_outer','var')==0, nnwt_outer=1; end

%------ fin ingreso de datos --------------------------------------

limit = prop(12);
[numnp,ndf] = size(phi);

% Loop temporal o pseudotemporal
%------------------------------------------------------------------

for itime=1:ntime,
   
   restart_time = 0;
   
   if restart_time ==1,
      phi = phiold;
   else
      phiold = phi;
      if 1,
         if exist('dtmin')&exist('dtmax'),
            dt = dtmin+(dtmax-dtmin)*itime/ntime;
            prop(13)=dt;
            disp(['dt = ' num2str(dt)])
         end  
      end
   end
   
   ttime = ttime+dt;
   
   % Actualiza las condiciones de contorno si fueran funcion del tiempo
   % La funcionalidad se lee del archivo "bc_time"
   if exist('bc_time_flag')==1,
      if (bc_time_flag==1)&(exist('bc_time')~=2), 
         disp('Debe tener en el directorio de trabajo un archivo de nombre bc_time.m ');
         error(' bc_time_flag==1 y bc_time file no existe '); 
      end
      if bc_time_flag==1, bc_time; end
   end
   
   nu_outer    = 0;
   nu_max_outer = nnwt_outer;
   iterflag_outer = nu_outer < nu_max_outer;
   
   res_outer = [];
   
   while iterflag_outer
      
      nu_outer = nu_outer +1;
      Rg_outer = 0;         
      
      nu    = 0;
      nu_max = nnwt_liq;
      iterflag = nu<nu_max;        
      
      Rg_liq = 0; dphi_liq=0;
      while iterflag
         
         nu= nu+1;      
         phi_nu = phi;      
         ijob = 0;
         
         if nu==1,
            % Liquid phase        
            external_fields = phi(:,indx_gas);
            external_fields_old = phiold(:,indx_gas);
            fixa_p = v2m(fixa,ndf);
            fixa_p = m2v(fixa_p(:,indx_liq));
            forc_p = v2m(forc,ndf);
            forc_p = m2v(forc_p(:,indx_liq));
            lin_con_p = [];      
            if isempty(lin_con)==0,
               [Nr,Nc]=size(lin_con);             
               for idf=indx_liq,
                  nn = find(lin_con(:,3)==idf);
                  lin_con_p =[lin_con_p;lin_con(nn,:)];
               end
               map = [1,0,2,3,0,0];
               for icol=3:3:Nc,
                  ipt = lin_con_p(:,icol);
                  jpt = map(ipt)';
                  lin_con_p(:,icol) = jpt;               
               end
            end
         end
         %      disp('drvfem');keyboard;pause
         [Kg,Rg_liq] = bubbly_2D(xnod,icone,fixa_p,forc_p,teco,lin_con_p,external_fields,...
            external_fields_old,prop,ifaceb,phi(:,indx_liq),phiold(:,indx_liq),'liq');                      
         [phi_p,Rg_liq]=solver(phi(:,indx_liq),Rg_liq,Kg,fixa_p,prop,prop_solver,ndf_liq);   
         phi(:,indx_liq) = phi_p;
         
         
         % Analisis de la convergencia
         %------------------------------------------------------------------
         dphi_liq = phi-phi_nu;
         Rg = Rg_liq;
         dphi = dphi_liq;
         
         iterflag = (norm(Rg)>limit) & (nu< nu_max); % & (norm(dphi)>limit);
         
         if nu==1, disp(' Liquid phase step'); end
         if nu==1, Rg_outer=Rg_outer+norm(Rg); end
         
         disp(['time ' num2str(itime) ... 
               ' Iter ' num2str(nu)  ' || R || -----> ' num2str(norm(Rg)) ... 
               ' || Delta phi || -----> ' num2str(norm(dphi))  ])
         
      end  % end while

      if 0,
      nu    = 0;
      nu_max = nnwt_gas;
      iterflag = nu<nu_max;
      
      while iterflag
         
         nu= nu+1;      
         phi_nu = phi;      
         ijob = 0;
         Rg_gas = 0; dphi_gas=0;
         
         indx_gas_p = [5,6];    % v_g_fijo   , solving alpha_g
         solver_gas_phase;
         
      end  % end while
      
      nu    = 0;
      nu_max = nnwt_gas;
      iterflag = nu<nu_max;
      
      while iterflag
         
         nu= nu+1;      
         phi_nu = phi;      
         ijob = 0;
         Rg_gas = 0; dphi_gas=0;
         
         indx_gas_p = 2;    % alpha_g fijo  , solving gas velocity         
         solver_gas_phase;
         
      end  % end while

  else

      nu    = 0;
      nu_max = nnwt_gas;
      iterflag = nu<nu_max;
      
      while iterflag
         
         nu= nu+1;      
         phi_nu = phi;      
         ijob = 0;
         Rg_gas = 0; dphi_gas=0;
         
         indx_gas_p = [];    % solving all gas phase variables  
         solver_gas_phase;
         
      end  % end while
      
  end
  
      iterflag_outer = (norm(Rg_outer)>limit) & (nu_outer< nu_max_outer); 
      
      disp(['time ' num2str(itime) ... 
            ' Iter (outer) ' num2str(nu_outer)  ' || R || -----> ' num2str(norm(Rg_outer))   ])
      
      res_outer = [res_outer; norm(Rg_outer)];         
      
   end % iterflag_outer
   
   hc_res_outer = [hc_res_outer; res_outer ];             
   
   if res_outer(end)>res_outer(1), 
      restart_time=1;    
      dt = max([dt/2,dtmin]);
   else
      restart_time=0;
   end
   
   % Salida grafica de resultados (provista por cada aplicacion)
   %------------------------------------------------------------------
   
   plot_fem
   
   if norm(Rg)>limit ,
      %  error(' NO CONVERGENCE ');
      bfh_nc = [bfh_nc ; itime];
   end
   
   if exist('nsave')==0; nsave=ntime;end
   
   if exist('filesave')==0; filesave='tempo'; end
   
   if exist('filestate')==0; filestate='last_state'; end
   
   if rem(itime,nsave)==0, 
      eval(['save ' filesave ';']);
      eval(['save ' filestate 'phi ' ';']);
   end
   
   if rem(itime,nstep)==0,
      bfh_u = [bfh_u , phi];
   end
   
end % itime loop

