function [H,Cp] = enthalpy_function_liq(Up,alpha_g,prop)
%
%      [H,Cp] = enthalpy_function(Up,prop)
%
%       Computes enthalpy function to handle primitive variables in 2D 
%


ijob = 'get';
handle_prop_elem;

if virtual_mass,
   rho_l_eff = rho_l*(1-C_vm);
else
   rho_l_eff = rho_l;
end

[N,ndf]     = size(Up);
pre         = Up(:,1);
vel_l       = Up(:,2:3);
alpha_l     = 1-alpha_g;   
H            = [rho_l*alpha_l,rho_l_eff*(alpha_l*[1,1]).*vel_l];

Cp           = zeros(N,ndf,ndf);
Cp(:,2,2)    = rho_l_eff*alpha_l;
Cp(:,3,3)    = rho_l_eff*alpha_l;
