type_upwind         = 0;
lumping_drag_forces = 1;
lumping_time_terms  = 0;
debug = 0;

ne  = length(eles);
[bas,ndf_fields] = size(extra_nodal_fields);

% Localizacion de las variables
%------------------------------------------------------------------
ceros = zeros(ne,nen*ndf);
Ue = ceros;
U0e = ceros;
re = zeros(ne,nen);
Uf_e = zeros(ne,nen*ndf_fields);
Uenorm = zeros(ne,nen);
for inod=1:nen,
    nodes  = icone(eles,inod);
    jnod  = (inod-1)*ndf+(1:ndf);
    knod  = (inod-1)*ndf_fields+(1:ndf_fields);            
    Ue(:,jnod)  = U(nodes,1:ndf);		 
    U0e(:,jnod) = Uold(nodes,1:ndf);   
    re(:,inod)  = xnod(nodes,1);		        
    Uf_e(:,knod)  = extra_nodal_fields(nodes,1:ndf_fields);       
    Uenorm(:,inod) = sqrt(sum(Uold(nodes,1:ndf)'.^2)');
end

% UPWIND EN EL CENTROIDE 
%------------------------------------------------------------------
if nen==4,
    [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),0,0);
    [dshapex0,N0] = shape2d(X2S,0,0,nen); 
elseif nen==3,
    [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),1/3,1/3);
    [dshapex0,N0] = shape2d(X2S,1/3,1/3,nen); 
else
    error(' Bad type of element , nen ~=3, nen ~=4 ')
end
Upg        = zeros(ne,ndf);
dUpg       = zeros(ne,ndf,ndm);
dUpg_new   = zeros(ne,ndf,ndm);
grad_Unorm = zeros(ne,ndm);
grad_p     = zeros(ne,ndm);
vel_l      = zeros(ne,ndm);

for inod=1:nen,
    jnod = (inod-1)*ndf+(1:ndf);
    Upg(:,(1:ndf))    =  Upg(:,(1:ndf)) + N0(inod).*  U0e(:,jnod);
    dUpg(:,(1:ndf),1) = dUpg(:,(1:ndf),1) + ...
        (dshapex0(:,inod,1)*ones(1,ndf)).* U0e(:,jnod);          
    dUpg(:,(1:ndf),2) = dUpg(:,(1:ndf),2)+ ...
        (dshapex0(:,inod,2)*ones(1,ndf)).* U0e(:,jnod);             
    dUpg_new(:,(1:ndf),1) = dUpg_new(:,(1:ndf),1) + ...
        (dshapex0(:,inod,1)*ones(1,ndf)).* Ue(:,jnod);          
    dUpg_new(:,(1:ndf),2) = dUpg_new(:,(1:ndf),2)+ ...
        (dshapex0(:,inod,2)*ones(1,ndf)).* Ue(:,jnod);             
    
    grad_Unorm(:,1) = grad_Unorm(:,1) + dshapex0(:,inod,1).* Uenorm(:,inod);
    grad_Unorm(:,2) = grad_Unorm(:,2) + dshapex0(:,inod,2).* Uenorm(:,inod);   
    
    grad_p(:,1)  = grad_p(:,1) + dshapex0(:,inod,1).* Uf_e(:,(inod-1)*ndf_fields+1);
    grad_p(:,2)  = grad_p(:,2) + dshapex0(:,inod,2).* Uf_e(:,(inod-1)*ndf_fields+1);          
    vel_l(:,1)   = vel_l (:,1) + N0(inod).* Uf_e(:,(inod-1)*ndf_fields+2);
    vel_l(:,2)   = vel_l (:,2) + N0(inod).* Uf_e(:,(inod-1)*ndf_fields+3);      
    
end    

velpg   = Upg(:,2:3);
hele    = comp_hele(velpg,dshapex0,Jaco0,nen);
[tau,delta,bas] = supg_bubbly_2d(Upg,dUpg,hele,prop,type_upwind);

if debug,
    tau = 0*tau;
    delta = 0*delta;
end

Vol = zeros(ne,nen);

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------
for ipg=1:npg
    
    [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
    [dshapex,N] = shape2d(X2S,psipg(ipg),etapg(ipg),nen); 
    
    % Interpolacion en punto de Gauss
    %------------------------------------------------------------------
    
    Upg    = zeros(ne,ndf);
    U0pg    = zeros(ne,ndf);
    dUpg    = zeros(ne,ndf,ndm);
    radpg    = zeros(ne,1);
    grad_p   = zeros(ne,ndm);
    vel_l    = zeros(ne,ndm);
    
    for inod=1:nen,
        jnod = (inod-1)*ndf+(1:ndf);
        Upg(:,(1:ndf))  =  Upg(:,(1:ndf)) + N(inod).*  Ue(:,jnod);
        U0pg(:,(1:ndf)) = U0pg(:,(1:ndf)) + N(inod).* U0e(:,jnod);
        radpg(:,1)      =      radpg(:,1) + N(inod).* re(:,inod);
        
        dUpg(:,(1:ndf),1)   = dUpg(:,(1:ndf),1) + ...
            (dshapex(:,inod,1)*ones(1,ndf)).* Ue(:,jnod);
        
        dUpg(:,(1:ndf),2) = dUpg(:,(1:ndf),2)+ ...
            (dshapex(:,inod,2)*ones(1,ndf)).* Ue(:,jnod);          
        grad_p(:,1)  = grad_p(:,1) + dshapex(:,inod,1).* Uf_e(:,(inod-1)*ndf_fields+1);
        grad_p(:,2)  = grad_p(:,2) + dshapex(:,inod,2).* Uf_e(:,(inod-1)*ndf_fields+1);          
        vel_l(:,1)   = vel_l (:,1) + N(inod).* Uf_e(:,(inod-1)*ndf_fields+2);
        vel_l(:,2)   = vel_l (:,2) + N(inod).* Uf_e(:,(inod-1)*ndf_fields+3);      
    end
    
    [H,Cp]     =  enthalpy_function(Upg,prop);
    [H0,bas]   =  enthalpy_function(U0pg,prop);
    
    % advective flux function  
    [Fa,Ax,Ay]     =  Flux_function(Upg,prop);        
    
    % reactive and source terms due to:
    % .- pressure gradient 
    % .- bouyancy forces
    % .- phase interactions drag  
    
    if lumping_drag_forces,
        job  = 1; % [0] en Cflux todas las 3 fuerzas (pressure, buoyancy y pressure)
        % [1] en Cflux solo las fuerzas de pressure y buoyancy
        % [2] en Cflux solo la fuerza de drag
        job  = 2;
    else
        job = 0;
    end
    
    [Fc_1,C_1] = Cflux(Upg,grad_p,vel_l,prop,job);      
    
    [Fd,Kxx,Kxy,Kyx,Kyy,ttau]  = Dflux(Upg,dUpg,prop);  
    
    
    if debug,
        Fc_1=0*Fc_1;
        C_1=0*C_1;
        Fd=0*Fd;
        Kxx=0*Kxx;
        Kxy=0*Kxy;
        Kyx=0*Kyx;
        Kyy=0*Kyy;
    end
    disp('bubbly_2d_ele');keyboard;pause
    
    % Correccion axisimetrica del jacobiano de la transformacion al elemento master
    %------------------------------------------------------------------
    xsj =  wpg(ipg) .* Jaco;
    if axisim,
        xsj = xsj.*radpg;
    end
    
    AgU = rowprod(Ax,dUpg(:,1:ndf,1),ndf,ndf,1) + ... 
        rowprod(Ay,dUpg(:,1:ndf,2),ndf,ndf,1);
    
    % P_i Petrov-Galerkin perturbation weight function
    for inod=1:nen,   
        
        P_supg = zeros(ne,ndf,ndf);       
        
        % Element Volume
        Vol(:,inod)=Vol(:,inod)+N(inod)*xsj;
        
        % W_i = N_i + P_i
        tmp = tau.*(velpg(:,1).*dshapex(:,inod,1)+velpg(:,2).*dshapex(:,inod,2));
        for idf=1:ndf,
            P_supg(:,idf,idf) = tmp;
        end
        
        W_supg = P_supg;      
        for idf=1:ndf,
            W_supg(:,idf,idf)=W_supg(:,idf,idf)+N(inod);
        end
        
        % W_i N_j term
        
        for jnod=1:nen,        
            % A_gN     
            tmpx = dshapex(:,jnod,1);
            tmpy = dshapex(:,jnod,2);
            for idf=1:ndf,
                for jdf=1:ndf,
                    A_gN(:,idf,jdf,jnod) = tmpx.*Ax(:,idf,jdf) + tmpy.*Ay(:,idf,jdf) ;
                end 
            end    
        end
        
        for jnod=1:nen,
            
            % temporal terms
            W_Cp_N = rowprod(W_supg,Cp,ndf,ndf,ndf)*N(jnod) ;        
            %W_Cp_N = N(inod)*Cp*N(jnod) ;         
            
            % N_A_gN or gN_A_N according to weak form
            if weak_form,
                N_A_gN = -A_gN(:,:,:,inod)*N(jnod);                 
            else          
                N_A_gN =  A_gN(:,:,:,jnod)*N(inod);              
            end
            
            P_A_gN = rowprod(P_supg,A_gN(:,:,:,jnod),ndf,ndf,ndf);
            
            % shock capturing term
            gN_D_gN = zeros(numel,ndf,ndf);        
            if (shocap > 0)        
                for idf=1:ndf,
                    for idm=1:ndm
                        gN_D_gN(:,idf,idf) = gN_D_gN(:,idf,idf) + ...
                            dshapex(:,inod,idm).*delta.*dshapex(:,jnod,idm);
                    end
                end
            end
            
            gN_K_gN = zeros(numel,ndf,ndf);        
            for idf=1:ndf,
                for jdf=1:ndf,
                    gN_K_gN(:,idf,jdf) = ...
                        -( (dshapex(:,inod,1).*Kxx(:,idf,jdf).*dshapex(:,jnod,1))+ ...
                        (dshapex(:,inod,1).*Kxy(:,idf,jdf).*dshapex(:,jnod,2))+ ...
                        (dshapex(:,inod,2).*Kyx(:,idf,jdf).*dshapex(:,jnod,1))+ ...
                        (dshapex(:,inod,2).*Kyy(:,idf,jdf).*dshapex(:,jnod,2)) );
                end             
            end
 
%            keyboard;pause            
            KgN = zeros(ne,ndf,ndf);
            for idf=1:ndf,
                KgN(:,idf,1) = KgN(:,idf,1)+ttau(:,idf,1).*dshapex(:,inod,1) + ttau(:,idf,2).*dshapex(:,inod,2);                
            end
            N_KgN = KgN*N(jnod);
    
            % reactive terms
            W_C_N = rowprod(W_supg,C_1,ndf,ndf,ndf)*N(jnod) ;        
            
            % assembling
            vaux =  N_A_gN + P_A_gN + gN_D_gN - gN_K_gN + W_C_N + 1*N_KgN;
            
            
            for idf=1:ndf,
                for jdf=1:ndf,              
                    Mele(:,inod,idf,jnod,jdf) = Mele(:,inod,idf,jnod,jdf) + ... 
                        xsj.*( (1-lumping_time_terms)*W_Cp_N(:,idf,jdf) ./ dt + vaux(:,idf,jdf) );           
                end
            end
            
        end % jnod
        
        % temporal term
        W_dUdt   = rowprod(W_supg,(H-H0),ndf,ndf,1);
        
        % advective fluxes
        if weak_form,
            
            gN_Fa = -(dshapex(:,inod,1)*ones(1,ndf)).*Fa(:,1:ndf,1) ... 
                -(dshapex(:,inod,2)*ones(1,ndf)).*Fa(:,1:ndf,2);
        else
            gN_Fa = (N(inod)*ones(numel,ndf)).* AgU(:,1:ndf);
        end
        
        % diffusive fluxes
        gN_Fd = -(dshapex(:,inod,1)*ones(1,ndf)).*Fd(:,1:ndf,1) ... 
            -(dshapex(:,inod,2)*ones(1,ndf)).*Fd(:,1:ndf,2);
        
        % stabilization SUPG terms        
        P_A_gU   = rowprod(P_supg,AgU,ndf,ndf,1);
        
        gN_D_gU = zeros(ne,ndf);
        
        if(shocap>0)                
            for idf=1:ndf,
                for idm=1:ndm              
                    gN_D_gU(:,idf) = gN_D_gU(:,idf) + ...
                        dshapex(:,inod,idm).*delta.*dUpg(:,idf,idm);
                end
            end
        end        
        
        % reactive and source terms        
        W_Fc_1   = rowprod(W_supg,Fc_1,ndf,ndf,1) ;
        
        vaux =  gN_Fa + P_A_gU + gN_D_gU - gN_Fd + W_Fc_1;  
        
        for idf=1:ndf,
            Rele(:,inod,idf) = Rele(:,inod,idf) - ... 
                (vaux(:,idf) +(1-lumping_time_terms)*W_dUdt(:,idf) ./ dt ).* xsj ;
        end
        
    end % inod
    
end % ipg


if lumping_drag_forces,
    
    for inod=1:nen,
        % reactive and source terms        
        job         = 2; % [0] en Cflux todas las 3 fuerzas (pressure, buoyancy y pressure)
        % [1] en Cflux solo las 3 fuerzas de pressure y buoyancy
        % [2] en Cflux solo la fuerza de drag
        job = 1;
        
        jnod           = (inod-1)*ndf+(1:ndf);
        Upg(:,(1:ndf)) = Ue(:,jnod);
        U0pg(:,(1:ndf)) = U0e(:,jnod);   
        vel_l(:,1)     = Uf_e(:,(inod-1)*ndf_fields+2);
        vel_l(:,2)     = Uf_e(:,(inod-1)*ndf_fields+3);      
        
        [H,Cp]     =  enthalpy_function(Upg,prop);
        [H0,bas]   =  enthalpy_function(U0pg,prop);
        
        [Fc_2,C_2] = Cflux(Upg,grad_p,vel_l,prop,job);
        
        
        for idf=1:ndf,
            for jdf=1:ndf,              
                Mele(:,inod,idf,inod,jdf)=Mele(:,inod,idf,inod,jdf)+Vol(:,inod).*C_2(:,idf,jdf);               
                Mele(:,inod,idf,inod,jdf)=Mele(:,inod,idf,inod,jdf)+Vol(:,inod).*Cp(:,idf,jdf)./dt;           
            end
        end
        
        for idf=1:ndf,
            Rele(:,inod,idf) = Rele(:,inod,idf) - Vol(:,inod).*Fc_2(:,idf);
            Rele(:,inod,idf) = Rele(:,inod,idf) - Vol(:,inod).*(H(:,idf)-H0(:,idf))./dt;      
        end
        
    end
end

% ------ Terminos de contorno
if weak_form,
    [Mele,Rele] = bc_conv_bubbly_2d(xnod,icone,Ue,ifaceb,Rele,Mele,prop);   
end
