### $Id: mkmesh.m,v 1.3 2001/11/06 02:38:49 mstorti Exp $ 

source("./data.m.tmp");

w=zhomo([0 R 0 H],Nr+1,Nz+1,[1 1 1 1 zratio 1*zratio]);

[xnod,icone]=pfcm2fem(w);
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);

icone = icone(:,[1,4,3,2]); 

xmin = min(xnod);
xmax = max(xnod);
tol  = 1e-6;
nodes_bot = find(abs(xnod(:,2)-xmin(2))<tol);
nodes_top = find(abs(xnod(:,2)-xmax(2))<tol);
nodes_rig = find(abs(xnod(:,1)-xmax(1))<tol);
nodes_lef = find(abs(xnod(:,1)-xmin(1))<tol);

## bottom
fixa = [];
nodes = nodes_bot;
idfs = [2,3,4,5,6]; 
values = [p_bot,alpha_g_in,[0,v_l_in],[0,v_g_in]];

for icompo=idfs
  compo = icompo*ones(length(nodes),1);
  value = values(icompo)*ones(length(nodes),1);
  fixa  = [ fixa ; [nodes compo value ]];
endfor
asave("laddle_1d.fixa_bot.tmp",fixa);

fixa=[];
if flag_alpha_g_all_fixed==1,
   numnp  = length(xnod(:,2));
  if 1,
  ## sobrescribo condicion de entrada en void fraction para suavizarla
    Ampl   = alpha_g_in-alpha_g_ini;
    sigma  = 0.002;
    xc     = xmin(2);    
    z      = xnod(:,2)-xc;
    value  = alpha_g_ini+Ampl*exp(-z.^2/sigma);       
    fixa   = [ fixa ; [(1:numnp)' 2*ones(numnp,1) value ]]; 
  else
    fixa  = [ fixa ; [(1:numnp)' ones(numnp,1)*[2,alpha_g_ini]]];    
  endif
  asave("laddle_1d.fixa_all_alpha_g.tmp",fixa);
endif

## en las tapas laterales las velocidades horizontales son nulas
fixa = [];
nodes = [nodes_lef;nodes_rig];
values = [0,alpha_g_in,[0,0],[0,0]]; 
idfs=[3,5];
for icompo=idfs
  compo = icompo*ones(length(nodes),1);
  value = values(icompo)*ones(length(nodes),1);
  fixa  = [ fixa ; [nodes compo value ]];
endfor
asave("laddle_1d.fixa_lat.tmp",fixa);

## en la tapa de arriba la presion de referencia
fixa = [];

if flag_pressure_all_fixed==1,
    if 0,        
        value = rho_l*abs(gravity)*(H-xnod(:,2))+p_top;
    else
        value = 10*ones(length(xnod(:,2)),1);        
    endif
    fixa   = [ fixa ; [(1:numnp)' 1*ones(numnp,1) value ]];     
    asave("laddle_1d.fixa_all_pressure.tmp",fixa);
else
nodes = nodes_top;
idfs = [1];
values = [p_top,alpha_g_in,0,0,0,0];
for icompo=idfs
  compo = icompo*ones(length(nodes),1);
  value = values(icompo)*ones(length(nodes),1);
  fixa  = [ fixa ; [nodes compo value ]];
endfor
asave("laddle_1d.fixa_top.tmp",fixa);
endif

fixa=[];
if flag_v_g_all_fixed==1,
   numnp  = length(xnod(:,2));
  if 0,
  ## sobrescribo condicion de entrada en void fraction para suavizarla
    Ampl   = alpha_g_in-alpha_g_ini;
    sigma  = 0.002;
    xc     = xmin(2);    
    z      = xnod(:,2)-xc;
    value  = alpha_g_ini+Ampl*exp(-z.^2/sigma);       
    fixa   = [ fixa ; [(1:numnp)' 2*ones(numnp,1) value ]]; 
  else
    fixa  = [ fixa ; [(1:numnp)' ones(numnp,1)*[6,v_g_ini]]];    
  endif
  asave("laddle_1d.fixa_all_v_g.tmp",fixa);
endif


# initial condition
uini=[p_ini,alpha_g_ini,[0,v_l_ini],[0,v_g_ini],k_ini,eps_ini];
uini = ones(numnp,1)*uini;
uini(:,1) = rho_l*abs(gravity)*(H-xnod(:,2))+p_top;
Ampl   = alpha_g_in-alpha_g_ini;
sigma  = 0.002;
xc     = xmin(2);
xx     = xnod(:,2)-ones(numnp,1)*xc;
z      = xx;
uini(:,2) = alpha_g_ini*ones(length(z),1)+Ampl*exp(-z.^2/sigma);   
if 0,
    mask    = (xnod(:,2)>(H/2));
    uini(:,4) = v_l_ini*mask+(1-mask)*v_l_in;
else
    uini(:,4) = (v_l_in-v_l_ini)*(1-xnod(:,2)/H)+v_l_ini;
endif
asave("laddle_1d.ini.tmp",uini);

fid = fopen("laddle_1d.fixa_all.tmp","w");
idfs=[7,8];
for j=1:numnp;
  fprintf(fid,"%d %d %f\n",j,idfs(1),k_ini);
  fprintf(fid,"%d %d %f\n",j,idfs(2),eps_ini);
endfor
fclose(fid);

## Bcconv
if 1,
bcconv = [];

nodes=nodes_top;
N=length(nodes);
[bas,ibas]=sort(xnod(nodes,1));
nodes=nodes(ibas);
bcconv = [bcconv;[ nodes(2:N) nodes(1:N-1)]];
%bcconv = [bcconv;[ nodes(1:N-1) nodes(2:N) ]];

nodes=nodes_bot;
N=length(nodes);
[bas,ibas]=sort(xnod(nodes,1));
nodes=nodes(ibas);
bcconv = [bcconv;[ nodes(1:N-1) nodes(2:N) ]];
%bcconv = [bcconv;[ nodes(2:N) nodes(1:N-1) ]];

asave("laddle_1d.bcconv.tmp",bcconv);
endif

# periodico segun la transversal
node1 = nodes_rig;
node2 = nodes_lef;
nn=find(abs(xnod(node1,2)-xmax(2))<1e-6);
node1(nn)=[];
nn=find(abs(xnod(node2,2)-xmax(2))<1e-6);
node2(nn)=[];
uno   = ones(length(node1),1);
vaux = [];
idfs=(1:ndof); 
for compo =idfs
vaux = [vaux ; [uno, node1 , compo*uno , -uno, node2, compo*uno]];
endfor

if 1,
# periodico a la salida
mask = zeros(numnp,1);
mask(nodes_top)=1;
nn = find(mask==0);
[bas,ip]=max(xnod(nn,2));
ymax_m1 = xnod(ip,2);
nodes_top_m1 = find(abs(xnod(:,2)-ymax_m1)<tol);
node1 = nodes_top;
node2 = nodes_top_m1;
uno   = ones(length(node1),1);
idfs=(2:ndof); 
for compo =idfs
vaux = [vaux ; [uno, node1 , compo*uno , -uno, node2, compo*uno]];
endfor
endif

asave("laddle_1d.peri_1d.tmp",vaux);

# escribo la malla
asave("laddle_1d.nod.tmp",xnod);
asave("laddle_1d.con.tmp",icone);
