### $Id: mkmesh.m,v 1.3 2001/11/06 02:38:49 mstorti Exp $ 

source("./data.m.tmp");

if flag_axi==1, axi=1; else axi=0; endif
if (flag_1d==1 && flag_axi==1), error(" axi & 1-D is not possible "); end

if ip>0, fixa_field=ip; endif

#w=zhomo([0 R 0 H],Nr+1,Nz+1,[rratio 5*rratio 2*rratio 1 4*zratio 8*zratio]);
w=zhomo([0 R 0 H],Nr+1,Nz+1,[1 1 1 1 1 1]);

[xnod,icone]=pfcm2fem(w);
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);

if axi==0, 
  icone = icone(:,[1,4,3,2]); 
else
## 3D extension for axisymmetric computation
angle = -1*pi/180;
rota = [cos(angle) , 0 , -sin(angle); 0,1,0; sin(angle), 0 , cos(angle)];
x3d = [xnod , xnod(:,1)*0];
x3d = [x3d; (rota*x3d')'];
icone3d = [icone , icone+numnp];
endif

xmin = min(xnod);
xmax = max(xnod);
tol  = 1e-6;
nodes_bot = find(abs(xnod(:,2)-xmin(2))<tol);
nodes_top = find(abs(xnod(:,2)-xmax(2))<tol);
nodes_wall= find(abs(xnod(:,1)-xmax(1))<tol);
nodes_axis= find(abs(xnod(:,1)-xmin(1))<tol);

## in
fixa = [];
nodes = nodes_bot;
if axi==1, 
idfs = [2,3,4,6,7]; 
values = [p_bot,alpha_g_in,[0,v_l_in,0],[0,v_g_in,0]];
else 
idfs = [2,3,4,5,6]; 
values = [p_bot,alpha_g_in,[0,v_l_in],[0,v_g_in]]
endif

for icompo=idfs
  compo = icompo*ones(length(nodes),1);
  value = values(icompo)*ones(length(nodes),1);
  fixa  = [ fixa ; [nodes compo value ]];
endfor
asave("laddle_pipe.fixa_in.tmp",fixa);

# out
fixa = [];
nodes = nodes_top;
idfs=[1];
values = [p_top,0,0,0,0,0,0,0];

for icompo=idfs
  compo = icompo*ones(length(nodes),1);
  value = values(icompo)*ones(length(nodes),1);
  fixa  = [ fixa ; [nodes compo value ]];
endfor
asave("laddle_pipe.fixa_out.tmp",fixa);


## wall
fixa = [];
nodes = nodes_wall;
values = [0,alpha_g_in,[0,0,0],[0,0,0]]; 

if axi==1,  idfs=[3,4,6,7]; else idfs=[3,4,5,6]; endif
for icompo=idfs
  compo = icompo*ones(length(nodes),1);
  value = values(icompo)*ones(length(nodes),1);
  fixa  = [ fixa ; [nodes compo value ]];
endfor
asave("laddle_pipe.fixa_wall.tmp",fixa);


## axis
fixa = [];
nodes = nodes_axis;
values = [0,alpha_g_in,0,0,0,0,0,0]; 

if axi==1,  idfs=[3,6]; else idfs=[3,5]; endif
for icompo=idfs
  compo = icompo*ones(length(nodes),1);
  value = values(icompo)*ones(length(nodes),1);
  fixa  = [ fixa ; [nodes compo value ]];
endfor
asave("laddle_pipe.fixa_axis.tmp",fixa);


# initial condition
if axi==1,
  uini=[p_ini,alpha_g_ini,v_l_ini*[0,1,0],v_g_ini*[0,1,0],k_ini,eps_ini];
  uini = ones(2*numnp,1)*uini;
  uini(:,1) = rho_l*abs(gravity)*(H-x3d(:,2))+p_top;  
else
  uini=[p_ini,alpha_g_ini,v_l_ini*[0,1],v_g_ini*[0,1],k_ini,eps_ini];
  uini = ones(numnp,1)*uini;
  uini(:,1) = rho_l*abs(gravity)*(H-xnod(:,2))+p_top;
endif

if isempty(pert_node)==0,
#perturbamos el flujo
if 0,
uini(pert_node,pert_idf)=pert_value;
else
if pert_idf==2
Ampl   = pert_value;
sigma  = 0.001;
xc     = xnod(pert_node,2);    
z      = xnod(:,2)-ones(length(xnod(:,1)),1)*xc;
value  = alpha_g_ini+Ampl*exp(-z.^2/sigma);       
uini(:,pert_idf)=value;
else
error(' VER MKLADDLE')
endif
endif
endif

asave("laddle_pipe.ini.tmp",uini);

if ip>=0,
  XX=aload(save_file);
  p_x      = XX(:,1);
  alpha_g_x = XX(:,2);
  u_l_x    = XX(:,3);
  v_l_x    = XX(:,4);
  if axi==1,
    w_l_x    = XX(:,5);
    u_g_x    = XX(:,6);
    v_g_x    = XX(:,7);
    w_g_x    = XX(:,8);
  else
    u_g_x    = XX(:,5);
    v_g_x    = XX(:,6);
  endif
else
  p_x      = uini(:,1);
  alpha_g_x = uini(:,2);
  u_l_x    = uini(:,3);
  v_l_x    = uini(:,4);
  if axi==1,
    w_l_x    = uini(:,5);
    u_g_x    = uini(:,6);
    v_g_x    = uini(:,7);
    w_g_x    = uini(:,8);
  else
    u_g_x    = uini(:,5);
    v_g_x    = uini(:,6);
  endif
endif

fid = fopen("laddle_pipe.fixa_all.tmp","w");

for j=1:numnp;

if (fixa_field==1),
  fprintf(fid,"%d %d %f\n",j,1,p_x(j));
  fprintf(fid,"%d %d %f\n",j,3,u_l_x(j));
  fprintf(fid,"%d %d %f\n",j,4,v_l_x(j));
elseif (fixa_field==2),
  if axi==1,  idfs=[2,6,7]; else idfs=[2,5,6]; endif
  fprintf(fid,"%d %d %f\n",j,idfs(1),alpha_g_x(j));
  fprintf(fid,"%d %d %f\n",j,idfs(2),u_g_x(j));
  fprintf(fid,"%d %d %f\n",j,idfs(3),v_g_x(j));
elseif (fixa_field==3),
  if axi==1,  idfs=[1,3,4,6,7]; else idfs=[1,3,4,5,6]; endif
  fprintf(fid,"%d %d %f\n",j,idfs(1),p_x(j));
  fprintf(fid,"%d %d %f\n",j,idfs(2),u_l_x(j));
  fprintf(fid,"%d %d %f\n",j,idfs(3),v_l_x(j));
  fprintf(fid,"%d %d %f\n",j,idfs(4),u_g_x(j));
  fprintf(fid,"%d %d %f\n",j,idfs(5),v_g_x(j));
elseif (fixa_field==4),
  fprintf(fid,"%d %d %f\n",j,1,p_x(j));
  fprintf(fid,"%d %d %f\n",j,3,u_l_x(j));
  fprintf(fid,"%d %d %f\n",j,4,v_l_x(j));
  fprintf(fid,"%d %d %f\n",j,2,alpha_g_x(j));
endif

  if axi==1,
  fprintf(fid,"%d %d %f\n",j,5,0);
  fprintf(fid,"%d %d %f\n",j,8,0);
  endif

  if flag_1d==1,
  fprintf(fid,"%d %d %f\n",j,3,0);
  fprintf(fid,"%d %d %f\n",j,5,0);
  endif

  if flag_alpha_g_all_fixed==1,
  fprintf(fid,"%d %d %f\n",j,2,alpha_g_in);
  endif

  if axi==1,  idfs=[9,10]; else idfs=[7,8]; endif
  fprintf(fid,"%d %d %f\n",j,idfs(1),k_ini);
  fprintf(fid,"%d %d %f\n",j,idfs(2),eps_ini);
endfor
fclose(fid);

## Bcconv
bcconv = [];

nodes=nodes_top;
N=length(nodes);
[bas,ibas]=sort(xnod(nodes,1));
nodes=nodes(ibas);
#bcconv = [bcconv;[ nodes(1:N-1) nodes(2:N)]];
bcconv = [bcconv;[ nodes(2:N) nodes(1:N-1)]];

if isempty(nodes_bot)==0,
nodes=nodes_bot;
N=length(nodes);
[bas,ibas]=sort(xnod(nodes,1));
nodes=nodes(ibas);
#bcconv = [bcconv;[ nodes(2:N) nodes(1:N-1) ]];
bcconv = [bcconv;[ nodes(1:N-1) nodes(2:N) ]];
endif

if ndm>2,  
  bcconv = [bcconv, bcconv(:,[2,1])+numnp];
endif

asave("laddle_pipe.bcconv.tmp",bcconv);


if axi==1,  

## periodic constrain for axisymmetric computation
## Imposing axisymmetric fields 
uno   = ones(numnp,1);
node1 = numnp+(1:numnp)';
node2 = (1:numnp)';
no2   = [0;0;1];
no1   = rota*no2;

vaux = [];

idfs=[1,2,4,7,9,10]; 
for compo =idfs
  vaux = [vaux ; [uno, node1 , compo*uno , -uno, node2, compo*uno]];
endfor

asave("laddle_pipe.axisym_scalar.tmp",vaux);

vaux = [];
vaux  = [ ...
	[uno, node1 ,3*uno , -uno*rota(1,1) , node2 , 3*uno, -uno*rota(1,3) , node2 , 5*uno];
	[uno, node1 ,5*uno , -uno*rota(3,1) , node2 , 3*uno, -uno*rota(3,3) , node2 , 5*uno]];

vaux  = [ vaux ;
	[uno, node1 ,6*uno , -uno*rota(1,1) , node2 , 6*uno, -uno*rota(1,3) , node2 , 8*uno];
	[uno, node1 ,8*uno , -uno*rota(3,1) , node2 , 6*uno, -uno*rota(3,3) , node2 , 8*uno]];

asave("laddle_pipe.axisym_vector.tmp",vaux);

elseif flag_1d==1,

    node1 = nodes_wall;
    node2 = nodes_axis;
    uno   = ones(length(node1),1);
    vaux = [];
    idfs=(1:ndof); 
    for compo =idfs
        vaux = [vaux ; [uno, node1 , compo*uno , -uno, node2, compo*uno]];
    endfor
    asave("laddle_pipe.peri_1d.tmp",vaux);    
endif

if peri_in_out==1,
    vaux = [];
    node1 = nodes_bot;
    node2 = nodes_top;
    uno   = ones(length(node1),1);
    idfs=(1:ndof); 
    for compo =idfs
        vaux = [vaux ; [uno, node1 , compo*uno , -uno, node2, compo*uno]];
    endfor
    asave("laddle_pipe.peri_in_out.tmp",vaux);        
endif

if axi==1,
asave("laddle_pipe.nod.tmp",x3d);
asave("laddle_pipe.con.tmp",icone3d);
else
asave("laddle_pipe.nod.tmp",xnod);
asave("laddle_pipe.con.tmp",icone);
endif


