Nphi = 100;
tol  = 1e-5;
phi_min = 0+tol;
phi_max = 2*pi-tol;
dphi    = (phi_max-phi_min)/Nphi;

dt      = 0.1;
dx      = 1;

alpha   = 0.9;
vel_g   = 2;
vel_l   = 1;
p       = 0;

rho_l    = 1000;
rho_g    = 1;
r_bubble = 0.001;
Cd       = 10;

state = [alpha,vel_g,vel_l,p];
[A,B,C] = bubbly_model_1(state,rho_l,rho_g); 

C = alpha*Cd*rho_l/r_bubble*abs(vel_g-vel_l)*C;

G = []; phih=[];
for phi=phi_min:dphi:phi_max
    Mass = 1/6*(exp(i*phi)+4+exp(-i*phi));    
    phih=[phih;phi];
    D = (Mass*A+B*dt/dx*(1-exp(-i*phi))-Mass*C*dt)\(Mass*A);
    [Vv,La] = eig(D);
    G = [G;reshape(diag(La),1,4)];
end