function [tau,delta,dt] = supg_bubbly_2d_gas(Upg,grad_phi,hele,prop,type_upwind)
%
%  [tau,delta,dt] = supg_bubbly_2d(Upg,grad_phi,dUpg,gamma,Cou,hele,shocap,type_upwind)
%

tol_upw = 1e-08;

ijob = 'get';
handle_prop_elem;

[N,ndf]     = size(Upg);
alpha_g     = Upg(:,1);
vel_g       = Upg(:,2:3);

velmod  = sqrt(sum(Upg(:,2:3)'.^2))';
velmod  = max([velmod';tol_upw*ones(1,N)])';      

Pe = 0.5/(visco_g/rho_g)*velmod.*hele ;
psi = min([ones(1,N);Pe'/3])';

if type_upwind==0,
    tau   = 0.5* hele ./ velmod.*psi;
%    delta = velmod.*hele/2.*psi;
    delta = velmod.*hele/2;    
    dt    =  Cou*hele ./ velmod;   
elseif type_upwind==1,
    tau =  (2*velmod./hele).^2 + 9*(4*(visco_g/rho_g) ./(hele).^2).^2;
    tau =   1 ./ sqrt(tau);
%    delta = velmod.*hele/2.*psi;
    delta = velmod.*hele/2;
    dt    = Cou*hele ./ velmod;      
else   
    error(' Bad type of upwind has been chosen')
end

tau = tau_factor*tau;
delta = tau_factor*delta;