function [tau,delta,dt] = supg_bubbly_2d_liq(Upg,grad_phi,hele,prop,type_upwind)
%
%  [tau,delta,dt] = supg_bubbly_2d(Upg,grad_phi,dUpg,gamma,Cou,hele,shocap,type_upwind)
%

tol_upw = 1e-08;

ijob = 'get';
handle_prop_elem;

[N,ndf]  = size(Upg);
pre      = Upg(:,1);
vel_l    = Upg(:,2:3);

velmod  = sqrt(sum(Upg(:,2:3)'.^2))';

velmod  = max([velmod';tol_upw*ones(1,N)])';  
Pe = 0.5/(visco_l/rho_l)*velmod.*hele ;
psi = min([ones(1,N);Pe'/3])';

if type_upwind==0,
    tau   = 0.5* hele ./ velmod.*psi;
    %   delta = tau_factor*velmod.*hele/2.*psi;
    delta = velmod.*hele/2.*psi;   
elseif type_upwind==1,
    tau =  (2*velmod./hele).^2 + 9*(4*(visco_l/rho_l) ./(hele).^2).^2;
    tau =   1 ./ sqrt(tau);
    %   delta = tau_factor*velmod.*hele/2;
    delta = velmod.*hele/2.*psi;   
else   
    error(' Bad type of upwind has been chosen')
end
dt    = Cou*hele ./ velmod;      

%tau = 0.02;
%delta = 0.0;

tau = tau_factor*tau;
delta = tau_factor*delta;
