% ====================================================================
%
%                       
%
% ====================================================================

filestate = 'laddle_axi';

flag_alpha_g_all_fixed = 0;
flag_pressure_all_fixed = 0;
flag_v_g_all_fixed = 0;

% bc files

%bc_file_list_base = strvcat('laddle_axi.fixa_wall.tmp','laddle_axi.fixa_nozzle.tmp','laddle_axi.fixa_top.tmp');
bc_file_list_base = strvcat('laddle_axi.fixa_wall.tmp');
bc_file_list = bc_file_list_base;

if flag_alpha_g_all_fixed==1,     
    bc_file_list=strvcat(bc_file_list,'laddle_1d.fixa_all_alpha_g.tmp');
end
if flag_pressure_all_fixed==1,     
    bc_file_list=strvcat(bc_file_list,'laddle_1d.fixa_all_pressure.tmp');
end    
if flag_v_g_all_fixed==1,     
    bc_file_list=strvcat(bc_file_list,'laddle_1d.fixa_all_v_g.tmp');
end    

nnwt_liq   = 4;
nnwt_gas   = 4;
nnwt_outer = 2;

shocap                = 1;
weak_form             = 1; 

Cou   =  1;
npg   =  4;
ndf   =  6;
ndf_liq = 3;
ndf_gas = 3;
tol   = 1e-12;

indx_gas = [2,5,6];
indx_liq = [1,3,4];

% PHYSICAL DATA
gravity =  -9.8;
rho_l   =  1000;
rho_g   =  1;
d_bubble = 0.001;                              
visco_l =  0.8e-3;                            
visco_g =  1e-5;

comp_interphase_terms = 1;
drag_factor           = 1.0;
virtual_mass          = 1;
C_vm                  = 1/2;
model_visco_std       = 0;   % [1] std --> alpha_k * visco_k  [2] avg(alpha_k) * visco_k [0] visco_k
qpot_drag_model       = 1;   % F_drag propto alpha_l ^ qpot
fRe_drag_model        = 2;   % [0] Laminar model [1] Cd=0.44 [2] turbulento
axisim                = 0;

lumping_drag_forces   = 1;
lumping_time_terms    = 1;
tau_factor            = 1;

% ESCALEO
if 0,
    visco_l=visco_l/sqrt(rho_l);
    visco_g=visco_g/sqrt(rho_l);
    rho_g=rho_g/sqrt(rho_l);
    %   p_bot=p_bot/sqrt(rho_l);    
    %   p_ini=p_ini/sqrt(rho_l);    
    %   p_ref=p_ref/sqrt(rho_l);    
    rho_l=rho_l/sqrt(rho_l);
else
    visco_l=visco_l/rho_l;
    visco_g=visco_g/rho_l;
    rho_g=rho_g/rho_l;
    rho_l=rho_l/rho_l;    
end

filename = filestate;

[xnod]  = read_file([filename '.nod.tmp']);
[icone] = read_file([filename '.con.tmp']);
% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end
[numnp,ndm] = size(xnod);
[numel,nen] = size(icone);

xmin = min(xnod);
xmax = max(xnod);

%-------- Solucion inicial (PHI)
[uini] = read_file([filename '.ini.tmp']);
uini = uini(:,1:ndf);

%-------- fijaciones (FIXA)
fixa = zeros(numnp,ndf);
forc = zeros(numnp,ndf);

if exist('bc_file_list','var')==0, error(' BC files does not exist'); end
[nfiles,bas] = size(bc_file_list);
for k=1:nfiles
    bc_file = bc_file_list(k,:);
    [fixa_pf]  = read_file(bc_file );
    [fixa,forc] = conv_fixa_pfem(fixa_pf,fixa,forc);    
end

if 1,
    node=[3,104];
    node=[101,202];
fixa(node,1) = 1;
forc(node,1) = 0;
end

if 0,
% fijo un nodo de presion
if 0,
fixa(3,1) = 1;
forc(3,1) = 0;
fixa(104,1) = 1;
forc(104,1) = 0;
elseif 0,
fixa(101,1) = 1;
forc(101,1) = 0;
fixa(102,1) = 1;
forc(202,1) = 0;
else
fixa(101,1) = 1;
forc(101,1) = 0;
fixa(202,1) = 1;
forc(202,1) = 0;    
end
% fijo a la entrada 
fixa([1,102],[2,4,6])=1;
forc([1,102],[4,6])=1;
forc([1,102],[2])=0.02;
if flag_alpha_g_all_fixed>0,
    fixa(:,2)=1;
    forc(:,2)=0.02;
end
end

% fijo todas las velocidadeds horizontales
fixa(:,[3,5])=1;

%-------- Propiedades del material
ijob = 'set';
handle_prop_elem;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas y deslizamiento AHORA como linear constraints
lin_con = [];
if 1,
    peri  = read_file([filename '.peri_1d.tmp']);
    [nr,nc]=size(peri)
    mask=zeros(nr,1);
    for k=3:3:nc,
        mask = mask | (peri(:,k)==7) | (peri(:,k)==8);
    end
    nn = find(mask==1);
    peri(nn,:)=[];
    
    lin_con = peri;
    clear peri
end

% condicion inicial en primitivas
%-----------------------------------------------
if 1,
    bini   = uini;
    for k=1:ndf,
        nofree        = find(fixa(:,k)~=0);
        bini(nofree,k)   = forc(nofree,k);
    end   
end

bc_time_flag = 0;
bc_time_t_end = 1;