### $Id: mkmesh.m,v 1.3 2001/11/06 02:38:49 mstorti Exp $ 

source("./data.m.tmp");

if flag_axi==1, axi=1; else axi=0; endif
if (flag_1d==1 && flag_axi==1), error(" axi & 1-D is not possible "); end

if ip>0, fixa_field=ip; endif

#w=zhomo([0 R 0 H],Nr+1,Nz+1,[rratio 5 1 zratio 5 1]);
#w=zhomo([0 R 0 H],Nr+1,Nz+1,[rratio 5*rratio 2*rratio 1 4*zratio 8*zratio]);
w=zhomo([0 R 0 H],Nr+1,Nz+1);
[xnod,icone]=pfcm2fem(w);
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);

if axi==0, 
  icone = icone(:,[1,4,3,2]); 
else
## 3D extension for axisymmetric computation
angle = -1*pi/180;
rota = [cos(angle) , 0 , -sin(angle); 0,1,0; sin(angle), 0 , cos(angle)];
x3d = [xnod , xnod(:,1)*0];
x3d = [x3d; (rota*x3d')'];
icone3d = [icone , icone+numnp];
endif

xmin = min(xnod);
xmax = max(xnod);
tol  = 1e-6;
nodes_bot = find(abs(xnod(:,2)-xmin(2))<tol);
nodes_top = find(abs(xnod(:,2)-xmax(2))<tol);
nodes_wall= find(abs(xnod(:,1)-xmax(1))<tol);
nodes_axis= find(abs(xnod(:,1)-xmin(1))<tol);
nn = find(abs(xnod(nodes_bot,1))<nozzle_radius);
nodes_nozzle = nodes_bot(nn);
#nodes_bot(nn)=[];

## bottom
fixa = [];
nodes = nodes_bot;
if axi==1, 
idfs = [3,4,6,7]; 
values = [p_bot,alpha_g_in,[0,0,0],[0,0,0]];
else 
idfs = [3,4,5,6]; 
values = [p_bot,alpha_g_in,[0,0],[0,0]];
endif

for icompo=idfs
  compo = icompo*ones(length(nodes),1);
  value = values(icompo)*ones(length(nodes),1);
  fixa  = [ fixa ; [nodes compo value ]];
endfor
asave("laddle_axi.fixa_in.tmp",fixa);

## inlet at nozzle
fixa = [];
nodes = nodes_nozzle;

if alpha_g_as_time_function==1 & v_g_as_time_function==0,
if axi==1,  idfs=[4,6,7]; else idfs=[4,5,6]; endif
elseif alpha_g_as_time_function==0 & v_g_as_time_function==1,
if axi==1,  idfs=[2,4,6]; else idfs=[2,4,5]; endif
elseif alpha_g_as_time_function==1 & v_g_as_time_function==1,
if axi==1,  idfs=[4,6]; else idfs=[4,5]; endif
else
   if axi==1,  
      idfs=[2,4,6,7]; 
   else 
      idfs=[2,6];
   endif
endif

if axi==1,
values = [p_bot,alpha_g_in,[0,0,0],[0,v_g_in,0]];
else
values = [p_bot,alpha_g_in,[0,0],[0,v_g_in]];
endif


for icompo=idfs
  ## sobrescribo condicion de entrada en void fraction para suavizarla
  if (icompo==2)&(flag_1d==0),
    nodes_2 = [nodes_nozzle;nodes_bot(1:6)];
    compo = icompo*ones(length(nodes_2),1);    
    Ampl   = alpha_g_in-alpha_g_ini;
    sigma  = 0.01;
    xc     = xmin(1);    
    z     = xnod(nodes_2,1)-ones(length(nodes_2),1)*xc;
    value = alpha_g_ini+Ampl*exp(-z.^2/sigma);       
    fixa  = [ fixa ; [nodes_2 compo value ]]; 
  else
    compo = icompo*ones(length(nodes),1);
    value = values(icompo)*ones(length(nodes),1);  
    fixa  = [ fixa ; [nodes compo value ]];    
  end
endfor

asave("laddle_axi.fixa_nozzle.tmp",fixa);

## en la pared las velocidades son nulas
fixa = [];
nodes = nodes_wall;
if axi==1, 
values = [0,alpha_g_in,[0,0,0],[0,0,0]]; 
else
values = [0,alpha_g_in,[0,0],[0,0]]; 
endif

if axi==1,  idfs=[3,4,6,7]; else idfs=[3,5]; endif
for icompo=idfs
  compo = icompo*ones(length(nodes),1);
  value = values(icompo)*ones(length(nodes),1);
  fixa  = [ fixa ; [nodes compo value ]];
endfor
asave("laddle_axi.fixa_wall.tmp",fixa);

## en la tapa de arriba la presion de referencia, velocidad normal nula
## del liquido y tangencial nula del gas ( el gas sale normal ) 
fixa = [];
nodes = nodes_top;
if axi==1,  idfs=[1,4]; else idfs=[1]; endif
#if axi==1,  idfs=[1,4,6]; else idfs=[1,4,5]; endif
if axi==1,
values = [p_top,alpha_g_in,0,0,0,0,0,0];
else
values = [p_top,alpha_g_in,0,0,0,0];
endif
for icompo=idfs
  compo = icompo*ones(length(nodes),1);
  value = values(icompo)*ones(length(nodes),1);
  fixa  = [ fixa ; [nodes compo value ]];
endfor
asave("laddle_axi.fixa_top.tmp",fixa);

## en el eje la velocidad normal es nula
#fixa = [];
#nodes = nodes_axis;
#if axi==1, 
#values = [0,alpha_g_in,0,0,0,0,0,0]; 
#else
#values = [0,alpha_g_in,0,0,0,0]; 
#endif

#if axi==1,  idfs=[3,6]; else idfs=[3,5]; endif
#for icompo=idfs
#  compo = icompo*ones(length(nodes),1);
#  value = values(icompo)*ones(length(nodes),1);
#  fixa  = [ fixa ; [nodes compo value ]];
#endfor
#asave("laddle_axi.fixa_axis.tmp",fixa);

# initial condition
if axi==1,
  uini=[p_ini,alpha_g_ini,1e-6*[1,1,1],1e-6*[1,1,1],k_ini,eps_ini];
  uini = ones(2*numnp,1)*uini;
  uini(:,1) = rho_l*abs(gravity)*(H-x3d(:,2))+p_top;
Ampl   = alpha_g_in-alpha_g_ini;
sigma  = 0.002;
xc     = xmin;
##xx     = xnod-ones(2*numnp,1)*xc;
xx     = x3d(:,1:2)-ones(2*numnp,1)*xc;
z      = sqrt(sum(xx'.^2))';
uini(:,2) = alpha_g_ini*ones(length(z),1)+Ampl*exp(-z.^2/sigma);   
else
  v_g_ini=0.8*v_g_in;
  v_l_ini=0.8*v_g_in;
  uini=[p_ini,alpha_g_ini,v_l_ini*[0,1],v_l_ini*[0,1],k_ini,eps_ini];
  uini = ones(numnp,1)*uini;
  uini(:,1) = rho_l*abs(gravity)*(H-xnod(:,2))+p_top;
Ampl   = alpha_g_in-alpha_g_ini;
sigma  = 0.002;
if flag_1d==0,
xc     = xmin;
xx     = xnod-ones(numnp,1)*xc;
z      = sqrt(sum(xx'.^2))';
else
xc     = xmin(2);
xx     = xnod(:,2)-ones(numnp,1)*xc;
z      = xx;
endif
uini(:,2) = alpha_g_ini*ones(length(z),1)+Ampl*exp(-z.^2/sigma);   
endif
asave("laddle_axi.ini.tmp",uini);

if ip>=0,
  XX=aload(save_file);
  p_x      = XX(:,1);
  alpha_g_x = XX(:,2);
  u_l_x    = XX(:,3);
  v_l_x    = XX(:,4);
  if axi==1,
    w_l_x    = XX(:,5);
    u_g_x    = XX(:,6);
    v_g_x    = XX(:,7);
    w_g_x    = XX(:,8);
  else
    u_g_x    = XX(:,5);
    v_g_x    = XX(:,6);
  endif
else
  p_x      = uini(:,1);
  alpha_g_x = uini(:,2);
  u_l_x    = uini(:,3);
  v_l_x    = uini(:,4);
  if axi==1,
    w_l_x    = uini(:,5);
    u_g_x    = uini(:,6);
    v_g_x    = uini(:,7);
    w_g_x    = uini(:,8);
  else
    u_g_x    = uini(:,5);
    v_g_x    = uini(:,6);
  endif
endif

fid = fopen("laddle_axi.fixa_all.tmp","w");

for j=1:numnp;

if (fixa_field==1),
  fprintf(fid,"%d %d %f\n",j,1,p_x(j));
  fprintf(fid,"%d %d %f\n",j,3,u_l_x(j));
  fprintf(fid,"%d %d %f\n",j,4,v_l_x(j));
elseif (fixa_field==2),
  if axi==1,  idfs=[2,6,7]; else idfs=[2,5,6]; endif
  fprintf(fid,"%d %d %f\n",j,idfs(1),alpha_g_x(j));
  fprintf(fid,"%d %d %f\n",j,idfs(2),u_g_x(j));
  fprintf(fid,"%d %d %f\n",j,idfs(3),v_g_x(j));
elseif (fixa_field==3),
  if axi==1,  idfs=[1,3,4,6,7]; else idfs=[1,3,4,5,6]; endif
  fprintf(fid,"%d %d %f\n",j,idfs(1),p_x(j));
  fprintf(fid,"%d %d %f\n",j,idfs(2),u_l_x(j));
  fprintf(fid,"%d %d %f\n",j,idfs(3),v_l_x(j));
  fprintf(fid,"%d %d %f\n",j,idfs(4),u_g_x(j));
  fprintf(fid,"%d %d %f\n",j,idfs(5),v_g_x(j));
elseif (fixa_field==4),
  fprintf(fid,"%d %d %f\n",j,1,p_x(j));
  fprintf(fid,"%d %d %f\n",j,3,u_l_x(j));
  fprintf(fid,"%d %d %f\n",j,4,v_l_x(j));
  fprintf(fid,"%d %d %f\n",j,2,alpha_g_x(j));
endif

  if axi==1,
  fprintf(fid,"%d %d %f\n",j,5,0);
  fprintf(fid,"%d %d %f\n",j,8,0);
  endif

  if flag_1d==1,
  fprintf(fid,"%d %d %f\n",j,3,0);
  fprintf(fid,"%d %d %f\n",j,5,0);
  endif

  if flag_alpha_g_all_fixed==1,
  fprintf(fid,"%d %d %f\n",j,2,alpha_g_in);
  endif

  if axi==1,  idfs=[9,10]; else idfs=[7,8]; endif
  fprintf(fid,"%d %d %f\n",j,idfs(1),k_ini);
  fprintf(fid,"%d %d %f\n",j,idfs(2),eps_ini);
endfor
fclose(fid);

if alpha_g_as_time_function==1 | v_g_as_time_function==1,
## alpha_g as a function of time

if alpha_g_as_time_function==1,
vmin = alpha_g_min;
vmax = alpha_g_max;
fileout = "alpha_g.time.tmp";
compo = 2;
else
vmin = v_g_min;
vmax = v_g_max;
fileout = "v_g.time.tmp";
if axi==1, compo = 7; else compo = 6; endif
endif

fid = fopen("laddle_axi.fixa_nozzle_time.tmp","w");
for k=1:length(nodes_nozzle)
  fprintf(fid,"%d %d %f\n",nodes_nozzle(k),compo,1.0);
endfor
fclose(fid);

th = (0:nstep+1)'*Dt;
N = length(th);
N1 = round(-N/2);
N2 = N1+N-1;
value = (tanh((N1:N2)'/N*4*pi)+1)/2*(vmax-vmin)+vmin;
ux = [th value];
asave(fileout,ux);

endif

## Bcconv

bcconv = [];

nodes=nodes_top;
N=length(nodes);
[bas,ibas]=sort(xnod(nodes,1));
nodes=nodes(ibas);
#bcconv = [bcconv;[ nodes(1:N-1) nodes(2:N)]];
bcconv = [bcconv;[ nodes(2:N) nodes(1:N-1)]];

nodes=nodes_bot;
N=length(nodes);
[bas,ibas]=sort(xnod(nodes,1));
nodes=nodes(ibas);
#bcconv = [bcconv;[ nodes(2:N) nodes(1:N-1) ]];
bcconv = [bcconv;[ nodes(1:N-1) nodes(2:N) ]];

if (flag_axi==1),
bcconv = [bcconv, bcconv(:,[2,1])+numnp];
endif

asave("laddle_axi.bcconv.tmp",bcconv);


if axi==1,  

  ## periodic constrain for axisymmetric computation
## Imposing axisymmetric fields 
uno   = ones(numnp,1);
node1 = numnp+(1:numnp)';
node2 = (1:numnp)';
no2   = [0;0;1];
no1   = rota*no2;

vaux = [];

idfs=[1,2,4,7,9,10]; 
for compo =idfs
  vaux = [vaux ; [uno, node1 , compo*uno , -uno, node2, compo*uno]];
endfor

asave("laddle_axi.axisym_scalar.tmp",vaux);

vaux = [];
vaux  = [ ...
	[uno, node1 ,3*uno , -uno*rota(1,1) , node2 , 3*uno, -uno*rota(1,3) , node2 , 5*uno];
	[uno, node1 ,5*uno , -uno*rota(3,1) , node2 , 3*uno, -uno*rota(3,3) , node2 , 5*uno]];

vaux  = [ vaux ;
	[uno, node1 ,6*uno , -uno*rota(1,1) , node2 , 6*uno, -uno*rota(1,3) , node2 , 8*uno];
	[uno, node1 ,8*uno , -uno*rota(3,1) , node2 , 6*uno, -uno*rota(3,3) , node2 , 8*uno]];

asave("laddle_axi.axisym_vector.tmp",vaux);

elseif flag_1d==1,

    node1 = nodes_wall;
    node2 = nodes_axis;
    uno   = ones(length(node1),1);
    vaux = [];
    idfs=(1:ndof); 
    for compo =idfs
        vaux = [vaux ; [uno, node1 , compo*uno , -uno, node2, compo*uno]];
    endfor

    node1 = nodes_bot;
    node2 = nodes_top;
    uno   = ones(length(node1),1);
    idfs=(1:ndof); 
    for compo =idfs
        vaux = [vaux ; [uno, node1 , compo*uno , -uno, node2, compo*uno]];
    endfor

    asave("laddle_axi.peri_1d.tmp",vaux);

endif

if axi==1,
asave("laddle_axi.nod.tmp",x3d);
asave("laddle_axi.con.tmp",icone3d);
else
asave("laddle_axi.nod.tmp",xnod);
asave("laddle_axi.con.tmp",icone);
endif


