syms alfa rho_l rho_g u_l v_l w_l u_g v_g w_g p kappa epsilon
syms tau q_x q_y q_z delta ul_x vl_x ul_y vl_y p_x p_y
%syms tau_1 tau_2 tau_3
%syms p_xx alfa_xx u_l_xx v_l_xx u_g_xx v_g_xx
%syms p_xy alfa_xy u_l_xy v_l_xy u_g_xy v_g_xy
%syms p_yx alfa_yx u_l_yx v_l_yx u_g_yx v_g_yx
%syms p_yy alfa_yy u_l_yy v_l_yy u_g_yy v_g_yy

ndim =2;
turbu = 0;

if ndim==3,
vel_l=[u_l;v_l;w_l];
vel_g=[u_g;v_g;w_g];
vel_l_T=reshape(vel_l,1,3);
vel_g_T=reshape(vel_g,1,3);
else
vel_l=[u_l;v_l];
vel_g=[u_g;v_g];
vel_l_T=reshape(vel_l,1,2);
vel_g_T=reshape(vel_g,1,2);
end

% alfa es la fraccion de gas
U    = [p;alfa;vel_l;vel_g];

Fa = [ (1-alfa)*rho_l*vel_l_T  ;
          alfa *rho_g*vel_g_T ;
       (1-alfa)*rho_l*vel_l*vel_l_T+(1-alfa)*p*eye(ndim) ;
          alfa *rho_g*vel_g*vel_g_T+   0*alfa *p*eye(ndim) ];

if turbu==1,
    U = [U;kappa;epsilon];
    Fa = [Fa;
   (1-alfa)*rho_l*kappa*vel_l_T ; 
   (1-alfa)*rho_l*epsilon*vel_l_T ];
end

A_1 = jacobian(Fa(:,1),U);
A_2 = jacobian(Fa(:,2),U);
if ndim==3,
    A_3 = jacobian(Fa(:,3),U);
end

if 0,
% correccion por termino alfa*grad[p]
if ndim==2,
   A_1(3,2)=A_1(3,2)-p;
   A_1(5,2)=A_1(5,2)-p;
   A_2(4,2)=A_2(4,2)-p;
   A_2(6,2)=A_2(6,2)-p;
else
   A_1(3,2)=A_1(3,2)-p;
   A_1(6,2)=A_1(6,2)-p;   
   A_2(4,2)=A_2(4,2)-p;
   A_2(7,2)=A_2(7,2)-p;   
   A_3(5,2)=A_3(5,2)-p;
   A_3(8,2)=A_3(8,2)-p;      
end
end

U_liq = U([1,3,4])
Fa_liq=Fa([1,3,4],:)
A_1_liq = jacobian(Fa_liq(:,1),U_liq);
A_2_liq = jacobian(Fa_liq(:,2),U_liq);
if ndim==3, error(' por ahora solo en 2D la parte especifica del liquido '); end
%    A_3_liq = jacobian(Fa_liq(:,3),U_liq);
%end

H = [(1-alfa)*rho_l , alfa*rho_g , (1-alfa)*rho_l*vel_l_T,alfa*rho_g*vel_g_T];

if turbu==1,
   H=[H,(1-alfa)*rho_l*kappa, (1-alfa)*rho_l*epsilon];
end
       
dHdU = jacobian(H,U);

% delta = tau*vel*gradN
P_supg_liq = [0 , tau/rho_l*q_x , tau/rho_l*q_y ;
    0 , delta , 0 ; 0 , 0, delta];

dU_liq_dx = [p_x; ul_x; vl_x];
dU_liq_dy = [p_y; ul_y; vl_y];


return

syms D_b mu_l
v_slip = vel_l-vel_g;
Uslip  = sqrt(sum((v_slip).^2));
Rey    = rho_l*D_b*Uslip/mu_l;
Cd     = 24/Rey;
F_int  = 3/4*mu_l/D_b/D_b*Rey*Cd*alfa*(1-alfa)*v_slip;

dFintdU = simple(jacobian(F_int,U));


return