function [tau,delta,dt] = supg_bubbly_2d(Upg,grad_phi,hele,prop,type_upwind)
%
%  [tau,delta,dt] = supg_bubbly_2d(Upg,grad_phi,dUpg,gamma,Cou,hele,shocap,type_upwind)
%

tol_upw = 1e-08;
tau_factor = 1;

ijob = 'get';
handle_prop_elem;

[N,ndf]   = size(Upg);
pre       = Upg(:,1);
vel_l     = Upg(:,2:3);

velmod  = sqrt(sum(vel_l'.^2))';

if type_upwind==0,
   Pe = 0.5/(visco_l/rho_l)*velmod.*hele ;
   psi = min([ones(1,N);Pe'/3])';
   velmod  = max([velmod';tol_upw*ones(1,N)])';  
   tau   = tau_factor*0.5* hele ./ velmod.*psi;
   delta = tau_factor*velmod.*hele/2;
   dt    =  Cou*hele ./ velmod;   
else   
   error(' Bad type of upwind has been chosen')
end

