syms alfa visco_l visco_g rho_l rho_g u_l v_l w_l u_g v_g w_g p kappa epsilon
syms Re f_Re df_RedRe d_bubble g grad_p dRedU v_slip
syms p_x p_y p_z
syms U_1 U_2 U_3

ndim =2;

if ndim==3,
vel_l=[u_l;v_l;w_l];
vel_g=[u_g;v_g;w_g];
vel_l_T=reshape(vel_l,1,3);
vel_g_T=reshape(vel_g,1,3);
grad_p=[p_x;p_y;p_z];
else
vel_l=[u_l;v_l];
vel_g=[u_g;v_g];
vel_l_T=reshape(vel_l,1,2);
vel_g_T=reshape(vel_g,1,2);
grad_p=[p_x;p_y];
end

% alfa es la fraccion de gas
%U = [alfa;alfa*vel_g];
U = [U_1;U_2;U_3];

%Fa = [    alfa *vel_g_T ;
%          alfa *vel_g*vel_g_T];

Fa = [    U_2 , U_3 ;
    U_2*U_2/U_1 , U_2*U_3/U_1 ; 
    U_3*U_2/U_1 , U_3*U_3/U_1 ];

A_1 = jacobian(Fa(:,1),U);
A_2 = jacobian(Fa(:,2),U);

if ndim==3,
    A_3 = jacobian(Fa(:,3),U);
end

H = [ U_1 ; U_2 ; U_3];       
dHdU = jacobian(H,U);

G = [ 0; alfa*(g-grad_p/rho_g)];

C0_drag     = 3/4*visco_l/d_bubble^2/rho_g;
C_drag      = C0_drag*Re*f_Re;  
tmp1_drag   = f_Re+Re*df_RedRe;
tmp2_drag   = dRedU*tmp1_drag/v_slip;

%F_drag = C_drag*alfa*(vel_l-vel_g);
%dGdU = jacobian(G,U);
%dF_dragdU = jacobian(F_drag,U);
