% 
%  handle_prop_elem
%

if strcmp(ijob,'get')
    
    % get_prop_elem
    
    %%%%%%%%%%%%%% PROPIEDADES DEL MATERIAL 
    
    rho_g   = prop(1);
    visco_g = prop(2);
    gravity = prop(3);
    npg     = prop(4);
    weak_form = prop(5);
    Cou       = prop(6);
    shocap  = prop(7);
    axisim  = prop(8);
    comp_interphase_terms =  prop(9);
    drag_factor = prop(10);
    dt       = prop(13);
    visco_l  = prop(11);
    rho_l    = prop(15);
    d_bubble = prop(16);
    virtual_mass        = prop(17);
    C_vm                = prop(18);
    model_visco_std     = prop(19);
    qpot_drag_model     = prop(20);
    fRe_drag_model      = prop(21);
    tau_factor          = prop(22);
    lumping_drag_forces = prop(23);
    lumping_time_terms  = prop(24);
    PMM_method          = prop(25);
    Advdif_scheme       = prop(26);
    cc                  = prop(27);
    if prop(28)==1
        supg_method='standard';
    elseif prop(28)==2;
        supg_method='finlandes';
    end
    
    mask_matrix = prop(29);
    
    liq_mass_eq_mod = prop(30);
    
    smoothed_alpha_freq = prop(31);
    
    tol_adt_high = prop(32);
    tol_adt_low  = prop(33);
    tol_adt_min  = prop(34);

    automatic_time_control = prop(35);    

    Sato_model_coef = prop(36);  

    ASM_version = prop(37);        
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(ijob,'set'),
    
    %  set_prop_elem
    
    prop(1) =  rho_g  ;
    prop(2) =  visco_g;
    prop(3) =  gravity;
    prop(4) =  npg;
    prop(5)  = weak_form;
    prop(6)  = Cou ;
    prop(7)  = shocap ;
    prop(8)  = axisim ;
    prop(9)  = comp_interphase_terms;
    prop(10) = drag_factor;
    if exist('dt','var')>0,
        prop(13) = dt;      
    end
    prop(11) = visco_l;  
    prop(15) = rho_l;
    prop(16) = d_bubble; 
    prop(17) = virtual_mass;
    prop(18) = C_vm; 
    prop(19) = model_visco_std; 
    prop(20) = qpot_drag_model;
    prop(21) = fRe_drag_model; 
    if exist('tau_factor','var')==0,
        tau_factor = 1;
    end
    prop(22) = tau_factor; 
    prop(23) = lumping_drag_forces;
    prop(24) = lumping_time_terms;
    prop(25) = PMM_method;
    prop(26) = Advdif_scheme;
    prop(27) = cc; 
    if strcmp(supg_method,'standard')==1,
        prop(28) = 1;
    elseif strcmp(supg_method,'finlandes')==1,
        prop(28) = 2;
    end
    
    if exist('mask_matrix','var')==0,
        mask_matrix = 1111;
    end
    prop(29) = mask_matrix;
    
    if exist('liq_mass_eq_mod','var')==0,
        liq_mass_eq_mod  =1;
    end
    prop(30) = liq_mass_eq_mod;
    
    if exist('smoothed_alpha_freq','var')==0,
        smoothed_alpha_freq=1e+15;
    end    
    prop(31) =   smoothed_alpha_freq;

    if exist('tol_adt_high','var')==0,    
        tol_adt_high = 1000;
    end
    
    if exist('tol_adt_low','var')==0,    
        tol_adt_low = -1000;
    end
    
    if exist('tol_adt_min','var')==0,        
        tol_adt_min=-2000;
    end

    prop(32) = tol_adt_high;
    prop(33) = tol_adt_low;
    prop(34) = tol_adt_min;    
    
    if exist('automatic_time_control','var')==0,        
        automatic_time_control = 0;    
    end
    
    prop(35) = automatic_time_control;

    if exist('Sato_model_coef','var')==0,        
        Sato_model_coef = 0;    
    end
    
    prop(36) = Sato_model_coef;

    if exist('ASM_version','var')==0,        
        ASM_version = 0;    
    end
    
    prop(37) = ASM_version;    
    
else
    error(' Bad ijob choice for HANDLE_PROP_ELEM')
end
