% ====================================================================
%
%                           laddle_1d_homo
%
% ====================================================================
read_from_file = 0;
filestate = 'bubbly_1d_homo';

ASM_version = 1 ;
% mask_matrix = [mask_Cp , mask_A , mask_C , mask_D]
mask_matrix = 1111;

tol_adt_high = 3.5;
tol_adt_low  = 2.5;
tol_adt_min  = 1.5;

automatic_time_control = 0;

PMM_method = 0;
Advdif_scheme = 1;
liq_mass_eq_mod = 1;

smoothed_alpha_freq = 500000000000000000;

supg_method = 'finlandes';
supg_method = 'standard';

coupled = 1;
nnwt_outer = 1;
nnwt = 4;

indx_gas = [2];
indx_liq = [1,3,4];

flag_p_all_fixed = 0;
flag_v_l_all_fixed = 0;
flag_v_g_all_fixed = 0;
flag_alpha_g_all_fixed = 0;

shocap                = 1;
weak_form             = 1; 

cc    = 1000000;  % velocidad del sonido para poder regularizar la matriz de masa que es nearly singular
%cc  = 1e+10;
cc    = 1e+5;

Cou   =  1;
npg   =  4;
ndf   =  4;
tol   = 1e-6;

H = 1;                     % Depth of the fluid
R = 0.2;                   % Radius of the container
Nr = 11;                     % Number of elements in r dir
Nz = 41;
Nx = Nr;
Ny = Nz;
rratio = 1;               % Ratio between axis / side element size
zratio = 1;                  % Ratio between axis / side element size

% PHYSICAL DATA
gravity  = -9.8*1;
visco_l  =  0.8e-3;          % liquid phase viscosity
visco_g  =  1.000e-5;        % gas phase viscosity

rho_l    =  1000;
rho_g    =  1;

Sato_model_coef = 0.6;

d_bubble              = 0.04;
comp_interphase_terms = 0;
axisim                = 0;
drag_factor           = 1;
virtual_mass          = 0;
C_vm                  = 0.5;
model_visco_std       = 0;   % [0]  visco_k [1] alpha_k * visco_k  [2]  avg(alpha_k) * visco_k
qpot_drag_model       = 1;   % F_drag propto alpha_l ^ qpot
fRe_drag_model        = 2;   % [0] Laminar model [1] Cd=0.44 [2] turbulent model

lumping_drag_forces   = 0;
lumping_time_terms    = 0;
tau_factor            = 1;

% BOUNDARY CONDITIONS
% es flujo homogeneo por lo tanto los contornos son todos periodicos

% INITIAL VALUES
p_ini       = 0;
alpha_g_in  = 0.01;
alpha_g_ini = 0.01;
vel_l_ini   = [0,0.00];
vel_g_ini   = [0,0.001];
vel_g_in    = [0,0.1]

% ESCALEO
if 1,
if 0,
   visco_l=visco_l/sqrt(rho_l);
   visco_g=visco_g/sqrt(rho_l);
   rho_g=rho_g/sqrt(rho_l);
   rho_l=rho_l/sqrt(rho_l);
   p_ini=p_ini/(rho_l);    
else
   visco_l=visco_l/(rho_l);
   visco_g=visco_g/(rho_l);
   rho_g=rho_g/(rho_l);
   p_ini=p_ini/(rho_l);       
   rho_l=rho_l/(rho_l);   
end
end

% ====================================================================
x        = (0:Nr-1)'/(Nr-1)*R;
%y        = refh([1,6*zratio,8*zratio],Nz)*H;
y        = refh([1,1,1],Nz)*H;

%-------- coordenadas (XNOD)
xnod     =[];
for k=1:Ny,
   xnod=[xnod;[x y(k)*ones(Nx,1)]];
end

%-------- conectividades (ICONE)
icone    =[];
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
ico2= [ (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' (1:Nx-1)'];
for k=1:Ny-1,
   icone=[icone; (k-1)*Nx+ico ];
end

% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end

[numnp,ndm] = size(xnod);
[numel,nen] = size(icone);

xmin = min(xnod);
xmax = max(xnod);

%-------- Solucion inicial (PHI)
if read_from_file==1,
    eval(['load ' filestate]);
    U = phi;
elseif 1,
    uini    = [p_ini,alpha_g_ini,vel_l_ini];
    U       =  ones(numnp,1)*uini;          
    Ampl   = 0.1;
    sigma  = 0.005;      
    xc     = [R/2,H/2];
    z      = sqrt(sum((xnod-ones(numnp,1)*xc)'.^2))';
    U(:,indx_gas(1)) = alpha_g_in+alpha_g_ini*exp(-z.^2/sigma);  
    U(:,indx_liq(1)) = p_ini+rho_l*abs(gravity)*(H-xnod(:,2));       
else
    uini    = [p_ini,alpha_g_ini,vel_l_ini];
    U       =  ones(numnp,1)*uini;          
    U(:,indx_liq(1)) = p_ini+rho_l*abs(gravity)*(H-xnod(:,2));           
end

xmin = min(xnod);
xmax = max(xnod);
tol  = 1e-6;

nodes_bot = find(abs(xnod(:,2)-xmin(2))<tol);
nodes_top = find(abs(xnod(:,2)-xmax(2))<tol);
nodes_wall= find(abs(xnod(:,1)-xmax(1))<tol);
nodes_axis= find(abs(xnod(:,1)-xmin(1))<tol);

%-------- fijaciones (FIXA)
fixa = zeros(numnp,ndf);
forc = zeros(numnp,ndf);
    
% fijamos la presion en algunos nodos
if flag_p_all_fixed==1,
    fixa(:,indx_liq(1))=1;
    forc(:,indx_liq(1))=p_ini;    
    forc(:,indx_liq(1))=p_ini+rho_l*abs(gravity)*(H-xnod(:,2));   
else
    fixa([nodes_top],indx_liq(1))=1;
    forc([nodes_top],indx_liq(1))=p_ini;
end

fixa(nodes_wall,[3,4])=1;
fixa(nodes_axis,[3,4])=1;

fixa(nodes_top,indx_liq(2:3))=1;
fixa(nodes_bot,indx_liq(2:3))=1;

if 1,
% fijamos la void fraction y la velocidad del gas a la entrada
fixa(nodes_bot,indx_gas(1))=1;
forc(nodes_bot,indx_gas(1))=alpha_g_in;
end

if flag_v_l_all_fixed==1,
   fixa(:,indx_liq(2:3))= ones(numnp,2);
   forc(:,indx_liq(2:3))= ones(numnp,1)*vel_l_ini;   
end

if flag_alpha_g_all_fixed==1,
   fixa(:,indx_gas(1))= ones(numnp,1);
   forc(:,indx_gas(1))= U(:,indx_gas(1));   
end

%-------- Propiedades del material
ijob = 'set';
handle_prop_elem;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas y deslizamiento AHORA como linear constraints
lin_con = [];

if 0,
for icompo=[1,2,3,4]
   lin_con = [lin_con ; ... 
         [ones(length(nodes_axis),1) nodes_axis icompo*ones(length(nodes_axis),1) ...
            -ones(length(nodes_wall),1) nodes_wall icompo*ones(length(nodes_wall),1)]];      
end

for icompo=[2]
   lin_con = [lin_con ; ... 
         [ones(length(nodes_top),1) nodes_top icompo*ones(length(nodes_top),1) ...
                -ones(length(nodes_top),1) [99;100] icompo*ones(length(nodes_top),1)]];      
end

if 0,
idfs=[2,5,6];
for icompo = idfs,    
    lin_con = [lin_con ; ...                     
            [    ones(length(nodes_bot),1) nodes_bot icompo*ones(length(nodes_bot),1) ...
                -ones(length(nodes_bot),1) [99;100] icompo*ones(length(nodes_bot),1)];
        [    ones(length(nodes_top),1) nodes_top icompo*ones(length(nodes_top),1) ...             
                -ones(length(nodes_top),1) [ 3;  4] icompo*ones(length(nodes_top),1)]];             
end
end
end

% condicion inicial en primitivas
%-----------------------------------------------

bini   = U;
for k=1:ndf,
   nofree        = find(fixa(:,k)~=0);
   bini(nofree,k)   = forc(nofree,k);
end   

bc_time_flag = 0;
bc_time_t_end = 1e-3;