function [tau_l,tau_g,P_supg_full,delta_l,delta] = comp_eig_bubbly_1d(Up,prop,Cp,Ax,hele_l,hele_g)
% function [tau_l,tau_g,P_supg_l,P_supg_g] = comp_eig_stadtke_1d(Up,prop,Cp,Ax,hele_l,hele_g)
%
%  [tau_l,tau_g,P_supg_l,P_supg_g] = comp_eig_stadtke_1d(Up,prop,Cp,Ax,hele_l,hele_g)
%

%global row col P_supg_full delta_g

tol_upw = 1e-08;
ijob = 'get';
handle_prop_elem;

[N,ndf]  = size(Up);
ndm = (ndf-2)/2;
if ndm~=1, error(' comp_eig_stadtke_1d - only for 1D problems '); end

indx_l = [1,3];
indx_g = [2,4];   

alpha_g     = Up(:,indx_g(1));
vel_g       = Up(:,indx_g(2));
pre         = Up(:,indx_l(1));
vel_l       = Up(:,indx_l(2));
alpha_l     = 1-alpha_g;

ug = vel_g;
ul = vel_l;
cc_g = s_sound_g;
cc_l = s_sound_l;

tau_l = []; tau_g = [];

P_supg_full = zeros(N,ndf,ndf);

if(coupled==1) error(' comp_eig_bubbly_1d is only used with decoupled schemes'); end

% LIQUID
supg_pspg_1d;
% GAS
for k=1:N,
   vaux_Cp=reshape(Cp(k,indx_g,indx_g),2,2);
   vaux_Ax=reshape(Ax(k,indx_g,indx_g),2,2);
   vaux_Cpi = inv(vaux_Cp);
   vaux_B = vaux_Cpi*vaux_Ax;
   [V,D] = eig(vaux_B);
   Dv    = diag(D);
   if isreal(D)==0, keyboard;pause; end
   tau   = diag(hele_l(k)/2*sign(Dv));
   P_supg_full(k,indx_g,indx_g) = V*tau*inv(V)*vaux_Cpi;                            
   delta(k,1)   = hele_l(k)/2*max(abs(diag(D)));         
end   
%   keyboard;pause   

