function [tau_l,tau_g,P_supg_full,delta] = comp_eig_stadtke_1d(Up,prop,Cp,Ax,hele_l,hele_g)
% function [tau_l,tau_g,P_supg_l,P_supg_g] = comp_eig_stadtke_1d(Up,prop,Cp,Ax,hele_l,hele_g)
%
%  [tau_l,tau_g,P_supg_l,P_supg_g] = comp_eig_stadtke_1d(Up,prop,Cp,Ax,hele_l,hele_g)
%

%global row col P_supg_full delta_g

tol = 1e-12;
vel_min = tol;
ijob = 'get';
handle_prop_elem;

[N,ndf]  = size(Up);
ndm = (ndf-2)/2;
if ndm~=1, error(' comp_eig_stadtke_1d - only for 1D problems '); end

indx_l = [1,3];
indx_g = [2,4];   

alpha_g     = Up(:,indx_g(1));
vel_g       = Up(:,indx_g(2));
pre         = Up(:,indx_l(1));
vel_l       = Up(:,indx_l(2));
alpha_l     = 1-alpha_g;

%nn = find(abs(vel_g)<tol); if isempty(nn)==0, vel_g(nn)=vel_min; end
%nn = find(abs(vel_l)<tol); if isempty(nn)==0, vel_l(nn)=vel_min; end

ug = vel_g;
ul = vel_l;
cc_g = s_sound_g;
cc_l = s_sound_l;

if 0,
   Vl(:,1,1) = 1./2.*rho_l./(-rho_g.*cc_g.^2+rho_g.*cc_g.^2.*alpha_g-alpha_g.*rho_l.*cc_l.^2).*(-2.*rho_g.*cc_g.^2.*ul-alpha_g.*rho_l.*cc_l.^2.*ug+2.*rho_g.*cc_g.^2.*ul.*alpha_g-cc_l.^2.*alpha_g.*rho_l.*ul+(rho_l.^2.*cc_l.^4.*alpha_g.^2.*ug.^2-2.*rho_l.^2.*cc_l.^4.*alpha_g.^2.*ug.*ul+rho_l.^2.*cc_l.^4.*alpha_g.^2.*ul.^2-8.*rho_g.^2.*cc_g.^4.*alpha_g.*cc_l.^2+4.*rho_g.^2.*cc_g.^4.*cc_l.^2+4.*rho_g.^2.*cc_g.^4.*alpha_g.^2.*cc_l.^2-4.*alpha_g.^2.*rho_l.*cc_l.^4.*rho_g.*cc_g.^2+4.*alpha_g.*rho_l.*cc_l.^4.*rho_g.*cc_g.^2).^(1./2))-rho_l.*ul;
   
   Vl(:,1,2) = 1./2.*rho_l./(-rho_g.*cc_g.^2+rho_g.*cc_g.^2.*alpha_g-alpha_g.*rho_l.*cc_l.^2).*(-2.*rho_g.*cc_g.^2.*ul-rho_l.*cc_l.^2.*alpha_g.*ug+2.*rho_g.*cc_g.^2.*ul.*alpha_g-rho_l.*cc_l.^2.*alpha_g.*ul-(rho_l.^2.*cc_l.^4.*alpha_g.^2.*ug.^2-2.*rho_l.^2.*cc_l.^4.*alpha_g.^2.*ug.*ul+cc_l.^4.*alpha_g.^2.*rho_l.^2.*ul.^2-8.*rho_g.^2.*cc_g.^4.*alpha_g.*cc_l.^2+4.*rho_g.^2.*cc_g.^4.*cc_l.^2+4.*rho_g.^2.*cc_g.^4.*alpha_g.^2.*cc_l.^2-4.*alpha_g.^2.*rho_l.*cc_l.^4.*rho_g.*cc_g.^2+4.*alpha_g.*rho_l.*cc_l.^4.*rho_g.*cc_g.^2).^(1./2))-rho_l.*ul;
   
   Vl(:,2,1) = 1;
   
   Vl(:,2,2) = 1;
   
   Vl_inv(:,1,1) = (-rho_g.*cc_g.^2+rho_g.*cc_g.^2.*alpha_g-alpha_g.*rho_l.*cc_l.^2)./rho_l./(rho_l.^2.*cc_l.^2.*alpha_g.^2.*ug.^2-2.*rho_l.^2.*cc_l.^2.*alpha_g.^2.*ug.*ul+rho_l.^2.*cc_l.^2.*alpha_g.^2.*ul.^2-8.*rho_g.^2.*cc_g.^4.*alpha_g+4.*rho_g.^2.*cc_g.^4+4.*rho_g.^2.*cc_g.^4.*alpha_g.^2-4.*alpha_g.^2.*rho_l.*cc_l.^2.*rho_g.*cc_g.^2+4.*alpha_g.*rho_l.*cc_l.^2.*rho_g.*cc_g.^2).^(1./2)./cc_l;
   
   Vl_inv(:,1,2) = (1./2.*rho_l.*cc_l.*alpha_g.*ug-1./2.*rho_l.*cc_l.*alpha_g.*ul+1./2.*(rho_l.^2.*cc_l.^2.*alpha_g.^2.*ug.^2-2.*rho_l.^2.*cc_l.^2.*alpha_g.^2.*ug.*ul+cc_l.^2.*alpha_g.^2.*rho_l.^2.*ul.^2-8.*rho_g.^2.*cc_g.^4.*alpha_g+4.*rho_g.^2.*cc_g.^4+4.*rho_g.^2.*cc_g.^4.*alpha_g.^2-4.*alpha_g.^2.*rho_l.*cc_l.^2.*rho_g.*cc_g.^2+4.*alpha_g.*rho_l.*cc_l.^2.*rho_g.*cc_g.^2).^(1./2))./(rho_l.^2.*cc_l.^2.*alpha_g.^2.*ug.^2-2.*rho_l.^2.*cc_l.^2.*alpha_g.^2.*ug.*ul+cc_l.^2.*alpha_g.^2.*rho_l.^2.*ul.^2-8.*rho_g.^2.*cc_g.^4.*alpha_g+4.*rho_g.^2.*cc_g.^4+4.*rho_g.^2.*cc_g.^4.*alpha_g.^2-4.*alpha_g.^2.*rho_l.*cc_l.^2.*rho_g.*cc_g.^2+4.*alpha_g.*rho_l.*cc_l.^2.*rho_g.*cc_g.^2).^(1./2);
   
   Vl_inv(:,2,1) = (rho_g.*cc_g.^2-rho_g.*cc_g.^2.*alpha_g+alpha_g.*rho_l.*cc_l.^2)./rho_l./(rho_l.^2.*cc_l.^2.*alpha_g.^2.*ug.^2-2.*rho_l.^2.*cc_l.^2.*alpha_g.^2.*ug.*ul+rho_l.^2.*cc_l.^2.*alpha_g.^2.*ul.^2-8.*rho_g.^2.*cc_g.^4.*alpha_g+4.*rho_g.^2.*cc_g.^4+4.*rho_g.^2.*cc_g.^4.*alpha_g.^2-4.*alpha_g.^2.*rho_l.*cc_l.^2.*rho_g.*cc_g.^2+4.*alpha_g.*rho_l.*cc_l.^2.*rho_g.*cc_g.^2).^(1./2)./cc_l;
   
   Vl_inv(:,2,2) = (-1./2.*rho_l.*cc_l.*alpha_g.*ug+1./2.*rho_l.*cc_l.*alpha_g.*ul+1./2.*(rho_l.^2.*cc_l.^2.*alpha_g.^2.*ug.^2-2.*rho_l.^2.*cc_l.^2.*alpha_g.^2.*ug.*ul+rho_l.^2.*cc_l.^2.*alpha_g.^2.*ul.^2-8.*rho_g.^2.*cc_g.^4.*alpha_g+4.*rho_g.^2.*cc_g.^4+4.*rho_g.^2.*cc_g.^4.*alpha_g.^2-4.*alpha_g.^2.*rho_l.*cc_l.^2.*rho_g.*cc_g.^2+4.*alpha_g.*rho_l.*cc_l.^2.*rho_g.*cc_g.^2).^(1./2))./(rho_l.^2.*cc_l.^2.*alpha_g.^2.*ug.^2-2.*rho_l.^2.*cc_l.^2.*alpha_g.^2.*ug.*ul+rho_l.^2.*cc_l.^2.*alpha_g.^2.*ul.^2-8.*rho_g.^2.*cc_g.^4.*alpha_g+4.*rho_g.^2.*cc_g.^4+4.*rho_g.^2.*cc_g.^4.*alpha_g.^2-4.*alpha_g.^2.*rho_l.*cc_l.^2.*rho_g.*cc_g.^2+4.*alpha_g.*rho_l.*cc_l.^2.*rho_g.*cc_g.^2).^(1./2);
   
   Dl(:,1,1) = 1./2./(-rho_g.*cc_g.^2+rho_g.*cc_g.^2.*alpha_g-alpha_g.*rho_l.*cc_l.^2).*(-2.*rho_g.*cc_g.^2.*ul-alpha_g.*rho_l.*cc_l.^2.*ug+2.*rho_g.*cc_g.^2.*ul.*alpha_g-cc_l.^2.*alpha_g.*rho_l.*ul+(rho_l.^2.*cc_l.^4.*alpha_g.^2.*ug.^2-2.*rho_l.^2.*cc_l.^4.*alpha_g.^2.*ug.*ul+rho_l.^2.*cc_l.^4.*alpha_g.^2.*ul.^2-8.*rho_g.^2.*cc_g.^4.*alpha_g.*cc_l.^2+4.*rho_g.^2.*cc_g.^4.*cc_l.^2+4.*rho_g.^2.*cc_g.^4.*alpha_g.^2.*cc_l.^2-4.*alpha_g.^2.*rho_l.*cc_l.^4.*rho_g.*cc_g.^2+4.*alpha_g.*rho_l.*cc_l.^4.*rho_g.*cc_g.^2).^(1./2));
   
   Dl(:,2,2) = 1./2./(-rho_g.*cc_g.^2+rho_g.*cc_g.^2.*alpha_g-alpha_g.*rho_l.*cc_l.^2).*(-2.*rho_g.*cc_g.^2.*ul-rho_l.*cc_l.^2.*alpha_g.*ug+2.*rho_g.*cc_g.^2.*ul.*alpha_g-rho_l.*cc_l.^2.*alpha_g.*ul-(rho_l.^2.*cc_l.^4.*alpha_g.^2.*ug.^2-2.*rho_l.^2.*cc_l.^4.*alpha_g.^2.*ug.*ul+cc_l.^4.*alpha_g.^2.*rho_l.^2.*ul.^2-8.*rho_g.^2.*cc_g.^4.*alpha_g.*cc_l.^2+4.*rho_g.^2.*cc_g.^4.*cc_l.^2+4.*rho_g.^2.*cc_g.^4.*alpha_g.^2.*cc_l.^2-4.*alpha_g.^2.*rho_l.*cc_l.^4.*rho_g.*cc_g.^2+4.*alpha_g.*rho_l.*cc_l.^4.*rho_g.*cc_g.^2).^(1./2));
   
   Dg(:,1,1) = ug;
   
   Dg(:,2,2) = (-cc_l.^2.*alpha_g.*rho_l.*ul-cc_g.^2.*rho_g.*ug+cc_g.^2.*rho_g.*ug.*alpha_g)./(-cc_g.^2.*rho_g+cc_g.^2.*rho_g.*alpha_g-alpha_g.*rho_l.*cc_l.^2);
   
   Vg(:,1,1) = -cc_g.^2.*(-1+alpha_g).*rho_g./rho_l./cc_l.^2./(ug-ul);
   
   Vg(:,1,2) = 1;
   
   Vg(:,2,1) = 1;
   
   Vg(:,2,2) = 0;
   
   Vg_inv = zeros(size(Vg));
   
   Vg_inv(:,1,1) = 0;
   
   Vg_inv(:,1,2) = 1;
   
   Vg_inv(:,2,1) = 1;
   
   Vg_inv(:,2,2) = cc_g.^2.*(-1+alpha_g).*rho_g./rho_l./cc_l.^2./(ug-ul);
   
   nn = find(abs(Dl(:,1,1))<tol); if isempty(nn)==0, Dl(nn,1,1)=vel_min; end
   nn = find(abs(Dl(:,2,2))<tol); if isempty(nn)==0, Dl(nn,2,2)=vel_min; end
   
   nn = find(abs(Dg(:,1,1))<tol); if isempty(nn)==0, Dg(nn,1,1)=vel_min; end
   nn = find(abs(Dg(:,2,2))<tol); if isempty(nn)==0, Dg(nn,2,2)=vel_min; end
   
   tmp_1 = zeros(N,2,2);
   tmp_1(:,1,1) = abs(1 ./ Dl(:,1,1));
   tmp_1(:,2,2) = abs(1 ./ Dl(:,2,2));
   tmp_2 = rowprod(Vl,tmp_1,2,2,2);
   tau_l = rowprod(tmp_2,Vl_inv,2,2,2);
   
   tmp_1(:,1,1) = abs(1 ./ Dg(:,1,1));
   tmp_1(:,2,2) = abs(1 ./ Dg(:,2,2));
   tmp_2 = rowprod(Vg,tmp_1,2,2,2);
   tau_g = rowprod(tmp_2,Vg_inv,2,2,2);
   
   tmp = Cp(:,indx_l,indx_l);      
   detCp = tmp(:,1,1).*tmp(:,2,2)-tmp(:,1,2).*tmp(:,2,1);
   Cpi_l(:,1,1) =  tmp(:,2,2)./detCp;
   Cpi_l(:,2,2) =  tmp(:,1,1)./detCp;
   Cpi_l(:,1,2) = -tmp(:,1,2)./detCp;
   Cpi_l(:,2,1) = -tmp(:,2,1)./detCp;      
   tmp=rowprod(tau_l,Cpi_l,2,2,2);
   tmp_l=rowprod(tmp,Ax(:,indx_l,indx_l),2,2,2);
   
   for idf=1:2
      for jdf=1:2,
         P_supg_l(:,idf,jdf) =tmp_l(:,idf,jdf).*hele_l/2;
      end
   end
   
   tmp = Cp(:,indx_g,indx_g);      
   detCp = tmp(:,1,1).*tmp(:,2,2)-tmp(:,1,2).*tmp(:,2,1);
   Cpi_g(:,1,1) =  tmp(:,2,2)./detCp;
   Cpi_g(:,2,2) =  tmp(:,1,1)./detCp;
   Cpi_g(:,1,2) = -tmp(:,1,2)./detCp;
   Cpi_g(:,2,1) = -tmp(:,2,1)./detCp;      
   tmp=rowprod(tau_g,Cpi_g,2,2,2);
   tmp_g=rowprod(tmp,Ax(:,indx_g,indx_g),2,2,2);            
   for idf=1:2
      for jdf=1:2,
         P_supg_g(:,idf,jdf) =tmp_g(:,idf,jdf).*hele_g/2;
      end
   end
   
else
   
   tau_l = [];
   tau_g = [];

%   bfh = [];
   for k=1:N,
      vaux_Cp = reshape(Cp(k,:,:),ndf,ndf);
      vaux_Ax = reshape(Ax(k,:,:),ndf,ndf);
      vaux_Cpi = inv(vaux_Cp);
      vaux_B = vaux_Cpi*vaux_Ax;
      [V,D] = eig(vaux_B);
      Dv    = diag(D);
      if isreal(D)==0, keyboard;pause; end
      %      nn    = find(abs(Dv)<tol); if isempty(nn)==0, Dv(nn)=vel_min; end
      if 0,
         Dv    = diag(1 ./ abs(Dv));         
         tau   = hele_l(k)/2*(V*Dv*inv(V));
         tau   = tau_factor*tau*vaux_Cpi;
         P_supg_full(k,1:ndf,1:ndf) = vaux_Ax*tau;                  
      elseif 0,
         tau   = hele_l(k)/2/max(abs(Dv));
         P_supg_full(k,1:ndf,1:ndf) = vaux_Ax*tau;          
      else
         tau   = diag(hele_l(k)/2*sign(Dv));
%         P_supg_full(k,1:ndf,1:ndf) = vaux_Cp*(V*tau*inv(V))*vaux_Cpi; 
         P_supg_full(k,1:ndf,1:ndf) = V*tau*inv(V)*vaux_Cpi;                            
      end
      delta(k,1)   = hele_l(k)/2*max(abs(diag(D)));         
      
 %     bfh = [bfh;Dv'];
      
   end   
   
%   keyboard;pause   
   %    comp_eig_stadtke_analytic;   
   
end

return

%
%Vl = [ ... 
%[ 1/2*rho_l/(-rho_g*cc_g^2+rho_g*cc_g^2*alpha_g-alpha_g*rho_l*cc_l^2)*(-2*cc_g^2*rho_g*ul-rho_l*cc_l^2*alpha_g*ug+2*cc_g^2*rho_g*ul*alpha_g-cc_l^2*alpha_g*rho_l*ul+(rho_l^2*cc_l^4*alpha_g^2*ug^2-2*rho_l^2*cc_l^4*alpha_g^2*ug*ul+cc_l^4*alpha_g^2*rho_l^2*ul^2-8*rho_g^2*cc_g^4*alpha_g*cc_l^2+4*rho_g^2*cc_g^4*cc_l^2+4*rho_g^2*cc_g^4*alpha_g^2*cc_l^2-4*alpha_g^2*rho_l*cc_l^4*rho_g*cc_g^2+4*alpha_g*rho_l*cc_l^4*rho_g*cc_g^2)^(1/2))-rho_l*ul, 1/2*rho_l/(-rho_g*cc_g^2+rho_g*cc_g^2*alpha_g-alpha_g*rho_l*cc_l^2)*(-2*cc_g^2*rho_g*ul-rho_l*cc_l^2*alpha_g*ug+2*cc_g^2*rho_g*ul*alpha_g-cc_l^2*alpha_g*rho_l*ul-(rho_l^2*cc_l^4*alpha_g^2*ug^2-2*rho_l^2*cc_l^4*alpha_g^2*ug*ul+cc_l^4*alpha_g^2*rho_l^2*ul^2-8*rho_g^2*cc_g^4*alpha_g*cc_l^2+4*rho_g^2*cc_g^4*cc_l^2+4*rho_g^2*cc_g^4*alpha_g^2*cc_l^2-4*alpha_g^2*rho_l*cc_l^4*rho_g*cc_g^2+4*alpha_g*rho_l*cc_l^4*rho_g*cc_g^2)^(1/2))-rho_l*ul]
%[                                                                                                                                                                                                                                                                                                                                                                                                                                                    1,                                                                                                                                                                                                                                                                                                                                                                                                                                                    1]];
% 
% 
%Dl = [... 
%[ 1/2/(-rho_g*cc_g^2+rho_g*cc_g^2*alpha_g-alpha_g*rho_l*cc_l^2)*(-2*cc_g^2*rho_g*ul-rho_l*cc_l^2*alpha_g*ug+2*cc_g^2*rho_g*ul*alpha_g-cc_l^2*alpha_g*rho_l*ul+(rho_l^2*cc_l^4*alpha_g^2*ug^2-2*rho_l^2*cc_l^4*alpha_g^2*ug*ul+cc_l^4*alpha_g^2*rho_l^2*ul^2-8*rho_g^2*cc_g^4*alpha_g*cc_l^2+4*rho_g^2*cc_g^4*cc_l^2+4*rho_g^2*cc_g^4*alpha_g^2*cc_l^2-4*alpha_g^2*rho_l*cc_l^4*rho_g*cc_g^2+4*alpha_g*rho_l*cc_l^4*rho_g*cc_g^2)^(1/2)),                                                                                                                                                                                                                                                                                                                                                                                                                                     0]
%[                                                                                                                                                                                                                                                                                                                                                                                                                                     0, 1/2/(-rho_g*cc_g^2+rho_g*cc_g^2*alpha_g-alpha_g*rho_l*cc_l^2)*(-2*cc_g^2*rho_g*ul-rho_l*cc_l^2*alpha_g*ug+2*cc_g^2*rho_g*ul*alpha_g-cc_l^2*alpha_g*rho_l*ul-(rho_l^2*cc_l^4*alpha_g^2*ug^2-2*rho_l^2*cc_l^4*alpha_g^2*ug*ul+cc_l^4*alpha_g^2*rho_l^2*ul^2-8*rho_g^2*cc_g^4*alpha_g*cc_l^2+4*rho_g^2*cc_g^4*cc_l^2+4*rho_g^2*cc_g^4*alpha_g^2*cc_l^2-4*alpha_g^2*rho_l*cc_l^4*rho_g*cc_g^2+4*alpha_g*rho_l*cc_l^4*rho_g*cc_g^2)^(1/2))] ];
% 
%
%Vl_inv = [ ...
% [ (-rho_g*cc_g^2+rho_g*cc_g^2*alpha_g-alpha_g*rho_l*cc_l^2)/rho_l/(rho_l^2*cc_l^2*alpha_g^2*ug^2-2*rho_l^2*cc_l^2*alpha_g^2*ug*ul+cc_l^2*alpha_g^2*rho_l^2*ul^2-8*rho_g^2*cc_g^4*alpha_g+4*rho_g^2*cc_g^4+4*rho_g^2*cc_g^4*alpha_g^2-4*alpha_g^2*rho_l*cc_l^2*rho_g*cc_g^2+4*alpha_g*rho_l*cc_l^2*rho_g*cc_g^2)^(1/2)/cc_l,  1/2*(rho_l*cc_l*alpha_g*ug-cc_l*alpha_g*rho_l*ul+(rho_l^2*cc_l^2*alpha_g^2*ug^2-2*rho_l^2*cc_l^2*alpha_g^2*ug*ul+cc_l^2*alpha_g^2*rho_l^2*ul^2-8*rho_g^2*cc_g^4*alpha_g+4*rho_g^2*cc_g^4+4*rho_g^2*cc_g^4*alpha_g^2-4*alpha_g^2*rho_l*cc_l^2*rho_g*cc_g^2+4*alpha_g*rho_l*cc_l^2*rho_g*cc_g^2)^(1/2))/(rho_l^2*cc_l^2*alpha_g^2*ug^2-2*rho_l^2*cc_l^2*alpha_g^2*ug*ul+cc_l^2*alpha_g^2*rho_l^2*ul^2-8*rho_g^2*cc_g^4*alpha_g+4*rho_g^2*cc_g^4+4*rho_g^2*cc_g^4*alpha_g^2-4*alpha_g^2*rho_l*cc_l^2*rho_g*cc_g^2+4*alpha_g*rho_l*cc_l^2*rho_g*cc_g^2)^(1/2)]
%[ (rho_g*cc_g^2-rho_g*cc_g^2*alpha_g+alpha_g*rho_l*cc_l^2)/rho_l/(rho_l^2*cc_l^2*alpha_g^2*ug^2-2*rho_l^2*cc_l^2*alpha_g^2*ug*ul+cc_l^2*alpha_g^2*rho_l^2*ul^2-8*rho_g^2*cc_g^4*alpha_g+4*rho_g^2*cc_g^4+4*rho_g^2*cc_g^4*alpha_g^2-4*alpha_g^2*rho_l*cc_l^2*rho_g*cc_g^2+4*alpha_g*rho_l*cc_l^2*rho_g*cc_g^2)^(1/2)/cc_l, 1/2*(-rho_l*cc_l*alpha_g*ug+cc_l*alpha_g*rho_l*ul+(rho_l^2*cc_l^2*alpha_g^2*ug^2-2*rho_l^2*cc_l^2*alpha_g^2*ug*ul+cc_l^2*alpha_g^2*rho_l^2*ul^2-8*rho_g^2*cc_g^4*alpha_g+4*rho_g^2*cc_g^4+4*rho_g^2*cc_g^4*alpha_g^2-4*alpha_g^2*rho_l*cc_l^2*rho_g*cc_g^2+4*alpha_g*rho_l*cc_l^2*rho_g*cc_g^2)^(1/2))/(rho_l^2*cc_l^2*alpha_g^2*ug^2-2*rho_l^2*cc_l^2*alpha_g^2*ug*ul+cc_l^2*alpha_g^2*rho_l^2*ul^2-8*rho_g^2*cc_g^4*alpha_g+4*rho_g^2*cc_g^4+4*rho_g^2*cc_g^4*alpha_g^2-4*alpha_g^2*rho_l*cc_l^2*rho_g*cc_g^2+4*alpha_g*rho_l*cc_l^2*rho_g*cc_g^2)^(1/2)] ];
%
%
%Vg = [... 
%[ -cc_g^2*(-1+alpha_g)*rho_g/rho_l/cc_l^2/(ug-ul),                                               1]
%[                                               1,                                               0]];
% 
% 
%Dg = [ ... 
%[                                                                                                                           ug,                                                                                                                            0]
%[                                                                                                                            0, (-cc_l^2*alpha_g*rho_l*ul-cc_g^2*rho_g*ug+cc_g^2*rho_g*ug*alpha_g)/(-rho_g*cc_g^2+rho_g*cc_g^2*alpha_g-alpha_g*rho_l*cc_l^2)]];
%
%Vg_inv = [ ...
%[                                              0,                                              1]
%[                                              1, cc_g^2*(-1+alpha_g)*rho_g/rho_l/cc_l^2/(ug-ul)]];
%
%

