

ug    = vel_g;
ul    = vel_l;
cc_g  = s_sound_g;
cc_l  = s_sound_l;
v_rel = vel_g - vel_l;

Z1 = -2*(ug+ul);
Ca = rho_g*cc_g^2*alpha_l;
Cb = rho_l*cc_l^2*alpha_g;
deno = Ca+Cb;
factor = flag_interf_pressure*(rho_g+rho_l)*alpha_g.*alpha_l;
vaux = factor.*v_rel(:,1).^2;
Ccg = vaux / rho_g;
Ccl = vaux / rho_l;
Ccg = rho_g*cc_g^2 / rho_g;
Ccl = rho_l*cc_l^2 / rho_l;
Z2 = Ca.*( (ug+ul).^2 +2*ug.*ul - Ccg - cc_l^2) + Cb.*( (ug+ul).^2 +2*ug.*ul - Ccl - cc_g^2);
Z2 = 1 ./ deno .*Z2;
Z3 = Ca.*( ug.*(cc_l^2-ul.^2) + ul.*(Ccg - ug.^2)) + Cb.*( ul.*(cc_g^2-ug.^2) + ug.*(Ccl - ul.^2));
Z3 = 2 ./ deno .*Z3;
Z4 = Ca.*( (cc_l^2-ul.^2).*(Ccg - ug.^2)) + Cb.*( (cc_g^2-ug.^2).*(Ccl - ul.^2));
Z4 = 1 ./ deno .*Z4;

Lambdas = zeros(N,4);
for k=1:N
    CC = [1,Z1(k),Z2(k),Z3(k),Z4(k)];
    lambda = roots(CC); 
    Lambdas(k,:)=lambda';
end