% ====================================================================
%
%                           laddle_1d_homo
%
% ====================================================================
read_from_file = 0;
filestate = 'homo_1d_';

% mask_matrix = [mask_Cp , mask_A , mask_C , mask_D]
mask_matrix = 1111;

tol_adt_high = 3.5;
tol_adt_low  = 2.5;
tol_adt_min  = 1.5;

automatic_time_control = 0;

PMM_method = 1;
Advdif_scheme = 1;
liq_mass_eq_mod = 1;

smoothed_alpha_freq = 0;

stadtke_method = 0;

supg_method = 'finlandes';
supg_method = 'non_standard';
supg_method = 'standard';

artif_compres = 0;
s_sound_g = 300;
s_sound_l = 10000;

%gp_reduced = 2;

coupled    = 0;
nnwt_outer = 1;
nnwt       = 3;
nnwt_liq   = 3;
nnwt_gas   = 3;
nstep_liq  = 1;
nstep_gas  = 1;

flag_p_all_fixed = 0;
flag_v_l_all_fixed = 0;
flag_v_g_all_fixed = 0;
flag_alpha_g_all_fixed = 0;

shocap        = 0;
weak_form     = 0; 
tau_factor    = 1;

Cou   =  1;
npg   =  2;
ndf   =  4;
tol   = 1e-6;

indx_gas = [2,4];
indx_liq = [1,3];

H  = 10;                     % Depth of the fluid
Nx = 101;
xratio = 1;               % Ratio between axis / side element size

axisim                = 0;

% PHYSICAL DATA
gravity  =  9.8*0;
visco_l  =  0.8e-3;          % liquid phase viscosity
visco_g  =  1.000e-5;        % gas phase viscosity

rho_l    =  2;
rho_g    =  1;

Sato_model_coef = 0.6;
Sato_model_coef = 0;

d_bubble              = 0.04;
comp_interphase_terms = 0;
drag_factor           = 1;
virtual_mass          = 0;
C_vm                  = 0.5;
flag_interf_pressure  = 0;

model_visco_std       = 1;   % [0]  visco_k [1] alpha_k * visco_k  [2]  avg(alpha_k) * visco_k
qpot_drag_model       = 1;   % F_drag propto alpha_l ^ qpot
fRe_drag_model        = 0;   % [0] Laminar model [1] Cd=0.44 [2] turbulent model

lumping_drag_forces   = 0;
lumping_time_terms    = 0;

% BOUNDARY CONDITIONS
% es flujo homogeneo por lo tanto los contornos son todos periodicos

% INITIAL VALUES
p_ini       = 0;
alpha_g_in  = 0.2;
alpha_g_ini = 0.2;
vel_l_ini   = [10];
vel_l_in    = [10]
vel_g_ini   = [0.1];
vel_g_in    = [0.1];

% ESCALEO
if 0,
   if 0,
      visco_l=visco_l/sqrt(rho_l);
      visco_g=visco_g/sqrt(rho_l);
      rho_g=rho_g/sqrt(rho_l);
      rho_l=rho_l/sqrt(rho_l);
      p_ini=p_ini/(rho_l);    
   else
      visco_l=visco_l/(rho_l);
      visco_g=visco_g/(rho_l);
      rho_g=rho_g/(rho_l);
      p_ini=p_ini/(rho_l);       
      rho_l=rho_l/(rho_l);   
   end
end

% ====================================================================
x        = (0:Nx-1)'/(Nx-1)*H;
%-------- coordenadas (XNOD)
xnod     = x ;

%-------- conectividades (ICONE)
icone = [ (1:Nx-1)' (2:Nx)' ];

[numnp,ndm] = size(xnod);
[numel,nen] = size(icone);

xmin = min(xnod);
xmax = max(xnod);

%-------- Solucion inicial (PHI)
if read_from_file==1,
   eval(['load ' filestate]);
   U = phi;
elseif 1,
   uini    = [p_ini,alpha_g_ini,vel_l_ini,vel_g_ini];
   U       =  ones(numnp,1)*uini;          
   Ampl   = 0.1;
   sigma  = 0.5;
%   sigma  = 0.1;      
   xc     = H/2;
   z      = xnod(:,1)-xc;
   U(:,indx_gas(1)) = alpha_g_ini*(1+Ampl*exp(-z.^2/sigma));  
%   U(:,indx_liq(1)) = p_ini*(1+Ampl*exp(-z.^2/sigma)); %+rho_l*abs(gravity)*(H-xnod(:,2));       
else
   uini    = [p_ini,alpha_g_ini,vel_l_ini,vel_g_ini];
   U       =  ones(numnp,1)*uini;              
end

xmin = min(xnod);
xmax = max(xnod);
tol  = 1e-6;

nodes_bot = find(abs(xnod(:,1)-xmin(1))<tol);
nodes_top = find(abs(xnod(:,1)-xmax(1))<tol);

%-------- fijaciones (FIXA)
fixa = zeros(numnp,ndf);
forc = zeros(numnp,ndf);

fixa(nodes_top-1,1)=1;
fixa(nodes_bot,1)=1;

if 0,
   % fijacion a la salida
   fixa(nodes_top,indx_liq(1))=1;
   fixa([nodes_top],indx_gas(1))=1;
   forc(nodes_top,indx_liq(1))=p_ini;
   forc(nodes_top,indx_gas(1))=alpha_g_in;
   % a la entrada
   fixa(nodes_bot,indx_liq(2))=1;
   fixa(nodes_bot,indx_gas(1))=1;
   fixa(nodes_bot,indx_gas(2))=1;
   forc(nodes_bot,indx_liq(2))=vel_l_in;
   forc(nodes_bot,indx_gas(1))=alpha_g_in;
   forc(nodes_bot,indx_gas(2))=vel_g_in;
end

if flag_p_all_fixed==1,
   fixa(:,indx_liq(1))=1;
   forc(:,indx_liq(1))=U(:,indx_liq(1));    
end

if flag_v_l_all_fixed==1,
   fixa(:,indx_liq(2))=1;
   forc(:,indx_liq(2))=U(:,indx_liq(2));    
end

if flag_v_g_all_fixed==1,
   fixa(:,indx_gas(2))=1;
   forc(:,indx_gas(2))=U(:,indx_gas(2));
   %    forc(nodes_bot,indx_gas(2))=vel_g_in;        
end

if flag_alpha_g_all_fixed==1,
   fixa(:,indx_gas(1))=1;
   forc(:,indx_gas(1))=U(:,indx_gas(1));    
end

%-------- Propiedades del material
ijob = 'set';
handle_prop_elem;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas y deslizamiento AHORA como linear constraints
lin_con = [];
N = numnp;
for icompo= 1:ndf   
   lin_con = [lin_con ; [1 1 icompo -1 N-1 icompo]];
   lin_con = [lin_con ; [1 N icompo -1 2 icompo]];   
end

if 0,
for icompo= 1:ndf   
   lin_con = [lin_con ; ... 
         [ones(length(nodes_top),1) nodes_top icompo*ones(length(nodes_top),1) ...
            -ones(length(nodes_bot),1) nodes_bot+1 icompo*ones(length(nodes_bot),1)]];         
end

for icompo= 1:ndf   
   lin_con = [lin_con ; ... 
         [ones(length(nodes_bot),1) nodes_bot icompo*ones(length(nodes_bot),1) ...
            -ones(length(nodes_top),1) nodes_top-1 icompo*ones(length(nodes_top),1)]];         
end
end


% condicion inicial en primitivas
%-----------------------------------------------

bini   = U;
for k=1:ndf,
   nofree        = find(fixa(:,k)~=0);
   bini(nofree,k)   = forc(nofree,k);
end   

bc_time_flag = 0;
bc_time_t_end = 1e-3;