%-------------------------------------------------------------------%
% Aplication: TWO PHASE FLOW                                        %
%-------------------------------------------------------------------%
% Rutina:                                                           %
%             newton_loop                                           %
%-------------------------------------------------------------------%
% Descripcion:                                                      %
%             Rutina - Lazo de Newton                               %
%-------------------------------------------------------------------%
% Subrutinas:                                                       %
%             bubbly_2d                                             %
%-------------------------------------------------------------------%


% Contador de Iteraciones
nu       = 0;
% Numero de Iteraciones Maximas
nu_max   = nnwt;

iterflag = nu < nu_max;

res = [];

while iterflag
    
    nu   = nu +1;
    Rg   = 0;               
    dphi = 0;
    
    phi_nu = phi;      
    ijob = 0;
    
    [Kg,Rg] = bubbly_2D(xnod,icone,fixa,forc,teco,lin_con,external_fields,external_fields_old,prop,ifaceb,phi,phiold,'all'); %%%%%%%%%%%%==============================>>>>>>>>>>>>>>>
    
    if coupled==0,
        
        if 0,
            
            if phase_id == 'liq'; 
                indx = indx_liq;
            else
                indx = indx_gas;
            end
            
            dofs = length(indx);
            Rg_p = zeros(dofs*numnp,1);
            for k=1:dofs,
                Rg_p(k:dofs:dofs*numnp,1) = Rg(indx(k):ndf:numnp*ndf); 
                for kk=1:dofs,
                    Kg_p(k:dofs:dofs*numnp,kk:dofs:dofs*numnp) = Kg(indx(k):ndf:numnp*ndf,indx(kk):ndf:numnp*ndf);
                end            
            end
            
            Rg = Rg_p;
            Kg = Kg_p;
            
            ndf_tmp = ndf;
            ndf = dofs;
            
            phi_p = phi(:,indx);
            fixa_p = v2m(fixa,ndf_tmp);
            fixa_p = m2v(fixa_p(:,indx));
            
        else
            
            if phase_id == 'liq'; 
                indx = (1:ndf);
                indx_fixa = indx_gas;
            else
                indx = (1:ndf);
                indx_fixa = indx_liq;                
            end            
            ndf_tmp = ndf;
            fixa_p = v2m(fixa,ndf_tmp);
            fixa_p(:,indx_fixa) = 1;
            fixa_p = m2v(fixa_p);            
            phi_p  = phi;            
            
        end 
        
    else
        indx=(1:ndf);
        ndf_tmp = ndf;
        fixa_p = fixa;        
        phi_p  = phi;
    end        
    
    %disp('newton_loop'); keyboard;pause
    
    [phi_p,Rg]=solver(phi_p,Rg,Kg,fixa_p,prop,prop_solver,ndf);   
    phi(:,indx) = phi_p;
    
    % Analisis de la convergencia
    %------------------------------------------------------------------
    %    dphi = phi-phi_nu;
    
    iterflag = (norm(Rg)>limit) & (nu < nu_max); 
    
    disp(['time ' num2str(itime) ' Iter ' num2str(nu)  ' || R || -----> ' num2str(norm(Rg))   ])

    if nu==1, Rg_outer = [Rg_outer;Rg]; end
    
    res = [res ; norm(Rg)];         
    
    ndf = ndf_tmp;
    
end % iterflag

hc_res = [hc_res; res ];             
