%-------------------------------------------------------------------%
% Aplication: TWO PHASE FLOW                                        %
%-------------------------------------------------------------------%
% Rutina:                                                           %
%             read_data                                             %
%-------------------------------------------------------------------%
% Descripcion:                                                      %
%             Fichero de Datos                                      %
%			1. Defino caso a resolver.                              %
%			2. Defino propiedades del solver por default.           %
%			3. Defino propiedades del solver especificas            %
%-------------------------------------------------------------------%
% Subrutinas:                                                       %
%             water_faucet_1d;                                      %
%-------------------------------------------------------------------%


%-----------------<  Defino "caso" a resolver >---------------------%

caso  = 2;

if caso==0,
   % Square cavity for one phase (alpha_g=0)
   % bubbly_sqcav;
   % Poiseuille flow
   bubbly_poise;
elseif caso==1,
   % Ejemplo Anagbo
   bubbly_laddle_2d;
elseif caso==2,
   % Ejemplo Anagbo pero hecho 1D axial (periodico radial)
   % bubbly_laddle_1d;
   % laddle_1d;
   % bubbly_laddle_1d_homo;
   % bubbly_laddle_1d_homo_2;
   % bubbly_laddle_1d_homo_3;
   % bubbly_laddle_1d_homo_4;
   % Water_faucet;
   % water_faucet_1d;
   homo_1d_beta;
elseif caso==3,
   % Ejemplo back step finlandes
   bubbly_bstep;   
else
   error(' MALA ELECCION DEL CASO A TRATAR')
end

%--------------<  Propiedades del Caso por default >----------------%

limit       = 1e-08;      % Limite
dt          = 0.01 ;      % Paso de tiempo
type_solver = 0;          % Type_solver ------>  [ 0 ]  standard - directo con relajacion (relax)
                          %                      [ 1 ]  line-search
                          %                      [ 2 ]  explicito
                          %                      [ 3 ]  GMRES
relax       = 1;          % Parametro de relajacion fijo para type_solver=0
nu_max      = 1;	      % Numero maximo de iteraciones por paso de tiempo
alfa_min    = 0.01;       % Para linesearch
alpha       = 1;          % Grado de implicitud (1/2 Cranck-Nicholson)
ntime       = 10;          % Numero de pasos de tiempo
nstep       = 1;          % Guarda solucion cada nstep pasos de tiempo
scaling     = 1;          % Scaling equations at solver for better conditioning of the system

if caso==0 | caso==1 | caso==2 | caso==3,
   alpha       = 1;
   dt          = 1e-03 ;
   type_solver = 0;
   relax       = 1;     
   nu_max      = 4;  
   alfa_min    = 0.01;    
   nstep       = 10;     
   nsave       = 10;   
   dtmin       = 1e-4;
   dtmax       = 1e-4;   
end

if caso==2,
    scaling = 1;
    dt      = 0.0001;
    dtmin   = 1e-8;
    dtmax   = 1;
    ntime   = 3;
    nstep   = 1;     
    nsave   = 1;   
    limit   =   1e-12;
    alfa_min    = 0.01;
    nu_max      = 4;
    type_solver = 0;
end

if caso==3,
    scaling = 0;
    dtmin   = 1e-0;
    dtmax   = 1e-0;    
end

prop(12) = limit    ;
prop(13)  = dt    ; % paso de tiempo
prop(14)  = alpha ; % grado de implicitud  

prop_solver = [type_solver,relax,nu_max,alfa_min,alpha,ntime,nstep,scaling];