function [tau_l,tau_g,delta_l,delta_g,dt] = supg_bubbly(Upg,grad_phi,hele_l,hele_g,prop)
%
%    [tau_l,tau_g,delta_l,delta_g,dt] = supg_bubbly(Upg,grad_phi,hele_l,hele_g,prop)
%

tol_upw = 1e-08;

ijob = 'get';
handle_prop_elem;

[N,ndf]     = size(Upg);
ndm = (ndf-2)/2;

if ndm==2,
   indx_l = [1,3,4];
   indx_g = [2,5,6];
else
   indx_l = [1,3];
   indx_g = [2,4];   
end


alpha_g     = Upg(:,indx_g(1));
vel_g       = Upg(:,indx_g(2:ndm+1));
pre         = Upg(:,indx_l(1));
vel_l       = Upg(:,indx_l(2:ndm+1));
alpha_l     = 1-alpha_g;

% LIQUID
rho    = rho_l;
visco  = visco_l;
vel    = vel_l;
hele   = hele_l;

if ndm==2,
   velmod    = sqrt(sum(vel'.^2))';
else
   velmod = abs(vel);
end

velmod    = max([velmod';tol_upw*ones(1,N)])';      
if artif_compres,
   velmod = velmod + s_sound_l;
end

Pe        = 0.5/(visco/rho)*velmod.*hele ;
psi       = min([ones(1,N);Pe'/3])';

tau       = (2*velmod./hele).^2 + 9*(4*(visco/rho) ./(hele).^2).^2;
tau       = 1 ./ sqrt(tau);
delta     = velmod.*hele/2.*psi;   
tau       = tau_factor*tau;
%delta     = tau_factor*delta;

tau_l     = tau;
delta_l   = delta;
dt_l      = Cou*hele_l ./ velmod;      

% GAS
rho    = rho_g;
visco  = visco_g;
vel    = vel_g;
hele   = hele_g;

v_rel       = vel_l - vel_g;
v_slip      = sqrt(sum(v_rel'.^2))';

if ndm==2,
   velmod    = sqrt(sum(vel'.^2))';
else
   velmod = abs(vel);
end

velmod    = max([velmod';tol_upw*ones(1,N)])';      
if artif_compres,
   velmod = velmod + s_sound_g;
end
Pe        = 0.5/(visco/rho)*velmod.*hele ;
psi       = min([ones(1,N);Pe'/3])';

tau       = (2*velmod./hele).^2 + 9*(4*(visco/rho)./(hele).^2).^2;
tau       = 1 ./ sqrt(tau);
if strcmp(supg_method,'finlandes')==1,
   %    delta = abs(alpha_g).*hele;
   delta     = velmod.*hele/2.*psi;   
else
   if 0,
      delta     = velmod.*hele/2.*psi;   
   else   
      delta     = v_slip.*hele/2;
   end
end

tau       = tau_factor*tau;
%delta     = tau_factor*delta;

tau_g     = tau;
delta_g   = delta;
dt_g      = Cou*hele_g ./ velmod;      

dt = min(min([dt_l';dt_g'])');

% disp('supg_bubbly_2d'); keyboard;pause