function [Kg,Rg] = bubbly_2D(xnod,icone,fixa,forc,teco,lin_con,extra_nodal_fields,...
   extra_nodal_fields_old,prop,ifaceb,Up,Upold,Id_phase) 
%------------------------------------------------------------------
%
%  TWO PHASE FLOW APPLICATIONS
%
%  only for the gas phase, the liquid is fixed to a prescribed pressure and
%  velocity field
%
%  state vector = [alpha_g ; vel_g ]
%
%------------------------------------------------------------------

global row col

if nargin < 12, error('phase Id is not input '); end

ijob = 'get';
handle_prop_elem;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

U    = Up;
Uold = Upold;

[numel,nen]   = size(icone);
[numnp,ndf]   = size(U);
if ndf~=6, error(' NDF debe ser 6 ( Bubbly in 2D ) ');end
ndm = 2;

if ndm==1,
   pgauss1d;
elseif ndm==2, 
   pgauss2d; 
elseif ndm==3,
   pgauss3d; 
end

Rele = zeros(numel,nen,ndf);
Mele = zeros(numel,nen,ndf,nen,ndf);

Rg    = 0*forc;
eles  = (1:numel)';
ceros = zeros(length(eles),nen);

if length(eles)>0,    
   if strcmp(Id_phase,'all')==1
      bubbly_2d_ele;
   else
      error(' Bad Id phase was chosen ')
   end   
end

% Gather contributions from eles to nodes
%------------------------------------------------------------------
[Rg,Kg] = gather(Rele,Mele,icone,nen,ndf);

% Linear restrictions
%------------------------------------------------------------------
if isempty(lin_con)==0,
    [Rg,Kg] = linear_constraint(Rg,Kg,lin_con,ndf);
end

