%
%   COMPUTE SUPG : Calcula tau y P_supg
%

P_supg = zeros(ne,ndf,ndf);                                   
    
switch method
case {'standard'}
case{'alpha_constrain'}
otherwise
    error('Unknown method')
end



if 0,        
    
    tmp_x=rowprod(Ax,tau,ndf,ndf,ndf);
    tmp_y=rowprod(Ay,tau,ndf,ndf,ndf);                        
    for idf=1:ndf
        for jdf=1:ndf
            tmp_x(:,idf,jdf)=tmp_x(:,idf,jdf).*dshapex(:,inod,1);
            tmp_y(:,idf,jdf)=tmp_y(:,idf,jdf).*dshapex(:,inod,2);                    
        end
    end
    P_supg = tmp_x+tmp_y;
    
    %    disp('BUBBLY_2D_ELE');keyboard;pause    
    
elseif 0,
    
    % LIQUID
    tmp = tau_l.*(velpg_l(:,1).*dshapex(:,inod,1)+velpg_l(:,2).*dshapex(:,inod,2));
    for idm=1:ndm,
        P_supg(:,indx_l(idm+1),indx_l(idm+1)) = tmp;
    end
    P_supg(:,indx_l(1),indx_l(2)) = tau_l/rho_l.*dshapex(:,inod,1);
    P_supg(:,indx_l(1),indx_l(3)) = tau_l/rho_l.*dshapex(:,inod,2);        
    if (shocap>0),
        P_supg(:,indx_l(2),indx_l(1)) = rho_l*delta_l.*dshapex(:,inod,1);
        P_supg(:,indx_l(3),indx_l(1)) = rho_l*delta_l.*dshapex(:,inod,2);
    end      
    
    % GAS
    tmp = tau_g.*(velpg_g(:,1).*dshapex(:,inod,1)+velpg_g(:,2).*dshapex(:,inod,2));
    for idm=1:3,
        P_supg(:,indx_g(idm),indx_g(idm)) = tmp;
    end
    
elseif 1,
    
    tau_pspg_factor = 1;
    % LIQUID
    tau = reshape(tau_l(:,indx_l(1),indx_l(1)),ne,1);
    tmp = tau.*(velpg_l(:,1).*dshapex(:,inod,1)+velpg_l(:,2).*dshapex(:,inod,2));
    for idm=1:ndm,
        P_supg(:,indx_l(idm+1),indx_l(idm+1)) = tmp;
    end
    P_supg(:,indx_l(1),indx_l(2)) = tau_pspg_factor*tau/rho_l.*dshapex(:,inod,1);
    P_supg(:,indx_l(1),indx_l(3)) = tau_pspg_factor*tau/rho_l.*dshapex(:,inod,2);        
    if (shocap>0),
        P_supg(:,indx_l(2),indx_l(1)) = rho_l*delta_l.*dshapex(:,inod,1);
        P_supg(:,indx_l(3),indx_l(1)) = rho_l*delta_l.*dshapex(:,inod,2);
    end      
    
    % GAS   
    if 0,
        tau = tau_g(:,indx_g,indx_g);
        Axx = Ax(:,indx_g,indx_g);
        Ayy = Ay(:,indx_g,indx_g);
        tmp_x=rowprod(Axx,tau,3,3,3);
        tmp_y=rowprod(Ayy,tau,3,3,3);                        
        for idf=1:3
            for jdf=1:3
                tmp_x(:,idf,jdf)=tmp_x(:,idf,jdf).*dshapex(:,inod,1);
                tmp_y(:,idf,jdf)=tmp_y(:,idf,jdf).*dshapex(:,inod,2);                    
            end
        end
        P_supg(:,indx_g,indx_g) = tmp_x+tmp_y;
    else
        
        tau = reshape(tau_g(:,indx_g(1),indx_g(1)),ne,1);
        tmp = tau.*(velpg_g(:,1).*dshapex(:,inod,1)+velpg_g(:,2).*dshapex(:,inod,2));
        for idm=1:3,
            P_supg(:,indx_g(idm),indx_g(idm)) = tmp;
        end
        P_supg(:,indx_g(1),indx_g(2)) = tau_pspg_factor*tau/rho_g.*dshapex(:,inod,1);
        P_supg(:,indx_g(1),indx_g(3)) = tau_pspg_factor*tau/rho_g.*dshapex(:,inod,2);        
        if (shocap>0&0),
            P_supg(:,indx_g(2),indx_g(1)) = rho_g*delta_g.*dshapex(:,inod,1);
            P_supg(:,indx_g(3),indx_g(1)) = rho_g*delta_g.*dshapex(:,inod,2);
        end      
               
    end

elseif 0,

    alpha_g = Upg(:,indx_g(1));
    tau_pspg_factor = 1;
    % LIQUID
    tau = reshape(tau_l(:,indx_l(1),indx_l(1)),ne,1);
    for idm=1:2,
        lambda(:,idm) = (rho_g*(1-alpha_g).*beta.*velpg_g(:,idm)+alpha_g*rho_l.*velpg_l(:,idm)) ./ ...
            (rho_g*beta.*(1-alpha_g)+alpha_g*rho_l);
    end

    tmp = tau.*(lambda(:,1).*dshapex(:,inod,1)+lambda(:,2).*dshapex(:,inod,2));
    for idm=1:ndm,
        P_supg(:,indx_l(idm+1),indx_l(idm+1)) = tmp;
    end
    P_supg(:,indx_l(1),indx_l(2)) = tau_pspg_factor*tau/rho_l.*dshapex(:,inod,1);
    P_supg(:,indx_l(1),indx_l(3)) = tau_pspg_factor*tau/rho_l.*dshapex(:,inod,2);        
    if (shocap>0),
        P_supg(:,indx_l(2),indx_l(1)) = rho_l*delta_l.*dshapex(:,inod,1);
        P_supg(:,indx_l(3),indx_l(1)) = rho_l*delta_l.*dshapex(:,inod,2);
    end      

    % GAS
    for idm=1:3,
        P_supg(:,indx_g(idm),indx_g(idm)) = tmp;
    end    
else

    % GAS   
    tau = tau_g;
    Axx = Ax;
    Ayy = Ay;
    tmp_x=rowprod(Axx,tau,ndf,ndf,ndf);
    tmp_y=rowprod(Ayy,tau,ndf,ndf,ndf);                        
    for idf=1:ndf
        for jdf=1:ndf
            tmp_x(:,idf,jdf)=tmp_x(:,idf,jdf).*dshapex(:,inod,1);
            tmp_y(:,idf,jdf)=tmp_y(:,idf,jdf).*dshapex(:,inod,2);                    
        end
    end
    P_supg(:,1:ndf,1:ndf) = tmp_x+tmp_y;
    
    % LIQUID
    tau_pspg_factor = 1;    
    tau = reshape(tau_l(:,indx_l(1),indx_l(1)),ne,1);
    P_supg(:,indx_l(1),indx_l(2)) = P_supg(:,indx_l(1),indx_l(2))+tau_pspg_factor*tau/rho_l.*dshapex(:,inod,1);
    P_supg(:,indx_l(1),indx_l(3)) = P_supg(:,indx_l(1),indx_l(3))+tau_pspg_factor*tau/rho_l.*dshapex(:,inod,2);        
    
end

%disp('compute P supg ');keyboard;pause       