function [xnew,iconew,state_new] = refine(xnod,icone,state,dir)
%
%  refinamos una corrida en un sector de una malla cuasi 1D
%
%  [xnew,iconew,state_new] = refine(xnod,icone,state,dir)
%
%  

if nargin<4, dir = ''; end

xref_min = 2;
xref_max = 4;

% marcamos los elementos cuyos centroides caen en el intervalo
[numnp,ndm] = size(xnod);
[numel,nen] = size(icone);

xc = zeros(numel,ndm);
for k=1:nen,
    nodes = icone(:,k)';
    xc = xc+(1/nen)*xnod(nodes,:);
end

mask = (xc(:,2)<xref_max)&(xc(:,2)>xref_min);
ne = find(mask==1);

%nodes = rmdblist(m2v(icone(ne,:)));
%figure(1);clf;pltmsh(xnod,icone),axis equal;hold on;plot(xnod(nodes,1),xnod(nodes,2),'ro');


% creamos dos nodos en la mitad de cada elemento
xnew=[]; iconew=[]; statenew=[]; nlast=numnp;
for k=1:length(ne),
    iele=ne(k);
    nodes = icone(iele,:);    
    if strcmp(dir,'12')
        xhalf1 = 0.5*(xnod(nodes(1),:)+xnod(nodes(2),:)); n1=nlast+1;
        xhalf2 = 0.5*(xnod(nodes(3),:)+xnod(nodes(4),:)); n2=nlast+2;       
        xnew = [xnew;[ xhalf1;xhalf2;] ];
        iconew = [iconew; [nodes(1) , n1 , n2 , nodes(4)];[n1 nodes(2) nodes(3) n2]];        
        state1 = 0.5*(state(nodes(1),:)+state(nodes(2),:)); 
        state2 = 0.5*(state(nodes(3),:)+state(nodes(4),:));  
        statenew = [statenew;[ state1; state2] ];         
        nlast = nlast+2;
    elseif strcmp(dir,'14')
        xhalf1 = 0.5*(xnod(nodes(1),:)+xnod(nodes(4),:)); n1=nlast+1; 
        xhalf2 = 0.5*(xnod(nodes(2),:)+xnod(nodes(3),:)); n2=nlast+2; 
        xnew = [xnew;[ xhalf1; xhalf2] ];        
        iconew = [iconew; [nodes(1) , nodes(2), n2 , n1 ];[n1 n2 nodes(3) nodes(4)]];                
        state1 = 0.5*(state(nodes(1),:)+state(nodes(4),:)); 
        state2 = 0.5*(state(nodes(2),:)+state(nodes(3),:));          
        statenew = [statenew;[ state1; state2] ]; 
        nlast = nlast+2;        
    else
        error(' Only valid for dir=12 or dir=14 ')
    end    
end
       
icone(ne,:)=[];
        
%plot(xnew(:,1),xnew(:,2),'g.');
xnew = [xnod;xnew];
iconew= [icone;iconew];
state_new=[state;statenew];
%figure(2);clf;pltmsh(xnew,iconew);
