function [tau,delta] = supg_bubbly_2d_bis(Upg,grad_phi,hele_l,hele_g,prop,Cp,Ax,Ay,Cpi)
%
%    [tau_l,tau_g,delta_l,delta_g,dt] = supg_bubbly_2d(Upg,grad_phi,hele_l,hele_g,prop,Cp,Ax,Ay)
%

tol_upw = 1e-08;

ijob = 'get';
handle_prop_elem;

indx_l = [1,3,4];
indx_g = [2,5,6];

[N,ndf]     = size(Upg);
alpha_g     = Upg(:,indx_g(1));
vel_g       = Upg(:,indx_g(2:3));
pre         = Upg(:,indx_l(1));
vel_l       = Upg(:,indx_l(2:3));
alpha_l     = 1-alpha_g;
hele        = sqrt(hele_l.*hele_g);

sdir = vel_g-vel_l; sdir = sdir ./(sqrt(dot(sdir',sdir')')*[1,1]); 
[nnod,ndf] = size(Upg);
for kk=1:nnod,

    if 0,
        vaux_Cp = reshape(Cp(kk,:,:),ndf,ndf);
        vaux_Cp(indx_g(1),indx_l(1)) = vaux_Cp(indx_g(1),indx_l(1)) + alpha_g(kk) /cc^2;
        vaux_Cp(indx_l(1),indx_l(1)) = vaux_Cp(indx_l(1),indx_l(1)) + (1-alpha_g(kk)) /cc^2;
        vaux_Cp = inv(vaux_Cp);
    else
        vaux_Cp = reshape(Cpi(kk,:,:),ndf,ndf);
    end

    vaux_Ax = vaux_Cp*reshape(Ax(kk,:,:),ndf,ndf);
    vaux_Ay = vaux_Cp*reshape(Ay(kk,:,:),ndf,ndf);    

    if 1,
        vaux    = (vaux_Ax*vaux_Ax+vaux_Ay*vaux_Ay);
    else
        vaux    = vaux_Ax*abs(sdir(kk,1))+vaux_Ay*abs(sdir(kk,2));
    end    
    
        %    disp('SUPG BUBBLY 2D BIS ');keyboard;pause

    tau_t   = (hele(kk)/2*ones(ndf,ndf)).*(inv(sqrtm(vaux))*vaux_Cp);    
    tau(kk,1:ndf,1:ndf) = tau_t;
    
    delta(kk) = max(diag(tau_t));
end
