%------------------------------------------------------------------
%     APLICATION  :  TWO PHASE FLOW
%------------------------------------------------------------------

if(exist('inicia')==0),
    disp('Ingrese la variable inicia ')
    disp(' inicia == 0 ---> si continua una corrida previa ')
    disp(' inicia ~= 0 ---> si comienza una corrida nueva ')
    inicia = input(' Inicia = ')
end

%------ Ingreso de datos -------------------------------------------

if inicia,
    read_data;
    bfh=[];          % Guarda la solucion
    hc_res=[];       % Guarda la historia de la convergencia en residuo
    hc_du=[];        % Guarda la historia de la convergencia en dphi
    bfh_nc = [];     % Guarda los pasos de tiempo en que no hubo convergencia
    bfh_u=[];        % Guarda la solucion cada nstep pasos de tiempo
    posdat;
    ttime = 0;
    restart_time = 0;
end

%------ fin ingreso de datos --------------------------------------

limit = prop(12);
[numnp,ndf] = size(phi);

external_fields = [];
external_fields_old = [];

if nstep_liq==0, nstep_liq=1; end
if nstep_gas==0, nstep_gas=1; end

% Loop temporal o pseudotemporal
%------------------------------------------------------------------
restart_time = 0;
itime = 0;
time_step_flag = 1;
%for itime=1:ntime,
while time_step_flag==1,
    
    disp(['dt = ' num2str(dt)])    
    if restart_time ==1,
        phi = phiold;
        
    else
        phiold = phi;
        if 0,
            if exist('dtmin')&exist('dtmax'),
                dt = dtmin+(dtmax-dtmin)*itime/ntime;
                prop(13)=dt;
                disp(['dt = ' num2str(dt)])
            end  
        end
    end
    
    % Actualiza las condiciones de contorno si fueran funcion del tiempo
    % La funcionalidad se lee del archivo "bc_time"
    if exist('bc_time_flag')==1,
        if (bc_time_flag==1)&(exist('bc_time')~=2), 
            disp('Debe tener en el directorio de trabajo un archivo de nombre bc_time.m ');
            error(' bc_time_flag==1 y bc_time file no existe '); 
        end
        if bc_time_flag==1, bc_time; end
    end
    
    nu_outer     = 0;
    nu_outer_max = nnwt_outer;
    iterflag_outer = nu_outer < nu_outer_max;
    
    while iterflag_outer    
        nu_outer = nu_outer +1;
        Rg_outer = [];
        
        if coupled==0,
            
            k=0; Rg_norm = 1e10;
            while(k<nstep_gas & Rg_norm>limit)
                dt_liq = dt/nstep_liq;
                prop(13) = dt_liq;
                phase_id = 'liq';
                if(exist('nnwt_liq','var')==1), nnwt = nnwt_liq; end
                newton_loop;
                Rg_norm = norm(Rg);                 
            end
            
            k=0; Rg_norm = 1e10;
            while(k<nstep_gas & Rg_norm>limit)
                k = k+1;
                dt_gas = dt/nstep_gas;
                prop(13) = dt_gas;                
                phase_id = 'gas';
                if(exist('nnwt_gas','var')==1), nnwt = nnwt_gas; end
                newton_loop;
                Rg_norm = norm(Rg); 
            end
            
        else
            newton_loop;        
        end
        
        iterflag_outer = (norm(Rg_outer)>limit) & (nu_outer < nu_outer_max);         
        %        iterflag_outer = (nu_outer < nu_outer_max);               
        disp(['time ' num2str(itime) ' Iter ' num2str(nu)  ' || R || (outer) -----------------> ' num2str(norm(Rg_outer))   ])
        
    end
    
    restart_time=0;            
    if automatic_time_control,
        if log10(res(1)/res(end))>tol_adt_high, 
            dt = min([2*dt,dtmax]);
        elseif (log10(res(1)/res(end))<=tol_adt_high)&(log10(res(1)/res(end))>=tol_adt_min),             
            dt = dt;
        elseif (log10(res(1)/res(end))<tol_adt_low)&(log10(res(1)/res(end))>tol_adt_min), 
            dt = max([dt/2,dtmin]);            
        else
            restart_time=1;    
            dt = max([dt/3,dtmin]);
        end
        if dt<1.00001*dtmin, error(' DT too small '); end
        ijob='set';
        handle_prop_elem;
    end
    
%    if (rem(itime,smoothed_alpha_freq)==0 & restart_time==0 )
    if (rem(itime,smoothed_alpha_freq)==0)      
        drv_smoothed_alpha;
    end
    % Salida grafica de resultados (provista por cada aplicacion)
    %------------------------------------------------------------------
    
    if restart_time==0,
        itime = itime+1;
        ttime = ttime+dt;        
        
        plot_fem
        
        if norm(Rg)>limit ,
            %  error(' NO CONVERGENCE ');
            bfh_nc = [bfh_nc ; itime];
        end
        
        if exist('nsave')==0; nsave=ntime;end
        
        if exist('filesave')==0; filesave='tempo'; end
        
        if exist('filestate')==0; filestate='last_state'; end
        
        if rem(itime,nsave)==0, 
            eval(['save ' filesave ';']);
            eval(['save ' filestate 'phi ' ';']);
        end
        
        if rem(itime,nstep)==0,
            bfh_u = [bfh_u , phi];
        end
    end

    time_step_flag = ~((itime>=ntime)&(restart_time==0));
    
end % itime loop

