
H = 12;                     % Depth of the fluid
R = 0.1;                   % Radius of the container
Nr = 2;                     % Number of elements in r dir
Nz = 51;
Nx = Nr;
Ny = Nz;
rratio = 1;               % Ratio between axis / side element size
zratio = 1;                  % Ratio between axis / side element size

% ====================================================================
x        = (0:Nr-1)'/(Nr-1)*R;
%y        = refh([1,6*zratio,8*zratio],Nz)*H;
y        = refh([1,1,1],Nz)*H;

%-------- coordenadas (XNOD)
xnod     =[];
for k=1:Ny,
   xnod=[xnod;[x y(k)*ones(Nx,1)]];
end

%-------- conectividades (ICONE)
icone    =[];
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
ico2= [ (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' (1:Nx-1)'];
for k=1:Ny-1,
   icone=[icone; (k-1)*Nx+ico ];
end

% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end

[numnp,ndm] = size(xnod);
[numel,nen] = size(icone);

ndf = 1;
xmax = max(xnod);
xmin = min(xnod);
tol = 1e-6;

%-------- fijaciones (FIXA)
[ifaceb,nodes_bou]=pfbou2d(xnod,icone,1);

xmin = min(xnod);
xmax = max(xnod);
tol  = 1e-6;

nodes_bot = find(abs(xnod(:,2)-xmin(2))<tol);
nodes_top = find(abs(xnod(:,2)-xmax(2))<tol);
nodes_rig = find(abs(xnod(:,1)-xmax(1))<tol);
nodes_lef = find(abs(xnod(:,1)-xmin(1))<tol);

fixa = zeros(numnp,ndf);
forc = zeros(numnp,ndf);
if 0,
   fixa(nodes,1) = 1;
   forc(nodes,1) = value;
else
   fixa(nodes_top,1)=1;
   fixa(nodes_bot,1)=1;    
end

%-------- Fuentes de volumen (por elemento)
source = zeros(numel,1);
%--------- Termino reactivo -----------------------------
reac   = zeros(numel,1);

%--------- Campo de Velocidad -----------------------------
veloc  =  0*[zeros(numnp,1) ones(numnp,1)];

%-------- Propiedades del material
rho     = 1  ;
Cp      = 1  ;
kappa   = 0.1  ;
npg     =  2   ;
prop(1) =rho   ;
prop(2) =Cp    ;
prop(3) =kappa ;
prop(4) =npg   ;

upwind  =    0 ;
shocap  =    0 ;
axisim  =    0 ;
% [1] SUPG
% [2] (SU+C)PG
type_upw =    1;   
lumped   =   0 ;
weak_form =  0 ;

prop(6)  = upwind ;
prop(7)  = shocap ;
prop(8)  = axisim ;
prop(9)  = type_upw;
prop(11) = lumped ;
prop(16) = weak_form;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas
peri = [];
lin_con = [];

ther_contact=[];
%-------- Solucion inicial (PHI)
bini = zeros(numnp,ndf);

for k=1:ndf,
    nofree        = find(fixa(:,k)~=0);
    bini(nofree,k)   = forc(nofree,k);
end
