%
%    VERSION DEL FINLANDES
%

ne  = length(eles);
[bas,ndf_fields] = size(extra_nodal_fields);

% Localizacion de las variables
%------------------------------------------------------------------

    ceros = zeros(ne,nen*ndf);
       Ue = ceros;
      U0e = ceros;
	    re = zeros(ne,nen);
     Uf_e = zeros(ne,nen*ndf_fields);
   Uenorm = zeros(ne,nen);
for inod=1:nen,
            nodes  = icone(eles,inod);
            jnod  = (inod-1)*ndf+(1:ndf);
            knod  = (inod-1)*ndf_fields+(1:ndf_fields);            
       Ue(:,jnod)  = U(nodes,1:ndf);		 
       U0e(:,jnod) = Uold(nodes,1:ndf);   
       re(:,inod)  = xnod(nodes,1);		        
       Uf_e(:,knod)  = extra_nodal_fields(nodes,1:ndf_fields);       
       Uenorm(:,inod) = sqrt(sum(Uold(nodes,1:ndf)'.^2)');
end

Vol = zeros(ne,nen);

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------
 for ipg=1:npg
  
  [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
  [dshapex,N] = shape2d(X2S,psipg(ipg),etapg(ipg),nen); 

% Interpolacion en punto de Gauss
%------------------------------------------------------------------

     Upg    = zeros(ne,ndf);
    U0pg    = zeros(ne,ndf);
    dUpg    = zeros(ne,ndf,ndm);
   radpg    = zeros(ne,1);
   grad_p   = zeros(ne,ndm);
   vel_l    = zeros(ne,ndm);
 grad_Unorm = zeros(ne,ndm);

  for inod=1:nen,
     jnod = (inod-1)*ndf+(1:ndf);
      Upg(:,(1:ndf))  =  Upg(:,(1:ndf)) + N(inod).*  Ue(:,jnod);
      U0pg(:,(1:ndf)) = U0pg(:,(1:ndf)) + N(inod).* U0e(:,jnod);
      radpg(:,1)      =      radpg(:,1) + N(inod).* re(:,inod);
      
      dUpg(:,(1:ndf),1)   = dUpg(:,(1:ndf),1) + ...
	          (dshapex(:,inod,1)*ones(1,ndf)).* Ue(:,jnod);
          
      dUpg(:,(1:ndf),2) = dUpg(:,(1:ndf),2)+ ...
	          (dshapex(:,inod,2)*ones(1,ndf)).* Ue(:,jnod);          
      grad_p(:,1)  = grad_p(:,1) + dshapex(:,inod,1).* Uf_e(:,(inod-1)*ndf_fields+1);
      grad_p(:,2)  = grad_p(:,2) + dshapex(:,inod,2).* Uf_e(:,(inod-1)*ndf_fields+1);          
      vel_l(:,1)   = vel_l (:,1) + N(inod).* Uf_e(:,(inod-1)*ndf_fields+2);
      vel_l(:,2)   = vel_l (:,2) + N(inod).* Uf_e(:,(inod-1)*ndf_fields+3);      

      grad_Unorm(:,1) = grad_Unorm(:,1) + dshapex(:,inod,1).* Uenorm(:,inod);  
      grad_Unorm(:,2) = grad_Unorm(:,2) + dshapex(:,inod,2).* Uenorm(:,inod);
      
  end

  alpha_g  = Upg(:,1);
  velpg     = Upg(:,2:3);
  hele      = comp_hele(velpg,dshapex,Jaco,nen);
  div_vg_0  = dUpg(:,2,1)+dUpg(:,3,2);
  velmod    = sqrt(sum(velpg'.^2))';
  
mk   = 1/3;
Re   = rho_g*velmod.*hele/visco_g;
Re_K = 1/4*mk*Re.*hele.*velmod;
psi  = min([Re_K';ones(1,ne)])';
tau  = 0.5*hele./velmod.*psi;

  [H,Cp]     =  enthalpy_function(Upg,prop);
  [H0,bas]   =  enthalpy_function(U0pg,prop);
  
  % advective flux function  
  [Fa,Ax,Ay] = Flux_function(Upg,prop);

  % reactive and source terms due to:
  % .- pressure gradient 
  % .- bouyancy forces
  % .- phase interactions drag  
    
  %disp('Bubbly_2d_ele');keyboard;pause

  job = 0;
  [Fc_1,C_1] = Cflux(Upg,grad_p,vel_l,prop,job);
  
  % Upg y dUpg deben tener como 2da y 3ra componentes a la velocidad   
  [Fd,Kxx,Kxy,Kyx,Kyy]  = Dflux(Upg,dUpg,prop);  
  
  % Correccion axisimetrica del jacobiano de la transformacion al elemento master
  %------------------------------------------------------------------
  xsj =  wpg(ipg) .* Jaco;
  if axisim,
     xsj = xsj.*radpg;
  end

%  disp('bubbly_2d_ele');keyboard;pause  
  AgU = rowprod(Ax,dUpg(:,1:ndf,1),ndf,ndf,1) + ... 
        rowprod(Ay,dUpg(:,1:ndf,2),ndf,ndf,1);
    
  % P_i Petrov-Galerkin perturbation weight function
  for inod=1:nen,   
     
     % Element Volume
 %    Vol(:,inod)=Vol(:,inod)+N(inod)*xsj;
     
     P_supg = zeros(ne,ndf,ndf);       
     for idm=1:ndm,
         P_supg(:,idm+1,idm+1) = tau.*alpha_g.*(velpg(:,1).*dshapex(:,inod,1) + ...
             velpg(:,2).*dshapex(:,inod,2));
         P_supg(:,1,idm+1) = -tau.*alpha_g.*dshapex(:,inod,idm)/rho_g;
%         P_supg(:,1,1) = P_supg(:,1,1) + delta_alpha/rho_g* ...
%             (velpg(:,idm).*dshapex(:,inod,idm)+N(inod)*dUpg(:,idm+1,idm))
     end
     W_supg = P_supg;
     for idf=1:ndf,
        W_supg(:,idf,idf)=W_supg(:,idf,idf)+N(inod);
     end

     % calculo del residuo
     flag_terms = 0;
     comp_Rele;

 end % inod
 
     % estimacion de la norma del residuo
     R_idf = zeros(ne,ndf);
     for idf=1:ndf,
        vaux = Rele(:,:,idf);
        R_idf(:,idf) = sum(abs(vaux'))';
     end
     R_ndf = sum(R_idf')';
    
  for inod=1:nen,   

%====================================================================================
lambda_s = 1;
C_dif    = 1/2;
kappa_sc = C_dif*hele.*R_ndf./(sqrt(sum(grad_Unorm'.^2))'+hele);
Pe_K     = 1/2*mk*velmod.*hele/kappa_sc;
psi      = min([Pe_K';ones(1,ne)])';
delta_s  = lambda_s* abs(alpha_g).*hele.*psi;
%====================================================================================
      
     P_supg = zeros(ne,ndf,ndf);       
     for idm=1:ndm,
         P_supg(:,1,1) = P_supg(:,1,1) + delta_s/rho_g .* ...
             (velpg(:,idm).*dshapex(:,inod,idm)+N(inod)*dUpg(:,idm+1,idm));
     end
     W_supg = P_supg;
     
     gN_D_gU = zeros(ne,ndf);     
     if(shocap>0)                
        for idm=1:ndm              
           gN_D_gU(:,1) = gN_D_gU(:,1) + ...
              dshapex(:,inod,idm).*kappa_sc.*dUpg(:,idf,idm);
        end
     end        

     flag_terms = 1;
     comp_Rele;

 end

   for inod=1:nen,   

     P_supg = zeros(ne,ndf,ndf);       
     for idm=1:ndm,
         P_supg(:,idm+1,idm+1) = tau.*alpha_g.*(velpg(:,1).*dshapex(:,inod,1) + ...
             velpg(:,2).*dshapex(:,inod,2));
         P_supg(:,1,idm+1) = -tau.*alpha_g.*dshapex(:,inod,idm)/rho_g;
         P_supg(:,1,1) = P_supg(:,1,1) + delta_s/rho_g.* ...
             (velpg(:,idm).*dshapex(:,inod,idm)+N(inod)*dUpg(:,idm+1,idm));
     end
     W_supg = P_supg;
     for idf=1:ndf,
        W_supg(:,idf,idf)=W_supg(:,idf,idf)+N(inod);
     end

        for jnod=1:nen,        
        % A_gN     
        tmpx = dshapex(:,jnod,1);
        tmpy = dshapex(:,jnod,2);
        for idf=1:ndf,
           for jdf=1:ndf,
              A_gN(:,idf,jdf,jnod) = tmpx.*Ax(:,idf,jdf) + tmpy.*Ay(:,idf,jdf) ;
           end 
        end    
        end
        
        for jnod=1:nen,
           
        % temporal terms
        W_Cp_N = rowprod(W_supg,Cp,ndf,ndf,ndf)*N(jnod) ;        
        %W_Cp_N = N(inod)*Cp*N(jnod) ;         
        
        % N_A_gN or gN_A_N according to weak form
        if weak_form,
                 N_A_gN = -A_gN(:,:,:,inod)*N(jnod);                 
        else          
                 N_A_gN =  A_gN(:,:,:,jnod)*N(inod);              
        end
        
        P_A_gN = rowprod(P_supg,A_gN(:,:,:,jnod),ndf,ndf,ndf);
        
        % shock capturing term
        gN_D_gN = zeros(numel,ndf,ndf);        
        if (shocap > 0)        
           for idm=1:ndm
              gN_D_gN(:,1,1) = gN_D_gN(:,1,1) + ...
                dshapex(:,inod,idm).*kappa_sc.*dshapex(:,jnod,idm);
           end
        end
        
        gN_K_gN = zeros(numel,ndf,ndf);        
        for idf=1:ndf,
           for jdf=1:ndf,
              gN_K_gN(:,idf,jdf) = ...
                 -( (dshapex(:,inod,1).*Kxx(:,idf,jdf).*dshapex(:,jnod,1))+ ...
                    (dshapex(:,inod,1).*Kxy(:,idf,jdf).*dshapex(:,jnod,2))+ ...
                    (dshapex(:,inod,2).*Kyx(:,idf,jdf).*dshapex(:,jnod,1))+ ...
                    (dshapex(:,inod,2).*Kyy(:,idf,jdf).*dshapex(:,jnod,2)) );
           end             
        end
        
        % reactive terms
        W_C_N = rowprod(W_supg,C_1,ndf,ndf,ndf)*N(jnod) ;        
        
        % assembling
        vaux =  N_A_gN + P_A_gN + gN_D_gN - gN_K_gN + W_C_N;
        
        for idf=1:ndf,
           for jdf=1:ndf,              
              Mele(:,inod,idf,jnod,jdf) = Mele(:,inod,idf,jnod,jdf) + ... 
              xsj.*( W_Cp_N(:,idf,jdf) ./ dt + vaux(:,idf,jdf) );           
           end
        end
                
        end % jnod
        
  end % inod
    
end % ipg

% ------ Terminos de contorno

if weak_form,
   [Mele,Rele] = bc_conv_bubbly_2d(xnod,icone,Ue,ifaceb,Rele,Mele,prop);   
end


