
ne  = length(eles);
[bas,ndf_fields] = size(extra_nodal_fields);

% Localizacion de las variables
%------------------------------------------------------------------

    ceros = zeros(ne,nen*ndf);
       Ue = ceros;
      U0e = ceros;
	    re = zeros(ne,nen);
     Uf_e = zeros(ne,nen*ndf_fields);
   Uenorm = zeros(ne,nen);
for inod=1:nen,
            nodes  = icone(eles,inod);
            jnod  = (inod-1)*ndf+(1:ndf);
            knod  = (inod-1)*ndf_fields+(1:ndf_fields);            
       Ue(:,jnod)  = U(nodes,1:ndf);		 
       U0e(:,jnod) = Uold(nodes,1:ndf);   
       re(:,inod)  = xnod(nodes,1);		        
       Uf_e(:,knod)  = extra_nodal_fields(nodes,1:ndf_fields);       
       Uenorm(:,inod) = sqrt(sum(Uold(nodes,1:ndf)'.^2)');
end

% UPWIND EN EL CENTROIDE 
%------------------------------------------------------------------
if nen==4,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),0,0);
  [dshapex0,N0] = shape2d(X2S,0,0,nen); 
elseif nen==3,
  [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),1/3,1/3);
  [dshapex0,N0] = shape2d(X2S,1/3,1/3,nen); 
else
  error(' Bad type of element , nen ~=3, nen ~=4 ')
end
Upg        = zeros(ne,ndf);
dUpg       = zeros(ne,ndf,ndm);
dUpg_new   = zeros(ne,ndf,ndm);
grad_Unorm = zeros(ne,ndm);
grad_p     = zeros(ne,ndm);
vel_l      = zeros(ne,ndm);

for inod=1:nen,
   jnod = (inod-1)*ndf+(1:ndf);
   Upg(:,(1:ndf))    =  Upg(:,(1:ndf)) + N0(inod).*  U0e(:,jnod);
   dUpg(:,(1:ndf),1) = dUpg(:,(1:ndf),1) + ...
	          (dshapex0(:,inod,1)*ones(1,ndf)).* U0e(:,jnod);          
   dUpg(:,(1:ndf),2) = dUpg(:,(1:ndf),2)+ ...
             (dshapex0(:,inod,2)*ones(1,ndf)).* U0e(:,jnod);             
   dUpg_new(:,(1:ndf),1) = dUpg_new(:,(1:ndf),1) + ...
	          (dshapex0(:,inod,1)*ones(1,ndf)).* Ue(:,jnod);          
   dUpg_new(:,(1:ndf),2) = dUpg_new(:,(1:ndf),2)+ ...
             (dshapex0(:,inod,2)*ones(1,ndf)).* Ue(:,jnod);             
      
   grad_Unorm(:,1) = grad_Unorm(:,1) + dshapex0(:,inod,1).* Uenorm(:,inod);
   grad_Unorm(:,2) = grad_Unorm(:,2) + dshapex0(:,inod,2).* Uenorm(:,inod);   
   
      grad_p(:,1)  = grad_p(:,1) + dshapex0(:,inod,1).* Uf_e(:,(inod-1)*ndf_fields+1);
      grad_p(:,2)  = grad_p(:,2) + dshapex0(:,inod,2).* Uf_e(:,(inod-1)*ndf_fields+1);          
      vel_l(:,1)   = vel_l (:,1) + N0(inod).* Uf_e(:,(inod-1)*ndf_fields+2);
      vel_l(:,2)   = vel_l (:,2) + N0(inod).* Uf_e(:,(inod-1)*ndf_fields+3);      

end    

%[H,bas] = enthalpy_function(Upg,prop);

velpg   = Upg(:,2:3);
hele    = comp_hele(velpg,dshapex0,Jaco0,nen);
if type_upwind~=2,
%[tau,delta,bas] = supg_bubbly_2d(Upg,dUpg,Cou,hele,shocap,type_upwind);
[tau,delta,bas] = supg_bubbly_2d(Upg,dUpg,hele,prop,type_upwind);
else
velmod      = sqrt(sum(velpg'.^2))';
[bas,Cp]    = enthalpy_function(Upg,prop);
div_vg_0    = dUpg(:,2,1)+dUpg(:,3,2);
[bas,Cr]    = Cflux_nc(Upg,grad_p,vel_l,div_vg_0,prop,0);
reac        = [Cr(:,1,1)+Cp(:,1,1)./dt , Cr(:,2,2)+Cp(:,2,2)./dt , Cr(:,3,3)+Cp(:,3,3)./dt];
[tau,delta] = compute_tau_adv_dif_reac(Upg,dUpg,velmod,hele,reac,prop,1);
end

tau   = tau;
%delta = 0*delta;

% Flux_function_nc :=> non-conservative Flux_function version
  if conservative_version,
     [bas,Ax0,Ay0]     =  Flux_function(Upg,prop);        
  else
     [bas,Ax0,Ay0]     =  Flux_function_nc(Upg,prop);   
  end

div_vg_0 = dUpg_new(:,2,1)+dUpg_new(:,3,2);

Vol = zeros(ne,nen);

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------
 for ipg=1:npg
  
  [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
  [dshapex,N] = shape2d(X2S,psipg(ipg),etapg(ipg),nen); 

% Interpolacion en punto de Gauss
%------------------------------------------------------------------

     Upg    = zeros(ne,ndf);
    U0pg    = zeros(ne,ndf);
    dUpg    = zeros(ne,ndf,ndm);
   radpg    = zeros(ne,1);
   grad_p   = zeros(ne,ndm);
   vel_l    = zeros(ne,ndm);
   
  for inod=1:nen,
     jnod = (inod-1)*ndf+(1:ndf);
      Upg(:,(1:ndf))  =  Upg(:,(1:ndf)) + N(inod).*  Ue(:,jnod);
      U0pg(:,(1:ndf)) = U0pg(:,(1:ndf)) + N(inod).* U0e(:,jnod);
      radpg(:,1)      =      radpg(:,1) + N(inod).* re(:,inod);
      
      dUpg(:,(1:ndf),1)   = dUpg(:,(1:ndf),1) + ...
	          (dshapex(:,inod,1)*ones(1,ndf)).* Ue(:,jnod);
          
      dUpg(:,(1:ndf),2) = dUpg(:,(1:ndf),2)+ ...
	          (dshapex(:,inod,2)*ones(1,ndf)).* Ue(:,jnod);          
      grad_p(:,1)  = grad_p(:,1) + dshapex(:,inod,1).* Uf_e(:,(inod-1)*ndf_fields+1);
      grad_p(:,2)  = grad_p(:,2) + dshapex(:,inod,2).* Uf_e(:,(inod-1)*ndf_fields+1);          
      vel_l(:,1)   = vel_l (:,1) + N(inod).* Uf_e(:,(inod-1)*ndf_fields+2);
      vel_l(:,2)   = vel_l (:,2) + N(inod).* Uf_e(:,(inod-1)*ndf_fields+3);      
  end
    
  [H,Cp]     =  enthalpy_function(Upg,prop);
  [H0,bas]   =  enthalpy_function(U0pg,prop);
  
 
  % advective flux function  
  if conservative_version,
     [Fa,Ax,Ay]     =  Flux_function(Upg,prop);        
  else
     [Fa,Ax,Ay]     =  Flux_function_nc(Upg,prop);   
  end
    
  % reactive and source terms due to:
  % .- pressure gradient 
  % .- bouyancy forces
  % .- phase interactions drag  
    
  %disp('Bubbly_2d_ele');keyboard;pause

  if lumping_drag_forces,
  job         = 1; % [0] en Cflux todas las 3 fuerzas (pressure, buoyancy y pressure)
                   % [1] en Cflux solo las 3 fuerzas de pressure y buoyancy
                   % [2] en Cflux solo la fuerza de drag
  else
     job = 0;
  end
  
  if conservative_version,
     [Fc_1,C_1] = Cflux(Upg,grad_p,vel_l,prop,job);
  else
     % Cflux_nc :=> non-conservative Cflux version
     div_vg = dUpg(:,2,1)+dUpg(:,3,2);
     [Fc_1,C_1] = Cflux_nc(Upg,grad_p,vel_l,div_vg,prop,job);
  end
  
  % Upg y dUpg deben tener como 2da y 3ra componentes a la velocidad   
   [Fd,Kxx,Kxy,Kyx,Kyy]  = Dflux(Upg,dUpg,prop);  
%  [Kxx,Kxy,Kyx,Kyy] = Djac_2D(Upg,prop);
  
  % Correccion axisimetrica del jacobiano de la transformacion al elemento master
  %------------------------------------------------------------------
  xsj =  wpg(ipg) .* Jaco;
  if axisim,
     xsj = xsj.*radpg;
  end

  AgU = rowprod(Ax,dUpg(:,1:ndf,1),ndf,ndf,1) + ... 
        rowprod(Ay,dUpg(:,1:ndf,2),ndf,ndf,1);
    
  % P_i Petrov-Galerkin perturbation weight function
  for inod=1:nen,   

     P_supg = zeros(ne,ndf,ndf);       
     for idm=1:ndm,
         P_supg(:,idm+1,idm+1) = tau.*alpha.*(velpg(:,1).*dshapex(:,inod,1) + ...
             velpg(:,2).*dshapex(:,inod,2));
         P_supg(:,1,idm+1) = -beta_alpha*tau.*alpha.*dshapex(:,inod,idm);
     end
     W_supg = P_supg;
     for idf=1:ndf,
        W_supg(:,idf,idf)=W_supg(:,idf,idf)+N(inod);
     end
     
     % W_i N_j term
                
        for jnod=1:nen,        
        % A_gN     
        tmpx = dshapex(:,jnod,1);
        tmpy = dshapex(:,jnod,2);
        for idf=1:ndf,
           for jdf=1:ndf,
              A_gN(:,idf,jdf,jnod) = tmpx.*Ax(:,idf,jdf) + tmpy.*Ay(:,idf,jdf) ;
           end 
        end    
        end
        
        for jnod=1:nen,
           
        % temporal terms
        W_Cp_N = rowprod(W_supg,Cp,ndf,ndf,ndf)*N(jnod) ;        
        %W_Cp_N = N(inod)*Cp*N(jnod) ;         
        
        % N_A_gN or gN_A_N according to weak form
        if weak_form,
                 N_A_gN = -A_gN(:,:,:,inod)*N(jnod);                 
        else          
                 N_A_gN =  A_gN(:,:,:,jnod)*N(inod);              
        end
        
        P_A_gN = rowprod(P_supg,A_gN(:,:,:,jnod),ndf,ndf,ndf);
        
        % shock capturing term
        gN_D_gN = zeros(numel,ndf,ndf);        
        if (shocap > 0)        
        if(type_shocap==0)
           for idf=1:ndf,
%              gN_D_gN(:,idf,idf) = ((dshapex(:,inod,1).*delta.*dshapex(:,jnod,1))+ ...
%                 (dshapex(:,inod,2).*delta.*dshapex(:,jnod,2)));
              for idm=1:ndm
                 gN_D_gN(:,idf,idf) = gN_D_gN(:,idf,idf) + ...
                    dshapex(:,inod,idm).*delta.*dshapex(:,jnod,idm);
              end
           end
        else
           for idf=1:ndf,
              for idm=1:ndm
                 for jdm=1:ndm
                    gN_D_gN(:,idf,idf) = gN_D_gN(:,idf,idf) + ...
                       dshapex(:,inod,idm).*delta2(:,idf,idm,idf,jdm).*dshapex(:,jnod,jdm);
                 end
              end
           end
        end
        end
        
        gN_K_gN = zeros(numel,ndf,ndf);        
        for idf=1:ndf,
           for jdf=1:ndf,
              gN_K_gN(:,idf,jdf) = ...
                 -( (dshapex(:,inod,1).*Kxx(:,idf,jdf).*dshapex(:,jnod,1))+ ...
                    (dshapex(:,inod,1).*Kxy(:,idf,jdf).*dshapex(:,jnod,2))+ ...
                    (dshapex(:,inod,2).*Kyx(:,idf,jdf).*dshapex(:,jnod,1))+ ...
                    (dshapex(:,inod,2).*Kyy(:,idf,jdf).*dshapex(:,jnod,2)) );
           end             
        end
        
        % reactive terms
        W_C_N = rowprod(W_supg,C_1,ndf,ndf,ndf)*N(jnod) ;        
        
        % assembling
        vaux =  N_A_gN + P_A_gN + gN_D_gN - gN_K_gN + W_C_N;
        

        for idf=1:ndf,
           for jdf=1:ndf,              
              Mele(:,inod,idf,jnod,jdf) = Mele(:,inod,idf,jnod,jdf) + ... 
              xsj.*( time_factor*W_Cp_N(:,idf,jdf) ./ dt + vaux(:,idf,jdf) );           
           end
        end
                
        end % jnod
        
        % temporal term
        W_dUdt   = rowprod(W_supg,(H-H0),ndf,ndf,1);
 
        % C_alpha
        field = [indx_alpha,indx_ug,indx_vg];

        [C_alpha] = compute_C_alpha(Upg(:,field),dUpg(:,field,:));
        W_C_alpha = rowprod(W_supg,C_alpha,ndf,ndf,1);
        % D_alpha
        [D_alpha] = compute_D_alpha(Upg(:,field),dUpg(:,field,:),prop);
        N_D_alpha = zeros(ne,ndf);
        for idm=1:ndm,
            for jdm=1:ndm              
                N_D_alpha(:,idm+1) = N_D_alpha(:,idm+1) + dshapex(:,inod,jdm).*D_alpha(:,idm+1,jdm);
            end
        end 
        
        N_P_alpha = zeros(ne,ndf);
        % gradiente de presion en la ecuacion de momento
        grad_p = reshape(dUpg(:,indx_p,1:2),ne,2);
        alpha  = Upg(:,indx_alpha);
        N_P_alpha(:,2) = beta_alpha*N(inod)*alpha.*grad_p(:,1);
        N_P_alpha(:,3) = beta_alpha*N(inod)*alpha.*grad_p(:,2);
        % divergencia velocidad en la ec de continuidad
        div_vel = dUpg(:,indx_ug,1)+dUpg(:,indx_vg,2);
        N_P_alpha(:,1) = beta_alpha*N(inod)*alpha.*div_vel;
        
        % stabilization momentum equations
        Res_mom = W_C_alpha+N_P_alpha;
        
        Res_mom(:,1) = 0;
        S_mom  = rowprod(P_supg,Res_mom,ndf,ndf,1);
        
        Body_mom = zeros(ne,ndf);
        Body_mom(:,2:3) = beta_alpha*alpha*gravity;
        W_Body = = rowprod(W_supg,Body_mom,ndf,ndf,1);
        
        Dsc = zeros(ne,ndf);
        if(shocap>0)                
           for idm=1:ndm              
              Dsc(:,1) = Dsc(:,1) + kappa_sc*dshapex(:,inod,idm).*dUpg(:,1,idm);
           end
        end        
        
        Res_cont(:,1) = beta_alpha*(alpha.*div_vel + ...
               Upg(:,indx_ug).*dUpg(:,indx_alpha,1)+Upg(:,indx_vg).*dUpg(:,indx_alpha,2));
            
        P_cont = delta_alpha*beta_alpha*( N(inod)*div_vel + ...
               Upg(:,indx_ug).*dshapex(:,inod,1)+Upg(:,indx_vg).*dshapex(:,inod,2);
            
        S_cont = P_cont.*Res_cont;    
        
        Res_mom = W_C_alpha+N_D_alpha+N_P_alpha;
        
        vaux = Res_mom - Dsc + S_mom + S_cont ;  
    
        for idf=1:ndf,
           Rele(:,inod,idf) = Rele(:,inod,idf) - ... 
                              (vaux(:,idf) + W_dUdt(:,idf) ./ dt ).* xsj ;
        end

  end % inod
    
end % ipg

% ------ Terminos de contorno

%disp('bubbly_2d_ele');keyboard;pause
if weak_form,
   [Mele,Rele] = bc_conv_bubbly_2d(xnod,icone,Ue,ifaceb,Rele,Mele,prop);   
end


