function [D_alpha] = compute_D_alpha(U,gU,prop)
%--------------------------------------------------------------------
%
%       [D_alpha] = compute_D_alpha(U,gU,prop)
%
%      U = [ alpha , vel-x , vel-y ]
%
%--------------------------------------------------------------------

visco     = prop(2);
[N,ndf]   = size(U);
alpha     = U(:,1);
vel       = U(:,2:3);

grad_u      = reshape(gU(:,2,1:2),N,2);
grad_v      = reshape(gU(:,3,1:2),N,2);

% epsilon(u)
defo(:,1,1) = grad_u(:,1)+grad_u(:,1);
defo(:,1,2) = grad_u(:,2)+grad_v(:,1);
defo(:,2,1) = grad_v(:,1)+grad_u(:,2);
defo(:,2,2) = grad_v(:,2)+grad_v(:,2);
defo        = defo/2;

D_alpha = zeros(N,ndf,ndm);
for k=1:2,
    for m=1:2,
       D_alpha(:,k+1,m) = 2*visco*alpha.*defo(:,k,m);       
    end
end
