%------------------------------------------------------------------
%       Programa   " D R V F E M " 
%------------------------------------------------------------------

if(exist('inicia')==0),
   disp('Ingrese la variable inicia ')
   disp(' inicia == 0 ---> si continua una corrida previa ')
   disp(' inicia ~= 0 ---> si comienza una corrida nueva ')
   inicia = input(' Inicia = ')
end

%------ Ingreso de datos -------------------------------------------

if inicia,
   read_data;
   bfh=[];          % Guarda la solucion
   hc_res=[];       % Guarda la historia de la convergencia en residuo
   hc_du=[];        % Guarda la historia de la convergencia en dphi
   bfh_nc = [];     % Guarda los pasos de tiempo en que no hubo convergencia
   bfh_u=[];        % Guarda la solucion cada nstep pasos de tiempo
   posdat;
   ttime = 0;
end

%------ fin ingreso de datos --------------------------------------

limit = prop(12);

% Loop temporal o pseudotemporal
%------------------------------------------------------------------

for itime=1:ntime,
   
   if exist('dtmin')&exist('dtmax'),
      dt = dtmin+(dtmax-dtmin)*itime/ntime;
      prop(13)=dt;
      disp(['dt = ' num2str(dt)])
   end   
   ttime = ttime+dt;
   
   phiold = phi;
   
   % Actualiza las condiciones de contorno si fueran funcion del tiempo
   % La funcionalidad se lee del archivo "bc_time"
   if exist('bc_time_flag')==1,
      if (bc_time_flag==1)&(exist('bc_time')~=2), 
         disp('Debe tener en el directorio de trabajo un archivo de nombre bc_time.m ');
         error(' bc_time_flag==1 y bc_time file no existe '); 
      end
      if bc_time_flag==1, bc_time; end
   end
   
   nu    = 0;
   iterflag = 1;
   [numnp,ndf] = size(phi);
   
   while iterflag
      
      nu= nu+1;
      
      phi_nu = phi;
      
      if 1,
         % Paso 1 : Inviscid
         [Kg,Rg] = bubbly_2D(xnod,icone,fixa,forc,teco,lin_con,external_fields,prop,...
            ifaceb,phi,phiold,1);      
         [phi_star,Rg_1]=solver(phi,Rg,Kg,fixa,prop,prop_solver,ndf);   
      else
         phi_star = phi;
         Rg_1 = 0;
      end
      
      if 1,
         % Paso 2 : Viscous
         [Kg,Rg] = bubbly_2D(xnod,icone,fixa,forc,teco,lin_con,external_fields,prop,...
            ifaceb,phi_star,phi_star,2);      
         [phi,Rg_2]=solver(phi_star,Rg,Kg,fixa,prop,prop_solver,ndf);   
      else
         phi = phi_star;
         Rg_2 = 0*Rg_1;
      end
      
      dphi = phi-phi_nu;
      
      Rg = sqrt(Rg_1.^2+Rg_2.^2);
      
      % Analisis de la convergencia
      %------------------------------------------------------------------
      iterflag = (norm(Rg)>limit) & (nu< nu_max); % & (norm(dphi)>limit);
      
      disp(['time ' num2str(itime) ... 
            ' Iter ' num2str(nu)  ' || R || -----> ' num2str(norm(Rg)) ... 
            ' || Delta phi || -----> ' num2str(norm(dphi))  ])
      
      hc_res  = [hc_res ; norm(Rg)];
      hc_du   = [hc_du ; norm(dphi)];
      
   end  % end while
   
   % Salida grafica de resultados (provista por cada aplicacion)
   %------------------------------------------------------------------
   
   plot_fem
   
   %  bfh = [bfh phi(:,1)];
   
   
   if norm(Rg)>limit ,
      %  error(' NO CONVERGENCE ');
      bfh_nc = [bfh_nc ; itime];
   end
   
   if exist('nsave')==0; nsave=ntime;end
   
   if exist('filesave')==0; filesave='tempo'; end
   
   if rem(itime,nsave)==0, 
      eval(['save ' filesave ';']);
   end
   
   if rem(itime,nstep)==0,
      bfh_u = [bfh_u , phi];
   end
   
end % itime loop

