%------------------------------------------------------------------
%     APLICATION  :  TWO PHASE FLOW
%------------------------------------------------------------------

if(exist('inicia')==0),
    disp('Ingrese la variable inicia ')
    disp(' inicia == 0 ---> si continua una corrida previa ')
    disp(' inicia ~= 0 ---> si comienza una corrida nueva ')
    inicia = input(' Inicia = ')
end

%------ Ingreso de datos -------------------------------------------

if inicia,
    read_data;
    bfh=[];          % Guarda la solucion
    hc_res=[];       % Guarda la historia de la convergencia en residuo
    hc_du=[];        % Guarda la historia de la convergencia en dphi
    bfh_nc = [];     % Guarda los pasos de tiempo en que no hubo convergencia
    bfh_u=[];        % Guarda la solucion cada nstep pasos de tiempo
    posdat;
    ttime = 0;
    restart_time = 0;
end

%------ fin ingreso de datos --------------------------------------

limit = prop(12);
[numnp,ndf] = size(phi);

external_fields = [];
external_fields_old = [];

automatic_time_control = 0;

% Loop temporal o pseudotemporal
%------------------------------------------------------------------

for itime=1:ntime,
    
    restart_time = 0;
    
    if restart_time ==1,
        phi = phiold;
    else
        phiold = phi;
        if 1,
            if exist('dtmin')&exist('dtmax'),
                dt = dtmin+(dtmax-dtmin)*itime/ntime;
                prop(13)=dt;
                disp(['dt = ' num2str(dt)])
            end  
        end
    end
    
    ttime = ttime+dt;
    
    % Actualiza las condiciones de contorno si fueran funcion del tiempo
    % La funcionalidad se lee del archivo "bc_time"
    if exist('bc_time_flag')==1,
        if (bc_time_flag==1)&(exist('bc_time')~=2), 
            disp('Debe tener en el directorio de trabajo un archivo de nombre bc_time.m ');
            error(' bc_time_flag==1 y bc_time file no existe '); 
        end
        if bc_time_flag==1, bc_time; end
    end
    
    nu_outer     = 0;
    nu_outer_max = nnwt_outer;
    iterflag_outer = nu_outer < nu_outer_max;
    
    while iterflag_outer    
        nu_outer = nu_outer +1;
        Rg_outer = [];
        
        if coupled==0,
            phase_id = 'liq';
            newton_loop;
                        
            phase_id = 'gas';
            newton_loop;
                       
        else
            newton_loop;        
        end
                
        iterflag_outer = (norm(Rg_outer)>limit) & (nu_outer < nu_outer_max);         
%        iterflag_outer = (nu_outer < nu_outer_max);               
        disp(['time ' num2str(itime) ' Iter ' num2str(nu)  ' || R || (outer) -----------------> ' num2str(norm(Rg_outer))   ])
        
    end
    
    if automatic_time_control,
        if res(end)>res(1), 
            restart_time=1;    
            dt = max([dt/2,dtmin]);
        else
            restart_time=0;
        end
    end
    
    % Salida grafica de resultados (provista por cada aplicacion)
    %------------------------------------------------------------------
    
    plot_fem
    
    if norm(Rg)>limit ,
        %  error(' NO CONVERGENCE ');
        bfh_nc = [bfh_nc ; itime];
    end
    
    if exist('nsave')==0; nsave=ntime;end
    
    if exist('filesave')==0; filesave='tempo'; end
    
    if exist('filestate')==0; filestate='last_state'; end
    
    if rem(itime,nsave)==0, 
        eval(['save ' filesave ';']);
        eval(['save ' filestate 'phi ' ';']);
    end
    
    if rem(itime,nstep)==0,
        bfh_u = [bfh_u , phi];
    end
    
end % itime loop

