function [A,B,D,E,P_st,B_st]=get_matrix(state,param)
%
%
%  Stability analysis from Sing & Ishii paper
%
%  seguir la nomenclatura del paper
%
% state vector U = [alpha,ug,ul,p] according to Song paper
%

job='get';
handle_param

if caso==0,
   alpha_g = state(:,1);
   u_g     = state(:,2);
   u_l     = state(:,3);
   p       = state(:,4);
   
   % matriz temporal A
   N = length(alpha_g);
   A = zeros(N,4,4);
   A(:,1,1)=rho_g;
   A(:,2,1)=-rho_l;
   A(:,3,2)=alpha_g*rho_g;
   A(:,4,3)=(1-alpha_g)*rho_l;
   
   if artif_compres    
      A(:,1,4) = alpha_g /cc_g^2;
      A(:,2,4) = (1-alpha_g) /cc_l^2;
      A(:,2,1) = 0;
   end
   
   % matriz espacial B
   B = zeros(N,4,4);
   B(:,1,1) = rho_g*u_g;
   B(:,1,2) = alpha_g*rho_g;
   B(:,2,1) = -rho_l*u_l;
   B(:,2,3) = (1-alpha_g)*rho_l;
   B(:,3,1) = rho_g*(C_vg-1)*u_g.^2 ;
   B(:,3,2) = rho_g*(2*C_vg-1)*alpha_g.*u_g ;
   B(:,3,4) = alpha_g;
   B(:,4,1) = -rho_l*(C_vl-1)*u_l.^2 ;
   B(:,4,3) = rho_l*(2*C_vl-1)*(1-alpha_g).*u_l;
   B(:,4,4) = (1-alpha_g);  
   
   % agregado termino proporcional al grad alpha (presion interfacial)
   B(:,3,1) = B(:,3,1) + rho_l*delta*alpha_g.*(u_g-u_l).^2;
   B(:,4,1) = B(:,4,1) - rho_l*delta*alpha_g.*(u_g-u_l).^2;
   
   % matriz reactiva
   D = zeros(N,4,4);
   D(:,3,1) = C_d*rho_l*(u_g-u_l).^2;
   D(:,3,2) = 2*C_d*rho_l*alpha_g.*(u_g-u_l);
   D(:,3,3) = -2*C_d*rho_l*alpha_g.*(u_g-u_l);
   D(:,4,1) = -C_d*rho_l*(u_g-u_l).^2;
   D(:,4,2) = -2*C_d*rho_l*alpha_g.*(u_g-u_l);
   D(:,4,3) = 2*C_d*rho_l*alpha_g.*(u_g-u_l);
   
   % vector terminos fuentes
   C = zeros(N,4);
   
   C(:,3) =  C_d*rho_l*alpha_g.*(u_g-u_l).^2;
   C(:,4) = -C_d*rho_l*alpha_g.*(u_g-u_l).^2;
   
   P_st = zeros(nnod,ndf,ndf);
   if 1,
      tau_g    = dx/2 ./abs(u_g);
      tau_l    = dx/2 ./abs(u_l);
      tau_cont = 0*dx/2*abs(u_g);    
      P_st(:,1,1)=tau_g.*u_g;
      if 1,
         P_st(:,2,4)=tau_l/rho_l;
         P_st(:,3,3)=tau_g.*u_g;
         P_st(:,4,4)=tau_l.*u_l;
         P_st(:,4,2)=tau_cont*rho_l;
      end
   end
   E = zeros(N,ndf,ndf);
   E(:,3,2) = mu_g;
   E(:,4,3) = mu_l;
   
elseif caso==1,
      
   A = 1*ones(nnod,1,1);
   B = 1*ones(nnod,1,1);
   D = zeros(nnod,1,1);
   E = 1.*ones(nnod,1,1);
   
   P_st = zeros(nnod,ndf,ndf);
   if 1,
      vel = B(:,1,1);   
      tau    = dx/2 ./abs(vel);
      P_st(:,1,1) = tau.*vel;
   end
   
elseif caso==2,
      
   A = ones(nnod,1,1);
   A(:,2,2) = ones(nnod,1,1);

   B = ones(nnod,1,1);
   B(:,2,2) = -ones(nnod,1,1);
   
   D = zeros(nnod,2,2);
   E = 0*ones(nnod,1,1);
   E(:,2,2) = 0*ones(nnod,1,1);

   P_st = zeros(nnod,ndf,ndf);
   if 1,
      vel = B(:,1,1);   
      P_st(:,1,1) = dx/2.*sign(vel);
      vel = B(:,2,2);   
      P_st(:,2,2) = dx/2.*sign(vel);
   end
   
end

B_st=0*B;
for idf=1:ndf,
   for jdf=1:ndf
      for kdf=1:ndf
         B_st(:,idf,kdf) = B_st(:,idf,kdf)+P_st(:,idf,jdf).*B(:,jdf,kdf);
      end
   end   
end
