syms psi

h = 1;
Ni = 0.5*(1+psi*[-1,1]);
Nj = 0.5*(1+psi*[-1,1]);
gNi = diff(Ni,psi);
gNj = diff(Nj,psi);

Jaco = h/2;

% termino temporal
coe_m = int(Ni(2)*Nj(1),-1,1)*Jaco;
coe_p = int(Ni(1)*Nj(2),-1,1)*Jaco;
coe_0 = (int(Ni(1)*Nj(1),-1,1)+int(Ni(2)*Nj(2),-1,1))*Jaco;
coe_00 = [coe_m,coe_0,coe_p];
coe_00 = double(coe_00);

% termino convectivo
coe_m = int(Ni(2)*gNj(1),-1,1);
coe_p = int(Ni(1)*gNj(2),-1,1);
coe_0 = (int(Ni(1)*gNj(1),-1,1)+int(Ni(2)*gNj(2),-1,1));
coe_01 = [coe_m,coe_0,coe_p];
coe_01 = double(coe_01);

% termino difusivo
coe_m = int(gNi(2)*gNj(1),-1,1)/Jaco;
coe_p = int(gNi(1)*gNj(2),-1,1)/Jaco;
coe_0 = (int(gNi(1)*gNj(1),-1,1)+int(gNi(2)*gNj(2),-1,1))/Jaco;
coe_11 = [coe_m,coe_0,coe_p];
coe_11 = double(coe_11);

% termino estabilizacion antisimetrico
coe_m = int(gNi(2)*Nj(1),-1,1);
coe_p = int(gNi(1)*Nj(2),-1,1);
coe_0 = (int(gNi(1)*Nj(1),-1,1)+int(gNi(2)*Nj(2),-1,1));
coe_10 = [coe_m,coe_0,coe_p];
coe_10 = double(coe_10);

nnod = 10;
ndf = 1;

get_data

fixa = [1,1,2;
   nnod,1,0];

xnod = (0:nnod-1)'*dx;
nofree=[];
for idf=1:ndf,
   nn=find(fixa(:,2)==idf);
   if isempty(nn)==0,
      ipt=rmdblist((idf-1)*nnod+fixa(nn,1));
      nofree=[nofree;ipt];
      state(ipt,idf)=fixa(nn,3);
   end
end

Mas_Op   = coe_00/dt;
Adv_Op   = coe_01/dx;           
Dif_Op   = coe_11/dx/dx;        
Mas_P_Op = coe_10/dx;        
Adv_P_Op = coe_11/dx/dx;                

row=[];col=[];coe=[];coe_rhs=[];
indx = (2:nnod-1)';

[A,B,D] = get_matrix(state,param);
A = ones(nnod,1,1);
B = ones(nnod,1,1);
D = zeros(nnod,1,1);
E = ones(nnod,1,1);

% contribucion al interior
jndx=[-1,0,1]; 
for idf=1:ndf
   for jdf=1:ndf
      
      % termino temporal (matriz A)                
      kndx=[1,2,3];
      for k=1:length(kndx),
         kk=kndx(k);
         row = [row;nnod*(idf-1)+indx];
         col = [col;nnod*(jdf-1)+indx+jndx(kk)];
         vaux = A(indx,idf,jdf)*Mas_Op(kk);
         coe = [coe;vaux];
         coe_rhs = [coe_rhs;vaux.*state(indx+jndx(kk),jdf)];
      end
      
      % termino conveccion (matriz B centrada)        
      kndx=[1,3];
      for k=1:length(kndx),
         kk=kndx(k);
         row = [row;nnod*(idf-1)+indx];
         col = [col;nnod*(jdf-1)+indx+jndx(kk)];
         vaux = B(indx,idf,jdf)*Adv_Op(kk);
         coe = [coe;vaux];
         coe_rhs = [coe_rhs;vaux.*state(indx+jndx(kk),jdf)];
      end        
      
      % termino difusion (matriz E)        
      kndx=[1,2,3];
      for k=1:length(kndx),
         kk=kndx(k);
         row = [row;nnod*(idf-1)+indx];
         col = [col;nnod*(jdf-1)+indx+jndx(kk)];
         vaux = E(indx,idf,jdf)*Dif_Op(kk);
         coe = [coe;vaux];
         coe_rhs = [coe_rhs;vaux.*state(indx+jndx(kk),jdf)];
      end        
      
   end
end

Mas_Op_bc_lef   = [1, 4, 1]/6/2/dt;
Adv_Op_bc_lef   = [0,-1, 1]/dx;           
Dif_Op_bc_lef   = [0, 1,-1]/dx/dx;        

Mas_Op_bc_rig   = [1, 4, 1]/6/2/dt;
Adv_Op_bc_rig   = [-1, 1,0]/dx;           
Dif_Op_bc_rig   = [-1,1,0]/dx/dx;        

% contribucion en el contorno
for idf=1:ndf
   for jdf=1:ndf
      
      indx = 1        
      kndx=[2,3];
      for k=1:length(kndx),
         kk=kndx(k);
         row = [row;nnod*(idf-1)+indx];
         col = [col;nnod*(jdf-1)+indx+jndx(kk)];
         vaux = A(indx,idf,jdf)*Mas_Op_bc_lef(kk);
         coe = [coe;vaux];
         coe_rhs = [coe_rhs;vaux.*state(indx+jndx(kk),jdf)];
      end
      
      kndx=[2,3];
      for k=1:length(kndx),
         kk=kndx(k);
         row = [row;nnod*(idf-1)+indx];
         col = [col;nnod*(jdf-1)+indx+jndx(kk)];
         vaux = B(indx,idf,jdf)*Adv_Op_bc_lef(kk);
         coe = [coe;vaux];
         coe_rhs = [coe_rhs;vaux.*state(indx+jndx(kk),jdf)];
      end      
      
      kndx=[2,3];
      for k=1:length(kndx),
         kk=kndx(k);
         row = [row;nnod*(idf-1)+indx];
         col = [col;nnod*(jdf-1)+indx+jndx(kk)];
         vaux = E(indx,idf,jdf)*Dif_Op_bc_lef(kk);
         coe = [coe;vaux];
         coe_rhs = [coe_rhs;vaux.*state(indx+jndx(kk),jdf)];
      end      
      
      
      indx = nnod        
      row = [row;nnod*(idf-1)+indx];
      col = [col;nnod*(jdf-1)+indx];
      
      vaux = A(indx,idf,jdf)*Mas_Op_bc_rig(2);
      coe = [coe;vaux];
      coe_rhs = [coe_rhs;vaux.*state(indx,jdf)];
      
      row = [row;nnod*(idf-1)+indx];
      col = [col;nnod*(jdf-1)+indx-1];
      
      vaux = A(indx,idf,jdf)*Mas_Op_bc_rig(1);
      coe = [coe;vaux];
      coe_rhs = [coe_rhs;vaux.*state(indx-1,jdf)];
      
      row = [row;nnod*(idf-1)+indx];
      col = [col;nnod*(jdf-1)+indx];
      
      vaux = B(indx,idf,jdf)*Adv_Op_bc_rig(2);
      coe = [coe;vaux];
      coe_rhs = [coe_rhs;vaux.*state(indx,jdf)];
      
      row = [row;nnod*(idf-1)+indx];
      col = [col;nnod*(jdf-1)+indx-1];
      
      vaux = B(indx,idf,jdf)*Adv_Op_bc_rig(1);
      coe = [coe;vaux];
      coe_rhs = [coe_rhs;vaux.*state(indx-1,jdf)];
      
      row = [row;nnod*(idf-1)+indx];
      col = [col;nnod*(jdf-1)+indx];
      
      vaux = E(indx,idf,jdf)*Dif_Op_bc_rig(2);
      coe = [coe;vaux];
      coe_rhs = [coe_rhs;vaux.*state(indx,jdf)];
      
      row = [row;nnod*(idf-1)+indx];
      col = [col;nnod*(jdf-1)+indx-1];
      
      vaux = E(indx,idf,jdf)*Dif_Op_bc_rig(1);
      coe = [coe;vaux];
      coe_rhs = [coe_rhs;vaux.*state(indx-1,jdf)];
      
   end
end

K=sparse(row,col,coe);
R=sparse(row,ones(size(row)),coe_rhs);

K(nofree,:)=0;
K(nofree,nofree)=eye(length(nofree));
R(nofree,1)=0;
delta_state = -full(K\R);

figure(1);clf;plot(xnod,state(:,1)+delta_state,'-*');
