function [A,B,D,E,P_st,A_st,B_st,D_st]=get_matrix(state,param)
%
%
%  Stability analysis from Sing & Ishii paper
%
%  seguir la nomenclatura del paper
%
% state vector U = [alpha,ug,ul,p] according to Song paper
%

job='get';
handle_param

if caso==0,
   alpha_g = state(:,1);
   u_g     = state(:,2);
   u_l     = state(:,3);
   p       = state(:,4);
   
   ieq = [1,4,2,3];  % orden de las ecuaciones ===> CG, MG, ML, CL
   
   % matriz temporal A
   N = length(alpha_g);
   A = zeros(N,4,4);
   A(:,ieq(1),1)=rho_g;
   A(:,ieq(2),1)=-rho_l;
   A(:,ieq(3),2)=alpha_g*rho_g;
   A(:,ieq(4),3)=(1-alpha_g)*rho_l;
   
   if artif_compres    
      A(:,ieq(1),4) = alpha_g /cc_g^2;
      A(:,ieq(2),4) = (1-alpha_g) /cc_l^2;
      A(:,ieq(2),1) = 0;
   end
   
   % matriz espacial B
   B = zeros(N,4,4);
   B(:,ieq(1),1) = rho_g*u_g;
   B(:,ieq(1),2) = alpha_g*rho_g;
   B(:,ieq(2),1) = -rho_l*u_l;
   B(:,ieq(2),3) = (1-alpha_g)*rho_l;
   B(:,ieq(3),1) = rho_g*(C_vg-1)*u_g.^2 ;
   B(:,ieq(3),2) = rho_g*(2*C_vg-1)*alpha_g.*u_g ;
   B(:,ieq(3),4) = alpha_g;
   B(:,ieq(4),1) = -rho_l*(C_vl-1)*u_l.^2 ;
   B(:,ieq(4),3) = rho_l*(2*C_vl-1)*(1-alpha_g).*u_l;
   B(:,ieq(4),4) = (1-alpha_g);  
   
   % agregado termino proporcional al grad alpha (presion interfacial)
   B(:,ieq(3),1) = B(:,ieq(3),1) + rho_l*delta*alpha_g.*(u_g-u_l).^2;
   B(:,ieq(4),1) = B(:,ieq(4),1) - rho_l*delta*alpha_g.*(u_g-u_l).^2;
   
   % matriz reactiva
   D = zeros(N,4,4);
   D(:,ieq(3),1) = C_d*rho_l*(u_g-u_l).^2;
   D(:,ieq(3),2) = 2*C_d*rho_l*alpha_g.*(u_g-u_l);
   D(:,ieq(3),3) = -2*C_d*rho_l*alpha_g.*(u_g-u_l);
   D(:,ieq(4),1) = -C_d*rho_l*(u_g-u_l).^2;
   D(:,ieq(4),2) = -2*C_d*rho_l*alpha_g.*(u_g-u_l);
   D(:,ieq(4),3) = 2*C_d*rho_l*alpha_g.*(u_g-u_l);
   
   % vector terminos fuentes
   C = zeros(N,4);
   
   C(:,ieq(3)) =  C_d*rho_l*alpha_g.*(u_g-u_l).^2;
   C(:,ieq(4)) = -C_d*rho_l*alpha_g.*(u_g-u_l).^2;
   
   P_st = zeros(nnod,ndf,ndf);
   if 1,
      tau_g    = dx/2 ./abs(u_g);
      tau_l    = dx/2 ./abs(u_l);
      tau_cont = dx/2*abs(u_l);    
      P_st(:,ieq(1),ieq(1))=tau_g.*u_g;
      if 1,
         P_st(:,ieq(2),ieq(4))=tau_l/rho_l;
         P_st(:,ieq(3),ieq(3))=tau_g.*u_g;
         P_st(:,ieq(4),ieq(4))=tau_l.*u_l;
         P_st(:,ieq(4),ieq(2))=tau_cont*rho_l;
      end
   end
   E = zeros(N,ndf,ndf);
   E(:,ieq(3),2) = alpha_g*mu_g;
   E(:,ieq(4),3) = (1-alpha_g)*mu_l;
   
elseif caso==1,
      
   A = 1*ones(nnod,1,1);
   B = 1*ones(nnod,1,1);
   D = zeros(nnod,1,1);
   E = 1.*ones(nnod,1,1);
   
   P_st = zeros(nnod,ndf,ndf);
   if 1,
      vel = B(:,1,1);   
      tau    = dx/2 ./abs(vel);
      P_st(:,1,1) = tau.*vel;
   end
   
elseif caso==2,
      
   A = ones(nnod,1,1);
   A(:,2,2) = ones(nnod,1,1);

   B = ones(nnod,1,1);
   B(:,2,2) = -ones(nnod,1,1);
   
   D = zeros(nnod,2,2);
   E = 0*ones(nnod,1,1);
   E(:,2,2) = 0*ones(nnod,1,1);

   P_st = zeros(nnod,ndf,ndf);
   if 1,
      vel = B(:,1,1);   
      P_st(:,1,1) = dx/2.*sign(vel);
      vel = B(:,2,2);   
      P_st(:,2,2) = dx/2.*sign(vel);
   end
   
end

A_st=0*A;
B_st=0*B;
D_st=0*D;
for idf=1:ndf,
   for jdf=1:ndf
      for kdf=1:ndf
         A_st(:,idf,kdf) = A_st(:,idf,kdf)+P_st(:,idf,jdf).*A(:,jdf,kdf);
         B_st(:,idf,kdf) = B_st(:,idf,kdf)+P_st(:,idf,jdf).*B(:,jdf,kdf);
         D_st(:,idf,kdf) = D_st(:,idf,kdf)+P_st(:,idf,jdf).*D(:,jdf,kdf);         
      end
   end   
end
