function [A,B,D,E,P_st,A_st,B_st,D_st,beta]=get_matrix_pmm(state,param)
%
%  [A,B,D,E,P_st,A_st,B_st,D_st,beta]=get_matrix_pmm(state,param)
%

PMM_method = 1;

job='get';
handle_param


alpha_g = state(:,1);
u_g     = state(:,2);
u_l     = state(:,3);
p       = state(:,4);

ieq = [1,4,2,3];  % orden de las ecuaciones ===> CG, MG, ML, CL

% matriz temporal A
N = length(alpha_g);
A = zeros(N,4,4);
A(:,ieq(1),1)=rho_g;
A(:,ieq(2),1)=-rho_l;
A(:,ieq(3),2)=alpha_g*rho_g;
A(:,ieq(4),3)=(1-alpha_g)*rho_l;

% agregado para ver si se asemeja al FEMCODE
A(:,ieq(3),1)=rho_g*u_g;
A(:,ieq(4),1)=-rho_l*u_l;

if artif_compres    
    A(:,ieq(1),4) = alpha_g /cc_g^2;
    A(:,ieq(2),4) = (1-alpha_g) /cc_l^2;
    %    A(:,ieq(2),1) = 0;
end

% matriz espacial B
B = zeros(N,4,4);
B(:,ieq(1),1) = rho_g*u_g;
B(:,ieq(1),2) = alpha_g*rho_g;
B(:,ieq(2),1) = -rho_l*u_l;
B(:,ieq(2),3) = (1-alpha_g)*rho_l;
B(:,ieq(3),1) = rho_g*(C_vg-1)*u_g.^2 ;
B(:,ieq(3),2) = rho_g*(2*C_vg-1)*alpha_g.*u_g ;
B(:,ieq(3),4) = alpha_g;
B(:,ieq(4),1) = -rho_l*(C_vl-1)*u_l.^2 ;
B(:,ieq(4),3) = rho_l*(2*C_vl-1)*(1-alpha_g).*u_l;
B(:,ieq(4),4) = (1-alpha_g);  

% agregado para ver si se asemeja al FEMCODE   
B(:,ieq(3),1) = B(:,ieq(3),1)+rho_g*u_g.^2 ;
B(:,ieq(4),1) = B(:,ieq(4),1)-rho_l*u_l.^2 ;   
B(:,ieq(3),2) = B(:,ieq(3),2)+rho_g*alpha_g.*u_g ;
B(:,ieq(4),3) = B(:,ieq(4),3)+rho_l*(1-alpha_g).*u_l;      

% agregado termino proporcional al grad alpha (presion interfacial)
B(:,ieq(3),1) = B(:,ieq(3),1) + rho_l*delta*alpha_g.*(u_g-u_l).^2;
B(:,ieq(4),1) = B(:,ieq(4),1) - rho_l*delta*alpha_g.*(u_g-u_l).^2;

% matriz reactiva
D = zeros(N,4,4);
%D(:,ieq(3),1) = C_d*(u_g-u_l);
D(:,ieq(3),2) = C_d*alpha_g;
D(:,ieq(3),3) = -C_d*alpha_g;

%D(:,ieq(4),1) = -C_d*(u_g-u_l);
D(:,ieq(4),2) = -C_d*alpha_g;
D(:,ieq(4),3) = C_d*alpha_g;

% vector terminos fuentes
C = zeros(N,4);

C(:,ieq(3)) =  C_d*alpha_g.*(u_g-u_l);
C(:,ieq(4)) = -C_d*alpha_g.*(u_g-u_l);

% beta para PMM
if PMM_method==1,    
    compute_beta_limits;
else
    beta=1;
end

P_st = zeros(nnod,ndf,ndf);
if PMM_method==1,        
    if 1,
        compute_tau_with_pmm;
    else    
        tmp = (beta-1) ./ beta;
        if isempty(find(tmp<0))==0,error(' Check beta values because in the stabilization it is negative and stabilization '); end            
        u_g_st   = u_g.*(1+sqrt(tmp));        
        tau_l    = dx/2 ./abs(u_l);
        tau_cont = dx/2  *abs(u_l);  
        tau_g    = dx/2 ./abs(u_g_st);    
        % liquido
        P_st(:,ieq(2),ieq(4))=tau_l/rho_l;    
        P_st(:,ieq(4),ieq(4))=tau_l.*u_l;
        P_st(:,ieq(4),ieq(2))=tau_cont*rho_l;  
        % gas
        P_st(:,ieq(1),ieq(1))=tau_g.*u_g_st;    
        P_st(:,ieq(3),ieq(3))=tau_g.*u_g_st;    
    end
else
    tau_g    = dx/2 ./abs(u_g);
    tau_l    = dx/2 ./abs(u_l);
    tau_cont = dx/2*abs(u_l);    
    P_st(:,ieq(1),ieq(1))=tau_g.*u_g;
    if 1,
        P_st(:,ieq(2),ieq(4))=tau_l/rho_l;
        P_st(:,ieq(3),ieq(3))=tau_g.*u_g;
        P_st(:,ieq(4),ieq(4))=tau_l.*u_l;
        P_st(:,ieq(4),ieq(2))=tau_cont*rho_l;        
    end    
end

%keyboard;pause

E = zeros(N,ndf,ndf);
E(:,ieq(3),2) = alpha_g*mu_g;
E(:,ieq(4),3) = (1-alpha_g)*mu_l;

A_st=0*A;
B_st=0*B;
D_st=0*D;
for idf=1:ndf,
    for jdf=1:ndf
        for kdf=1:ndf
            %            A_st(:,idf,kdf) = A_st(:,idf,kdf)+P_st(:,idf,jdf).*A(:,jdf,kdf);
            B_st(:,idf,kdf) = B_st(:,idf,kdf)+P_st(:,idf,jdf).*B(:,jdf,kdf);
            D_st(:,idf,kdf) = D_st(:,idf,kdf)+P_st(:,idf,jdf).*D(:,jdf,kdf);         
        end
    end   
end


