syms psi

h = 1;
Ni = 0.5*(1+psi*[-1,1]);
Nj = 0.5*(1+psi*[-1,1]);
gNi = diff(Ni,psi);
gNj = diff(Nj,psi);

Jaco = h/2;

% termino temporal
coe_m = int(Ni(2)*Nj(1),-1,1)*Jaco;
coe_p = int(Ni(1)*Nj(2),-1,1)*Jaco;
coe_0 = (int(Ni(1)*Nj(1),-1,1)+int(Ni(2)*Nj(2),-1,1))*Jaco;
coe_00 = [coe_m,coe_0,coe_p];
coe_00 = double(coe_00);

% termino convectivo
coe_m = int(Ni(2)*gNj(1),-1,1);
coe_p = int(Ni(1)*gNj(2),-1,1);
coe_0 = (int(Ni(1)*gNj(1),-1,1)+int(Ni(2)*gNj(2),-1,1));
coe_01 = [coe_m,coe_0,coe_p];
coe_01 = double(coe_01);

% termino difusivo
coe_m = int(gNi(2)*gNj(1),-1,1)/Jaco;
coe_p = int(gNi(1)*gNj(2),-1,1)/Jaco;
coe_0 = (int(gNi(1)*gNj(1),-1,1)+int(gNi(2)*gNj(2),-1,1))/Jaco;
coe_11 = [coe_m,coe_0,coe_p];
coe_11 = double(coe_11);

% termino estabilizacion antisimetrico
coe_m = int(gNi(2)*Nj(1),-1,1);
coe_p = int(gNi(1)*Nj(2),-1,1);
coe_0 = (int(gNi(1)*Nj(1),-1,1)+int(gNi(2)*Nj(2),-1,1));
coe_10 = [coe_m,coe_0,coe_p];
coe_10 = double(coe_10);

get_data

[A,B,D] = get_matrix(state,param);
[ndf,ndf]=size(A);
P_st = zeros(ndf);
if 1,
    tau_g    = h/2/abs(u_g);
    tau_l    = h/2/abs(u_l);
    tau_cont = 0*h/2*abs(u_g);    
    P_st(1,1)=tau_g*u_g;
    if 1,
        P_st(2,4)=tau_l/rho_l;
        P_st(3,3)=tau_g*u_g;
        P_st(4,4)=tau_l*u_l;
        P_st(4,2)=tau_cont*rho_l;
    end
end

A_st = P_st*A;
B_st = P_st*B;
D_st = P_st*D;

E = zeros(ndf);
if 1,
    E(3,2)=2*mu_g*alpha;
    E(4,3)=2*mu_l*(1-alpha);
end
if 0,
% agregado estabilizacion adicional
E(1,1)=E(1,1)+tau_g*u_g^2*rho_g;
E(3,2)=E(3,2)+tau_g*u_g^2*rho_g;
end

idf=[1,2,3,4];
jdf=[1,2,3,4];
A=A(idf,jdf);B=B(idf,jdf);D=D(idf,jdf);E=E(idf,jdf);
A_st=A_st(idf,jdf);B_st=B_st(idf,jdf);D_st=D_st(idf,jdf);
[ndf,ndf]=size(A);

D_impl = D;
D_expl = D-D_impl;

% lazo sobre los numeros de onda
tol     = 1e-6;
phi_min = 0+tol;
phi_max = 2*pi-tol;
dphi    = (phi_max-phi_min)/Nphi;
phiv= (phi_min:dphi:phi_max);
G = []; phih=[];lhs_h=[];
for phi=phi_min:dphi:phi_max
    if 0,
        Mas_Op = 1/6*(exp(i*phi)+4+exp(-i*phi));            
        Mas_Op = 1;
        Adv_Op = (exp(i*phi)-exp(-i*phi))/2/dx;        
        Dif_Op = -(exp(i*phi)-2+exp(-i*phi))/dx/dx;
        Mas_P_Op = 0 ;
        Adv_P_Op = 0 ;
    else
        Mas_Op = coe_00*exp(i*phi*[-1,0,1]');    
        Mas_Op = [0,1,0]*exp(i*phi*[-1,0,1]');
        Adv_Op = coe_01*exp(i*phi*[-1,0,1]');           
        Dif_Op = coe_11*exp(i*phi*[-1,0,1]');        
        Mas_P_Op = coe_10*exp(i*phi*[-1,0,1]');        
        Adv_P_Op = coe_11*exp(i*phi*[-1,0,1]');                
    end    
    phih   = [phih;phi];
    lhs = (Mas_Op*A + Mas_P_Op*A_st + (Adv_Op*B + Adv_P_Op*B_st + Mas_Op*D_impl + Mas_P_Op*D_st + Dif_Op*E )*dt);
    D = lhs\(Mas_Op*A - Mas_Op*D_expl);
    [Vv,La] = eig(D);
    G=[G;reshape(diag(La),1,ndf)];
    lhs_h=[lhs_h;lhs];
end

figure(1);clf;plot(real(G),imag(G),'.')
hold on; plot(real(cc),imag(cc),'-');
title(['R=' num2str(R) ' /S=' num2str(S) ' /a=' num2str(alpha)])
