%------------------------------------------------------------------
%       Programa   " D R V F E M " 
%------------------------------------------------------------------

if(exist('inicia')==0),
  disp('Ingrese la variable inicia ')
  disp(' inicia == 0 ---> si continua una corrida previa ')
  disp(' inicia ~= 0 ---> si comienza una corrida nueva ')
  inicia = input(' Inicia = ')
end

%------ Ingreso de datos -------------------------------------------

if inicia,
  read_data;
  bfh=[];          % Guarda la solucion
  hc_res=[];       % Guarda la historia de la convergencia en residuo
  hc_du=[];        % Guarda la historia de la convergencia en dphi
  bfh_nc = [];     % Guarda los pasos de tiempo en que no hubo convergencia
  bfh_u=[];        % Guarda la solucion cada nstep pasos de tiempo
  posdat;
  ttime = 0;
end

%------ fin ingreso de datos --------------------------------------

limit = prop(12);

% Loop temporal o pseudotemporal
%------------------------------------------------------------------

for itime=1:ntime,
  ttime = ttime+dt;
  
  phiold = phi;

% Actualiza las condiciones de contorno si fueran funcion del tiempo
% La funcionalidad se lee del archivo "bc_time"
    if exist('bc_time_flag')==1,
	  if (bc_time_flag==1)&(exist('bc_time')~=2), 
	  disp('Debe tener en el directorio de trabajo un archivo de nombre bc_time.m ');
	    error(' bc_time_flag==1 y bc_time file no existe '); 
      end
	  if bc_time_flag==1, bc_time; end
	end
    
  nu    = 0;
  iterflag = 1;
  [numnp,ndf] = size(phi);

while iterflag

  nu= nu+1;
    
%------------------------------------------------------------------
%        Montaje sistema y solucion del problema
%------------------------------------------------------------------

    ijob = 0;
    if type_solver ==2, ijob=-1; end

% ### Generate x-coordinate
fixa_1=v2m(fixa,ndf);
forc_1=v2m(forc,ndf);

idf = 1;
[Kg,Rg] = advdif_2d(xnod,icone,ifaceb,fixa_1(:,idf),forc_1(:,idf),teco,lin_con,prop,... 
            veloc(:,:,idf),reac(:,idf),source(:,idf),phi(:,idf),phiold(:,idf),ijob);
         
phi_nu = phi(:,idf);
         
%solver;
[phi(:,idf),Rg]=solver(phi(:,idf),Rg,Kg,fixa_1(:,idf),prop,prop_solver,1);

Rg_norm = norm(Rg);
dphi_norm = norm(phi(:,idf)-phi_nu);

idf = 2;
[Kg,Rg] = advdif_2d(xnod,icone,ifaceb,fixa_1(:,idf),forc_1(:,idf),teco,lin_con,prop,... 
            veloc(:,:,idf),reac(:,idf),source(:,idf),phi(:,idf),phiold(:,idf),ijob);
         
phi_nu = phi(:,idf);         
%solver;
[phi(:,idf),Rg]=solver(phi(:,idf),Rg,Kg,fixa_1(:,idf),prop,prop_solver,1);

Rg_norm = max([norm(Rg),Rg_norm]);
dphi_norm = max([norm(phi(:,idf)-phi_nu),dphi_norm]);

% Analisis de la convergencia
%------------------------------------------------------------------
  iterflag = (norm(Rg)>limit) & (nu< nu_max); % & (norm(dphi)>limit);

  disp(['time ' num2str(itime) ... 
          ' Iter ' num2str(nu)  ' || R || -----> ' num2str(Rg_norm) ... 
          ' || Delta phi || -----> ' num2str(dphi_norm)  ])

  hc_res  = [hc_res ; Rg_norm];
  hc_du   = [hc_du ; dphi_norm];
  

end  % end while

% Salida grafica de resultados (provista por cada aplicacion)
%------------------------------------------------------------------

plot_fem

if norm(Rg)>limit ,
%  error(' NO CONVERGENCE ');
 bfh_nc = [bfh_nc ; itime];
end

if exist('nsave')==0; nsave=ntime;end

if exist('filesave')==0; filesave='tempo'; end

if rem(itime,nsave)==0, 
  eval(['save ' filesave ';']);
end

if rem(itime,nstep)==0,
  bfh_u = [bfh_u , phi];
end

end % itime loop

