void_solid = 0;

% leemos la malla y la solucion de la corrida
[xnod,icone,state]=proc('trafo_00','tmp');

% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end

[ifaceb,nodes_bou] = pfbou2d(xnod,icone,1);

% obtiene los nodos que no estan conectados a ningun elemento
[free_nodes] = get_free_nodes(xnod,icone);

if void_solid==0 & isempty(free_nodes)==0,
    error(' Solid as fluid should not have free nodes (ficticious) ')
end

% generamos un mapeo de nodo a elementos
[map,ipt] = map_node_to_ele(xnod,icone);

if void_solid>0,
% divido la lista del contorno en aquella parte correspondiente al borde externo y aquella del interno
node_0=1;  % tomo un nodo que pertenece al borde exterior
[bou_ext,bou_int]=split_nodes_bou(xnod,icone,map,ipt,nodes_bou,node_0);
nodes_bou_ext=rmdblist(m2v(bou_ext));
nodes_bou_int=rmdblist(m2v(bou_int));
else
    nodes_bou_ext=rmdblist(m2v(nodes_bou));
end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;

fixa= zeros(numnp,ndf);
fixa(nodes_bou_ext,1)=ones(length(nodes_bou_ext),1);
fixa(free_nodes,1)=ones(length(free_nodes),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc = zeros(numnp,ndf);

%-------- Fuentes de volumen (por elemento)
source = zeros(numel,1);

%--------- Termino reactivo -----------------------------
reac = zeros(numel,1);

%--------- Campo de Velocidad -----------------------------
veloc  =  state(:,1:2);

%-------- Propiedades del material

 rho     = 1    ;
 Cp      = 1    ;
 kappa   = 1;
 npg     =  2   ;
 prop(1) =rho   ;
 prop(2) =Cp    ;
 prop(3) =kappa ;
 prop(4) =npg   ;

 upwind  =    0 ;
 shocap  =    0 ;
 axisim  =    0 ;
% [1] SUPG
% [2] (SU+C)PG
 type_upw =    1;   
 lumped   =   0 ;

 prop(6)  = upwind ;
 prop(7)  = shocap ;
 prop(8)  = axisim ;
 prop(9)  = type_upw;
 prop(11) = lumped ;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%---- Linear restrictions
lin_con = [];

%-------- Solucion inicial (PHI)
phi0 =  0;
for k=1:ndf,
 bini(:,k)   = forc(:,k);
 free        = find(fixa(:,k)==0);
 bini(free,k)= phi0(1,k)*ones(size(free));
end

