%
%  probamos integraciones para volumenes finitos
%

clear all
ndm=2;
N=100;
tol=1e-10;

[psi,eta] = meshgrid(0:1/N:1, 0:1/N:1);

psi=reshape(psi,(N+1)*(N+1),1);
eta=reshape(eta,(N+1)*(N+1),1);
mask = (eta<=((1-psi)+tol));
nn   = find(mask==1);
psi=psi(nn);
eta=eta(nn);

x1=[0,0];
x2=[1,0];
x3=[0,1];

N1=1-psi-eta;
N2=psi;
N3=eta;

for idm=1:ndm
   x(:,idm) = N1*x1(idm)+N2*x2(idm)+N3*x3(idm);
end

figure(1);clf;plot(x(:,1),x(:,2),'.')
