function [tau] = supg_euler_1d(Upg,UPpg,gamma,hele,ndf,tau_TET)
%
% calculo de tau (stabilizacion numerica) para Euler 1D
%
%     [tau] = supg_euler_1d(Upg,UPpg,gamma,hele,ndf,tau_TET)
%


ne = length(Upg(:,1));

% calculo del upwind en cada punto de Gauss  
  cc         = sqrt(gamma*UPpg(:,3)./UPpg(:,1));
  lambda_max = abs(Upg(:,2))+cc;
  if tau_TET,  
  % segun Tezduyar     
    tau  = hele/2 ./ lambda_max;
    %    tau  = tau*[1,0,0,0,1,0,0,0,1];    
    tau_m  = zeros(ne,ndf,ndf);
    for idf=1:ndf
       tau_m(:,idf,idf) = tau;
    end
    tau = tau_m;
    
  else
  % segun una diagonalizacion y descomposicion en autovalores  
   [P,P1,Lambda] = Jaco_cv2chv(Upg,gamma);
   tau  = [ (1 ./ abs(Lambda(:,1))) , cero , cero , ...
         cero , (1 ./ abs(Lambda(:,2))) , cero , ...
         cero , cero , (1 ./ abs(Lambda(:,3))) ];     
   tau  = rowprod(P,tau,ndf,ndf,ndf);
   tau  = rowprod(tau,P1,ndf,ndf,ndf);   
   tau  = ((hele/2)*ones(1,ndf^2)).*tau;
  end

