function [Fc,C] = Cflux(Up,grad_p,vel_l,prop);
%
%   [Fc,C] = Cflux(Up,grad_p,vel_l,prop);
%

rho_g       = prop(1);
visco_g     = prop(2);
gravity     = prop(3);
[N,ndf]     = size(Up);
alpha_g     = Up(:,1);
vel_g       = Up(:,2:3);

Fc          = zeros(N,ndf);
C           = zeros(N,ndf,ndf);

% reactive fluxes due to bouyancy forces
Fc(:,3)     = -rho_g*gravity*alpha_g;
C(:,3,1)    = -rho_g*gravity*ones(N,1);

% reactive fluxes due to pressure gradient
Fc(:,2)     = Fc(:,2)+alpha_g.*grad_p(:,1);
Fc(:,3)     = Fc(:,3)+alpha_g.*grad_p(:,2);
C(:,2,1)    = grad_p(:,1);
C(:,3,1)    = grad_p(:,2);

% reactive and source terms due to drag interaction forces
C_drag      = 0;  % FALTA HACER BIEN ESTO Y AGREGARLO A LA MATRIZ "C"
Fc(:,2)     = Fc(:,2)+C_drag*alpha_g.*(vel_l(:,1)-vel_g(:,1));
Fc(:,3)     = Fc(:,3)+C_drag*alpha_g.*(vel_l(:,2)-vel_g(:,2));
