function [Fd] = Dflux(Up,dUp,prop);
%--------------------------------------------------------------------
%
%         [Fd] = Dflux(Up,dUp,prop);
%
%  Diffusive fluxes for the gas phase in the two phase flow eqs 
%
%--------------------------------------------------------------------

rho_g       = prop(1);
visco_g     = prop(2);
[N,ndf]     = size(Up);
alpha_g     = Up(:,1);
vel_g       = Up(:,2:3);

Fd          = zeros(N,ndf,2);

grad_u      = reshape(dUp(:,2,1:2),N,2);
grad_v      = reshape(dUp(:,3,1:2),N,2);

defo(:,1,1) = grad_u(:,1)+grad_u(:,1);
defo(:,1,2) = grad_u(:,2)+grad_v(:,1);
defo(:,2,1) = grad_v(:,1)+grad_u(:,2);
defo(:,2,2) = grad_v(:,2)+grad_v(:,2);
defo        = defo/2;
tau         = 2*visco_g*defo;

for k=1:2,
    for m=1:2,
        Fd(:,k+1,m) = alpha_g.*tau(:,k,m);
    end
end

