function [Rg,Kg] = linear_constraint(Rg,Kg,lin_con,ndf)
%
%  [Rg,Kg] = linear_constraint(Rg,Kg,lin_con,ndf)
%

scheme = 0;

if scheme==0
    
    lin_con=sort_lin_con(lin_con);
    
    [nr,nc]=size(lin_con);
    
    if rem(nc,3)~=0, error(' lin_con array is corrupted [00] '); end
    nnod  = nc/3;
    if nnod<2,  error(' lin_con array is corrupted [01]'); end
    
    coef1 = lin_con(:,1);
    node1 = lin_con(:,2);
    dof1  = lin_con(:,3);
    
    row=(node1-1)*ndf+dof1;
    col=row;
    coe=ones(nr,1);
    
    for k=2:nnod
        coef = lin_con(:,1+3*(k-1));
        node = lin_con(:,2+3*(k-1));
        dof  = lin_con(:,3+3*(k-1));
        row=[row;(node1-1)*ndf+dof1];
        col=[col;(node-1)*ndf+dof];
        coe=[coe;coef./coef1];
    end
    
    nr = length(row);
    [row0,col0,coe0]=find(Kg);
    
    for ir=1:nr
        nn=find(row0==row(ir));
        coe0(nn)=0;   
        Rg(row(ir),1)=0;
    end
    
    Kg = sparse([row0;row],[col0;col],[coe0;coe]);
    
else
    
    grande = 1e10;
    
    [nr,nc]=size(lin_con);
    if rem(nc,3)~=0, error(' lin_con array is corrupted [00] '); end
    if nc>6, error(' *** linear_constraint *** , nc > 6 is not possible '); end
    
    [bas,ibas] = sort(abs(lin_con(:,[1,4]))');
    ibas = ibas';
    nn=find(ibas(:,2)==2);
    if isempty(nn), lin_con(nn,:) = lin_con(nn,[4,5,6,1,2,3]); end
    %keyboard;pause
    
    coef1 = lin_con(:,1);
    node1 = lin_con(:,2);
    dof1  = lin_con(:,3);
    
    coef2 = lin_con(:,4);
    node2 = lin_con(:,5);
    dof2  = lin_con(:,6);
    
    row1 = (node1-1)*ndf+dof1;
    col1 = row1;
    coe1 = grande*ones(nr,1);
    
    row2 = (node1-1)*ndf+dof1;
    col2 = (node2-1)*ndf+dof2;
    coe2 = grande*coef2./coef1;
    
    row = [row1;row2];
    col = [col1;col2];
    coe = [coe1;coe2];
    
    Rg(row,1) = 0;
    [row0,col0,coe0]=find(Kg);
    Kg = sparse([row0;row],[col0;col],[coe0;coe]);
    
end

