function [At]=Area_valve_Blair(Lv,N_v,D_is,D_os,D_st,D_m,D_p,Cm,phi,Cd)
%
%      phi  : seat angle
%      D_os : outer seat diameter
%      D_is : inner seat diameter
%       N_v : number of valves per cylinder
%        Ap : port area
%        Cd : flow discharge coefficient
%

Lv_lim = (D_os-D_is)/sin(2*phi);

mask = Lv > Lv_lim;

At_1 = pi*Lv*cos(phi).*(D_is+Lv*sin(phi)*cos(phi));
vaux = (Lv-0.5*(D_os-D_is)*tan(phi)).^2+((D_os-D_is)/2).^2;
At_2 = pi*(D_os+D_is)/2*sqrt(vaux);

At   = (1-mask).*At_1+mask.*At_2;
At   = N_v*At;

if 0,
Am   = pi/4*D_m^2;
Ap   = Am/Cm;

mask = At>Ap;
At   = Cd*((1-mask).*At+mask.*Ap);
end