function [dQ_chem] = Cyl_comb(theta,cylinder,U)
%
%  [dQ_chem] = Cyl_comb(theta,cylinder,U)
%
%   coefs Wiebe
%  a        = 6.02;  ! acorde a Blair
%  m        = 1.64   ! acorde a Blair
% 

a   = cylinder.crank_radius;
Bo  = cylinder.bore;
l   = cylinder.rod_length;
Ap  = cylinder.piston_area;
Ach = cylinder.head_area;
rpm = cylinder.rpm;
Vc  = cylinder.Vc;
model_ht  = cylinder.model_ht;
factor_ht = cylinder.factor_ht;
hvap = cylinder.hvap;
Q_fuel = cylinder.Q_fuel;
mass_fuel = cylinder.mass_fuel;

a_wiebe = cylinder.a_wiebe;
m_wiebe = cylinder.m_wiebe;
theta_ig = cylinder.theta_ig;
dtheta_comb = cylinder.dtheta_comb;

omega = rpm * 2 * pi / 60;

pot      = -a_wiebe*((theta-theta_ig)/dtheta_comb)^(m_wiebe+1);
x_burned = 1.0d0 - exp(pot);

xbdot    = (-1)*exp(pot)*(-a)*(m+1)*((theta-theta_ig)/dtheta_comb)^m/dtheta_comb;
xbdot    = omega * xbdot;

dQ_chem = mass_fuel * Q_fuel * xbdot

%dQ_ht_fuel = mass_fuel * xbdot * hvap
