function [Vol_cyl,Area_cyl,Vdot] = Cyl_geo(theta,cylinder)
%
%  [Vol_cyl,Area_cyl,Vdot] = Cyl_geo(theta,cylinder)
%

%global cylinder general_data
%icyl = general_data.icyl;
%ijob = 'get';
%handle_cylinder_props;

a   = cylinder.crank_radius;
Bo  = cylinder.bore;
l   = cylinder.rod_length;
Ap  = cylinder.piston_area;
Ach = cylinder.head_area;
rpm = cylinder.rpm;
Vc  = cylinder.Vc;

% computing the stroke (distance between the cranck axis and piston pin axis)
s = a*cos(theta) + sqrt(l^2-a^2*sin(theta)^2);

% computing the engine volume
Vol_cyl = Vc + pi*Bo^2/4*(l+a-s);

% computing the engine area
Area_cyl = Ach + Ap + pi*Bo*(l+a-s);

% computing the volume rate (dV/dt)
sdot = -(a*sin(theta)+a^2*sin(2*theta)/2/sqrt(l^2-a^2*sin(theta)^2)); 
Vdot = -rpm*2*pi/60*pi*Bo^2/4*sdot;

%ijob = 'set';
%handle_cylinder_props;
