function [h_film] = Cyl_ht(theta,cylinder,U)
%
%  [h_film] = Cyl_ht(theta,cylinder,U)
%


a   = cylinder.crank_radius;
Bo  = cylinder.bore;
l   = cylinder.rod_length;
Ap  = cylinder.piston_area;
Ach = cylinder.head_area;
rpm = cylinder.rpm;
Vc  = cylinder.Vc;
model_ht  = cylinder.model_ht;
factor_ht = cylinder.factor_ht;

ga     = cylinder.ga;
Rgas   = cylinder.Rgas;
Twall  = cylinder.Twall_cyl;

Cv     = Rgas/(ga-1);
Cp     = ga*Cv;

rho    = U(:,1);
T      = U(:,3);

Co_mu(1) = 1.457d-6; 
Co_mu(2) = 110.0d0;
mu       = Co_mu(1)*T^(3.0/2.0)/(Co_mu(2)+T);
Pr       = 0.72;
kk       = mu*Cp/Pr;

omega = rpm * 2 * pi / 60;
Sp  = 4 * a * omega;
Re  = rho*abs(Sp)*Bo/mu;

if(model_ht==1)
Nu   =  0.49 * Re^0.7; 
elseif(model_ht==2)
factor =   factor_ht * 0.035;
Nu = factor*Re^0.8*Pr^0.33;
end

C_h = Nu * kk/Bo;
%C_r = 4.25d-9*((T^4-Twall^4)/(T-Twall));
C_r = 4.25d-9*((T^2+Twall^2)*(T+Twall));
h_film = C_h + C_r;
