function [Kg,Rg] = do_abso_bc_tubes(Kg,Rg,phi,abso_bc_tubes,xnod)
%
%  [Kg,Rg] = do_abso_bc_tubes(Kg,Rg,phi,abso_bc_tubes,xnod)
%

global datos_abso_bc_tubes

ndf = 3;
ga = 1.4;

% abso_bc_tubes.nodes_end = [nodes_int , nodes_end, nodes_ref]
nodes_end = abso_bc_tubes.nodes_end;
type_end = abso_bc_tubes.type_end;  % sirve para las normales en los extremos
ntubes = length(type_end);

dx = [];

for itube=1:ntubes,
    dx = [dx;abs(xnod(nodes_end(itube,2))-xnod(nodes_end(itube,1)))];
end

datos_abso_bc_tubes.ga = ga;
datos_abso_bc_tubes.type_end = type_end;
datos_abso_bc_tubes.dx = dx;

U_in  = phi(nodes_end(:,1),:);
U_end = phi(nodes_end(:,2),:);
U_ref = phi(nodes_end(:,3),:);

Uv = [U_in;U_end;U_ref];
[K,R] = get_num_jacobian('r_abso_bc_tubes',Uv);

nodes_row = [];nodes_col = [];

for k=1:ntubes
    node = (nodes_end(k,2)-1)*ndf+(1:ndf)';
    nodes_row = [nodes_row;node];
end


for m=1:3,
    for k=1:ntubes            
        node = (nodes_end(k,m)-1)*ndf+(1:ndf)';
        nodes_col = [nodes_col;node];        
    end
end

if 1
    [ii,jj,cc]=find(K);
    ir = nodes_row(ii);
    ic = nodes_col(jj);
    
    Kg(nodes_row,nodes_col)=0;
    Rg(nodes_row,1)=0;
    
    if 0,
        Kg = Kg + sparse(ir,ic,cc);
    else
        Kaux = sparse(ir,ic,cc);
        Kg(nodes_row,nodes_col) =  Kg(nodes_row,nodes_col)+Kaux(nodes_row,nodes_col);
    end
    Rg(nodes_row,1)     = R;
else
    
    Kg(nodes_row,nodes_col)=0;
    Rg(nodes_row,1)=0;
    
    Kg(nodes_row,nodes_col) = K;
    Rg(nodes_row,1)     = R;
end

%disp('do_abso_bc_tubes');keyboard;pause