function [Kg,Rg] = do_cylinder(Kg,Rg,phi,cylinder,valve,gral_data)
%
%  [Kg,Rg] = do_cylinder(Kg,Rg,phi,cylinder,valve,gral_data)
%

global datos_cylinder datos_valve datos_gral

ndf = 3;
ga = 1.4;

nodes_end = cylinder.nodes_end;
[ncylinder,nc] = size(nodes_end);

if 0,
    datos_cylinder.ga = ga;
    datos_cylinder.ncylinder = ncylinder;
else
    datos_cylinder = cylinder;
    datos_valve = valve;
    datos_gral  = gral_data;
end

U_adm = phi(nodes_end(:,1),:);  % intake
U_cyl = phi(nodes_end(:,2),:);  % cylinder
U_exh = phi(nodes_end(:,3),:);  % exhaust

Uv = [U_adm;U_cyl;U_exh];
[K,R] = get_num_jacobian('r_cylinder',Uv);

nodes_row = [];nodes_col = [];

for k=1:ncylinder
    node = (nodes_end(k,2)-1)*ndf+(1:ndf)';
    nodes_row = [nodes_row;node];
end


for m=1:3,
    for k=1:ncylinder            
        node = (nodes_end(k,m)-1)*ndf+(1:ndf)';
        nodes_col = [nodes_col;node];        
    end
end

if 1
    [ii,jj,cc]=find(K);
    ir = nodes_row(ii);
    ic = nodes_col(jj);
    
    Kg(nodes_row,nodes_col)=0;
    Rg(nodes_row,1)=0;
    
    if 0,
        Kg = Kg + sparse(ir,ic,cc);
    else
        Kaux = sparse(ir,ic,cc);
        Kg(nodes_row,nodes_col) =  Kg(nodes_row,nodes_col)+Kaux(nodes_row,nodes_col);
    end
    Rg(nodes_row,1)     = R;
else
    
    Kg(nodes_row,nodes_col)=0;
    Rg(nodes_row,1)=0;
    
    Kg(nodes_row,nodes_col) = K;
    Rg(nodes_row,1)     = R;
end

%disp('do_cylinder');keyboard;pause