function [H,Cp,Cpi] = enthalpy(Uc,Up,gamma)
%
%  [H,Cp,Cpi] = enthalpy(Uc,Up,gamma)
%

[N,ndof] = size(Uc);
g1 = gamma-1;
H = Uc;

Cp = zeros(N,ndof,ndof);
Cp(:,1,1) = 1;
Cp(:,2,1) = Up(:,2); 
Cp(:,2,2) = Up(:,1); 
Cp(:,3,2) = Uc(:,2);
Cp(:,3,3) = 1/g1;
Cp(:,3,1) = 0.5*Up(:,2).^2;

Cpi = zeros(N,ndof,ndof);
Cpi(:,1,1) = 1;
Cpi(:,2,1) = -Up(:,2)./Up(:,1);
Cpi(:,2,2) = 1 ./ Up(:,1);
Cpi(:,3,2) = -g1*Up(:,2);
Cpi(:,3,3) = g1;
Cpi(:,3,1) = 0.5*g1*Up(:,2).^2;
