%
%   Ejemplo 1D test condiciones absorbentes 
%
%   1 tubo con condicion absorbente a la salida
%

xnod     =[];
icone    =[];

% abso_bc_tubes.nodes_end = [nodes_int , nodes_end, nodes_ref]
nodes_at_abso_bc = [];

Nxs = [40];
Lxs = [1];
x0s = [0];
y0s = [0];
type_end = [-1,+1];
node_ref = [41,42];
nends = length(type_end);
numnp = 0;
for itube=1:1
    Nx = Nxs(itube);   
    Lx = Lxs(itube);
    x0 = x0s(itube);
    y0 = y0s(itube);
    psi = (0:Nx-1)'/(Nx-1);
    x = x0+psi*Lx;
    xnod  = [xnod;x];    
    icone = [icone;numnp+[ (1:Nx-1)' (2:Nx)' ]];
    % y is only for ploting the real location of the pipes at the junction
    y(numnp+(1:length(x)),1) = y0;
    for kend=1:nends
        if type_end(kend)>0
            nodes_at_abso_bc = [nodes_at_abso_bc;[numnp+[Nx-1,Nx],node_ref(kend)]];
        else
            nodes_at_abso_bc = [nodes_at_abso_bc;[numnp+[2,1],node_ref(kend)]];            
        end
    end
    numnp = length(xnod);    
end

tol = 1e-5;
xmax = max(xnod);
xmin = min(xnod);
nodes_atm_lef = find(abs(xnod-xmin)<tol);
nodes_atm_rig = find(abs(xnod-xmax)<tol);

xnod(node_ref,1) = [xnod(nodes_atm_lef,1);xnod(nodes_atm_rig,1)];

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 3;

fixa= zeros(numnp,ndf);

%fixa(nodes_atm_lef,[1,2]) = ones(length(nodes_atm_lef),2);
%fixa(nodes_atm_rig,[3])   = ones(length(nodes_atm_rig),1);
fixa(node_ref,:) = 1;

%-------- Cargas/Desplazamientos nodales(FORC)
forc = zeros(numnp,ndf);

% At left atm
rho_atm = 1;
pre_atm = 72;
vel_atm = 1;

if 0
    forc(nodes_atm_lef,1)=   rho_atm*ones(length(nodes_atm_lef),1);
    forc(nodes_atm_lef,2)=   vel_atm*ones(length(nodes_atm_lef),1);
    %forc(nodes_atm_lef,3)=   pre_atm*ones(length(nodes_atm_lef),1);
else
    forc(node_ref(1),1) = rho_atm;
    forc(node_ref(1),2) = vel_atm;
    forc(node_ref(1),3) = pre_atm;
end

% At right atm
rho_atm = 1;
pre_atm = 72;
vel_atm = 0;

if 0
    %forc(nodes_atm_rig,3)=   pre_atm*ones(length(nodes_atm_rig),1);
else
    forc(node_ref(2),1) = rho_atm;
    forc(node_ref(2),2) = vel_atm;
    forc(node_ref(2),3) = pre_atm;
end
%-------- Propiedades del material
gamma   = 1.4  ;
Cou     = 0.5  ;
npg     =  2   ;

prop(1) =gamma ;
prop(2) =Cou   ;
prop(3) =npg   ;

upwind   =      1 ;
shocap   =      0 ;
lumped   =      0 ;
type_var = 0;  % conservative variables

prop(4)  = upwind ;
prop(5)  = shocap ;
prop(6)  = lumped ;
prop(7)  = type_var;

matrix_type = 'full';  % arma el jacobiano lo mejor posible
% matrix_type = 'diag';  % solo la matriz de masa y lumped 
%------------------------------------------------------------
% upwind Tezduyar else diagonalizacion analitica
tau_TET = 1;

%------------------------------------------------------------
% debilito termino advectivo Galerkin o no
weak_form = 1;

if exist('matrix_type'),
    if matrix_type=='diag', prop(8) = 0; else prop(8) = 1; end 
end

prop(9) = tau_TET;    
prop(10) = weak_form;

% no se usan pero deben estar 
strg = [];
teco = []; 

% Restricciones lineales ----> Condiciones periodicas
lin_con = [];
%-------- Solucion inicial (PHI)

U      =  ones(numnp,1)*[1,1,72];

if 1,
    DP     = 1;
    sigma  = 1;
    U(:,3) = U(:,3)+DP*exp(-xnod(:,1).^2/sigma);
else
    DP     = 0.1;
    sigma  = 1;
    U(:,1) = U(:,1)+DP*exp(-xnod(:,1).^2/sigma);
end

U(node_ref,:) = forc(node_ref,:);

% conversion a conservativas
%-----------------------------------------------
bini   = U;

for k=1:ndf,
    nofree        = find(fixa(:,k)~=0);
    bini(nofree,k)   = forc(nofree,k);
end

% abso_bc_tubes.nodes_end = [nodes_int , nodes_end, nodes_ref]
abso_bc_tubes.nodes_end = nodes_at_abso_bc;
abso_bc_tubes.type_end=type_end;

bc_time_flag = 0;
bc_time_t_end = 1;