%
%   <file> = Euler_1D_galilean_1.m
%
%   Ejemplo Test Euler : GALILEAN INVARIANCE
%
%   Free stream with [rho,v,p]_infty
%   v fixed to v_infty
%   rho & p unknowns
%

if 0
    v_mesh = -0.0;
else
    v_mesh = -0.5;
end

ALE_flag = 1;
v_infty  = 0.5;
gamma   = 1.4  ;

xnod     =[];
icone    =[];
Nx       = 101;   Lx =  20.0;
psi      = (0:Nx-1)'/(Nx-1);
%x       = sin(-pi/2+psi*pi);
x        = psi*Lx;

%-------- coordenadas (XNOD)
xnod  =  x;

%-------- conectividades (ICONE)
icone = [ (1:Nx-1)' (2:Nx)' ];

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 3;
nodes_lef  = 1;
nodes_rig  = Nx;

rho_L = gamma;
p_L   = 1;

rho_R = gamma;
p_R   = 0.1;

u_L   = v_infty+v_mesh;
u_R   = 0.5*v_infty+v_mesh;

fixa= zeros(numnp,ndf);
if 0
    fixa(nodes_lef,[1,2,3])=ones(length(nodes_lef),3);
    %fixa(nodes_rig,[2,3])=ones(length(nodes_rig),2);        
else
    fixa(nodes_lef,[1,2])=ones(length(nodes_lef),2);
    fixa(nodes_rig,[3])=ones(length(nodes_rig),1);        
end
%fixa(:,2) = 1;

%-------- Cargas/Desplazamientos nodales(FORC)
forc= zeros(numnp,ndf);
if 0
forc(nodes_lef,[1,2,3]) =  ones(length(nodes_lef),1)*[rho_L,u_L,p_L];
%forc(nodes_rig,[2,3]) =  ones(length(nodes_rig),1)*[u_R,p_R];
else
forc(nodes_lef,[1,2]) =  ones(length(nodes_lef),1)*[rho_L,u_L];
forc(nodes_rig,[3]) =  ones(length(nodes_rig),1)*[p_R];
end
%forc(:,2) = u_L;

%-------- Propiedades del material
Cou     = 1.0  ;
npg     =  2   ;

prop(1) =gamma ;
prop(2) =Cou   ;
prop(3) =npg   ;

upwind   =      1 ;
shocap   =      0 ;
lumped   =      0 ;
type_var = 0;  % conservative variables
%type_var = 1;  % characteristics variables NO SE USA

prop(4)  = upwind ;
prop(5)  = shocap ;
prop(6)  = lumped ;
prop(7)  = type_var;
 
matrix_type = 'full';  % arma el jacobiano lo mejor posible
%matrix_type = 'diag';  % solo la matriz de masa y lumped 
%------------------------------------------------------------
% upwind Tezduyar else diagonalizacion analitica
tau_TET = 1;
  
%------------------------------------------------------------
% debilito termino advectivo Galerkin o no
weak_form = 0;

if exist('matrix_type'),
   if matrix_type=='diag', prop(8) = 0; else prop(8) = 1; end 
end

prop(9) = tau_TET;    
prop(10) = weak_form;
prop(11) = ALE_flag;

% no se usan pero deben estar 
strg = [];
teco = []; 

% Restricciones lineales ----> Condiciones periodicas
lin_con = [];

%-------- Solucion inicial (PHI)
U      =  ones(numnp,1)*[rho_L,u_L,p_L];
nn     =  find(xnod>0);
U(nn,1:3) = ones(length(nn),1)*[rho_R,u_R,p_R];

% conversion a conservativas
%-----------------------------------------------
bini   = U;
for k=1:ndf,
 nofree        = find(fixa(:,k)~=0);
 bini(nofree,k)   = forc(nofree,k);
end

if ALE_flag
    bc_time_flag = 1;
end
