%
%   Ejemplo 1D junction 
%
%   3 tubos unidos por una union 2 a 1
%

xnod     =[];
icone    =[];
nodes_at_junction = [];

Nxs = [40,40];
Lxs = [1,1];
x0s = [0,1];
y0s = [0,0];
type_end = [+1,-1];
Areas = [1,2];

Nxs = [40,40];
Lxs = [1,1];
x0s = [0,0];
y0s = [-1,1];
type_end = [+1,+1];
Areas = [1,1];

Nxs = [40,40,80];
Lxs = [1,1,2];
x0s = [0,0,1.1];
y0s = [-1,1,0];
type_end = [+1,+1,-1];
Areas = [1,1,2];

junction.Nxs=Nxs;
junction.Lxs=Lxs;
junction.type_end=type_end;
junction.Area=Areas;

ntubes = length(type_end);
numnp = 0;
for itube=1:ntubes
    Nx = Nxs(itube);   
    Lx = Lxs(itube);
    x0 = x0s(itube);
    y0 = y0s(itube);
    psi = (0:Nx-1)'/(Nx-1);
    x = x0+psi*Lx;
    xnod  = [xnod;x];    
    icone = [icone;numnp+[ (1:Nx-1)' (2:Nx)' ]];
    % y is only for ploting the real location of the pipes at the junction
    y(numnp+(1:length(x)),1) = y0;
    if type_end(itube)>0 
        nodes_at_junction = [nodes_at_junction;numnp+[Nx-1,Nx]];
    else
        nodes_at_junction = [nodes_at_junction;numnp+[1,2]];        
    end    
    numnp = length(xnod);    
end

tol = 1e-5;
xmax = max(xnod);
xmin = min(xnod);
nodes_atm_lef = find(abs(xnod-xmin)<tol);
nodes_atm_rig = find(abs(xnod-xmax)<tol);

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 3;

fixa= zeros(numnp,ndf);
fixa(nodes_atm_lef,[1,3]) = ones(length(nodes_atm_lef),2);
fixa(nodes_atm_rig,[3])   = ones(length(nodes_atm_rig),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc = zeros(numnp,ndf);
forc(nodes_atm_lef,1)=     1*ones(length(nodes_atm_lef),1);
forc(nodes_atm_lef,3)=    72*ones(length(nodes_atm_lef),1);
forc(nodes_atm_rig,3)=    72*ones(length(nodes_atm_rig),1);

%-------- Propiedades del material
 gamma   = 1.4  ;
 Cou     = 0.5  ;
 npg     =  2   ;

 prop(1) =gamma ;
 prop(2) =Cou   ;
 prop(3) =npg   ;

 upwind   =      1 ;
 shocap   =      0 ;
 lumped   =      0 ;
 type_var = 0;  % conservative variables

 prop(4)  = upwind ;
 prop(5)  = shocap ;
 prop(6)  = lumped ;
 prop(7)  = type_var;
 
 matrix_type = 'full';  % arma el jacobiano lo mejor posible
% matrix_type = 'diag';  % solo la matriz de masa y lumped 
%------------------------------------------------------------
% upwind Tezduyar else diagonalizacion analitica
tau_TET = 1;
  
%------------------------------------------------------------
% debilito termino advectivo Galerkin o no
weak_form = 1;

if exist('matrix_type'),
   if matrix_type=='diag', prop(8) = 0; else prop(8) = 1; end 
end

prop(9) = tau_TET;    
prop(10) = weak_form;

% no se usan pero deben estar 
strg = [];
teco = []; 

% Restricciones lineales ----> Condiciones periodicas
lin_con = [];
%-------- Solucion inicial (PHI)

U      =  ones(numnp,1)*[1,1,72];

if 1,
DP     = 1;
sigma  = 1;
U(:,3) = U(:,3)+DP*exp(-xnod(:,1).^2/sigma);
else
DP     = 0.1;
sigma  = 1;
U(:,1) = U(:,1)+DP*exp(-xnod(:,1).^2/sigma);
end

% conversion a conservativas
%-----------------------------------------------
bini   = U;

for k=1:ndf,
 nofree        = find(fixa(:,k)~=0);
 bini(nofree,k)   = forc(nofree,k);
end

junction.nodes_end = nodes_at_junction;

bc_time_flag = 1;
bc_time_t_end = 1;