%
%  test del modelo del cilindro
%

datos_gral.ttime = 0;

datos_cylinder.ga = 1.4;
datos_cylinder.ncylinder = 1;
datos_cylinder.theta_0 = 0;
datos_cylinder.rpm = 1000;
datos_cylinder.dt = 1e-3;
datos_cylinder.Rgas = 287;
datos_cylinder.id_valves = [1,2];
datos_cylinder.nodes_end = [1,3,2];

Bo = 80.0/1000      ; % [ mts ]  
stroke =  85.0/1000    ; % [ mts ]
rc = 7 ;
Vd = pi*Bo^2/4*stroke ;
lrod  = 170/1000;
R  = lrod/(stroke/2);
% cylinder head surface
Ach = pi * Bo^2/4;
% piston crown surface  
Ap  = Ach ;               % we consider flat piston
Vc = Vd/(rc-1);

datos_cylinder.crank_radius = stroke/2 ;
datos_cylinder.bore         = stroke;
datos_cylinder.rod_length   = lrod;
datos_cylinder.piston_area  = Ap;
datos_cylinder.head_area    = Ach;
datos_cylinder.Vc           = Vc;
datos_cylinder.Twall_cyl    = 273+30;
datos_cylinder.pre_old  = 1e5;
datos_cylinder.Tem_old  = 273+30;
datos_cylinder.rho_old  = datos_cylinder.pre_old / ...
                                  (datos_cylinder.Tem_old*datos_cylinder.Rgas);
datos_cylinder.model_ht = 1;
datos_cylinder.factor_ht = 1;

datos_valve(1).type_valve = 'intake';
datos_valve(1).Lvmax = 10/1000;
datos_valve(1).Dv = 40/1000;
datos_valve(1).VO = 0;
datos_valve(1).VC = 210*pi/180;
datos_valve(2).type_valve = 'exhaust';
datos_valve(2).Lvmax = 9/1000;
datos_valve(2).Dv = 30/1000;
datos_valve(2).VO = 540*pi/180;
datos_valve(2).VC =  30*pi/180;

phi_int = [1,1,1e5];
phi_cyl = [1,1e5,300];
phi_exh = [1,0,1e5];    

phi = [phi_int;phi_exh;phi_cyl];

Kg = [];
Rg = [];

tol = 1e-8;
itermax = 20;
iter = 0;
lconv = 1;
while lconv
    iter=iter+1;
    [Kg,Rg] = do_cylinder(Kg,Rg,phi,datos_cylinder,datos_valve,datos_gral);
    free = 6+(1:3);
    Kg = Kg(free,free);
    Rg = Rg(free);
    dphi = inv(Kg)*Rg;
    phi(3,:)=phi(3,:)+reshape(dphi,3,1)';
    lconv = (norm(dphi)>tol)&(iter<itermax);
    disp([' || dphi || = ' num2str(norm(dphi))])
    disp([' || Rg || = ' num2str(norm(Rg))])
end

return

