function [tau] = supg_euler_1d(Upg,UPpg,v_mesh,gamma,hele,ndf,tau_TET)
%
% calculo de tau (stabilizacion numerica) para Euler 1D
%
%     [tau] = supg_euler_1d(Upg,UPpg,gamma,hele,ndf,tau_TET)
%


ne = length(Upg(:,1));

% calculo del upwind en cada punto de Gauss  
cc         = sqrt(gamma*UPpg(:,3)./UPpg(:,1));
lambda_max = abs(UPpg(:,2)-v_mesh)+cc;
if tau_TET,  
    % segun Tezduyar     
    tau  = hele/2 ./ lambda_max;
    %    tau  = tau*[1,0,0,0,1,0,0,0,1];    
    tau_m  = zeros(ne,ndf,ndf);
    for idf=1:ndf
        tau_m(:,idf,idf) = tau;
    end
    tau = tau_m;
    
else
    % segun una diagonalizacion y descomposicion en autovalores  
    [Q,Q1,D] = diagsys(Upg,gamma);
%    Dm = zeros(ne,ndf,ndf);
    tau_m = zeros(ne,ndf,ndf);
    for k=1:ndf
%        Dm(:,k,k)=D(:,k);
        tau_m(:,k,k) = (hele/2) ./ abs(D(:,k)-v_mesh);
    end    
    tau_m  = rowprod(Q,tau_m,ndf,ndf,ndf);
    tau_m  = rowprod(tau_m,Q1,ndf,ndf,ndf);   
%    tau  = ((hele/2)*ones(1,ndf^2)).*tau_m;
%    tau  = reshape(tau,ne,ndf,ndf);
%    disp(' supg_euler_1d ');keyboard;pause
    tau = tau_m;
end

