function [alfa,G,q]=source4(U,dAreax,T_wall,gamma,R_gas,Area)
%
%   computes source term for 
%         variable section
%         friction flow
%         heat transfer
%
%    U in primitive variables
%

g1           = gamma-1;
viscous_flow = 1;
heat_flow    = 1;
Cv           = R_gas/g1;
[nnod,ndf]   = size(U);

pres   = U(:,3);
rho    = U(:,1);
vel    = U(:,2);
Temp   = pres./rho/R_gas;

% variable section
   alfa = dAreax./Area;
   G = zeros(nnod,1);
   q = zeros(nnod,1);
   
   if viscous_flow ==1, 

Cf_codo      = 0;
Dia          = sqrt(4*Area/pi);
% viscosity coefficient
Co_mu        = [1.457e-6  110]; % taken from 1st homework of Abraham course 
% dynamic viscosity
mu           = Co_mu(1)*Temp.^(3/2) ./ (Co_mu(2) + Temp ) ; % [Pascal sec]
Re           = abs(rho.*vel) .* Dia ./ mu;
Re           = max(Re,ones*1e-10);
ff           = 0.2373*ones(nnod,1) ./ Re.^(0.25);
Cf_rect      = 4*ff ./Dia ;
Cf           = Cf_codo+Cf_rect ;

% Fuente por friccion
       G = Cf/2 .*vel.*abs(vel);             
   end

   if heat_flow == 1,
% Fuente por intercambio termico
%       Twall        = prop(4);
       GGG          = abs(rho.*vel)*3600; % en Kg/m^2/hora
       alfap        = 0.004*(GGG).^(0.8) ./ (Dia.^(0.2));
       Th_equiv     = 4187 ;  % 4187 Joules = 1 Kcal
       qptot        = 4*alfap.*(T_wall-Temp) ./ Dia .* Area * Th_equiv;
       qptot        = qptot / 3600 ;
       q            = qptot./rho;          
    end

% disp(' SOURCE4 ');keyboard;pause