function [Kg,Rg] = do_valve(Kg,Rg,phi,valve,gral_data)
%
%  [Kg,Rg] = do_cylinder(Kg,Rg,phi,cylinder,valve,gral_data)
%

global datos_valve datos_gral

ndf = 3;

nvalves = length(valve);
for k=1:nvalves
    nodes_end(k,:) = valve(k).nodes_end;
end

datos_valve = valve;
datos_gral  = gral_data;

U_pipe_int = phi(nodes_end(:,1),:);  % pipe interior node
U_pipe_end = phi(nodes_end(:,2),:);  % pipe end node
U_valve_th = phi(nodes_end(:,3),:);  % valve throat
U_cylinder = phi(nodes_end(:,4),:);  % cylinder state

%disp('do_valve');keyboard;pause

Uv = [U_pipe_int;U_pipe_end;U_valve_th;U_cylinder];
[K,R] = get_num_jacobian('r_valve',Uv);

nodes_row = [];nodes_col = [];

for k=1:nvalves
    for m=2:3
        node = (nodes_end(k,m)-1)*ndf+(1:ndf)';
        nodes_row = [nodes_row;node];
    end
end


for m=1:4,
    for k=1:nvalves            
        node = (nodes_end(k,m)-1)*ndf+(1:ndf)';
        nodes_col = [nodes_col;node];        
    end
end

if 1
    [ii,jj,cc]=find(K);
    ir = nodes_row(ii);
    ic = nodes_col(jj);
    
    Kg(nodes_row,nodes_col)=0;
    Rg(nodes_row,1)=0;
    
    if 0,
        Kg = Kg + sparse(ir,ic,cc);
    else
        Kaux = sparse(ir,ic,cc);
        if max(ic)<max(nodes_col), Kaux(max(nodes_row),max(nodes_col))=0; end
        Kg(nodes_row,nodes_col) =  Kg(nodes_row,nodes_col)+Kaux(nodes_row,nodes_col);
    end
    Rg(nodes_row,1)     = R;
else
    
    Kg(nodes_row,nodes_col)=0;
    Rg(nodes_row,1)=0;
    
    Kg(nodes_row,nodes_col) = K;
    Rg(nodes_row,1)     = R;
end

