Nx = 100;
Lx = 1;
xnod = (0:Nx)'/Nx*Lx;
dxs = diff(xnod);

%type_end = [-1];

ga = 1.4;
dx = dxs(end,1);

rho_p = ga;
p_p   = 1;
%u_p   = -0.5;

rho_c = ga;
p_c   = 1;
T_c   = 1;

if type_end>0
    x_P = xnod(1,1);
    indx_int = 2;
    indx_end = 1;
    vaxis = [0. 0.1 1.25 1.6];    
else
    x_P = xnod(end,1);
    indx_int = Nx;
    indx_end = Nx+1;
    vaxis = [0.9 1 1.25 1.6];    
end


U = ones(Nx+1,1)*[rho_p,u_p,p_p];
U_ext = [rho_c,p_c,T_c];

kn = 3*2*pi/Lx;
T  = 2;
omega = 2*pi/T;
ntime = 100;
dt    = 0.005;

figure(1);clf;
for itime=1:ntime
    ttime = itime*dt;
    U(:,1) = rho_p*(1+0.1*sin(kn*xnod+omega*ttime));
    U_int = U(indx_int,:);
    U_end = U(indx_end,:);
    [U_S,U_R,indx_tubes_out,x_S,x_R] = valve_model_get_state(U_int,U_end,U_ext,dx,dt,x_P,type_end);    
    if isempty(indx_tubes_out)==0,
        plot(xnod,U(:,1),'-x',x_S,U_S(:,1),'ro',x_R,U_R(:,1),'g*');    
    else
        plot(xnod,U(:,1),'-x',x_S,U_S(:,1),'ro');            
    end
    axis(vaxis)
    pause
%    keyboard;pause    
end


return

