function [Kg,Rg] = do_junction(Kg,Rg,phi,junction,xnod)
%
%  [Kg,Rg] = do_junction(Kg,Rg,phi,junction,xnod)
%

global datos

ndf = 3;

ga = 1.4;

nodes_end = junction.nodes_end;
Area = junction.Area;
type_end = junction.type_end;
ntubes = length(type_end);
dx = [];

for itube=1:ntubes,
    dx = [dx;xnod(nodes_end(itube,2))-xnod(nodes_end(itube,1))];
end

datos.ga = ga;
datos.type_end = type_end;
datos.Area=Area;

U_in=[];
nodes_tube_end = [];
nodes_tube_int = [];

for k=1:length(type_end)
    if type_end(k)>0,
        U_in = [U_in;phi(nodes_end(k,1),:)];
        nodes_tube_end = [nodes_tube_end;nodes_end(k,2)];
        nodes_tube_int = [nodes_tube_int;nodes_end(k,1)];
    else
        U_in = [U_in;phi(nodes_end(k,2),:)];  
        nodes_tube_end = [nodes_tube_end;nodes_end(k,1)];
        nodes_tube_int = [nodes_tube_int;nodes_end(k,2)];        
    end
end

%U_in = cv2pv(U_in,ga,-1);

datos.U_in = U_in;  % estado en el nodo inmediato interior a cada tubo
datos.dx = dx;    % tamao celda extrema de cada tubo en la union 

%U = 0.95*U_in;
%keyboard;pause
U=phi(nodes_tube_end,:);

[K,R] = get_num_jacobian('r_junction',[U;U_in]);

nodes_row = [];nodes_col = [];

for k=1:ntubes
    node = (nodes_tube_end(k)-1)*ndf+(1:ndf)';
    nodes_row = [nodes_row;node];
end

nodes_col = nodes_row;
for k=1:ntubes    
    node = (nodes_tube_int(k)-1)*ndf+(1:ndf)';
    nodes_col = [nodes_col;node];        
end

Kg(nodes_row,nodes_col)=0;
Rg(nodes_row,1)=0;

%Rg=1e-16*Rg;
%Kg=1e-16*Kg;

Kg(nodes_row,nodes_col) = K;
Rg(nodes_row,1)     = R;

%keyboard;pause