
if ~ALE_flag, 
    v_mesh = 0;
else
    if(size(xnod,2)~=2), error(' xnod tiene que tener dos columnas para las coordenadas viejas y las actuales'); end
    vnod_mesh = (xnod(:,1)-xnod(:,2))/dt;
end

ne   = length(eles);
hele = xnod(icone(:,2),1)-xnod(icone(:,1),1); 
cero = zeros(ne,1);  

% Localizacion de las variables
%------------------------------------------------------------------

for inod=1:nen,
    nodes = icone(eles,inod);
    jnod = (inod-1)*ndf+(1:ndf);
    Ue(:,jnod) = U(nodes,1:ndf);		 
    U0e(:,jnod) = Uold(nodes,1:ndf);   
    if ALE_flag,
        ve_mesh(:,inod) = vnod_mesh(nodes,1);
    end
    Area_e(:,inod) = Area(nodes);    
end

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------

for ipg=1:npg
    
    % Calculo de transformacion isoparametrica y funciones de forma
    %------------------------------------------------------------------
    [X2S,S2X,Jaco]  = xy2st(xnod(:,1),icone(eles,:),psipg(ipg));
    [dNdx,N]        = shape1d(X2S,psipg(ipg),nen); 
    xsj             =  wpg(ipg) .* Jaco;
    
    % Interpolacion en punto de Gauss
    %------------------------------------------------------------------
    
    Upg     = zeros(ne,ndf);
    U0pg    = zeros(ne,ndf);
    dUpg    = zeros(ne,ndf);
    v_mesh  = zeros(ne,1);
    Area_pg = zeros(ne,1);
    dAreadx = zeros(ne,1);
    
    for inod=1:nen,
        jnod = (inod-1)*ndf+(1:ndf);
        Upg(:,(1:ndf))  =  Upg(:,(1:ndf)) + N(inod).*  Ue(:,jnod);
        U0pg(:,(1:ndf))  = U0pg(:,(1:ndf)) + N(inod).* U0e(:,jnod);
        dUpg(:,(1:ndf))  = dUpg(:,(1:ndf)) + (dNdx(:,inod)*ones(1,ndf)).* Ue(:,jnod);	 
        if ALE_flag
            v_mesh           = v_mesh + N(inod)*ve_mesh(:,inod);
        end
        Area_pg    = Area_pg + N(inod)*Area_e(:,inod);        
        dAreadx    = dAreadx + dNdx(:,inod).*Area_e(:,inod);                
    end
    
    U0Cpg = cv2pv(U0pg,gamma,-1);  % pasaje de variables conservativas a primitivas
    UCpg = cv2pv(Upg,gamma,-1);  % pasaje de variables conservativas a primitivas
    
    [H_old,bas,bas] = enthalpy(U0Cpg,U0pg,gamma);
    [H,Cp,Cpi] = enthalpy(UCpg,Upg,gamma);
    
    if 0
        Upg_supg = Upg;
        Upg_supg(:,2) = Upg_supg(:,2)-v_mesh;
        UCpg_supg = cv2pv(Upg_supg,gamma,-1);
        [tau] = upwind*supg_euler_1d(UCpg_supg,Upg_supg,0*v_mesh,gamma,hele,ndf,tau_TET);                
    else
        [tau] = upwind*supg_euler_1d(UCpg,Upg,v_mesh,gamma,hele,ndf,tau_TET);        
    end
    
    if tau_TET<0
        tau = rowprod(Cp,tau,ndf,ndf,ndf);
        tau = rowprod(tau,Cpi,ndf,ndf,ndf);
    end
    
    [Fa,Ax] = fluxa_1D(UCpg,Upg,gamma,Cp);   
    
    AgU = rowprod(Ax,dUpg(:,1:ndf),ndf,ndf,1);    
    
    % terminos fuente (cambio de area + friccion + transferencia de calor
    % en pared )
    H_source = source_euler_1D(UCpg,Upg,dAreadx,Area_pg);
    
    if 0
        Atau_tmp = rowprod(Ax,tau,ndf,ndf,ndf); 
        Atau = rowprod(Atau_tmp,Cpi,ndf,ndf,ndf); 
    else
        Atau_tmp = rowprod(Cpi,tau,ndf,ndf,ndf); 
        %Atau_tmp = rowprod(tau,Cpi,ndf,ndf,ndf); 
        tmp1 = Ax - reshape((v_mesh*ones(1,9)),ne,ndf,ndf).*Cp;
        Atau = rowprod(tmp1,Atau_tmp,ndf,ndf,ndf);         
    end
    
    %   disp('elem_Euler_1D_2');keyboard;pause
    
    for idf=1:ndf           
        xsjm(:,:,idf) = xsj*ones(1,ndf);           
    end
    
    % ALE terms
    if ALE_flag
        for idf=1:ndf
            tmp(:,idf) = v_mesh.*dUpg(:,idf);           
        end       
        Fa_ALE = rowprod(Cp,tmp,ndf,ndf,1);
    end
    
    %------ Matriz de masa 
    
    for inod=1:nen,
        
        for idf=1:ndf,
            P_supg(:,:,idf) = Atau(:,:,idf).*(dNdx(:,inod)*ones(1,ndf));
        end     
        
        W_supg = P_supg;        
        for idf=1:ndf,
            W_supg(:,idf,idf)=W_supg(:,idf,idf)+N(inod);
        end
        
        for jnod=1:nen,
            ter1 = N(inod)*N(jnod) / dt ; 
            for idf=1:ndf
                for jdf=1:ndf
                    Mele(:,inod,idf,jnod,jdf) = Mele(:,inod,idf,jnod,jdf) + ...
                        Cp(:,idf,jdf).*ter1.*xsj;
                end               
            end        
            
            if weak_form,
                for idf=1:ndf,
                    ter2(:,:,idf) = -((dNdx(:,inod)*N(jnod))*ones(1,ndf)).*Ax(:,:,idf);
                end        
            else
                for idf=1:ndf,        
                    ter2(:,:,idf) = +((dNdx(:,jnod)*N(inod))*ones(1,ndf)).*Ax(:,:,idf); 
                end        
            end
            
            if(ALE_flag)
                % ALE Galerkin terms  
                for idf=1:ndf,                        
                    ter2_ALE(:,:,idf) = -(((dNdx(:,jnod)*N(inod)).*v_mesh)*ones(1,ndf)).*Cp(:,:,idf);
                end                
                ter2 = ter2 + ter2_ALE;
            end
            
            % stabilization SUPG terms
            
            ter00(:,:,jnod) = (dNdx(:,jnod)*ones(1,ndf));
            for idf=1:ndf        
                AgN(:,:,idf)  = Ax(:,:,idf).*ter00(:,:,jnod);        
            end
            
            ter3 = rowprod(P_supg,AgN,ndf,ndf,ndf);                      
            
            if(ALE_flag)
                tmp_ALE = dNdx(:,jnod).*v_mesh;
                tmp_ALE_2 = rowprod(P_supg,Cp,ndf,ndf,ndf);                
                % ALE stabilization terms  
                for idf=1:ndf,           
                    ter3_ALE(:,:,idf) = -(tmp_ALE*ones(1,ndf)).*tmp_ALE_2(:,:,idf);
                end                
                ter3 = ter3 + ter3_ALE;
            end            
            
            Mele(:,inod,1:ndf,jnod,1:ndf) = Mele(:,inod,1:ndf,jnod,1:ndf) + ...
                reshape((ter2+ter3).*xsjm,ne,1,ndf,1,ndf);
            %        (1*ter2+1*ter3).*(xsj*ones(1,ndf,ndf));                 
        end
    end
    
    
    %disp('HOLA');keyboard;pause
    
    %------ Residuo
    for inod=1:nen,
        % temporal terms
        ter1 = N(inod)*(H-H_old)/dt;
        % advective term
        if weak_form,
            ter2 = -(dNdx(:,inod)*ones(1,ndf)).*Fa(:,1:ndf);
        else
            ter2 = (N(inod)*ones(numel,ndf)).* AgU(:,1:ndf);
        end
        
        if(ALE_flag)
            % ALE Galerkin terms            
            ter2_ALE = -N(inod)*Fa_ALE;
            ter2 = ter2 + ter2_ALE;
        end
        
        % stabilization SUPG terms   
        for idf=1:ndf,
            P_supg(:,:,idf) = Atau(:,:,idf).*(dNdx(:,inod)*ones(1,ndf));
        end   
        
        ter3   = rowprod(P_supg,AgU,ndf,ndf,1);    

        % source terms
        ter4 = -N(inod)*H_source;

        if(ALE_flag)
            % ALE stabilization terms            
            ter3_ALE = -rowprod(P_supg,Fa_ALE,ndf,ndf,1);
            ter3 = ter3 + ter3_ALE;
        end
        
        vaux(1:ne,1,1:ndf) = (ter1+ter2+ter3+ter4).*(xsj*ones(1,ndf));    
        Rele(:,inod,1:ndf) = Rele(:,inod,1:ndf) - vaux ;    
        
    end % inod
    
end % ipg


% ------ Terminos de contorno

if weak_form,
    [Rele,Mele] = bc_conv_euler_1D(xnod,icone,Ue,ifaceb,Rele,Mele,gamma,matrix_type);   
end
