%
%   Ejemplo 1D junction 
%
%   2 tubos unidos por una union
%

xnod     =[];
icone    =[];
Nx       = 51;   Lx =  5.0;
psi      = (0:Nx-1)'/(Nx-1);
%x       = sin(-pi/2+psi*pi);
x        = -2.5+psi*Lx;

%-------- coordenadas (XNOD)
xnod  =  x;

%-------- conectividades (ICONE)
icone = [ (1:Nx-1)' (2:Nx)' ];

xmax = max(xnod);
xmin = min(xnod);

[numnp,ndm]=size(xnod);

xnod = [xnod;xnod+(xmax-xmin)];
icone = [icone; numnp+[(1:Nx-1)' (2:Nx)']];

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 3;
nodes_lef  = 1;
nodes_rig  = numnp;

fixa= zeros(numnp,ndf);
fixa(nodes_lef,[1,2])=ones(length(nodes_lef),2);
fixa(nodes_rig,[3])=ones(length(nodes_rig),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc= zeros(numnp,ndf);
forc(nodes_lef,1)=    1*ones(length(nodes_lef),1);
forc(nodes_lef,2)=    3*ones(length(nodes_lef),1);
forc(nodes_rig,3)=    72*ones(length(nodes_rig),1);

if 0
    fixa=ones(numnp,ndf);
    fixa([Nx;Nx+1],:)=0;
    forc=ones(numnp,1)*[1,1,72];
    forc([Nx;Nx+1],:)=0;
end


%-------- Propiedades del material
 gamma   = 1.4  ;
 Cou     = 0.5  ;
 npg     =  2   ;

 prop(1) =gamma ;
 prop(2) =Cou   ;
 prop(3) =npg   ;

 upwind   =      1 ;
 shocap   =      0 ;
 lumped   =      0 ;
type_var = 0;  % conservative variables
%type_var = 1;  % characteristics variables NO SE USA

 prop(4)  = upwind ;
 prop(5)  = shocap ;
 prop(6)  = lumped ;
 prop(7)  = type_var;
 
 matrix_type = 'full';  % arma el jacobiano lo mejor posible
% matrix_type = 'diag';  % solo la matriz de masa y lumped 
%------------------------------------------------------------
% upwind Tezduyar else diagonalizacion analitica
tau_TET = 1;
  
%------------------------------------------------------------
% debilito termino advectivo Galerkin o no
weak_form = 1;

if exist('matrix_type'),
   if matrix_type=='diag', prop(8) = 0; else prop(8) = 1; end 
end

prop(9) = tau_TET;    
prop(10) = weak_form;

% no se usan pero deben estar 
strg = [];
teco = []; 

% Restricciones lineales ----> Condiciones periodicas
lin_con = [];

%-------- Solucion inicial (PHI)

U      =  ones(numnp,1)*[1,3,72];

if 1,
DP     = 1;
sigma  = 1;
U(:,3) = U(:,3)+DP*exp(-xnod(:,1).^2/sigma);
else
DP     = 0.1;
sigma  = 1;
U(:,1) = U(:,1)+DP*exp(-xnod(:,1).^2/sigma);
end

% conversion a conservativas
%-----------------------------------------------
bini   = U;

for k=1:ndf,
 nofree        = find(fixa(:,k)~=0);
 bini(nofree,k)   = forc(nofree,k);
end

%bini([Nx;Nx+1],:) = 0.95*bini([Nx;Nx+1],:);
%bini    =  pv2cv(bini,gamma);

junction.nodes_end = [Nx-1,Nx;Nx+1,Nx+2];