%
%   Ejemplo Euler 1D : conv-div nozzle
%

global prop_nod prop_ele

xnod     =[];
icone    =[];
Nx       = 101;   Lx =  20.0;
psi      = (0:Nx-1)'/(Nx-1);
%x       = sin(-pi/2+psi*pi);
x        = -Lx/2+psi*Lx;

%-------- coordenadas (XNOD)
xnod  =  x;

%-------- conectividades (ICONE)
icone = [ (1:Nx-1)' (2:Nx)' ];

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
xmin = min(xnod);
xmax = max(xnod);
[numel,nen]=size(icone);
ndf = 3;
nodes_lef  = 1;
nodes_rig  = Nx;

%-------- Cargas/Desplazamientos nodales(FORC)
rho_in  = 1;
u_in    = 0.25;
p_in    = 0.72;

rho_out = 1;
u_out   = 0.25;
p_out   = 0.65;

rho_L = rho_in;
rho_R = rho_out;
u_L   = u_in;
u_R   = u_out;
p_L   = p_in;
p_R   = p_out;

fixa_abso = 1;

if fixa_abso
    xnod(numnp+(1:2),:) = xnod([1,numnp],:);

    fixa= zeros(numnp,ndf);
    fixa(numnp+1,[1,2,3])=ones(1,3);
    fixa(numnp+2,[1,2,3])=ones(1,3);
    
    forc= zeros(numnp,ndf);
    forc(numnp+1,1:3) =  [rho_in,u_in,p_in];
    forc(numnp+2,1:3) =  [rho_out,u_out,p_out];
    
else
    fixa= zeros(numnp,ndf);
    fixa(nodes_lef,[1,2])=ones(length(nodes_lef),2);
    fixa(nodes_rig,[3])=ones(length(nodes_rig),1);
   
    forc= zeros(numnp,ndf);
    forc(nodes_lef,1:2) =  ones(length(nodes_lef),1)*[rho_in,u_in];
    forc(nodes_rig,3) =  ones(length(nodes_rig),1)*[p_out];    
end


%-------- Propiedades del material
gamma   = 1.4  ;
Cou     = 1.0  ;
npg     =  2   ;

prop(1) =gamma ;
prop(2) =Cou   ;
prop(3) =npg   ;

upwind   =      1 ;
shocap   =      0 ;
lumped   =      0 ;
type_var = 0;  % conservative variables
%type_var = 1;  % characteristics variables NO SE USA

prop(4)  = upwind ;
prop(5)  = shocap ;
prop(6)  = lumped ;
prop(7)  = type_var;

matrix_type = 'full';  % arma el jacobiano lo mejor posible
%matrix_type = 'diag';  % solo la matriz de masa y lumped 
%------------------------------------------------------------
% upwind Tezduyar else diagonalizacion analitica
tau_TET = 1;

%------------------------------------------------------------
% debilito termino advectivo Galerkin o no
weak_form = 1;

if exist('matrix_type'),
    if matrix_type=='diag', prop(8) = 0; else prop(8) = 1; end 
end

prop(9) = tau_TET;    
prop(10) = weak_form;

% no se usan pero deben estar 
strg = [];
teco = []; 

% Restricciones lineales ----> Condiciones periodicas
lin_con = [];

%-------- Solucion inicial (PHI)
U      =  ones(numnp,1)*[rho_L,u_L,p_L];
if 0
nn     =  find(xnod>0);
U(nn,1:3) = ones(length(nn),1)*[rho_R,u_R,p_R];
end
%U(1:numnp,1) = U(1:numnp,1).*(1+0.1*exp(-(xnod(1:numnp,1)/(0.25*Lx)).^2));

if fixa_abso
    U(numnp+(1:2),:) = U([1,numnp],:);
end

% conversion a conservativas
%-----------------------------------------------
bini   = U;
for k=1:ndf,
    nofree        = find(fixa(:,k)~=0);
    bini(nofree,k)   = forc(nofree,k);
end

%bini    =  pv2cv(bini,gamma);

% nodal properties (Area)
psi = (xnod-xmin)/(xmax-xmin);
Area = 0.1+psi*0.1;
Area = 0.1*ones(numnp,1);
Area = 0.2-0.1*((tanh((psi-0.5)/0.25)+1)/2);
prop_nod = Area;
prop_ele = [];

nodes_at_abso_bc = [];
if fixa_abso
    % absorbent bc 
    type_end = [-1,+1];
    node_ref = numnp+[1,2];
    for iend=1:2
        if type_end(iend)<0
            nodes_at_abso_bc = [nodes_at_abso_bc;[2,1,node_ref(iend)]];
        else
            nodes_at_abso_bc = [nodes_at_abso_bc;[numnp-1,numnp,node_ref(iend)]];
        end
    end    
    abso_bc_tubes.nodes_end = nodes_at_abso_bc;
    abso_bc_tubes.type_end=type_end;
end
