function H = source_euler_1D(UCpg,UPpg,dareax,area)
%
%   H_source = source_euler_1D(UCpg,UPpg,dareax,area)
%
%  UCpg : conservative variables (rho, rho*vel, rho*ene)
%  UPpg : primitive variables  (rho, vel, pre)
%

factor = -dareax./area;

H(:,1) = factor.*UCpg(:,2);
H(:,2) = factor.*UCpg(:,2).^2./UCpg(:,1);
H(:,3) = factor.*(UCpg(:,3)+UPpg(:,3)).*UPpg(:,2);