function [Fc,C] = Cflux(Up,dUp,alpha_g,prop,job)
%
%   [Fc,C] = Cflux(Up,dUp,alpha_g,prop,job)
%

ijob = 'get';
handle_prop_elem;

[N,ndf]      = size(Up);
pre          = Up(:,1);
vel_l        = Up(:,2:3);

alpha_l      = 1-alpha_g;

grad_v_l = dUp(:,2:3,1:2);

Fc           = zeros(N,ndf);
C            = zeros(N,ndf,ndf);

field = [1,1,1];

if job==1, field(3)=0; end
if job==2, field(1:2)=zeros(2,1); end

if field(1),
    % reactive fluxes due to bouyancy forces
    Fc(:,3)     = -rho_l*gravity*alpha_l;
end

