function [Fa,Ax,Ay] = Flux_function(Up,alpha_g,prop)
%
%            [Fa,Ax,Ay] = Flux_function(Up,alpha_g,prop)
%
%       Computes advective fluxes F_a
%                   2D    
%	 Dimension of Fa array = numnp x ndm*ndf 
%             

ndm         = 2;

ijob = 'get';
handle_prop_elem;
[N,ndf]     = size(Up);

pre     = Up(:,1);
vel_l   = Up(:,2:3);
alpha_l = 1-alpha_g;

% advective fluxes
Fa            = zeros(N,ndf,2);
A             = zeros(N,ndm,ndf,ndf);

Fa(:,1,1:2)   = rho_l*(alpha_l*[1,1]).*vel_l;
Fa(:,2,1)     = alpha_l.*(rho_l*vel_l(:,1).*vel_l(:,1));
Fa(:,3,1)     = alpha_l.*(rho_l*vel_l(:,1).*vel_l(:,2));
Fa(:,2,2)     = alpha_l.*(rho_l*vel_l(:,2).*vel_l(:,1));
Fa(:,3,2)     = alpha_l.*(rho_l*vel_l(:,2).*vel_l(:,2));

if weak_form
Fa(:,2,1)     = Fa(:,2,1) + alpha_l.*pre;
Fa(:,3,2)     = Fa(:,3,2) + alpha_l.*pre;
end

A(:,1,1,2)    = rho_l*alpha_l;
A(:,2,1,3)    = rho_l*alpha_l;
A(:,1,2,1)    = alpha_l;
A(:,2,3,1)    = alpha_l;

A(:,1,2,2)    = 2*rho_l*alpha_l.*vel_l(:,1);
A(:,1,3,2)    = rho_l*alpha_l.* vel_l(:,2);
A(:,1,3,3)    = rho_l*alpha_l.* vel_l(:,1);

A(:,2,2,2)    = rho_l*alpha_l.*vel_l(:,2);
A(:,2,2,3)    = rho_l*alpha_l.*vel_l(:,1);
A(:,2,3,3)    = 2*rho_l*alpha_l.*vel_l(:,2);

Ax         = reshape(A(:,1,:,:),N,ndf,ndf);
Ay         = reshape(A(:,2,:,:),N,ndf,ndf);      
