%
%  K predictor & poisson and R predictor
%

u_gu = rowprod(dUpg(:,indx_v,:),Upg(:,indx_v),ndm,ndm,1);

visco_model = 1;  % [0] modelo viscoso basado en solo la parte de la div grad vel
visco_model = 0;  % [0] modelo viscoso normalmente usado ( div grad vel + grad div vel )

if visco_model==0
    strain_rate = row_transp(dUpg(:,indx_v,:));
    strain_rate = 0.5*(strain_rate + dUpg(:,indx_v,:));
    sigma       = 2*visco*strain_rate;
else
    strain_rate = alpha*dU1pg(:,indx_v,:);
    strain_rate = strain_rate + (1-alpha)*dU0pg(:,indx_v,:);
    strain_rate = row_transp(strain_rate);
    sigma       = visco*strain_rate;
end

terd        = rowprod(dshapex,sigma,nen,ndm,ndm);
dshapex_t   = row_transp(dshapex);
terd_m      = visco*rowprod(dshapex,dshapex_t,nen,ndm,nen);

grad_p = reshape(dU0pg(:,indx_p,:),ne,ndm,1);    

for inod=1:nen,   
    
    if tau_centroide==0,
        compute_P_supg;
    end
    
    W_supg = P_delta;      
    for idf=1:ndm,
        W_supg(:,idf,idf)=W_supg(:,idf,idf)+N(inod);
    end
    
    % Residual assembling        
    R_mom = (U1pg(:,indx_v)-U0pg(:,indx_v))/dt+u_gu+grad_p;
    R_mom_2 = 0*(U1pg(:,indx_v)-U0pg(:,indx_v))/(dt) + u_gu;
    R_mom_1 = 1*(U1pg(:,indx_v)-U0pg(:,indx_v))/dt + grad_p;
    
    for idm=1:ndm
        Rele(:,inod,indx_v(idm)) = Rele(:,inod,indx_v(idm)) - ( ...  
            W_supg(:,idm,idm).*R_mom_2(:,idm) + ...                  % momentum residual ( Galerkin + SUPG )
            N(inod).*R_mom_1(:,idm) + ...                  % momentum residual ( Galerkin + SUPG )
            terd(:,inod,idm) ...
            ).*xsj;                 
        
    end
    
    % Matriz assembling
    for jnod=1:nen,        
        
        u_gN = zeros(ne,ndm);
        for idm=1:ndm
            for jdm=1:ndm
                u_gN(:,idm) = u_gN(:,idm) + dshapex(:,jnod,jdm).*Upg(:,indx_v(jdm));
            end
        end            
        
        %keyboard;pause
        for idm=1:ndm
            Kele(:,inod,indx_v(idm),jnod,indx_v(idm)) = Kele(:,inod,indx_v(idm),jnod,indx_v(idm)) + ( ...  
                0*W_supg(:,idm,idm)*N(jnod)/(dt) + ... % termino temporal
                N(inod)*N(jnod)/dt + ...
                alpha*W_supg(:,idm,idm).*u_gN(:,idm)      + ... % termino convectivo                  
                alpha*terd_m(:,inod,jnod) ... 
                ).*xsj;  
            
            Kele(:,inod,indx_p,jnod,indx_p) = Kele(:,inod,indx_p,jnod,indx_p) + ( ...
                dt*dshapex(:,inod,idm).*dshapex(:,jnod,idm) + ...
                P_epsilon(:,1,indx_v(idm)).*dshapex(:,jnod,idm) ...
                ).*xsj; 
            
            if visco_model==0
                for jdm=1:ndm
                    Kele(:,inod,indx_v(idm),jnod,indx_v(jdm)) = ... 
                        Kele(:,inod,indx_v(idm),jnod,indx_v(jdm)) + ( ...                      
                        alpha*visco*dshapex(:,inod,jdm).*dshapex(:,jnod,idm) ...
                        ).*xsj; 
                end
            end
            
        end
        
    end % jnod
    
end % inod

%   disp('bubbly_2d_ele (liquid) phase ');keyboard;pause   
