function [R_neumann,K_neumann] = bc_neumann_fun(x,y,ttime,Upg,prop);
%
%  function to write the Neumann bc over a set of elements
%  This function may use an analytic computation of the h flux vector
%

get_index;

ijob = 'get';
handle_prop_elem;

[nele,ndf]=size(Upg);

R_neumann = zeros(nele,ndf);
p    =  -0.25*(cos(4*pi*x)+cos(4*pi*y))*exp(-16*pi^2*visco*ttime);
du1dx =  2*pi*(sin(2*pi*x).*sin(2*pi*y))*exp(-8*pi^2*visco*ttime);    
du2dx =  2*pi*(cos(2*pi*x).*cos(2*pi*y))*exp(-8*pi^2*visco*ttime);       
h1 = du1dx+ p;
h2 = du2dx;
R_neumann(:,indx_v(1)) = h1;
R_neumann(:,indx_v(2)) = h2;


