function [Mele,Rele] = bc_neumann_nsi_tet(xnod,icone,U,bou_data,Rele,Mele,axisim,prop)
%                                     

ijob = 'get';
handle_prop_elem;

[numnp,ndm] = size(xnod);  
[numel,nen] = size(icone);
[nbou,bas]  = size(bou_data);
[bas,ndf]   = size(U);

ndf= ndf/nen;

[bas,ncol]  = size(Mele);

if nbou>0,
    
    xpg    = sqrt(3)/3;
    psipg  = [ -xpg xpg ];
    wpg    = [   1   1  ];
    
    eles_bou = bou_data(:,1);
    face_bou = bou_data(:,2);
    
    nodo_1 = face_bou;
    nodo_2 = (nodo_1+1).*(nodo_1<nen)+(nodo_1==nen);
    nodos  = [nodo_1,nodo_2];
    nodog1 = getcol(icone(eles_bou,:),nodo_1);
    nodog2 = getcol(icone(eles_bou,:),nodo_2);
    nodog  = [nodog1 , nodog2];
    dxbc   = xnod(nodog2,1) - xnod(nodog1,1);
    dybc   = xnod(nodog2,2) - xnod(nodog1,2);
    lbou   = sqrt(dxbc.^2+dybc.^2);
    norbc  = [dybc./lbou, -dxbc./lbou];
    
    xe = v2m(xnod(icone(eles_bou,:)',1),nen);
    xe = [getcol(xe,nodo_1), getcol(xe,nodo_2) ];
    
    ye = v2m(xnod(icone(eles_bou,:)',2),nen);
    ye = [getcol(ye,nodo_1), getcol(ye,nodo_2) ];
    
    Ue = zeros(nbou,ndf*2);
    
    for idf=1:ndf
        Ue(:,idf)     = getcol(U(eles_bou,:),(nodo_1-1)*ndf+idf);
        Ue(:,ndf+idf) = getcol(U(eles_bou,:),(nodo_2-1)*ndf+idf);
    end
    
    for ipg=1:2,
        
        N = ones(nbou,1)*[(1-psipg(ipg))/2 , (1+psipg(ipg))/2 ];
        
        Upg      = zeros(nbou,ndf);
        xpg      = zeros(nbou,1);
        ypg      = zeros(nbou,1);        
        
        for inod=1:2,    
            xpg = xpg + N(:,inod).*xe(:,inod);
            ypg = ypg + N(:,inod).*ye(:,inod);            
            Upg = Upg + (N(:,inod)*ones(1,ndf)).*Ue(:,(inod-1)*ndf+(1:ndf));
        end         
        
        if (exist('bc_neumann')~=2), 
            disp('Debe tener en el directorio de trabajo un archivo de nombre bc_neumann.m ');
            error(' bc_neumann file no existe '); 
        end

        [R_neumann,K_neumann] = bc_neumann_fun(xpg,ypg,ttime,Upg,prop);
        
        xsj = wpg(ipg)*lbou/2;
        if axisim,
            xsj = xsj.*radpg;
        end
        
        for iface=1:nen,
            for inod=1:2,
                eles = find(face_bou==iface);
                jnod = iface-1+inod;
                if(jnod>nen),jnod=1; end 
                vaux  =  (N(eles,inod).*xsj(eles)*ones(1,ndf)).*R_neumann(eles,1:ndf);
                Rele(eles_bou(eles),jnod,1:ndf) = Rele(eles_bou(eles),jnod,1:ndf) - ...
                    reshape(vaux,length(eles),1,ndf);
                
                for iinod=1:2, 
                    jjnod = iface-1+iinod;
                    if(jjnod>nen),jjnod=1; end           
                    ip=((jnod-1)*nen+(jjnod-1))*ndf^2;         
                    for idf=1:ndf
                        for jdf=1:ndf,
                            vaux  =  (N(eles,inod).*xsj(eles).*N(eles,iinod)).*K_neumann(eles,idf,jdf);                  
                            Mele(eles_bou(eles),jnod,idf,jjnod,jdf) = ...
                                Mele(eles_bou(eles),jnod,idf,jjnod,jdf) + vaux;          
                        end
                    end
                end % for iinod
            end  % for inod
        end % for iface
        
    end % puntos de Gauss del contorno
    
end % if bou

