%------------------------------------------------------------------
%     APLICATION  :  TWO PHASE FLOW
%------------------------------------------------------------------

if(exist('inicia')==0),
    disp('Ingrese la variable inicia ')
    disp(' inicia == 0 ---> si continua una corrida previa ')
    disp(' inicia ~= 0 ---> si comienza una corrida nueva ')
    inicia = input(' Inicia = ')
end

%------ Ingreso de datos -------------------------------------------

if inicia,
    read_data;
    bfh=[];          % Guarda la solucion
    hc_res=[];       % Guarda la historia de la convergencia en residuo
    hc_du=[];        % Guarda la historia de la convergencia en dphi
    hc_res_outer = [];
    bfh_nc = [];     % Guarda los pasos de tiempo en que no hubo convergencia
    bfh_u=[];        % Guarda la solucion cada nstep pasos de tiempo
    posdat;
    ttime = 0;
    restart_time = 0;
    
    [rowe,cole] = gen_matrix_ij(icone,ndf);
    
    if exist('bou_data_neumann','var')==0, bou_data_neumann = [];end
end

if exist('nnwt_outer','var')==0, nnwt_outer=1; end

%------ fin ingreso de datos --------------------------------------

limit = prop(12);
[numnp,ndf] = size(phi);

% Loop temporal o pseudotemporal
%------------------------------------------------------------------

for itime=1:ntime,
    
    restart_time = 0;
    
    if restart_time ==1,
        phi = phiold;
    else
        phiold = phi;
        if 1,
            if exist('dtmin')&exist('dtmax'),
                dt = dtmin+(dtmax-dtmin)*itime/ntime;
                prop(13)=dt;
                disp(['dt = ' num2str(dt)])
            end  
        end
    end
    
    ttime = ttime+dt;
    ijob = 'set';
    handle_prop_elem;
    
    % Actualiza las condiciones de contorno si fueran funcion del tiempo
    % La funcionalidad se lee del archivo "bc_time"
    if exist('bc_time_flag')==1,
        if (bc_time_flag==1)&(exist('bc_time')~=2), 
            disp('Debe tener en el directorio de trabajo un archivo de nombre bc_time.m ');
            error(' bc_time_flag==1 y bc_time file no existe '); 
        end
        if bc_time_flag==1, bc_time; end
    end
    
    nu_outer    = 0;
    nu_max_outer = nnwt_outer;
    iterflag_outer = nu_outer < nu_max_outer;
    
    res_outer = [];
    
    while iterflag_outer
        
        nu_outer = nu_outer +1;
        Rg_outer = 0;         
        
        solver_nsi_tet;
        
        iterflag_outer = (norm(Rg_outer)>limit) & (nu_outer< nu_max_outer); 
        
        disp(['time ' num2str(itime) ... 
                ' Iter (outer) ' num2str(nu_outer)  ' || R || -----> ' num2str(norm(Rg_outer))   ])
        
        res_outer = [res_outer; norm(Rg_outer)];         
        
    end % iterflag_outer
    
    hc_res_outer = [hc_res_outer; res_outer ];             
    
    if res_outer(end)>res_outer(1), 
        restart_time=1;    
        dt = max([dt/2,dtmin]);
    else
        restart_time=0;
    end
    
    % Salida grafica de resultados (provista por cada aplicacion)
    %------------------------------------------------------------------
    
    plot_fem
    
    hc_res = [ hc_res; norm(Rg)];
    hc_du = [ hc_du; norm(dphi)];
    
    if norm(Rg)>limit ,
        %  error(' NO CONVERGENCE ');
        bfh_nc = [bfh_nc ; itime];
    end
    
    if exist('nsave')==0; nsave=ntime;end
    
    if exist('filesave')==0; filesave='tempo'; end
    
    if exist('filestate')==0; filestate='last_state'; end
    
    if rem(itime,nsave)==0, 
        eval(['save ' filesave ';']);
        eval(['save ' filestate 'phi ' ';']);
    end
    
    if rem(itime,nstep)==0,
        bfh_u = [bfh_u , phi];
    end
    
end % itime loop

