function [Kg,Rg] = nsi_tet(xnod,icone,fixa,forc,teco,lin_con,extra_nodal_fields,...
   extra_nodal_fields_old,prop,ifaceb,bou_data_neumann,Up,Upold,rowe,cole) 
%------------------------------------------------------------------
%
%  NSI_TET solver
%
%  state vector = [p ; vel ]
%
%------------------------------------------------------------------

global row col

ijob = 'get';
handle_prop_elem;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

U    = Up;
Uold = Upold;

[numel,nen]   = size(icone);
[numnp,ndf]   = size(U);
if ndf~=3, error(' NDF debe ser 3 (NSI_TET) ');end
ndm = 2;

if ndm==1,
   pgauss1d;
elseif ndm==2, 
   pgauss2d; 
elseif ndm==3,
   pgauss3d; 
end

Rele = zeros(numel,nen,ndf);
Kele = zeros(numel,nen,ndf,nen,ndf);

Rg    = 0*forc;
eles  = (1:numel)';
ceros = zeros(length(eles),nen);

t0 = cputime;
if length(eles)>0,    
   nsi_tet_ele;
end

if isempty(bou_data_neumann)==0,
   [Rele,Kele] = bc_neumann_nsi_tet(xnod,icone,Ue,bou_data_neumann,Rele,Kele,axisim,prop);
end

t1_1=cputime;
disp([' dt assemble (element) = ' num2str(t1_1-t0)])   

% Gather contributions from eles to nodes
%------------------------------------------------------------------
%disp(' at BUBBLY_2d ')
%keyboard;pause
[Rg,Kg] = gather_2(Rele,Kele,icone,nen,ndf,rowe,cole);

t1_2=cputime;
disp([' dt assemble (gather) = ' num2str(t1_2-t1_1)])   

%disp('bubbly_2d antes');keyboard;pause
% Linear restrictions
%------------------------------------------------------------------
if isempty(lin_con)==0,
    [Rg,Kg] = linear_constraint(Rg,Kg,lin_con,ndf);
%disp('bubbly_2d despues');keyboard;pause
end
