%------------------------------------------------------------------
%     APLICATION  :  TWO PHASE FLOW
%------------------------------------------------------------------

if(exist('inicia')==0),
   disp('Ingrese la variable inicia ')
   disp(' inicia == 0 ---> si continua una corrida previa ')
   disp(' inicia ~= 0 ---> si comienza una corrida nueva ')
   inicia = input(' Inicia = ')
end

%------ Ingreso de datos -------------------------------------------

if inicia,
   read_data;
   bfh=[];          % Guarda la solucion
   hc_res=[];       % Guarda la historia de la convergencia en residuo
   hc_du=[];        % Guarda la historia de la convergencia en dphi
   hc_res_outer = [];
   bfh_nc = [];     % Guarda los pasos de tiempo en que no hubo convergencia
   bfh_u=[];        % Guarda la solucion cada nstep pasos de tiempo
   posdat;
   ttime = 0;
   restart_time = 0;

   % generacion perfil matriz sparse para predictor + poisson
   [rowe,cole] = gen_matrix_ij(icone,ndf);
   % generacion perfil matriz sparse para projection
   %[rowe_pr,cole_pr] = gen_matrix_ij_proj(icone,ndm);   

   % generacion matriz paso projector
   fs_step = 0;
   [Kg_pr,bas] = nsi_fs(xnod,icone,fixa,forc,teco,lin_con,prop,ifaceb,phi,phi,rowe,cole,fs_step);
   
end


%------ fin ingreso de datos --------------------------------------

limit = prop(12);
[numnp,ndf] = size(phi);

% Loop temporal o pseudotemporal
%------------------------------------------------------------------

for itime=1:ntime,
    
    phiold = phi;        
    ttime = ttime+dt;
    
    % Actualiza las condiciones de contorno si fueran funcion del tiempo
    % La funcionalidad se lee del archivo "bc_time"
    if exist('bc_time_flag')==1,
        if (bc_time_flag==1)&(exist('bc_time')~=2), 
            disp('Debe tener en el directorio de trabajo un archivo de nombre bc_time.m ');
            error(' bc_time_flag==1 y bc_time file no existe '); 
        end
        if bc_time_flag==1, bc_time; end
    end
    
    solver_nsi_tet;
    
    % Salida grafica de resultados (provista por cada aplicacion)
    %------------------------------------------------------------------
    
    plot_fem

    hc_res = [ hc_res; norm(Rg)];
    hc_du = [ hc_du; norm(dphi)];
    
    if norm(Rg)>limit ,
        %  error(' NO CONVERGENCE ');
        bfh_nc = [bfh_nc ; itime];
    end
    
    if exist('nsave')==0; nsave=ntime;end
    
    if exist('filesave')==0; filesave='tempo'; end
    
    if exist('filestate')==0; filestate='last_state'; end
    
    if rem(itime,nsave)==0, 
        eval(['save ' filesave ';']);
        eval(['save ' filestate 'phi ' ';']);
    end
    
    if rem(itime,nstep)==0,
        bfh_u = [bfh_u , phi];
    end
    
end % itime loop

