function [tau,delta,dt] = supg_nsi_tet(vel,grad_phi,hele,prop,type_upwind)
%
%

tol_upw = 1e-08;

ijob = 'get';
handle_prop_elem;

[N,bas]  = size(vel);
velmod  = sqrt(sum(vel'.^2))';
velmod  = max([velmod';tol_upw*ones(1,N)])';  
Pe = 0.5/(visco/rho)*velmod.*hele ;
psi = min([ones(1,N);Pe'/3])';

if type_upwind==0,
    tau   = 0.5* hele ./ velmod.*psi;
    %   delta = tau_factor*velmod.*hele/2.*psi;
    delta = velmod.*hele/2.*psi;   
elseif type_upwind==1,
    tau =  (2*velmod./hele).^2 + 9*(4*(visco/rho) ./(hele).^2).^2;
    tau =   1 ./ sqrt(tau);
    %   delta = tau_factor*velmod.*hele/2;
    delta = velmod.*hele/2.*psi;   
else   
    error(' Bad type of upwind has been chosen')
end
dt    = Cou*hele ./ velmod;      

tau = tau_factor*tau;
delta = tau_factor*delta;
