%
%   Ejemplo 01 : Ej_planar_front
%

Nx       = 61;Lx=3;  
Ny       = 21;Ly=1;  
psi      = (0:Nx-1)'/(Nx-1);
x        = psi.^1*Lx;
eta      = (0:Ny-1)'/(Ny-1)*1; 
y        = eta.^1*Ly;

%-------- coordenadas (XNOD)
xnod     =[];
for k=1:Ny,
   xnod=[xnod;[x ones(Nx,1)*y(k)]];
end

%-------- conectividades (ICONE)
icone    =[];
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
ico2= [ (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' (1:Nx-1)'];
for k=1:Ny-1,
   icone=[icone; (k-1)*Nx+ico ];
end

% convertimos cuadrangulos en triangulos
quad2tri=0;

if quad2tri, quad_to_tri; end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;
nodes_bot  = (1:Nx)';
nodes_top  = Nx*(Ny-1)+(1:Nx)';
nodes_lef  = (1:Nx:Nx*Ny)';
nodes_rig  = (Nx:Nx:Nx*Ny)';
fixa= zeros(numnp,ndf);
forc = zeros(numnp,ndf);

fixa(nodes_lef,1)=ones(length(nodes_lef),1);
%fixa(nodes_rig,1)=ones(length(nodes_rig),1);
forc(nodes_lef,1)=0.75*ones(length(nodes_lef),1);
%forc(nodes_rig,1)=-1.875*ones(length(nodes_rig),1);

%-------- Fuentes de volumen (por elemento)
xc=xc_ele(xnod,icone);
mask1=(xc(:,1)<Lx/4);
mask2=(xc(:,1)>(3*Lx/8));
source = mask1-mask2;

%--------- Termino reactivo -----------------------------
reac = 0*ones(numel,1);

%--------- Campo de Velocidad -----------------------------
veloc  =  ones(numnp,1)*[1 0];
%-------- Propiedades del material

rho     = 1    ;
Cp      = 1    ;
kappa   = 1e-012;
npg     =  2   ;
prop(1) =rho   ;
prop(2) =Cp    ;
prop(3) =kappa ;
prop(4) =npg   ;

upwind  =    1 ;
shocap  =    0 ;
axisim  =    0 ;
% [1] SUPG
% [2] (SU+C)PG
type_upw =    1;   
lumped   =   1 ;

prop(6)  = upwind ;
prop(7)  = shocap ;
prop(8)  = axisim ;
prop(9)  = type_upw;
prop(11) = lumped ;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)

eles    = (2*(Nx-1):Nx-1:(Nx-1)*(Ny-1))';
[numel,nen]=size(icone);
face    = 2*ones(size(eles));
val1    = 800*ones(size(eles));
val2    = 40*ones(size(eles));

%teco    = [eles face val1/rho/Cp val2 ];
teco     = [];

%-------- Condiciones periodicas
peri = [nodes_bot' nodes_top'];
peri = [];
uno  = ones(length(nodes_bot),1);
lin_con = [uno nodes_bot uno -uno nodes_top uno];
lin_con = [];

%-------- Solucion inicial (PHI)
mask1 = (xnod(:,1)<Lx/4);
mask2 = (xnod(:,1)>(3*Lx/8));
phi0 =  0.75*mask1-1.875*mask2;
phi0 = (Lx/4-xnod(:,1)).*mask1-(xnod(:,1)-3*Lx/8).*mask2;
for k=1:ndf,
   bini(:,k)   = forc(:,k);
   free        = find(fixa(:,k)==0);
   bini(free,k)= phi0(free);
end

adre = 0;
filename = 'adre_advdif_01'

% escribo la funcion phi_0 necesaria para poder calcular la distancia
% (level set)
my_fprintf('phi_0.dat','%10.5f \n',source);
