%
%  BC_TIME file
%

if caso==10,
   periodo = 2;
   omega = 2*pi/periodo;
   amplitude = 0.1;
   phi(nodes_int,1)=T_int*ones(length(nodes_int),1)*(1+amplitude*sin(omega*ttime));
return   
end

% caso de tener h_film = f(t)
if 0,
% amplitude
eval(['[h_seat,T0_seat]=' bc_time_file_amplitude '(' num2str(ttime) ');']);

% where to be imposed
eles    = ifaceb_seat(:,1);
face    = ifaceb_seat(:,2);
val1    = h_seat*ones(size(eles));
val2    = T0_seat*ones(size(eles));
teco    = [eles face val1/rho/Cp val2 ];
end

if 1,
   
   % Valve Lift to be used as convection BC between guide and valve
   props_valve_lift = [theta_VO,theta_VC,Lvmax];
   omega            = rpm*2*pi/60;
   eval(['Lv=' bc_time_file_lift_valve '(' num2str(ttime*omega) ',[props_valve_lift]);']);
   xnod_mod = xnod;
   xnod_mod(:,2) = xnod_mod(:,2)+Lv;
      
   x_guide = 0.5*(xnod_mod(icone_guide(:,1),2)+xnod_mod(icone_guide(:,2),2));
   x_fluid = 0.5*(xnod_mod(icone_fluid(:,1),2)+xnod_mod(icone_fluid(:,2),2));
   x_seat  = 0.5*(xnod_mod(icone_seat (:,1),2)+xnod_mod(icone_seat (:,2),2));
   
   % convection at guide taken into account the valve motion
   mask_guide = (x_guide>x_guide_min)&(x_guide<x_guide_max);
   
   rho = prop_elem(1,1);
   Cp  = prop_elem(2,1);
   teco = [];
   nn= find(mask_guide==1);
   teco = [teco;[ifaceb_guide(nn,1:2) , ones(length(nn),1)*[h_guide/rho/Cp,T_guide] ]];
   nn= find(mask_guide==0);
   teco = [teco;[ifaceb_guide(nn,1:2) , ones(length(nn),1)*[h_fluid/rho/Cp,T_fluid] ]];
   % convection between valve and the gas (fluid)
   teco = [teco;[ifaceb_fluid(:,1:2) , ones(length(ifaceb_fluid(:,1)),1)*[h_fluid/rho/Cp,T_fluid] ]];
   % convection between part of the seat in face with the gas (fluid)
   teco = [teco;[ifaceb_seat_fluid(:,1:2) , ones(length(ifaceb_seat_fluid(:,1)),1)*[h_fluid/rho/Cp,T_fluid] ]];   
   % at seat , convection when valve is open and thermal contact when valve is closed
   if Lv>0,
      teco = [teco;[ifaceb_seat(:,1:2) , ones(length(ifaceb_seat(:,1)),1)*[h_seat/rho/Cp,T_fluid] ]];
      teco = [teco;[ifaceb_seat_out(:,1:2) , ones(length(ifaceb_seat_out(:,1)),1)*[h_seat_out/rho/Cp,T_fluid] ]];
      ther_contact = [];
   else
      ther_contact =  [icone_seat(:,[2,1]) icone_seat_out(:,[2,1]) ... 
            C_seat/rho/Cp*ones(length(icone_seat(:,1)),1)];
   end
   
   % convection between part of the seat in face with the cylinder 
   eval(['[h_cylinder,T_cylinder]=' bc_time_file_T_cyl '(' num2str(ttime*omega) ');']);   
   teco = [teco;[ifaceb_seat_cylinder(:,1:2) , ones(length(ifaceb_seat_cylinder(:,1)),1)*[h_cylinder/rho/Cp,T_cylinder] ]]; 
   % convection between valve and cylinder
   teco = [teco;[ifaceb_cyl(:,1:2) , ones(length(ifaceb_cyl(:,1)),1)*[h_cylinder/rho/Cp,T_cylinder] ]];   
end

