%
%   T = [phi , y]
%
%   being y: the orthogonal projection of phi to the FEM subspace
%

compute_at_centroide = 0;
oss = 1;

% Calculos del elemento propiamente dichos
%------------------------------------------------------------------

beta_supg = 1;      % consistent SUPG mass matrix parameter
% [0] consistent Galerkin ; [1] consistent SUPG
implicit_factor = 1;  % [1] full implicit ; 
% [0] only mass matrix is implicit ;

ne    = length(eles);

weak_form = 0;

difu_phys = kappa /rho/Cp; 
Kappa_pg = difu_phys*eye(2);

ceros = zeros(ne,nen,ndf);
% Localizacion
%------------------------------------------------------------------
Te = ceros;
T0e = ceros;
vele = zeros(length(eles),nen,ndm);
radio = zeros(ne,nen);

for inod=1:nen,
    for idf=1:ndf
        nodes  = icone(eles,inod);
        jnod  = (inod-1)*ndf+(1:ndf);
        Te(:,inod,idf)  = T(nodes,idf);		 
        T0e(:,inod,idf) = Told(nodes,idf);   
        re(:,inod)  = xnod(nodes,1);		       
        vele(:,inod,1:ndm) = veloc(nodes,1:ndm);       
    end
end


if compute_at_centroide,    
    % Calculo del tamao del elemento en el centroide del elemento
    %------------------------------------------------------------------
    if nen==4,
        [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),0,0);
        [dshapex0,N0] = shape2d(X2S,0,0,nen); 
    elseif nen==3,
        [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),1/3,1/3);
        [dshapex0,N0] = shape2d(X2S,1/3,1/3,nen); 
    else
        error(' Bad type of element , nen ~=3, nen ~=4 ')
    end
    
    velpg  = zeros(ne,2);
    Tpg    = zeros(ne,ndf);
    dTpg   = zeros(ne,ndf,ndm);    
    
    for inod=1:nen,
        jnod = (inod-1)*ndf+(1:ndf);        
        for idf=1:ndf
            Tpg(:,idf) =  Tpg(:,idf) + N0(inod).*  Te(:,inod,idf);        
            for idm=1:ndm,
                velpg(:,idm) = velpg(:,idm) +  N0(inod).* vele(:,inod,idm);
                dTpg(:,idf,idm) = dTpg(:,idf,idm) + ...
                    (dshapex0(:,inod,idm)*ones(1,ndf)).* T0e(:,inod,idf);                      
            end      
        end
    end    
    
    hele = comp_hele(velpg,dshapex0,Jaco0,nen);
    [P1_pg,tau,difu_anis]=supg_advdif_2d(velpg,difu_phys,dshapex0,hele,Tpg(:,1),dTpg(:,1,:),reac, ... 
        source,nen,shocap,tau_fac)                                      
    
end

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------

for ipg=1:npg
    
    [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
    [dshapex,N] = shape2d(X2S,psipg(ipg),etapg(ipg),nen); 
    
    % Interpolacion en punto de Gauss
    %------------------------------------------------------------------
    radpg  = zeros(ne,1);
    velpg  = zeros(ne,2);
    Tpg    = zeros(ne,ndf);
    T0pg   = Tpg;
    dTpg   = zeros(ne,ndf,ndm);    
    dT0pg  = dTpg;
    
    for inod=1:nen,
        jnod = (inod-1)*ndf+(1:ndf);        
        for idf=1:ndf
            Tpg(:,idf)   =  Tpg(:,idf) + N(inod).*  Te(:,inod,idf);        
            T0pg(:,idf)  =  T0pg(:,idf) + N(inod).*  T0e(:,inod,idf);                
            for idm=1:ndm,
                velpg(:,idm)     = velpg(:,idm) +  N(inod).* vele(:,inod,idm);
                dTpg(:,idf,idm)  = dTpg(:,idf,idm) + (dshapex(:,inod,idm)).* Te(:,inod,idf);
                dT0pg(:,idf,idm) = dTpg(:,idf,idm) + (dshapex(:,inod,idm)).* T0e(:,inod,idf);                                                  
            end      
        end
        radpg(:,1)  =   radpg(:,1) +      N(inod).* radio(:,inod);        
    end    
    
    hele = comp_hele(velpg,dshapex,Jaco,nen);
    [P1_pg,tau,difu_anis]=supg_advdif_2d(velpg,difu_phys,dshapex,hele,Tpg(:,1),dTpg(:,1,:),reac(eles), ... 
        source(eles),nen,shocap,tau_fac);
    
    % Correccion axisimetrica del jacobiano de la transformacion al elemento master
    %------------------------------------------------------------------
    xsj =  wpg(ipg) .* Jaco;
    if axisim,
        xsj = xsj.*radpg;
    end
    
    % Calculo matriz tangente y residuo
    %--------------------------------------------------------------------
    for inod=1:nen,
        if ijob==0,
            
            for jnod=1:nen,
                if lumped,
                    if inod==jnod, ter1 = (N(inod))/dt   ;else ter1=0; end
                else
                    ter1 = (N(inod)+beta_supg*P1_pg(:,inod))*N(jnod)/dt   ;
                end
                
                ter20 = (velpg(:,1).*dshapex(:,jnod,1) + velpg(:,2).*dshapex(:,jnod,2));             
                if weak_form,
                    ter2 = -(dshapex(:,inod,1).*velpg(:,1)+dshapex(:,inod,2).*velpg(:,2)).*N(jnod);
                    ter2 = ter2 + P1_pg(:,inod).* ter20 ;              
                else
                    ter2 = (N(inod)+P1_pg(:,inod)).* ter20;
                end 
                
                ter3 = dshapex(:,inod,1).* ... 
                    (Kappa_pg(1,1).*dshapex(:,jnod,1)+Kappa_pg(1,2).*dshapex(:,jnod,2)) + ...
                    dshapex(:,inod,2).* ...
                    (Kappa_pg(2,1).*dshapex(:,jnod,1)+Kappa_pg(2,2).*dshapex(:,jnod,2)) ;
                
                ter4 = dshapex(:,inod,1).* ... 
                    (difu_anis(:,1).*dshapex(:,jnod,1)+difu_anis(:,2).*dshapex(:,jnod,2)) + ...
                    dshapex(:,inod,2).* ...
                    (difu_anis(:,3).*dshapex(:,jnod,1)+difu_anis(:,4).*dshapex(:,jnod,2)) ;
                
                ter5 = (N(inod)+P1_pg(:,inod))*N(jnod).*reac(eles);
                
                Kele(eles,inod,1,jnod,1) = Kele(eles,inod,1,jnod,1) + ( ... 
                    ter1+implicit_factor*(ter2+ter3+ter4+ter5)  ) .* xsj;
                
                if oss
                    ter7 = -P1_pg(:,inod)*N(jnod);                 
                    Kele(eles,inod,1,jnod,2) = Kele(eles,inod,1,jnod,2) + ( ter7).*xsj;
                end
                
                Kele(eles,inod,2,jnod,2) = Kele(eles,inod,2,jnod,2) + (N(inod)*N(jnod)).*xsj;
                Kele(eles,inod,2,jnod,1) = Kele(eles,inod,2,jnod,1) - (N(inod)*ter20).*xsj;                
                
            end  % jnod
            
        else
            
            ter1 = (N(inod))/dt;   
            Kele(eles,inod,1,inod,1) = Kele(eles,inod,1,inod,1) + ter1.* xsj;
            
        end % if ijob
        
        if lumped,
            ter1 = (N(inod)).*(Te(:,inod,1)-T0e(:,inod,1))/dt ;
        else
            ter1 = (N(inod)+beta_supg*P1_pg(:,inod)).*(Tpg(:,1)-T0pg(:,1))/dt ;
        end
        ter20 = (velpg(:,1).*dTpg(:,1,1) + velpg(:,2).*dTpg(:,1,2));
        if weak_form,
            ter2 = -(dshapex(:,inod,1).*velpg(:,1)+dshapex(:,inod,2).*velpg(:,2)).*Tpg(:,1);
            ter2 = ter2 + P1_pg(:,inod).*ter20;
        else
            ter2 = (N(inod)+P1_pg(:,inod)).*ter20;                 
        end
        
        ter3 = (dshapex(:,inod,1).* ... 
            (Kappa_pg(1,1).*dTpg(:,1)+Kappa_pg(1,2).*dTpg(:,1,2)) + ...
            dshapex(:,inod,2).* ... 
            (Kappa_pg(2,1).*dTpg(:,1)+Kappa_pg(2,2).*dTpg(:,1,2)) );
        
        ter4 = (dshapex(:,inod,1).* ... 
            (difu_anis(:,1).*dTpg(:,1)+difu_anis(:,2).*dTpg(:,1,2)) + ...
            dshapex(:,inod,2).* ... 
            (difu_anis(:,3).*dTpg(:,1)+difu_anis(:,4).*dTpg(:,1,2)) );
        
        
        ter5 = (N(inod)+P1_pg(:,inod)).*source(eles) ;
        ter6 = (N(inod)+P1_pg(:,inod)).*reac(eles).*Tpg(:,1) ;
        Rele(eles,inod,1) = Rele(eles,inod,1) - (ter1+ter2+ter3+ter4+ter5+ter6) .* xsj;
        
        ter1 = N(inod).*Tpg(:,2);
        ter2 = N(inod).*ter20;                         
        Rele(eles,inod,2) = Rele(eles,inod,2) - (ter1-ter2) .* xsj;
        
        if oss
            ter7 = P1_pg(:,inod).*Tpg(:,2);
            Rele(eles,inod,1) = Rele(eles,inod,1) + (ter7) .* xsj;
        end
    end % inod
    
end % ipg

