%
%   Ejemplo: conveccion - reaccion
%

Nx       = 41;Lx=1;  
Ny       = 41;Ly=3;  
psi      = (0:Nx-1)'/(Nx-1);
x        = psi.^1*Lx;
eta      = (0:Ny-1)'/(Ny-1)*1; 
y0       = -1;
y        = eta.^1*Ly+y0;

%-------- coordenadas (XNOD)
xnod     =[];
for k=1:Ny,
   xnod=[xnod;[x ones(Nx,1)*y(k)]];
end

%-------- conectividades (ICONE)
icone    =[];
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
ico2= [ (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' (1:Nx-1)'];
for k=1:Ny-1,
   icone=[icone; (k-1)*Nx+ico ];
end

% convertimos cuadrangulos en triangulos
quad2tri=0;

if quad2tri, quad_to_tri; end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 2;
nodes_bot  = (1:Nx)';
nodes_top  = Nx*(Ny-1)+(1:Nx)';
nodes_lef  = (1:Nx:Nx*Ny)';
nodes_rig  = (Nx:Nx:Nx*Ny)';
fixa = zeros(numnp,ndf);
forc = zeros(numnp,ndf);
if 0,
   fixa(nodes_lef,1)=ones(length(nodes_lef),1);
   fixa(nodes_bot,1)=ones(length(nodes_bot),1);
   mask = xnod(nodes_lef,2)<0;
   nn   = find(mask==1); 
   forc(nodes_lef(nn),1)=ones(length(nodes_lef(nn)),1);
   mask = xnod(nodes_bot,1)<0.5;
   nn   = find(mask==1); 
   forc(nodes_bot(nn),1)=ones(length(nodes_bot(nn)),1);
else
   fixa_pf = [];
   mask = xnod(nodes_lef,2)<0;
   nn   = find(mask==1);    
   nodes = nodes_lef(nn);
   fixa_pf = [fixa_pf ; [nodes  , ones(length(nodes),1) , ones(length(nodes),1)] ];
   nn   = find(mask==0);
   nodes = nodes_lef(nn);
   fixa_pf = [fixa_pf ; [nodes  , ones(length(nodes),1) , zeros(length(nodes),1)] ];   
   mask = xnod(nodes_bot,1)<0.5;
   nn   = find(mask==1); 
   nodes = nodes_bot(nn);
   fixa_pf = [fixa_pf ; [nodes  , ones(length(nodes),1) , ones(length(nodes),1)] ];   
   nn   = find(mask==0); 
   nodes = nodes_bot(nn);
   fixa_pf = [fixa_pf ; [nodes  , ones(length(nodes),1) , zeros(length(nodes),1)] ];    
   [fixa,forc] = conv_fixa_pfem(fixa_pf,fixa,forc);
end

% fijo por ahora el segundo grado de libertad
fixa(nodes_lef,2)=1;
fixa(nodes_bot,2)=1;

%-------- Fuentes de volumen (por elemento)
xc=0;yc=0;
factor = 1/nen;
for kk=1:nen,
   xc = xc+factor*xnod(icone(:,kk),1);
   yc = yc+factor*xnod(icone(:,kk),2);
end
mask=(yc>0.1)&(yc<0.3);
source = 0*mask;

%--------- Termino reactivo -----------------------------
reac = 0*ones(numel,1);

%--------- Campo de Velocidad -----------------------------
veloc  =  ones(numnp,1)*[cos(pi/3) sin(pi/3)];
%-------- Propiedades del material

rho     = 1    ;
Cp      = 1    ;
kappa   = 1e-03;
npg     =  2   ;
prop(1) =rho   ;
prop(2) =Cp    ;
prop(3) =kappa ;
prop(4) =npg   ;

upwind  =    0.1 ;
shocap  =    0 ;
axisim  =    0 ;
% [1] SUPG
% [2] (SU+C)PG
type_upw =    1;   
lumped   =   1 ;

prop(6)  = upwind ;
prop(7)  = shocap ;
prop(8)  = axisim ;
prop(9)  = type_upw;
prop(11) = lumped ;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)

eles    = (2*(Nx-1):Nx-1:(Nx-1)*(Ny-1))';
[numel,nen]=size(icone);
face    = 2*ones(size(eles));
val1    = 800*ones(size(eles));
val2    = 40*ones(size(eles));

%teco    = [eles face val1/rho/Cp val2 ];
teco     = [];

%-------- Condiciones periodicas
peri = [nodes_bot' nodes_top'];
peri = [];
uno  = ones(length(nodes_bot),1);
lin_con = [uno nodes_bot uno -uno nodes_top uno];
lin_con = [];

%-------- Solucion inicial (PHI)
phi0 =  [0,0];
for k=1:ndf,
   bini(:,k)   = forc(:,k);
   free        = find(fixa(:,k)==0);
   if isempty(free)==0,
       bini(free,k)= phi0(1,k)*ones(size(free));
   end
end

adre = 0;
filename = 'adre_advdif_01'