%
%   Ejemplo advdif en una corona circular
%


Nr = 20;
re = 4;
ri = 1;
Nc = 40;

T_int = 100;
T_ext = 200;

[xnod,icone]=cc2d(ri,re,Nr,Nc);

% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;
tol = 1e-6;
radius = sqrt(sum(xnod'.^2))';
nodes_int  = find(abs(radius-ri)<tol);
nodes_ext  = find(abs(radius-re)<tol);

figure(1);clf;pltmsh(xnod,icone);hold on
plot(xnod(nodes_int,1),xnod(nodes_int,2),'y*')
plot(xnod(nodes_ext,1),xnod(nodes_ext,2),'g*')
if 0,
chvar = input('Esta conforme con la malla ? [y/n]','s')
if strcmp(chvar,'y')==0, error('Malla no aceptada'); end
end

fixa= zeros(numnp,ndf);
fixa(nodes_int,1)=ones(length(nodes_int),1);
fixa(nodes_ext,1)=ones(length(nodes_ext),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc = zeros(numnp,ndf);
%mask = xnod(nodes_rig,2)>=y0;
%nn   = find(mask==1); 
forc(nodes_int,1)=T_int*ones(length(nodes_int),1);
forc(nodes_ext,1)=T_ext*ones(length(nodes_ext),1);

%-------- Fuentes de volumen (por elemento)
xc=xc_ele(xnod,icone);
mask=(xc(:,2)>-0.1)&(xc(:,2)<1.3);
source = 0*mask;

%--------- Termino reactivo -----------------------------
reac = 0*ones(numel,1);

%--------- Campo de Velocidad -----------------------------
veloc  =  0*[zeros(numnp,1) ones(numnp,1)];

%-------- Propiedades del material
rho     = 1 ;
Cp      = 1 ;
kappa   = 1 ;
npg     =  2   ;
prop(1) = rho   ;
prop(2) = Cp    ;
prop(3) = kappa ;
prop(4) = npg   ;

upwind  =    1 ;
shocap  =    0 ;
axisim  =    0 ;
lumped   =   0 ;

prop(6)  = upwind ;
prop(7)  = shocap ;
prop(8)  = axisim ;
prop(11) = lumped ;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
%eles    = (2*(Nx-1):Nx-1:(Nx-1)*(Ny-1))';
%[numel,nen]=size(icone);
%face    = 2*ones(size(eles));
%val1    = 800*ones(size(eles));
%val2    = 40*ones(size(eles));
%teco    = [eles face val1/rho/Cp val2 ];
teco     = [];

%-------- Condiciones periodicas
peri = [];

%-------- Solucion inicial (PHI)
phi0 =  (T_int+T_ext)/2;;
for k=1:ndf,
 bini(:,k)   = forc(:,k);
 free        = find(fixa(:,k)==0);
 bini(free,k)= phi0(1,k)*ones(size(free));
end

bc_time_flag=1;