%------------------------------------------------------------------
%                   COMPUTE LOW ORDER TERMS
%------------------------------------------------------------------

for ipg=1:1
    
    if nen==4,
        [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),0,0);
        [dshapex,N] = shape2d(X2S,0,0,nen); 
    elseif nen==3,
        [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),1/3,1/3);
        [dshapex,N] = shape2d(X2S,1/3,1/3,nen); 
    else
        error(' Bad type of element , nen ~=3, nen ~=4 ')
    end
    
    % Interpolacion en punto de Gauss
    %------------------------------------------------------------------
    Tpg    = zeros(ne,1);
    T0pg    = zeros(ne,1);
    dTpg    = zeros(ne,2);
    dT0pg    = zeros(ne,2);    
    velpg    = zeros(ne,2);
    radpg    = zeros(ne,1);
    
    for inod=1:nen,
        Tpg(:,1)  =     Tpg(:,1) +      N(inod).*    Te(:,inod);
        T0pg(:,1)  =    T0pg(:,1) +      N(inod).*   T0e(:,inod);
        dTpg(:,1)  =    dTpg(:,1) + dshapex(:,inod,1).*    Te(:,inod);
        dTpg(:,2)  =    dTpg(:,2) + dshapex(:,inod,2).*    Te(:,inod);
        dT0pg(:,1)  =   dT0pg(:,1) + dshapex(:,inod,1).*    T0e(:,inod);
        dT0pg(:,2)  =   dT0pg(:,2) + dshapex(:,inod,2).*    T0e(:,inod);     
        velpg(:,1)  =   velpg(:,1) +      N(inod).* vele(:,inod,1);
        velpg(:,2)  =   velpg(:,2) +      N(inod).* vele(:,inod,2);
        radpg(:,1)  =   radpg(:,1) +      N(inod).* radio(:,inod);
    end
    
    % asumimos que la difusion fisica es cte
    %  kappa_pg = difu_phys;
    
    hele = comp_hele(velpg,dshapex,Jaco,nen);
    [P1_pg,tau,difu_anis]=supg_advdif_2d(velpg,difu_phys,dshapex,hele,Tpg,dTpg,reac(eles), ... 
        source(eles),nen,shocap,tau_fac);
    
    % Correccion axisimetrica del jacobiano de la transformacion al elemento master
    %------------------------------------------------------------------
    xsj =  wpg(ipg) .* Jaco;
    if axisim,
        xsj = xsj.*radpg;
    end
    
    % Calculo matriz tangente y residuo
    %--------------------------------------------------------------------
    for inod=1:nen,
        if ijob==0,
            
            for jnod=1:nen,
                %     ip=((inod-1)*nen+(jnod-1))*ndf^2;
                
                ter_1_low = (P1_pg(:,inod))*N(jnod)/dt   ;
                
                
                ter20 = (velpg(:,1).*dshapex(:,jnod,1) + velpg(:,2).*dshapex(:,jnod,2));             
                if weak_form,
                    ter_2_low = P1_pg(:,inod).* ter20 ;              
                else
                    ter_2_low = P1_pg(:,inod).* ter20;
                end
                
                ter_3_low = 0;
                ter_4_low = 0;                
                
                if 0,
                    ter_3_low = dshapex(:,inod,1).* ... 
                        (Kappa_pg(1,1).*dshapex(:,jnod,1)+Kappa_pg(1,2).*dshapex(:,jnod,2)) + ...
                        dshapex(:,inod,2).* ...
                        (Kappa_pg(2,1).*dshapex(:,jnod,1)+Kappa_pg(2,2).*dshapex(:,jnod,2)) ;
                end
                
                if 1,                    
                    ter_4_low = dshapex(:,inod,1).* ... 
                        (difu_anis(:,1).*dshapex(:,jnod,1)+difu_anis(:,2).*dshapex(:,jnod,2)) + ...
                        dshapex(:,inod,2).* ...
                        (difu_anis(:,3).*dshapex(:,jnod,1)+difu_anis(:,4).*dshapex(:,jnod,2)) ;
                end
                
                ter_5_low = (P1_pg(:,inod))*N(jnod).*reac(eles)   ;
                
                Kele(eles,inod,1,jnod,1) = Kele(eles,inod,1,jnod,1) + ( ... 
                    ter_1_low+implicit_factor*(ter_2_low+ter_3_low+ter_4_low+ter_5_low)  ) .* xsj;
                
            end  % jnod
            
        end % if ijob
        
        ter_1_low = (P1_pg(:,inod)).*(Tpg-T0pg)/dt ;
        
        ter20 = (velpg(:,1).*dTpg(:,1) + velpg(:,2).*dTpg(:,2));
        if weak_form,
            ter_2_low = P1_pg(:,inod).*ter20;
        else
            ter_2_low = P1_pg(:,inod).*ter20;                 
        end
        
        ter_3_low = 0;
        ter_4_low = 0;                
        
        if 0,
            ter_3_low = (dshapex(:,inod,1).* ... 
                (Kappa_pg(1,1).*dTpg(:,1)+Kappa_pg(1,2).*dTpg(:,2)) + ...
                dshapex(:,inod,2).* ... 
                (Kappa_pg(2,1).*dTpg(:,1)+Kappa_pg(2,2).*dTpg(:,2)) );
        end
        
        if 1,
            ter_4_low = (dshapex(:,inod,1).* ... 
                (difu_anis(:,1).*dTpg(:,1)+difu_anis(:,2).*dTpg(:,2)) + ...
                dshapex(:,inod,2).* ... 
                (difu_anis(:,3).*dTpg(:,1)+difu_anis(:,4).*dTpg(:,2)) );
        end
        
        ter_5_low = P1_pg(:,inod).*source(eles) ;
        ter_6_low = P1_pg(:,inod).*reac(eles).*Tpg ;
        
        Rele(eles,inod,1) = Rele(eles,inod,1) - (ter_1_low+ter_2_low+ter_3_low+ter_4_low+ter_5_low+ter_6_low) .* xsj;
        
    end % inod
    
end % ipg
