%------------------------------------------------------------------
%       Programa   " D R V F E M " 
%------------------------------------------------------------------

if(exist('inicia')==0),
    disp('Ingrese la variable inicia ')
    disp(' inicia == 0 ---> si continua una corrida previa ')
    disp(' inicia ~= 0 ---> si comienza una corrida nueva ')
    inicia = input(' Inicia = ')
end

%------ Ingreso de datos -------------------------------------------

if inicia,
    
    if 0,
        read_data;
        posdat;
    end
    
    load mesh_multigrid;    
    
    imesh=1;
    job='unpack';
    mesh_data;
    
    bfh=[];          % Guarda la solucion
    hc_res=[];       % Guarda la historia de la convergencia en residuo
    hc_du=[];        % Guarda la historia de la convergencia en dphi
    bfh_nc = [];     % Guarda los pasos de tiempo en que no hubo convergencia
    bfh_u=[];        % Guarda la solucion cada nstep pasos de tiempo
    
    ttime = 0;
    level_ref =0;   
    
end

%------ fin ingreso de datos --------------------------------------

limit = prop_elem(12);
dt    = prop_elem(13);
analysis = 1;
type_solver = prop_solver(1);
nu_max = prop_solver(3);
ntime = prop_solver(6);
nstep = prop_solver(7);
nplot = prop_solver(9);

for k=1:2,
    disp([' k = ' num2str(k)])
    for igrid=1:multigrid_levels
        disp([' coarse to fine between grids ' num2str(igrid) ' and ' num2str(igrid+1) ]) 
        [mesh(igrid+1)]=coarse2fine(mesh(igrid),mesh(igrid+1));
    end    
    for igrid=multigrid_levels:-1:1
        disp([' fine to coarse between grids ' num2str(igrid+1) ' and ' num2str(igrid) ])         
        [mesh(igrid)]=fine2coarse(mesh(igrid),mesh(igrid+1));
    end        
end

if 0,
    for igrid = 1:3
        figure(igrid);clf;view2d(mesh(igrid).xnod,mesh(igrid).icone,mesh(igrid).phi);
    end
end

% Loop temporal o pseudotemporal
%------------------------------------------------------------------

mesh_sequence = 2*[1,1,1,1];
mesh_sequence = [ones(1,10),2*ones(1,5),3,2*ones(1,5),ones(1,10)];

mesh(2).prop(13)=dt/2;
mesh(3).prop(13)=dt/4;
ntime = 1;

nmgrid = length(mesh_sequence);

for itime=1:ntime,
    ttime = ttime+dt;
    
    for kmesh=1:nmgrid,
        
        imesh = mesh_sequence(kmesh);
        
        phi    = mesh(imesh).phi;
        phiold = phi;
        mesh(imesh).phiold = phiold;
        xnod = mesh(imesh).xnod;
        icone = mesh(imesh).icone;


        
        % Actualiza las condiciones de contorno si fueran funcion del tiempo
        % La funcionalidad se lee del archivo "bc_time"
        if exist('bc_time_flag')==1,
            if (bc_time_flag==1)&(exist('bc_time')~=2), 
                disp('Debe tener en el directorio de trabajo un archivo de nombre bc_time.m ');
                error(' bc_time_flag==1 y bc_time file no existe '); 
            end
            if bc_time_flag==1, bc_time; end
        end
        
        nu    = 0;
        iterflag = 1;
        [numnp,ndf] = size(phi);
        
        if analysis,
            
            while iterflag
                
                nu= nu+1;
                
                phi_nu = phi;
                
                %------------------------------------------------------------------
                %        Montaje sistema y solucion del problema
                %------------------------------------------------------------------
                
                ijob = 0;
                if type_solver ==2, ijob=-1; end
                
                disp(' ASSEMBLING ')
                [Kg,Rg] = advdif_2d(mesh,imesh,phiold,ijob);
                
                disp(' SOLVING ')
                [phi,Rg]=solver(mesh(imesh).phi,Rg,Kg,mesh(imesh).fixa,mesh(imesh).prop,prop_solver,1);
                mesh(imesh).phi=phi;
                
                disp(' CONVERGENCE STATISTICS ')
                iterflag = (norm(Rg)>limit) & (nu< nu_max); % & (norm(dphi)>limit);            
                dphi = phi-phi_nu;            
                disp(['time ' num2str(itime) ... 
                        ' Iter ' num2str(nu)  ' || R || -----> ' num2str(norm(Rg)) ... 
                        ' || Delta phi || -----> ' num2str(norm(dphi))  ])            
                hc_res  = [hc_res ; norm(Rg)];
                hc_du   = [hc_du ; norm(dphi)];
                
            end  % end while
            
            disp(' PLOTING ')
            plot_fem
            
            if norm(Rg)>limit ,
                %  error(' NO CONVERGENCE ');
                bfh_nc = [bfh_nc ; itime];
            end
            
            if exist('nsave')==0; nsave=ntime;end
            
            if exist('filesave')==0; filesave='tempo'; end
            
            if rem(itime,nsave)==0, 
                eval(['save ' filesave ';']);
            end
            
            if rem(itime,nstep)==0,
                bfh_u = [bfh_u , phi];
            end
            
        end % if analysis

        if kmesh<nmgrid
            ig2jg = mesh_sequence(kmesh+1)-mesh_sequence(kmesh);
            if ig2jg>0
                [mesh(mesh_sequence(kmesh+1))] = coarse2fine(mesh(mesh_sequence(kmesh)),mesh(mesh_sequence(kmesh+1)));
            elseif ig2jg<0
                [mesh(mesh_sequence(kmesh+1))]   = fine2coarse(mesh(mesh_sequence(kmesh+1)),mesh(mesh_sequence(kmesh)));    
            end            
        end
        
    end % mesh sequence
end % itime loop
