function [array_new] = refine_array(array,icone,icone_ref_info,type);
%
%  [array_new] = refine_array(array,icone,icone_ref_info,type);
%
%  type = 'nodal' 
%  type = 'element' 
%

[numel,nen] = size(icone);

nodes_base = icone_ref_info(:,1:nen);
if nen==3,
    nodes_new = icone_ref_info(:,nen+(1:nen));
    eles_new = icone_ref_info(:,2*nen+(1:3));
elseif nen==4,
    nodes_new = icone_ref_info(:,nen+(1:nen+1)); 
    eles_new = icone_ref_info(:,2*nen+1+(1:3));        
else
    error(' in REFINE_ARRAY.M - nen .ne. 3 or 4 not possible ')
end

array_new = array;
if strcmp(type,'nodal')==1,
    for k=1:nen,
        nodes=nodes_new(:,k);
        n1 = nodes_base(:,k); if k==nen, n2 = nodes_base(:,1); else n2 = nodes_base(:,k+1); end
        array_new(nodes,:)=0.5*(array(n1,:)+array(n2,:));
    end
    if nen==4, 
        nodes=nodes_new(:,nen+1);
        n1 = nodes_new(:,1); 
        n2 = nodes_new(:,2);
        n3 = nodes_new(:,3);
        n4 = nodes_new(:,4);        
        array_new(nodes,:)=0.25*(array_new(n1,:)+array_new(n2,:)+array_new(n3,:)+array_new(n4,:)); 
    end
elseif strcmp(type,'element')==1,
    for k=1:3,
        eles=eles_new(:,k);
        array_new(eles,:)=array;
    end
else
    error(' in REFINE_ARRAY.M type not found ')
end