function [grid_new] = refine_2d_homo(grid,level_ref)

eles  = grid.eles_to_ref;
xnod  = grid.xnod;
icone = grid.icone;
eles_edges = grid.eles_edges;
edges_refined = grid.edges_refined;
edges_father_refined = grid.edges_father_refined;
eles_level_ref = grid.eles_level_ref;

[numel,nen] = size(icone);
[numnp,ndm] = size(xnod);
[nnod,ndof] = size(state);

inoar = get_inoar(ndm,nen);

nlast       = max(max(icone));
elelast     = numel;

iconew      = icone;
xnew        = xnod;
ele_edges_new = ele_edges;
nedges = length(edges_refined);
nedgelast = nedges;
nele = length(eles);

icone_ref_info = icone;

for k=1:nele
    ele = eles(k);
    nodes = [];
    % edge refinement
    edges = ele_edges(ele,:);
    for m=1:length(edges),
        edge=edges(m);
        n1 = inoar(m,1); n2 = inoar(m,2);            
        n1 = icone(ele,n1); n2 = icone(ele,n2);        
        if edges_refined(edge)==0,
            edges_refined(edge)=nlast+1;
            edges_father_refined(edge,1:2)=[n1,n2];
            nlast=nlast+1;
            xnew(nlast,:)= (xnod(n1,:)+xnod(n2,:))/2;
            statenew(nlast,:)= (state(n1,:)+state(n2,:))/2;            
            nodes = [ nodes; [n1;edges_refined(edge)] ];            
            icone_ref_info(ele,nen+m)=edges_refined(edge);
        else
            nodes = [ nodes; [n1;edges_refined(edge)] ];                    
            icone_ref_info(ele,nen+m)=edges_refined(edge);            
            edges_refined(edge)=0;            
        end 
    end    
    if nen==4,
        % element refinement    
        icone_ref_info(ele,2*nen+1)=nlast+1;                    
%        eles_refined(ele)=nlast+1;
        nodes = [nodes;nlast+1];
        nlast = nlast+1;
        xnew(nlast,:)= (xnod(nodes(1),:)+xnod(nodes(5),:))/2;
        statenew(nlast,:)= (state(nodes(1),:)+state(nodes(5),:))/2;        
        iconew(ele,:) = nodes([1,2,9,8])';
        iconew(elelast+1,:) = nodes([2,3,4,9])';
        iconew(elelast+2,:) = nodes([8,9,6,7])';
        iconew(elelast+3,:) = nodes([9,4,5,6])';    
        eles_level_ref(ele) = eles_level_ref(ele)+1;
        eles_level_ref(elelast+1) = level_ref+1;
        eles_level_ref(elelast+2) = level_ref+1;        
        eles_level_ref(elelast+3) = level_ref+1;        
        ele_edges_new(ele,1:4) = nedgelast+(1:4);
        ele_edges_new(elelast+1,1:4) = nedgelast+4+(1:4);        
        ele_edges_new(elelast+2,1:4) = nedgelast+2*4+(1:4);                
        ele_edges_new(elelast+3,1:4) = nedgelast+3*4+(1:4);                       
        edges_refined = [edges_refined;zeros(16,1)];
        %        edges_father_refined = [edges_father_refined;zeros(16,2)];
        edges_father_refined(nedgelast+(1:4),1:2) =nodes([1,2;2,9;9,8;8,1]); 
        edges_father_refined(nedgelast+4+(1:4),1:2) =nodes([2,3;3,4;4,9;9,2]); 
        edges_father_refined(nedgelast+4*2+(1:4),1:2) =nodes([8,9;9,6;6,7;7,8]);         
        edges_father_refined(nedgelast+4*3+(1:4),1:2) =nodes([9,4;4,5;5,6;6,9]);         
        
%        eles_refined = [eles_refined;zeros(4,1)];        
        icone_ref_info(ele,2*nen+1+(1:3)) = elelast+(1:3);
        elelast = elelast+3;        
        nedgelast = nedgelast+16;        
    else
        iconew(ele,:) = nodes([1,2,6])';
        iconew(elelast+1,:) = nodes([2,3,4])';        
        iconew(elelast+2,:) = nodes([2,4,6])';        
        iconew(elelast+3,:) = nodes([6,4,5])';                
        eles_level_ref(ele) = eles_level_ref(ele)+1;
        eles_level_ref(elelast+1) = level_ref+1;
        eles_level_ref(elelast+2) = level_ref+1;        
        eles_level_ref(elelast+3) = level_ref+1;        
        ele_edges_new(ele,1:3) = nedgelast+(1:3);
        ele_edges_new(elelast+1,1:3) = nedgelast+3+(1:3);        
        ele_edges_new(elelast+2,1:3) = nedgelast+2*3+(1:3);                
        ele_edges_new(elelast+3,1:3) = nedgelast+3*3+(1:3);                       
        edges_refined = [edges_refined;zeros(12,1)];        
        edges_father_refined(nedgelast+(1:3),1:2) =nodes([1,2;2,6;6,1]); 
        edges_father_refined(nedgelast+3+(1:3),1:2) =nodes([2,3;3,4;4,2]); 
        edges_father_refined(nedgelast+3*2+(1:3),1:2) =nodes([2,4;4,6;6,1]);         
        edges_father_refined(nedgelast+3*3+(1:3),1:2) =nodes([6,4;4,5;5,6]);         
        icone_ref_info(ele,2*nen+(1:3)) = elelast+(1:3);
        elelast = elelast+3;                        
        nedgelast = nedgelast+12;        
%        eles_refined = [eles_refined;zeros(3,1)];        
    end
%disp(' REFINE 2D END ');keyboard;pause    
end
