%
%  K predictor & poisson and R predictor
%

u_gu = rowprod(dUpg(:,indx_v,:),Upg(:,indx_v),ndm,ndm,1);

visco_model = 1;  % [0] modelo viscoso basado en solo la parte de la div grad vel
visco_model = 0;  % [0] modelo viscoso normalmente usado ( div grad vel + grad div vel )

if visco_model==0
    strain_rate = row_transp(dUpg(:,indx_v,:));
    strain_rate = 0.5*(strain_rate + dUpg(:,indx_v,:));
    sigma       = 2*visco*strain_rate;
else
    strain_rate = alpha*dU1pg(:,indx_v,:);
    strain_rate = strain_rate + (1-alpha)*dU0pg(:,indx_v,:);
    strain_rate = row_transp(strain_rate);
    sigma       = visco*strain_rate;
end

terd        = rowprod(dshapex,sigma,nen,ndm,ndm);
dshapex_t   = row_transp(dshapex);
terd_m      = visco*rowprod(dshapex,dshapex_t,nen,ndm,nen);

grad_p = reshape(dU0pg(:,indx_p,:),ne,ndm,1);    
%grad_p = reshape(dUpg(:,indx_p,:),ne,ndm,1);    

% phase k diffusivity
diffu_vf = nu_vf/Sct_vf;

% termino convectivo
u_gvf = zeros(ne,1);
for idm=1:ndm
    u_gvf = u_gvf + dUpg(:,indx_vf,idm).*velpg_vf(:,idm);
end

% termino difusivo
for k=1:ndm
    sigma_vf(:,k) = diffu_vf.*dUpg(:,indx_vf,k);
end

for inod=1:nen,   
    
    if tau_centroide==0,
        compute_P_supg;
    end
    
    W_supg = P_delta;      
    for idf=1:ndm,
        W_supg(:,idf,idf)=W_supg(:,idf,idf)+N(inod);
    end
    
    % Residual assembling        
    % R_mom = (U1pg(:,indx_v)-U0pg(:,indx_v))/dt+u_gu+grad_p;
    R_mom_2 = (rho_m*[1,1]).*u_gu;
    R_mom_1 = (rho_m*[1,1]).*(U1pg(:,indx_v)-U0pg(:,indx_v))/dt + grad_p;
    
    for idm=1:ndm
        Rele(:,inod,indx_v(idm)) = Rele(:,inod,indx_v(idm)) - ( ...  
            W_supg(:,idm,idm).*R_mom_2(:,idm) + ...                  % momentum residual ( Galerkin + SUPG )
            N(inod).*R_mom_1(:,idm) + ...                  % momentum residual ( Galerkin + SUPG )
            terd(:,inod,idm) ...
            ).*xsj;                         
    end
    
    % void fraction for phase k    
    W_supg_vf = P_vf;          
    W_supg_vf = W_supg_vf +N(inod);
    
    if 0                
        R_vf = (U1pg(:,indx_vf)-U0pg(:,indx_vf))/dt+u_gvf;
        
        Rele(:,inod,indx_vf) = Rele(:,inod,indx_vf) - ( ...  
            W_supg_vf .*R_vf + ...            % temporal and convective terms
        (dshapex(:,inod,1).*sigma_vf(:,1)+dshapex(:,inod,2).*sigma_vf(:,2)) ...
            ).*xsj;                 
    end
    
    % Matriz assembling
    for jnod=1:nen,        
        
        u_gN = zeros(ne,ndm);
        for idm=1:ndm
            for jdm=1:ndm
                u_gN(:,idm) = u_gN(:,idm) + dshapex(:,jnod,jdm).*Upg(:,indx_v(jdm));
            end
        end            
        
        %keyboard;pause
        for idm=1:ndm
            Kele(:,inod,indx_v(idm),jnod,indx_v(idm)) = Kele(:,inod,indx_v(idm),jnod,indx_v(idm)) + ( ...  
                rho_m.*(N(inod)*N(jnod)/dt + ...
                alpha*W_supg(:,idm,idm).*u_gN(:,idm))      + ... % termino convectivo                  
                alpha*terd_m(:,inod,jnod) ... 
                ).*xsj;  
            
            Kele(:,inod,indx_p,jnod,indx_p) = Kele(:,inod,indx_p,jnod,indx_p) + ( ...
                dt*dshapex(:,inod,idm).*dshapex(:,jnod,idm) + ...
                P_epsilon(:,1,indx_v(idm)).*dshapex(:,jnod,idm) ...
                ).*xsj; 
            
            if visco_model==0
                for jdm=1:ndm
                    Kele(:,inod,indx_v(idm),jnod,indx_v(jdm)) = ... 
                        Kele(:,inod,indx_v(idm),jnod,indx_v(jdm)) + ( ...                      
                        alpha*visco*dshapex(:,inod,jdm).*dshapex(:,jnod,idm) ...
                        ).*xsj; 
                end
            end
            
        end
        
        % void fraction for phase k            
        u_gN_vf = zeros(ne,1);
        for idm=1:ndm            
            u_gN_vf = u_gN_vf + dshapex(:,jnod,idm).*velpg_vf(:,idm);            
        end            
        %keyboard;pause
        
        if(weak_form)
            Kele(:,inod,indx_vf,jnod,indx_vf) = Kele(:,inod,indx_vf,jnod,indx_vf) + ( ...  
                1*W_supg_vf*N(jnod)/(dt) + ... % termino temporal
                0*N(inod)*N(jnod)/dt + ...                
                P_vf.*u_gN_vf      - ... % termino convectivo                  
                (dshapex(:,inod,1).*velpg_vf(:,1) + dshapex(:,inod,2).*velpg_vf(:,2))*N(jnod) + ...
                diffu_vf*(dshapex(:,inod,1).*dshapex(:,jnod,1) + ... 
                dshapex(:,inod,2).*dshapex(:,jnod,2)) ...  % termino difusivo
                ).*xsj;              
        else
            Kele(:,inod,indx_vf,jnod,indx_vf) = Kele(:,inod,indx_vf,jnod,indx_vf) + ( ...  
                1*W_supg_vf*N(jnod)/(dt) + ... % termino temporal
                0*N(inod)*N(jnod)/dt + ...
                W_supg_vf.*u_gN_vf      + ... % termino convectivo                  
                diffu_vf*(dshapex(:,inod,1).*dshapex(:,jnod,1) + ... 
                dshapex(:,inod,2).*dshapex(:,jnod,2)) ...  % termino difusivo
                ).*xsj;  
        end
    end % jnod
    
end % inod

%   disp('bubbly_2d_ele (liquid) phase ');keyboard;pause   
