%
%  K and R for phase k mass conservation
%

debug_flag = 1;

if (debug_flag)
nu_t = 1;
Sc_t = 1;
end
diffu_vf = nu_t/Sc_t;

% termino convectivo
u_gvf = zeros(ne,1);
for idm=1:ndm
    u_gvf = u_gvf + dUpg(:,indx_vf,idm).*velpg_vf(:,idm);
end

% termino difusivo
for k=1:ndm
    sigma(:,k) = diffu_vf.*dUpg(:,indx_vf,k);
end

for inod=1:nen,   
    
    if tau_centroide==0,
        compute_P_supg;
    end
    
    W_supg = P_vf;          
    W_supg=W_supg+N(inod);

    
    % Residual assembling        
    R_vf = (U1pg(:,indx_vf)-U0pg(:,indx_vf))/dt+u_gvf;

    Rele(:,inod,indx_vf) = Rele(:,inod,indx_vf) - ( ...  
        W_supg.*R_vf + ...            % temporal and convective terms
        (dshapex(:,inod,1).*sigma(:,1)+dshapex(:,inod,2).*sigma(:,2)) ...
    ).*xsj;                 
    
    % Matriz assembling
    for jnod=1:nen,        
        
        u_gN = zeros(ne,1);
        for idm=1:ndm            
            u_gN = u_gN + dshapex(:,jnod,idm).*velpg_vf(:,idm);            
        end            
        %keyboard;pause

            Kele(:,inod,indx_vf,jnod,indx_vf) = Kele(:,inod,indx_vf,jnod,indx_vf) + ( ...  
                0*W_supg*N(jnod)/(dt) + ... % termino temporal
                N(inod)*N(jnod)/dt + ...
                W_supg.*u_gN      + ... % termino convectivo                  
                diffu_vf*dshapex(:,inod,1).*dshapex(:,jnod,1) + ... 
                diffu_vf*dshapex(:,inod,2).*dshapex(:,jnod,2) ...  % termino difusivo
                ).*xsj;  
        
    end % jnod
    
end % inod

%   disp('bubbly_2d_ele (liquid) phase ');keyboard;pause   
