function [Kele,Rele] = bc_teco(xnod,icone,T,teco,Kele,Rele,axisim)
%
%   [Kele,Rele] = bc_teco(xnod,icone,T,teco,Kele,Rele,axisim)
%

[numel,nen] = size(icone);
[nteco,bas] = size(teco);
npg = 2;

if nteco~=0,
   
  pgauss1d;
   
  eles_teco = teco(:,1);
  face_teco = teco(:,2);
  val1_teco = teco(:,3);
  val2_teco = teco(:,4);

  nodo_1 = face_teco;
  nodo_2 = (nodo_1+1).*(nodo_1<nen)+(nodo_1==nen);
  nodos  = [nodo_1,nodo_2];
  
  nodog1 = getcol(icone(eles_teco,:),nodo_1);
  nodog2 = getcol(icone(eles_teco,:),nodo_2);  
  nodog  = [nodog1 , nodog2];
    
  lteco  = sqrt((xnod(nodog1,1) - xnod(nodog2,1)).^2 + ... 
                (xnod(nodog1,2) - xnod(nodog2,2)).^2 );             
  Jaco = lteco/2;
    
  re = v2m(xnod(icone(eles_teco,:)',1),nen);
  re = [getcol(re,nodo_1), getcol(re,nodo_2) ];
    
  Te(:,1) = getcol(T(eles_teco,:),nodo_1);
  Te(:,2) = getcol(T(eles_teco,:),nodo_2);

  for ipg=1:2,
     
   N = ones(nteco,1)*[(1-psipg(ipg))/2 , (1+psipg(ipg))/2 ];
   
% Localizacion , scatter   
   Tpg      = zeros(nteco,1);
   radpg    = zeros(nteco,1);
   
   for inod=1:2,    
    radpg  = radpg +  N(:,inod).*re(:,inod);
    Tpg    = Tpg   +  N(:,inod).*Te(:,inod);
   end 
        
   xsj = wpg(ipg)*Jaco;
   if axisim,
     xsj = xsj.*radpg;
   end
      
   for iface=1:nen,
      eles = find(face_teco==iface);      
      if isempty(eles)==0,
      for inod=1:2,
       jnod = iface-1+inod;
       if(jnod>nen),jnod=1; end 
       vaux =  N(eles,inod).*val1_teco(eles).*(Tpg(eles)-val2_teco(eles)).*xsj(eles);       
       Rele(eles_teco(eles),jnod,1) = Rele(eles_teco(eles),jnod,1) - vaux;                 
       for iinod=1:2, 
         jjnod = iface-1+iinod;
         if(jjnod>nen),jjnod=1; end           
         vaux  =  N(eles,inod).*val1_teco(eles).*N(eles,iinod).*xsj(eles);         
         Kele(eles_teco(eles),jnod,1,jjnod,1) = Kele(eles_teco(eles),jnod,1,jjnod,1)+ vaux;           
       end % for iinod
     end  % for inod
    end % isempty
   end % for iface
  end % puntos de Gauss del contorno
      
end % if nteco

