% ====================================================================
%
%                       column bubbly
%
% ====================================================================

ref = 1;

vslip_variable = 0;

read_from_file = 0;
filestate_to_read = '';

filestate = '';

nnwt = 3;

shocap                = 0;
weak_form             = 1; 
reverse_normal        = 0;

Cou   =  1;
npg   =  4;
ndf   =  6;
tol   = 1e-6;

Lx = 1;                     % Depth of the fluid
Ly = 5;
Nx = 11*ref;                     % Number of elements in r dir
Ny = 41*ref;
xratio = 1;               % Ratio between axis / side element size
yratio = 1;                  % Ratio between axis / side element size

% PHYSICAL DATA
gravity    = -9.8;
Rey        =  400;
rho        =  10.0;
visco      =  rho/Rey
axisim     = 0;
tau_factor = 1;

nphases    = 1;
g_dir      = 2;
vslip      = 0.5;
Sct_vf     = 1;
visco_g    = 1e-4;
rho_g      = 1;
dp         = 1e-3;

% BOUNDARY CONDITIONS
p_ref      = 0;
v_wall     = [0,0];
vf_ref     = 1e-1;

% INITIAL VALUES
p_ini      = p_ref;
vel_ini    = v_wall;
vf_ini     = 0*vf_ref;

% ====================================================================
xnod     =[];
icone    =[];
x        = refh([1,2,1],Nx)*Lx;
y        = refh([1,1,1],Ny)*Ly;
%-------- coordenadas (XNOD)
for k=1:Ny,
    xnod=[xnod;[x y(k)*ones(Nx,1)]];
end

%-------- conectividades (ICONE)
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
ico2= [ (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' (1:Nx-1)'];
for k=1:Ny-1,
    icone=[icone; (k-1)*Nx+ico ];
end
% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end

[numnp,ndm] = size(xnod);
[numel,nen] = size(icone);
xmax = max(xnod);
xmin = min(xnod);

get_index

%-------- Solucion inicial (PHI)
if read_from_file==1,
    eval(['load ' filestate_to_read '.mat']);
    U = phi;
else
    uini    = [p_ini,vel_ini,vf_ini,0*vel_ini];
    U       =  ones(numnp,1)*uini;       
    nodes_gas = find(xnod(:,2)<(xmin(2)+xmax(2))/4);
    U(nodes_gas,indx_vf) = 2*vf_ref;
    y0 = (xmin(2)+xmax(2))/4;
    y1 = (xmin(2)+xmax(2))/2;
    v0 = vf_ref*(0.5*(1+tanh((xnod(:,2)-y0)/0.2)));
    v1 = vf_ref*(1-0.5*(1+tanh((xnod(:,2)-y1)/0.2)));    
    U(:,indx_vf) = (v1.*v0)*10;
    rho_l = rho;
    rho_m     = compute_rho_m(U(:,indx_vf),rho_l,rho_g);
    U(:,indx_p) = p_ref+abs(gravity)*rho_m.*(Ly-xnod(:,2));
end


%-------- fijaciones (FIXA)
nodes_bot   = (1:Nx)';
nodes_top   = Nx*(Ny-1)+(1:Nx)';
nodes_lef   = (1:Nx:Nx*Ny)';
nodes_rig   = (Nx:Nx:Nx*Ny)';
nodes_wall  = rmdblist([nodes_bot;nodes_lef;nodes_rig;nodes_top]);

fixa= zeros(numnp,ndf);

fixa(nodes_wall,indx_v) = ones(length(nodes_wall),ndm);
fixa(nodes_top,indx_p)          = 1;

fixa(nodes_bot,indx_vf) = 1;

if 0
%    fixa(:,indx_v) = 1;
    fixa(:,indx_p) = 1;
%    fixa(:,indx_vf) = 1;
end

if 0
    fixa(:,indx_v_d) = 1;
else
    fixa([nodes_bot],indx_v_d) = 1;    
end

%-------- Cargas/Desplazamientos nodales(FORC)
forc                     = zeros(numnp,ndf);
forc(nodes_top,indx_p)           = p_ref;
forc(nodes_wall,indx_v)  = ones(length(nodes_wall),1)*v_wall;

forc(nodes_bot,indx_vf)  = 0;

if 0
    forc(:,indx_v_d(g_dir)) = vslip;
else
    forc([nodes_bot],indx_v_d) = 0;    
end

if 0
%    forc(:,indx_v) = U(:,indx_v);
    forc(:,indx_p) = U(:,indx_p);
%    forc(:,indx_vf) = U(:,indx_vf);
end

%-------- Propiedades del material
ijob = 'set';
handle_prop_elem;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas y deslizamiento AHORA como linear constraints
lin_con = [];
if 0,
    for icompo=[1,2,3]
        lin_con = [lin_con ; ... 
                [ones(length(nodes_lef),1) nodes_lef icompo*ones(length(nodes_lef),1) ...
                    -ones(length(nodes_rig),1) nodes_rig icompo*ones(length(nodes_rig),1)]];
        
        lin_con = [lin_con ; ... 
                [ones(length(nodes_top),1) nodes_top icompo*ones(length(nodes_top),1) ...
                    -ones(length(nodes_top),1) nodes_top-2 icompo*ones(length(nodes_top),1)]];
    end
end

% condicion inicial en primitivas
%-----------------------------------------------
if 1,
    bini   = U;
    for k=1:ndf,
        nofree        = find(fixa(:,k)~=0);
        bini(nofree,k)   = forc(nofree,k);
    end   
end

bc_time_flag = 0;
bc_time_t_end = 100000;

hc_gas = [];