function [K,R] = get_num_jacobian(filename,U,flag)
%
%  [K,R] = get_num_jacobian(filename,U,[flag])
%
% if flag ~=0 , U is a field
%

if nargin < 3, flag=0; end

if flag~=0,
    [nU,nr]=size(U);
else
    [nr,nc]=size(U);
end

eval(['R=' filename '(U);']);
ep = 1e-7;

if flag==0
    for kr=1:nr,
        for kc=1:nc, 
            Up = U;
            if (abs(Up(kr,kc))<ep), 
                Up(kr,kc) = ep; 
            else
                Up(kr,kc) = Up(kr,kc)*(1+ep);            
            end        
            eval(['rp=' filename '(Up);']);
            Up = U;    
            if (abs(Up(kr,kc))<ep), 
                Up(kr,kc) = -ep; 
            else        
                Up(kr,kc) = Up(kr,kc)*(1-ep);    
            end
            eval(['rm=' filename '(Up);']);
            if (abs(U(kr,kc))<ep), 
                K(:,(kr-1)*nc+kc) = -(rp-rm)/(2*ep);            
            else        
                K(:,(kr-1)*nc+kc) = -(rp-rm)./(2*U(kr,kc)*ep);
            end
        end
    end
else
    for kr=1:nr,
        Up = U;
        
        nn = find(abs(Up(:,kr))<=ep);
        Up(nn,kr) = ep;
        nn = find(abs(Up(:,kr))>ep);            
        Up(nn,kr) = Up(nn,kr)*(1+ep);                        
        eval(['rp=' filename '(Up);']);
        
        Up = U;    
        
        nn = find(abs(Up(:,kr))<=ep);
        Up(nn,kr) = -ep;
        nn = find(abs(Up(:,kr))>ep);            
        Up(nn,kr) = Up(nn,kr)*(1-ep);                        
        eval(['rm=' filename '(Up);']);
        
        nn = find(abs(U(:,kr))<=ep);
        K(nn,kr) = -(rp(nn,:)-rm(nn,:))/(2*ep);            
        nn = find(abs(U(:,kr))>ep);
        K(nn,kr) = -(rp(nn,:)-rm(nn,:))./(2*U(nn,kr)*ep);
    end
end
