function [phi,Rgh] = newton_solver(file_res,phi)
%
%
%    [phi,Rgh] = newton_solver(file_res,phi)
%
%

iter = 0;
jter = 0;
sigma_jter = 5;
lconv = 1;
jtermax = 0;
relax0 = 0.1;
tol    = 1e-10;
itermax = 1000;
%phi = phi0;

dphi = 0*phi;

while lconv
    iter=iter+1;
    jter=jter+1;
    if iter==1, phi0 = phi; end
    
    flag = 1; % means that the nonlinear eqs are many (a field) scalar equations
    [Kg,Rg] = get_num_jacobian(file_res,phi,flag);    
    
    relax = min(relax0 + tanh(jter/sigma_jter),1);
    free = (abs(Rg)>0);
    dphi(free) = relax*Rg(free)./Kg(free,:);    
    
    phi=phi+dphi;
    
    if iter==1, Rg0=Rg; Rgh=[]; end 
    Rgh = [Rgh;[relax,norm(Rg)]];
    lconv = (norm(dphi)>tol)&(iter<itermax);
    %        lconv = (norm(dphi)>tol);        
    %        disp([' || dphi || = ' num2str(norm(dphi))])
    %disp([' || Rg || = ' num2str(norm(Rg))])   
    
    if (iter>100 & norm(Rg)>norm(Rg0))                    
        disp(' Newton_solver in Femcode , problems with convergence ');keyboard;pause                    
    end
    
end

disp([' convergence of drag model || Rg || / || Rg(0) || = ' num2str(norm(Rg)/norm(Rg0))])   

%disp('newton_solver');keyboard;pause