%
%   ASM + fase dispersa
%

C_smag = 0.18;
Damping_factor = 1;

type_upwind         = 1;
tau_centroide       = 0;
debug               = 0;

get_index;

visco = prop(2);

% cutoff void fraction between 0 and 1
if 0
    tol = 1e-4;
    alpha_g = min([U(:,indx_vf)';(1-tol)*ones(1,numnp)])';
    U(:,indx_vf) = max([alpha_g';tol*ones(1,numnp)])';
end

%------------------------------------------------------------------
ne  = length(eles);
[bas,ndf_fields] = size(extra_nodal_fields);

rho_l       = rho;
rho_m_old   = compute_rho_m(Uold(:,indx_vf),rho_l,rho_g);
V0liq_nod   = compute_Vliq(rho_l,rho_m_old,Uold(:,indx_v),rho_g,Uold(:,indx_v_d),Uold(:,indx_vf));
rho_m       = compute_rho_m(U(:,indx_vf),rho_l,rho_g);
Vliq_nod    = compute_Vliq(rho_l,rho_m,U(:,indx_v),rho_g,U(:,indx_v_d),U(:,indx_vf));

% Localizacion de las variables
%------------------------------------------------------------------
ceros = zeros(ne,nen*ndf);
Ue = ceros;
U0e = ceros;
re = zeros(ne,nen);
Vliq_ele = zeros(ne,nen*ndm);
V0liq_ele = zeros(ne,nen*ndm);

for inod=1:nen,
    nodes  = icone(eles,inod);
    jnod  = (inod-1)*ndf+(1:ndf);
    lnod  = (inod-1)*ndm+(1:ndm);
    knod  = (inod-1)*ndf_fields+(1:ndf_fields);            
    Ue(:,jnod)  = U(nodes,1:ndf);		 
    Vliq_ele(:,lnod) = Vliq_nod(nodes,1:ndm);
    V0liq_ele(:,lnod) = V0liq_nod(nodes,1:ndm);    
    U0e(:,jnod) = Uold(nodes,1:ndf);   
    re(:,inod)  = xnod(nodes,1);		        
    if (ndf_fields>0)
        Ue_fields(:,knod) = extra_nodal_fields(nodes,1:ndf_fields);
    end
end

% UPWIND EN EL CENTROIDE 
%------------------------------------------------------------------
if nen==4,
    [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),0,0);
    [dshapex,N] = shape2d(X2S,0,0,nen); 
elseif nen==3,
    [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),1/3,1/3);
    [dshapex,N] = shape2d(X2S,1/3,1/3,nen); 
else
    error(' Bad type of element , nen ~=3, nen ~=4 ')
end

Upg          = zeros(ne,ndf);
dUpg         = zeros(ne,ndf,ndm);
Upg_fields   = zeros(ne,ndf_fields);

for inod=1:nen,
    jnod = (inod-1)*ndf+(1:ndf);
    knod  = (inod-1)*ndf_fields+(1:ndf_fields);                
    Upg(:,(1:ndf))    =  Upg(:,(1:ndf)) + N(inod).*  U0e(:,jnod);
    for idm=1:ndm
        dUpg(:,(1:ndf),idm) = dUpg(:,(1:ndf),idm) + ...
            (dshapex(:,inod,idm)*ones(1,ndf)).* U0e(:,jnod);          
    end
    if (ndf_fields>0)
        Upg_fields(:,1:ndf_fields) = Upg_fields(:,1:ndf_fields) + N(inod).* Ue_fields(:,knod);
    end
end    

if tau_centroide==1,
    velpg   = Upg(:,indx_v);
    hele    = comp_hele(velpg,dshapex,Jaco,nen);
    %    [tau,delta,bas] = supg_nsi_tet(Upg,dUpg,hele,prop,type_upwind);
    
    strain_rate = row_transp(dUpg(:,indx_v,:));
    strain_rate = 0.5*(strain_rate + dUpg(:,indx_v,:));
    
    if LES,
        nu_t = (C_smag*hele).^2.*Damping_factor.*sqrt(2*row_sumall(strain_rate.^2));
    else
        nu_t = zeros(ne,1);
    end
    
    visco_l = visco + rho_m.*nu_t;
    rho_l = rho;
    rho_m     = compute_rho_m(Upg(:,indx_vf),rho_l,rho_g);    
    
    [tau,delta] = supg_nsi_tet(velpg,dUpg,hele,rho_m,visco_l,type_upwind);
    
    velpg_vf = Upg(:,indx_v_d);
    hele_vf  = comp_hele(velpg_vf,dshapex,Jaco,nen);
    %    [tau_vf,delta_vf,bas] = supg_nsi_tet(velpg_vf,reshape(dUpg(:,indx_vf,:),ne,ndm),hele_vf,prop,type_upwind);
    [tau_vf,delta_vf] = supg_nsi_tet(velpg_vf,reshape(dUpg(:,indx_vf,:),ne,ndm),hele_vf,rho_g,visco_g,type_upwind);    
    
    compute_P_supg;   
end


% Loop sobre los puntos de Gauss
%------------------------------------------------------------------
for ipg=1:npg
    
    [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
    [dshapex,N] = shape2d(X2S,psipg(ipg),etapg(ipg),nen); 
    
    % Interpolacion en punto de Gauss
    %------------------------------------------------------------------
    
    Upg     = zeros(ne,ndf);
    U0pg    = zeros(ne,ndf);
    dUpg    = zeros(ne,ndf,ndm);
    Vliqpg  = zeros(ne,ndm);
    V0liqpg  = zeros(ne,ndm);
    dVliqpg = zeros(ne,ndm,ndm);
    radpg   = zeros(ne,1);
    
    for inod=1:nen,
        jnod = (inod-1)*ndf+(1:ndf);
        lnod = (inod-1)*ndm+(1:ndm);
        Upg(:,(1:ndf))  =  Upg(:,(1:ndf)) + N(inod).*  Ue(:,jnod);
        U0pg(:,(1:ndf)) = U0pg(:,(1:ndf)) + N(inod).* U0e(:,jnod);
        Vliqpg(:,(1:ndm)) = Vliqpg(:,(1:ndm)) + N(inod).* Vliq_ele(:,lnod);
        V0liqpg(:,(1:ndm)) = V0liqpg(:,(1:ndm)) + N(inod).* V0liq_ele(:,lnod);        
        radpg(:,1)      =      radpg(:,1) + N(inod).* re(:,inod);
        for idm=1:ndm            
            dUpg(:,(1:ndf),idm)   = dUpg(:,(1:ndf),idm) + ...
                (dshapex(:,inod,idm)*ones(1,ndf)).* Ue(:,jnod);            
            dVliqpg(:,(1:ndm),idm)   = dVliqpg(:,(1:ndm),idm) + ...
                (dshapex(:,inod,idm)*ones(1,ndm)).* Vliq_ele(:,lnod);                        
        end        
    end
    
    xsj =  wpg(ipg) .* Jaco;
    if axisim,
        xsj = xsj.*radpg;
    end
    
    rho_l = rho;
    rho_m_old = compute_rho_m(U0pg(:,indx_vf),rho_l,rho_g);
    rho_m     = compute_rho_m(Upg(:,indx_vf),rho_l,rho_g);
    
    u_gu = rowprod(dUpg(:,indx_v,:),U0pg(:,indx_v),ndm,ndm,1);
    div_u = zeros(ne,1);
    for idm =1:ndm
        div_u = div_u + dUpg(:,indx_v(idm),idm) ;
    end
    
    u_gvf = zeros(ne,1);
    for idm=1:ndm
        u_gvf = u_gvf + dUpg(:,indx_vf,idm).*Upg(:,indx_v_d(idm));
    end
    
    ud_gud = rowprod(dUpg(:,indx_v_d,:),U0pg(:,indx_v_d),ndm,ndm,1);
    
    if 1
        % a futuro aqui calculariamos la div Vel_d cuando sea una incognita
        % (multifluid)
        div_Vel_d = zeros(ne,1);
        for idm =1:ndm
            div_Vel_d = div_Vel_d + dUpg(:,indx_v_d(idm),idm) ;
        end
    else
        div_Vel_d = div_u;
    end
    
    %    disp(' *** NSI_TET_ELE.M ***');keyboard;pause
    
    strain_rate = row_transp(dUpg(:,indx_v,:));
    strain_rate = 0.5*(strain_rate + dUpg(:,indx_v,:));
    strain_rate(:,1,1) = strain_rate(:,1,1)-1/3*div_u;
    strain_rate(:,2,2) = strain_rate(:,2,2)-1/3*div_u;
    
    % a simple frictional model
    visco_g_eff = visco_g;
    if 0
        visco_g_eff = visco_model(Upg(:,indx_vf),prop);
    end
    
    if tau_centroide==0,
        
        velpg   = Upg(:,indx_v);
        hele    = comp_hele(velpg,dshapex,Jaco,nen);
        
        if LES,
            nu_t = (C_smag*hele).^2.*Damping_factor.*sqrt(2*row_sumall(strain_rate.^2));
        else
            nu_t = zeros(ne,1);
        end
        
        visco_l = visco + rho_m.*nu_t;
        
        %        [tau,delta,bas] = supg_nsi_tet(Upg,dUpg,hele,prop,type_upwind);
        [tau,delta] = supg_nsi_tet(velpg,dUpg,hele,rho_m,visco_l,type_upwind);
        
        velpg_vf = Upg(:,indx_v_d);
        hele_vf  = comp_hele(velpg_vf,dshapex,Jaco,nen);
        %        [tau_vf,delta_vf,bas] = supg_nsi_tet(velpg_vf,reshape(dUpg(:,indx_vf,:),ne,ndm),hele_vf,prop,type_upwind);
        [tau_vf,delta_vf] = supg_nsi_tet(velpg_vf,reshape(dUpg(:,indx_vf,:),ne,ndm),hele_vf,rho_g,visco_g_eff,type_upwind);        
    end
    
    visco_m = Upg(:,indx_vf).*visco_g_eff + visco_l.*(1-Upg(:,indx_vf));
    
    sigma = row_scale(strain_rate,2*visco_m);        
    
    terd = rowprod(dshapex,sigma,nen,ndm,ndm);
    dshapex_t = row_transp(dshapex);
    terd_m = rowprod(dshapex,dshapex_t,nen,ndm,nen);    
    
    % disperse phase
    strain_rate_d = row_transp(dUpg(:,indx_v_d,:));
    strain_rate_d = 0.5*(strain_rate_d + dUpg(:,indx_v_d,:));
    strain_rate_d(:,1,1) = strain_rate_d(:,1,1)-1/3*div_Vel_d;
    strain_rate_d(:,2,2) = strain_rate_d(:,2,2)-1/3*div_Vel_d;
    
    %    sigma_d = 2*visco_g_eff*strain_rate_d;    
    sigma_d = row_scale(strain_rate_d,2*visco_g_eff);            
    
    terd_d = rowprod(dshapex,sigma_d,nen,ndm,ndm);
    
    tol = 1e-6;
    alpha_g = Upg(:,indx_vf);
    uno = ones(1,length(alpha_g));
    alpha_g = max([alpha_g';tol*uno])';
    alpha_g = min([alpha_g';(1-tol)*uno])';
    
    % Drag forces
    %Vliq = ((rho_m*[1,1]).*Upg(:,indx_v)- rho_g*(alpha_g*[1,1]).*Upg(:,indx_v_d))./(rho_l*(1-alpha_g)*[1,1]);
    %Vrel = Upg(:,indx_v)-Upg(:,indx_v_d);    
    Vrel = Vliqpg - Upg(:,indx_v_d);   
    Vrelmod = sqrt(sum(Vrel'.^2))';
    Vrelmod = sum(abs(Vrel'))';
    
    C_D  = 0.;
    C_ab = 0.75*C_D/dp*rho_l.*Vrelmod;
    %    C_ab = 0.75*C_D/dp*rho_l*ones(ne,1);
    F_drag = (C_ab*[1,1]).*Vrel;
    
    % disperse phase pressure gradient
    %alpha_g_old = U0pg(:,indx_vf);
    %Vliq_old = ((rho_m_old*[1,1]).*U0pg(:,indx_v)- rho_g*(alpha_g_old*[1,1]).*U0pg(:,indx_v_d))./(rho_l*(1-alpha_g_old)*[1,1]);
    Vrel_old = V0liqpg - U0pg(:,indx_v_d);       
    gVrel = dVliqpg - dUpg(:,indx_v_d,:);
    Vrel_gVrel = rowprod(gVrel,Vrel,ndm,ndm,1);    
    grad_pg = -rho_g*(-(Vrel-Vrel_old)/dt + Vrel_gVrel);
    
    for inod=1:nen,   
        
        if tau_centroide==0,
            compute_P_supg;
        end
        
        W_supg = P_delta;      
        for idf=1:ndm,
            W_supg(:,idf,idf)=W_supg(:,idf,idf) + N(inod);
        end
        
        W_supg_vf = P_delta_vf;      
        for idf=1:ndm,
            W_supg_vf(:,idf,idf) = W_supg_vf(:,idf,idf) + N(inod);
        end
        
        % Residual assembling        
        R_mom = (rho_m*[1,1]).*((Upg(:,indx_v)-U0pg(:,indx_v))/dt+u_gu) + ...
            reshape(dUpg(:,indx_p,:),ne,ndm,1) ;
        R_mom(:,g_dir) = R_mom(:,g_dir) - rho_m*gravity;
        
        for idm=1:ndm
            Rele(:,inod,indx_v(idm)) = Rele(:,inod,indx_v(idm)) - ( ...  
                W_supg(:,idm,idm).*R_mom(:,idm) + ...                  % momentum residual ( Galerkin + SUPG )
                terd(:,inod,idm) ...
                ).*xsj;                 
            Rele(:,inod,indx_p) = Rele(:,inod,indx_p) - ( ...                  
                P_epsilon(:,1,indx_v(idm)).*R_mom(:,idm)  ... % PSPG 
                ).*xsj; 
        end        
        
        Rele(:,inod,indx_p) = Rele(:,inod,indx_p) - ( ... 
            N(inod)*rho_m.*div_u ...                   % continuity Galerkin
            ).*xsj; 
        
        % continuity equation for disperse mass conservation
        R_disperse_mass_time = rho_g*(Upg(:,indx_vf)-U0pg(:,indx_vf))/dt ;
        
        %                keyboard;pause
        Rele(:,inod,indx_vf) = Rele(:,inod,indx_vf) - ( W_supg_vf(:,1,1).*R_disperse_mass_time + ...
            rho_g*P_delta_vf(:,1,1) .* (u_gvf + div_Vel_d.*Upg(:,indx_vf))  ...
            ).*xsj; 
        
        for idm=1:ndm
            Rele(:,inod,indx_vf) = Rele(:,inod,indx_vf) - ... 
                ( -rho_g * dshapex(:,inod,idm) .* Upg(:,indx_vf) .* Upg(:,indx_v_d(idm)) ...               
                ).*xsj;             
        end
        
        % shock capturing for void fraction equation
        for idm=1:ndm
            Rele(:,inod,indx_vf) = Rele(:,inod,indx_vf) - ( ...  
                rho_g*delta_vf.*dshapex(:,inod,idm).*dUpg(:,indx_vf,idm) ...
                ).*xsj;                 
        end
        
        R_mom_d = (Upg(:,indx_vf)*[1,1]).*(rho_g*((Upg(:,indx_v_d)-U0pg(:,indx_v_d))/dt+ud_gud) + ...
            reshape(dUpg(:,indx_p,:),ne,ndm,1)) ;
        R_mom_d(:,g_dir) = R_mom_d(:,g_dir) - rho_g*gravity*Upg(:,indx_vf);            
        R_mom_d = R_mom_d - (Upg(:,indx_vf)*[1,1]).*F_drag;
        R_mom_d = R_mom_d - (Upg(:,indx_vf)*[1,1]).*grad_pg;
        
        for idm=1:ndm
            Rele(:,inod,indx_v_d(idm)) = Rele(:,inod,indx_v_d(idm)) - ( ...  
                W_supg_vf(:,idm,idm).*R_mom_d(:,idm) + ...                  % momentum residual ( Galerkin + SUPG )
                Upg(:,indx_vf).*terd_d(:,inod,idm) ...
                ).*xsj;                 
        end        
        
        
        % Matriz assembling
        for jnod=1:nen,        
            
            u_gN = zeros(ne,ndm);            
            ud_gN = zeros(ne,ndm);            
            for idm=1:ndm
                for jdm=1:ndm
                    u_gN(:,idm) = u_gN(:,idm) + dshapex(:,jnod,jdm).*U0pg(:,indx_v(jdm));
                    ud_gN(:,idm) = ud_gN(:,idm) + dshapex(:,jnod,jdm).*U0pg(:,indx_v_d(jdm));                    
                end
            end            
            
            %keyboard;pause
            for idm=1:ndm
                Kele(:,inod,indx_v(idm),jnod,indx_v(idm)) = Kele(:,inod,indx_v(idm),jnod,indx_v(idm)) + ( ...  
                    W_supg(:,idm,idm).*rho_m.*N(jnod)/dt + ... % termino temporal
                    W_supg(:,idm,idm).*rho_m.*u_gN(:,idm)      + ... % termino convectivo                  
                    visco_m.*terd_m(:,inod,jnod) ... 
                    ).*xsj;  
                Kele(:,inod,indx_v(idm),jnod,indx_p) = Kele(:,inod,indx_v(idm),jnod,indx_p) + ( ...  
                    W_supg(:,idm,idm).*dshapex(:,jnod,idm) ...  % termino presion
                    ).*xsj;                     
                Kele(:,inod,indx_p,jnod,indx_v(idm)) = Kele(:,inod,indx_p,jnod,indx_v(idm)) + ( ...  
                    N(inod)*dshapex(:,jnod,idm).*rho_m + ... % termino continuidad Galerkin
                    P_epsilon(:,1,indx_v(idm)).*rho_m.*N(jnod)/dt + ... % estabilizacion continuidad temporal
                    P_epsilon(:,1,indx_v(idm)).*rho_m.*u_gN(:,idm) ... % estabilizacion continuidad convectivo
                    ).*xsj; 
                Kele(:,inod,indx_p,jnod,indx_p) = Kele(:,inod,indx_p,jnod,indx_p) + ( ...
                    P_epsilon(:,1,indx_v(idm)).*dshapex(:,jnod,idm) ...
                    ).*xsj; 
                
                for jdm=1:ndm
                    Kele(:,inod,indx_v(idm),jnod,indx_v(jdm)) = ... 
                        Kele(:,inod,indx_v(idm),jnod,indx_v(jdm)) + ( ...                      
                        visco_m.*dshapex(:,inod,jdm).*dshapex(:,jnod,idm) ...
                        ).*xsj; 
                    
                    Kele(:,inod,indx_v(idm),jnod,indx_v(jdm)) = ... 
                        Kele(:,inod,indx_v(idm),jnod,indx_v(jdm)) + ( ...                      
                        -2/3*visco_m.*dshapex(:,inod,idm).*dshapex(:,jnod,jdm) ...
                        ).*xsj; 
                    
                end
                
            end
            
            Kele(:,inod,indx_vf,jnod,indx_vf) = Kele(:,inod,indx_vf,jnod,indx_vf) + ( ...  
                rho_g*W_supg_vf(:,1,1)*N(jnod)/dt  ... % termino temporal
                ).*xsj;                  
            
            for idm=1:ndm
                Kele(:,inod,indx_vf,jnod,indx_vf) = Kele(:,inod,indx_vf,jnod,indx_vf) + ( ...                  
                    -rho_g*dshapex(:,inod,idm).*Upg(:,indx_v_d(idm))*N(jnod) + ...
                    rho_g*P_delta_vf(:,1,1).*Upg(:,indx_v_d(idm)).*dshapex(:,jnod,idm) ...
                    ).*xsj;  
            end
            
            Kele(:,inod,indx_vf,jnod,indx_vf) = Kele(:,inod,indx_vf,jnod,indx_vf) + ( ...  
                rho_g*P_delta_vf(:,1,1).*div_Vel_d.*N(jnod)  ...
                ).*xsj;                  
            
            % shock capturing for void fraction equation
            for idm=1:ndm
                Kele(:,inod,indx_vf,jnod,indx_vf) = Kele(:,inod,indx_vf,jnod,indx_vf) + ( ...  
                    rho_g*delta_vf.*dshapex(:,inod,idm).*dshapex(:,jnod,idm) ...
                    ).*xsj;                 
            end
            
            
            for idm=1:ndm
                Kele(:,inod,indx_v_d(idm),jnod,indx_v_d(idm)) = Kele(:,inod,indx_v_d(idm),jnod,indx_v_d(idm)) + ( ...  
                    rho_g.*alpha_g.*W_supg_vf(:,idm,idm) .*  ...
                    ( N(jnod)/dt + ud_gN(:,idm) )     + ... 
                    visco_g_eff*alpha_g.*terd_m(:,inod,jnod) ... 
                    ).*xsj;  
                
                Kele(:,inod,indx_v_d(idm),jnod,indx_v_d(idm)) = Kele(:,inod,indx_v_d(idm),jnod,indx_v_d(idm)) + ( ...  
                    W_supg_vf(:,idm,idm).* alpha_g.*(C_ab+0.75*C_D/dp*rho_l*sign(Vrel(:,idm)).*Vrel(:,idm))*N(jnod) ...
                    ).*xsj;  
                
                for jdm=1:ndm
                    Kele(:,inod,indx_v_d(idm),jnod,indx_v_d(jdm)) = ... 
                        Kele(:,inod,indx_v_d(idm),jnod,indx_v_d(jdm)) + ( ...                      
                        visco_g_eff.*alpha_g.*dshapex(:,inod,jdm).*dshapex(:,jnod,idm) ...
                        ).*xsj;                     
                    Kele(:,inod,indx_v_d(idm),jnod,indx_v_d(jdm)) = ... 
                        Kele(:,inod,indx_v_d(idm),jnod,indx_v_d(jdm)) + ( ...                      
                        -2/3*visco_g_eff.*alpha_g.*dshapex(:,inod,idm).*dshapex(:,jnod,jdm) ...
                        ).*xsj;                     
                end
                
                Kele(:,inod,indx_v_d(idm),jnod,indx_v_d(idm)) = Kele(:,inod,indx_v_d(idm),jnod,indx_v_d(idm)) + ( ...  
                    - rho_g * W_supg_vf(:,idm,idm).* alpha_g.*( - N(jnod)/dt + Vrel(:,idm) .*  dshapex(:,jnod,idm)) ...
                    ).*xsj;  
                
            end
            
        end % jnod
        
    end % inod
    
    %   disp('bubbly_2d_ele (liquid) phase ');keyboard;pause   
    
end % ipg

