function [Kg,Rg] = nsi_fs(xnod,icone,fixa,forc,teco,lin_con,prop,ifaceb,Up,Upold,rowe,cole,fs_step)
%------------------------------------------------------------------
%
%  NSI fractional step solver
%
%  state vector = [p ; vel ]
%
%------------------------------------------------------------------

global row col

ijob = 'get';
handle_prop_elem;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

U    = Up;
Uold = Upold;

[numel,nen]   = size(icone);
[numnp,ndf]   = size(U);
if ndf~=(3+nphases), error(' NDF debe ser 3 + nphases (NSI_TET) ');end
ndm = 2;

if ndm==1,
   pgauss1d;
elseif ndm==2, 
   pgauss2d; 
elseif ndm==3,
   pgauss3d; 
end

Rele = zeros(numel,nen,ndf);
Kele = zeros(numel,nen,ndf,nen,ndf);

Rg    = 0*forc;
eles  = (1:numel)';

%t0 = cputime;
if length(eles)>0,    
   nsi_fs_ele;
end

% ------ Termino de contorno BCCONV
if fs_step==1 | fs_step==4,
    ceros = zeros(length(eles),nen);    
    vfe = ceros;   
    vele = zeros(length(eles),nen,ndm);  
    for inod=1:nen,
        nodes = icone(eles,inod);
        vfe(:,inod) = U(nodes,indx_vf);
        vele(:,inod,1:ndm) = U(nodes,indx_v);
        vele(:,inod,g_dir) = vele(:,inod,g_dir) + vslip;
    end
    
    if (weak_form),
        [Rele,Kele] = bcconv_vf(xnod,icone,vele,vfe,ifaceb,Rele,Kele,axisim,reverse_normal);
    end
    
end

%t1_1=cputime;
%disp([' dt assemble (element) = ' num2str(t1_1-t0)])   

% Gather contributions from eles to nodes
%------------------------------------------------------------------
%disp(' at BUBBLY_2d ')
%keyboard;pause
if (fs_step==0) | (fs_step==1) | (fs_step==4)
    [Rg,Kg] = gather_2(Rele,Kele,icone,nen,ndf,rowe,cole);
else
    [Rg] = gather_res(Rele,icone,nen,ndf,rowe,cole); 
    Kg = 0;
end

%t1_2=cputime;
%disp([' dt assemble (gather) = ' num2str(t1_2-t1_1)])   

%disp('bubbly_2d antes');keyboard;pause
% Linear restrictions
%------------------------------------------------------------------
if isempty(lin_con)==0,
    error(' FALTA IMPLEMENTAR LINEAR CONSTRAINT EN FRACTIONAL STEP ')
    [Rg,Kg] = linear_constraint(Rg,Kg,lin_con,ndf);
%disp('bubbly_2d despues');keyboard;pause
end
