function [Fc,C,Hncx,Hncy] = Cflux(Up,dUp,Dmat_vg,Dmat_vl,prop,rho_g,rho_l,xpg)
%
%    [Fc,C,Hncx,Hncy] = Cflux(Up,dUp,Dmat_vg,Dmat_vl,prop,rho_g,rho_l,xpg)
%

ijob = 'get';
handle_prop_elem;

gravity_vector = [0,gravity];

[N,ndf]  = size(Up);
ndm = (ndf-2)/2;

get_index;

alpha_g      = Up(:,indx_g_vf);
vel_g        =  Up(:,indx_g_vel);
vel_l        =  Up(:,indx_l_vel);
p            =  Up(:,indx_l_p);

grad_alpha_g = dUp(:,indx_g_vf,:);
grad_p       = dUp(:,indx_l_p,:);
grad_vl      = dUp(:,indx_l_vel(2),:);
grad_vg      = dUp(:,indx_g_vel(2),:);

F_drag = zeros(N,ndm);
vrel = vel_g-vel_l;
Cd    = coef_Cd;

vrel_mod = sqrt(sum(vrel'.^2))';
for idm=1:ndm
    F_drag(:,idm) = (-3/8*Cd/(d_bubble/2).*alpha_g.*rho_l.*vrel_mod).*vrel(:,idm);
end

Fc     = zeros(N,ndf);
C      = zeros(N,ndf,ndf);

if interface_pressure_analytical==0,
    p_inter = alpha_g.*(1-alpha_g).*rho_g.*rho_l./(alpha_g.*rho_l+(1-alpha_g).*rho_g).*vrel_mod.^2;
    %p_inter = alpha_g.*(1-alpha_g).*(rho_g+rho_l).*vrel_mod.^2;
    p_inter = coef_sigma*p_inter;
else
    %p_inter = compute_interface_pressure(xpg,alpha_g,p,vel_l(:,2),grad_alpha_g(:,2),grad_p(:,2),grad_vl(:,2),prop);
    p_inter = compute_interface_pressure2(xpg,alpha_g,p,vel_l(:,2),grad_alpha_g(:,2),grad_p(:,2),grad_vl(:,2),vel_g(:,2),grad_vg(:,2),prop);    
end

%p_inter = p_inter+p;
%if stabi_with_nonconservative_terms
%    p_inter = p_inter+p;
%end

factor_grad_p = 1; % ver tambien en flux_function

for idm=1:ndm
    Fc(:,indx_g_mom(idm))  =  p_inter.*grad_alpha_g(:,idm) + gravity_vector(idm)*rho_g.*alpha_g     + F_drag(:,idm);
    Fc(:,indx_l_mom(idm))  = factor_grad_p* (-p_inter.*grad_alpha_g(:,idm)) + gravity_vector(idm)*rho_l.*(1-alpha_g) - F_drag(:,idm) ;
end

Hncx = zeros(N,ndf,ndf);
Hncy = zeros(N,ndf,ndf);

if stabi_with_nonconservative_terms
    Hncx(:,3,1) =  p_inter;
    Hncx(:,5,1) = -p_inter;
    Hncy(:,4,1) =  p_inter;
    Hncy(:,6,1) = -p_inter;
end

Cjac(:,3,1) =  p_inter;
Cjac(:,5,1) = -p_inter;
Cjac(:,4,1) =  p_inter;
Cjac(:,6,1) = -p_inter;


%keyboard;pause