function [Fa,Ax,Ay] = Flux_function(Up,prop,rho_g,rho_l,Cpi,Cp)
%
%        [Fa,Ax,Ay] = Flux_function(Up,prop,rho_g,rho_l,Cpi,Cp)
%
%       Computes advective fluxes F_a
%                   2D    
%	 Dimension of Fa array = numnp x ndm*ndf 
%             

factor_grad_p = 1; % ver tambien en Cflux

job = 1;
if nargin<6, job=0; end

ijob = 'get';
handle_prop_elem;

ndm = 2;
get_index;

indx_w1 = 1;
indx_w2 = 2;
indx_w3 = 2+(1:ndm);
indx_w4 = 2+ndm+(1:ndm);

[N,ndf]  = size(Up);
ndm = (ndf-2)/2;

alpha_g = Up(:,indx_g_vf);
vel_l   = Up(:,indx_l_vel);
vel_g   = Up(:,indx_g_vel);
p       = Up(:,indx_l_p);
alpha_l = 1-alpha_g;

Den = p-alpha_g*p_infty;
dalpha_g_dW = zeros(N,ndf);
dp_dW       = zeros(N,ndf);

if 0
    dalpha_g_dW(:,indx_w1) = -alpha_l*ag2./(gamma_g*Den);
    dalpha_g_dW(:,indx_w2) = alpha_g*al2./(gamma_l*Den);
    dp_dW(:,indx_w1) = (p-p_infty)*ag2./(gamma_g*Den);
    dp_dW(:,indx_w2) = p*al2./(gamma_l*Den);
else
    dalpha_g_dW(:,indx_g_con) = reshape(Cpi(:,indx_g_vf,indx_g_con),N,1);
    dalpha_g_dW(:,indx_l_con) = reshape(Cpi(:,indx_g_vf,indx_l_con),N,1);
    dp_dW(:,indx_g_con)       = reshape(Cpi(:,indx_l_p,indx_g_con),N,1);
    dp_dW(:,indx_l_con)       = reshape(Cpi(:,indx_l_p,indx_l_con),N,1);    
end

% advective fluxes
Fa          = zeros(N,ndf,ndm);
A           = zeros(N,ndm,ndf,ndf);

% momentum eq
for idm=1:ndm
    
    Fa(:,indx_l_con,idm)   = rho_l.*alpha_l.*vel_l(:,idm);
    Fa(:,indx_g_con,idm)   = rho_g.*alpha_g.*vel_g(:,idm);
    
    for jdm=1:ndm
        Fa(:,indx_l_mom(idm),jdm) = Fa(:,indx_l_mom(idm),jdm) + alpha_l.*(rho_l.*vel_l(:,jdm).*vel_l(:,idm));
        Fa(:,indx_g_mom(idm),jdm) = Fa(:,indx_g_mom(idm),jdm) + alpha_g.*(rho_g.*vel_g(:,jdm).*vel_g(:,idm));         
    end
    Fa(:,indx_l_mom(idm),idm) = Fa(:,indx_l_mom(idm),idm) + factor_grad_p*(alpha_l.*p);
    Fa(:,indx_g_mom(idm),idm) = Fa(:,indx_g_mom(idm),idm) + alpha_g.*p;
end

for idm=1:ndm
    A(:,idm,indx_l_con,indx_w4(idm)) = A(:,idm,indx_l_con,indx_w4(idm)) + 1;
    A(:,idm,indx_g_con,indx_w3(idm)) = A(:,idm,indx_g_con,indx_w3(idm)) + 1;    
    
    A(:,idm,indx_g_mom(idm),indx_w1)  = A(:,idm,indx_g_mom(idm),indx_w1) + p.*dalpha_g_dW(:,indx_w1)+alpha_g.*dp_dW(:,indx_w1);     
    A(:,idm,indx_l_mom(idm),indx_w1)  = A(:,idm,indx_l_mom(idm),indx_w1) + 1 * ( ...
        - p.*dalpha_g_dW(:,indx_w1)+(1-alpha_g).*dp_dW(:,indx_w1)); 
    
    A(:,idm,indx_g_mom(idm),indx_w2)  = A(:,idm,indx_g_mom(idm),indx_w2) + p.*dalpha_g_dW(:,indx_w2)+alpha_g.*dp_dW(:,indx_w2);     
    A(:,idm,indx_l_mom(idm),indx_w2)  = A(:,idm,indx_l_mom(idm),indx_w2) + 1 * ( ...
        - p.*dalpha_g_dW(:,indx_w2)+(1-alpha_g).*dp_dW(:,indx_w2)); 
    
    A(:,idm,indx_g_mom(idm),indx_w3(idm))  = A(:,idm,indx_g_mom(idm),indx_w3(idm)) + ... 
        p.*dalpha_g_dW(:,indx_w3(idm))+alpha_g.*dp_dW(:,indx_w3(idm));     
    A(:,idm,indx_l_mom(idm),indx_w3(idm))  = A(:,idm,indx_l_mom(idm),indx_w3(idm)) + 1 * ( ... 
        - p.*dalpha_g_dW(:,indx_w3(idm))+(1-alpha_g).*dp_dW(:,indx_w3(idm)) ); 
    
    A(:,idm,indx_g_mom(idm),indx_w4(idm)) = A(:,idm,indx_g_mom(idm),indx_w4(idm)) + ... 
        p.*dalpha_g_dW(:,indx_w4(idm))+alpha_g.*dp_dW(:,indx_w4(idm));     
    A(:,idm,indx_l_mom(idm),indx_w4(idm)) = A(:,idm,indx_l_mom(idm),indx_w4(idm)) + 1 * ( ... 
        - p.*dalpha_g_dW(:,indx_w4(idm))+(1-alpha_g).*dp_dW(:,indx_w4(idm)) ); 
    
    for jdm=1:ndm
        A(:,idm,indx_g_mom(jdm),indx_w1)  =  A(:,idm,indx_g_mom(jdm),indx_w1)           - vel_g(:,idm).*vel_g(:,jdm); 
        A(:,idm,indx_l_mom(jdm),indx_w2)  =  A(:,idm,indx_l_mom(jdm),indx_w2)           - vel_l(:,idm).*vel_l(:,jdm); 
        
        A(:,idm,indx_g_mom(jdm),indx_w3(jdm))  =  A(:,idm,indx_g_mom(jdm),indx_w3(jdm)) + vel_g(:,idm);         
        A(:,idm,indx_l_mom(jdm),indx_w4(jdm))  =  A(:,idm,indx_l_mom(jdm),indx_w4(jdm)) + vel_l(:,idm);                 
        
        A(:,idm,indx_g_mom(jdm),indx_w3(idm))  =  A(:,idm,indx_g_mom(jdm),indx_w3(idm)) + vel_g(:,jdm);         
        A(:,idm,indx_l_mom(jdm),indx_w4(idm))  =  A(:,idm,indx_l_mom(jdm),indx_w4(idm)) + vel_l(:,jdm);                 
        
    end
    
end

Ax = reshape(A(:,1,:,:),N,ndf,ndf);
Ay = reshape(A(:,2,:,:),N,ndf,ndf);      
if job>0
    Ax = rowprod(Ax,Cp,ndf,ndf,ndf);
    Ay = rowprod(Ay,Cp,ndf,ndf,ndf);
end

if 0
    Ax = 0.0001*Ax;
    Ay = 0.0001*Ay;
    Fa = 0.0001*Fa;
end

%disp(' Flux Function ');keyboard;pause
