function [Mele,Rele] = bc_conv_bubbly_2d(xnod,icone,U,bou_data,Rele,Mele,prop)
%
%  [Mele,Rele] = bc_conv_bubbly_2d(xnod,icone,U,bou_data,Rele,Mele,ga,axisim)
%                                     

ijob = 'get';
handle_prop_elem;

reverse_normal = 1;
%reverse_normal = -1;

ga = prop(1);
axisim = prop(8);

[numnp,ndm] = size(xnod);  
[numel,nen] = size(icone);
[nbou,bas]  = size(bou_data);
[bas,ndf]   = size(U);

ndf= ndf/nen;

[bas,ncol]  = size(Mele);

%disp(' bcconv ') ; keyboard,pause

if nbou>0,

    if npg==2 | npg==4
        xpg    = sqrt(3)/3;
        psipg  = [ -xpg xpg ];
        wpg    = [   1   1  ];
    elseif npg==3
        xpg    = sqrt(0.6);
        psipg  = [ -xpg  0 xpg ];
        wpg    = [  5 8 5  ]/9;        
    end
    
    eles_bou = bou_data(:,1);
    face_bou = bou_data(:,2);
    
    nodo_1 = face_bou;
    nodo_2 = (nodo_1+1).*(nodo_1<nen)+(nodo_1==nen);
    nodos  = [nodo_1,nodo_2];
    nodog1 = getcol(icone(eles_bou,:),nodo_1);
    nodog2 = getcol(icone(eles_bou,:),nodo_2);
    nodog  = [nodog1 , nodog2];
    dxbc   = xnod(nodog2,1) - xnod(nodog1,1);
    dybc   = xnod(nodog2,2) - xnod(nodog1,2);
    lbou   = sqrt(dxbc.^2+dybc.^2);
    norbc  = reverse_normal*[dybc./lbou, -dxbc./lbou];
    
    re = v2m(xnod(icone(eles_bou,:)',1),nen);
    re = [getcol(re,nodo_1), getcol(re,nodo_2) ];
    
    Ue = zeros(nbou,ndf*2);
    
    %  disp(' BC_CONV_BUBBLY ');keyboard;pause
    
    for idf=1:ndf
        Ue(:,idf)     = getcol(U(eles_bou,:),(nodo_1-1)*ndf+idf);
        Ue(:,ndf+idf) = getcol(U(eles_bou,:),(nodo_2-1)*ndf+idf);
    end
    
    
    for ipg=1:npg,
        
        N = ones(nbou,1)*[(1-psipg(ipg))/2 , (1+psipg(ipg))/2 ];
        
        Upg      = zeros(nbou,ndf);
        radpg    = zeros(nbou,1);
        
        for inod=1:2,    
            radpg = radpg + N(:,inod).*re(:,inod);
            Upg  = Upg + (N(:,inod)*ones(1,ndf)).*Ue(:,(inod-1)*ndf+(1:ndf));
        end 
        
        [rho_g,rho_l,drho_g_dp,drho_l_dp]  = get_density(Upg,prop,2);
        [H,Cp,Cpi]    = enthalpy_function(Upg,prop,rho_g,rho_l,drho_g_dp,drho_l_dp);
        [Fa,Ax,Ay]    = Flux_function(Upg,prop,rho_g,rho_l,Cpi,Cp); 
        
        Fan      =  (Fa(:,1:ndf,1).*(norbc(:,1)*ones(1,ndf)) + ...
            Fa(:,1:ndf,2).*(norbc(:,2)*ones(1,ndf)));   
        
        for idf=1:ndf,
            for jdf=1:ndf,      
                An(:,idf,jdf) =  Ax(:,idf,jdf).*norbc(:,1)+ Ay(:,idf,jdf).*norbc(:,2);
            end
        end
        
        xsj = wpg(ipg)*lbou/2;
        if axisim,
            xsj = xsj.*radpg;
        end
        
        for iface=1:nen,
            for inod=1:2,
                eles = find(face_bou==iface);
                jnod = iface-1+inod;
                if(jnod>nen),jnod=1; end 
                vaux  =  (N(eles,inod).*xsj(eles)*ones(1,ndf)).*Fan(eles,1:ndf);
                Rele(eles_bou(eles),jnod,1:ndf) = Rele(eles_bou(eles),jnod,1:ndf) - ...
                    reshape(vaux,length(eles),1,ndf);
                
                for iinod=1:2, 
                    jjnod = iface-1+iinod;
                    if(jjnod>nen),jjnod=1; end           
                    ip=((jnod-1)*nen+(jjnod-1))*ndf^2;         
                    for idf=1:ndf
                        for jdf=1:ndf,
                            vaux  =  (N(eles,inod).*xsj(eles).*N(eles,iinod)).*An(eles,idf,jdf);                  
                            Mele(eles_bou(eles),jnod,idf,jjnod,jdf) = ...
                                Mele(eles_bou(eles),jnod,idf,jjnod,jdf) + vaux;          
                        end
                    end
                end % for iinod
            end  % for inod
        end % for iface
        
    end % puntos de Gauss del contorno
    
end % if bou

