function [Kg,Rg] = bubbly_2D(xnod,icone,fixa,forc,teco,lin_con,extra_nodal_fields,...
   extra_nodal_fields_old,prop,ifaceb,Up,Upold,rowe,cole,performance_measure,inicia) 
%------------------------------------------------------------------
%
%  TWO PHASE FLOW APPLICATIONS
%
%------------------------------------------------------------------

%global row col 

if nargin< 16, inicia=1; end
if nargin< 15, performance_measure=0; end

t00=cputime;

ijob = 'get';
handle_prop_elem;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

U    = Up;
Uold = Upold;

[numel,nen]   = size(icone);
[numnp,ndf]   = size(U);
[numno,ndm]   = size(xnod);

if ndf~=(2*ndm+2), error(' NDF debe ser 2*NDM+2 ( Bubbly  ) ');end

if ndm==1,
   pgauss1d;
elseif ndm==2, 
   pgauss2d; 
elseif ndm==3,
   pgauss3d; 
end

Rele = zeros(numel,nen,ndf);
Mele = zeros(numel,nen,ndf,nen,ndf);

Rg    = 0*forc;
eles  = (1:numel)';
ceros = zeros(length(eles),nen);

t01=cputime;
if(performance_measure) 
    disp([' dt element-computation-header = ' num2str(t01-t00)])       
end

t0=cputime;
if length(eles)>0,        
    bubbly_2d_ele;
end
t1=cputime;
if(performance_measure) 
    disp([' dt element-computation = ' num2str(t1-t0)])       
end

% Gather contributions from eles to nodes
%------------------------------------------------------------------
[Rg,Kg] = gather_2(Rele,Mele,icone,nen,ndf,rowe,cole);

t2=cputime;
if(performance_measure) 
    disp([' gathering = ' num2str(t2-t1)])       
end

% Linear restrictions
%------------------------------------------------------------------
if inicia | 1 , 
    iflag = -1; 
else 
    iflag = 1;
end

if isempty(lin_con)==0,
    [Rg,Kg] = linear_constraint(Rg,Kg,lin_con,ndf,iflag);
end
t3=cputime;

if(performance_measure) 
    disp([' linear constraint = ' num2str(t3-t2)])       
end

tff=cputime;
if(performance_measure) 
    disp([' bubbly_2d time elapse = ' num2str(tff-t00)])       
end