%
% Garcia Cascales - Corberan version
%

lump_time_term = 0;
lump_reac_term = 0;

stabi_scheme = 'eig_numer';
stabi_scheme = 'tau_scalar';
stabi_scheme = 'eig_symbo';

inviscid = 1;

t110 = 0;
t0=cputime;

weak_form = 1;

get_index;

Uold(:,indx_g_vf) = ctff_fun(Uold(:,indx_g_vf));
U(:,indx_g_vf)    = ctff_fun(U(:,indx_g_vf));

% UPWIND EN EL CENTROIDE 
%------------------------------------------------------------------
type_upwind         = 0;      
tau_centroide       = 1;
debug               = 0;
%------------------------------------------------------------------

ne  = numel;
[bas,ndf_fields] = size(extra_nodal_fields);

% Localizacion de las variables
%------------------------------------------------------------------
ceros = zeros(ne,nen*ndf);
Ue = ceros;
U0e = ceros;
re = zeros(ne,nen);
for inod=1:nen,
    nodes  = icone(eles,inod);
    jnod  = (inod-1)*ndf+(1:ndf);
    knod  = (inod-1)*ndf_fields+(1:ndf_fields);            
    Ue(:,jnod)  = U(nodes,1:ndf);		 
    U0e(:,jnod) = Uold(nodes,1:ndf);   
end

if tau_centroide==1,
    
    if nen==4,
        [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),0,0);
        [dshapex0,N0]   = shape2d(X2S,0,0,nen); 
    elseif nen==3,
        [X2S,S2X,Jaco0] = xy2st(xnod,icone(eles,:),1/3,1/3);
        [dshapex0,N0]   = shape2d(X2S,1/3,1/3,nen); 
    else
        error(' Bad type of element , nen ~=3, nen ~=4 ')
    end
    
    Upg           = zeros(ne,ndf);
    U0pg          = zeros(ne,ndf);
    dUpg          = zeros(ne,ndf,ndm);
    dU0pg         = zeros(ne,ndf,ndm);
    
    for inod=1:nen,
        jnod = (inod-1)*ndf+(1:ndf);
        Upg(:,(1:ndf))    =  Upg(:,(1:ndf)) + N0(inod).*  Ue(:,jnod);
        U0pg(:,(1:ndf))   =  U0pg(:,(1:ndf)) + N0(inod).*  U0e(:,jnod);   
        for idm=1:ndm,
            dU0pg(:,(1:ndf),idm) = dU0pg(:,(1:ndf),idm) + ...
                (dshapex0(:,inod,idm)*ones(1,ndf)).* U0e(:,jnod);          
            dUpg(:,(1:ndf),idm) = dUpg(:,(1:ndf),idm) + ...
                (dshapex0(:,inod,idm)*ones(1,ndf)).* Ue(:,jnod);          
        end
    end    
    
    [rho_g,rho_l,drho_g_dp,drho_l_dp] = get_density(Upg,prop);
        
    velpg_l       = Upg(:,indx_l_vel);
    velpg_g       = Upg(:,indx_g_vel);
    
    hele_l        = comp_hele(velpg_l,dshapex0,Jaco0,nen);
    hele_g        = comp_hele(velpg_g,dshapex0,Jaco0,nen);          

    alpha_g = Upg(:,indx_g_vf);
    alpha_l = 1-alpha_g;

    if 0
        [tau_l,tau_g,delta_l,delta_g,bas] = supg_bubbly(Upg,velpg_l,velpg_g,hele_l,hele_g,prop,rho_g,rho_l); 
    elseif strcmp(stabi_scheme,'eig_symbo')
        tau_M = compute_tau_eig(Upg,velpg_g,velpg_l,hele_g,hele_l,prop);
        tau_M = tau_M*tau_factor;        
    elseif strcmp(stabi_scheme,'tau_scalar')
        rho_m = alpha_l.*rho_l+alpha_g.*rho_g;
        for idm=1:ndm
            velpg_M(:,idm) = (rho_l.*alpha_l.*velpg_l(:,idm)+rho_g.*alpha_g.*velpg_g(:,idm))./rho_m;
        end
        hele_M        = comp_hele(velpg_M,dshapex0,Jaco0,nen);
        
        tau_mixture = compute_tau_scalar_mixture(Upg,velpg_M,hele_M,prop,rho_g,rho_l);
        tau_mixture = tau_mixture*tau_factor;        
    elseif strcmp(stabi_scheme,'eig_numer')

        [bas,Cp,Cpi]    = enthalpy_function(Upg,prop,rho_g,rho_l,drho_g_dp,drho_l_dp);
        [bas,Axc,Ayc]    = Flux_function(Upg,prop,rho_g,rho_l,Cpi);        

        rho_m = alpha_l.*rho_l+alpha_g.*rho_g;
        for idm=1:ndm
            velpg_M(:,idm) = (rho_l.*alpha_l.*velpg_l(:,idm)+rho_g.*alpha_g.*velpg_g(:,idm))./rho_m;
        end

        hele_M        = comp_hele(velpg_M,dshapex0,Jaco0,nen);
        
        for idm=1:ndm
            nor(:,idm) = velpg_M(:,idm) ./ sqrt(sum(velpg_M'.^2))';
        end    

        for idf=1:ndf
            for jdf=1:ndf
                An(:,idf,jdf) = nor(:,1).*Axc(:,idf,jdf) + nor(:,2).*Ayc(:,idf,jdf) ;
            end
        end
       
        tau_M = compute_tau_eig_numer(An,hele_M,prop);
        tau_M = tau_M*tau_factor;                
        delta_g = sqrt(sum(velpg_g'.^2))'.*hele_g/2;

    else
        error(' **** Bad stabilization scheme **** ')
    end
end

t1=cputime;    
%disp([' dt element-computation - Part I = ' num2str(t1-t0)])       

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------
for ipg=1:npg
    
    if ndm==2
        [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
        [dshapex,N] = shape2d(X2S,psipg(ipg),etapg(ipg),nen); 
    else
        [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg));
        [dshapex,N] = shape1d(X2S,psipg(ipg),nen);    
    end
    
    % Interpolacion en punto de Gauss
    %------------------------------------------------------------------
    
    Upg    = zeros(ne,ndf);
    U0pg    = zeros(ne,ndf);
    dUpg    = zeros(ne,ndf,ndm);
    dU0pg    = zeros(ne,ndf,ndm);   
    radpg    = zeros(ne,1);
    
    for inod=1:nen,
        jnod = (inod-1)*ndf+(1:ndf);
        Upg(:,(1:ndf))  =  Upg(:,(1:ndf)) + N(inod).*  Ue(:,jnod);
        U0pg(:,(1:ndf)) = U0pg(:,(1:ndf)) + N(inod).* U0e(:,jnod);
        radpg(:,1)      =      radpg(:,1) + N(inod).* re(:,inod);      
        for idm=1:ndm,
            dUpg(:,(1:ndf),idm)   = dUpg(:,(1:ndf),idm) + ...
                (dshapex(:,inod,idm)*ones(1,ndf)).* Ue(:,jnod);      
            dU0pg(:,(1:ndf),idm)   = dU0pg(:,(1:ndf),idm) + ...
                (dshapex(:,inod,idm)*ones(1,ndf)).* U0e(:,jnod);            
        end
    end
    
    [rho_g_old,rho_l_old,drho_g_dp_old,drho_l_dp_old] = get_density(U0pg,prop);    
    [rho_g,rho_l,drho_g_dp,drho_l_dp]                 = get_density(Upg,prop);

    rho_g_half     = 0.5*(rho_g+rho_g_old);
    rho_l_half     = 0.5*(rho_l+rho_l_old);
    drho_g_dp_half = 0.5*(drho_g_dp+drho_g_dp_old);
    drho_l_dp_half = 0.5*(drho_l_dp+drho_l_dp_old);
    
    [H,Cp,Cpi]    = enthalpy_function(Upg,prop,rho_g,rho_l,drho_g_dp,drho_l_dp);
    [H0,bas,bas]  = enthalpy_function(U0pg,prop,rho_g_old,rho_l_old,drho_g_dp_old,drho_l_dp_old);   
    
    %[bas,Cp,Cpi]    = enthalpy_function(0.5*(Upg+U0pg),prop,rho_g_half,rho_l_half,drho_g_dp_half,drho_l_dp_half);
    
    %dH = rowprod(Cp,Upg-U0pg,ndf,ndf,1);
    dH = H-H0;
    %keyboard;pause
    
    %    [H0,bas,bas]  = enthalpy_function(U0pg,prop,rho_g,rho_l,drho_g_dp,drho_l_dp);   
    
    if 0
        [Fa,Ax,Ay]    = Flux_function(Upg,prop,rho_g,rho_l,Cpi,Cp); 
    else
        [Fa,Axc,Ayc]    = Flux_function(Upg,prop,rho_g,rho_l,Cpi);         
        Ax = rowprod(Axc,Cp,ndf,ndf,ndf);
        Ay = rowprod(Ayc,Cp,ndf,ndf,ndf);
    end

    [Dmat_vg,Dmat_vl] = virtual_mass(Upg,U0pg,dUpg,dt,prop);
    
    [Fc,Cjac] = Cflux(Upg,dUpg,Dmat_vg,Dmat_vl,prop,rho_g,rho_l);
    
    if inviscid==0
        [Fd,Kxx,Kxy,Kyx,Kyy]  = Dflux(Upg,dUpg,prop);  
    end

    % Correccion axisimetrica del jacobiano de la transformacion al elemento master
    %------------------------------------------------------------------
    xsj =  wpg(ipg) .* Jaco;
    if axisim,
        xsj = xsj.*radpg;
    end
    
    AgU = rowprod(Ax,reshape(dUpg(:,1:ndf,1),ne,ndf),ndf,ndf,1);
    AgU = AgU + rowprod(Ay,reshape(dUpg(:,1:ndf,2),ne,ndf),ndf,ndf,1);
    
    if tau_centroide==0,
        
        velpg_l       = Upg(:,indx_l_vel);
        velpg_g       = Upg(:,indx_g_vel);
        
        hele_l        = comp_hele(velpg_l,dshapex0,Jaco0,nen);
        hele_g        = comp_hele(velpg_g,dshapex0,Jaco0,nen);      
        
        [tau_l,tau_g,delta_l,delta_g,bas] = supg_bubbly(Upg,velpg_l,velpg_g,hele_l,hele_g,prop,rho_g,rho_l); 
        
    end
    
    for jnod=1:nen,        
        % A_gN     
        tmpx = dshapex(:,jnod,1);
        tmpy = dshapex(:,jnod,2);
        for idf=1:ndf,
            for jdf=1:ndf,
                A_gN(:,idf,jdf,jnod) = tmpx.*Ax(:,idf,jdf) + tmpy.*Ay(:,idf,jdf) ;
            end 
        end            
    end
    
    % P_i Petrov-Galerkin perturbation weight function
    for inod=1:nen,           

        if 0
            compute_P_supg;         
        elseif strcmp(stabi_scheme,'eig_symbo')
            compute_P_supg_eig;                     
        elseif strcmp(stabi_scheme,'tau_scalar')
            compute_P_supg_mixture;                     
        elseif strcmp(stabi_scheme,'eig_numer')
            compute_P_supg_eig_numer; 
        end
        %keyboard;pause
        
        W_supg = P_supg;      
        for idf=1:ndf,
            W_supg(:,idf,idf)=W_supg(:,idf,idf)+N(inod);
        end
        
        t10=cputime;
        for jnod=1:nen,
            
            % temporal terms
            if lump_time_term == 0,
                W_Cp_N = rowprod(W_supg,Cp,ndf,ndf,ndf)*N(jnod) ;        
            else
                % DEBUG
                W_Cp_N = N(inod)*Cp*N(jnod) ;         
            end
            
            % N_A_gN or gN_A_N according to weak form
            if weak_form,
                N_A_gN = -A_gN(:,:,:,inod)*N(jnod);                 
            else          
                N_A_gN =  A_gN(:,:,:,jnod)*N(inod);              
            end
            
            P_A_gN = rowprod(P_supg,A_gN(:,:,:,jnod),ndf,ndf,ndf);
            
            % shock capturing term
            if (abs(shocap)>0)
                gN_D_gN = zeros(numel,ndf,ndf);                        
                %for idf=1:ndm+1,
                for idm=1:ndm
                    gN_D_gN(:,indx_g_vf,indx_g_vf) = gN_D_gN(:,indx_g_vf,indx_g_vf) + ...
                        dshapex(:,inod,idm).*(shocap*rho_g.*delta_g).*dshapex(:,jnod,idm);
                end
                %end            
            end
            
            if inviscid==0            
                gN_K_gN = zeros(numel,ndf,ndf);                        
                for idf=1:ndf,
                    for jdf=1:ndf,
                        gN_K_gN(:,idf,jdf) = ...
                            ( (dshapex(:,inod,1).*Kxx(:,idf,jdf).*dshapex(:,jnod,1))+ ...
                            (dshapex(:,inod,1).*Kxy(:,idf,jdf).*dshapex(:,jnod,2))+ ...
                            (dshapex(:,inod,2).*Kyx(:,idf,jdf).*dshapex(:,jnod,1))+ ...
                            (dshapex(:,inod,2).*Kyy(:,idf,jdf).*dshapex(:,jnod,2)) );
                    end             
                end                
            end

            % reactive terms
            if lump_reac_term == 0;,
                W_C_N = rowprod(W_supg,Cjac,ndf,ndf,ndf)*N(jnod) ;        
            else
                % DEBUG
                W_C_N = Cjac*N(jnod)*N(inod) ;
            end    
            
            % assembling
            %            vaux =  N_A_gN + P_A_gN + gN_D_gN + gN_K_gN + W_C_N;
            vaux =  N_A_gN + P_A_gN - W_C_N;
            if abs(shocap), vaux = vaux + gN_D_gN; end
            if inviscid==0, vaux = vaux +  gN_K_gN; end
            
            
            for idf=1:ndf,
                for jdf=1:ndf,              
                    Mele(:,inod,idf,jnod,jdf) = Mele(:,inod,idf,jnod,jdf) + ... 
                        xsj.*( W_Cp_N(:,idf,jdf) ./ dt + vaux(:,idf,jdf) );                              
                end
            end
            
        end % jnod
        
        t11 = cputime;
        t110 = t110 + t11-t10;
        
        % temporal term
        if lump_time_term==0,
            W_dUdt   = rowprod(W_supg,dH,ndf,ndf,1);
        else
            W_dUdt   = N(inod)*dH;         
        end
        
        % advective fluxes
        if weak_form,    
            if ndm==2,
                gN_Fa = -(dshapex(:,inod,1)*ones(1,ndf)).*Fa(:,1:ndf,1) ... 
                    -(dshapex(:,inod,2)*ones(1,ndf)).*Fa(:,1:ndf,2);
            else
                gN_Fa = -(dshapex(:,inod,1)*ones(1,ndf)).*Fa(:,1:ndf,1) ;         
            end
            
        else
            gN_Fa = (N(inod)*ones(numel,ndf)).* AgU(:,1:ndf);
        end
        
        if inviscid==0
            % diffusive fluxes
            if ndm==2
                gN_Fd = (dshapex(:,inod,1)*ones(1,ndf)).*Fd(:,1:ndf,1) ... 
                    (dshapex(:,inod,2)*ones(1,ndf)).*Fd(:,1:ndf,2);
            else
                gN_Fd = -(dshapex(:,inod,1)*ones(1,ndf)).*Fd(:,1:ndf,1);      
            end
        end
        
        % stabilization SUPG terms        
        P_A_gU   = rowprod(P_supg,AgU,ndf,ndf,1);
        
        gN_D_gU = zeros(ne,ndf);
        
        if(abs(shocap)>0)                
            %for idf=1:ndm+1,            
            for idm=1:ndm              
                gN_D_gU(:,indx_g_vf) = gN_D_gU(:,indx_g_vf) + ...
                    dshapex(:,inod,idm).*(shocap*rho_g.*delta_g).*dUpg(:,indx_g_vf,idm);
            end
            %end         
        end        
        
        % reactive and source terms        
        if lump_reac_term==0,
            W_Fc  = rowprod(W_supg,Fc,ndf,ndf,1) ;
        else  % DEBUG
            W_Fc   = N(inod)*Fc; 
        end
        
        %        vaux =  gN_Fa + P_A_gU + gN_D_gU + gN_Fd + W_Fc  + W_dUdt/ dt;  
        vaux =  gN_Fa + P_A_gU - W_Fc  + W_dUdt/ dt;  
        if abs(shocap), vaux = vaux + gN_D_gU; end
        if inviscid==0, vaux= vaux +  gN_Fd; end
        
        %keyboard;pause        
        
        for idf=1:ndf,
            Rele(:,inod,idf) = Rele(:,inod,idf) - vaux(:,idf) .* xsj ;                   
        end
        
    end % inod
    
end % ipg


% ------ Terminos de contorno

t2=cputime;
%disp([' dt element-computation - Part II = ' num2str(t2-t1)])       

%disp([' dt element-computation - AgN = ' num2str(t110)])       

if weak_form,
    disp(' weak form ')
    [Mele,Rele] = bc_conv_bubbly_2d(xnod,icone,Ue,ifaceb,Rele,Mele,prop);      
end
