function p_int = compute_interface_pressure(x,alpha_g,p,vel_l,dalpha_g_dx,dpdx,dvel_l_dx,prop)
%
%   p_int = compute_interface_pressure(alpha_g,p,vel_l,dalpha_g_dx,dpdx,dvel_l_dx,prop)
%

global data

ijob = 'get';
handle_prop_elem;

u0 = data.u0;
g  = data.g;
x0 = data.x0;
L  = data.L;
alpha_g_0 = data.alpha_g_0;
gamma_g = data.gamma_g;
ag2 = data.ag2;
rho_l = data.rho_l;
sigma = data.sigma;

if 1
    alpha_g_th = 1 - (1-alpha_g_0)*u0 ./sqrt(u0^2+2*g*(x-x0));
    dalpha_g_dx_th = (1-alpha_g_0)*u0 ./(u0^2+2*g*x-2*g*x0).^(3/2)*g;
    alpha_l_th = 1 - alpha_g_th;
    
    vel_l_th   = (u0^2+2*g*x-2*g*x0).^(1/2);
    dvel_l_dx_th = 1 ./ (u0^2+2*g*x-2*g*x0).^(1/2)*g;
    
    rho_g_th = gamma_g/ag2*p;
    
    rho_m = alpha_g_th.*rho_g_th + alpha_l_th.*rho_l;
    
    dpdx_th = rho_m*g-rho_l*alpha_l_th.*vel_l_th.*dvel_l_dx_th;
    
    p_int_th = (rho_l*(1-alpha_g_th).*vel_l_th.*dvel_l_dx_th - p.*dalpha_g_dx_th + alpha_l_th.*dpdx_th - ...
        rho_l*alpha_l_th*g )./(-dalpha_g_dx_th);
end

if 1
    p_int = p_int_th;
else
    alpha_l = 1 - alpha_g;    
    p_int = (rho_l.*alpha_l.*vel_l.*dvel_l_dx - p.*dalpha_g_dx + alpha_l.*dpdx - rho_l*alpha_l*g )./(-dalpha_g_dx);
end

%disp(' Compute interface pressure ');keyboard;pause