function tau_M = compute_tau_eig(Upg,velpg_g,velpg_l,hele_g,hele_l,prop)
%
%  tau_M = compute_tau_eig(Upg,velpg_g,velpg_l,hele_g,hele_l,prop)
%
%   compute tau matrix from a phase decomposition using eigenvalues for
%   each phase
%

check = 0;

ijob = 'get';
handle_prop_elem;
ndm = 2;
get_index;

nor_G = velpg_g ./ (sqrt(sum(velpg_g'.^2))'*ones(1,ndm));
nor_L = velpg_l ./ (sqrt(sum(velpg_l'.^2))'*ones(1,ndm));

[Vg,Dg,Vgi,Vl,Dl,Vli,Bn_g,Bn_l] = compute_eig(Upg,nor_G,nor_L,prop,check);
nele = size(Dg,1);
if check, check_eig ; end
%disp('compute_tau_eig ');keyboard;pause   

% GAS PART
vaux = zeros(nele,3,3);
for k=1:3
    for j=1:3
        for i=1:3
            vaux(:,k,j) = vaux(:,k,j) + hele_g/2.*(Vg(:,k,i).*Vgi(:,i,j).* (1 ./ abs(Dg(:,i))));
        end
    end
end

tau_G = vaux;

% LIQUID PART
vaux = zeros(nele,3,3);
for k=1:3
    for j=1:3
        for i=1:3
            vaux(:,k,j) = vaux(:,k,j) + hele_l/2.*(Vl(:,k,i).*Vli(:,i,j).* (1 ./ abs(Dl(:,i))));
        end
    end
end
tau_L = vaux;

tau_M(:,[indx_g_vf,indx_g_vel],[indx_g_vf,indx_g_vel]) = tau_G;
tau_M(:,[indx_l_p,indx_l_vel],[indx_l_p,indx_l_vel]) = tau_L;
