function [tau_M,delta_g,delta_l] = compute_tau_eig_numer(An,hele,prop)
%
%   [tau_M,delta_g,delta_l] = compute_tau_eig_numer(An,hele,prop)
%
%   compute tau matrix from the whole advective jacobian
%   in a numerical fashion
%

coupled = 1; % coupled = 0 desacoplado por fase ; = 1 acoplado todo

ijob = 'get';
handle_prop_elem;
ndm = 2;
ndf = 6;
get_index;

NN = size(An,1);

eigmax = -1e20;
eigmin =  1e20;
eigratmin = eigmin;
bfh = []; bfh2=[];

if coupled
    for k=1:NN    
        [VV,DD] = eig(reshape(An(k,:,:),ndf,ndf));
        eigmin = min([eigmin,min(abs(diag(DD)))] );
        eigmax = max([eigmax,max(abs(diag(DD)))] );    
        eigratmin = min([eigratmin,min(abs(diag(DD)))./max(abs(diag(DD)))]);
        tau_M(k,:,:) = hele(k)/2*(VV*inv(abs(DD))*inv(VV));
        %tau_M(k,:,:) = hele(k)/2 /max(abs(diag(DD)))*eye(ndf,ndf);
        if isreal(diag(DD))==0, 
            disp(' *** ERROR **** >>> Complex eigenvalues '); 
            keyboard;pause
            error(' Complex eigenvalues ');         
        end
        bfh=[bfh;diag(DD)'];
        bfh2=[bfh2;det(reshape(An(k,:,:),ndf,ndf))];
        delta_g(k,1) = hele(k)/2*max(abs(diag(DD)));        
        delta_l(k,1) = delta_g(k,1);
    end
   
else
    
    for k=1:NN    
        indx = [indx_l_p,indx_l_vel];
        An_liq = An(k,indx,indx);
        [VV,DD] = eig(reshape(An_liq,ndf/2,ndf/2));        
        tau_M(k,indx,indx) = hele(k)/2*(VV*inv(abs(DD))*inv(VV));        
        eigmin = min([eigmin,min(abs(diag(DD)))] );
        eigmax = max([eigmax,max(abs(diag(DD)))] );    
        eigratmin = min([eigratmin,min(abs(diag(DD)))./max(abs(diag(DD)))]);
        
        if isreal(diag(DD))==0, 
            disp(' *** ERROR **** >>> Complex eigenvalues in liquid phase '); 
            keyboard;pause
            error(' Complex eigenvalues ');         
        end
        delta_l(k,1) = hele(k)/2*max(abs(diag(DD)));        
        
        indx = [indx_g_vf,indx_g_vel];
        An_gas = An(k,indx,indx);
        [VV,DD] = eig(reshape(An_gas,ndf/2,ndf/2));
        tau_M(k,indx,indx) = hele(k)/2*(VV*inv(abs(DD))*inv(VV));                
        eigmin = min([eigmin,min(abs(diag(DD)))] );
        eigmax = max([eigmax,max(abs(diag(DD)))] );    
        eigratmin = min([eigratmin,min(abs(diag(DD)))./max(abs(diag(DD)))]);
        
        if isreal(diag(DD))==0, 
            disp(' *** ERROR **** >>> Complex eigenvalues in gas phase '); 
            keyboard;pause
            error(' Complex eigenvalues ');         
        end
        delta_g(k,1) = hele(k)/2*max(abs(diag(DD)));        
        
        bfh=[bfh;diag(DD)'];
        bfh2=[bfh2;det(reshape(An(k,:,:),ndf,ndf))];
        
        %keyboard;pause
        
    end
    
end

if 0
    disp([' Min eigenvalue = ' num2str(eigmin)])
    disp([' Max eigenvalue = ' num2str(eigmax)])
    disp([' Max eigenvalue ratio = ' num2str(1 ./ eigratmin)])
    %keyboard,pause
end

