function [tau] = compute_tau_scalar_mixture(Upg,vel_M,hele_M,prop,rho_g,rho_l)
%
%    [tau] = compute_tau_scalar_mixture(Upg,vel_M,hele_M,prop,rho_g,rho_l)
%
%   get the scalar intrinsic time scale from mixture velocity and sonic
%   mixture velocity
%

ijob = 'get';
handle_prop_elem;

[N,ndf]     = size(Upg);
ndm = (ndf-2)/2;

get_index;
tol = 1e-10;

cg = sqrt((gamma_g-1)*Cp_g*Temp);
cl = sqrt((gamma_l-1)*Cp_l*Temp);

kappa_g = cg^2;
kappa_l = cl^2;
alpha_g = Upg(:,indx_g_vf);
vel_g = Upg(:,indx_g_vel);
vel_l = Upg(:,indx_l_vel);

alpha_l = 1-alpha_g;

rho_m = alpha_l.*rho_l+alpha_g.*rho_g;

kappa_M = (alpha_g./(rho_g*kappa_g) + alpha_l./(rho_l*kappa_l)).^(-1).*rho_m.^(-1);   

sonic_speed =  sqrt(kappa_M);

velmod = sqrt(sum(vel_M'.^2))';
velmod = velmod+sonic_speed;
if velmod>tol
    tau = hele_M/2 ./velmod;
else
    tau = 0*hele;
end
