%------------------------------------------------------------------
%     APLICATION  :  TWO PHASE FLOW
%------------------------------------------------------------------

global row col P_supg_full delta_g

if(exist('inicia')==0),
    disp('Ingrese la variable inicia ')
    disp(' inicia == 0 ---> si continua una corrida previa ')
    disp(' inicia ~= 0 ---> si comienza una corrida nueva ')
    inicia = input(' Inicia = ')
end

%------ Ingreso de datos -------------------------------------------

if inicia,
    read_data;
    bfh=[];          % Guarda la solucion
    hc_res=[];       % Guarda la historia de la convergencia en residuo
    hc_du=[];        % Guarda la historia de la convergencia en dphi
    bfh_nc = [];     % Guarda los pasos de tiempo en que no hubo convergencia
    bfh_u=[];        % Guarda la solucion cada nstep pasos de tiempo
    posdat;
    ttime = 0;
    restart_time = 0;
    if exist('nplot')==0; nplot=1;end
    if exist('nsave')==0; nsave=ntime;end    
    if exist('filesave')==0; filesave='tempo'; end    
    if exist('filestate')==0; filestate='last_state'; end    
end

%------ fin ingreso de datos --------------------------------------

limit = prop(12);
[numnp,ndf] = size(phi);

external_fields = [];
external_fields_old = [];

% Loop temporal o pseudotemporal
%------------------------------------------------------------------
restart_time = 0;

for itime = 1:ntime,
    
    ttime = ttime+dt;        
    phiold = phi;
    
    % Actualiza las condiciones de contorno si fueran funcion del tiempo
    % La funcionalidad se lee del archivo "bc_time"
    if exist('bc_time_flag')==1,
        if (bc_time_flag==1)&(exist('bc_time')~=2), 
            disp('Debe tener en el directorio de trabajo un archivo de nombre bc_time.m ');
            error(' bc_time_flag==1 y bc_time file no existe '); 
        end
        if bc_time_flag==1, bc_time; end
    end
    
    nu_outer     = 0;
    nu_outer_max = nnwt_outer;
    iterflag_outer = nu_outer < nu_outer_max;
    
    while iterflag_outer    
        nu_outer = nu_outer +1;
        Rg_outer = [];
        
        newton_loop;        
        
        iterflag_outer = (norm(Rg_outer)>limit) & (nu_outer < nu_outer_max);         
        disp(['time ' num2str(ttime) ' Iter ' num2str(nu)  ' || R || (outer) -----------------> ' num2str(norm(Rg_outer))   ])        
        
    end
    
    % Salida grafica de resultados (provista por cada aplicacion)
    %------------------------------------------------------------------
            
    if rem(itime,nplot)==0 
        plot_fem; 
    end
    
    if norm(Rg)>limit ,
        %  error(' NO CONVERGENCE ');
        bfh_nc = [bfh_nc ; itime];
    end
    
    if rem(itime,nsave)==0, 
        eval(['save ' filesave ';']);
        eval(['save ' filestate 'phi ' ';']);
    end
    
    if rem(itime,nstep)==0,
        bfh_u = [bfh_u , phi];
    end
    
end % itime loop

