function [VV,DD,BB,VVi] = eig_symb(U,nor,bloque);
%
%  [VV,DD,BB,VVi] = eig_symb(U,nor,bloque);
%

global data

gamma_l = data.gamma_l;
gamma_g = data.gamma_g;
cg = data.cg;
cl = data.cl;
p_infty = data.p_infty;

indx_g_vf = data.indx_g_vf;
indx_l_p  = data.indx_l_p;
indx_g_vel = data.indx_g_vel;
indx_l_vel = data.indx_l_vel;

vel_l   = U(indx_l_vel);
vel_g   = U(indx_g_vel);
p       = U(indx_l_p);
alpha_g = U(indx_g_vf);

if bloque=='G'
    %if nor(1)==0, error( ' nor(1) debe ser distinto de cero por el momento ' ); end
    
    vgn = sum(vel_g.*nor);
    cgn = sqrt(cg^2/gamma_g);
    L3 = vgn;
    L1 = vgn+cgn;
    L2 = vgn-cgn;
    Dg = diag([L1,L2,L3]);
    
    Bg = [0,nor(1),nor(2); 
        -(gamma_g*vel_g(1)*vgn-nor(1)*cg^2)/gamma_g, nor(1)*vel_g(1)+vgn , nor(2)*vel_g(1);
        -(gamma_g*vel_g(2)*vgn-nor(2)*cg^2)/gamma_g, nor(1)*vel_g(2) , nor(2)*vel_g(2)+vgn ;
    ];
    
    if nor(1)~=0 ,          
        Vg(:,1) = [ ...
                -(vel_g(1)*gamma_g-nor(1)*sqrt(gamma_g*cg^2))/(cg^2*nor(1)^2-vel_g(1)^2*gamma_g);
            1;
            -( (vel_g(1)*vel_g(2)*gamma_g-nor(1)*nor(2)*cg^2+sqrt(gamma_g*cg^2)*(vel_g(1)*nor(2)-vel_g(2)*nor(1)) ) / (cg^2*nor(1)^2-vel_g(1)^2*gamma_g))        
        ];
        Vg(:,2) = [ ...
                -(vel_g(1)*gamma_g+nor(1)*sqrt(gamma_g*cg^2))/(cg^2*nor(1)^2-vel_g(1)^2*gamma_g);
            1;
            -( (vel_g(1)*vel_g(2)*gamma_g-nor(1)*nor(2)*cg^2-sqrt(gamma_g*cg^2)*(vel_g(1)*nor(2)-vel_g(2)*nor(1)) ) / (cg^2*nor(1)^2-vel_g(1)^2*gamma_g))        
        ];
        Vg(:,3) = [ ...
                0;
            -nor(2)/nor(1);
            1
        ];    
        
        raiz = gamma_g*cg^2;
        
        Vgi(3,1) =  (-nor(1)*vel_g(2)+nor(2)*vel_g(1))*nor(1);
        Vgi(3,3) =  nor(1)^2;
        Vgi(3,2) = -nor(1)*nor(2);
        
        Vgi(1,1) = 1/2*(-gamma_g*vel_g(1)^2*nor(1)+nor(1)*cg^2-gamma_g*vel_g(1)*vel_g(2)*nor(2)+nor(2)*(-nor(1)*vel_g(2)+nor(2)*vel_g(1))*sqrt(raiz))/sqrt(raiz);
        Vgi(2,1) = 1/2*( gamma_g*vel_g(1)^2*nor(1)-nor(1)*cg^2+gamma_g*vel_g(1)*vel_g(2)*nor(2)+nor(2)*(-nor(1)*vel_g(2)+nor(2)*vel_g(1))*sqrt(raiz))/sqrt(raiz);
        
        Vgi(1,2) = 1/2*gamma_g*nor(1)*vel_g(1)/sqrt(raiz)+1/2*nor(1)^2;
        Vgi(2,2) =-1/2*gamma_g*nor(1)*vel_g(1)/sqrt(raiz)+1/2*nor(1)^2 
        
        Vgi(1,3) = 1/2*gamma_g*nor(2)*vel_g(1)/sqrt(raiz)+1/2*nor(2)*nor(1);
        Vgi(2,3) =-1/2*gamma_g*nor(2)*vel_g(1)/sqrt(raiz)+1/2*nor(2)*nor(1);
        
    else
        
        if 0
            
            Vg  = [1,1,0; 
                vel_g(1),vel_g(1),1; 
                vel_g(2)+cgn,vel_g(2)-cgn,0];
            
            Vgi = [1/2*(1-vel_g(2)/cgn) , 0,  1/2/cgn; 
                1/2*(1+vel_g(2)/cgn) , 0, -1/2/cgn; 
                -vel_g(1) , 1, 0   ];
            
        elseif 0
            
            Vg = [ 1,1,0;
                0,0,-nor(2);
                vel_g(2)+cgn, vel_g(2)-cgn , 0
            ];
            
            Vgi = [-1/2*(vel_g(2)-cgn)/cgn , 0,  1/2/cgn; 
                1/2*(vel_g(2)+cgn)/cgn , 0, -1/2/cgn; 
                0 , -1/nor(2), 0   ];
            
        else
            
            deno = vel_g(2)^2*gamma_g-cg^2;
            Vg = [ (gamma_g*vel_g(2)-sqrt(gamma_g*cg^2))/deno, (gamma_g*vel_g(2)+sqrt(gamma_g*cg^2))/deno, 0 ;
                0 , 0, 1 ;
                1,1, 0  ];
            
            Vgi = [ -1/2*(vel_g(2)^2*gamma_g-cg^2)/sqrt(gamma_g*cg^2) , 0 , 1/2*(vel_g(2)*gamma_g+sqrt(gamma_g*cg^2))/sqrt(gamma_g*cg^2);
                1/2*(vel_g(2)^2*gamma_g-cg^2)/sqrt(gamma_g*cg^2) , 0 , -1/2*(vel_g(2)*gamma_g-sqrt(gamma_g*cg^2))/sqrt(gamma_g*cg^2); 
                0 , 1 , 0     ];
            
            L3 = vgn;
            L1 = vgn+nor(2)*cgn;
            L2 = vgn-nor(2)*cgn;
            Dg = diag([L1,L2,L3]);
            
        end
    end
    
    VV = Vg;
    DD = Dg;
    
    BB = Bg;
    
    VVi = Vgi;    
elseif bloque=='L'
    %if nor(1)==0, error( ' nor(1) debe ser distinto de cero por el momento ' ); end
    if (alpha_g*p_infty<p), error( ' alpha_g*p_infty debe ser mayor que p ' ); end
    vln = sum(vel_l.*nor);
    cln = sqrt(-gamma_l*cl^2*p*(p-alpha_g*p_infty));
    deno = gamma_l*(p-alpha_g*p_infty);
    L3 = vln;
    L1 = vln+cln/deno;
    L2 = vln-cln/deno;
    Dl = diag([L1,L2,L3]);
    
    Bl = [0,nor(1),nor(2); 
        -vel_l(1)*vln-nor(1)*p*cl^2/(gamma_l*(p-alpha_g*p_infty)), nor(1)*vel_l(1)+vln , nor(2)*vel_l(1);
        -vel_l(2)*vln-nor(2)*p*cl^2/(gamma_l*(p-alpha_g*p_infty)), nor(1)*vel_l(2) , nor(2)*vel_l(2)+vln ;
    ];
    
    if 0
        Vl(:,1) = [ ...
                (vel_l(1)*gamma_l*(p-alpha_g*p_infty)-nor(1)*sqrt(-gamma_l*cl^2*p*(p-alpha_g*p_infty)))/(vel_l(1)^2*gamma_l*(p-alpha_g*p_infty)+nor(1)^2*p*cl^2);
            1;
            (vel_l(1)*vel_l(2)*gamma_l*(p-alpha_g*p_infty)+nor(1)*nor(2)*p*cl^2+ (vel_l(1)*nor(2)-vel_l(2)*nor(1))*sqrt(-gamma_l*cl^2*p*(p-alpha_g*p_infty)))/ ...
                (vel_l(1)^2*gamma_l*(p-alpha_g*p_infty)+nor(1)^2*p*cl^2);     
        ];
        
        Vl(:,2) = [ ...
                (vel_l(1)*gamma_l*(p-alpha_g*p_infty)+nor(1)*sqrt(-gamma_l*cl^2*p*(p-alpha_g*p_infty)))/(vel_l(1)^2*gamma_l*(p-alpha_g*p_infty)+nor(1)^2*p*cl^2);
            1;
            (vel_l(1)*vel_l(2)*gamma_l*(p-alpha_g*p_infty)+nor(1)*nor(2)*p*cl^2- (vel_l(1)*nor(2)-vel_l(2)*nor(1))*sqrt(-gamma_l*cl^2*p*(p-alpha_g*p_infty)))/ ...
                (vel_l(1)^2*gamma_l*(p-alpha_g*p_infty)+nor(1)^2*p*cl^2);     
        ];
        
        Vl(:,3) = [ ...    
                0;
            -nor(2)/nor(1);
            1
        ];
        
    else
        
        peff = (p-alpha_g*p_infty);        
        deno = (vel_l(2)^2*gamma_l*peff+nor(2)^2*p*cl^2);
        raiz = -p*gamma_l*cl^2*peff;
        vln  = sum(vel_l.*nor);
        %keyboard;pause
        
        if nor(1)~=0,      
            
            Vl(:,1) = [ ...
                    (gamma_l*vel_l(2)*peff-nor(2)*sqrt(raiz))/deno;
                (gamma_l*vel_l(1)*vel_l(2)*peff+nor(1)*nor(2)*p*cl^2+(vel_l(2)*nor(1)-vel_l(1)*nor(2))*sqrt(raiz))/deno;            
                1;
            ];
            
            Vl(:,2) = [ ...
                    (gamma_l*vel_l(2)*peff+nor(2)*sqrt(raiz))/deno;
                (gamma_l*vel_l(1)*vel_l(2)*peff+nor(1)*nor(2)*p*cl^2-(vel_l(2)*nor(1)-vel_l(1)*nor(2))*sqrt(raiz))/deno;            
                1;
            ];
            
            Vl(:,3) = [ ...    
                    0;
                -nor(2)/nor(1);
                1
            ];
            
            Vli(1,1) = -1/2*(peff*gamma_l*vel_l(2)*vln + p*nor(2)*cl^2 + nor(1)*(nor(2)*vel_l(1)-nor(1)*vel_l(2))*sqrt(raiz))/sqrt(raiz);
            Vli(2,1) =  1/2*(peff*gamma_l*vel_l(2)*vln + p*nor(2)*cl^2 - nor(1)*(nor(2)*vel_l(1)-nor(1)*vel_l(2))*sqrt(raiz))/sqrt(raiz);        
            Vli(3,1) = -nor(1)*(nor(1)*vel_l(2)-nor(2)*vel_l(1));
            Vli(1,2) =  1/2*(gamma_l*vel_l(2)*nor(1)*peff+nor(1)*nor(2)*sqrt(raiz))/sqrt(raiz);        
            Vli(2,2) = -1/2*(gamma_l*vel_l(2)*nor(1)*peff-nor(1)*nor(2)*sqrt(raiz))/sqrt(raiz);        
            Vli(3,2) = -nor(1)*nor(2);
            Vli(1,3) =  1/2*nor(2)*(gamma_l*vel_l(2)*peff+nor(2)*sqrt(raiz))/sqrt(raiz);
            Vli(2,3) = -1/2*nor(2)*(gamma_l*vel_l(2)*peff-nor(2)*sqrt(raiz))/sqrt(raiz);
            Vli(3,3) =  nor(1)^2;
        else
            
            deno2 = -gamma_l*vel_l(2)^2*peff-p*cl^2;
            
            Vl(1,1) = (-gamma_l*vel_l(2)*peff-sqrt(raiz))/deno2;
            Vl(1,2) = (-gamma_l*vel_l(2)*peff+sqrt(raiz))/deno2;            
            Vl(1,3) = 0;
            
            Vl(2,1) = vel_l(1)*(-gamma_l*vel_l(2)*peff-sqrt(raiz))/deno2;
            Vl(2,2) = vel_l(1)*(-gamma_l*vel_l(2)*peff+sqrt(raiz))/deno2;            
            Vl(2,3) = 1;
            
            Vl(3,1) = 1;
            Vl(3,2) = 1;   
            Vl(3,3) = 0;
            
            Vli(1,1) = -1/2*(-gamma_l*vel_l(2)^2*peff-p*cl^2)/sqrt(raiz);
            Vli(1,2) = 0;
            Vli(1,3) =  1/2*(-gamma_l*vel_l(2)*peff+sqrt(raiz))/sqrt(raiz);
            
            Vli(2,1) =  1/2*(-gamma_l*vel_l(2)^2*peff-p*cl^2)/sqrt(raiz);
            Vli(2,2) = 0;
            Vli(2,3) = -1/2*(-gamma_l*vel_l(2)*peff-sqrt(raiz))/sqrt(raiz);
            
            Vli(3,1) =  -vel_l(1);
            Vli(3,2) =   1;
            Vli(3,3) =  0;
            
        end
        
    end
    
    VV = Vl;
    DD = Dl;
    
    BB = Bl;    
    VVi = Vli;
    
    
else
    error(' bloque debe ser o (G) o (L) ')
end

