function [VV,DD,BB,VVi] = eig_symb_array(U,nor,bloque);
%
%  [VV,DD,BB,VVi] = eig_symb_array(U,nor,bloque);
%

global data

gamma_l = data.gamma_l;
gamma_g = data.gamma_g;
cg = data.cg;
cl = data.cl;
p_infty = data.p_infty;

indx_g_vf = data.indx_g_vf;
indx_l_p  = data.indx_l_p;
indx_g_vel = data.indx_g_vel;
indx_l_vel = data.indx_l_vel;

vel_l   = U(:,indx_l_vel);
vel_g   = U(:,indx_g_vel);
p       = U(:,indx_l_p);
alpha_g = U(:,indx_g_vf);

N = size(U,1);

if bloque=='G'
    %if nor(1)==0, error( ' nor(1) debe ser distinto de cero por el momento ' ); end
    
    vgn = sum((vel_g.*nor)')';
    cgn = sqrt(cg^2/gamma_g);
    L3  = vgn;
    L1  = vgn+cgn;
    L2  = vgn-cgn;
    Dg  = [L1,L2,L3];
    
    %    Bg = [0,nor(1),nor(2); 
    %        -(gamma_g*vel_g(1)*vgn-nor(1)*cg^2)/gamma_g, nor(1)*vel_g(1)+vgn , nor(2)*vel_g(1);
    %        -(gamma_g*vel_g(2)*vgn-nor(2)*cg^2)/gamma_g, nor(1)*vel_g(2) , nor(2)*vel_g(2)+vgn ;
    %    ];
    
    Bg  = zeros(N,3,3);
    Bg(:,1,2) = nor(:,1);
    Bg(:,1,3) = nor(:,2);
    Bg(:,2,1) = -(gamma_g*vel_g(:,1).*vgn-nor(:,1)*cg^2)/gamma_g;
    Bg(:,2,2) = nor(:,1).*vel_g(:,1)+vgn;
    Bg(:,2,3) = nor(:,2).*vel_g(:,1);
    Bg(:,3,1) = -(gamma_g*vel_g(:,2).*vgn-nor(:,2)*cg^2)/gamma_g;
    Bg(:,3,2) = nor(:,1).*vel_g(:,2);
    Bg(:,3,3) = nor(:,2).*vel_g(:,2)+vgn ;
    
    Vg_A = zeros(N,3,3); % nor(:,1) .ne. 0
    
    %        Vg(:,1) = [ ...
    %                -(vel_g(1)*gamma_g-nor(1)*sqrt(gamma_g*cg^2))/(cg^2*nor(1)^2-vel_g(1)^2*gamma_g);
    %            1;
    %            -( (vel_g(1)*vel_g(2)*gamma_g-nor(1)*nor(2)*cg^2+sqrt(gamma_g*cg^2)*(vel_g(1)*nor(2)-vel_g(2)*nor(1)) ) / (cg^2*nor(1)^2-vel_g(1)^2*gamma_g))        
    %        ];
    %        Vg(:,2) = [ ...
    %                -(vel_g(1)*gamma_g+nor(1)*sqrt(gamma_g*cg^2))/(cg^2*nor(1)^2-vel_g(1)^2*gamma_g);
    %            1;
    %            -( (vel_g(1)*vel_g(2)*gamma_g-nor(1)*nor(2)*cg^2-sqrt(gamma_g*cg^2)*(vel_g(1)*nor(2)-vel_g(2)*nor(1)) ) / (cg^2*nor(1)^2-vel_g(1)^2*gamma_g))        
    %        ];
    %        Vg(:,3) = [ ...
    %                0;
    %            -nor(2)/nor(1);
    %            1
    %        ];    
    
    deno = (cg^2*nor(:,1).^2-vel_g(:,1).^2*gamma_g);
    
    Vg_A(:,1,1) = -(vel_g(:,1)*gamma_g-nor(:,1)*sqrt(gamma_g*cg^2))./deno;
    Vg_A(:,2,1) = 1;
    Vg_A(:,3,1) = -( (vel_g(:,1).*vel_g(:,2)*gamma_g-nor(:,1).*nor(:,2)*cg^2+sqrt(gamma_g*cg^2).*(vel_g(:,1).*nor(:,2)-vel_g(:,2).*nor(:,1)))./ deno);
    
    Vg_A(:,1,2) = -(vel_g(:,1)*gamma_g+nor(:,1)*sqrt(gamma_g*cg^2))./deno;
    Vg_A(:,2,2) = 1;
    Vg_A(:,3,2) = -( (vel_g(:,1).*vel_g(:,2)*gamma_g-nor(:,1).*nor(:,2)*cg^2-sqrt(gamma_g*cg^2).*(vel_g(:,1).*nor(:,2)-vel_g(:,2).*nor(:,1)))./ deno);
    
    Vg_A(:,2,3) =  -nor(:,2)./nor(:,1);
    Vg_A(:,3,3) =  1;
    
    Vg_B = zeros(N,3,3);  % nor(:,1) .eq. 0
    
    %        Vg  = [1,1,0; 
    %            vel_g(1),vel_g(1),1; 
    %            vel_g(2)+cgn,vel_g(2)-cgn,0];
    
    if 0
        Vg_B(:,1,1) = 1;
        Vg_B(:,1,2) = 1;
        Vg_B(:,2,1) = vel_g(:,1);
        Vg_B(:,2,2) = vel_g(:,1);    
        Vg_B(:,2,3) = 1;
        Vg_B(:,3,1) = vel_g(:,2)+cgn;
        Vg_B(:,3,2) = vel_g(:,2)-cgn;    
        
    else
        
        %Vg = [ (gamma_g*vel_g(2)-sqrt(gamma_g*cg^2))/deno, (gamma_g*vel_g(2)+sqrt(gamma_g*cg^2))/deno, 0 ;
        %    0 , 0, 1 ;
        %    1,1, 0  ];
        
        deno = vel_g(:,2).^2*gamma_g-cg^2;
        
        Vg_B(:,1,1) = (gamma_g*vel_g(:,2)-sqrt(gamma_g*cg^2))./deno;
        Vg_B(:,1,2) = (gamma_g*vel_g(:,2)+sqrt(gamma_g*cg^2))./deno;
        Vg_B(:,2,3) = 1;
        Vg_B(:,3,1) = 1;
        Vg_B(:,3,2) = 1;
        
    end
    
    nn = find(nor(:,1)==0); if isempty(nn)==0, disp(' encontrado nor(:,1)==0 '); end
    Vg = Vg_A;
    Vg(nn,:,:) = Vg_B(nn,:,:);
    
    %Vg = Vg_A.*(nor(:,1)~=0)+Vg_B.*(nor(:,1)==0);
    
    Vgi_A = zeros(N,3,3); % nor(:,1) .ne. 0
    
    raiz = gamma_g*cg^2;
    
    %        Vgi(3,1) =  (-nor(1)*vel_g(2)+nor(2)*vel_g(1))*nor(1);
    %        Vgi(3,3) =  nor(1)^2;
    %        Vgi(3,2) = -nor(1)*nor(2);
    
    %        Vgi(1,1) = 1/2*(-gamma_g*vel_g(1)^2*nor(1)+nor(1)*cg^2-gamma_g*vel_g(1)*vel_g(2)*nor(2)+nor(2)*(-nor(1)*vel_g(2)+nor(2)*vel_g(1))*sqrt(raiz))/sqrt(raiz);
    %        Vgi(2,1) = 1/2*( gamma_g*vel_g(1)^2*nor(1)-nor(1)*cg^2+gamma_g*vel_g(1)*vel_g(2)*nor(2)+nor(2)*(-nor(1)*vel_g(2)+nor(2)*vel_g(1))*sqrt(raiz))/sqrt(raiz);
    
    %        Vgi(1,2) = 1/2*gamma_g*nor(1)*vel_g(1)/sqrt(raiz)+1/2*nor(1)^2;
    %        Vgi(2,2) =-1/2*gamma_g*nor(1)*vel_g(1)/sqrt(raiz)+1/2*nor(1)^2 
    
    %        Vgi(1,3) = 1/2*gamma_g*nor(2)*vel_g(1)/sqrt(raiz)+1/2*nor(2)*nor(1);
    %        Vgi(2,3) =-1/2*gamma_g*nor(2)*vel_g(1)/sqrt(raiz)+1/2*nor(2)*nor(1);
    
    Vgi_A(:,1,1) = 1/2*(-gamma_g*vel_g(:,1).^2.*nor(:,1)+nor(:,1)*cg^2-gamma_g*vel_g(:,1).*vel_g(:,2).*nor(:,2)+nor(:,2).*(-nor(:,1).*vel_g(:,2) + ... 
        nor(:,2).*vel_g(:,1)).*sqrt(raiz))./sqrt(raiz);
    Vgi_A(:,2,1) = 1/2*( gamma_g*vel_g(:,1).^2.*nor(:,1)-nor(:,1)*cg^2+gamma_g*vel_g(:,1).*vel_g(:,2).*nor(:,2)+nor(:,2).*(-nor(:,1).*vel_g(:,2) + ... 
        nor(:,2).*vel_g(:,1)).*sqrt(raiz))./sqrt(raiz);        
    
    Vgi_A(:,1,2) = 1/2*gamma_g*nor(:,1).*vel_g(:,1)./sqrt(raiz)+1/2*nor(:,1).^2;
    Vgi_A(:,2,2) =-1/2*gamma_g*nor(:,1).*vel_g(:,1)./sqrt(raiz)+1/2*nor(:,1).^2;
    
    Vgi_A(:,1,3) = 1/2*gamma_g*nor(:,2).*vel_g(:,1)./sqrt(raiz)+1/2*nor(:,2).*nor(:,1);
    Vgi_A(:,2,3) =-1/2*gamma_g*nor(:,2).*vel_g(:,1)./sqrt(raiz)+1/2*nor(:,2).*nor(:,1);
    
    Vgi_A(:,3,1) =  (-nor(:,1).*vel_g(:,2)+nor(:,2).*vel_g(:,1)).*nor(:,1);
    Vgi_A(:,3,3) =  nor(:,1).^2;
    Vgi_A(:,3,2) = -nor(:,1).*nor(:,2);
    
    %        Vgi = [1/2*(1-vel_g(2)/cgn) , 0,  1/2/cgn; 
    %               1/2*(1+vel_g(2)/cgn) , 0, -1/2/cgn; 
    %                -vel_g(1) , 1, 0   ];
    
    Vgi_B = zeros(N,3,3); % nor(:,1) .ne. 0
    
    if 0
        Vgi_B(:,1,1) =  1/2*(1-vel_g(:,2)/cgn);
        Vgi_B(:,2,1) =  1/2*(1+vel_g(:,2)/cgn);    
        Vgi_B(:,1,3) =  1 ./ (2*cgn);
        Vgi_B(:,2,3) = -1 ./ (2*cgn);    
        Vgi_B(:,3,1) = -vel_g(:,1);
        Vgi_B(:,3,2) = 1;
    else
        %Vgi = [ -1/2*(vel_g(2)^2*gamma_g-cg^2)/sqrt(gamma_g*cg^2) , 0 , 1/2*(vel_g(2)*gamma_g+sqrt(gamma_g*cg^2))/sqrt(gamma_g*cg^2);
        %    1/2*(vel_g(2)^2*gamma_g-cg^2)/sqrt(gamma_g*cg^2) , 0 , -1/2*(vel_g(2)*gamma_g-sqrt(gamma_g*cg^2))/sqrt(gamma_g*cg^2); 
        %    0 , 1 , 0     ];
        
        Vgi_B(:,1,1) =  -1/2*(vel_g(:,2).^2*gamma_g-cg^2)./sqrt(gamma_g*cg^2);
        Vgi_B(:,2,1) =   1/2*(vel_g(:,2).^2*gamma_g-cg^2)./sqrt(gamma_g*cg^2);
        Vgi_B(:,1,3) =   1/2*(vel_g(:,2).*gamma_g+sqrt(gamma_g*cg^2))./sqrt(gamma_g*cg^2);
        Vgi_B(:,2,3) =  -1/2*(vel_g(:,2).*gamma_g-sqrt(gamma_g*cg^2))./sqrt(gamma_g*cg^2);
        Vgi_B(:,3,2) =   1;
        
        L3 = vgn;
        L1 = vgn+nor(:,2)*cgn;
        L2 = vgn-nor(:,2)*cgn;
        Dg_B = [L1,L2,L3];
        
        
    end
    %Vgi = Vgi_A.*(nor(:,1)~=0)+Vgi_B.*(nor(:,1)==0);        
    
    Vgi = Vgi_A;
    Vgi(nn,:,:) = Vgi_B(nn,:,:);
    
    Dg(nn,:) = Dg_B(nn,:);
    
    VV = Vg;
    DD = Dg;
    
    BB = Bg;
    
    VVi = Vgi;    
        
elseif bloque=='L'
    
    
    if (alpha_g*p_infty<p), error( ' alpha_g*p_infty debe ser mayor que p ' ); end
    
    vln = sum((vel_l.*nor)')';
    cln = sqrt(-gamma_l*cl^2*p.*(p-alpha_g*p_infty));    
    deno = gamma_l*(p-alpha_g*p_infty);
    L3 = vln;
    L1 = vln+cln./deno;
    L2 = vln-cln./deno;
    Dl = [L1,L2,L3];
    
    %    Bl = [0,nor(1),nor(2); 
    %        -vel_l(1)*vln-nor(1)*p*cl^2/(gamma_l*(p-alpha_g*p_infty)), nor(1)*vel_l(1)+vln , nor(2)*vel_l(1);
    %        -vel_l(2)*vln-nor(2)*p*cl^2/(gamma_l*(p-alpha_g*p_infty)), nor(1)*vel_l(2) , nor(2)*vel_l(2)+vln ;
    %    ];
    
    Bl  = zeros(N,3,3);
    Bl(:,1,2) = nor(:,1);
    Bl(:,1,3) = nor(:,2);
    Bl(:,2,1) = -vel_l(:,1).*vln-nor(:,1).*p.*cl^2 ./ (gamma_l*(p-alpha_g*p_infty));
    Bl(:,2,2) = nor(:,1).*vel_l(:,1)+vln;
    Bl(:,2,3) = nor(:,2).*vel_l(:,1);
    Bl(:,3,1) = -vel_l(:,2).*vln-nor(:,2).*p.*cl^2 ./ (gamma_l*(p-alpha_g*p_infty));
    Bl(:,3,2) = nor(:,1).*vel_l(:,2);
    Bl(:,3,3) = nor(:,2).*vel_l(:,2)+vln;
    
    peff = (p-alpha_g*p_infty);        
    deno = (vel_l(:,2).^2*gamma_l.*peff+nor(:,2).^2.*p*cl^2);
    raiz = -p*gamma_l*cl^2.*peff;
    
    Vl_A = zeros(N,3,3); % nor(:,1) .ne. 0    
    
    %            Vl(:,1) = [ ...
    %                    (gamma_l*vel_l(2)*peff-nor(2)*sqrt(raiz))/deno;
    %                (gamma_l*vel_l(1)*vel_l(2)*peff+nor(1)*nor(2)*p*cl^2+(vel_l(2)*nor(1)-vel_l(1)*nor(2))*sqrt(raiz))/deno;            
    %                1;
    %            ];
    %            
    %            Vl(:,2) = [ ...
    %                    (gamma_l*vel_l(2)*peff+nor(2)*sqrt(raiz))/deno;
    %                (gamma_l*vel_l(1)*vel_l(2)*peff+nor(1)*nor(2)*p*cl^2-(vel_l(2)*nor(1)-vel_l(1)*nor(2))*sqrt(raiz))/deno;            
    %                1;
    %            ];
    %            
    %            Vl(:,3) = [ ...    
    %                    0;
    %                -nor(2)/nor(1);
    %                1
    %            ];
    
    Vl_A(:,1,1) = (gamma_l*vel_l(:,2).*peff-nor(:,2).*sqrt(raiz))./deno;
    Vl_A(:,2,1) = (gamma_l*vel_l(:,1).*vel_l(:,2).*peff+nor(:,1).*nor(:,2).*p*cl^2+(vel_l(:,2).*nor(:,1)-vel_l(:,1).*nor(:,2)).*sqrt(raiz))./deno;   
    Vl_A(:,3,1) = 1;
    
    Vl_A(:,1,2) = (gamma_l*vel_l(:,2).*peff+nor(:,2).*sqrt(raiz))./deno;
    Vl_A(:,2,2) = (gamma_l*vel_l(:,1).*vel_l(:,2).*peff+nor(:,1).*nor(:,2).*p*cl^2-(vel_l(:,2).*nor(:,1)-vel_l(:,1).*nor(:,2)).*sqrt(raiz))./deno;   
    Vl_A(:,3,2) = 1;
    
    Vl_A(:,2,3) = -nor(:,2)./nor(:,1);
    Vl_A(:,3,3) = 1;
    
    %            Vl(1,1) = (-gamma_l*vel_l(2)*peff-sqrt(raiz))/deno2;
    %            Vl(1,2) = (-gamma_l*vel_l(2)*peff+sqrt(raiz))/deno2;            
    %            Vl(1,3) = 0;
    %            
    %            Vl(2,1) = vel_l(1)*(-gamma_l*vel_l(2)*peff-sqrt(raiz))/deno2;
    %            Vl(2,2) = vel_l(1)*(-gamma_l*vel_l(2)*peff+sqrt(raiz))/deno2;            
    %            Vl(2,3) = 1;
    %            
    %            Vl(3,1) = 1;
    %            Vl(3,2) = 1;   
    %            Vl(3,3) = 0;
    %
    
    deno2 = -gamma_l*vel_l(:,2).^2.*peff-p*cl^2;
    deno3 = gamma_l*peff;
    Vl_B = zeros(N,3,3); % nor(:,1) .eq. 0    
    
    if 0
        Vl_B(:,1,1) = (-gamma_l*vel_l(:,2).*peff-sqrt(raiz))./deno2;
        Vl_B(:,1,2) = (-gamma_l*vel_l(:,2).*peff+sqrt(raiz))./deno2;               
        Vl_B(:,2,1) = vel_l(:,1).*(-gamma_l*vel_l(:,2).*peff-sqrt(raiz))./deno2;
        Vl_B(:,2,2) = vel_l(:,1).*(-gamma_l*vel_l(:,2).*peff+sqrt(raiz))./deno2;            
        Vl_B(:,2,3) = 1;
        Vl_B(:,3,1) = 1;
        Vl_B(:,3,2) = 1;   
    else
        
        Vl_B(:,3,1) = (gamma_l*vel_l(:,2).*peff+sqrt(raiz))./deno3;
        Vl_B(:,3,2) = (gamma_l*vel_l(:,2).*peff-sqrt(raiz))./deno3;               
        Vl_B(:,2,1) = vel_l(:,1);
        Vl_B(:,2,2) = vel_l(:,1);            
        Vl_B(:,2,3) = -nor(:,2);
        Vl_B(:,1,1) = 1;
        Vl_B(:,1,2) = 1;   
        
        
        deno = gamma_l*(p-alpha_g*p_infty);
        L3 = vln;
        L1 = vln+nor(:,2).*cln./deno;
        L2 = vln-nor(:,2).*cln./deno;
        Dl_B = [L1,L2,L3];

        L1 = vln+nor(:,1).*cln./deno;
        L2 = vln-nor(:,1).*cln./deno;
        Dl_C = [L1,L2,L3];
        
    end

    Vl_C = zeros(N,3,3); % nor(:,2) .eq. 0   
    
    if 0
        C1 = p*cl^2+gamma_l*vel_l(:,1).^2.*peff;
        C2 = sqrt(raiz);
        C3 = p_infty*gamma_l*vel_l(:,1).*alpha_g;
        
        Vl_C(:,1,1) = ((gamma_l*vel_l(:,1).*p-C3)-C2)./C1;
        Vl_C(:,1,2) = ((gamma_l*vel_l(:,1).*p-C3)+C2)./C1;    
        Vl_C(:,2,1) = 1;
        Vl_C(:,2,2) = 1;
        Vl_C(:,3,1) = ((gamma_l*vel_l(:,1).*p-C3)-C2).*vel_l(:,2)./C1;
        Vl_C(:,3,2) = ((gamma_l*vel_l(:,1).*p-C3)+C2).*vel_l(:,2)./C1;
        Vl_C(:,3,3) = 1;
    else
        Vl_C(:,1,1) = 1;
        Vl_C(:,1,2) = 1;
        Vl_C(:,2,1) = (gamma_l*vel_l(:,1).*peff+sqrt(raiz))./(gamma_l*peff);
        Vl_C(:,2,2) = (gamma_l*vel_l(:,1).*peff-sqrt(raiz))./(gamma_l*peff);        
        Vl_C(:,3,1) = vel_l(:,2);
        Vl_C(:,3,2) = vel_l(:,2);        
        Vl_C(:,3,3) = 1;
        
    end
    
    %    Vl = Vl_A.*(nor(:,1)~=0)+Vl_B.*(nor(:,1)==0);        
    
    nnx = find(nor(:,1)==0); 
    nny = find(nor(:,2)==0);     
    
%    if isempty(nn)==0, disp(' encontrado nor(:,1)==0 '); end
    Vl = Vl_A;
    if isempty(nnx)==0, Vl(nnx,:,:) = Vl_B(nnx,:,:); end
    if isempty(nny)==0, Vl(nny,:,:) = Vl_C(nny,:,:); end
    
    Vli_A = zeros(N,3,3); % nor(:,1) .ne. 0    
    
    %            Vli(1,1) = -1/2*(peff*gamma_l*vel_l(2)*vln + p*nor(2)*cl^2 + nor(1)*(nor(2)*vel_l(1)-nor(1)*vel_l(2))*sqrt(raiz))/sqrt(raiz);
    %            Vli(2,1) =  1/2*(peff*gamma_l*vel_l(2)*vln + p*nor(2)*cl^2 - nor(1)*(nor(2)*vel_l(1)-nor(1)*vel_l(2))*sqrt(raiz))/sqrt(raiz);        
    %            Vli(3,1) = -nor(1)*(nor(1)*vel_l(2)-nor(2)*vel_l(1));
    %            Vli(1,2) =  1/2*(gamma_l*vel_l(2)*nor(1)*peff+nor(1)*nor(2)*sqrt(raiz))/sqrt(raiz);        
    %            Vli(2,2) = -1/2*(gamma_l*vel_l(2)*nor(1)*peff-nor(1)*nor(2)*sqrt(raiz))/sqrt(raiz);        
    %            Vli(3,2) = -nor(1)*nor(2);
    %            Vli(1,3) =  1/2*nor(2)*(gamma_l*vel_l(2)*peff+nor(2)*sqrt(raiz))/sqrt(raiz);
    %            Vli(2,3) = -1/2*nor(2)*(gamma_l*vel_l(2)*peff-nor(2)*sqrt(raiz))/sqrt(raiz);
    %            Vli(3,3) =  nor(1)^2;
    
    Vli_A(:,1,1) = -1/2*(peff*gamma_l.*vel_l(:,2).*vln + p.*nor(:,2)*cl^2 + nor(:,1).*(nor(:,2).*vel_l(:,1)-nor(:,1).*vel_l(:,2)).*sqrt(raiz))./sqrt(raiz);
    Vli_A(:,2,1) =  1/2*(peff*gamma_l.*vel_l(:,2).*vln + p.*nor(:,2)*cl^2 - nor(:,1).*(nor(:,2).*vel_l(:,1)-nor(:,1).*vel_l(:,2)).*sqrt(raiz))./sqrt(raiz);            
    Vli_A(:,3,1) =  -nor(:,1).*(nor(:,1).*vel_l(:,2)-nor(:,2).*vel_l(:,1));
    Vli_A(:,1,2) =  1/2*(gamma_l*vel_l(:,2).*nor(:,1).*peff+nor(:,1).*nor(:,2).*sqrt(raiz))./sqrt(raiz);            
    Vli_A(:,2,2) = -1/2*(gamma_l*vel_l(:,2).*nor(:,1).*peff-nor(:,1).*nor(:,2).*sqrt(raiz))./sqrt(raiz);           
    Vli_A(:,3,2) = -nor(:,1).*nor(:,2);    
    Vli_A(:,1,3) =  1/2*nor(:,2).*(gamma_l*vel_l(:,2).*peff+nor(:,2).*sqrt(raiz))./sqrt(raiz);    
    Vli_A(:,2,3) = -1/2*nor(:,2).*(gamma_l*vel_l(:,2).*peff-nor(:,2).*sqrt(raiz))./sqrt(raiz);
    Vli_A(:,3,3) =  nor(:,1).^2;
    
    Vli_B = zeros(N,3,3); % nor(:,1) .eq. 0    
    
    %            Vli(1,1) = -1/2*(-gamma_l*vel_l(2)^2*peff-p*cl^2)/sqrt(raiz);
    %            Vli(1,2) = 0;
    %            Vli(1,3) =  1/2*(-gamma_l*vel_l(2)*peff+sqrt(raiz))/sqrt(raiz);
    %            
    %            Vli(2,1) =  1/2*(-gamma_l*vel_l(2)^2*peff-p*cl^2)/sqrt(raiz);
    %            Vli(2,2) = 0;
    %            Vli(2,3) = -1/2*(-gamma_l*vel_l(2)*peff-sqrt(raiz))/sqrt(raiz);
    %            
    %            Vli(3,1) =  -vel_l(1);
    %            Vli(3,2) =   1;
    %            Vli(3,3) =  0;
    
    if 0
        Vli_B(:,1,1) = -1/2*(-gamma_l*vel_l(:,2).^2.*peff-p*cl^2)./sqrt(raiz);
        Vli_B(:,1,3) =  1/2*(-gamma_l*vel_l(:,2).*peff+sqrt(raiz))./sqrt(raiz);
        Vli_B(:,2,1) =  1/2*(-gamma_l*vel_l(:,2).^2.*peff-p*cl^2)./sqrt(raiz);
        Vli_B(:,2,3) = -1/2*(-gamma_l*vel_l(:,2).*peff-sqrt(raiz))./sqrt(raiz);    
        Vli_B(:,3,1) =  -vel_l(:,1);
        Vli_B(:,3,2) =   1;
    else
        deno4 = sqrt(-cl^2*gamma_l.*p.*peff);

        Vli_B(:,1,1) = 1/2*(1-(gamma_l*vel_l(:,2).*peff)./deno4);
        Vli_B(:,2,1) = 1/2*(1+(gamma_l*vel_l(:,2).*peff)./deno4);

        Vli_B(:,3,1) = vel_l(:,1)./nor(:,2);
        Vli_B(:,3,2) = -1 ./nor(:,2);
        Vli_B(:,1,3) =  1/2*gamma_l*peff ./ sqrt(raiz);
        Vli_B(:,2,3) = -1/2*gamma_l*peff ./ sqrt(raiz);        
    end
    
    Vli_C = zeros(N,3,3); % nor(:,2) .eq. 0    
    
    if 0
        Vli_C(:,1,1) = -1/2*(p*cl^2+gamma_l*vel_l(:,1).^2.*peff)./sqrt(raiz);
        Vli_C(:,2,1) =  1/2*(p*cl^2+gamma_l*vel_l(:,1).^2.*peff)./sqrt(raiz);    
        
        Vli_C(:,1,2) =  1/2*(gamma_l*vel_l(:,1).*peff+sqrt(raiz))./sqrt(raiz);    
        Vli_C(:,2,2) = -1/2*(gamma_l*vel_l(:,1).*peff-sqrt(raiz))./sqrt(raiz);        
        
        Vli_C(:,3,1) =  -vel_l(:,2)./nor(:,1);
        Vli_C(:,3,3) =  1 ./ nor(:,1);
    else
        
        Vli_C(:,1,1) = -1/2*(gamma_l*vel_l(:,1).*peff-sqrt(raiz))./sqrt(raiz);       
        Vli_C(:,2,1) =  1/2*(gamma_l*vel_l(:,1).*peff+sqrt(raiz))./sqrt(raiz);               
        
        Vli_C(:,1,2) =  1/2*gamma_l*peff./sqrt(raiz);
        Vli_C(:,2,2) = -1/2*gamma_l*peff./sqrt(raiz);
        
        Vli_C(:,3,1) = -vel_l(:,2);
        Vli_C(:,3,3) = 1;
        
    end
    
    Vli = Vli_A;
    if isempty(nnx)==0, Vli(nnx,:,:) = Vli_B(nnx,:,:); end
    if isempty(nny)==0, Vli(nny,:,:) = Vli_C(nny,:,:); end    
    
    VV = Vl;

    if isempty(nnx)==0, Dl(nnx,:) = Dl_B(nnx,:); end
    if isempty(nny)==0, Dl(nny,:) = Dl_C(nny,:); end
    
    DD = Dl;

    BB = Bl;    
    VVi = Vli;
    
    
else
    error(' bloque debe ser o (G) o (L) ')
end

