function up = fdriven(y,u)
%
%
%

global data

u0 = data.u0;
g  = data.g;
x0 = data.x0;
L  = data.L;
alpha_g_0 = data.alpha_g_0;
gamma_g = data.gamma_g;
ag2 = data.ag2;
rho_l = data.rho_l;
sigma = data.sigma;

p = u;
x = L-y;

alpha_g = 1 - (1-alpha_g_0)*u0 ./sqrt(u0^2+2*abs(g)*(x-x0));
cte     = u0*(1-alpha_g(1));
vel_l   = cte ./ (1-alpha_g);
dalpha_g_dx = (1-alpha_g_0)*u0 ./(u0^2+2*abs(g)*x-2*g*x0).^(3/2)*abs(g);

rho_g = gamma_g/ag2*p;

vrel_mod = vel_l;
pint = sigma*(alpha_g.*(1-alpha_g).*rho_g.*rho_l./(alpha_g.*rho_l+(1-alpha_g).*rho_g).*vrel_mod.^2);

rhs = rho_g.*alpha_g*g + pint*dalpha_g_dx;
rhs = rhs - p*dalpha_g_dx;
dpdx = rhs ./ alpha_g;

dpdy = -dpdx;
up = dpdy;
%keyboard;pause
