function up = fdriven2(y,u)
%
%
%

global data

u0 = data.u0;
g  = data.g;
x0 = data.x0;
L  = data.L;
alpha_g_0 = data.alpha_g_0;
gamma_g = data.gamma_g;
ag2 = data.ag2;
rho_l = data.rho_l;
sigma = data.sigma;

p = u;
x = L-y;

rho_g = gamma_g/ag2*p;

alpha_g = 1 - (1-alpha_g_0)*u0 ./sqrt(u0^2+2*g*(x-x0));
alpha_l = 1 - alpha_g;

rho_m = alpha_g*rho_g + alpha_l*rho_l;

dalpha_g_dx = (1-alpha_g_0)*u0 ./(u0^2+2*g*x-2*g*x0).^(3/2)*g;
vel_l   = (u0^2+2*g*x-2*g*x0).^(1/2);
dvel_l_dx = 1 ./ (u0^2+2*g*x-2*g*x0).^(1/2)*g;

dpdx = rho_m*g-rho_l*(1-alpha_g_0)*u0/(u0^2+2*g*x-2*g*x0)^(1/2)*g;

dpdy = -dpdx;
up = dpdy;
%keyboard;pause
