function up = fdriven3(y,u)
%
%
%

global data

u0 = data.u0;
g  = data.g;
x0 = data.x0;
L  = data.L;
alpha_g_0 = data.alpha_g_0;
gamma_g = data.gamma_g;
ag2 = data.ag2;
rho_l = data.rho_l;
sigma = data.sigma;

vg = u(1);
p  = u(2);

x = L-y;

rho_g = gamma_g/ag2*p;

alpha_g = 1 - (1-alpha_g_0)*u0 ./sqrt(u0^2+2*g*(x-x0));
alpha_l = 1 - alpha_g;

rho_m = alpha_g*rho_g + alpha_l*rho_l;

dalpha_g_dx = (1-alpha_g_0)*u0 ./(u0^2+2*g*x-2*g*x0).^(3/2)*g;
vel_l   = (u0^2+2*g*x-2*g*x0).^(1/2);
dvel_l_dx = 1 ./ (u0^2+2*g*x-2*g*x0).^(1/2)*g;

A = [rho_g.*alpha_g.*vg , 1 ; rho_g.*alpha_g , gamma_g/ag2*alpha_g.*vg];
B = [0 , 0 ; -rho_g.*dalpha_g_dx,0];
C = [rho_m*g-rho_l*alpha_l.*vel_l.*dvel_l_dx;0];

up = -inv(A)*(B*u+C);
return

dpdx = rho_m*g-rho_l*(1-alpha_g_0)*u0/(u0^2+2*g*x-2*g*x0)^(1/2)*g;

dpdy = -dpdx;
up = dpdy;
%keyboard;pause
