function up = fdriven4(y,u)
%
%
%

global data

u0 = data.u0;
g  = data.g;
x0 = data.x0;
L  = data.L;
alpha_g_0 = data.alpha_g_0;
alpha_g_f = data.alpha_g_f;
gamma_g = data.gamma_g;
ag2 = data.ag2;
rho_l = data.rho_l;
sigma = data.sigma;

vg = u(1);
p  = u(2);

x = L-y;

rho_g = gamma_g/ag2*p;

alpha_g = alpha_g_0+(alpha_g_f-alpha_g_0)*(x-x0)/L;
alpha_l = 1 - alpha_g;

rho_m = alpha_g*rho_g + alpha_l*rho_l;

dalpha_g_dx = (alpha_g_f-alpha_g_0)/L*ones(length(x),1);
vel_l   = (1-alpha_g_0)*u0 ./ (1-alpha_g);
dvel_l_dx = u0*(1-alpha_g_0) ./ (1-alpha_g).^2.* dalpha_g_dx;

A = [rho_g.*alpha_g.*vg , 1 ; rho_g.*alpha_g , gamma_g/ag2*alpha_g.*vg];
B = [0 , 0 ; -rho_g.*dalpha_g_dx,0];
C = [rho_m*g-rho_l*alpha_l.*vel_l.*dvel_l_dx;0];

up = -inv(A)*(B*u+C);

return
