function [rho_g,rho_l,drho_g_dp,drho_l_dp] = get_density(Up,prop,job);
%
%    [rho_g,rho_l,drho_g_dp,drho_l_dp] = get_density(Up,prop,job);
%

if nargin <3 job=0; end

ijob = 'get';
handle_prop_elem;

ndm = 2;
get_index; 

N = length(Up(:,1));

ag2 = (gamma_g-1)*Cp_g*Temp;
al2 = (gamma_l-1)*Cp_l*Temp;

if job==0
    rho_g = gamma_g*Up(:,indx_l_p)/ag2;
    rho_l = gamma_l*(p_infty-Up(:,indx_l_p))/al2;
    
    drho_g_dp = gamma_g/ag2*ones(N,1);
    drho_l_dp =-gamma_l/al2*ones(N,1);
elseif job==1
    
    rho_g = gamma_g*Up(:,indx_l_p)/ag2;
    rho_l = rho_l_user;
    
    drho_g_dp = gamma_g/ag2*ones(N,1);
    drho_l_dp = 1/al2;
elseif job==2,
    
    rho_g = gamma_g*Up(:,indx_l_p)/ag2;
    rho_l = rho_l_user;
    
    drho_g_dp = gamma_g/ag2*ones(N,1);
    drho_l_dp = 0;
%    drho_l_dp = 0.5*drho_g_dp;
        
else
    
    error(' *** get_density routine ERROR *** , bad job choice ')
end
