
velpg_l       = Upg(:,indx_l_vel);
velpg_g       = Upg(:,indx_g_vel);

hele_l        = comp_hele(velpg_l,dshapex,Jaco,nen);
hele_g        = comp_hele(velpg_g,dshapex,Jaco,nen);          

alpha_g = Upg(:,indx_g_vf);
alpha_l = 1-alpha_g;

if 0 & strcmp(stabi_scheme,'supg_pspg')
    %[tau_l,tau_g,delta_l,delta_g,bas] = supg_bubbly(Upg,velpg_l,velpg_g,hele_l,hele_g,prop,rho_g,rho_l); 
    tau_M = compute_tau_supg_pspg(Upg,velpg_g,velpg_l,hele_g,hele_l,prop,rho_g,rho_l);
    tau_M = tau_M*tau_factor;                
elseif strcmp(stabi_scheme,'eig_symbo') | strcmp(stabi_scheme,'supg_pspg')
    tau_M = compute_tau_eig(Upg,velpg_g,velpg_l,hele_g,hele_l,prop);
    tau_M = tau_M*tau_factor;        
elseif strcmp(stabi_scheme,'tau_scalar')
    rho_m = alpha_l.*rho_l+alpha_g.*rho_g;
    for idm=1:ndm
        velpg_M(:,idm) = (rho_l.*alpha_l.*velpg_l(:,idm)+rho_g.*alpha_g.*velpg_g(:,idm))./rho_m;
    end
    hele_M        = comp_hele(velpg_M,dshapex,Jaco,nen);
    
    tau_mixture = compute_tau_scalar_mixture(Upg,velpg_M,hele_M,prop,rho_g,rho_l);
    tau_mixture = tau_mixture*tau_factor;        
elseif strcmp(stabi_scheme,'eig_numer')
    
    [bas,Cp,Cpi]    = enthalpy_function(Upg,prop,rho_g,rho_l,drho_g_dp,drho_l_dp);
    [bas,Axc,Ayc]    = Flux_function(Upg,prop,rho_g,rho_l,Cpi);        
    
    rho_m = alpha_l.*rho_l+alpha_g.*rho_g;
    for idm=1:ndm
        velpg_M(:,idm) = (rho_l.*alpha_l.*velpg_l(:,idm)+rho_g.*alpha_g.*velpg_g(:,idm))./rho_m;
    end
    
    hele_M        = comp_hele(velpg_M,dshapex,Jaco,nen);
    
    for idm=1:ndm
        nor(:,idm) = velpg_M(:,idm) ./ sqrt(sum(velpg_M'.^2))';
    end    
    
    %    keyboard;pause
    
    if stabi_with_nonconservative_terms==1
        
        [Fc,Cjac,Hncx,Hncy] = Cflux(Upg,dUpg,0,0,prop,rho_g,rho_l,ypg);
        
        dAx  = rowprod(Hncx,Cpi,ndf,ndf,ndf);
        Axc = Axc-dAx;
        dAy  = rowprod(Hncy,Cpi,ndf,ndf,ndf);
        Ayc = Ayc-dAy;
        
    end
    
    for idf=1:ndf
        for jdf=1:ndf
            An(:,idf,jdf) = nor(:,1).*Axc(:,idf,jdf) + nor(:,2).*Ayc(:,idf,jdf) ;
        end
    end       

    if 0
        [tau_M] = compute_tau_eig_numer(An,hele_M,prop);                        
        delta_g = sqrt(sum(velpg_g'.^2))'.*hele_g/2;
        delta_l = sqrt(sum(velpg_l'.^2))'.*hele_l/2;            
    else        
        [tau_M,delta_g,delta_l] = compute_tau_eig_numer(An,hele_M,prop);                        
    end
    
    tau_M = tau_M*tau_factor;                
    
else
    error(' **** Bad stabilization scheme **** ')
end
