% 
%  handle_prop_elem
%

if strcmp(ijob,'get')
    
    % get_prop_elem
    
    %%%%%%%%%%%%%% PROPIEDADES DEL MATERIAL 
    
    Temp    = prop(1);
    gamma_g = prop(2);
    gamma_l = prop(3);   
    Cp_g    = prop(4);
    Cp_l    = prop(5);   
    npg     = prop(6);
    
    shocap  = prop(7);
    axisim  = prop(8);
    visco_g  = prop(9);   
    visco_l  = prop(10);
    
    gravity = prop(11);

    
    dt       = prop(13);   
    d_bubble = prop(16);
    coef_sigma = prop(17);
    p_infty = prop(18);
    coef_Cd    = prop(19);
    
    tau_factor          = prop(22);    

    rho_l_user = prop(23);
    rho_g_user = prop(24);
    stabi_with_nonconservative_terms = prop(25);

    interface_pressure_analytical = prop(26);
    model_get_density = prop(27);
    
    if 0
        virtual_mass        = prop(17);
        C_vm                = prop(18);
        model_visco_std     = prop(19);
        qpot_drag_model     = prop(20);
        fRe_drag_model      = prop(21);
        lumping_drag_forces = prop(23);
        lumping_time_terms  = prop(24);
        PMM_method          = prop(25);
        Advdif_scheme       = prop(26);    
        s_sound_g           = prop(27);
        
        if prop(28)==1
            supg_method='standard';
        elseif prop(28)==2;
            supg_method='finlandes';
        elseif prop(28)==3;
            supg_method='non_standard';
        end
        
        mask_matrix = prop(29);
        
        liq_mass_eq_mod = prop(30);
        
        smoothed_alpha_freq = prop(31);
        
        tol_adt_high = prop(32);
        tol_adt_low  = prop(33);
        tol_adt_min  = prop(34);
        
        automatic_time_control = prop(35);    
        
        Sato_model_coef = prop(36);  
        
        flag_interf_pressure = prop(37);
        
        stadtke_method = prop(38);
        
        s_sound_l = prop(39);
        
        artif_compres = prop(40);
        
        if length(prop)>40,        
            gp_reduced = prop(41);
        end
        
        coupled = prop(42);   
    end
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(ijob,'set'),
    
    %  set_prop_elem
    
    prop(1) = Temp  ;
    prop(2) = gamma_g;
    prop(3) = gamma_l;
    prop(4) = Cp_g;
    prop(5) = Cp_l;
    prop(6) =  npg;    
    
    prop(7)  = shocap ;
    prop(8)  = axisim ;
    
    prop(9)  = visco_g;
    prop(10) = visco_l;
    prop(11) =  gravity;
    
    if exist('dt','var')>0,
        prop(13) = dt;      
    end
    
    prop(16) = d_bubble;     
    prop(17) = coef_sigma;    
    prop(18) = p_infty;
    prop(19) = coef_Cd;    
    
    if exist('tau_factor','var')==0,
        tau_factor = 1;
    end
    prop(22) = tau_factor; 

    prop(23) = rho_l_user;
    prop(24) = rho_g_user;
    prop(25) = stabi_with_nonconservative_terms;    

    prop(26) = interface_pressure_analytical;    

    prop(27) = model_get_density;
    
    if 0
        prop(17) = virtual_mass;
        prop(18) = C_vm; 
        prop(19) = model_visco_std; 
        prop(20) = qpot_drag_model;
        prop(21) = fRe_drag_model; 
        prop(23) = lumping_drag_forces;
        prop(24) = lumping_time_terms;
        prop(25) = PMM_method;
        prop(26) = Advdif_scheme;
        
        if exist('s_sound_g','var')==0,        
            s_sound_g = 300;    
        end
        
        prop(27) = s_sound_g; 
        
        if strcmp(supg_method,'standard')==1,
            prop(28) = 1;
        elseif strcmp(supg_method,'finlandes')==1,
            prop(28) = 2;
        elseif strcmp(supg_method,'non_standard')==1,
            prop(28) = 3;            
        end
        
        if exist('mask_matrix','var')==0,
            mask_matrix = 1111;
        end
        prop(29) = mask_matrix;
        
        if exist('liq_mass_eq_mod','var')==0,
            liq_mass_eq_mod  =1;
        end
        prop(30) = liq_mass_eq_mod;
        
        if exist('smoothed_alpha_freq','var')==0,
            smoothed_alpha_freq=1e+15;
        end    
        prop(31) =   smoothed_alpha_freq;
        
        if exist('tol_adt_high','var')==0,    
            tol_adt_high = 1000;
        end
        
        if exist('tol_adt_low','var')==0,    
            tol_adt_low = -1000;
        end
        
        if exist('tol_adt_min','var')==0,        
            tol_adt_min=-2000;
        end
        
        prop(32) = tol_adt_high;
        prop(33) = tol_adt_low;
        prop(34) = tol_adt_min;    
        
        if exist('automatic_time_control','var')==0,        
            automatic_time_control = 0;    
        end
        
        prop(35) = automatic_time_control;
        
        if exist('Sato_model_coef','var')==0,        
            Sato_model_coef = 0;    
        end
        
        prop(36) = Sato_model_coef;
        
        if exist('flag_interf_pressure','var')==0,        
            flag_interf_pressure = 0;    
        end
        
        prop(37) = flag_interf_pressure;
        
        if exist('stadtke_method','var')==0,        
            stadtke_method = 0;    
        end
        
        prop(38) = stadtke_method;    
        
        if exist('s_sound_l','var')==0,        
            s_sound_l = s_sound_g/1000;    
        end
        
        prop(39) = s_sound_l;
        
        if exist('artif_compres','var')==0,        
            artif_compres = 0;    
        end
        
        prop(40) = artif_compres;
        
        if exist('gp_reduced','var')==1,        
            prop(41) = gp_reduced;
        end
        
        prop(42) = coupled;   
    end        
    
else
    error(' Bad ijob choice for HANDLE_PROP_ELEM')
end


