
coupled_solver = 1;

nu     = 0;
nu_max = nnwt;
iterflag = nu < nu_max;

while iterflag
    
    nu   = nu +1;
    Rg   = 0;               
    dphi = 0;
    
    phi_nu = phi;      
    ijob = 0;
    
    t0=cputime;
    [Kg,Rg] = bubbly_2D(xnod,icone,fixa,forc,teco,lin_con,external_fields,external_fields_old,prop,ifaceb,phi,phiold,rowe,cole,performance_measure,inicia);   
    t1=cputime;
    if(performance_measure) 
        disp([' dt assemble = ' num2str(t1-t0)])       
    end
    
    if coupled_solver
        indx=(1:ndf);
        ndf_tmp = ndf;
        fixa_p = fixa;        
        phi_p  = phi;
        
        Rgfull = full(Rg);
        Rgfull = reshape(Rgfull,ndf,numnp)';
        
%        disp(' newton loop');keyboard;pause
        
        [phi_p,Rg]=solver(phi_p,Rg,Kg,fixa_p,prop,prop_solver,ndf);   
        phi(:,indx) = phi_p;
    else

        phi_0 = phi;
        disp(' SOLVER LIQUID PHASE')
        indx_g=[indx_g_vf,indx_g_vel];
        fixa_p = v2m(fixa,ndf); fixa_p(:,indx_g)=1; fixa_p = m2v(fixa_p);
        [phi,Rg_liq]=solver(phi_0,Rg,Kg,fixa_p,prop,prop_solver,ndf);   
        dphi_liq = phi-phi_0;

%        keyboard;pause
        disp(' SOLVER GAS PHASE')        
        indx_l=[indx_l_p,indx_l_vel];
        fixa_p = v2m(fixa,ndf); fixa_p(:,indx_l)=1; fixa_p = m2v(fixa_p);
        [phi,Rg_gas]=solver(phi_0,Rg,Kg,fixa_p,prop,prop_solver,ndf); 
        dphi_gas = phi-phi_0;
        
        phi = phi_0 + dphi_liq + dphi_gas;
        
        Rg = [Rg_gas;Rg_liq];
        
    end
    t2=cputime;
    if(performance_measure) 
        disp([' dt solver = ' num2str(t2-t1)])       
    end
    
    % Analisis de la convergencia
    %------------------------------------------------------------------
    %    dphi = phi-phi_nu;
    
    iterflag = (norm(Rg)>limit) & (nu < nu_max); 
    
    %    disp(['time ' num2str(itime) ' Iter ' num2str(nu)  ' || R || -----> ' num2str(norm(Rg))   ])
    disp([' Iter ' num2str(nu)  ' || R || -----> ' num2str(norm(Rg))   ])
    
    if nu==1, res_outer = [res_outer;norm(Rg)]; end
    
    res_inner = [res_inner ; norm(Rg)];         
    
    ndf = ndf_tmp;
    
end % iterflag
