function [tau_l,tau_g,delta_l,delta_g,dt] = supg_bubbly(Upg,vel_l,vel_g,hele_l,hele_g,prop,rho_g,rho_l)
%
%    [tau_l,tau_g,delta_l,delta_g,dt] = supg_bubbly(Upg,vel_l,vel_g,hele_l,hele_g,prop,rho_g,rho_l)
%

ijob = 'get';
handle_prop_elem;

[N,ndf]     = size(Upg);
ndm = (ndf-2)/2;

get_index;

velmod_l = sqrt(sum(vel_l'.^2))';
velmod_g = sqrt(sum(vel_g'.^2))';

ag2 = (gamma_g-1)*Cp_g*Temp;
al2 = (gamma_l-1)*Cp_l*Temp;

v_l = velmod_l+sqrt(al2);
v_g = velmod_g+sqrt(ag2);

tau_l     = (2*v_l./hele_l).^2 + 9*(4*(visco_l./rho_l) ./(hele_l).^2).^2;
tau_g     = (2*v_g./hele_g).^2 + 9*(4*(visco_g./rho_g) ./(hele_g).^2).^2;
tau_l     = 1 ./ sqrt(tau_l);
tau_g     = 1 ./ sqrt(tau_g);
delta_l   = v_l.*hele_l/2;
delta_g   = v_g.*hele_g/2;

tau_l     = tau_factor*tau_l;
tau_g     = tau_factor*tau_g;
