
Temp    = 300;
gamma_g = 1.4;
gamma_l = 2.8;   
Cp_g    = 1000;
Cp_l    = 4000;       
p_infty = 8.5e8;

%read_data

Temp    = 300;
gamma_g = 1.4;
gamma_l = 2.8;   
Cp_g    = 1000;
Cp_l    = 4000;       
p_infty = 8.5e8;

ijob = 'set';
handle_prop_elem;

alpha_g = 0.8;
u_g = [2,1e-4];
u_l = [1,2e-4];
p   = 2e5;
alpha_l = 1-alpha_g;

tol = 1e-8;

Upg(indx_g_vf) = alpha_g;
Upg(indx_l_p) = p;
Upg(indx_g_vel) = u_g;
Upg(indx_l_vel) = u_l;

[rho_g,rho_l,drho_g_dp,drho_l_dp] = get_density(Upg,prop);
Wpg = [alpha_g*rho_g,alpha_l*rho_l,alpha_g*rho_g*u_g,alpha_l*rho_l*u_l];
Wpg_ref = Wpg;
rho_g_ref = rho_g;
rho_l_ref = rho_l;

Vpg_ref = Upg;

[rho_g,rho_l,drho_g_dp,drho_l_dp] = get_density(Upg,prop);

[H,Cp] = enthalpy_function(Upg,prop,rho_g,rho_l,drho_g_dp,drho_l_dp);
Cpi = inv(reshape(Cp,2*ndm+2,2*ndm+2));

Cpi_m = reshape(Cpi,1,2*ndm+2,2*ndm+2);

[Fa,Ax_ref,Ay_ref] = Flux_function(Upg,prop,rho_g,rho_l,Cpi_m);    

Fa_ref = Fa;

for k=1:2*ndm+2,

    delta_Wpg = zeros(1,2*ndm+2);
    delta_Wpg(:,k) = Wpg_ref(:,k)*tol;        
    delta_Vpg = (Cpi*delta_Wpg')';
        
%    disp(['k = ' num2str(k)])
%    keyboard ,pause

    if 1
        Vpg = Vpg_ref + delta_Vpg;
    else
        Vpg = Vpg_ref;
        Vpg(:,k) = Vpg(:,k)*(1+tol);        
    end
    
    [rho_g,rho_l,drho_g_dp,drho_l_dp] = get_density(Vpg,prop);
    [Fap,bas,bas] = Flux_function(Vpg,prop,rho_g,rho_l,Cpi_m);    
    
    if 1
        Vpg = Vpg_ref - delta_Vpg;
    else
        Vpg = Vpg_ref;
        Vpg(:,k) = Vpg(:,k)*(1-tol);        
    end
    
    [rho_g,rho_l,drho_g_dp,drho_l_dp] = get_density(Vpg,prop);
    [Fam,bas,bas] = Flux_function(Vpg,prop,rho_g,rho_l,Cpi_m);    
    
    if 1
        if abs(Wpg_ref(:,k))>0
            Ax(:,:,k) = (Fap(:,:,1)-Fam(:,:,1))/(2*tol*Wpg_ref(:,k));
            Ay(:,:,k) = (Fap(:,:,2)-Fam(:,:,2))/(2*tol*Wpg_ref(:,k));
        else
            Ax(:,:,k) = (Fap(:,:,1)-Fam(:,:,1))/(2*tol);
            Ay(:,:,k) = (Fap(:,:,2)-Fam(:,:,2))/(2*tol);            
        end        
    else
        Ax(:,:,k) = (Fap(:,:,1)-Fam(:,:,1))/(2*tol*Vpg_ref(:,k));
        Ay(:,:,k) = (Fap(:,:,2)-Fam(:,:,2))/(2*tol*Vpg_ref(:,k));        
    end
    
    if 0
        delta_Wpg = zeros(1,2*ndm+2);
        delta_Wpg(:,k) = Wpg_ref(:,k)*0.1;        
        delta_Vpg = (Cpi*delta_Wpg')';
        V2 = cv2pv(Wpg_ref+delta_Wpg,rho_g,rho_l,p)    
        Vpg_ref+delta_Vpg
        
        keyboard;pause
    end
    
end

disp('Ax')
disp(' calculado ')
reshape(Ax_ref,6,6)
disp(' por diferencias ')
reshape(Ax,6,6)
disp(' la diferencia entre ambos')
reshape(Ax_ref,6,6)-reshape(Ax,6,6)
pause
disp('Ay')
reshape(Ay_ref,6,6)
disp(' por diferencias ')
reshape(Ay,6,6)
disp(' la diferencia entre ambos')
reshape(Ay_ref,6,6)-reshape(Ay,6,6)
