%
%  vemos autovalores del jacobiano advectivo
%

Temp    = 300;
gamma_g = 1.4;
gamma_l = 2.8;   
Cp_g    = 1000;
Cp_l    = 4000;       
p_infty = 8.5e8;

read_data

Temp    = 300;
gamma_g = 1.4;
gamma_l = 2.8;   
Cp_g    = 1000;
Cp_l    = 4000;       
p_infty = 8.5e8;


ijob = 'set';
handle_prop_elem;

alpha_g = 0.99;
u_g = [-2,1];
u_l = [1,-1];
p   = 1e6;
alpha_l = 1-alpha_g;

tol = 1e-7;

Upg = [alpha_g,u_g,u_l,p];
[rho_g,rho_l,drho_g_dp,drho_l_dp] = get_density(Upg,prop);
Wpg = [alpha_g*rho_g,alpha_l*rho_l,alpha_g*rho_g*u_g,alpha_l*rho_l*u_l];
Wpg_ref = Wpg;
rho_g_ref = rho_g;
rho_l_ref = rho_l;

Vpg_ref = Upg;

[rho_g,rho_l,drho_g_dp,drho_l_dp] = get_density(Upg,prop);

[H,Cp] = enthalpy_function(Upg,prop,rho_g,rho_l,drho_g_dp,drho_l_dp);
Cpi = inv(reshape(Cp,2*ndm+2,2*ndm+2));

[Fa,Ax_ref,Ay_ref] = Flux_function(Upg,prop,rho_g,rho_l,Cpi);    

[Vx,Dx]=eig(reshape(Ax_ref,6,6));
[Vy,Dy]=eig(reshape(Ay_ref,6,6));

ul = sqrt(u_l(:,1).^2+u_l(:,2).^2);
ug = sqrt(u_g(:,1).^2+u_g(:,2).^2);
cc_l = gamma_l*p/rho_l;
cc_g = gamma_g*p/rho_g;
ag2 = (gamma_g-1)*Cp_g*Temp;
al2 = (gamma_l-1)*Cp_l*Temp;
cc_l = al2;
cc_g = ag2;

Lambda_x_1 = u_l(:,1) + sqrt(cc_l/gamma_l * p/(alpha_g*p_infty - p ));
Lambda_x_2 = u_l(:,1) - sqrt(cc_l/gamma_l * p/(alpha_g*p_infty - p ));
Lambda_x_3 = u_g(:,1) + sqrt(cc_g/gamma_g);
Lambda_x_4 = u_g(:,1) - sqrt(cc_g/gamma_g);
Lambda_x_5 = u_l(:,1);
Lambda_x_6 = u_g(:,1);

Lambda_y_1 = u_l(:,2) + sqrt(cc_l/gamma_l * p/(alpha_g*p_infty - p ));
Lambda_y_2 = u_l(:,2) - sqrt(cc_l/gamma_l * p/(alpha_g*p_infty - p ));
Lambda_y_3 = u_g(:,2) + sqrt(cc_g/gamma_g);
Lambda_y_4 = u_g(:,2) - sqrt(cc_g/gamma_g);
Lambda_y_5 = u_l(:,2);
Lambda_y_6 = u_g(:,2);

Lambda_X = [Lambda_x_1 ;Lambda_x_2 ;Lambda_x_3 ;Lambda_x_4 ;Lambda_x_5 ;Lambda_x_6 ]

Lambda_Y = [Lambda_y_1 ;Lambda_y_2 ;Lambda_y_3 ;Lambda_y_4 ;Lambda_y_5 ;Lambda_y_6 ]

return

Fa_ref = Fa;

for k=1:2*ndm+2,

    delta_Wpg = zeros(1,2*ndm+2);
    delta_Wpg(:,k) = Wpg_ref(:,k)*tol;        
    delta_Vpg = (Cpi*delta_Wpg')';
        
    if 1
        Vpg = Vpg_ref + delta_Vpg;
    else
        Vpg = Vpg_ref;
        Vpg(:,k) = Vpg(:,k)*(1+tol);        
    end
    
    [rho_g,rho_l,drho_g_dp,drho_l_dp] = get_density(Vpg,prop);
    [Fap,bas,bas] = Flux_function(Vpg,prop,rho_g,rho_l,Cpi);    
    
    if 1
        Vpg = Vpg_ref - delta_Vpg;
    else
        Vpg = Vpg_ref;
        Vpg(:,k) = Vpg(:,k)*(1-tol);        
    end
    
    [rho_g,rho_l,drho_g_dp,drho_l_dp] = get_density(Vpg,prop);
    [Fam,bas,bas] = Flux_function(Vpg,prop,rho_g,rho_l,Cpi);    
    
    if 1
        Ax(:,:,k) = (Fap(:,:,1)-Fam(:,:,1))/(2*tol*Wpg_ref(:,k));
        Ay(:,:,k) = (Fap(:,:,2)-Fam(:,:,2))/(2*tol*Wpg_ref(:,k));
    else
        Ax(:,:,k) = (Fap(:,:,1)-Fam(:,:,1))/(2*tol*Vpg_ref(:,k));
        Ay(:,:,k) = (Fap(:,:,2)-Fam(:,:,2))/(2*tol*Vpg_ref(:,k));        
    end
    
    if 0
        delta_Wpg = zeros(1,2*ndm+2);
        delta_Wpg(:,k) = Wpg_ref(:,k)*0.1;        
        delta_Vpg = (Cpi*delta_Wpg')';
        V2 = cv2pv(Wpg_ref+delta_Wpg,rho_g,rho_l,p)    
        Vpg_ref+delta_Vpg
        
        keyboard;pause
    end
    
end

