%
%  script para chequear que el calculo simbolico hecho en try1 para
%  determinar los autovalores de A partido por bloques (liquido/gas)
%  sea equivalente al que obtendriamos si lo hacemos en forma numerica
%

global data

if 0
    
    alpha_g = 0.1*(1+0.1*randn);
    p       = 1e5*(1+0.1*randn);
    
    ug      =  -1*(1+0.1*randn);
    vg      = 0.2*(1+0.1*randn);
    
    ug      =   0*(1+0.1*randn);
    vg      = 0.2*(1+0.1*randn);
    
    ul      =   2*(1+0.1*randn);
    vl      =-0.1*(1+0.1*randn);
    
    ul      =   0*(1+0.1*randn);
    vl      =-0.1*(1+0.1*randn);
    
    rho_g = 1;    
    rho_l = 1000;    
    gamma_g = 1.4;
    gamma_l = 2.8;
    Cp_g = 1008;
    Cp_l = 4186;
    T = 300;
    h_g = Cp_g*T;
    h_l = Cp_l*T;
    p_infty = 8.5e8;
    cc_g = ((gamma_g-1)*Cp_g*T);
    cc_l = ((gamma_l-1)*Cp_l*T);
    sigma = 1;    
    
elseif 1
    
    nnodes = 100;
    alpha_g_min = 1e-2;
    p_atm = 1e5;
    ug_min = 1e-3;
    ul_min = 1e-3;
        
    ug = [0]*ones(nnodes,1);
    vg = [1]*ones(nnodes,1);
    ul = [0]*ones(nnodes,1);
    vl = [1]*ones(nnodes,1);

    alpha_g = 0.1*ones(nnodes,1);
    p = p_atm*ones(nnodes,1);
    ug = [0];
    vg = [1];
    ul = [0];
    vl = [-1];

    alpha_g = max([rand(1,nnodes);ones(1,nnodes)*alpha_g_min])';
    p       = p_atm+20000*randn(nnodes,1);

    ug      = randn(nnodes,1);
    vg      = randn(nnodes,1);

    ul      = randn(nnodes,1);
    vl      = randn(nnodes,1);
    
    
    if 1
    if 1
        nn = find(abs(ug)<ug_min);
        ug(nn)  = 0;
        nn = find(abs(vg)<ug_min);
        vg(nn)  = 0;
    end
    
    
    if 0
        nn = find(abs(ul)<ul_min);
        ul(nn)  = 0;
        nn = find(abs(vl)<ul_min);
        vl(nn)  = 0;
    end

end
    rho_g = 1;    
    rho_l = 1000;    
    gamma_g = 1.4;
    gamma_l = 2.8;
    Cp_g = 1008;
    Cp_l = 4186;
    T = 300;
    h_g = Cp_g*T;
    h_l = Cp_l*T;
    p_infty = 8.5e8;
    cc_g = ((gamma_g-1)*Cp_g*T);
    cc_l = ((gamma_l-1)*Cp_l*T);
    sigma = 1;    
    
else
    node=6;
    rho_g = rho_g(node);
    ug    = Upg(node,indx_g_vel(1));
    alpha_g = Upg(node,indx_g_vf);
    ul  = Upg(node,indx_l_vel(1));
    rho_l = rho_l(node);
    p = Upg(node,indx_l_p);
    T = Temp;
    cc_g = ((gamma_g-1)*Cp_g*T);
    cc_l = ((gamma_l-1)*Cp_l*T);
    vl = Upg(node,indx_l_vel(2));
    vg = Upg(node,indx_g_vel(2));        
end

data.gamma_l = gamma_l;
data.gamma_g = gamma_g;
data.cg = sqrt(cc_g);
data.cl = sqrt(cc_l);
data.p_infty = p_infty;

vel_g = [ug,vg];
vel_l = [ul,vl];

indx_g_vf = 1;
indx_l_p = 2;
indx_g_vel = (3:4);
indx_l_vel = (5:6);

data.indx_g_vf  = indx_g_vf;
data.indx_l_p   = indx_l_p;
data.indx_g_vel = indx_g_vel;
data.indx_l_vel = indx_l_vel;

alpha_l = 1-alpha_g;

% ecuaciones de estado
h_g = Cp_g*T;
h_l = Cp_l*T;

rho_g = gamma_g*p/cc_g;
rho_l = gamma_l*(p_infty-p)/cc_l;

if 0
    arho_l = rho_l*alpha_l;
    arho_g = rho_g*alpha_g;
    
    drho_g_dp =  gamma_g/cc_g;
    drho_l_dp = -gamma_l/cc_l; 
    
    % matriz temporal A
    A = [rho_g,alpha_g*drho_g_dp,0,0,0,0;
        -rho_l,alpha_l*drho_l_dp,0,0,0,0;    
        rho_g*ug, alpha_g*ug*drho_g_dp,arho_g, 0 , 0, 0;
        rho_g*vg, alpha_g*vg*drho_g_dp , 0 ,arho_g, 0 , 0;        
        -rho_l*ul, alpha_l*ul*drho_l_dp , 0 , 0, arho_l , 0 ;
        -rho_l*vl, alpha_l*vl*drho_l_dp , 0 , 0, 0, arho_l 
    ];
    
    % su inversa
    Ai = inv(A);
    
    dalpha_g_dW1 = Ai(1,1);
    dalpha_g_dW2 = Ai(1,2);
    dp_dW1       = Ai(2,1);
    dp_dW2       = Ai(2,2);    
    dapdw1 = p*dalpha_g_dW1+alpha_g*dp_dW1;
    dapdw2 = p*dalpha_g_dW2+alpha_g*dp_dW2;
    dalpdw1 = -p*dalpha_g_dW1+(1-alpha_g)*dp_dW1;
    dalpdw2 = -p*dalpha_g_dW2+(1-alpha_g)*dp_dW2;
    
    Bx = [0,0,1,0,0,0;
        0,0,0,0,1,0;
        -ug^2+dapdw1 , dapdw2, 2*ug, 0 , 0 , 0 ;
        -ug*vg , 0, vg , ug , 0 , 0 ;
        dalpdw1 , -ul^2+dalpdw2 , 0 , 0, 2*ul , 0;
        0 , -ul*vl , 0 , 0 , vl, ul 
    ];
    
    By = [0,0,0,1,0,0;
        0,0,0,0,0,1;
        -ug*vg ,0 , vg , ug , 0 , 0 ;
        -vg^2+dapdw1 ,  dapdw2 , 0 , 2*vg , 0 , 0 ;
        0 , -ul*vl , 0 , 0 , vl, ul ;
        dalpdw1 , -vl^2+dalpdw2 , 0 , 0, 0 , 2*vl ];    
    
end

Up(:,indx_g_vf) = alpha_g;
Up(:,indx_g_vel) = vel_g;
Up(:,indx_l_p) = p;
Up(:,indx_l_vel) = vel_l;

% bloques GAS
disp(' GAS - V*D*inv(V)-Bg')
disp(' ===================================== ')

nx = ug./sqrt(ug.^2+vg.^2); ny = vg./sqrt(ug.^2+vg.^2);
%Bx_g=Bx([indx_g_vf,indx_g_vel],[indx_g_vf,indx_g_vel]);
%By_g=By([indx_g_vf,indx_g_vel],[indx_g_vf,indx_g_vel]);
%Bn_g = Bx_g*nx+By_g*ny;
%[Vg,Dg] = (eig(Bn_g));
%tau_g = (Vg*inv(abs(Dg))*inv(Vg));

[Vg_symb,Dg_symb,Bn_g_symb,Vgi_symb] = eig_symb_array(Up,[nx,ny],'G');

if 0
    %Vg_symb=[Vg_symb(:,2),Vg_symb(:,1),Vg_symb(:,3)];
    erro = Vg_symb*Dg_symb*inv(Vg_symb)-Bn_g
    disp([' Max error = ' num2str(abs(max(max(erro))))])
    if abs(max(max(erro)))>1e-8, error(' excede tolerancia'); end
    
    erro = inv(Vg_symb)-Vgi_symb;
    disp([' Max error en la inversa = ' num2str(abs(max(max(erro))))])
    if abs(max(max(erro)))>1e-8, error(' excede tolerancia'); end
end

vaux = zeros(nnodes,3,3);
for k=1:3
    for j=1:3
        for i=1:3
            vaux(:,k,j) = vaux(:,k,j) + Vg_symb(:,k,i).*Vgi_symb(:,i,j).*Dg_symb(:,i);
        end
    end
end


for k=1:nnodes
    err = reshape(abs(vaux(k,:,:)-Bn_g_symb(k,:,:)),3,3);
    erro(k,1) = max(max(err));
end

disp([' Max error en la inversa = ' num2str(max(abs(erro)))])
if max(abs(erro))>1e-8, error(' excede tolerancia'); end

% bloque LIQUIDO
disp(' LIQUID - V*D*inv(V)-Bl')
disp(' ===================================== ')

nx = ul./sqrt(ul.^2+vl.^2); ny = vl./sqrt(ul.^2+vl.^2);
%Bx_l=Bx([indx_l_p,indx_l_vel],[indx_l_p,indx_l_vel]);
%By_l=By([indx_l_p,indx_l_vel],[indx_l_p,indx_l_vel]);
%Bn_l = Bx_l*nx+By_l*ny;
%[Vl,Dl] = (eig(Bn_l));
%tau_l = (Vl*inv(abs(Dl))*inv(Vl));            

[Vl_symb,Dl_symb,Bn_l_symb,Vli_symb] = eig_symb_array(Up,[nx,ny],'L');

vaux = zeros(nnodes,3,3);
for k=1:3
    for j=1:3
        for i=1:3
            vaux(:,k,j) = vaux(:,k,j) + Vl_symb(:,k,i).*Vli_symb(:,i,j).*Dl_symb(:,i);
        end
    end
end

erro = max(max(max(vaux-Bn_l_symb)));
disp([' Max error en la inversa = ' num2str(erro)])
if abs(erro)>1e-8, error(' excede tolerancia'); end

if 0
    %Vl_symb=[Vl_symb(:,2),Vl_symb(:,1),Vl_symb(:,3)];
    erro = Vl_symb*Dl_symb*inv(Vl_symb)-Bn_l
    disp([' Max error en autovectores = ' num2str(abs(max(max(erro))))])
    if abs(max(max(erro)))>1e-8, error(' excede tolerancia'); end
    
    erro = inv(Vl_symb)-Vli_symb;
    disp([' Max error en la inversa = ' num2str(abs(max(max(erro))))])
    if abs(max(max(erro)))>1e-8, error(' excede tolerancia'); end
end
