
syms rho_g rho_l alpha_g ug ul vl vg p gamma_g gamma_l al2 ag2 p_infty 

ndm = 2;

get_index;

alpha_l = 1-alpha_g;
vel_l = [ul ;vl];
vel_g = [ug ;vg];

rho_g = gamma_g*p/ag2;
rho_l = gamma_l*(p_infty-p)/al2;

%Fa = zeros(2+2*ndm,ndm);

W = [rho_g*alpha_g;rho_l*alpha_l;rho_g*alpha_g*vel_g(1);rho_g*alpha_g*vel_g(2);rho_l*alpha_l*vel_l(1);rho_l*alpha_l*vel_l(2)];
U = [alpha_g;p;vel_g;vel_l];


for idm=ndm:-1:1
    Fa(indx_l_mom(idm),idm) = alpha_l*p;
    Fa(indx_g_mom(idm),idm) = alpha_g*p;
    
    Fa(indx_l_con,idm)   = rho_l.*alpha_l*vel_l(idm);
    Fa(indx_g_con,idm)   = rho_g.*alpha_g*vel_g(idm);
    
    for jdm=1:ndm
        Fa(indx_g_mom(idm),jdm) = Fa(indx_g_mom(idm),jdm) + alpha_g*(rho_g*vel_g(jdm)*vel_g(idm));         
        Fa(indx_l_mom(idm),jdm) = Fa(indx_l_mom(idm),jdm) + alpha_l*(rho_l*vel_l(jdm)*vel_l(idm));
    end
end

H(indx_g_con,1)   = rho_g*alpha_g;
H(indx_l_con,1)   = rho_l*(1-alpha_g);
for idm=1:ndm
    H(indx_g_mom(idm),1)   = rho_g*    alpha_g*vel_g(idm);
    H(indx_l_mom(idm),1)   = rho_l*(1-alpha_g)*vel_l(idm);
end

% jacobianos dF/dU
Ax = jacobian(Fa(:,1),U);
Ay = jacobian(Fa(:,2),U);

Cp = jacobian(H,U);

Cpi = inv(Cp);

% jacobianos dF/dW = dF/dU*dU/dW
Axc = simple(Ax*Cpi);
Ayc = simple(Ay*Cpi);


% check con la version numerica
read_data 

Temp    = 300;
gamma_g = 1.4;
gamma_l = 2.8;   
Cp_g    = 1000;
Cp_l    = 4000;       
p_infty = 8.5e8;

ijob = 'set';
handle_prop_elem;

alpha_g = 0.2*(1+rand);
u_g     = [1,2]*(1+rand);
u_l     = [1,1]*(1+rand);
p       = 1e5*(1+rand);
alpha_l = 1-alpha_g;

NN = 2;
Upg(1:NN,indx_g_vf) = alpha_g;
Upg(1:NN,indx_l_p) = p;
for idm=1:ndm
    Upg(1:NN,indx_g_vel(idm)) = u_g(idm);
    Upg(1:NN,indx_l_vel(idm)) = u_l(idm);
end

[rho_g,rho_l,drho_g_dp,drho_l_dp] = get_density(Upg,prop);
[H_num,Cp_num]                    = enthalpy_function(Upg,prop,rho_g,rho_l,drho_g_dp,drho_l_dp);
for kk=1:NN
    Cpi_num(kk,:,:)                = reshape(inv(reshape(Cp_num(kk,:,:),6,6)),1,6,6);
end
[Fa_num,Axc_num,Ayc_num]          = Flux_function(Upg,prop,rho_g,rho_l,Cpi_num);

vaux = subs(subs(subs(subs(subs(subs(Axc,'gamma_g',gamma_g),'gamma_l',gamma_l),'ag2',(gamma_g-1)*Cp_g*Temp),'al2',(gamma_l-1)*Cp_l*Temp),'p_infty',p_infty),'alpha_g',alpha_g);
vaux = subs(subs(subs(subs(subs(subs(vaux,'alpha_l',alpha_l),'ug',u_g(1)),'vg',u_g(2)),'ul',u_l(1)),'vl',u_l(2)),'p',p);
bfh_x=[];
for kk=1:NN
    disp('symbolic to numeric'), vaux
    disp('numeric to numeric'), reshape(Axc_num(kk,:,:),6,6)
    disp('differences'), reshape(Axc_num(kk,:,:),6,6)-vaux
    bfh_x=[bfh_x;max(max(abs(reshape(Axc_num(kk,:,:),6,6)-vaux)))];
end

disp(' enter to continue'),pause

vaux = subs(subs(subs(subs(subs(subs(Ayc,'gamma_g',gamma_g),'gamma_l',gamma_l),'ag2',(gamma_g-1)*Cp_g*Temp),'al2',(gamma_l-1)*Cp_l*Temp),'p_infty',p_infty),'alpha_g',alpha_g);
vaux = subs(subs(subs(subs(subs(subs(vaux,'alpha_l',alpha_l),'ug',u_g(1)),'vg',u_g(2)),'ul',u_l(1)),'vl',u_l(2)),'p',p);

bfh_y=[];
for kk=1:NN
    disp('symbolic to numeric'), vaux
    disp('numeric to numeric'), reshape(Ayc_num(kk,:,:),6,6)
    disp('differences'), reshape(Ayc_num(kk,:,:),6,6)-vaux
    bfh_y=[bfh_y;max(max(abs(reshape(Ayc_num(kk,:,:),6,6)-vaux)))];    
end