numerico = 0;
liquid_incom = 1;

if numerico==0
    syms rho_g ug alpha_g ul rho_l p gamma_g gamma_l T Cp_g Cp_l cc_g cc_l p_infty Lambda sigma p_i p_i_0 vl vg
else
    if 1
        rho_g = 1;
        ug    = -1;
        alpha_g = 0.1;
        ul  = 2;
        rho_l = 1000;
        p = 1e5;
        gamma_g = 1.4;
        gamma_l = 2.8;
        Cp_g = 1008;
        Cp_l = 4186;
        T = 300;
        h_g = Cp_g*T;
        h_l = Cp_l*T;
        p_infty = 8.5e8;
        cc_g = ((gamma_g-1)*Cp_g*T);
        cc_l = ((gamma_l-1)*Cp_l*T);
        sigma = 1;    
        vl = -0.1;
        vg = 0.2;
    else
        node=6;
        rho_g = rho_g(node);
        ug    = Upg(node,indx_g_vel(1));
        alpha_g = Upg(node,indx_g_vf);
        ul  = Upg(node,indx_l_vel(1));
        rho_l = rho_l(node);
        p = Upg(node,indx_l_p);
        %        gamma_g = 1.4;
        %        gamma_l = 2.8;
        %        Cp_g = 1008;
        %        Cp_l = 4186;
        T = Temp;
        %        h_g = Cp_g*T;
        %        h_l = Cp_l*T;
        %        p_infty = 8.5e8;
        cc_g = ((gamma_g-1)*Cp_g*T);
        cc_l = ((gamma_l-1)*Cp_l*T);
        %        sigma = 1;    
        vl = Upg(node,indx_l_vel(2));
        vg = Upg(node,indx_g_vel(2));        
    end
end

indx_g_vf = 1;
indx_l_p = 2;
indx_g_vel = (3:4);
indx_l_vel = (5:6);

alpha_l = 1-alpha_g;

% ecuaciones de estado
h_g = Cp_g*T;
h_l = Cp_l*T;

rho_g = gamma_g*p/cc_g;
if liquid_incom
    syms rho_l;
else
    rho_l = gamma_l*(p_infty-p)/cc_l;
end

arho_l = rho_l*alpha_l;
arho_g = rho_g*alpha_g;

drho_g_dp =  gamma_g/cc_g;
if liquid_incom
    drho_l_dp = 0;     
else
    drho_l_dp = -gamma_l/cc_l; 
end

% matriz temporal A
A = [rho_g,alpha_g*drho_g_dp,0,0,0,0;
    -rho_l,alpha_l*drho_l_dp,0,0,0,0;    
    rho_g*ug, alpha_g*ug*drho_g_dp,arho_g, 0 , 0, 0;
    rho_g*vg, alpha_g*vg*drho_g_dp , 0 ,arho_g, 0 , 0;        
    -rho_l*ul, alpha_l*ul*drho_l_dp , 0 , 0, arho_l , 0 
    -rho_l*vl, alpha_l*vl*drho_l_dp , 0 , 0, 0, arho_l ];
    
    % su inversa
    
    Ai = inv(A);
    
    dalpha_g_dW1 = Ai(1,1);
    dalpha_g_dW2 = Ai(1,2);
    dp_dW1       = Ai(2,1);
    dp_dW2       = Ai(2,2);    
    dapdw1 = p*dalpha_g_dW1+alpha_g*dp_dW1;
    dapdw2 = p*dalpha_g_dW2+alpha_g*dp_dW2;
    dalpdw1 = -p*dalpha_g_dW1+(1-alpha_g)*dp_dW1;
    dalpdw2 = -p*dalpha_g_dW2+(1-alpha_g)*dp_dW2;
    
    Bx = [0,0,1,0,0,0;
        0,0,0,0,1,0;
        -ug^2+dapdw1 , dapdw2, 2*ug, 0 , 0 , 0 ;
        -ug*vg , 0, vg , ug , 0 , 0 ;
        dalpdw1 , -ul^2+dalpdw2 , 0 , 0, 2*ul , 0;
        0 , -ul*vl , 0 , 0 , vl, ul ];
        
        By = [0,0,0,1,0,0;
            0,0,0,0,0,1;
            -ug*vg ,0 , vg , ug , 0 , 0 ;
            -vg^2+dapdw1 ,  dapdw2 , 0 , 2*vg , 0 , 0 ;
            0 , -ul*vl , 0 , 0 , vl, ul ;
            dalpdw1 , -vl^2+dalpdw2 , 0 , 0, 0 , 2*vl ];    
        
        
        if numerico
            
            Bx_g=Bx([indx_g_vf,indx_g_vel],[indx_g_vf,indx_g_vel]);
            By_g=By([indx_g_vf,indx_g_vel],[indx_g_vf,indx_g_vel]);
            B_g = Bx_g*Bx_g+By_g*By_g;
            tau_g = inv(sqrtm(B_g));
            Px_g = tau_g*Bx_g;
            Py_g = tau_g*By_g;
            
            Bx_l=Bx([indx_l_p,indx_l_vel],[indx_l_p,indx_l_vel]);
            By_l=By([indx_l_p,indx_l_vel],[indx_l_p,indx_l_vel]);
            B_l = Bx_l*Bx_l+By_l*By_l;
            tau_l = inv(sqrtm(B_l));
            Px_l = tau_l*Bx_l;
            Py_l = tau_l*By_l;
            
        else
            
            syms nx ny
            Bx_g=Bx([indx_g_vf,indx_g_vel],[indx_g_vf,indx_g_vel]);
            By_g=By([indx_g_vf,indx_g_vel],[indx_g_vf,indx_g_vel]);
            Bn_g = Bx_g*nx+By_g*ny;
            [Vg,Dg] = (eig(Bn_g));            
            tau_g = (Vg*inv(abs(Dg))*inv(Vg));
            if 0
                % nx=0
                [Vg,Dg] = (eig(subs(By_g,ug,0)));
                tau_g = (Vg*inv(abs(Dg))*inv(Vg));
                % pongo nx=ug y ny=vg (porque la proyeccion es a lo largo de la
                % streamline
                Bn_g = Bx_g*ug+By_g*vg;
                [Vg,Dg] = (eig(Bn_g));
                tau_g = (Vg*inv(abs(Dg))*inv(Vg));
            end
            
            Bx_l=Bx([indx_l_p,indx_l_vel],[indx_l_p,indx_l_vel]);
            By_l=By([indx_l_p,indx_l_vel],[indx_l_p,indx_l_vel]);
            Bn_l = Bx_l*nx+By_l*ny;
            [Vl,Dl] = (eig(Bn_l));
            tau_l = (Vl*inv(abs(Dl))*inv(Vl));            
            if 0
                % pongo nx=ul y ny=vl (porque la proyeccion es a lo largo de la
                % streamline
                Bn_l = (Bx_l*ul+By_l*vl)/(sqrt(ul^2+vl^2));
                [Vl,Dl] = (eig(Bn_l));
                tau_l = (Vl*inv(abs(Dl))*inv(Vl));
            end
            
        end
        
        return
        
        U = [alpha_g;ug;vg;ul;vl;p];
        H = [rho_g*alpha_g;rho_l*alpha_l;rho_g*alpha_g*ug;rho_g*alpha_g*vg;rho_l*alpha_l*ul;rho_l*alpha_l*vl];
        
        H_old = subs(subs(subs(subs(subs(subs(H,p,'pold'),alpha_g,'alpha_g_old'),ug,'ug_old'),vg,'vg_old'),ul,'ul_old'),vl,'vl_old');
        U_old = subs(subs(subs(subs(subs(subs(U,p,'pold'),alpha_g,'alpha_g_old'),ug,'ug_old'),vg,'vg_old'),ul,'ul_old'),vl,'vl_old');
        
        syms rho_g_old ug_old alpha_g_old
        
        vaux = (rho_g+rho_g_old)/2*(ug+ug_old)/2*(alpha_g-alpha_g_old)+(rho_g+rho_g_old)/2*(alpha_g+alpha_g_old)/2*(ug-ug_old)+(ug+ug_old)/2*(alpha_g+alpha_g_old)/2*(rho_g-rho_g_old);
        
        vaux = (rho_g+rho_g_old)/2*(alpha_g-alpha_g_old)+(alpha_g+alpha_g_old)/2*(rho_g-rho_g_old);
