
read_data

rho_l_user = 1000;
rho_g_user = 1;

rho_g = rho_g_user;
rho_l = rho_l_user;

ag2 = (gamma_g-1)*Cp_g*Temp;
al2 = (gamma_l-1)*Cp_l*Temp;

drho_g_dp = gamma_g/ag2;
drho_l_dp = 0;

ijob = 'set';
handle_prop_elem;

alpha_g = 0.99;
p       = 1e5;
velpg_g   = [0,100];
velpg_l   = [0,1];
coef_sigma = -3;

Upg = [alpha_g,p,velpg_g,velpg_l];

alpha_l = 1-alpha_g;

[bas,Cp,Cpi]    = enthalpy_function(Upg,prop,rho_g,rho_l,drho_g_dp,drho_l_dp);
[bas,Axc,Ayc]    = Flux_function(Upg,prop,rho_g,rho_l,Cpi);        

rho_m = alpha_l.*rho_l+alpha_g.*rho_g;
for idm=1:ndm
    velpg_M(:,idm) = (rho_l.*alpha_l.*velpg_l(:,idm)+rho_g.*alpha_g.*velpg_g(:,idm))./rho_m;
end

%hele_M        = comp_hele(velpg_M,dshapex0,Jaco0,nen);
hele_M = 1;
hele_g = 1;
hele_l = 1;

for idm=1:ndm
    nor(:,idm) = velpg_M(:,idm) ./ sqrt(sum(velpg_M'.^2))';
end    

for idf=1:ndf
    for jdf=1:ndf
        An(:,idf,jdf) = nor(:,1).*Axc(:,idf,jdf) + nor(:,2).*Ayc(:,idf,jdf) ;
    end
end

[V_full_cons,D_full_cons] = eig(reshape(An,ndf,ndf));

tau_M_full_cons = compute_tau_eig_numer(An,hele_M,prop);

vrel = velpg_g-velpg_l;
vrel_mod = sqrt(sum(vrel'.^2))';

p_int = alpha_g.*(1-alpha_g).*rho_g.*rho_l./(alpha_g.*rho_l+(1-alpha_g).*rho_g).*vrel_mod.^2;
p_int = coef_sigma*p_int;

Hncx = zeros(ndf,ndf);
Hncy = zeros(ndf,ndf);
if 1
    Hncx(3,1) =  p_int;
    Hncx(5,1) = -p_int;
    Hncy(4,1) =  p_int;
    Hncy(6,1) = -p_int;
else
    Hncx(3,1) =  p+p_int;
    Hncx(5,1) = -p-p_int;
    Hncy(4,1) =  p+p_int;
    Hncy(6,1) = -p-p_int;    
end

dAx = Hncx*reshape(Cpi,ndf,ndf);
ANCx = Axc-reshape(dAx,1,ndf,ndf);
dAy = Hncy*reshape(Cpi,ndf,ndf);
ANCy = Ayc-reshape(dAy,1,ndf,ndf);

for idf=1:ndf
    for jdf=1:ndf
        ANCn(:,idf,jdf) = nor(:,1).*ANCx(:,idf,jdf) + nor(:,2).*ANCy(:,idf,jdf) ;
    end
end

tau_M_full_nocons = compute_tau_eig_numer(ANCn,hele_M,prop);

[V_full_nocons,D_full_nocons] = eig(reshape(ANCn,ndf,ndf));

tau_M_block_cons = compute_tau_eig(Upg,velpg_g,velpg_l,hele_g,hele_l,prop);

An_block_gas = reshape(An(1,[indx_g_vf,indx_g_vel],[indx_g_vf,indx_g_vel]),3,3);
An_block_liq = reshape(An(1,[indx_l_p,indx_l_vel],[indx_l_p,indx_l_vel]),3,3);

[V_block_liq_cons,D_block_liq_cons] = eig(An_block_liq);
[V_block_gas_cons,D_block_gas_cons] = eig(An_block_gas);

disp([' en bloques - GAS & LIQ ///// full - CONSERVATIVE ///// full - NO CONSERVATIVE '])
[[diag(D_block_gas_cons);diag(D_block_liq_cons)],[diag(D_full_cons)],[diag(D_full_nocons)]]