%
%  solucion analitica water faucet
%

global data

% desactivarlo si lo corro desde dentro de la rutina de femcode
% read_data  


L = 12;
alpha_g_0 = 0.2;
ul_0      = 10;
g         = 9.81;
x0        = 0;
p_end     = 1e5;
rho_l     = 1000;
rho_g     = 1;

Temp      = 273+35;
gamma_g   = 1.4;
Cp_g      = 1000;
ag2       = (gamma_g-1)*Cp_g*Temp;

%rho_g     = gamma_g*p/ag2;
    
u0        = ul_0;

sigma = 1;

data.u0 = u0;
data.g  = g;
data.x0 = x0;
data.L  = L;
data.alpha_g_0  = alpha_g_0;
data.gamma_g = gamma_g;
data.ag2 = ag2;
data.rho_l = rho_l;
data.sigma = sigma;

x = xnod(nodes_lef,2);

YSPAN = [0,L];
YSPAN = xnod(nodes_lef,2);
YSPAN = L-flipud(x);

U0    = 1e5;
[Y,U] = ODE45('fdriven',YSPAN,U0);

p = flipud(U);

alpha_g = 1 - (1-alpha_g_0)*u0 ./sqrt(u0^2+2*abs(g)*(x-x0));
cte     = u0*(1-alpha_g(1));
vel_l   = cte ./ (1-alpha_g);
dalpha_g_dx = (1-alpha_g_0)*u0 ./(u0^2+2*abs(g)*x-2*g*x0).^(3/2)*abs(g);

figure(1);clf;plot(x,alpha_g)
figure(2);clf;plot(x,vel_l)
figure(3);clf;plot(x,p)

uini(nodes_lef,indx_g_vf) = alpha_g;
uini(nodes_rig,indx_g_vf) = alpha_g;

uini(nodes_lef,indx_l_p) = p;
uini(nodes_rig,indx_l_p) = p;

uini(nodes_lef,indx_l_vel(2)) = vel_l;
uini(nodes_rig,indx_l_vel(2)) = vel_l;

uini(nodes_lef,indx_l_vel(1)) = 0*vel_l;
uini(nodes_rig,indx_l_vel(1)) = 0*vel_l;

uini(nodes_lef,indx_g_vel(2)) = vel_g_ini(2);
uini(nodes_rig,indx_g_vel(2)) = vel_g_ini(2);

uini(nodes_lef,indx_g_vel(1)) = 0*vel_l;
uini(nodes_rig,indx_g_vel(1)) = 0*vel_l;

return

% tiempo al estado estacionario
t_st = (L-(g/2)^2)/u0;

x = (0:100)/100*L;

alpha_g = 1 - (1-alpha_g_0)*u0 ./sqrt(u0^2+2*abs(g)*(x-x0));
cte     = u0*(1-alpha_g(1));
vel_l   = cte ./ (1-alpha_g);
dalpha_g_dx = (1-alpha_g_0)*u0 ./(u0^2+2*abs(g)*x-2*g*x0).^(3/2)*abs(g);

if 0
    dalpha_g_dx_num = diff(alpha_g)./diff(x);
    xhalf = (x(1:end-1)+x(2:end))*0.5;
end

% integro la ecuacion de momento del gas para despejar la presion
vrel_mod = vel_l;
pint = 1* (alpha_g.*(1-alpha_g).*rho_g.*rho_l./(alpha_g.*rho_l+(1-alpha_g).*rho_g).*vrel_mod.^2);
cte = alpha_g(end)*p_end - (rho_g(end)*alpha_g(end)*g+pint(end)*dalpha_g_dx(end))*L;
p = ( cte + (rho_g*alpha_g*g+pint.*dalpha_g_dx).*x ) ./  alpha_g;

