%
%  solucion analitica water faucet
%
global data

% desactivarlo si lo corro desde dentro de la rutina de femcode
% read_data  
L         = 12;
alpha_g_0 = 0.2;
alpha_g_f = 0.3;
ul_0      = 10;
g         = 9.81*0.1;
x0        = 0;
p_end     = 1e5;
rho_l     = 1000;
rho_g     = 1;

Temp      = 273+35;
gamma_g   = 1.4;
Cp_g      = 1000;
ag2       = (gamma_g-1)*Cp_g*Temp;
u0        = ul_0;
sigma = 1;

data.u0 = u0;
data.g  = g;
data.x0 = x0;
data.L  = L;
data.alpha_g_0  = alpha_g_0;
data.alpha_g_f  = alpha_g_f;
data.gamma_g = gamma_g;
data.ag2 = ag2;
data.rho_l = rho_l;
data.sigma = sigma;

x = xnod(nodes_lef,2);

YSPAN = [0,L];
YSPAN = xnod(nodes_lef,2);
YSPAN = L-flipud(x);

% incognitas U = [vg , p]
U0    = [10,1e5];
[Y,U] = ODE45('fdriven4',YSPAN,U0);

vel_g = flipud(U(:,1));
p     = flipud(U(:,2));

alpha_g = alpha_g_0+(alpha_g_f-alpha_g_0)*(x-x0)/L;
dalpha_g_dx = (alpha_g_f-alpha_g_0)/L*ones(length(x),1);
alpha_l = 1 - alpha_g;
vel_l   = (1-alpha_g_0)*u0 ./ (1-alpha_g);
dvel_l_dx = u0*(1-alpha_g_0) ./ (1-alpha_g).^2.* dalpha_g_dx;

rho_g = gamma_g/ag2*p;
rho_m = alpha_g.*rho_g + alpha_l.*rho_l;

dpdx = (rho_m*g-rho_l*alpha_l.*vel_l.*dvel_l_dx +rho_g.*dalpha_g_dx.*vel_g.*vel_g) ./ (1- rho_g.*alpha_g.*vel_g.^2 ./p);

p_int = (rho_l*(1-alpha_g).*vel_l.*dvel_l_dx - p.*dalpha_g_dx + alpha_l.*dpdx - rho_l*alpha_l*g )./(-dalpha_g_dx);

figure(1);clf;plot(x,alpha_g)
figure(2);clf;plot(x,vel_l)
figure(3);clf;plot(x,p)


uini(nodes_lef,indx_g_vf) = alpha_g;
uini(nodes_rig,indx_g_vf) = alpha_g;

uini(nodes_lef,indx_l_p) = p;
uini(nodes_rig,indx_l_p) = p;

uini(nodes_lef,indx_l_vel(2)) = vel_l;
uini(nodes_rig,indx_l_vel(2)) = vel_l;

uini(nodes_lef,indx_l_vel(1)) = 0*vel_l;
uini(nodes_rig,indx_l_vel(1)) = 0*vel_l;

uini(nodes_lef,indx_g_vel(2)) = vel_g;
uini(nodes_rig,indx_g_vel(2)) = vel_g;

uini(nodes_lef,indx_g_vel(1)) = 0*vel_l;
uini(nodes_rig,indx_g_vel(1)) = 0*vel_l;

if 0
    vaux = zeros(numnp,1);
    vaux(nodes_lef,1) = p_int;
    vaux(nodes_rig,1) = p_int;
    my_fprintf('file_pint.dat','%20.10e \n',vaux);
end

if 1
    vaux1 = (alpha_g.*vel_g.^2.*rho_g+alpha_g.*p);
    dadx = (diff(alpha_g)./diff(xnod(nodes_rig,2)));
    vaux2 = (p_int(1:end-1)+p_int(2:end))/2.*dadx;
    vaux3 = g*rho_g.*alpha_g;
    vaux3 = 0.5*(vaux3(2:end)+vaux3(1:end-1));
    vaux = (diff(vaux1)./diff(xnod(nodes_rig,2)))-vaux2-vaux3;
    vaux_gas = vaux;
    
    vaux1 = (alpha_l.*vel_l.^2.*rho_l+alpha_l.*p);
    dadx = (diff(alpha_l)./diff(xnod(nodes_rig,2)));
    vaux2 = (p_int(1:end-1)+p_int(2:end))/2.*dadx;
    vaux3 = g*rho_l.*alpha_l;
    vaux3 = 0.5*(vaux3(2:end)+vaux3(1:end-1));
    vaux = (diff(vaux1)./diff(xnod(nodes_rig,2)))-vaux2-vaux3;
    vaux_liq = vaux;
    
end

return
