function [Dmat_vg,Dmat_vl] = virtual_mass(Upg,U0pg,dUpg,dt,prop)
%
%   [Dmat_vg,Dmat_vl] = virtual_mass(Upg,U0pg,dUpg,dt,prop)
%

[N,ndf]  = size(Upg);
ndm = (ndf-2)/2;

get_index;

vel_g      = Upg(:,indx_g_vel);
vel_g_old  = U0pg(:,indx_g_vel);       
vel_l      = Upg(:,indx_l_vel);
vel_l_old  = U0pg(:,indx_l_vel);       
grad_vel_g = dUpg(:,indx_g_vel,:);
grad_vel_l = dUpg(:,indx_l_vel,:);    

for idm=1:ndm,
    Dmat_vg(:,idm) = (vel_g(:,idm)-vel_g_old(:,idm))/dt;
    Dmat_vl(:,idm) = (vel_l(:,idm)-vel_l_old(:,idm))/dt;
    for jdm=1:ndm
        Dmat_vg(:,idm) = Dmat_vg(:,idm) + ...
            vel_g(:,jdm).*grad_vel_g(:,idm,jdm);
        Dmat_vl(:,idm) = Dmat_vl(:,idm) + ...
            vel_l(:,jdm).*grad_vel_l(:,idm,jdm);         
    end
end       
