function [Kg,Rg] = nsi_tet(xnod,icone,fixa,forc,teco,lin_con,extra_nodal_fields,...
    extra_nodal_fields_old,prop,ifaceb,bou_data_neumann,Up,Upold,rowe,cole) 
%------------------------------------------------------------------
%
%  NSI_TET solver
%
%  state vector = [p ; vel ]
%
%------------------------------------------------------------------

global row col

ijob = 'get';
handle_prop_elem;

get_index;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

U    = Up;
Uold = Upold;

[numel,nen]   = size(icone);
[numnp,ndf]   = size(U);
%if ndf~=3, error(' NDF debe ser 3 (NSI_TET) ');end
%ndm = 2;

if ndm==1,
    pgauss1d;
elseif ndm==2, 
    pgauss2d; 
elseif ndm==3,
    pgauss3d; 
end

Rele = zeros(numel,nen,ndf);
Kele = zeros(numel,nen,ndf,nen,ndf);

Rg    = 0*forc;
eles  = (1:numel)';
ceros = zeros(length(eles),nen);

t0 = cputime;

%==========================================================================
% flow field
compute_flow_fields;
%==========================================================================

%keyboard;pause

% scalar transport equations
reac   = zeros(numel,1);
source = zeros(numel,1); 
veloc  = Up(:,indx_v);
if(vslip_variable)
    veloc(:,g_dir)  = veloc(:,g_dir) + extra_nodal_fields(:,1);
else
    veloc(:,g_dir)  = veloc(:,g_dir) + vslip;
end
T      = Up(:,indx_scal);
Told   = Upold(:,indx_scal);

compute_scalar_fields;
%==========================================================================

t1_1=cputime;
disp([' dt assemble (element) = ' num2str(t1_1-t0)])   

% Gather contributions from eles to nodes
%------------------------------------------------------------------
%disp(' at BUBBLY_2d ')
%keyboard;pause
[Rg,Kg] = gather_2(Rele,Kele,icone,nen,ndf,rowe,cole);

t1_2=cputime;
disp([' dt assemble (gather) = ' num2str(t1_2-t1_1)])   

%disp('bubbly_2d antes');keyboard;pause
% Linear restrictions
%------------------------------------------------------------------
if isempty(lin_con)==0,
    [Rg,Kg] = linear_constraint(Rg,Kg,lin_con,ndf);
    %disp('bubbly_2d despues');keyboard;pause
end
