%
%   ASM + fase dispersa
%

C_smag = 0.18;
Damping_factor = 1;

type_upwind         = 1;
tau_centroide       = 0;
debug               = 0;

get_index;

visco = prop(2);

% cutoff void fraction between 0 and 1
if 0
    tol = 1e-4;
    alpha_g = min([U(:,indx_vf)';(1-tol)*ones(1,numnp)])';
    U(:,indx_vf) = max([alpha_g';tol*ones(1,numnp)])';
end

%------------------------------------------------------------------
ne  = length(eles);
[bas,ndf_fields] = size(extra_nodal_fields);

% Localizacion de las variables
%------------------------------------------------------------------
ceros = zeros(ne,nen*ndf);
Ue = ceros;
U0e = ceros;
re = zeros(ne,nen);

for inod=1:nen,
    nodes  = icone(eles,inod);
    jnod  = (inod-1)*ndf+(1:ndf);
    knod  = (inod-1)*ndf_fields+(1:ndf_fields);            
    Ue(:,jnod)  = U(nodes,1:ndf);		 
    U0e(:,jnod) = Uold(nodes,1:ndf);   
    re(:,inod)  = xnod(nodes,1);		        
    if (ndf_fields>0)
        Ue_fields(:,knod) = extra_nodal_fields(nodes,1:ndf_fields);
    end
end

% UPWIND EN EL CENTROIDE 
%------------------------------------------------------------------
if nen==4,
    [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),0,0);
    [dshapex,N] = shape2d(X2S,0,0,nen); 
elseif nen==3,
    [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),1/3,1/3);
    [dshapex,N] = shape2d(X2S,1/3,1/3,nen); 
else
    error(' Bad type of element , nen ~=3, nen ~=4 ')
end

Upg          = zeros(ne,ndf);
dUpg         = zeros(ne,ndf,ndm);
Upg_fields   = zeros(ne,ndf_fields);

for inod=1:nen,
    jnod = (inod-1)*ndf+(1:ndf);
    knod  = (inod-1)*ndf_fields+(1:ndf_fields);                
    Upg(:,(1:ndf))    =  Upg(:,(1:ndf)) + N(inod).*  U0e(:,jnod);
    for idm=1:ndm
        dUpg(:,(1:ndf),idm) = dUpg(:,(1:ndf),idm) + ...
            (dshapex(:,inod,idm)*ones(1,ndf)).* U0e(:,jnod);          
    end
    if (ndf_fields>0)
        Upg_fields(:,1:ndf_fields) = Upg_fields(:,1:ndf_fields) + N(inod).* Ue_fields(:,knod);
    end
end    

if tau_centroide==1,
    velpg   = Upg(:,indx_v);
    hele    = comp_hele(velpg,dshapex,Jaco,nen);
    
    strain_rate = row_transp(dUpg(:,indx_v,:));
    strain_rate = 0.5*(strain_rate + dUpg(:,indx_v,:));
    
    nu_t = (C_smag*hele).^2.*Damping_factor.*sqrt(2*row_sumall(strain_rate.^2));
    
    visco_l = visco + rho_m.*nu_t;
    rho_l = rho;
    rho_m     = compute_rho_m(Upg(:,indx_vf),rho_l,rho_g);    
    
    [tau,delta] = supg_nsi_tet(velpg,dUpg,hele,rho_m,visco_l,type_upwind);
        
    compute_P_supg;   
end

if 0
if(vslip_variable)
    % modelo de Ergun para el drag
    vslip_old = Ue_fields(:,1);
    drag_model;
    Ue_fields(:,1) = vslip_new;    
end
end

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------
for ipg=1:npg
    
    [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
    [dshapex,N] = shape2d(X2S,psipg(ipg),etapg(ipg),nen); 
    
    % Interpolacion en punto de Gauss
    %------------------------------------------------------------------
    
    Upg    = zeros(ne,ndf);
    U0pg    = zeros(ne,ndf);
    dUpg    = zeros(ne,ndf,ndm);
    radpg    = zeros(ne,1);
    
    for inod=1:nen,
        jnod = (inod-1)*ndf+(1:ndf);
        Upg(:,(1:ndf))  =  Upg(:,(1:ndf)) + N(inod).*  Ue(:,jnod);
        U0pg(:,(1:ndf)) = U0pg(:,(1:ndf)) + N(inod).* U0e(:,jnod);
        radpg(:,1)      =      radpg(:,1) + N(inod).* re(:,inod);
        for idm=1:ndm            
            dUpg(:,(1:ndf),idm)   = dUpg(:,(1:ndf),idm) + ...
                (dshapex(:,inod,idm)*ones(1,ndf)).* Ue(:,jnod);            
        end        
    end
    
    xsj =  wpg(ipg) .* Jaco;
    if axisim,
        xsj = xsj.*radpg;
    end
    
    rho_l = rho;
    rho_m_old = compute_rho_m(U0pg(:,indx_vf),rho_l,rho_g);
    rho_m     = compute_rho_m(Upg(:,indx_vf),rho_l,rho_g);
    
    u_gu = rowprod(dUpg(:,indx_v,:),U0pg(:,indx_v),ndm,ndm,1);
    div_u = zeros(ne,1);
    for idm =1:ndm
        div_u = div_u + dUpg(:,indx_v(idm),idm) ;
    end
    
    % disperse phase velocity
    Vel_d = Upg(:,indx_v);
    Vel_d(:,abs(g_dir)) = Vel_d(:,abs(g_dir)) + vslip;
    
    u_gvf = zeros(ne,1);    
    for idm=1:ndm
        u_gvf = u_gvf + dUpg(:,indx_vf,idm).*Vel_d(:,idm);
    end
    
    if 0
        % a futuro aqui calculariamos la div Vel_d cuando querramos incorporar 
        % una vslip local no uniforme
        div_Vel_d = zeros(ne,1);
    else
        div_Vel_d = div_u;
    end   
    
    strain_rate = row_transp(dUpg(:,indx_v,:));
    strain_rate = 0.5*(strain_rate + dUpg(:,indx_v,:));

%        disp(' *** NSI_TET_ELE.M ***');keyboard;pause        

    if tau_centroide==0,
        
        velpg   = Upg(:,indx_v);
        hele    = comp_hele(velpg,dshapex,Jaco,nen);
        
        nu_t = (C_smag*hele).^2.*Damping_factor.*sqrt(2*row_sumall(strain_rate.^2));        
        visco_l = visco + rho_m.*nu_t;

        [tau,delta] = supg_nsi_tet(velpg,dUpg,hele,rho_m,visco_l,type_upwind);
        
        velpg_vf = Vel_d;        
        visco_g = (rho_g*nu_t/Sct_vf); visco_g = max([visco_g';1e-12*ones(1,ne)])';
        [tau_vf,delta_vf] = supg_nsi_tet(velpg,dUpg,hele,rho_g,visco_g,type_upwind);        
    end
        
    sigma = row_scale(strain_rate,2*visco_l);
    
    terd = rowprod(dshapex,sigma,nen,ndm,ndm);
    dshapex_t = row_transp(dshapex);
    terd_m = rowprod(dshapex,dshapex_t,nen,ndm,nen);    
    
    % disperse phase    
    tol = 1e-6;
    alpha_g = Upg(:,indx_vf);
    uno = ones(1,length(alpha_g));
    alpha_g = max([alpha_g';tol*uno])';
    alpha_g = min([alpha_g';(1-tol)*uno])';
    
    % slip velocity through equilibrium with drag forces    
    
    for inod=1:nen,   
        
        if tau_centroide==0,
            compute_P_supg;
        end
        
        W_supg = P_delta;      
        for idf=1:ndm,
            W_supg(:,idf,idf)=W_supg(:,idf,idf) + N(inod);
        end
        
        W_supg_vf = P_delta_vf;      
        for idf=1:ndm,
            W_supg_vf(:,idf,idf) = W_supg_vf(:,idf,idf) + N(inod);
        end
        
        % Residual assembling        
        R_mom = (rho_m*[1,1]).*((Upg(:,indx_v)-U0pg(:,indx_v))/dt+u_gu) + ...
            reshape(dUpg(:,indx_p,:),ne,ndm,1) ;
        R_mom(:,g_dir) = R_mom(:,g_dir) - rho_m*gravity;
        
        for idm=1:ndm
            Rele(:,inod,indx_v(idm)) = Rele(:,inod,indx_v(idm)) - ( ...  
                W_supg(:,idm,idm).*R_mom(:,idm) + ...                  % momentum residual ( Galerkin + SUPG )
                terd(:,inod,idm) ...
                ).*xsj;                 
            Rele(:,inod,indx_p) = Rele(:,inod,indx_p) - ( ...                  
                P_epsilon(:,1,indx_v(idm)).*R_mom(:,idm)  ... % PSPG 
                ).*xsj; 
        end        
        
        Rele(:,inod,indx_p) = Rele(:,inod,indx_p) - ( ... 
            N(inod)*rho_m.*div_u ...                   % continuity Galerkin
            ).*xsj; 
        
        % continuity equation for disperse mass conservation
        R_disperse_mass_time = rho_g*(Upg(:,indx_vf)-U0pg(:,indx_vf))/dt ;
        
        %                keyboard;pause
        Rele(:,inod,indx_vf) = Rele(:,inod,indx_vf) - ( W_supg_vf(:,1,1).*R_disperse_mass_time + ...
            rho_g*P_delta_vf(:,1,1) .* (u_gvf + div_Vel_d.*Upg(:,indx_vf))  ...
            ).*xsj; 
        
        for idm=1:ndm
            Rele(:,inod,indx_vf) = Rele(:,inod,indx_vf) - ... 
                ( -rho_g * dshapex(:,inod,idm) .* Upg(:,indx_vf) .* Vel_d(:,idm) ...               
                ).*xsj;             
        end
        
        % shock capturing + diffusive terms for void fraction equation
        for idm=1:ndm
            Rele(:,inod,indx_vf) = Rele(:,inod,indx_vf) - ( ...  
                rho_g*(delta_vf+nu_t/Sct_vf).*dshapex(:,inod,idm).*dUpg(:,indx_vf,idm) ...
                ).*xsj;                 
        end
        
        
        % Matriz assembling
        for jnod=1:nen,        
            
            u_gN = zeros(ne,ndm);            
            for idm=1:ndm
                for jdm=1:ndm
                    u_gN(:,idm) = u_gN(:,idm) + dshapex(:,jnod,jdm).*U0pg(:,indx_v(jdm));
                end
            end            
            
            %keyboard;pause
            for idm=1:ndm
                Kele(:,inod,indx_v(idm),jnod,indx_v(idm)) = Kele(:,inod,indx_v(idm),jnod,indx_v(idm)) + ( ...  
                    W_supg(:,idm,idm).*rho_m.*N(jnod)/dt + ... % termino temporal
                    W_supg(:,idm,idm).*rho_m.*u_gN(:,idm)      + ... % termino convectivo                  
                    visco_l.*terd_m(:,inod,jnod) ... 
                    ).*xsj;  
                Kele(:,inod,indx_v(idm),jnod,indx_p) = Kele(:,inod,indx_v(idm),jnod,indx_p) + ( ...  
                    W_supg(:,idm,idm).*dshapex(:,jnod,idm) ...  % termino presion
                    ).*xsj;                     
                Kele(:,inod,indx_p,jnod,indx_v(idm)) = Kele(:,inod,indx_p,jnod,indx_v(idm)) + ( ...  
                    N(inod)*dshapex(:,jnod,idm).*rho_m + ... % termino continuidad Galerkin
                    P_epsilon(:,1,indx_v(idm)).*rho_m.*N(jnod)/dt + ... % estabilizacion continuidad temporal
                    P_epsilon(:,1,indx_v(idm)).*rho_m.*u_gN(:,idm) ... % estabilizacion continuidad convectivo
                    ).*xsj; 
                Kele(:,inod,indx_p,jnod,indx_p) = Kele(:,inod,indx_p,jnod,indx_p) + ( ...
                    P_epsilon(:,1,indx_v(idm)).*dshapex(:,jnod,idm) ...
                    ).*xsj; 
                
                for jdm=1:ndm
                    Kele(:,inod,indx_v(idm),jnod,indx_v(jdm)) = ... 
                        Kele(:,inod,indx_v(idm),jnod,indx_v(jdm)) + ( ...                      
                        visco_l.*dshapex(:,inod,jdm).*dshapex(:,jnod,idm) ...
                        ).*xsj; 
                end
                
            end
            
            Kele(:,inod,indx_vf,jnod,indx_vf) = Kele(:,inod,indx_vf,jnod,indx_vf) + ( ...  
                rho_g*W_supg_vf(:,1,1)*N(jnod)/dt  ... % termino temporal
                ).*xsj;                  
            
            for idm=1:ndm
                Kele(:,inod,indx_vf,jnod,indx_vf) = Kele(:,inod,indx_vf,jnod,indx_vf) + ( ...                  
                    -rho_g*dshapex(:,inod,idm).*Vel_d(:,idm)*N(jnod) + ...
                    rho_g*P_delta_vf(:,1,1).*Vel_d(:,idm).*dshapex(:,jnod,idm) ...
                    ).*xsj;  
            end
            
            Kele(:,inod,indx_vf,jnod,indx_vf) = Kele(:,inod,indx_vf,jnod,indx_vf) + ( ...  
                rho_g*P_delta_vf(:,1,1).*div_Vel_d.*N(jnod)  ...
                ).*xsj;                  
            
            % shock capturing and diffusive terms for void fraction equation
            for idm=1:ndm
                Kele(:,inod,indx_vf,jnod,indx_vf) = Kele(:,inod,indx_vf,jnod,indx_vf) + ( ...  
                    rho_g*(delta_vf+nu_t/Sct_vf).*dshapex(:,inod,idm).*dshapex(:,jnod,idm) ...
                    ).*xsj;                 
            end
            
        end % jnod
        
    end % inod
    
    %   disp('bubbly_2d_ele (liquid) phase ');keyboard;pause   
    
end % ipg

