function [Rele,Kele] = bcconv_bubbly(xnod,icone,U,bou_data,Rele,Kele,axisim,prop)
%
%      [Rele,Kele] = bcconv_bubbly(xnod,icone,U,bou_data,Rele,Kele,axisim,prop)
%

get_index

ijob = 'get';
handle_prop_elem;

[numnp,ndf] = size(U);
[numnp,ndm] = size(xnod);
[numel,nen] = size(icone);

if ndm==2, 
    npg = 2; 
    nen_1d = 2;    
else 
    error('bcconv-bubbly only for 2D problems '); 
end

[numel,bas] = size(icone);
[nbou,bas] = size(bou_data);

ne = nbou;

icone_bou = bou_data(:,3:4);
eles_bou  = bou_data(:,1);
face_bou  = bou_data(:,2);

[slip_data] = get_normal(xnod,icone,icone_bou,1);
norbc = slip_data(:,2:3);

if nbou>0,
   
   pgauss1d;
   
   nodog1 = icone_bou(:,1);
   nodog2 = icone_bou(:,2);
   
   % calculo de la normal  
   dxbc   = xnod(nodog2,1) - xnod(nodog1,1);
   dybc   = xnod(nodog2,2) - xnod(nodog1,2);
   lbou   = sqrt(dxbc.^2+dybc.^2);
   norbc  = [dybc./lbou, -dxbc./lbou];
   % det Jacobiano transformacion al master
   Jaco   = lbou/2;
   
   ceros = zeros(nbou,nen_1d*ndf);
   Ue = ceros;
   re = zeros(nbou,nen_1d);
   
   for inod=1:nen_1d,
       nodes  = icone_bou(:,inod);
       jnod   = (inod-1)*ndf+(1:ndf);
       Ue(:,jnod)  = U(nodes,1:ndf);		 
       re(:,inod)  = xnod(nodes,1);		        
   end

   Fan = zeros(nbou,ndf);
   
   for ipg=1:npg,
      
      N = ones(nbou,1)*[(1-psipg(ipg))/2 , (1+psipg(ipg))/2 ];
      
      % Localizacion , scatter   
      Upg      = zeros(nbou,ndf);
      radpg    = zeros(nbou,1);
      velpg    = zeros(nbou,ndm);
      
      for inod=1:2,    
          radpg  = radpg +  N(:,inod).*re(:,inod);
          Upg    =   Upg + (N(:,inod)*ones(1,ndf)).*Ue(:,(inod-1)*ndf+(1:ndf));
      end             
      
      vslip_new = vslip;
      if 1
          if(vslip_variable)              
              % modelo de Ergun para el drag
              % keyboard;pause
              dUpg = extrapolate_grad_boundary(xnod,icone,U,bou_data(:,1:2),ipg);              
              vslip_old = vslip*ones(nbou,1);              
              drag_model;
          end
      end
      
      velpg  = Upg(:,indx_v);
      velpg(:,abs(g_dir)) = velpg(:,abs(g_dir)) + vslip_new;
      
      vn     =  sum((velpg.*norbc)')';
      
      % convective term for disperse phase continuity equation
      Fan(:,indx_vf)    =  rho_g*Upg(:,indx_vf).*vn;

      % extra term in the mixture momentum equation (weak form)
      Fan(:,indx_v(abs(g_dir)))  =  rho_g*vslip_new.*vslip_new.*Upg(:,indx_vf).*norbc(:,abs(g_dir));
      
      xsj = wpg(ipg)*Jaco;
      if axisim,
         xsj = xsj.*radpg;
      end
                 
      for iface=1:nen,
          eles = find(face_bou==iface);    
         if isempty(eles)==0,
            for inod=1:2,
               jnod = iface-1+inod;
               if(jnod>nen),jnod=1; end 
               vaux  =  (N(eles,inod).*xsj(eles)*ones(1,ndf)).*Fan(eles,:);
               Rele(eles_bou(eles),jnod,:) = Rele(eles_bou(eles),jnod,:) - reshape(vaux,length(eles),1,ndf);          
               for iinod=1:2, 
                  jjnod = iface-1+iinod;
                  if(jjnod>nen),jjnod=1; end           
                  vaux  =  rho_g*(N(eles,inod).*xsj(eles)).*vn(eles,1).*N(eles,iinod);         
                  Kele(eles_bou(eles),jnod,indx_vf,jjnod,indx_vf) = Kele(eles_bou(eles),jnod,indx_vf,jjnod,indx_vf)+ vaux;           
               end % for iinod
            end  % for inod
         end % if isempty
      end % for iface
   end % puntos de Gauss del contorno
   
end % if bou

%disp(' BC_CONV_EULER ');keyboard;pause
