function [h_supg] = compute_h_supg(vel,dshapex,velmod,h_pspg)
%
%  [h_supg] = compute_h_supg(vel,dshapex,velmod,h_pspg)
%

[ne,nen,ndm] = size(dshapex);
tol=1.0e-16 ;

%svec = vel./(velmod*[1,1]);
svec = vel./(max([velmod';tol*ones(1,ne)])'*[1,1]);
vaux = rowprod(dshapex,svec,nen,ndm,1);
vaux = row_sumall(abs(vaux));
h_supg = vaux.*(vaux>tol)+tol*(vaux<=tol);
h_supg = 2 ./ h_supg;

h_supg = (velmod>tol).*h_supg+(velmod<=tol).*h_pspg;
