function dUpg = extrapolate_grad_boundary(xnod,icone,U,ifaceb,ipg)
%
%  dUpg = extrapolate_grad_boundary(xnod,icone,U,ifaceb)
%

npg = 2;
pgauss1d;
ndm = 2;

% Localizacion de las variables
%------------------------------------------------------------------
[numel,nen]=size(icone);
[numnp,ndf]=size(U);

ceros = zeros(numel,nen*ndf);
Ue = ceros;
for inod=1:nen,
    nodes  = icone(:,inod);
    jnod  = (inod-1)*ndf+(1:ndf);
    Ue(:,jnod)  = U(nodes,1:ndf);		 
end

Nfaces = max(ifaceb(:,2));

psipg_v = [psipg ; ones(1,2) ; psipg([2,1]); -ones(1,2)];
etapg_v = [-ones(1,2) ; psipg; ones(1,2) ; psipg([2,1])];

ne = length(ifaceb(:,1));

Upg    = zeros(ne,ndf);
dUpg    = zeros(ne,ndf,ndm);

for iface=1:Nfaces
    
    kface = find(ifaceb(:,2)==iface);
    
    if isempty(kface)==0,
        
        eles = ifaceb(kface,1);
        psi = psipg_v(iface,ipg);
        eta = etapg_v(iface,ipg);
        
        [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psi,eta);
        [dshapex,N] = shape2d(X2S,psi,eta,nen); 
        
        % Interpolacion en punto de Gauss
        %------------------------------------------------------------------
        
        for inod=1:nen,
            jnod = (inod-1)*ndf+(1:ndf);
            Upg(kface,(1:ndf))  =  Upg(kface,(1:ndf)) + N(inod).*  Ue(eles,jnod);
            for idm=1:ndm            
                dUpg(kface,(1:ndf),idm)   = dUpg(kface,(1:ndf),idm) + ...
                    (dshapex(:,inod,idm)*ones(1,ndf)).* Ue(eles,jnod);            
            end        
        end
        
    end
end

    
