% ====================================================================
%
%                      FCC A 2D : a simple model 
%
%                      ASM model
% ====================================================================

ref = 1;

vslip_variable = 0;

read_from_file = 1;
filestate_to_read = 'fccA-simple_4';

filestate = 'fccA-simple';

nnwt = 3;

shocap                = 0;
weak_form             = 1; 
reverse_normal        = 0;

Cou   =  1;
npg   =  4;
ndf   =  4;
tol   = 1e-6;

% PHYSICAL DATA
gravity    = -9.8;
Rey        =  400;
rho        =  1.0;
vinlet     =  1;
visco      =  1e-5;
axisim     = 0;
tau_factor = 1;

nphases    = 1;
g_dir      = 2;
vslip      = -0.1;
nu_vf      = 1e-5;
Sct_vf     = 1;
visco_g    = 1e-3;
rho_g      = 1377;
dp         = 1e-3;

% BOUNDARY CONDITIONS
p_ref      = 0;
v_wall     = [0,0];
vf_ref     = 0.45;

% INITIAL VALUES
p_ini      = p_ref;
vel_ini    = [0,-vinlet];
vf_ini     = vf_ref;

v_air_inj = 0.1;

% genera malla
gen_mesh_tee_bubbly;

% convertimos cuadrangulos en triangulos
quad2tri=0;
if quad2tri, quad_to_tri; end

[numnp,ndm] = size(xnod);
[numel,nen] = size(icone);
xmax = max(xnod);
xmin = min(xnod);

get_index

%-------- Solucion inicial (PHI)
if read_from_file==1,
    eval(['load ' filestate_to_read '.mat']);
    U = phi;
else
    uini    = [p_ini,vel_ini,vf_ini];
    U       =  ones(numnp,1)*uini;       
    rho_l   = rho;
    rho_m   = compute_rho_m(U(:,indx_vf),rho_l,rho_g);
    U(:,indx_p) = abs(gravity)*rho_m.*(xmax(2)-xnod(:,2));
    p_ref = abs(gravity)*rho_m(nodes_OUT(1)).*(xmax(2)-xnod(nodes_OUT(1),2));
end


%-------- fijaciones (FIXA)

fixa= zeros(numnp,ndf);
fixa(nodes_wall,indx_v)   = ones(length(nodes_wall),ndm);
fixa(nodes_IN  ,indx_v)   = ones(length(nodes_IN),ndm);
fixa(nodes_OUT ,indx_p)   = 1;
fixa(nodes_IN  ,indx_vf)  = 1;

%fixa(:,indx_vf) = 1;

%-------- Cargas/Desplazamientos nodales(FORC)
forc                       = zeros(numnp,ndf);
forc(nodes_OUT ,indx_p)    = p_ref;
forc(nodes_IN_1,indx_v(2)) = -vinlet;
forc(nodes_IN_2,indx_v(1)) = -v_air_inj;
forc(nodes_IN_1,indx_vf)   = vf_ref;
forc(nodes_IN_2,indx_vf)   = 0.0;
forc(nodes_wall,indx_v)    = ones(length(nodes_wall),1)*v_wall;

%forc(:,indx_vf) = vf_ref;

%-------- Propiedades del material
ijob = 'set';
handle_prop_elem;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas y deslizamiento AHORA como linear constraints
lin_con = [];
if 0
    if slip_wall_d
        nn=find(abs(nor_wall(:,2).*nor_wall(:,3))~=0);        
        if isempty(nn)==0;
            NN = length(nn);
            lin_con = [lin_con ; ... 
                    [nor_wall(nn,2) nor_wall(nn,1) indx_v_d(1)*ones(NN,1)  nor_wall(nn,3) nor_wall(nn,1) indx_v_d(2)*ones(NN,1)  ] ];
        end
    end
end

% condicion inicial en primitivas
%-----------------------------------------------
if 1,
    bini   = U;
    for k=1:ndf,
        nofree        = find(fixa(:,k)~=0);
        bini(nofree,k)   = forc(nofree,k);
    end   
end

bc_time_flag = 0;
bc_time_t_end = 100000;

hc_gas = [];