%
%  generate a tee mesh
%

% caso axi
Lx1 = 1;
Ly1 = 6;
Ly2 = 0.2;
Ly3 = 3;
Ly4 = 0.2;
Ly5 = 3;

Nx1 = 15;
Ny1 = 30;
Ny2 = 10;
Ny3 = 15;    
Ny4 = 10;
Ny5 = 15;    

Lt = Ly2+Ly3+Ly4+Ly5;

psi = (0:Nx1)'/Nx1; 
x1 = (1-(1-psi).^2)*Lx1;
x1 = [x1,0*x1];
psi = (0:Ny1)'/Ny1; 
y1 = psi.^1.5*Ly1; 
y1 = [0*y1,Lt+y1];
[xnod_1,icone_1] = qq3d(x1,y1);

xnod  = xnod_1;
icone = icone_1;

Lt = Lt-Ly2;
y2 = (0:Ny2)'/Ny2*Ly2; 
y2 = [0*y2,Lt+y2];
[xnod_2,icone_2] = qq3d(x1,y2);

icone = [icone; size(xnod,1)+icone_2];
xnod  = [xnod;xnod_2];

Lt = Lt-Ly3;
psi = (0:Ny3)'/Ny3;
y3 = (1-psi.^1.5)*Ly3;
y3 = sin(psi*pi/2).^2*Ly3;
y3 = [0*y3,Lt+y3];
[xnod_3,icone_3] = qq3d(x1,y3);

icone = [icone; size(xnod,1)+icone_3];
xnod  = [xnod;xnod_3];

Lt = Lt-Ly4;
y4 = (0:Ny4)'/Ny4*Ly4; 
y4 = [0*y4,Lt+y4];
[xnod_4,icone_4] = qq3d(x1,y4);

icone = [icone; size(xnod,1)+icone_4];
xnod  = [xnod;xnod_4];

Lt = Lt-Ly5;
psi = (0:Ny5)'/Ny5;
y5 = (1-psi.^1.5)*Ly5; 
y5 = [0*y5,Lt+y5];
[xnod_5,icone_5] = qq3d(x1,y5);

icone = [icone; size(xnod,1)+icone_5];
xnod  = [xnod;xnod_5];

tol = 1e-3;
[xnod,icone,imap] = sew_mesh(xnod,icone,tol);

if 0  % see posdat.m
    [iconew] = check_mesh_orientation(xnod,icone);
    icone = iconew;
end

%figure(1);clf;pltmsh(xnod_1,icone_1);hold on;pltmsh(xnod_2,icone_2);hold on;;pltmsh(xnod_3,icone_3);hold on;;pltmsh(xnod_4,icone_4);
figure(1);clf;pltmsh(xnod,icone);

tol = 1e-6;
xmax = max(xnod);
xmin = min(xnod);

%-------- fijaciones (FIXA)
nodes_IN_1  = find(abs(xnod(:,2)-xmax(2))<tol);

Linf = Ly5+Ly4+Ly3;
Lsup = Ly5+Ly4+Ly3+Ly2;
nodes_IN_2  = find((xnod(:,2)>Linf)&(xnod(:,2)<Lsup)&(abs(xnod(:,1)-Lx1)<tol));

Linf = Ly5;
Lsup = Ly5+Ly4;
nodes_IN_3  = find((xnod(:,2)>Linf)&(xnod(:,2)<Lsup)&(abs(xnod(:,1)-Lx1)<tol));

nodes_OUT  = find(abs(xnod(:,2)-xmin(2))<tol);

[bas,bou] = pfbou2d(xnod,icone,1);
nodes_bou = rmdblist(m2v(bou));

nodes = [nodes_IN_1;nodes_IN_2;nodes_IN_3;nodes_OUT];

if axisim
    nodes_sym = find(abs(xnod(:,1))<tol);
    nodes = [nodes;nodes_sym];
else
    nodes_sym = [];
end

nodes_wall = complement(nodes_bou,nodes);

[bas,ibas] = sort(xnod(nodes_OUT,1));
nodes_OUT = nodes_OUT(ibas);

[bas,ibas] = sort(xnod(nodes_IN_1,1));
nodes_IN_1 = nodes_IN_1(ibas);

[bas,ibas] = sort(xnod(nodes_IN_2,2));
nodes_IN_2 = nodes_IN_2(ibas);

[bas,ibas] = sort(xnod(nodes_IN_3,2));
nodes_IN_3 = nodes_IN_3(ibas);

if 1
if axisim==0
    nodes_wall = [nodes_wall;nodes_OUT([1,end])];
else
    nodes_wall = [nodes_wall;nodes_OUT(end)];
end
end

figure(1);hold on;plot(xnod(nodes_wall,1),xnod(nodes_wall,2),'ro')

nodes_IN  = [nodes_IN_1;nodes_IN_2;nodes_IN_3];