%
%  generate a tee mesh
%

if 0
    % caso 2D
    Lx1 = 1;
    Lx2 = 1;
    Ly1 = 4;
    Ly2 = 1;
    Ly3 = 8;
    
    Nx1 = 10;
    Ny1 = 40;
    Ny2 = 10;
    Nx2 = 10;
    Ny3 = 80;
else
    % caso axi
    Lx1 = 1;
    Lx2 = 1;
    Ly1 = 6;
    Ly2 = 0.25;
    Ly3 = 6;
    
    Nx1 = 15;
    Ny1 = 35;
    Ny2 = 12;
    Nx2 = 15;
    Ny3 = 35;    
end

x1 = (0:Nx1)'/Nx1*Lx1; x1 = [x1,0*x1];
psi = (0:Ny1)'/Ny1; 
y1 = psi.^1.5*Ly1; 
y1 = [0*y1,Ly3+Ly2+y1];
[xnod_1,icone_1] = qq3d(x1,y1);

xnod  = xnod_1;
icone = icone_1;

y2 = (0:Ny2)'/Ny2*Ly2; y2 = [0*y2,Ly3+y2];
[xnod_2,icone_2] = qq3d(x1,y2);

icone = [icone; size(xnod,1)+icone_2];
xnod  = [xnod;xnod_2];

x2 = (0:Nx2)'/Nx2*Lx2; x2 = [Lx1+x2,0*x2];
[xnod_3,icone_3] = qq3d(x2,y2);

icone = [icone; size(xnod,1)+icone_3];
xnod  = [xnod;xnod_3];

psi = (0:Ny3)'/Ny3;
y3 = (1-psi.^1.5)*Ly3; 
y3 = [0*y3,y3];
[xnod_4,icone_4] = qq3d(x1,y3);

icone = [icone; size(xnod,1)+icone_4];
xnod  = [xnod;xnod_4];

tol = 1e-3;
[xnod,icone,imap] = sew_mesh(xnod,icone,tol);

if 0  % see posdat.m
[iconew] = check_mesh_orientation(xnod,icone);
icone = iconew;
end

%figure(1);clf;pltmsh(xnod_1,icone_1);hold on;pltmsh(xnod_2,icone_2);hold on;;pltmsh(xnod_3,icone_3);hold on;;pltmsh(xnod_4,icone_4);
figure(1);clf;pltmsh(xnod,icone);

tol = 1e-6;
xmax = max(xnod);
xmin = min(xnod);

%-------- fijaciones (FIXA)
nodes_IN_1  = find(abs(xnod(:,2)-xmax(2))<tol);
nodes_IN_2  = find(abs(xnod(:,1)-xmax(1))<tol);
nodes_OUT  = find(abs(xnod(:,2)-xmin(2))<tol);

[bas,bou] = pfbou2d(xnod,icone,1);
nodes_bou = rmdblist(m2v(bou));

nodes = [nodes_IN_1;nodes_IN_2;nodes_OUT];

if axisim
    nodes_sym = find(abs(xnod(:,1))<tol);
    nodes = [nodes;nodes_sym];
else
    nodes_sym = [];
end

nodes_wall = complement(nodes_bou,nodes);

[bas,ibas] = sort(xnod(nodes_OUT,1));
nodes_OUT = nodes_OUT(ibas);

[bas,ibas] = sort(xnod(nodes_IN_1,1));
nodes_IN_1 = nodes_IN_1(ibas);

[bas,ibas] = sort(xnod(nodes_IN_2,2));
nodes_IN_2 = nodes_IN_2(ibas);

if axisim==0
    nodes_wall = [nodes_wall;nodes_OUT([1,end]);nodes_IN_1([1,end]);nodes_IN_2([1,end])];
else
    nodes_wall = [nodes_wall;nodes_OUT(end);nodes_IN_1(end);nodes_IN_2([1,end])];
end

figure(1);hold on;plot(xnod(nodes_wall,1),xnod(nodes_wall,2),'ro')

nodes_IN  = [nodes_IN_1;nodes_IN_2];