
% Calculos del elemento propiamente dichos
%------------------------------------------------------------------

ne    = length(eles);

% Localizacion
%------------------------------------------------------------------

ceros = zeros(ne,nen*ndf);
Ue = ceros;
U0e = ceros;
re = zeros(ne,nen);

for inod=1:nen,
    nodes         = icone(eles,inod);
    jnod          = (inod-1)*ndf+(1:ndf);
    Ue(:,jnod)    = U(nodes,1:ndf); 
    U0e(:,jnod)   = Uold(nodes,1:ndf);     
    radio(:,inod) = xnod(nodes,1);
end

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------

for ipg=1:npg
    
    [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
    [dshapex,N] = shape2d(X2S,psipg(ipg),etapg(ipg),nen); 
    
    % Interpolacion en punto de Gauss
    %------------------------------------------------------------------
    radpg    = zeros(ne,1);
    Upg     = zeros(ne,ndf);
    dUpg    = zeros(ne,ndf,ndm);
    dU0pg   = zeros(ne,ndf,ndm);
    
    for inod=1:nen,
        jnod = (inod-1)*ndf+(1:ndf);
        Upg(:,(1:ndf))  =  Upg(:,(1:ndf)) + N(inod).*  Ue(:,jnod);
        radpg(:,1)  =   radpg(:,1) +      N(inod).* radio(:,inod);                
        for idm=1:ndm            
            dUpg(:,(1:ndf),idm)   = dUpg(:,(1:ndf),idm) + ...
                (dshapex(:,inod,idm)*ones(1,ndf)).* Ue(:,jnod);            
            dU0pg(:,(1:ndf),idm)   = dU0pg(:,(1:ndf),idm) + ...
                (dshapex(:,inod,idm)*ones(1,ndf)).* U0e(:,jnod);                        
        end        
    end
    
    % Correccion axisimetrica del jacobiano de la transformacion al elemento master
    %------------------------------------------------------------------
    xsj =  wpg(ipg) .* Jaco;
    if axisim,
        xsj = xsj.*radpg;
    end
    
    % Definition of the diffusion tensor : based on the transformation
    % metrics
    g11 = dU0pg(:,1,1).^2+dU0pg(:,2,1).^2;
    g22 = dU0pg(:,1,2).^2+dU0pg(:,2,2).^2;    
    h_eta = sqrt(g22);
    h_psi = sqrt(g11);
    ff = h_eta ./ h_psi;
    N = g22;
    D = g11;
    
    Kappa_pg(:,1) = ff ; % ratio of the scale factor metrics
    Kappa_pg(:,2) = 1 ./ ff ; % ratio of the scale factor metrics
    Kappa_pg(:,1) = 0*ff+1;
    Kappa_pg(:,2) = 0*ff+1;
    
    if 0
        [ff_nod]=ele_field_to_nod_field(xnod,icone,ff);
        figure(3);clf;view2d(xnod,icone,log10(ff_nod));colorbar,pause
    end
    
    % Calculo matriz tangente y residuo
    %--------------------------------------------------------------------
    for inod=1:nen,
        for jnod=1:nen,
            
            if 0
                dNdu = 2*dUpg(:,1,2).*dshapex(:,jnod,2);
                dNdv = 2*dUpg(:,2,2).*dshapex(:,jnod,2);
                dDdu = 2*dUpg(:,1,1).*dshapex(:,jnod,1);
                dDdv = 2*dUpg(:,2,1).*dshapex(:,jnod,1);
                dfdu = 0.5*(1 ./ ff).*(dNdu.*D-N.*dDdu) ./ (D.^2);
                dfdv = 0.5*(1 ./ ff).*(dNdv.*D-N.*dDdv) ./ (D.^2);    
            end
            
            Kele(:,inod,1,jnod,1) = Kele(:,inod,1,jnod,1) + ( ...  
                Kappa_pg(:,1).*dshapex(:,inod,1).*dshapex(:,jnod,1) +  ...
                Kappa_pg(:,2).*dshapex(:,inod,2).*dshapex(:,jnod,2) ).*xsj; 
            
            Kele(:,inod,2,jnod,2) = Kele(:,inod,2,jnod,2) + ( ...                                          
                Kappa_pg(:,1).*dshapex(:,inod,1).*dshapex(:,jnod,1) +  ...
                Kappa_pg(:,2).*dshapex(:,inod,2).*dshapex(:,jnod,2) ).*xsj; 
            
            if 0,
                % agregado termino derivada de la difusividad
                Kele(:,inod,1,jnod,1) = Kele(:,inod,1,jnod,1) + ( ...  
                    dshapex(:,inod,1).*dUpg(:,1,1).*dfdu + ...
                    1*dshapex(:,inod,2).*dUpg(:,1,2).*(-1 ./ (ff.^2)).*dfdu ).*xsj; 
                
                Kele(:,inod,2,jnod,2) = Kele(:,inod,2,jnod,2) + ( ...  
                    dshapex(:,inod,1).*dUpg(:,2,1).*dfdv + ...
                    1*dshapex(:,inod,2).*dUpg(:,2,2).*(-1 ./ (ff.^2)).*dfdv ).*xsj; 
                
                if 1,
                    Kele(:,inod,1,jnod,2) = Kele(:,inod,1,jnod,2) + ( ...  
                        dshapex(:,inod,1).*dUpg(:,1,1).*dfdv + ...
                        1*dshapex(:,inod,2).*dUpg(:,1,2).*(-1 ./ (ff.^2)).*dfdv ).*xsj; 
                    
                    Kele(:,inod,2,jnod,1) = Kele(:,inod,2,jnod,1) + ( ...  
                        dshapex(:,inod,1).*dUpg(:,2,1).*dfdu + ...
                        1*dshapex(:,inod,2).*dUpg(:,2,2).*(-1 ./ (ff.^2)).*dfdu ).*xsj; 
                end
                
            end
            
        end  % jnod            
        
        ter1 = (dshapex(:,inod,1).* Kappa_pg(:,1).*dUpg(:,1,1) + ...
            dshapex(:,inod,2).* Kappa_pg(:,2).*dUpg(:,1,2)) ;
        
        ter2 = (dshapex(:,inod,1).* Kappa_pg(:,1).*dUpg(:,2,1) + ...
            dshapex(:,inod,2).* Kappa_pg(:,2).*dUpg(:,2,2)) ;
        
        Rele(eles,inod,1) = Rele(eles,inod,1) - ter1 .* xsj;
        Rele(eles,inod,2) = Rele(eles,inod,2) - ter2 .* xsj;        
        
    end % inod    
end % ipg
