%
%   Ejemplo 01 : ejemplo para empezar (algo medio trivial)
%

Nx       = 21;Lx=1;  
Ny       = 21;Ly=1;  
psi      = (0:Nx-1)'/(Nx-1);
x        = psi*Lx;
eta      = (0:Ny-1)'/(Ny-1); 
y        = eta*Ly;

%-------- coordenadas (XNOD)
xnod     =[];
for k=1:Ny,
   xnod=[xnod;[x ones(Nx,1)*y(k)]];
end

%-------- conectividades (ICONE)
icone    =[];
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
ico2= [ (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' (1:Nx-1)'];
for k=1:Ny-1,
   icone=[icone; (k-1)*Nx+ico ];
end

% convertimos cuadrangulos en triangulos
quad2tri=0;

if quad2tri, quad_to_tri; end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 2;
nodes_bot  = (1:Nx)';
nodes_top  = Nx*(Ny-1)+(1:Nx)';
nodes_lef  = (1:Nx:Nx*Ny)';
nodes_rig  = (Nx:Nx:Nx*Ny)';
fixa= zeros(numnp,ndf);
forc = zeros(numnp,ndf);

nodes = [nodes_top,nodes_lef,nodes_rig,nodes_bot];
fixa(nodes,1:2) = 1;

Hx = 2;
Hy = 5;
ymin = -2;
xmin = 0;
forc(nodes_lef,1)=xmin;
forc(nodes_rig,1)=xmin+Hx;
forc(nodes_bot,2)=ymin;
forc(nodes_top,2)=ymin+Hy;

y = xnod(nodes_lef,2);
forc(nodes_lef,2)=(y-min(y))/(max(y)-min(y))*Hy+ymin;
y = xnod(nodes_rig,2);
forc(nodes_rig,2)=(y-min(y))/(max(y)-min(y))*Hy+ymin;

nodes = nodes_bot;
x = xnod(nodes,1);
forc(nodes,1)=(x-min(y))/(max(x)-min(x))*Hx+xmin;
nodes = nodes_top;
x = xnod(nodes,1);
forc(nodes,1)=(x-min(x))/(max(x)-min(x))*Hx+xmin;

if 0,
fixa(:,2)=1;
forc(:,2)=xnod(:,2);
end

% source terms
source = 0*ones(numel,ndf);

%--------- Termino reactivo -----------------------------
reac = 0*ones(numel,ndf);

%--------- Campo de Velocidad -----------------------------
veloc  =  ones(numnp,1)*zeros(1,ndm);

%-------- Propiedades del material
rho     = 1    ;
Cp      = 1    ;
kappa   = 1e-03;
npg     =  2   ;
prop(1) =rho   ;
prop(2) =Cp    ;
prop(3) =kappa ;
prop(4) =npg   ;
axisim  = 0;
prop(8)  = axisim ;
coef = 0;  % coeficiente que pesa los terminos del jacobiano que se agregan por la nolinealidad
           % del tensor de difusion. Al principio conviene ponerlo en 0
           % hasta entrar en el radio de convergencia. Ir subiendolo
           % despacio hasta 1.
prop(9)  = coef;
explicit = 1; % si 1 entonces evalua el tensor de difusion en el paso de tiempo anterior. 
              % Es como un cuasi-newton. Si 0, evalua el tensor acorde al
              % estado corriente.
prop(10) = explicit;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas
lin_con = [];

%-------- Solucion inicial (PHI)
bini = xnod;
for k=1:ndf,
%   bini(:,k)   = forc(:,k);
   nofree        = find(fixa(:,k)~=0);
   bini(nofree,k)= forc(nofree,k);
end

adre = 0;
filename = 'adre_advdif_01'

