%
%   Ejemplo 03 : C grid around a circle
%

Ej_03_ap;
Nx = 2*(N_AB-1)+ N_BBp;
Ny = N_AC;
Lx=1;  
Ly=1;  

if 0,
    xc = [0 N_AB (N_AB+N_BBp/2) (N_AB+N_BBp) (2*N_AB+N_BBp)]/Nx;
    hc = [0 5 1 1 5 ];
    [x] = gen_hele(xc,hc,Nx)*Lx;
    
    yc = [0 N_AC/2 N_AC];
    hc = [0 1 5 ];
    [y] = gen_hele(yc,hc,Ny)*Ly;
else
    psi      = (0:Nx-1)'/(Nx-1);
    x        = psi*Lx;
    eta      = (0:Ny-1)'/(Ny-1); 
    y        = eta*Ly;
end

Nx = size(x,1);
Ny = size(y,1);

%-------- coordenadas (XNOD)
xnod     =[];
for k=1:Ny,
    xnod=[xnod;[x ones(Nx,1)*y(k)]];
end

%-------- conectividades (ICONE)
icone    =[];
ico = [ (1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)'];
ico2= [ (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' (1:Nx-1)'];
for k=1:Ny-1,
    icone=[icone; (k-1)*Nx+ico ];
end

% convertimos cuadrangulos en triangulos
quad2tri=0;

if quad2tri, quad_to_tri; end

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 2;
nodes_bot  = (1:Nx)';
nodes_top  = Nx*(Ny-1)+(1:Nx)';
nodes_lef  = (1:Nx:Nx*Ny)';
nodes_rig  = (Nx:Nx:Nx*Ny)';
fixa= zeros(numnp,ndf);
forc = zeros(numnp,ndf);

fixa(nodes_lef,1:2)=1;
forc(nodes_lef,1:2)=X_CA(N_AC:-1:1,:);
fixa(nodes_rig,1:2)=1;
forc(nodes_rig,1:2)=X_ApD;

fixa(nodes_bot,1:2)=1;
forc(nodes_bot,1:2)=[X_AB(1:end-1,:);X_BBp;X_BpAp(2:end,:)];

nodes_top_EC = nodes_top(1:N_CE-1);
fixa(nodes_top_EC,2)=1;
forc(nodes_top_EC,2)=rot90(rot90(X_EC(1:N_CE-1,2)));

nodes_top_EF = nodes_top(N_CE-1+(1:N_EF));
fixa(nodes_top_EF,1)=1;
forc(nodes_top_EF,1)=rot90(rot90(X_FE(:,1)));
fixa(nodes_top_EF([1,end]),2)=1;
forc(nodes_top_EF([1,end]),2)=rot90(rot90(X_FE([1,end],2)));

nodes_top_FD = nodes_top(N_CE-1+N_EF+(1:N_FD-1));
fixa(nodes_top_FD,2)=1;
forc(nodes_top_FD,2)=rot90(rot90(X_DF(1:N_FD-1,2)));


% source terms
source = 0*ones(numel,ndf);

%--------- Termino reactivo -----------------------------
reac = 0*ones(numel,ndf);

%--------- Campo de Velocidad -----------------------------
veloc  =  ones(numnp,1)*zeros(1,ndm);

%-------- Propiedades del material
rho     = 1    ;
Cp      = 1    ;
kappa   = 1e-03;
npg     =  2   ;
prop(1) =rho   ;
prop(2) =Cp    ;
prop(3) =kappa ;
prop(4) =npg   ;
axisim  = 0;
initial_guess = 1;
prop(7) = initial_guess;
prop(8)  = axisim ;
coef = 0;  % coeficiente que pesa los terminos del jacobiano que se agregan por la nolinealidad
% del tensor de difusion. Al principio conviene ponerlo en 0
% hasta entrar en el radio de convergencia. Ir subiendolo
% despacio hasta 1.
prop(9)  = coef;
explicit = 1; % si 1 entonces evalua el tensor de difusion en el paso de tiempo anterior. 
% Es como un cuasi-newton. Si 0, evalua el tensor acorde al
% estado corriente.
prop(10) = explicit;

%-------- Cargas repartidas (STRG)
strg    = [];

%-------- Condiciones de contorno mixtas (TECO)
teco     = [];

%-------- Condiciones periodicas
lin_con = [];

%-------- Solucion inicial (PHI)
bini(:,1) = 0*xnod(:,1);
for k=1:ndf,
    %   bini(:,k)   = forc(:,k);
    nofree        = find(fixa(:,k)~=0);
    bini(nofree,k)= forc(nofree,k);
end

adre = 0;
filename = 'adre_advdif_01'

