global ff_min ff_max

% Calculos del elemento propiamente dichos
%------------------------------------------------------------------

ne    = length(eles);

% Localizacion
%------------------------------------------------------------------

ceros = zeros(ne,nen*ndf);
Ue = ceros;
U0e = ceros;
re = zeros(ne,nen);

for inod=1:nen,
    nodes         = icone(eles,inod);
    jnod          = (inod-1)*ndf+(1:ndf);
    Ue(:,jnod)    = U(nodes,1:ndf); 
    U0e(:,jnod)   = Uold(nodes,1:ndf);     
    radio(:,inod) = xnod(nodes,1);
end

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------

for ipg=1:npg
    
    [X2S,S2X,Jaco] = xy2st(xnod,icone(eles,:),psipg(ipg),etapg(ipg));
    [dshapex,N] = shape2d(X2S,psipg(ipg),etapg(ipg),nen); 
    
    % Interpolacion en punto de Gauss
    %------------------------------------------------------------------
    radpg    = zeros(ne,1);
    Upg     = zeros(ne,ndf);
    dUpg    = zeros(ne,ndf,ndm);
    dU0pg   = zeros(ne,ndf,ndm);
    
    for inod=1:nen,
        jnod = (inod-1)*ndf+(1:ndf);
        Upg(:,(1:ndf))  =  Upg(:,(1:ndf)) + N(inod).*  Ue(:,jnod);
        radpg(:,1)  =   radpg(:,1) +      N(inod).* radio(:,inod);                
        for idm=1:ndm            
            dUpg(:,(1:ndf),idm)   = dUpg(:,(1:ndf),idm) + ...
                (dshapex(:,inod,idm)*ones(1,ndf)).* Ue(:,jnod);                        
            dU0pg(:,(1:ndf),idm)   = dU0pg(:,(1:ndf),idm) + ...
                (dshapex(:,inod,idm)*ones(1,ndf)).* U0e(:,jnod);                        
        end        
    end
    
    % Correccion axisimetrica del jacobiano de la transformacion al elemento master
    %------------------------------------------------------------------
    xsj =  wpg(ipg) .* Jaco;
    if axisim,
        xsj = xsj.*radpg;
    end
    
    % Definition of the diffusion tensor : based on the transformation
    % metrics
    if explicit,
        g11 = dU0pg(:,1,1).^2+dU0pg(:,2,1).^2;
        g22 = dU0pg(:,1,2).^2+dU0pg(:,2,2).^2;            
    else
        g11 = dUpg(:,1,1).^2+dUpg(:,2,1).^2;
        g22 = dUpg(:,1,2).^2+dUpg(:,2,2).^2;    
    end
    h_eta = sqrt(g22);
    h_psi = sqrt(g11);
    ff = h_eta ./ h_psi;
    
    ff_thres = 1e-4;
    delta = ff_thres;
    hff = 0.5*((ff-ff_thres)+sqrt((ff-ff_thres).^2+4*delta));
    ff = hff;
    
    gg = 1 ./ ff;
    hff = 0.5*((gg-ff_thres)+sqrt((gg-ff_thres).^2+4*delta));
    ff = 1 ./ hff;    
    
    if ipg==1, ff_min = min(ff); ff_max = max(ff); end
    
    if initial_guess
        Kappa_pg(:,1) = ones(size(ff)) ; % ratio of the scale factor metrics
        Kappa_pg(:,2) = Kappa_pg(:,1) ;  
    else
        Kappa_pg(:,1) = ff ; % ratio of the scale factor metrics
        Kappa_pg(:,2) = 1 ./ ff ; % ratio of the scale factor metrics
    end
    
    if 0 & (ipg==1),
        [ff_nod]=ele_field_to_nod_field(xnod,icone,ff);
        figure(3);clf;view2d(xnod,icone,ff_nod);colorbar,title(' ff ')
        keyboard;pause
    end
    
    % Calculo matriz tangente y residuo
    %--------------------------------------------------------------------
    for inod=1:nen,
        for jnod=1:nen,
            
            if 0,
                N = g22;
                D = g11;                
                dNdu = 2*dUpg(:,1,2).*dshapex(:,jnod,2);
                dNdv = 2*dUpg(:,2,2).*dshapex(:,jnod,2);
                dDdu = 2*dUpg(:,1,1).*dshapex(:,jnod,1);
                dDdv = 2*dUpg(:,2,1).*dshapex(:,jnod,1);
                dfdu = 0.5*(1 ./ ff).*(dNdu.*D-N.*dDdu) ./ (D.^2);
                dfdv = 0.5*(1 ./ ff).*(dNdv.*D-N.*dDdv) ./ (D.^2);    
                
            else
                N = g22;
                D = g11;                
                dNdu = 2*dUpg(:,1,2);
                dNdv = 2*dUpg(:,2,2);
                dDdu = 2*dUpg(:,1,1);
                dDdv = 2*dUpg(:,2,1);
                
                %                dfdu = 0.5*(1 ./ ff).*(dNdu.*D.*dshapex(:,jnod,2) - N.*dDdu.*dshapex(:,jnod,1)) ./ (D.^2);
                %                dfdv = 0.5*(1 ./ ff).*(dNdv.*D.*dshapex(:,jnod,2) - N.*dDdv.*dshapex(:,jnod,1)) ./ (D.^2);   
                
                dfdu_y = 0.5*(1 ./ ff).*(  dNdu.*D) ./ (D.^2);
                dfdu_x = 0.5*(1 ./ ff).*(- N.*dDdu) ./ (D.^2);
                
                dfdv_y = 0.5*(1 ./ ff).*(  dNdv.*D) ./ (D.^2);   
                dfdv_x = 0.5*(1 ./ ff).*(- N.*dDdv) ./ (D.^2);                   
                
                dfdu_1_y = dfdu_y.*dUpg(:,1,1);
                dfdu_1_x = dfdu_x.*dUpg(:,1,1);
                
                dfdu_2_y = dfdu_y.*dUpg(:,1,2).*(-1 ./ (ff.^2));
                dfdu_2_x = dfdu_x.*dUpg(:,1,2).*(-1 ./ (ff.^2));
                
                dfdv_1_y = dfdv_y.*dUpg(:,2,1);
                dfdv_1_x = dfdv_x.*dUpg(:,2,1);
                
                dfdv_2_y = dfdv_y.*dUpg(:,2,2).*(-1 ./ (ff.^2));
                dfdv_2_x = dfdv_x.*dUpg(:,2,2).*(-1 ./ (ff.^2));
                
                if 0&(ipg==1)&(jnod==2)
                    [ff_nod]=ele_field_to_nod_field(xnod,icone,dfdu_1_x);
                    figure(3);clf;subplot(221);view2d(xnod,icone,ff_nod);colorbar,title('XX')
                    [ff_nod]=ele_field_to_nod_field(xnod,icone,dfdu_1_y);
                    figure(3);subplot(222);view2d(xnod,icone,ff_nod);colorbar,title('XY')
                    [ff_nod]=ele_field_to_nod_field(xnod,icone,dfdu_2_x);
                    figure(3);subplot(223);view2d(xnod,icone,ff_nod);colorbar,title('YX')
                    [ff_nod]=ele_field_to_nod_field(xnod,icone,dfdu_2_y);
                    figure(3);subplot(224);view2d(xnod,icone,ff_nod);colorbar,title('YY')
                    
                    [ff_nod]=ele_field_to_nod_field(xnod,icone,dfdv_1_x);
                    figure(2);clf;subplot(221);view2d(xnod,icone,ff_nod);colorbar,title('XX')
                    [ff_nod]=ele_field_to_nod_field(xnod,icone,dfdv_1_y);
                    figure(2);subplot(222);view2d(xnod,icone,ff_nod);colorbar,title('XY')
                    [ff_nod]=ele_field_to_nod_field(xnod,icone,dfdv_2_x);
                    figure(2);subplot(223);view2d(xnod,icone,ff_nod);colorbar,title('YX')
                    [ff_nod]=ele_field_to_nod_field(xnod,icone,dfdv_2_y);
                    figure(2);subplot(224);view2d(xnod,icone,ff_nod);colorbar,title('YY')
                    
                    vaux_u = dfdu_1_x.*dfdu_2_y-dfdu_1_y.*dfdu_2_x;
                    [ff_nod]=ele_field_to_nod_field(xnod,icone,vaux_u);
                    figure(1);clf;subplot(211)
                    view2d(xnod,icone,ff_nod);colorbar,title('(Kxx*Kyy-Kyx*Kxy) para u')
                    
                    vaux_v = dfdv_1_x.*dfdv_2_y-dfdv_1_y.*dfdv_2_x;
                    [ff_nod]=ele_field_to_nod_field(xnod,icone,vaux_v);                    
                    figure(1);subplot(212)
                    view2d(xnod,icone,ff_nod);colorbar,title('(Kxx*Kyy-Kyx*Kxy) para v')
                    
                    keyboard;pause
                end
                
                
            end
            
            Kele(:,inod,1,jnod,1) = Kele(:,inod,1,jnod,1) + ( ...  
                Kappa_pg(:,1).*dshapex(:,inod,1).*dshapex(:,jnod,1) +  ...
                Kappa_pg(:,2).*dshapex(:,inod,2).*dshapex(:,jnod,2) ).*xsj; 
            
            Kele(:,inod,2,jnod,2) = Kele(:,inod,2,jnod,2) + ( ...                                          
                Kappa_pg(:,1).*dshapex(:,inod,1).*dshapex(:,jnod,1) +  ...
                Kappa_pg(:,2).*dshapex(:,inod,2).*dshapex(:,jnod,2) ).*xsj; 
            
            if initial_guess~=1,
                
                % agregado termino derivada de la difusividad
                Kele(:,inod,1,jnod,1) = Kele(:,inod,1,jnod,1) + coef*( ...  
                    dshapex(:,inod,1).*(dfdu_1_y.*dshapex(:,jnod,2)+1*dfdu_1_x.*dshapex(:,jnod,1)) + ...
                    dshapex(:,inod,2).*(dfdu_2_y.*dshapex(:,jnod,2)+dfdu_2_x.*dshapex(:,jnod,1)) ).*xsj; 
                
                Kele(:,inod,2,jnod,2) = Kele(:,inod,2,jnod,2) + coef*( ... 
                    dshapex(:,inod,1).*(dfdv_1_y.*dshapex(:,jnod,2)+dfdv_1_x.*dshapex(:,jnod,1)) + ... 
                    dshapex(:,inod,2).*(1*dfdv_2_y.*dshapex(:,jnod,2)+dfdv_2_x.*dshapex(:,jnod,1)) ).*xsj; 
                
                dfdu_1_y = dfdu_y.*dUpg(:,2,1);
                dfdu_1_x = dfdu_x.*dUpg(:,2,1);
                
                dfdu_2_y = dfdu_y.*dUpg(:,2,2).*(-1 ./ (ff.^2));
                dfdu_2_x = dfdu_x.*dUpg(:,2,2).*(-1 ./ (ff.^2));
                
                dfdv_1_y = dfdv_y.*dUpg(:,1,1);
                dfdv_1_x = dfdv_x.*dUpg(:,1,1);
                
                dfdv_2_y = dfdv_y.*dUpg(:,1,2).*(-1 ./ (ff.^2));
                dfdv_2_x = dfdv_x.*dUpg(:,1,2).*(-1 ./ (ff.^2));
                
                
                Kele(:,inod,1,jnod,2) = Kele(:,inod,1,jnod,2) + coef*( ...  
                    dshapex(:,inod,1).*(dfdv_1_x.*dshapex(:,jnod,1)+dfdv_1_y.*dshapex(:,jnod,2)) + ...
                    dshapex(:,inod,2).*(dfdv_2_x.*dshapex(:,jnod,1)+dfdv_2_y.*dshapex(:,jnod,2))).*xsj; 
                
                Kele(:,inod,2,jnod,1) = Kele(:,inod,2,jnod,1) + coef*( ...  
                    dshapex(:,inod,1).*(dfdu_1_x.*dshapex(:,jnod,1)+dfdu_1_y.*dshapex(:,jnod,2)) + ...
                    dshapex(:,inod,2).*(dfdu_2_x.*dshapex(:,jnod,1)+dfdu_2_y.*dshapex(:,jnod,2))).*xsj; 
                
                
            end
            
        end  % jnod            
        
        ter1 = (dshapex(:,inod,1).* Kappa_pg(:,1).*dUpg(:,1,1) + ...
            dshapex(:,inod,2).* Kappa_pg(:,2).*dUpg(:,1,2)) ;
        
        ter2 = (dshapex(:,inod,1).* Kappa_pg(:,1).*dUpg(:,2,1) + ...
            dshapex(:,inod,2).* Kappa_pg(:,2).*dUpg(:,2,2)) ;
        
        Rele(eles,inod,1) = Rele(eles,inod,1) - ter1 .* xsj;
        Rele(eles,inod,2) = Rele(eles,inod,2) - ter2 .* xsj;        
        
    end % inod    
end % ipg
