function [fixa,forc] = conv_fixa_pfem(fixa_pf,fixa,forc,flag)
%
%   [fixa,forc] = conv_fixa_pfem(fixa_pf,fixa,forc,flag)
%
%   default ==> flag =0  
%   convert Petscfem format fixations to FemCode format fixations 
%
%   flag .ne. 0
%   convert FemCode format fixations to Petscfem format fixations

if nargin<4, flag=0; end

if flag == 0,
    idf_max = max(fixa_pf(:,2));
    idf_min = min(fixa_pf(:,2));
    for idf=idf_min:idf_max
        nn=find(fixa_pf(:,2)==idf);
        if isempty(nn)==0,
            nodes=fixa_pf(nn,1);
            value=fixa_pf(nn,3);
            fixa(nodes,idf)=1;
            forc(nodes,idf)=value;
        end
    end
else
    bfh = [];
    idf_min = 1;
    [bas,idf_max] = size(fixa);
    for idf=idf_min:idf_max
        nn = find(fixa(:,idf)==1);
        if isempty(nn)==0,
            bfh = [bfh;[nn , ones(length(nn),1)*idf forc(nn,idf)]];
        end
    end    
    fixa = bfh;
end

