%
%  RUTINA PARA GENERAR LOS ARCHIVOS DE RESULTADOS
%  PARA SER POSTPROCESADOS CON GID
%

disp(' ==================================================')
disp(' ==================================================')
disp('')
disp(' ///////  WRITING POSTPROCESSING GID FILES /////// ')
disp('')
disp(' ==================================================')
disp(' ==================================================')

eval(['my_dir=pwd;']);
file_to_search=[my_dir,'\data_gid_as_post.m'];
if exist(file_to_search,'file')==2,
   data_gid_as_post;
end
   
%  File [1] NAME.flavia.msh
% ============================
while exist('filename','var')==0,
   filename=input(' Enter filename ','s');
end
eval(['load ' filename '.nod']);
eval(['xnod= ' filename ';']);
eval(['load ' filename '.con']);
eval(['icone= ' filename ';']);
eval(['clear ' filename ]);

[numel,nen]=size(icone);
[numnp,ndm]=size(xnod);

if ndm==2&nen==3,
   elem_type = 'Triangle';
elseif ndm==3&nen==3,
   elem_type = 'Triangle';   
elseif ndm==2&nen==4,
   elem_type = 'Quadrilateral';
elseif ndm==3&nen==4,
   elem_type = 'Tetrahedra';
elseif ndm==3&nen==8,
   elem_type = 'Hexahedra';
else
   error(' Bad element type')
end

filename_base = filename;
%if ndm==2,
%   filename_write = [filename_base , '.flavia.dat'];   
%else
   filename_write = [filename_base , '.flavia.msh'];
%end

fid = fopen(filename_write,'wt');

% 1.- Header with 6 free lines

fprintf(fid,' # ================================================== \n',[]);
fprintf(fid,['# \n'],[]);
fprintf(fid,' # POSTPROCESSING WITH GID - MESH FILE \n',[]);
fprintf(fid,['# EXAMPLE NAME: ' filename  ' \n'],[]);
fprintf(fid,' # ================================================== \n',[]);
fprintf(fid,[' MESH "' filename '" dimension ' num2str(ndm) ' Elemtype ' elem_type ...
              ' Nnode ' num2str(nen) '\n'],[]);
fprintf(fid,' Coordinates \n',[]);
fprintf(fid,' # node number   coordinate_x  coordinate_y  coordinate_z \n',[]);

% 4.- Coordinates 
format_xnod = [];
for k=1:ndm,
   format_xnod=[format_xnod, '%15.5e'];
end
format_xnod=[' %10i ' format_xnod, '\n'];
fprintf(fid,format_xnod,[(1:numnp)',xnod]');

fprintf(fid,' end coordinates \n',[]);
fprintf(fid,' # we put the same material in the whole MESH, \n',[]);

fprintf(fid,' Elements \n',[]);

format_title = ' # element ';
for k=1:nen,
   format_title=[format_title, ' node_' num2str(k)];
end
format_title=[format_title, ' material number \n'];

fprintf(fid,format_title,[]);

format_icone = [];
for k=1:nen,
   format_icone=[format_icone, '%7i'];
end
format_icone=['%10i ' format_icone, '     %2i ' '\n'];

fprintf(fid,format_icone,[(1:numel)',icone, 1*ones(numel,1)]');

fprintf(fid,' end elements ',[]);

fclose(fid)

%  Archivo [2] NAME.flavia.res
% ============================

eval(['load ' filename '.state']);
eval(['state= ' filename ';']);

filename_base = filename;
filename_write = [filename_base , '.flavia.res'];
fid = fopen(filename_write,'wt');
if length(filename)>13,
   filename = filename(1:13);
end
% 1 linea de header del archivo residuo
% [1] 15 caracteres ocupados por el titulo
% [2] Load_type (integer) 
%     = 1 Time step
%     = 2 Load step
%     = 3 frequency step
%     = 4 User step
% [3] Step_val (real)
%     identifica el current time de la solucion a graficar
% [4] Local descriptor OPCIONAL
% [5] Data_type
%     = 1 scalar
%     = 2 vector
%     = 3 matrix
%     = 4 2D plane defor
%     = 5 Main stress
%     = 6 Euler angles
% [6] Data_location
%     = 1 at nodes
%     = 2 at Gauss points
% [7] Description components
%     = 0 NO description
%     = 1 SI description (solo si [4] contiene algo)
% [8] Gauss point names OPCIONAL

nvars = size(variable_name);
nstep = length(Step_val);
   
for k=1:nvars
      
   k1 = var_field(k,1);
   k2 = var_field(k,2);   
   format_state = ['%7i'];
   for kk=k1:k2,
      format_state=[format_state , '%15.5e '];
   end
   format_state = [format_state, '\n'];
      
   for istep=1:nstep
         
   if Desc_comp==0,
      fprintf(fid,[variable_name(k,:) '         ' '%5i %10.5f %5i %5i %5i' '\n'],[Load_type Step_val(istep) Data_type(k) Data_location Desc_comp]);
   else
      fprintf(fid,[variable_name(k,:) '         ' '%5i %10.5f ' Local_descriptor ' %5i %5i %5i' '\n'],[Load_type Step_val(istep) Data_type Data_location Desc_comp]);
   end   
   
   fprintf(fid,[format_state],[(1:numnp)',state((istep-1)*numnp+(1:numnp),k1:k2)]');
   
   end

end

fclose(fid)

return
