function [angle_ratio,side_length_ratio]=quality_mesh_triangle(xnod,icone,iplot)
%
%  [angle_ratio,side_length_ratio]=quality_mesh_triangle(xnod,icone,[...iplot])
%

if nargin<3,  iplot=0;end

[nr,nc]=size(xnod);
if nc>2,error(' ONLY FOR 2D'); end

x1 = xnod(icone(:,1),1:2);
x2 = xnod(icone(:,2),1:2);
x3 = xnod(icone(:,3),1:2);

% side lengths
dx1 = x2-x1;l1=sqrt(sum(dx1'.^2))';
dx2 = x3-x2;l2=sqrt(sum(dx2'.^2))';
dx3 = x1-x3;l3=sqrt(sum(dx3'.^2))';

xmin=min([l1,l2,l3]')';
xmax=max([l1,l2,l3]')';

side_length_ratio=xmax./xmin;

dx1=[dx1,0*dx1(:,1)];
dx2=[dx2,0*dx2(:,1)];
dx3=[dx3,0*dx3(:,1)];

v1=pvec(dx3,dx1);
v2=pvec(dx1,dx2);
v3=pvec(dx2,dx3);

w1=sqrt(sum(v1'.^2))';
w2=sqrt(sum(v2'.^2))';
w3=sqrt(sum(v3'.^2))';

angle_1 = asin(w1./(l3.*l1));
angle_2 = asin(w2./(l1.*l2));
angle_3 = asin(w3./(l2.*l3));

amin=min([angle_1,angle_2,angle_3]')';
amax=max([angle_1,angle_2,angle_3]')';

angle_ratio=amax./amin;

if iplot>0,
figure(1);clf;
hist(side_length_ratio,20);
ylabel('Number of elements')
xlabel('Side length ratio')
title('TRIANGLE MESH QUALITY')

figure(2);clf;
hist(angle_ratio,20);
ylabel('Number of elements')
xlabel('Angle ratio')
title('TRIANGLE MESH QUALITY')
end
