%%
%%  refine the first element in the layer in the normal direction at half
%%  part
%%

if 0,
    % elemset sobre la piel del cuerpo
    wall=load('ahmed125_fluid.wall ');
    % capa de prismas
    icone_p=load('ahmed125_fluid.prism');
    % coordenadas nodales totales
    xnod=load('ahmed125_fluid.nod-skin-all');
    % vector de estado para continuar corriendo
    state=load('ahmed125_fluid.step.56');    
else
    load tempo.mat
end

[numel,nen]=size(icone_p);
if nen~=6, error(' NEN should be 6'); end
% selecciono los elementos (prismas) que estan sobre la piel
nodes_skin = rmdblist(m2v(wall));
eles_skin = get_eles_by_nodes(nodes_skin,icone_p,0);
icone_skin = icone_p(eles_skin,:);

% divido los prismas en dos y agrego nodos a la lista
[numnp,ndm]=size(xnod);

lay1 = icone_skin(:,1:3);
lay2 = icone_skin(:,4:6);
% cual es la lay que esta sobre el cuerpo ?
% para ello comparamos lay1 con wall y lay2 con wall
% lay1 es la que esta sobre la pared
% lay2 es la que esta fuera de la pared
if(isequal(sort(wall')',sort(lay1')'))
elseif(isequal(sort(wall')',sort(lay2')')) 
    lay_tmp = lay1;
    lay1 = lay2;
    lay2 = lay_tmp;
    clear lay_tmp
else
    error(' neither lay1 nor lay2 equal to wall')
end

% calculo las coordenadas y el estado de los nodos intermedios que nacen
% del refinamiento y luego parto el elemento sobre el cuerpo en dos partes
nodes_skin = rmdblist(m2v(lay1));
nnod_skin = length(nodes_skin);
nodes = numnp+(1:nnod_skin)';
ipt = zeros(numnp,1);
ipt(nodes_skin)=nodes;
xnew = xnod;
lay_half = [];
state_new = state;
for k=1:nen/2
    xhalf = (xnod(lay1(:,k),:)+xnod(lay2(:,k),:))/2;
    ne = ipt(lay1(:,k));
    xnew(ne,:) = xhalf;
    lay_half = [lay_half,ne];
    state_half = (state(lay1(:,k),:)+state(lay2(:,k),:))/2;    
    state_new(ne,:) = state_half;
end

iconew_p = icone_p;
iconew_p(eles_skin,:)=[];
iconew_p = [iconew_p;[lay2,lay_half];[lay_half,lay1]];

write_mesh_and_state(xnew,iconew_p,state_new,['ahmed125_fluid_ref_1']);