function [map] = rmdbnode(xnod,tol)
%
%  found duplicate nodes and create a map to remove them
%
%    [map] = rmdbnode(xnod,tol) 
%
%  to remove           to leave
%   map(:,1)     --->  map(:,2)
%

if nargin<2, tol=1e-10; end
[nnod,ndm] = size(xnod);

xmin=min(xnod);
xmax=max(xnod);

alea1=rand(1,ndm);
alea2=rand(1,ndm);
alea3=rand(1,ndm);
alea4=rand(1,ndm);

X1 = xmin;
X2 = xmax;
d1 = xnod-ones(length(xnod(:,1)),1)*(X1.*alea1);
d2 = xnod-ones(length(xnod(:,1)),1)*(X2.*alea2);
if ndm==2,   
   X3 = [xmin(1),xmax(2)];
   X4 = [xmax(1),xmin(2)];
   d3 = xnod-ones(length(xnod(:,1)),1)*(X3.*alea3);   
   d4 = xnod-ones(length(xnod(:,1)),1)*(X4.*alea4);
else
   d3 = xnod-ones(length(xnod(:,1)),1)*([xmin(1),xmax(2),xmin(3)].*alea3);
   d4 = xnod-ones(length(xnod(:,1)),1)*([xmax(1),xmin(2),xmax(3)].*alea4);
end

dd1 = sqrt(sum(d1'.^2))';
dd2 = sqrt(sum(d2'.^2))';
dd3 = sqrt(sum(d3'.^2))';
dd4 = sqrt(sum(d4'.^2))';

%ds = [dd1,dd2,dd3,dd4]*ones(4,1);

bfh=[];
ds = dd1;
[bas,ibas] = sort(ds);
xnew  = xnod(ibas,:);
dd    = diff(d1(ibas,:));
dd    = sqrt(sum(dd'.^2))';
nn    = find(dd<tol);
map   = [ibas(nn+1) , ibas(nn)];
bfh   = [bfh;map];

ds = dd2;
[bas,ibas] = sort(ds);
xnew  = xnod(ibas,:);
dd    = diff(d1(ibas,:));
dd    = sqrt(sum(dd'.^2))';
nn    = find(dd<tol);
map   = [ibas(nn+1) , ibas(nn)];
bfh   = [bfh;map];

ds = dd3;
[bas,ibas] = sort(ds);
xnew  = xnod(ibas,:);
dd    = diff(d1(ibas,:));
dd    = sqrt(sum(dd'.^2))';
nn    = find(dd<tol);
map   = [ibas(nn+1) , ibas(nn)];
bfh   = [bfh;map];

ds = dd4;
[bas,ibas] = sort(ds);
xnew  = xnod(ibas,:);
dd    = diff(d1(ibas,:));
dd    = sqrt(sum(dd'.^2))';
nn    = find(dd<tol);
map   = [ibas(nn+1) , ibas(nn)];
bfh   = [bfh;map];

if isempty(bfh)==0,
bfh = sort(bfh')';
[bas,ipt] = rmdblist2(bfh(:,1));
bfh = bfh(ipt,:);
map = bfh;

follow=1;
while follow,
   found = 0;
for k=1:length(nn),
   nn = find(map(:,1)==map(k,2));
   if length(nn)==1,
      map(k,2)=map(nn,2);
      found = found+1;
   end
end
   follow=found>0;
end

else
  map = [];
end

return
