function [nodes] = select_nodes(xnod,idm,value,ijob,tol)
%
%  [nodes] = select_nodes(xnod,idm,value,ijob,[...tol])
%
%  ijob = 1: the value input is only an approximation and the routine find the closest nodal coordinate
%

if nargin <4, ijob=0; end
if nargin <5, tol = 1e-6; end

if ijob==0,
    nodes=find(abs(xnod(:,idm)-value)<tol);
else
    [bas,ibas]=min(abs(xnod(:,idm)-value));
    value = xnod(ibas,idm);
    nodes=find(abs(xnod(:,idm)-value)<tol);
end
