function [xnew,iconew,imap] = sew_mesh(xnod,icone,tol)
%
%  [xnew,iconew,imap] = sew_mesh(xnod,icone,tol)
%
%  Cose una malla compuesta de partes no unidas en su totalidad
%

if nargin <3, tol = 1e-10; end

[numnp,ndm]      = size(xnod);
[numel,nen]      = size(icone);

% map only for duplicate nodes
[map] = rmdbnode(xnod,tol);

if isempty(map)==0,
% general mapping
mask  = zeros(numnp,1);
mask(map(:,1))=ones(length(map(:,1)),1);
[bas,ibas]=sort(mask);

map_gral = (1:numnp)'*[1,1,1,1];
map_gral(:,4) = mask;
map_gral(map(:,1),2)=map(:,2);

%map_1 = map_gral(:,1:2);

% DEBUG
nnod_active=find(map_gral(:,4)==0);
nn=find(map_gral(:,4)==1);
for k=1:length(map_gral(nn,1)),
   kk=map_gral(nn(k),2);
   while map_gral(kk,4)==1,
      kk=map_gral(kk,2);
   end
   map_gral(nn(k),2)=kk;
end
%

map_gral = map_gral(ibas,:);
map_gral(:,3) = (1:numnp)';

map_gral_copy(ibas,1) = map_gral(:,3);
nn=find(map_gral(:,4)==1);
for k=1:length(map_gral(nn,1)),
   kk=map_gral(nn(k),2);
   kkk=map_gral_copy(kk);
   if kkk>nnod_active, error(' SEW_MESH , pointing to a non active node'); end
   map_gral(nn(k),3)=kkk;    
end

map(map_gral(:,1),1) = map_gral(:,3);

%keyboard;pause

%map_2=zeros(numnp,1);
%map_2(map_gral(:,1),1) = map_gral(:,3);

%map=map_2(map_1(:,2),1);


clear imap
imap(map(1:length(map),1),1) = (1:length(map))';

for k=1:nen,
   iconew(:,k)=map(icone(:,k));
end

xnew  = xnod(imap,:);

% si existen elementos que degeneran en una dimension menor 2D --> 1D los remueve
area = area_mesh(xnew,iconew);
nn = find(abs(area)<1e-12);
iconew(nn,:)=[];
else
    xnew = xnod;
    iconew=icone;
end

return

vaux=sort(iconew');
bas=min(diff(vaux))';
nn=find(bas==0);
if length(nn)>0,
   disp(' Check the following elements (please enter to return) '),pause
   disp([' element # - nodes 1 , 2 , ... '])
   disp([nn iconew(nn,:)])
end

% OLD VERSION

if nargin <3, tol = 1e-10; end

% Remuevo los duplicados
% [1] Calculo la distancia a un punto arbitrario [0,0,0]
distan = sqrt(sum(xnod'.^2))';

% [2] Ordeno por el valor de dicha distancia
[ysort,isort] = sort(distan);
yyy =  diff(ysort);
nnn =  find(abs(yyy)>tol);
n2  =  max(diff(nnn))+1;

% [3] Recorro el arreglo ordenado por patches de valores
ynod = xnod(isort,:);
[n1,m1] = size(ynod);

irepeat=zeros(n1,1);

for k=1:n1-1,
  kk=min([k+(1:n2);n1*ones(1,n2)])';
  vaux = ones(n2,1)*ynod(k,:)-ynod(kk,:);
  vaux = sqrt(sum(vaux'.^2))';
  irepeat(kk,1)=irepeat(kk,1)| (vaux<tol);  
end

nnn = find(irepeat==1);
node_dupl = isort(nnn);

[numel,nen]=size(icone);
[numnp,ndm]=size(xnod);
nnn = length(node_dupl);

node_dupl = [node_dupl , zeros(nnn,1)];

for k=1:nnn,
   xxx = (xnod'-xnod(node_dupl(k,1),:)'*ones(1,numnp));
   distan = sqrt(sum(xxx.^2))';
   nn = find(distan<tol);
   mm = find(nn==node_dupl(k,1));
   nn(mm)=[];
   if length(nn)~=1,
         keyboard;pause
      error(' sew_mesh routine - ERROR [000]'); 
   end
   node_dupl(k,2) = nn;   
end

maping = (1:numnp)';
maping(node_dupl(:,1)) = maping(node_dupl(:,2));

for k=1:nen
   icone(:,k) = maping(icone(:,k));
end


% calculamos los nodos que quedan en la nueva malla
nodes=[];
set_ele = (1:numel)';
for k=1:nen,
  nodes = [nodes;icone(set_ele,k)];
end
nodes = sort(nodes);
nodes = rmdblist(nodes);

nnod = max2(icone);
set_nod = (1:nnod)';
set_nod(nodes) = (1:length(nodes))';

xnew = xnod(nodes,:);
for k=1:nen,
  iconew(:,k) = set_nod(icone(set_ele,k));
end
