function [xnod]=split_curve_N_points(xnod_0,N)
%
%  [xnod]=split_curve_N_points(xnod_0,N)
% 
%   Genera una curva que pasa por los nodos definidos como xnod_0
%   y tiene N puntos sobre ella, incluyendo en los N a los puntos xnod_0
%

N0 = length(xnod_0(:,1));
if N<N0, error(' gen_curve, N should be >= length(x0) '); end

xnod_0_orig = xnod_0;

% ordeno a la entrada el conjunto de nodos 
[p_index] = sort_xnod(xnod_0);
xnod_0    = xnod_0(p_index,:);

ds = diff(xnod_0);   
ds = sqrt(sum(ds'.^2))';   
ss = cumsum(ds);   
ss = [0;ss];

psi = (0:N-1)'/(N-1);
x   = xnod_0(:,1);
s   = ss;
sh  = psi*max(ss);
xx  = spline(s,x,sh);

y   = xnod_0(:,2);
s   = ss;
sh  = psi*max(ss);
yy  = spline(s,y,sh);

X1 = [xx,yy];

N1 = N;
for kk=1:N0,
   dx1 = X1-ones(N1,1)*xnod_0(kk,:);
   dd1 = sqrt(sum(dx1'.^2));
   [bas,ibas] = min(dd1);
   N1 = N1-1;
   X1(ibas,:) = [];
end      

X1        = [X1;xnod_0];   
   
% ordeno el conjunto de nodos final
[p_index] = sort_xnod(X1,xnod_0_orig(1,:));
%[p_index] = sort_xnod(X1);
xnod      = X1(p_index,:);

return
%================================================================================

% datos
%========================================
xnod = [0,0];
xnod = [xnod;xnod(1,:)+[1,1]];
xnod = [xnod;xnod(2,:)+[1,1]];
xnod = [xnod;xnod(3,:)+[1,1]];
xnod = [xnod;xnod(4,:)+[1,1]];
xnod = [xnod;xnod(5,:)+[1,1]];
%========================================
psi = (1:6)'/6;
xnod(:,1) = psi;
xnod(:,2) = 3*psi.^2;
%========================================
radio = 2;
psi = (0:8)'/16;
angle = (-3:8)'/18*2*pi;
angle = (-1+3*psi.^2)*2*pi;
xnod = radio*[cos(angle),sin(angle)];

if 1,
   ds=diff(xnod);   
   ds=sqrt(sum(ds'.^2))';   
   ss=cumsum(ds);   
%   ss(:,1)=ss(:,1)-ss(1,1);
%   ss(:,2)=ss(:,2)-ss(1,2);
   ss = [0;ss];
else
spcv = cscvn(xnod'); fnplt(spcv), hold on; plot(xnod(:,1),xnod(:,2),'r.');
xx=(-1:.1:2);
values = fnval(spcv,xx);
end

% fin datos
xnod_0 = xnod;

N = 20;

