function [xnod,icone]=split_surface(xnod,nodes_1,nodes_2,nodes_3,nodes_4)
%
%      [xnod,icone]=split_surface(xnod,nodes_1,nodes_2,nodes_3,nodes_4)
%
%      mallamos la superficie
%      usamos una interpolacion lineal entre los bordes opuestos 
%      para generar cada coordenada
%

nnod=length(xnod(:,1));

Ni = length(nodes_1);
Nj = length(nodes_2);
if Ni~=length(nodes_3), error(' nodes_1 & nodes_3 should be the same'); end
if Nj~=length(nodes_4), error(' nodes_2 & nodes_4 should be the same'); end
x1 = xnod(nodes_1,:);
x3 = xnod(nodes_3,:);
x2 = xnod(nodes_2,:);
x4 = xnod(nodes_4,:);

% ordeno los nodos del borde de forma de que sigan una direccion de numeracion cerrada

tol = 1e-6;
if 1,
   [x1,x2,nodes_1,nodes_2]=check_num_arista(x1,x2,nodes_1,nodes_2,Ni,Nj);
   
   origen = x1(1,:);
   dx     = x4-ones(Nj,1)*origen;
   ds     = sqrt(sum(dx'.^2));   
   [bas,ibas] = sort(ds);
   x4     = x4(ibas,:);
   nodes_4 = nodes_4(ibas);
   
   origen = x4(Nj,:);
   dx     = x3-ones(Ni,1)*origen;
   ds     = sqrt(sum(dx'.^2));   
   [bas,ibas] = sort(ds);
   x3     = x3(ibas,:);
   nodes_3 = nodes_3(ibas);
   
else   
   origen = x1(Ni,:);
   dx     = x2-ones(Nj,1)*origen;
   ds     = sqrt(sum(dx'.^2));   
   [bas,ibas] = sort(ds);
   x2     = x2(ibas,:);
   nodes_2 = nodes_2(ibas);
      
   origen = x1(1,:);
   dx     = x4-ones(Nj,1)*origen;
   ds     = sqrt(sum(dx'.^2));   
   [bas,ibas] = sort(ds);
   x4     = x4(ibas,:);
   nodes_4 = nodes_4(ibas);
   
   origen = x4(Nj,:);
   dx     = x3-ones(Ni,1)*origen;
   ds     = sqrt(sum(dx'.^2));   
   [bas,ibas] = sort(ds);
   x3     = x3(ibas,:);
   nodes_3 = nodes_3(ibas);
   
end

xx=[];
psiv = [-1,1,1,-1];
etav = [-1,-1,1,1];

xx1=[];
for j=1:Nj,         
   xx1 = [xx1;[x1+(x3-x1)*(j-1)/(Nj-1)]];
end

xx2=[];
for i=1:Ni,         
   xx2 = [xx2;[x4+(x2-x4)*(i-1)/(Ni-1)]];
end

xx2(:,1) = reshape(reshape(xx2(:,1),Nj,Ni)',Ni*Nj,1);
xx2(:,2) = reshape(reshape(xx2(:,2),Nj,Ni)',Ni*Nj,1);
xx = 0.5*(xx1+xx2);

if 0,
xx(1:Ni,:)=x1;
xx(Ni*(Nj-1)+(1:Ni),:)=x3;
xx(1:Ni:Ni*(Nj-1)+1,:)=x4;
xx(Ni:Ni:Nj*Ni,:)=x2;
else
   % removemos los nodos de los contornos que ya estan incluidos en el xnod inputeado
   nodes_bou =[(1:Ni),Ni*(Nj-1)+(1:Ni),(1:Ni:Ni*(Nj-1)+1),(Ni:Ni:Nj*Ni)];
   xx(nodes_bou,:)=[];
end

xnod=[xnod;xx];

map        = [(1:Ni*Nj)'*[1,1]];
nodes_bou  = [(1:Ni),Ni*(Nj-1)+(1:Ni),(1:Ni:Ni*(Nj-1)+1),(Ni:Ni:Nj*Ni)]';

nodes_bou2 = rmdblist(nodes_bou);

new_nodes  = (1:Ni*Nj)';
new_nodes(nodes_bou2)=[];
nnodes_new = length(new_nodes);
[bas,ibas] = sort(new_nodes);
map(new_nodes,2) = ibas+nnod;
map(nodes_bou,2) = [nodes_1,nodes_3,nodes_4,nodes_2]';

ico0 = [(1:Ni-1)',(2:Ni)'];
ico0 = [ico0 , Ni+[ico0(:,2),ico0(:,1)]];
icone=[];
for j=1:Nj-1,
   icone=[icone;(j-1)*Ni+ico0];
end

[numel,nen]=size(icone);
for k=1:nen
   icone(:,k)=map(icone(:,k),2);
end

%disp('SPLIT SURFACE')
%keyboard,pause
%figure(2);clf;plot(xx(:,1),xx(:,2),'r.')
