function [nu_t,nu_t_nod] = visco_les(xnod,icone,vel)
%
%  [nu_t,nu_t_nod] = visco_les(xnod,icone,vel)
%

[nele,nen]=size(icone);
[numnp,ndm]=size(xnod);
npg = 1; % centroide

[grad_vec] = grad_phi_by_ele(xnod,icone,vel,npg);
gU=reshape(grad_vec(:,1,1:ndm,1:ndm),nele,ndm,ndm);

[ar,emax,emin] = ar3d(xnod,icone);
hele = sqrt(emin.*emax);
C_smag = 0.18;
nu_t = zeros(nele,1);
strain_rate = reshape(gU,nele,ndm,ndm);
Sij = zeros(nele,1);
for idm=1:ndm,
    for jdm=1:ndm,
        Sij=Sij+(0.5*(strain_rate(:,idm,jdm)+strain_rate(:,jdm,idm)).^2);
    end
end
nu_t=sqrt(Sij);
nu_t = (C_smag*hele).^2.*nu_t;

factor = 1/nen;
nu_t_nod = zeros(numnp,1);
for inod=1:nen,
    nodes=icone(:,inod);
    nu_t_nod(nodes,1)=nu_t_nod(nodes,1)+factor*nu_t;
end

