function [vort,divu] = vortex(xnod,icone,veloc,ijob)
%
%      [vort,divu] = vortex(xnod,icone,veloc,[ijob=0])
%
%  ijob > 0 , calculo en el centroide de cada elemento
%  ijob = 0 (def) calculo nodal

[nnod,ndm]=size(xnod);
[nele,nen]=size(icone);
if nargin <4, ijob=0; end

if ndm==2,
   ndof = 3;
else
   ndof = 5;
end

[nnod,bas]=size(xnod);
[nele,nen]=size(icone);
Rele = zeros(nele,ndof*nen);
Rg   = zeros(nnod,ndof);

npg = 1;
% set coordinates and weights of Gauss points for numerical integration  

if ndm==2,
   pgauss2d;
else
   pgauss3d;  
end

ceros = zeros(nele,nen);

if ndm==2,
  velex = ceros;
  veley = ceros;
    
  for inod=1:nen,
            nodes = icone(:,inod);
    velex(:,inod) = veloc(nodes,1);
    veley(:,inod) = veloc(nodes,2);
 end   
else   
  velex = ceros;
  veley = ceros;
  velez = ceros;
    
  for inod=1:nen,
            nodes = icone(:,inod);
    velex(:,inod) = veloc(nodes,1);
    veley(:,inod) = veloc(nodes,2);
    velez(:,inod) = veloc(nodes,3);    
 end
end

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------
for ipg=1:npg
   
   if ndm==2,
      [X2S,S2X,Jaco] = xy2st(xnod,icone,psipg(ipg),etapg(ipg));  
      [dshapex,N] = shape2d(X2S,psipg(ipg),etapg(ipg),nen);        
   else            
      [X2S,S2X,Jaco] = xyz2rst(xnod,icone,psipg(ipg),etapg(ipg),zetapg(ipg));  
      [dNdx,dNdy,dNdz,N] = shape3d(X2S,psipg(ipg),etapg(ipg),zetapg(ipg),nen);  
   end
   dNdx = dshapex(:,:,1);
   dNdy = dshapex(:,:,2);
   
   xsj =  wpg(ipg) .* Jaco;
   
   if ndm==2,
     dudx = zeros(nele,2); dvdx = zeros(nele,2);
     
       for inod=1:nen,
    dudx(:,1) = dudx(:,1) + dNdx(:,inod).* velex(:,inod);
    dudx(:,2) = dudx(:,2) + dNdy(:,inod).* velex(:,inod);
    
    dvdx(:,1) = dvdx(:,1) + dNdx(:,inod).* veley(:,inod);
    dvdx(:,2) = dvdx(:,2) + dNdy(:,inod).* veley(:,inod);        
 end
 
  wz = dvdx(:,1)-dudx(:,2);
  
  div_u = dudx(:,1)+dvdx(:,2);
  
  for inod=1:nen,
% RESIDUO    
% termino temporal
	Rele(:,(inod-1)*ndof+1) =  Rele(:,(inod-1)*ndof+1) + N(inod) .* ones(nele,1) .*xsj;
   Rele(:,(inod-1)*ndof+2) =  Rele(:,(inod-1)*ndof+2) + N(inod) .* wz .* xsj;         
	Rele(:,(inod-1)*ndof+3) =  Rele(:,(inod-1)*ndof+3) + N(inod) .* div_u .* xsj;            
  end % inod

  else     
     dudx    = zeros(nele,3);   dvdx    = zeros(nele,3);   dwdx    = zeros(nele,3);
    
  for inod=1:nen,
    dudx(:,1) = dudx(:,1) + dNdx(:,inod).* velex(:,inod);
    dudx(:,2) = dudx(:,2) + dNdy(:,inod).* velex(:,inod);
    dudx(:,3) = dudx(:,3) + dNdz(:,inod).* velex(:,inod);
    
    dvdx(:,1) = dvdx(:,1) + dNdx(:,inod).* veley(:,inod);
    dvdx(:,2) = dvdx(:,2) + dNdy(:,inod).* veley(:,inod);
    dvdx(:,3) = dvdx(:,3) + dNdz(:,inod).* veley(:,inod);
    
    dwdx(:,1) = dwdx(:,1) + dNdx(:,inod).* velez(:,inod);
    dwdx(:,2) = dwdx(:,2) + dNdy(:,inod).* velez(:,inod);
    dwdx(:,3) = dwdx(:,3) + dNdz(:,inod).* velez(:,inod);
    
  end
 
  wx = dwdx(:,2)-dvdx(:,3);
  wy = dudx(:,3)-dwdx(:,1);
  wz = dvdx(:,1)-dudx(:,2);
  
  div_u = dudx(:,1)+dvdx(:,2)+dwdx(:,3);
  
  for inod=1:nen,
% RESIDUO    
% termino temporal
	Rele(:,(inod-1)*ndof+1) =  Rele(:,(inod-1)*ndof+1) + N(inod) .* ones(nele,1) .*xsj;
	Rele(:,(inod-1)*ndof+2) =  Rele(:,(inod-1)*ndof+2) + N(inod) .* wx .* xsj;    
	Rele(:,(inod-1)*ndof+3) =  Rele(:,(inod-1)*ndof+3) + N(inod) .* wy .* xsj;
    Rele(:,(inod-1)*ndof+4) =  Rele(:,(inod-1)*ndof+4) + N(inod) .* wz .* xsj;         
	Rele(:,(inod-1)*ndof+5) =  Rele(:,(inod-1)*ndof+5) + N(inod) .* div_u .* xsj;            
  end % inod
  
end % if ndm==2

end  % for ipg

for k=1:nen,
   nodos=icone(:,k);
   for idf=1:ndof,
      Rg(nodos,idf) = Rg(nodos,idf)+Rele(:,(k-1)*ndof+idf);
   end   
end

if ijob>0,

  if ndm==2,
      %vort = Rele(:,2)./Rele(:,1);
      vort = wz;
      %divu = Rele(:,3)./Rele(:,1);
      divu = div_u;
  else
      %vort = Rele(:,2:4)./(Rele(:,1)*[1,1,1]);
      vort = [wx,wy,wz];
      %divu = Rele(:,5)./Rele(:,1);      
      divu = div_u;
  end
  
else
    
if ndm==2,
vort(:,1)=Rg(:,2)./Rg(:,1);
divu = Rg(:,3)./Rg(:,1);
   
else
   
vort(:,1)=Rg(:,2)./Rg(:,1);
vort(:,2)=Rg(:,3)./Rg(:,1);
vort(:,3)=Rg(:,4)./Rg(:,1);
divu = Rg(:,5)./Rg(:,1);

end

end
