fileout = 'test_asm_2';

% convert Femcode arrays to Petscfem arrays and write on files

% Fixa
[numnp,ndf]=size(fixa);
vaux = [];
for idf=1:ndf
   nodes = find(fixa(:,idf)>0);
   value = forc(nodes,idf);
   vaux = [vaux ; [nodes , idf*ones(size(nodes)) , value ]];
end

my_fprintf([fileout '.fixa'],'%7i %2i %15.5e \n',vaux);

% mesh (xnod) & (icone)
write_mesh(xnod,icone,fileout);

fmt = [];
for k=1:ndf,
   fmt=[fmt , ['%15.5e ']]; 
end
fmt = [fmt, ' \n '];

% Initial condition
my_fprintf([fileout '.state.ini'],fmt,bini);

% Bcconv
[ifaceb,face_bou] = pfbou2d(xnod,icone,1);
my_fprintf([fileout '.bcconv'],'%7i %7i \n',face_bou);

% Linear constraints
if isempty(lin_con)==0,
   [nrow,ncol]=size(lin_con);
   fmt = [];
   for k=1:ncol/3,
      fmt=[fmt , ['%15.5e %7i %2i ']]; 
   end
   fmt = [fmt, ' \n '];
   my_fprintf([fileout '.const'],fmt,lin_con);   
end

fid = fopen([fileout '.epl'],'a');

fprintf(fid,['__INCLUDE__ ' fileout '.nod \n' ]);
fprintf(fid,['__INCLUDE__ ' fileout '.con \n' ]);
fprintf(fid,['__INCLUDE__ ' fileout '.fixa \n' ]);
fprintf(fid,['__INCLUDE__ ' fileout '.state.ini \n' ]);
fprintf(fid,['__INCLUDE__ ' fileout '.bcconv \n' ]);
if isempty(lin_con)==0,
   fprintf(fid,['__INCLUDE__ ' fileout '.const \n' ]);
end






fclose(fid)
