function array_out = xt_cycle(theta,array)
%
%        array_out = xt_cycle(theta,array)
%
%    Extrae de un arreglo "array" aquel subarreglo
%    del ultimo ciclo completo.
%
%  Input:
%
%       theta : arreglo con los angulos del ciclo
%       array : arreglo con los valores de todos los ciclos
%
%  Output:
%
%   array_out : arreglo con los valores del ultimo ciclo completo
%

end_cycle = find(diff(theta)<0);
ncycle    = length(end_cycle);
index = end_cycle(ncycle-1)+1:end_cycle(ncycle);

array_out = array(index,:);