function [xnod,icone] = boxgrid(x_SW,x_NE,Nx,Ny)
%
%   Generate a uniform grid of [Nx , Ny] nodes inside a
%   rectangular box of vertices x_SW to x_NE
%
%    [xnod,icone] = boxgrid(x_SW,x_NE,Nx,Ny)  
%


x = (0:Nx-1)'/(Nx-1)*(x_NE(1)-x_SW(1))+x_SW(1) ;
y = (0:Ny-1)'/(Ny-1)*(x_NE(2)-x_SW(2))+x_SW(2) ;

xnod = [];
for k=1:Ny,
  xnod = [xnod ; [x ones(Nx,1)*y(k)]];
end

icone=[];
ico = [(1:Nx-1)' (2:Nx)' Nx+(2:Nx)' Nx+(1:Nx-1)' ];
for k=1:Ny-1,
  icone = [icone ; (k-1)*Nx+ico];
end
