function [iconew,list] = check_mesh_orientation(xnod,icone,job);
%
%  [iconew,list] = check_mesh_orientation(xnod,icone,[list=[]]);
%
%  check the mesh orientation ONLY for 2D, if the mesh is clockwise
%  change it to become counterclockwise
%
list=[];

if nargin<3, job=0; end

[numnp,ndm] = size(xnod);
[numel,nen] = size(icone);
if ndm==2,
    if nen==3,
        v1 = xnod(icone(:,2),:)-xnod(icone(:,1),:);
        v2 = xnod(icone(:,nen),:)-xnod(icone(:,1),:);
        v3 = pvec([v1,0*v1(:,1)],[v2,0*v2(:,1)]);
        nn=find(v3(:,3)<0);
        disp([' Elementos con jacobiano negativos ' num2str(length(nn)) ' / ' num2str(numel) ])
        iconew = icone;
        iconew(nn,1:nen)=icone(nn,nen:-1:1);
    elseif nen==4
        v1 = xnod(icone(:,2),:)-xnod(icone(:,1),:);
        v2 = xnod(icone(:,3),:)-xnod(icone(:,2),:);
        v12 = pvec([v1,0*v1(:,1)],[v2,0*v2(:,1)]);
        v3 = xnod(icone(:,4),:)-xnod(icone(:,3),:);
        v4 = xnod(icone(:,1),:)-xnod(icone(:,4),:);
        v34 = pvec([v3,0*v3(:,1)],[v4,0*v4(:,1)]);
        nn=find((v12(:,3).*v34(:,3))<0);
        % swapping of diagonals
        icone(nn,:)=icone(nn,[1,2,4,3]);
        v1 = xnod(icone(:,2),:)-xnod(icone(:,1),:);
        v2 = xnod(icone(:,nen),:)-xnod(icone(:,1),:);
        v3 = pvec([v1,0*v1(:,1)],[v2,0*v2(:,1)]);
        nn=find(v3(:,3)<0);
        disp([' Elementos con jacobiano negativos ' num2str(length(nn)) ' / ' num2str(numel) ])
        iconew = icone;
        iconew(nn,1:nen)=icone(nn,nen:-1:1);
    else
        error(' *** check_mesh_orientation error *** , bad element type in 2D')
    end

else
    v1 = xnod(icone(:,2),:)-xnod(icone(:,1),:);
    v2 = xnod(icone(:,nen),:)-xnod(icone(:,1),:);
    v3 = pvec(v1,v2);
    nodes = rmdblist(m2v(icone));
    xmin = min(xnod(nodes,:));
    xmax = max(xnod(nodes,:));
    xc   = (xmin+xmax)/2;
    v0   = xnod(icone(:,1),:)-ones(length(v1(:,1)),1)*xc;
    v30  = sum((v3.*v0)')';
    nn   = find(v30<0);
    if (job), list=nn; end
    disp([' Elementos con jacobiano negativos ' num2str(length(nn)) ' / ' num2str(numel) ])
    iconew = icone;
    iconew(nn,1:nen)=icone(nn,nen:-1:1);
end

