function [iconew,list] = check_mesh_orientation_hexas(xnod,icone,job);
%
%  [iconew,list] = check_mesh_orientation_hexas(xnod,icone,[list=[]]);
%
%  check the mesh orientation ONLY for hexas
%

list=[];

if nargin<3, job=0; end

[numnp,ndm] = size(xnod);
[numel,nen] = size(icone);

% first assume that the first four nodes are well oriented and 
% the second four are well oriented or reversed

v1 = xnod(icone(:,2),:)-xnod(icone(:,1),:);
v2 = xnod(icone(:,4),:)-xnod(icone(:,1),:);
v3 = pvec(v1,v2);

w1 = xnod(icone(:,6),:)-xnod(icone(:,5),:);
w2 = xnod(icone(:,8),:)-xnod(icone(:,5),:);
w3 = pvec(w1,w2);

u3 = sum((v3.*w3)')';

nn   = find(u3<0);
if (job), list=nn; end
disp([' Elementos con jacobiano negativos ' num2str(length(nn)) ' / ' num2str(numel) ])
disp(' will be inverted ')

error('  routine not available yet ')
return

icone(nn,5:8) = icone(nn,[]);
nodes = rmdblist(m2v(icone));
xmin = min(xnod(nodes,:));
xmax = max(xnod(nodes,:));
xc   = (xmin+xmax)/2;
v0   = xnod(icone(:,1),:)-ones(length(v1(:,1)),1)*xc;
v30  = sum((v3.*v0)')';
nn   = find(v30<0);
if (job), list=nn; end
disp([' Elementos con jacobiano negativos ' num2str(length(nn)) ' / ' num2str(numel) ])
iconew = icone;
iconew(nn,1:nen)=icone(nn,nen:-1:1);


