function [x1,x2,nodes_1,nodes_2]=check_num_arista(x1,x2,nodes_1,nodes_2,Ni,Nj,tol)
%
%  [x1,x2,nodes_1,nodes_2]=check_num_arista(x1,x2,nodes_1,nodes_2,Ni,Nj,[tol])
%

  if nargin<7, tol = 1e-6; end

   dx = x1(Ni,:)-x2(1,:);
   ds = sqrt(sum(dx'.^2));
   if ds>tol,      
      dx  = x1(Ni,:)-x2(Nj,:);      
      ds1 = sqrt(sum(dx'.^2));            
      dx  = x1(1,:)-x2(1,:);      
      ds2 = sqrt(sum(dx'.^2));            
      dx  = x1(1,:)-x2(Nj,:);      
      ds3 = sqrt(sum(dx'.^2));            
      nn=find([ds1;ds2;ds3]<tol);
      if nn==1,
         x2 = x2(Nj:-1:1,:);      
         nodes_2 = nodes_2(Nj:-1:1);
      elseif nn==2,
         x1 = x1(Ni:-1:1,:);         
         nodes_1 = nodes_1(Ni:-1:1);         
      elseif nn==3,
         x1 = x1(Ni:-1:1,:);         
         x2 = x2(Nj:-1:1,:);               
         nodes_1 = nodes_1(Ni:-1:1);                  
         nodes_2 = nodes_2(Nj:-1:1);                  
      else
         error(' Split_surface ERROR [000]');
      end      
   end
