function [Drag,Lift] = drag_lif(tauh,ph,normal,Area)
%
%        [Drag,Lift] = drag_lif(tauh,ph,normal,Area)
%
%    Inputs:
%
%        ph : historico de presiones sobre set de nodos
%      tauh : historico de las tensiones de corte
%    normal : versor normal a cada nodo del set
%      Area : area asociada con cada nodo del set
%        
%-------------------------------
% componente de presion
%-------------------------------
normal = -normal;
Area   = [Area Area];
anormal=  normal.*Area;
[np,mp]=size(ph);
fxh = (anormal(:,1)*ones(1,mp)).*ph;
fyh = (anormal(:,2)*ones(1,mp)).*ph;
Drag = sum(fxh);
Lift = sum(fyh);
%-------------------------------
% componente viscosa
%-------------------------------
fxh = (anormal(:,2)*ones(1,mp)).*tauh;
fyh = -(anormal(:,1)*ones(1,mp)).*tauh;

Drag = Drag+sum(fxh);
Lift = Lift+sum(fyh);