function [xc,rc]=draw_circle(x,y)
%
%   [xc,rc]=draw_circle(x,y)
%

global datos_circle

[nnod,nen]=size(x);
cero = zeros(nnod,1);
if nen==3,

v1   = [x(:,2)-x(:,1) , y(:,2)-y(:,1)];
v2   = [x(:,3)-x(:,2) , y(:,3)-y(:,2)];
v3   = [x(:,1)-x(:,3) , y(:,1)-y(:,3)];

w1   = pvec([v1,cero],ones(nnod,1)*[0,0,1]);
w2   = pvec([v2,cero],ones(nnod,1)*[0,0,1]);
w3   = pvec([v3,cero],ones(nnod,1)*[0,0,1]);
w1n  = sqrt(sum(w1'.^2))';
w2n  = sqrt(sum(w2'.^2))';
w3n  = sqrt(sum(w3'.^2))';
w1   = w1(:,1:2)./(w1n*[1,1]);
w2   = w2(:,1:2)./(w2n*[1,1]);
w3   = w3(:,1:2)./(w3n*[1,1]);

P1   = 0.5*[x(:,2)+x(:,1) , y(:,2)+y(:,1)];
P2   = 0.5*[x(:,3)+x(:,2) , y(:,3)+y(:,2)];
P3   = 0.5*[x(:,3)+x(:,1) , y(:,3)+y(:,1)];

[Pa]=intersect_lines(P1,v1,P2,v2);
[Pb]=intersect_lines(P2,v2,P3,v3);
[Pc]=intersect_lines(P3,v3,P1,v1);

ra = dist_vec(Pa,[x(:,1),y(:,1)]);
rb = dist_vec(Pb,[x(:,2),y(:,2)]);
rc = dist_vec(Pc,[x(:,3),y(:,3)]);
Pm = (Pa+Pb+Pc)/3;;
rm = (ra+rb+rc)/3;

NN = 100;
theta=(0:NN)'/NN*2*pi;
ct=cos(theta); st=sin(theta);

for k=1:nnod
   X0(1:2) = Pm(k,:);
   X0(3)   = rm(k);   
   datos_circle = [x(k,:)' , y(k,:)'];
   XX  = fsolve('eq_circle',X0);   
   xc(k,1:2) = XX(1:2);
   rc(k)     = XX(3); 

% postprocessing
   plot(xc(k,1),xc(k,2),'ro');hold on
   xx=ones(NN+1,1)*xc(k,1)+ct*rc(k);
   yy=ones(NN+1,1)*xc(k,2)+st*rc(k);
   plot(xx,yy);
   plot(x,y,'b*')   
end

else
   error(' nen SHOULD be 3 ')
end

%disp('draw_circle');keyboard;pause
