%function [xh,yh] = drv_st(xnod,icone,u,XP0,UP0,...
%                                  nbox,nsteps,scale_factor,traces,option)
%
%----------------------------------------------------------
%       Compute coordinates of several streamlines 
%----------------------------------------------------------
%
%    Inputs:
%
%          xnod , icone , sol 
%         lista  : nodes list to start computation of streamlines

%----------------------------------------------------------
%   DATOS del usuario
%----------------------------------------------------------

global xbox ybox pt2box setpt x_I y_I u_I v_I nbox

  if exist('inicia')==0,
    inicia = input(' Ingrese variable INICIA ');
  end

if inicia,

  dt_step = 1;
  nstep   = 50;

  if exist('lista')==0,
     error(' Input list of nodes to start streamlines computation ')
  end

  if exist('sol')==0,
     error(' Solution should be renamed to variable ----> sol ')
  end

  vel     = sol(:,1:2);

  XP0 = xnod(lista,:);
  UP0 = vel(lista,:);

  traces=0;
  option   = 1;
  nbox     = 8;


%  y = ((0:21)'/21)*0.4;
%  nn = length(y);
%  XP0 = [0.05*ones(nn,1) y];
%  x = ((0:30)'/30)*0.106;
%  nn = length(x);
%  XP0 = [XP0 ; [x ones(nn,1)*0.1]];
%  UP0 = [0 0.8739];


  xh = [];
  yh = [];
  u  = vel;

  npg    =   1; % nro de puntos a usar para interpolar
  psi_I  = [ 0 ];
  eta_I  = [ 0 ];  % coordenadas naturales de los ptos a interpolar

  tol = 1e-4;
  trace = 0;
  time_0  = 0;

end

%----------------------------------------------------------
% FIN DATOS
%----------------------------------------------------------

if inicia, 
xp_0 = XP0(:,1);
yp_0 = XP0(:,2);
upp_0 = UP0(:,1);
vpp_0 = UP0(:,2);

[numel,nen] = size(icone);

if option==1,
%----------------------------------------------------------
% (4) Calcular puntos de interpolacion en cada elemento 
% (5) Interpolar las velocidades en los puntos de interpolacion
%----------------------------------------------------------

x_I = []; y_I= []; 
u_I = []; v_I= [];

if nen==4,
  
  x1 = xnod(icone(:,1),1); y1 = xnod(icone(:,1),2);
  x2 = xnod(icone(:,2),1); y2 = xnod(icone(:,2),2);
  x3 = xnod(icone(:,3),1); y3 = xnod(icone(:,3),2);
  x4 = xnod(icone(:,4),1); y4 = xnod(icone(:,4),2);

  u1 = u(icone(:,1),1); v1 = u(icone(:,1),2);
  u2 = u(icone(:,2),1); v2 = u(icone(:,2),2);
  u3 = u(icone(:,3),1); v3 = u(icone(:,3),2);
  u4 = u(icone(:,4),1); v4 = u(icone(:,4),2);

  for k=1:npg
    psi = psi_I(k); eta = eta_I(k);
    N1 = 0.25*(1-psi)*(1-eta);
    N2 = 0.25*(1+psi)*(1-eta);
    N3 = 0.25*(1+psi)*(1+eta);
    N4 = 0.25*(1-psi)*(1+eta);
    x_I=[x_I ; x1*N1+x2*N2+x3*N3+x4*N4 ];
    y_I=[y_I ; y1*N1+y2*N2+y3*N3+y4*N4 ];
    u_I=[u_I ; u1*N1+u2*N2+u3*N3+u4*N4 ];
    v_I=[v_I ; v1*N1+v2*N2+v3*N3+v4*N4 ];
  end

else

  x1 = xnod(icone(:,1),1); y1 = xnod(icone(:,1),2);
  x2 = xnod(icone(:,2),1); y2 = xnod(icone(:,2),2);
  x3 = xnod(icone(:,3),1); y3 = xnod(icone(:,3),2);

  u1 = u(icone(:,1),1); v1 = u(icone(:,1),2);
  u2 = u(icone(:,2),1); v2 = u(icone(:,2),2);
  u3 = u(icone(:,3),1); v3 = u(icone(:,3),2);


  for k=1:npg
    psi = psi_I(k); eta = eta_I(k);
    N1 = 1-psi-eta;
    N2 = psi;
    N3 = eta;
    x_I=[x_I ; x1*N1+x2*N2+x3*N3 ];
    y_I=[y_I ; y1*N1+y2*N2+y3*N3 ];
    u_I=[u_I ; u1*N1+u2*N2+u3*N3 ];
    v_I=[v_I ; v1*N1+v2*N2+v3*N3 ];
  end

end

else

x_I = xnod(:,1); y_I = xnod(:,2);
u_I = u(:,1) ; v_I = u(:,2);

end

%------------------------------------------------
% (6) Calcular la caja de calculo
%------------------------------------------------

xmax = max(xnod(:,1)); ymax = max(xnod(:,2));
xmin = min(xnod(:,1)); ymin = min(xnod(:,2));
box  = [xmin xmax ymin ymax];

%------------------------------------------------
% (6.1) Partimos la caja en varias
%------------------------------------------------

limit = 0.01*max([(xmax-xmin);(ymax-ymin)]);
lx_box = (xmax-xmin+2*limit)/nbox;
ly_box = (ymax-ymin+2*limit)/nbox;
xbox = [xmin-limit];
ybox = [ymin-limit];
for k=1:nbox
  xbox = [ xbox;xmin+k*lx_box];
  ybox = [ ybox;ymin+k*ly_box];
end

%------------------------------------------------
% (6.2) Asociamos a cada punto una caja
%------------------------------------------------

[N,m]   = size(x_I); 
pt2box = zeros(N,1);
for ibox=1:nbox,
  maskx = (x_I>=xbox(ibox))&(x_I<=xbox(ibox+1));
  for jbox=1:nbox,
    masky = (y_I>=ybox(jbox))&(y_I<=ybox(jbox+1));
    mask = maskx.*masky;
    puntos=find(mask~=0);
    pt2box(puntos)=ones(size(puntos))*(ibox-1)*nbox+jbox;
  end
end

end

%  hold on


  for k=1:nstep,
    X_0       = [xp_0;yp_0];
    time_f    = time_0+dt_step;
    [time,X]  = ODE45('streamls',time_0,time_f,X_0,tol,trace);
    time_0    = time_f;
    [last,Np] = size(X);
    Np        = Np/2;
    xp_0      = X(last,1:Np)';
    yp_0      = X(last,Np+(1:Np))';
	[xh]      = [xh;X(:,1:Np)];
	[yh]      = [yh;X(:,Np+(1:Np))];
    plot(xh,yh,'c-'),pause(0.1)
  end
%  hold off
