function [f_nod]=ele_field_to_nod_field(xnod,icone,f_ele)
%
%    [f_nod]=ele_field_to_nod_field(xnod,icone,f_ele)
%
%   f_ele : element-wise field
%   f_nod : nodal field
%

[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);

f_nod = zeros(numnp,1);
A_nod = zeros(numnp,1);

if ndm==2,
    [area] = area_mesh(xnod,icone);
else
    if nen==3,
        [area] = area_mesh(xnod,icone);     
    elseif nen==4,
        [area]=checktetras(xnod,icone);
    elseif nen==6
        [area]=checkprismas(xnod,icone);
    else
        error(' NOT AVAILABLE FOR HEXAS ')
    end
end

for k=1:nen,
    nodes=icone(:,k);
    f_nod(nodes,1) = f_nod(nodes,1)+f_ele.*area/nen;
    A_nod(nodes,1) = A_nod(nodes,1)+area/nen;
end
nn = find(A_nod>0);
f_nod(nn,1) = f_nod(nn,1) ./ A_nod(nn,1);
