function [phii] = fine2coa(xnod,phi,N,xc) 
%
%       [phii] = fine2coa(xnod,phi,N,xc) 
%
%   xnod : coordenadas nodales malla original
%   phi  : solucion escalar a interpolar
%   N    : Nro de nodos segun X
%   xc   : coordenadas nodales malla a interpolar
%
% Se asume que los datos xnod y phi se refieren a una malla
% que llena una caja rectangular alineada con los ejes x,y
%
% Para obtener malla gruesa VER "BOXGRID"
%

% Ordeno por coordenada Y
[bas,i1] = sort(xnod(:,2));
xnod = xnod(i1,:);
phi  = phi(i1,:);

% Tomo los valores de X e Y 
tol = 1e-6;
xmin = min(xnod(:,1));
ymin = min(xnod(:,2));
ny = find(abs(xnod(:,1)-xmin)<tol);
nx = find(abs(xnod(:,2)-ymin)<tol);
if length(nx)~=N, error(' N .ne. nx');end
x = xnod(nx,1);
y = xnod(ny,2);

% Interpolo
phii =  interp2(x,y,v2m(phi,N),xc(:,1),xc(:,2));