function [xnod,icone] = gen_block_mesh(c1,c2,c3,c4);
%
%  [xnod,icone] = gen_block_mesh(c1,c2,c3,c4);
%
%  Generate an structured block mesh from curve "c1" to curve "c2"
%  The first and last nodes of each layer are imposed to be located
%  at those corresponding to c3 and c4 curve
%

[N1,ibas] = size(c1); 
[N3,ibas] = size(c3); 

xh1 = [];

h3 = sqrt(sum(diff(c3)'.^2)');
h4 = sqrt(sum(diff(c4)'.^2)');
hh = 0.5*(h3+h4);

if 0,
for k=1:N3
   alfa = (k-1)/(N3-1);
   x = c1*(1-alfa)+c2*alfa;
   x(1,:)  = c3(k,:);
   x(N1,:) = c4(k,:);
   xh1 = [xh1 ; x];
end
else
   y = 0   ;
   YT = sum(hh);
   xh1 = c1;
for k=2:N3   
   y = y + hh(k-1);   
   alfa = y/YT;         
   x = c1*(1-alfa)+c2*alfa;
   x(1,:)  = c3(k,:);
   x(N1,:) = c4(k,:);
   xh1 = [xh1 ; x];
end   
end


xnod = xh1;

icone = [];
ico = (1:N1-1)'; ico=[ico,ico+1]; ico=[ico,ico(:,[2,1])+N1];
for k=1:N3-1
   icone = [icone ; ico+(k-1)*N1];
end


return

xh2 = [];
for k=1:N1
   alfa = (k-1)/(N1-1);
   x = c3*(1-alfa)+c4*alfa;
   x(1,:)  = c1(k,:);
   x(N3,:) = c2(k,:);
   xh2 = [xh2 ; x];
end

xnod = 0.5*(0*xh1+2*xh2);

return

X = (0:N1-1)'/(N1-1);
Y = (0:N3-1)'/(N3-1);

XX = [X;X;0*Y;0*Y+1];
YY = [0*X;0*X+1;Y;Y];

[XI,YI] = meshgrid(X,Y);

Z = [c1;c2;c3;c4];

% coordenada X
ZZ = Z(:,1);

%XI = reshape(XI,N1*N3,1);
%YI = reshape(YI,N1*N3,1);
ZI = INTERP2(XX,YY,ZZ,XI,YI);