function [edges] = get_edges(xnod,icone,ijob)
%
%   [edges] = get_edges(xnod,icone,[ijob])
%
%   if ijob > 0 , no remueve las aristas duplicadas
%

if nargin <3, ijob=0; end

[numel,nen]=size(icone);
[numnp,ndm]=size(xnod);

if ndm==3&nen==4,
   % Tetrahedra
   inoar = [1,2;2,4;1,4;1,3;2,3;3,4];   
elseif ndm==3&nen==8,
   % Hexahedra
   inoar = [1,2;2,3;3,4;4,1;5,6;6,7;7,8;8,5;1,5;2,6;3,7;4,8];
%   inoar = [1,2;2,3;3,4;4,1;5,6;6,7;7,8;8,5];   
elseif ndm==2&nen==3,
   % Triangles
   inoar = [1,2;2,3;3,1];
elseif ndm==2&nen==4,
   % Quadrangles
   inoar = [1,2;2,3;3,4;4,1];   
elseif ndm==3&nen==3,
   % Triangles in 3D
   inoar = [1,2;2,3;3,1];   
else
   error(' Bad element type in Get_edges')
end

edges = [];
for k=1:length(inoar(:,1)),
   n1=icone(:,inoar(k,1));
   n2=icone(:,inoar(k,2));
   edges=[edges;[n1,n2,(1:numel)']];
%   edges_by_ele(:,k) = (1:numel)'+(k-1)*numel;
end

if ijob~=0, return; end

% remuevo los duplicados
vaux = edges(:,1:2);
[bas,ibas] = sort(vaux');
ibas = ibas';
nn=find(ibas(:,1)==2);
vaux(nn,1:2)=vaux(nn,[2,1]);

[bas,ibas]=mksort(vaux,[1,2]);
dd = diff(vaux(ibas,:))';
nn = find(sum(abs(dd))==0);
nn = nn+1;

edges = edges(ibas,:);
edges(nn,:)=[];

