function edges = get_edges_by_nodes(nodes,icone,ijob)
%
%    edges = get_edges_by_nodes(nodes,icone,ijob)
%
%  Se calculan las aristas que tienen 
%     al menos 1 nodo en la lista "nodes" (ijob=0)
%     todos los nodos en la lista "nodes" (ijob=1)
%     para mallas refinadas, detecta solo las aristas de un borde que surgieron de refinar una arista del mismo tipo de borde (ijob=2)
%

if nargin<3, ijob=0; end

if isempty(nodes)==1, edges=[]; return; end

[numel,nen]=size(icone);
numnp = max(max(icone));
mark = zeros(numnp,1);
mark(nodes,1)=1;
mark2 = zeros(numel,1);

if ijob==0,
    for inod=1:nen
        nn = find(mark(icone(:,inod))==1);
        mark2(nn,1)=1;
    end
    edges = find(mark2==1);
elseif ijob==1,
    for inod=1:nen
        nn = find(mark(icone(:,inod))==1);
        mark2(nn,1)=mark2(nn,1)+1;
    end
    edges = find(mark2==nen);
elseif ijob==2,
    row = []; col=[]; coe=[];
    for inod=1:nen
        nn = find(mark(icone(:,inod))==1);
        row = [row;m2v(icone(nn,:))]; col=[col;ones(2*length(nn),1)]; coe=[coe;ones(2*length(nn),1)];
    end
    mark3=sparse(row,col,coe);
    nn=max(max(icone));
    [mm,mmm]=size(mark3);
    if nn>mm, mark3(nn,1)=-1; end
    for inod=1:nen    
        nn = find(mark3(icone(:,inod),1)==2);        
        mark2(nn,1)=mark2(nn,1)+1;
    end
    edges = find(mark2==2);   
end

