function [eles] = get_eles_by_xnod(xnod,icone,x_eles,tol)
%
%  [eles] = get_eles_by_xnod(xnod,icone,x_eles,tol)
%
%  Get the subset of eles in icone that have as their nodes
%  those defined in x_eles
%
%  Format of x_eles = [number_of_elements_in_subset , ndim*nen]
%  x_eles = [x(:,1:nen) y(:,1:nen)]
%

if nargin <4, tol=1e-10; end

[nr,nc]=size(x_eles);
[numel,nen]   = size(icone);
[numnp,ndm]   = size(xnod);

if nc ~= (ndm*nen), error('get_eles_by_xnod - colums in x_eles should be ndm*nen '); end

xc_master = xc_ele(xnod,icone);
xc        = mean(x_eles(:,1:nen)')';
yc        = mean(x_eles(:,nen+(1:nen))')';
if ndm==3, zc        = mean(x_eles(:,2*nen+(1:nen))')'; end

if ndm==3, 
    xc_slave  = [xc,yc,zc]; 
else
    xc_slave  = [xc,yc];    
end

eles = [];
for k=1:nr,
   dv = xc_master-ones(numel,1)*xc_slave(k,:);
   dd = sqrt(sum(dv'.^2))';
   ip = find(dd<tol);
   eles = [eles;ip];
end
