function [nor_face] = get_normal_surface(xnod,icone)
%
% Calculo de la normal a cada elemento de una superficie
%
%  [nor_face] = get_normal_surface(xnod,icone)
%
%  icone : surface mesh
%
%-----------------------------------------------------------------

if nargin<3, key=0; end

[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);

if nen==3,  
    nodes = icone;
    dx12 = xnod(nodes(:,2),:)-xnod(nodes(:,1),:);
    dx13 = xnod(nodes(:,3),:)-xnod(nodes(:,1),:);        
    nor_face = pvec(dx12,dx13);        
    nor_mag = sqrt(sum(nor_face'.^2))';
    nor_face = nor_face ./(nor_mag*ones(1,ndm));
else
    error(' IMPLEMENTACION 3D NO DISPONIBLE AUN ')
end    


