function [visco] = get_visco_les(xnod,icone,vel,C_smag)
%
%  [visco] = get_visco_les(xnod,icone,vel)
%

if nargin <4, C_smag = 0.18;end

[nele,nen]=size(icone);
[numnp,ndm]=size(xnod);
[nr,bas]=size(vel);

bfh = [];
npg = 1; % centroide

nstates = nr/numnp;

% calculo gradiente de la velocidad
[grad_vec] = grad_phi_by_ele(xnod(:,1:ndm),icone,vel,npg);
gU = reshape(grad_vec(:,1,1:ndm,1:ndm),nele,ndm,ndm);
bfh = [];
for idm=1:ndm
    bfh = [ bfh , gU(:,1:ndm,idm)];
end
bfh = reshape(bfh,nele,nstates,ndm*ndm);

[ar,emax,emin] = ar3d(xnod,icone);
hele = sqrt(emin.*emax);
nu_t = zeros(nele,nstates);
for k=1:nstates,
    strain_rate = reshape(bfh(:,k,1:ndm^2),nele,ndm,ndm);
    Sij = zeros(nele,1);
    for idm=1:ndm,
        for jdm=1:ndm,
            Sij=Sij+(0.5*(strain_rate(:,idm,jdm)+strain_rate(:,jdm,idm)).^2);
        end
    end
    nu_t(:,k)=sqrt(Sij);
    nu_t(:,k) = (C_smag*hele).^2.*nu_t(:,k);
end

factor = 1/nen;
nu_t_nod = zeros(numnp,nstates);
for inod=1:nen,
    nodes=icone(:,inod);
    nu_t_nod(nodes,1:nstates)=nu_t_nod(nodes,1:nstates)+factor*nu_t;
end

visco = nu_t_nod;