function [grad_phi] = grad_scalar(xnod,icone,phi)
%
%      [grad_phi] = grad_scalar(xnod,icone,phi)
%

[nnod,ndm]=size(xnod);
[nele,nen]=size(icone);

ndof = ndm+1;

[nnod,bas]=size(xnod);
[nele,nen]=size(icone);
Rele = zeros(nele,ndof*nen);
Rg   = zeros(nnod,ndof);

npg = 1;
% set coordinates and weights of Gauss points for numerical integration  

if ndm==2,
   pgauss;
else
   pgauss_3d;  
end

ceros = zeros(nele,nen);

phie = ceros;
for inod=1:nen,
            nodes = icone(:,inod);
    phie(:,inod) = phi(nodes);
end   

% Loop sobre los puntos de Gauss
%------------------------------------------------------------------
for ipg=1:npg
   
   if ndm==2,
      [X2S,S2X,Jaco] = xy2st(xnod,icone,psipg(ipg),etapg(ipg));  
      [dNdx,dNdy,N] = shape(X2S,psipg(ipg),etapg(ipg),nen);        
   else            
      [X2S,S2X,Jaco] = xyz2rst(xnod,icone,psipg(ipg),etapg(ipg),zetapg(ipg));  
      [dNdx,dNdy,dNdz,N] = shape3d(X2S,psipg(ipg),etapg(ipg),zetapg(ipg),nen);  
   end
   xsj =  wpg(ipg) .* Jaco;
   
   type = ['xyz'];
   
   dphidx = zeros(nele,ndm);
     
     for inod=1:nen,        
        for idm=1:ndm,
           eval(['dphidx(:,idm) = dphidx(:,idm) + dNd' type(idm) '(:,inod).* phie(:,inod);']);
        end        
     end
   
     for inod=1:nen,
	    Rele(:,(inod-1)*ndof+1) =  Rele(:,(inod-1)*ndof+1) + N(inod) .* ones(nele,1) .*xsj;
       for idm=1:ndm,
          Rele(:,(inod-1)*ndof+idm+1) =  Rele(:,(inod-1)*ndof+idm+1) + N(inod) .* dphidx(:,idm) .* xsj;         
       end       
    end % inod

end  % for ipg

for k=1:nen,
   nodos=icone(:,k);
   for idf=1:ndof,
      Rg(nodos,idf) = Rg(nodos,idf)+Rele(:,(k-1)*ndof+idf);
   end   
end

for idm=1:ndm
   grad_phi(:,idm) = Rg(:,idm+1)./Rg(:,1);
end

   
