function [P]=intersect_lines(P1,v1,P2,v2)
%
%  [P]=intersect_lines(P1,v1,P2,v2)
%
%  v1,v2 : 2 directions
%  P1,P2 : application points for the 2 directions
%      P : intersection point between the 2 lines v1,v2
%

%rhs  = m2v(P2-P1)';
rhs  = P2-P1;
K    = [v1(:,1),-v2(:,1),v1(:,2),-v2(:,2)];
detK = K(:,1).*K(:,4)-K(:,2).*K(:,3);
z(:,1) = (K(:,4).*rhs(:,1)-K(:,2).*rhs(:,2))./detK;
z(:,2) = (-K(:,3).*rhs(:,1)+K(:,1).*rhs(:,2))./detK;
P      = P1 + z(:,1)*[1,1].*v1;
